/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls","vs/base/common/event","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/uri","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/amdX","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/parts/request/common/request","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],he=function(Q){for(var e=[],P=0,I=Q.length;P<I;P++)e[P]=le[Q[P]];return e};define(le[75],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=e.LoaderEventType=e.$W=e.$V=void 0,e.$V=!1,e.$W=!0;var P;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class I{static get(){const k=new Map,C=new Map,R=new Map,m=new Map;function u(g,S){g.has(S.detail)||g.set(S.detail,-S.timestamp)}function d(g,S){const b=g.get(S.detail);b&&(b>=0||g.set(S.detail,b+S.timestamp))}let f=[];typeof Q=="function"&&typeof Q.getStats=="function"&&(f=Q.getStats().slice(0).sort((g,S)=>g.timestamp-S.timestamp));for(const g of f)switch(g.type){case P.BeginLoadingScript:u(k,g);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:d(k,g);break;case P.BeginInvokeFactory:u(C,g);break;case P.EndInvokeFactory:d(C,g);break;case P.NodeBeginNativeRequire:u(R,g);break;case P.NodeEndNativeRequire:d(R,g);break;case P.NodeBeginEvaluatingScript:u(m,g);break;case P.NodeEndEvaluatingScript:d(m,g);break}let $=0;R.forEach(g=>$+=g);function h(g){const S=[];return g.forEach((b,y)=>S.push([y,b])),S}return{amdLoad:h(k),amdInvoke:h(C),nodeRequire:h(R),nodeEval:h(m),nodeRequireTotal:$}}static toMarkdownTable(k,C){let R="";const m=[];return k.forEach((u,d)=>{m[d]=u.length}),C.forEach(u=>{u.forEach((d,f)=>{typeof d>"u"&&(d=u[f]="-");const $=d.toString().length;m[f]=Math.max($,m[f])})}),k.forEach((u,d)=>{R+=`| ${u+" ".repeat(m[d]-u.toString().length)} `}),R+=`|
`,k.forEach((u,d)=>{R+=`| ${"-".repeat(m[d])} `}),R+=`|
`,C.forEach(u=>{u.forEach((d,f)=>{typeof d<"u"&&(R+=`| ${d+" ".repeat(m[f]-d.toString().length)} `)}),R+=`|
`}),R}}e.$X=I}),define(le[55],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=I,e.$di=v,e.$ei=k;function P(C){return(R,m,u)=>{let d=null,f=null;if(typeof u.value=="function"?(d="value",f=u.value):typeof u.get=="function"&&(d="get",f=u.get),!f)throw new Error("not supported");u[d]=C(f,m)}}function I(C,R,m){let u=null,d=null;if(typeof m.value=="function"?(u="value",d=m.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(u="get",d=m.get),!d)throw new Error("not supported");const f=`$memoize$${R}`;m[u]=function(...$){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,$)}),this[f]}}function v(C,R,m){return P((u,d)=>{const f=`$debounce$${d}`,$=`$debounce$result$${d}`;return function(...h){this[$]||(this[$]=m?m():void 0),clearTimeout(this[f]),R&&(this[$]=R(this[$],...h),h=[this[$]]),this[f]=setTimeout(()=>{u.apply(this,h),this[$]=m?m():void 0},C)}})}function k(C,R,m){return P((u,d)=>{const f=`$throttle$timer$${d}`,$=`$throttle$result$${d}`,h=`$throttle$lastRun$${d}`,g=`$throttle$pending$${d}`;return function(...S){if(this[$]||(this[$]=m?m():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[$]=R(this[$],...S)),this[g])return;const b=this[h]+C;b<=Date.now()?(this[h]=Date.now(),u.apply(this,[this[$]]),this[$]=m?m():void 0):(this[g]=!0,this[f]=setTimeout(()=>{this[g]=!1,this[h]=Date.now(),u.apply(this,[this[$]]),this[$]=m?m():void 0},b-Date.now()))}})}}),define(le[76],he([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=I,e.$jd=v,e.$kd=k,e.$ld=C,e.$md=R,e.$nd=m;function I(u,d){if(!u)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function v(u,d="Unreachable"){throw new Error(d)}function k(u,d="unexpected state"){if(!u)throw new P.$gb(`Assertion Failed: ${d}`)}function C(u){u||(0,P.$4)(new P.$gb("Soft Assertion Failed"))}function R(u){if(!u()){debugger;u(),(0,P.$4)(new P.$gb("Assertion Failed"))}}function m(u,d){let f=0;for(;f<u.length-1;){const $=u[f],h=u[f+1];if(!d($,h))return!1;f++}return!0}}),define(le[34],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$3n=C,e.$4n=f,e.$5n=$,e.$6n=h,e.$7n=g,e.$8n=S,e.$9n=b,e.$0n=y,e.$$n=c,e.$_n=O,e.$ao=w;var P;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var I;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(I||(e.SyntaxKind=I={}));var v;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(v||(e.ParseErrorCode=v={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function C(i,a=!1){let n=0;const r=i.length;let t="",s=0,o=I.Unknown,l=P.None;function p(Y){let ne=0,ae=0;for(;ne<Y;){const ue=i.charCodeAt(n);if(ue>=d._0&&ue<=d._9)ae=ae*16+ue-d._0;else if(ue>=d.A&&ue<=d.F)ae=ae*16+ue-d.A+10;else if(ue>=d.a&&ue<=d.f)ae=ae*16+ue-d.a+10;else break;n++,ne++}return ne<Y&&(ae=-1),ae}function A(Y){n=Y,t="",s=0,o=I.Unknown,l=P.None}function T(){const Y=n;if(i.charCodeAt(n)===d._0)n++;else for(n++;n<i.length&&u(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===d.dot)if(n++,n<i.length&&u(i.charCodeAt(n)))for(n++;n<i.length&&u(i.charCodeAt(n));)n++;else return l=P.UnexpectedEndOfNumber,i.substring(Y,n);let ne=n;if(n<i.length&&(i.charCodeAt(n)===d.E||i.charCodeAt(n)===d.e))if(n++,(n<i.length&&i.charCodeAt(n)===d.plus||i.charCodeAt(n)===d.minus)&&n++,n<i.length&&u(i.charCodeAt(n))){for(n++;n<i.length&&u(i.charCodeAt(n));)n++;ne=n}else l=P.UnexpectedEndOfNumber;return i.substring(Y,ne)}function N(){let Y="",ne=n;for(;;){if(n>=r){Y+=i.substring(ne,n),l=P.UnexpectedEndOfString;break}const ae=i.charCodeAt(n);if(ae===d.doubleQuote){Y+=i.substring(ne,n),n++;break}if(ae===d.backslash){if(Y+=i.substring(ne,n),n++,n>=r){l=P.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case d.doubleQuote:Y+='"';break;case d.backslash:Y+="\\";break;case d.slash:Y+="/";break;case d.b:Y+="\b";break;case d.f:Y+="\f";break;case d.n:Y+=`
`;break;case d.r:Y+="\r";break;case d.t:Y+="	";break;case d.u:{const me=p(4);me>=0?Y+=String.fromCharCode(me):l=P.InvalidUnicode;break}default:l=P.InvalidEscapeCharacter}ne=n;continue}if(ae>=0&&ae<=31)if(m(ae)){Y+=i.substring(ne,n),l=P.UnexpectedEndOfString;break}else l=P.InvalidCharacter;n++}return Y}function D(){if(t="",l=P.None,s=n,n>=r)return s=r,o=I.EOF;let Y=i.charCodeAt(n);if(R(Y)){do n++,t+=String.fromCharCode(Y),Y=i.charCodeAt(n);while(R(Y));return o=I.Trivia}if(m(Y))return n++,t+=String.fromCharCode(Y),Y===d.carriageReturn&&i.charCodeAt(n)===d.lineFeed&&(n++,t+=`
`),o=I.LineBreakTrivia;switch(Y){case d.openBrace:return n++,o=I.OpenBraceToken;case d.closeBrace:return n++,o=I.CloseBraceToken;case d.openBracket:return n++,o=I.OpenBracketToken;case d.closeBracket:return n++,o=I.CloseBracketToken;case d.colon:return n++,o=I.ColonToken;case d.comma:return n++,o=I.CommaToken;case d.doubleQuote:return n++,t=N(),o=I.StringLiteral;case d.slash:{const ne=n-1;if(i.charCodeAt(n+1)===d.slash){for(n+=2;n<r&&!m(i.charCodeAt(n));)n++;return t=i.substring(ne,n),o=I.LineCommentTrivia}if(i.charCodeAt(n+1)===d.asterisk){n+=2;const ae=r-1;let ue=!1;for(;n<ae;){if(i.charCodeAt(n)===d.asterisk&&i.charCodeAt(n+1)===d.slash){n+=2,ue=!0;break}n++}return ue||(n++,l=P.UnexpectedEndOfComment),t=i.substring(ne,n),o=I.BlockCommentTrivia}return t+=String.fromCharCode(Y),n++,o=I.Unknown}case d.minus:if(t+=String.fromCharCode(Y),n++,n===r||!u(i.charCodeAt(n)))return o=I.Unknown;case d._0:case d._1:case d._2:case d._3:case d._4:case d._5:case d._6:case d._7:case d._8:case d._9:return t+=T(),o=I.NumericLiteral;default:for(;n<r&&j(Y);)n++,Y=i.charCodeAt(n);if(s!==n){switch(t=i.substring(s,n),t){case"true":return o=I.TrueKeyword;case"false":return o=I.FalseKeyword;case"null":return o=I.NullKeyword}return o=I.Unknown}return t+=String.fromCharCode(Y),n++,o=I.Unknown}}function j(Y){if(R(Y)||m(Y))return!1;switch(Y){case d.closeBrace:case d.closeBracket:case d.openBrace:case d.openBracket:case d.doubleQuote:case d.colon:case d.comma:case d.slash:return!1}return!0}function x(){let Y;do Y=D();while(Y>=I.LineCommentTrivia&&Y<=I.Trivia);return Y}return{setPosition:A,getPosition:()=>n,scan:a?x:D,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>l}}function R(i){return i===d.space||i===d.tab||i===d.verticalTab||i===d.formFeed||i===d.nonBreakingSpace||i===d.ogham||i>=d.enQuad&&i<=d.zeroWidthSpace||i===d.narrowNoBreakSpace||i===d.mathematicalSpace||i===d.ideographicSpace||i===d.byteOrderMark}function m(i){return i===d.lineFeed||i===d.carriageReturn||i===d.lineSeparator||i===d.paragraphSeparator}function u(i){return i>=d._0&&i<=d._9}var d;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(d||(d={}));function f(i,a){const n=[],r=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(p,A,T,N){s.value=p,s.offset=A,s.length=T,s.type=N,s.colonOffset=void 0,t=s}try{O(i,{onObjectBegin:(p,A)=>{if(a<=p)throw r;t=void 0,o=a>p,n.push("")},onObjectProperty:(p,A,T)=>{if(a<A||(l(p,A,T,"property"),n[n.length-1]=p,a<=A+T))throw r},onObjectEnd:(p,A)=>{if(a<=p)throw r;t=void 0,n.pop()},onArrayBegin:(p,A)=>{if(a<=p)throw r;t=void 0,n.push(0)},onArrayEnd:(p,A)=>{if(a<=p)throw r;t=void 0,n.pop()},onLiteralValue:(p,A,T)=>{if(a<A||(l(p,A,T,w(p)),a<=A+T))throw r},onSeparator:(p,A,T)=>{if(a<=A)throw r;if(p===":"&&t&&t.type==="property")t.colonOffset=A,o=!1,t=void 0;else if(p===","){const N=n[n.length-1];typeof N=="number"?n[n.length-1]=N+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(p){if(p!==r)throw p}return{path:n,previousNode:t,isAtPropertyKey:o,matches:p=>{let A=0;for(let T=0;A<p.length&&T<n.length;T++)if(p[A]===n[T]||p[A]==="*")A++;else if(p[A]!=="**")return!1;return A===p.length}}}function $(i,a=[],n=k.DEFAULT){let r=null,t=[];const s=[];function o(p){Array.isArray(t)?t.push(p):r!==null&&(t[r]=p)}return O(i,{onObjectBegin:()=>{const p={};o(p),s.push(t),t=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const p=[];o(p),s.push(t),t=p,r=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:o,onError:(p,A,T)=>{a.push({error:p,offset:A,length:T})}},n),t[0]}function h(i,a=[],n=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(p){r.type==="property"&&(r.length=p-r.offset,r=r.parent)}function s(p){return r.children.push(p),p}O(i,{onObjectBegin:p=>{r=s({type:"object",offset:p,length:-1,parent:r,children:[]})},onObjectProperty:(p,A,T)=>{r=s({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:p,offset:A,length:T,parent:r})},onObjectEnd:(p,A)=>{r.length=p+A-r.offset,r=r.parent,t(p+A)},onArrayBegin:(p,A)=>{r=s({type:"array",offset:p,length:-1,parent:r,children:[]})},onArrayEnd:(p,A)=>{r.length=p+A-r.offset,r=r.parent,t(p+A)},onLiteralValue:(p,A,T)=>{s({type:w(p),offset:A,length:T,parent:r,value:p}),t(A+T)},onSeparator:(p,A,T)=>{r.type==="property"&&(p===":"?r.colonOffset=A:p===","&&t(A))},onError:(p,A,T)=>{a.push({error:p,offset:A,length:T})}},n);const l=r.children[0];return l&&delete l.parent,l}function g(i,a){if(!i)return;let n=i;for(const r of a)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],t=!0;break}if(!t)return}else{const t=r;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function S(i){if(!i.parent||!i.parent.children)return[];const a=S(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;a.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&a.push(n)}return a}function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const a=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(a[n.children[0].value]=b(r))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function y(i,a,n=!1){return a>=i.offset&&a<i.offset+i.length||n&&a===i.offset+i.length}function c(i,a,n=!1){if(y(i,a,n)){const r=i.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=a;t++){const s=c(r[t],a,n);if(s)return s}return i}}function O(i,a,n=k.DEFAULT){const r=C(i,!1);function t(K){return K?()=>K(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(K){return K?ie=>K(ie,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),l=s(a.onObjectProperty),p=t(a.onObjectEnd),A=t(a.onArrayBegin),T=t(a.onArrayEnd),N=s(a.onLiteralValue),D=s(a.onSeparator),j=t(a.onComment),x=s(a.onError),Y=n&&n.disallowComments,ne=n&&n.allowTrailingComma;function ae(){for(;;){const K=r.scan();switch(r.getTokenError()){case P.InvalidUnicode:ue(v.InvalidUnicode);break;case P.InvalidEscapeCharacter:ue(v.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:ue(v.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:Y||ue(v.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:ue(v.UnexpectedEndOfString);break;case P.InvalidCharacter:ue(v.InvalidCharacter);break}switch(K){case I.LineCommentTrivia:case I.BlockCommentTrivia:Y?ue(v.InvalidCommentToken):j();break;case I.Unknown:ue(v.InvalidSymbol);break;case I.Trivia:case I.LineBreakTrivia:break;default:return K}}}function ue(K,ie=[],se=[]){if(x(K),ie.length+se.length>0){let L=r.getToken();for(;L!==I.EOF;){if(ie.indexOf(L)!==-1){ae();break}else if(se.indexOf(L)!==-1)break;L=ae()}}}function me(K){const ie=r.getTokenValue();return K?N(ie):l(ie),ae(),!0}function W(){switch(r.getToken()){case I.NumericLiteral:{let K=0;try{K=JSON.parse(r.getTokenValue()),typeof K!="number"&&(ue(v.InvalidNumberFormat),K=0)}catch{ue(v.InvalidNumberFormat)}N(K);break}case I.NullKeyword:N(null);break;case I.TrueKeyword:N(!0);break;case I.FalseKeyword:N(!1);break;default:return!1}return ae(),!0}function _(){return r.getToken()!==I.StringLiteral?(ue(v.PropertyNameExpected,[],[I.CloseBraceToken,I.CommaToken]),!1):(me(!1),r.getToken()===I.ColonToken?(D(":"),ae(),H()||ue(v.ValueExpected,[],[I.CloseBraceToken,I.CommaToken])):ue(v.ColonExpected,[],[I.CloseBraceToken,I.CommaToken]),!0)}function M(){o(),ae();let K=!1;for(;r.getToken()!==I.CloseBraceToken&&r.getToken()!==I.EOF;){if(r.getToken()===I.CommaToken){if(K||ue(v.ValueExpected,[],[]),D(","),ae(),r.getToken()===I.CloseBraceToken&&ne)break}else K&&ue(v.CommaExpected,[],[]);_()||ue(v.ValueExpected,[],[I.CloseBraceToken,I.CommaToken]),K=!0}return p(),r.getToken()!==I.CloseBraceToken?ue(v.CloseBraceExpected,[I.CloseBraceToken],[]):ae(),!0}function U(){A(),ae();let K=!1;for(;r.getToken()!==I.CloseBracketToken&&r.getToken()!==I.EOF;){if(r.getToken()===I.CommaToken){if(K||ue(v.ValueExpected,[],[]),D(","),ae(),r.getToken()===I.CloseBracketToken&&ne)break}else K&&ue(v.CommaExpected,[],[]);H()||ue(v.ValueExpected,[],[I.CloseBracketToken,I.CommaToken]),K=!0}return T(),r.getToken()!==I.CloseBracketToken?ue(v.CloseBracketExpected,[I.CloseBracketToken],[]):ae(),!0}function H(){switch(r.getToken()){case I.OpenBracketToken:return U();case I.OpenBraceToken:return M();case I.StringLiteral:return me(!0);default:return W()}}return ae(),r.getToken()===I.EOF?n.allowEmptyContent?!0:(ue(v.ValueExpected,[],[]),!1):H()?(r.getToken()!==I.EOF&&ue(v.EndOfFileExpected,[],[]),!0):(ue(v.ValueExpected,[],[]),!1)}function w(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[77],he([0,1,34]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=I,e.$co=v,e.$do=R,e.$eo=m;function I(u,d,f){let $,h,g,S,b;if(d){for(S=d.offset,b=S+d.length,g=S;g>0&&!m(u,g-1);)g--;let l=b;for(;l<u.length&&!m(u,l);)l++;h=u.substring(g,l),$=C(h,f)}else h=u,$=0,g=0,S=0,b=u.length;const y=R(f,u);let c=!1,O=0,w;f.insertSpaces?w=k(" ",f.tabSize||4):w="	";const i=(0,P.$3n)(h,!1);let a=!1;function n(){return y+k(w,$+O)}function r(){let l=i.scan();for(c=!1;l===P.SyntaxKind.Trivia||l===P.SyntaxKind.LineBreakTrivia;)c=c||l===P.SyntaxKind.LineBreakTrivia,l=i.scan();return a=l===P.SyntaxKind.Unknown||i.getTokenError()!==P.ScanError.None,l}const t=[];function s(l,p,A){!a&&p<b&&A>S&&u.substring(p,A)!==l&&t.push({offset:p,length:A-p,content:l})}let o=r();if(o!==P.SyntaxKind.EOF){const l=i.getTokenOffset()+g,p=k(w,$);s(p,g,l)}for(;o!==P.SyntaxKind.EOF;){let l=i.getTokenOffset()+i.getTokenLength()+g,p=r(),A="";for(;!c&&(p===P.SyntaxKind.LineCommentTrivia||p===P.SyntaxKind.BlockCommentTrivia);){const N=i.getTokenOffset()+g;s(" ",l,N),l=i.getTokenOffset()+i.getTokenLength()+g,A=p===P.SyntaxKind.LineCommentTrivia?n():"",p=r()}if(p===P.SyntaxKind.CloseBraceToken)o!==P.SyntaxKind.OpenBraceToken&&(O--,A=n());else if(p===P.SyntaxKind.CloseBracketToken)o!==P.SyntaxKind.OpenBracketToken&&(O--,A=n());else{switch(o){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:O++,A=n();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:A=n();break;case P.SyntaxKind.BlockCommentTrivia:c?A=n():A=" ";break;case P.SyntaxKind.ColonToken:A=" ";break;case P.SyntaxKind.StringLiteral:if(p===P.SyntaxKind.ColonToken){A="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:p===P.SyntaxKind.LineCommentTrivia||p===P.SyntaxKind.BlockCommentTrivia?A=" ":p!==P.SyntaxKind.CommaToken&&p!==P.SyntaxKind.EOF&&(a=!0);break;case P.SyntaxKind.Unknown:a=!0;break}c&&(p===P.SyntaxKind.LineCommentTrivia||p===P.SyntaxKind.BlockCommentTrivia)&&(A=n())}const T=i.getTokenOffset()+g;s(A,l,T),o=p}return t}function v(u,d){const f=JSON.stringify(u,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?f.replace(/\r\n|\r|\n/g,d.eol):f}function k(u,d){let f="";for(let $=0;$<d;$++)f+=u;return f}function C(u,d){let f=0,$=0;const h=d.tabSize||4;for(;f<u.length;){const g=u.charAt(f);if(g===" ")$++;else if(g==="	")$+=h;else break;f++}return Math.floor($/h)}function R(u,d){for(let f=0;f<d.length;f++){const $=d.charAt(f);if($==="\r")return f+1<d.length&&d.charAt(f+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return u&&u.eol||`
`}function m(u,d){return`\r
`.indexOf(u.charAt(d))!==-1}}),define(le[78],he([0,1,34,77]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=v,e.$go=k,e.$ho=C,e.$io=R,e.$jo=m;function v(u,d,f){return k(u,d,void 0,f)}function k(u,d,f,$,h){const g=d.slice(),S=[],b=(0,P.$6n)(u,S);let y,c;for(;g.length>0&&(c=g.pop(),y=(0,P.$7n)(b,g),y===void 0&&f!==void 0);)typeof c=="string"?f={[c]:f}:f=[f];if(y)if(y.type==="object"&&typeof c=="string"&&Array.isArray(y.children)){const O=(0,P.$7n)(y,[c]);if(O!==void 0)if(f===void 0){if(!O.parent)throw new Error("Malformed AST");const w=y.children.indexOf(O.parent);let i,a=O.parent.offset+O.parent.length;if(w>0){const n=y.children[w-1];i=n.offset+n.length}else i=y.offset+1,y.children.length>1&&(a=y.children[1].offset);return C(u,{offset:i,length:a-i,content:""},$)}else return C(u,{offset:O.offset,length:O.length,content:JSON.stringify(f)},$);else{if(f===void 0)return[];const w=`${JSON.stringify(c)}: ${JSON.stringify(f)}`,i=h?h(y.children.map(n=>n.children[0].value)):y.children.length;let a;if(i>0){const n=y.children[i-1];a={offset:n.offset+n.length,length:0,content:","+w}}else y.children.length===0?a={offset:y.offset+1,length:0,content:w}:a={offset:y.offset+1,length:0,content:w+","};return C(u,a,$)}}else if(y.type==="array"&&typeof c=="number"&&Array.isArray(y.children))if(f!==void 0){const O=`${JSON.stringify(f)}`;let w;if(y.children.length===0||c===0)w={offset:y.offset+1,length:0,content:y.children.length===0?O:O+","};else{const i=c===-1||c>y.children.length?y.children.length:c,a=y.children[i-1];w={offset:a.offset+a.length,length:0,content:","+O}}return C(u,w,$)}else{const O=c,w=y.children[O];let i;if(y.children.length===1)i={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===O){const a=y.children[O-1],n=a.offset+a.length,r=y.offset+y.length;i={offset:n,length:r-2-n,content:""}}else i={offset:w.offset,length:y.children[O+1].offset-w.offset,content:""};return C(u,i,$)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${y.type}`);else return f===void 0?[]:C(u,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(f)},$)}function C(u,d,f){let $=R(u,d),h=d.offset,g=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;h>0&&!(0,I.$eo)($,h-1);)h--;for(;g<$.length&&!(0,I.$eo)($,g);)g++}const S=(0,I.$bo)($,{offset:h,length:g-h},f);for(let y=S.length-1;y>=0;y--){const c=S[y];$=R($,c),h=Math.min(h,c.offset),g=Math.max(g,c.offset+c.length),g+=c.content.length-c.length}const b=u.length-($.length-g)-h;return[{offset:h,length:b,content:$.substring(h,g)}]}function R(u,d){return u.substring(0,d.offset)+d.content+u.substring(d.offset+d.length)}function m(u,d){const f=d.slice(0).sort((h,g)=>{const S=h.offset-g.offset;return S===0?h.length-g.length:S});let $=u.length;for(let h=f.length-1;h>=0;h--){const g=f[h];if(g.offset+g.length<=$)u=R(u,g);else throw new Error("Overlapping edit");$=g.offset}return u}}),define(le[79],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=P;function P(k){let C=!1;const R=new Map,m=new Map;if(v(k,S=>{if(k===S)return!0;const b=JSON.stringify(S);if(b.length<30)return!0;const y=R.get(b);if(!y){const c={schemas:[S]};return R.set(b,c),m.set(S,c),!0}return y.schemas.push(S),m.set(S,y),C=!0,!1}),R.clear(),!C)return JSON.stringify(k);let d="$defs";for(;k.hasOwnProperty(d);)d+="_";const f=[];function $(S){return JSON.stringify(S,(b,y)=>{if(y!==S){const c=m.get(y);if(c&&c.schemas.length>1)return c.id||(c.id=`_${f.length}`,f.push(c.schemas[0])),{$ref:`#/${d}/${c.id}`}}return y})}const h=$(k),g=[];for(let S=0;S<f.length;S++)g.push(`"_${S}":${$(f[S])}`);return g.length?`${h.substring(0,h.length-1)},"${d}":{${g.join(",")}}}`:h}function I(k){return typeof k=="object"&&k!==null}function v(k,C){if(!k||typeof k!="object")return;const R=(...h)=>{for(const g of h)I(g)&&f.push(g)},m=(...h)=>{for(const g of h)if(I(g))for(const S in g){const b=g[S];I(b)&&f.push(b)}},u=(...h)=>{for(const g of h)if(Array.isArray(g))for(const S of g)I(S)&&f.push(S)},d=h=>{if(Array.isArray(h))for(const g of h)I(g)&&f.push(g);else I(h)&&f.push(h)},f=[k];let $=f.pop();for(;$;)C($)&&(R($.additionalItems,$.additionalProperties,$.not,$.contains,$.propertyNames,$.if,$.then,$.else,$.unevaluatedItems,$.unevaluatedProperties),m($.definitions,$.$defs,$.properties,$.patternProperties,$.dependencies,$.dependentSchemas),u($.anyOf,$.allOf,$.oneOf,$.prefixItems),d($.items)),$=f.pop()}}),define(le[80],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Qm=P,e.rot=I,e.$Vm=R;function P(m,u,d){return Math.min(Math.max(m,u),d)}function I(m,u){return(u+m%u)%u}class v{constructor(){this.a=0}getNext(){return this.a++}}e.$Sm=v;class k{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tm=k;class C{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const d=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Um=C;function R(m,u,d,f,$,h,g,S){const b=g-d,y=S-f,c=$-d,O=h-f,w=m-d,i=u-f,a=b*b+y*y,n=b*c+y*O,r=b*w+y*i,t=c*c+O*O,s=c*w+O*i,o=1/(a*t-n*n),l=(t*r-n*s)*o,p=(a*s-n*r)*o;return l>=0&&p>=0&&l+p<1}}),function(){function Q(v){const k=[];typeof v=="number"&&k.push("code/timeOrigin",v);function C(m){k.push(m,Date.now())}function R(){const m=[];for(let u=0;u<k.length;u+=2)m.push({name:k[u],startTime:k[u+1]});return m}return{mark:C,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const C of performance.getEntriesByType("mark"))k.push({name:C.name,startTime:Math.round(v+C.startTime)});return k}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function P(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=e()),v.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=P(I))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var I in P)(typeof exports=="object"?exports:Q)[I]=P[I]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function P(I){if(e[I])return e[I].exports;var v=e[I]={i:I,l:!1,exports:{}};return Q[I].call(v.exports,v,v.exports,P),v.l=!0,v.exports}return P.m=Q,P.c=e,P.d=function(I,v,k){P.o(I,v)||Object.defineProperty(I,v,{enumerable:!0,get:k})},P.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},P.t=function(I,v){if(1&v&&(I=P(I)),8&v||4&v&&typeof I=="object"&&I&&I.__esModule)return I;var k=Object.create(null);if(P.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:I}),2&v&&typeof I!="string")for(var C in I)P.d(k,C,function(R){return I[R]}.bind(null,C));return k},P.n=function(I){var v=I&&I.__esModule?function(){return I.default}:function(){return I};return P.d(v,"a",v),v},P.o=function(I,v){return Object.prototype.hasOwnProperty.call(I,v)},P.p="",P(P.s=0)}([function(Q,e,P){(function(I){var v;e=Q.exports=L,v=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],m=e.src=[],u=0,d=u++;m[d]="0|[1-9]\\d*";var f=u++;m[f]="[0-9]+";var $=u++;m[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=u++;m[h]="("+m[d]+")\\.("+m[d]+")\\.("+m[d]+")";var g=u++;m[g]="("+m[f]+")\\.("+m[f]+")\\.("+m[f]+")";var S=u++;m[S]="(?:"+m[d]+"|"+m[$]+")";var b=u++;m[b]="(?:"+m[f]+"|"+m[$]+")";var y=u++;m[y]="(?:-("+m[S]+"(?:\\."+m[S]+")*))";var c=u++;m[c]="(?:-?("+m[b]+"(?:\\."+m[b]+")*))";var O=u++;m[O]="[0-9A-Za-z-]+";var w=u++;m[w]="(?:\\+("+m[O]+"(?:\\."+m[O]+")*))";var i=u++,a="v?"+m[h]+m[y]+"?"+m[w]+"?";m[i]="^"+a+"$";var n="[v=\\s]*"+m[g]+m[c]+"?"+m[w]+"?",r=u++;m[r]="^"+n+"$";var t=u++;m[t]="((?:<|>)?=?)";var s=u++;m[s]=m[f]+"|x|X|\\*";var o=u++;m[o]=m[d]+"|x|X|\\*";var l=u++;m[l]="[v=\\s]*("+m[o]+")(?:\\.("+m[o]+")(?:\\.("+m[o]+")(?:"+m[y]+")?"+m[w]+"?)?)?";var p=u++;m[p]="[v=\\s]*("+m[s]+")(?:\\.("+m[s]+")(?:\\.("+m[s]+")(?:"+m[c]+")?"+m[w]+"?)?)?";var A=u++;m[A]="^"+m[t]+"\\s*"+m[l]+"$";var T=u++;m[T]="^"+m[t]+"\\s*"+m[p]+"$";var N=u++;m[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=u++;m[D]="(?:~>?)";var j=u++;m[j]="(\\s*)"+m[D]+"\\s+",R[j]=new RegExp(m[j],"g");var x=u++;m[x]="^"+m[D]+m[l]+"$";var Y=u++;m[Y]="^"+m[D]+m[p]+"$";var ne=u++;m[ne]="(?:\\^)";var ae=u++;m[ae]="(\\s*)"+m[ne]+"\\s+",R[ae]=new RegExp(m[ae],"g");var ue=u++;m[ue]="^"+m[ne]+m[l]+"$";var me=u++;m[me]="^"+m[ne]+m[p]+"$";var W=u++;m[W]="^"+m[t]+"\\s*("+n+")$|^$";var _=u++;m[_]="^"+m[t]+"\\s*("+a+")$|^$";var M=u++;m[M]="(\\s*)"+m[t]+"\\s*("+n+"|"+m[l]+")",R[M]=new RegExp(m[M],"g");var U=u++;m[U]="^\\s*("+m[l]+")\\s+-\\s+("+m[l]+")\\s*$";var H=u++;m[H]="^\\s*("+m[p]+")\\s+-\\s+("+m[p]+")\\s*$";var K=u++;m[K]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)v(ie,m[ie]),R[ie]||(R[ie]=new RegExp(m[ie]));function se(B,ee){if(B instanceof L)return B;if(typeof B!="string"||B.length>k||!(ee?R[r]:R[i]).test(B))return null;try{return new L(B,ee)}catch{return null}}function L(B,ee){if(B instanceof L){if(B.loose===ee)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof L))return new L(B,ee);v("SemVer",B,ee),this.loose=ee;var te=B.trim().match(ee?R[r]:R[i]);if(!te)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var Se=+ge;if(Se>=0&&Se<C)return Se}return ge}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}e.parse=se,e.valid=function(B,ee){var te=se(B,ee);return te?te.version:null},e.clean=function(B,ee){var te=se(B.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(B){return v("SemVer.compare",this.version,this.loose,B),B instanceof L||(B=new L(B,this.loose)),this.compareMain(B)||this.comparePre(B)},L.prototype.compareMain=function(B){return B instanceof L||(B=new L(B,this.loose)),z(this.major,B.major)||z(this.minor,B.minor)||z(this.patch,B.patch)},L.prototype.comparePre=function(B){if(B instanceof L||(B=new L(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],ge=B.prerelease[ee];if(v("prerelease compare",ee,te,ge),te===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(te===void 0)return-1;if(te!==ge)return z(te,ge)}while(++ee)},L.prototype.inc=function(B,ee){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,ee,te,ge){typeof te=="string"&&(ge=te,te=void 0);try{return new L(B,te).inc(ee,ge).version}catch{return null}},e.diff=function(B,ee){if(J(B,ee))return null;var te=se(B),ge=se(ee);if(te.prerelease.length||ge.prerelease.length){for(var Se in te)if((Se==="major"||Se==="minor"||Se==="patch")&&te[Se]!==ge[Se])return"pre"+Se;return"prerelease"}for(var Se in te)if((Se==="major"||Se==="minor"||Se==="patch")&&te[Se]!==ge[Se])return Se},e.compareIdentifiers=z;var V=/^[0-9]+$/;function z(B,ee){var te=V.test(B),ge=V.test(ee);return te&&ge&&(B=+B,ee=+ee),te&&!ge?-1:ge&&!te?1:B<ee?-1:B>ee?1:0}function E(B,ee,te){return new L(B,te).compare(new L(ee,te))}function F(B,ee,te){return E(B,ee,te)>0}function X(B,ee,te){return E(B,ee,te)<0}function J(B,ee,te){return E(B,ee,te)===0}function G(B,ee,te){return E(B,ee,te)!==0}function q(B,ee,te){return E(B,ee,te)>=0}function Z(B,ee,te){return E(B,ee,te)<=0}function re(B,ee,te,ge){var Se;switch(ee){case"===":typeof B=="object"&&(B=B.version),typeof te=="object"&&(te=te.version),Se=B===te;break;case"!==":typeof B=="object"&&(B=B.version),typeof te=="object"&&(te=te.version),Se=B!==te;break;case"":case"=":case"==":Se=J(B,te,ge);break;case"!=":Se=G(B,te,ge);break;case">":Se=F(B,te,ge);break;case">=":Se=q(B,te,ge);break;case"<":Se=X(B,te,ge);break;case"<=":Se=Z(B,te,ge);break;default:throw new TypeError("Invalid operator: "+ee)}return Se}function ce(B,ee){if(B instanceof ce){if(B.loose===ee)return B;B=B.value}if(!(this instanceof ce))return new ce(B,ee);v("comparator",B,ee),this.loose=ee,this.parse(B),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}e.rcompareIdentifiers=function(B,ee){return z(ee,B)},e.major=function(B,ee){return new L(B,ee).major},e.minor=function(B,ee){return new L(B,ee).minor},e.patch=function(B,ee){return new L(B,ee).patch},e.compare=E,e.compareLoose=function(B,ee){return E(B,ee,!0)},e.rcompare=function(B,ee,te){return E(ee,B,te)},e.sort=function(B,ee){return B.sort(function(te,ge){return e.compare(te,ge,ee)})},e.rsort=function(B,ee){return B.sort(function(te,ge){return e.rcompare(te,ge,ee)})},e.gt=F,e.lt=X,e.eq=J,e.neq=G,e.gte=q,e.lte=Z,e.cmp=re,e.Comparator=ce;var fe={};function we(B,ee){if(B instanceof we)return B.loose===ee?B:new we(B.raw,ee);if(B instanceof ce)return new we(B.value,ee);if(!(this instanceof we))return new we(B,ee);if(this.loose=ee,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function de(B){return!B||B.toLowerCase()==="x"||B==="*"}function pe(B,ee,te,ge,Se,Ne,ke,Te,Oe,Ce,Ue,De,Le){return((ee=de(te)?"":de(ge)?">="+te+".0.0":de(Se)?">="+te+"."+ge+".0":">="+ee)+" "+(Te=de(Oe)?"":de(Ce)?"<"+(+Oe+1)+".0.0":de(Ue)?"<"+Oe+"."+(+Ce+1)+".0":De?"<="+Oe+"."+Ce+"."+Ue+"-"+De:"<="+Te)).trim()}function ye(B,ee){for(var te=0;te<B.length;te++)if(!B[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<B.length;te++)if(v(B[te].semver),B[te].semver!==fe&&B[te].semver.prerelease.length>0){var ge=B[te].semver;if(ge.major===ee.major&&ge.minor===ee.minor&&ge.patch===ee.patch)return!0}return!1}return!0}function $e(B,ee,te){try{ee=new we(ee,te)}catch{return!1}return ee.test(B)}function ve(B,ee,te,ge){var Se,Ne,ke,Te,Oe;switch(B=new L(B,ge),ee=new we(ee,ge),te){case">":Se=F,Ne=Z,ke=X,Te=">",Oe=">=";break;case"<":Se=X,Ne=q,ke=F,Te="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(B,ee,ge))return!1;for(var Ce=0;Ce<ee.set.length;++Ce){var Ue=ee.set[Ce],De=null,Le=null;if(Ue.forEach(function(Fe){Fe.semver===fe&&(Fe=new ce(">=0.0.0")),De=De||Fe,Le=Le||Fe,Se(Fe.semver,De.semver,ge)?De=Fe:ke(Fe.semver,Le.semver,ge)&&(Le=Fe)}),De.operator===Te||De.operator===Oe||(!Le.operator||Le.operator===Te)&&Ne(B,Le.semver)||Le.operator===Oe&&ke(B,Le.semver))return!1}return!0}ce.prototype.parse=function(B){var ee=this.loose?R[W]:R[_],te=B.match(ee);if(!te)throw new TypeError("Invalid comparator: "+B);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new L(te[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(B){return v("Comparator.test",B,this.loose),this.semver===fe||(typeof B=="string"&&(B=new L(B,this.loose)),re(B,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(B,ee){if(!(B instanceof ce))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new we(B.value,ee),$e(this.value,te,ee);if(B.operator==="")return te=new we(this.value,ee),$e(B.semver,te,ee);var ge=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ne=this.semver.version===B.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Te=re(this.semver,"<",B.semver,ee)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Oe=re(this.semver,">",B.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ge||Se||Ne&&ke||Te||Oe},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(B){var ee=this.loose;B=B.trim(),v("range",B,ee);var te=ee?R[H]:R[U];B=B.replace(te,pe),v("hyphen replace",B),B=B.replace(R[M],"$1$2$3"),v("comparator trim",B,R[M]),B=(B=(B=B.replace(R[j],"$1~")).replace(R[ae],"$1^")).split(/\s+/).join(" ");var ge=ee?R[W]:R[_],Se=B.split(" ").map(function(Ne){return function(ke,Te){return v("comp",ke),ke=function(Oe,Ce){return Oe.trim().split(/\s+/).map(function(Ue){return function(De,Le){v("caret",De,Le);var Fe=Le?R[me]:R[ue];return De.replace(Fe,function(qe,Pe,Ie,Re,Ae){var je;return v("caret",De,qe,Pe,Ie,Re,Ae),de(Pe)?je="":de(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de(Re)?je=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":Ae?(v("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Re+Ae+" <"+Pe+"."+Ie+"."+(+Re+1):">="+Pe+"."+Ie+"."+Re+Ae+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Re+Ae+" <"+(+Pe+1)+".0.0"):(v("no pr"),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Re+" <"+Pe+"."+Ie+"."+(+Re+1):">="+Pe+"."+Ie+"."+Re+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Re+" <"+(+Pe+1)+".0.0"),v("caret return",je),je})}(Ue,Ce)}).join(" ")}(ke,Te),v("caret",ke),ke=function(Oe,Ce){return Oe.trim().split(/\s+/).map(function(Ue){return function(De,Le){var Fe=Le?R[Y]:R[x];return De.replace(Fe,function(qe,Pe,Ie,Re,Ae){var je;return v("tilde",De,qe,Pe,Ie,Re,Ae),de(Pe)?je="":de(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de(Re)?je=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":Ae?(v("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),je=">="+Pe+"."+Ie+"."+Re+Ae+" <"+Pe+"."+(+Ie+1)+".0"):je=">="+Pe+"."+Ie+"."+Re+" <"+Pe+"."+(+Ie+1)+".0",v("tilde return",je),je})}(Ue,Ce)}).join(" ")}(ke,Te),v("tildes",ke),ke=function(Oe,Ce){return v("replaceXRanges",Oe,Ce),Oe.split(/\s+/).map(function(Ue){return function(De,Le){De=De.trim();var Fe=Le?R[T]:R[A];return De.replace(Fe,function(qe,Pe,Ie,Re,Ae,je){v("xRange",De,qe,Pe,Ie,Re,Ae,je);var Ve=de(Ie),Me=Ve||de(Re),Be=Me||de(Ae);return Pe==="="&&Be&&(Pe=""),Ve?qe=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Be?(Me&&(Re=0),Be&&(Ae=0),Pe===">"?(Pe=">=",Me?(Ie=+Ie+1,Re=0,Ae=0):Be&&(Re=+Re+1,Ae=0)):Pe==="<="&&(Pe="<",Me?Ie=+Ie+1:Re=+Re+1),qe=Pe+Ie+"."+Re+"."+Ae):Me?qe=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(qe=">="+Ie+"."+Re+".0 <"+Ie+"."+(+Re+1)+".0"),v("xRange return",qe),qe})}(Ue,Ce)}).join(" ")}(ke,Te),v("xrange",ke),ke=function(Oe,Ce){return v("replaceStars",Oe,Ce),Oe.trim().replace(R[K],"")}(ke,Te),v("stars",ke),ke}(Ne,ee)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Ne){return!!Ne.match(ge)})),Se=Se.map(function(Ne){return new ce(Ne,ee)})},we.prototype.intersects=function(B,ee){if(!(B instanceof we))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(ge){return B.set.some(function(Se){return Se.every(function(Ne){return ge.intersects(Ne,ee)})})})})},e.toComparators=function(B,ee){return new we(B,ee).set.map(function(te){return te.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},we.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new L(B,this.loose));for(var ee=0;ee<this.set.length;ee++)if(ye(this.set[ee],B))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(B,ee,te){var ge=null,Se=null;try{var Ne=new we(ee,te)}catch{return null}return B.forEach(function(ke){Ne.test(ke)&&(ge&&Se.compare(ke)!==-1||(Se=new L(ge=ke,te)))}),ge},e.minSatisfying=function(B,ee,te){var ge=null,Se=null;try{var Ne=new we(ee,te)}catch{return null}return B.forEach(function(ke){Ne.test(ke)&&(ge&&Se.compare(ke)!==1||(Se=new L(ge=ke,te)))}),ge},e.validRange=function(B,ee){try{return new we(B,ee).range||"*"}catch{return null}},e.ltr=function(B,ee,te){return ve(B,ee,"<",te)},e.gtr=function(B,ee,te){return ve(B,ee,">",te)},e.outside=ve,e.prerelease=function(B,ee){var te=se(B,ee);return te&&te.prerelease.length?te.prerelease:null},e.intersects=function(B,ee,te){return B=new we(B,te),ee=new we(ee,te),B.intersects(ee)},e.coerce=function(B){if(B instanceof L)return B;if(typeof B!="string")return null;var ee=B.match(R[N]);return ee==null?null:se((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,P(1))},function(Q,e){var P,I,v=Q.exports={};function k(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function R(b){if(P===setTimeout)return setTimeout(b,0);if((P===k||!P)&&setTimeout)return P=setTimeout,setTimeout(b,0);try{return P(b,0)}catch{try{return P.call(null,b,0)}catch{return P.call(this,b,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:k}catch{P=k}try{I=typeof clearTimeout=="function"?clearTimeout:C}catch{I=C}})();var m,u=[],d=!1,f=-1;function $(){d&&m&&(d=!1,m.length?u=m.concat(u):f=-1,u.length&&h())}function h(){if(!d){var b=R($);d=!0;for(var y=u.length;y;){for(m=u,u=[];++f<y;)m&&m[f].run();f=-1,y=u.length}m=null,d=!1,function(c){if(I===clearTimeout)return clearTimeout(c);if((I===C||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(c);try{I(c)}catch{try{return I.call(null,c)}catch{return I.call(this,c)}}}(b)}}function g(b,y){this.fun=b,this.array=y}function S(){}v.nextTick=function(b){var y=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)y[c-1]=arguments[c];u.push(new g(b,y)),u.length!==1||d||R(h)},g.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=S,v.addListener=S,v.once=S,v.off=S,v.removeListener=S,v.removeAllListeners=S,v.emit=S,v.prependListener=S,v.prependOnceListener=S,v.listeners=function(b){return[]},v.binding=function(b){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(b){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(le[81],he([0,1]),function(Q,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0;class I{constructor(R,m,u){this.level=R,this.key=m,this.value=u,this.forward=[]}}const v=void 0;class k{constructor(R,m=2**16){this.comparator=R,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(m)|0),this.e=new I(this.c,v,v)}get size(){return this.f}clear(){this.e=new I(this.c,v,v),this.f=0}has(R){return!!k.g(this,R,this.comparator)}get(R){return k.g(this,R,this.comparator)?.value}set(R,m){return k.h(this,R,m,this.comparator)&&(this.f+=1),this}delete(R){const m=k.k(this,R,this.comparator);return m&&(this.f-=1),m}forEach(R,m){let u=this.e.forward[0];for(;u;)R.call(m,u.value,u.key,this),u=u.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",m=this.e.forward[0];for(;m;)R+=`node(${m.key}, ${m.value}, lvl:${m.level})`,m=m.forward[0];return R}static g(R,m,u){let d=R.e;for(let f=R.d-1;f>=0;f--)for(;d.forward[f]&&u(d.forward[f].key,m)<0;)d=d.forward[f];if(d=d.forward[0],d&&u(d.key,m)===0)return d}static h(R,m,u,d){const f=[];let $=R.e;for(let h=R.d-1;h>=0;h--){for(;$.forward[h]&&d($.forward[h].key,m)<0;)$=$.forward[h];f[h]=$}if($=$.forward[0],$&&d($.key,m)===0)return $.value=u,!1;{const h=k.j(R);if(h>R.d){for(let g=R.d;g<h;g++)f[g]=R.e;R.d=h}$=new I(h,m,u);for(let g=0;g<h;g++)$.forward[g]=f[g].forward[g],f[g].forward[g]=$;return!0}}static j(R,m=.5){let u=1;for(;Math.random()<m&&u<R.c;)u+=1;return u}static k(R,m,u){const d=[];let f=R.e;for(let $=R.d-1;$>=0;$--){for(;f.forward[$]&&u(f.forward[$].key,m)<0;)f=f.forward[$];d[$]=f}if(f=f.forward[0],!f||u(f.key,m)!==0)return!1;for(let $=0;$<R.d&&d[$].forward[$]===f;$++)d[$].forward[$]=f.forward[$];for(;R.d>0&&R.e.forward[R.d-1]===v;)R.d-=1;return!0}}e.$2s=k}),define(le[47],he([0,1,7,2]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=v,e.$Ee=k,e.$Fe=C,e.$Ge=R,e.$He=u,e.$Ie=d,e.$Je=f,e.$Ke=$,e.$Le=h,e.$Me=g,e.$Ne=S,e.$Oe=b,e.$Pe=y,e.$Qe=c,e.$Re=O;function v(w){const i=w;return i?typeof i.read=="function":!1}function k(w){const i=w;return i?[i.on,i.pause,i.resume,i.destroy].every(a=>typeof a=="function"):!1}function C(w){const i=w;return i?k(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function R(w,i){return new m(w,i)}class m{constructor(i,a){this.e=i,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(a=>a(i))}h(i){this.c.error.length===0?(0,P.$4)(i):this.c.error.slice(0).forEach(a=>a(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,a){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(i,a){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(a);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(w,i){const a=[];let n;for(;(n=w.read())!==null;)a.push(n);return i(a)}function d(w,i,a){const n=[];let r;for(;(r=w.read())!==null&&n.length<a;)n.push(r);return r===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return w.read()}}}function f(w,i){return new Promise((a,n)=>{const r=[];$(w,{onData:t=>{i&&r.push(t)},onError:t=>{i?n(t):a(void 0)},onEnd:()=>{a(i?i(r):void 0)}})})}function $(w,i,a){w.on("error",n=>{a?.isCancellationRequested||i.onError(n)}),w.on("end",()=>{a?.isCancellationRequested||i.onEnd()}),w.on("data",n=>{a?.isCancellationRequested||i.onData(n)})}function h(w,i){return new Promise((a,n)=>{const r=new I.$Yc,t=[],s=p=>{if(t.push(p),t.length>i)return r.dispose(),w.pause(),a({stream:w,buffer:t,ended:!1})},o=p=>(r.dispose(),n(p)),l=()=>(r.dispose(),a({stream:w,buffer:t,ended:!0}));r.add((0,I.$Xc)(()=>w.removeListener("error",o))),w.on("error",o),r.add((0,I.$Xc)(()=>w.removeListener("end",l))),w.on("end",l),r.add((0,I.$Xc)(()=>w.removeListener("data",s))),w.on("data",s)})}function g(w,i){const a=R(i);return a.end(w),a}function S(){const w=R(()=>{throw new Error("not supported")});return w.end(),w}function b(w){let i=!1;return{read:()=>i?null:(i=!0,w)}}function y(w,i,a){const n=R(a);return $(w,{onData:r=>n.write(i.data(r)),onError:r=>n.error(i.error?i.error(r):r),onEnd:()=>n.end()}),n}function c(w,i,a){let n=!1;return{read:()=>{const r=i.read();return n?r:(n=!0,r!==null?a([w,r]):w)}}}function O(w,i,a){let n=!1;const r=R(a);return $(i,{onData:t=>n?r.write(t):(n=!0,r.write(a([w,t]))),onError:t=>r.error(t),onEnd:()=>{n||(n=!0,r.write(w)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(Q,e,P,I){I===void 0&&(I=P);var v=Object.getOwnPropertyDescriptor(e,P);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(Q,I,v)}:function(Q,e,P,I){I===void 0&&(I=P),Q[I]=e[P]}),xe=this&&this.__setModuleDefault||(Object.create?function(Q,e){Object.defineProperty(Q,"default",{enumerable:!0,value:e})}:function(Q,e){Q.default=e}),be=this&&this.__importStar||function(Q){if(Q&&Q.__esModule)return Q;var e={};if(Q!=null)for(var P in Q)P!=="default"&&Object.prototype.hasOwnProperty.call(Q,P)&&We(e,Q,P);return xe(e,Q),e};define(le[13],he([0,1,147,47]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=u,e.$Ue=d,e.$Ve=f,e.$We=$,e.$Xe=h,e.$Ye=g,e.$Ze=S,e.$1e=b,e.$2e=y,e.$3e=c,e.$4e=O,e.$5e=w,e.$6e=i,e.$7e=a,e.$8e=n,e.$9e=r,e.$0e=t,e.$$e=s,e.$_e=o,e.$af=A,I=be(I);const v=typeof Buffer<"u",k=new P.$Y(()=>new Uint8Array(256));let C,R;class m{static alloc(N){return v?new m(Buffer.allocUnsafe(N)):new m(new Uint8Array(N))}static wrap(N){return v&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new m(N)}static fromString(N,D){return!(D?.dontUseNodeBuffer||!1)&&v?new m(Buffer.from(N)):(C||(C=new TextEncoder),new m(C.encode(N)))}static fromByteArray(N){const D=m.alloc(N.length);for(let j=0,x=N.length;j<x;j++)D.buffer[j]=N[j];return D}static concat(N,D){if(typeof D>"u"){D=0;for(let Y=0,ne=N.length;Y<ne;Y++)D+=N[Y].byteLength}const j=m.alloc(D);let x=0;for(let Y=0,ne=N.length;Y<ne;Y++){const ae=N[Y];j.set(ae,x),x+=ae.byteLength}return j}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=m.alloc(this.byteLength);return N.set(this),N}toString(){return v?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(N,D){return new m(this.buffer.subarray(N,D))}set(N,D){if(N instanceof m)this.buffer.set(N.buffer,D);else if(N instanceof Uint8Array)this.buffer.set(N,D);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),D);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return $(this.buffer,N)}writeUInt32BE(N,D){h(this.buffer,N,D)}readUInt32LE(N){return g(this.buffer,N)}writeUInt32LE(N,D){S(this.buffer,N,D)}readUInt8(N){return b(this.buffer,N)}writeUInt8(N,D){y(this.buffer,N,D)}indexOf(N,D=0){return u(this.buffer,N instanceof m?N.buffer:N,D)}}e.$Se=m;function u(T,N,D=0){const j=N.byteLength,x=T.byteLength;if(j===0)return 0;if(j===1)return T.indexOf(N[0]);if(j>x-D)return-1;const Y=k.value;Y.fill(N.length);for(let me=0;me<N.length;me++)Y[N[me]]=N.length-me-1;let ne=D+N.length-1,ae=ne,ue=-1;for(;ne<x;)if(T[ne]===N[ae]){if(ae===0){ue=ne;break}ne--,ae--}else ne+=Math.max(N.length-ae,Y[T[ne]]),ae=N.length-1;return ue}function d(T,N){return T[N+0]<<0>>>0|T[N+1]<<8>>>0}function f(T,N,D){T[D+0]=N&255,N=N>>>8,T[D+1]=N&255}function $(T,N){return T[N]*2**24+T[N+1]*2**16+T[N+2]*2**8+T[N+3]}function h(T,N,D){T[D+3]=N,N=N>>>8,T[D+2]=N,N=N>>>8,T[D+1]=N,N=N>>>8,T[D]=N}function g(T,N){return T[N+0]<<0>>>0|T[N+1]<<8>>>0|T[N+2]<<16>>>0|T[N+3]<<24>>>0}function S(T,N,D){T[D+0]=N&255,N=N>>>8,T[D+1]=N&255,N=N>>>8,T[D+2]=N&255,N=N>>>8,T[D+3]=N&255}function b(T,N){return T[N]}function y(T,N,D){T[D]=N}function c(T){return I.$He(T,N=>m.concat(N))}function O(T){return I.$Oe(T)}function w(T){return I.$Je(T,N=>m.concat(N))}async function i(T){return T.ended?m.concat(T.buffer):m.concat([...T.buffer,await w(T.stream)])}function a(T){return I.$Me(T,N=>m.concat(N))}function n(T){return I.$Pe(T,{data:N=>typeof N=="string"?m.fromString(N):m.wrap(N)},N=>m.concat(N))}function r(T){return I.$Ge(N=>m.concat(N),T)}function t(T,N){return I.$Qe(T,N,D=>m.concat(D))}function s(T,N){return I.$Re(T,N,D=>m.concat(D))}function o(T){let N=0,D=0,j=0;const x=new Uint8Array(Math.floor(T.length/4*3)),Y=ae=>{switch(D){case 3:x[j++]=N|ae,D=0;break;case 2:x[j++]=N|ae>>>2,N=ae<<6,D=3;break;case 1:x[j++]=N|ae>>>4,N=ae<<4,D=2;break;default:N=ae<<2,D=1}};for(let ae=0;ae<T.length;ae++){const ue=T.charCodeAt(ae);if(ue>=65&&ue<=90)Y(ue-65);else if(ue>=97&&ue<=122)Y(ue-97+26);else if(ue>=48&&ue<=57)Y(ue-48+52);else if(ue===43||ue===45)Y(62);else if(ue===47||ue===95)Y(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ae]}`)}}const ne=j;for(;D>0;)Y(0);return m.wrap(x).slice(0,ne)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:T},N=!0,D=!1){const j=D?p:l;let x="";const Y=T.byteLength%3;let ne=0;for(;ne<T.byteLength-Y;ne+=3){const ae=T[ne+0],ue=T[ne+1],me=T[ne+2];x+=j[ae>>>2],x+=j[(ae<<4|ue>>>4)&63],x+=j[(ue<<2|me>>>6)&63],x+=j[me&63]}if(Y===1){const ae=T[ne+0];x+=j[ae>>>2],x+=j[ae<<4&63],N&&(x+="==")}else if(Y===2){const ae=T[ne+0],ue=T[ne+1];x+=j[ae>>>2],x+=j[(ae<<4|ue>>>4)&63],x+=j[ue<<2&63],N&&(x+="=")}return x}}),define(le[27],he([0,1,3]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=I,e.$lo=v,e.$mo=C,e.$no=m,e.$oo=u,e.$po=d,e.$qo=f,e.$ro=$,e.$so=h,e.$to=g,e.$uo=S,e.$vo=b,e.$wo=y;function I(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const O=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([w,i])=>{O[w]=i&&typeof i=="object"?I(i):i}),O}function v(c){if(!c||typeof c!="object")return c;const O=[c];for(;O.length>0;){const w=O.shift();Object.freeze(w);for(const i in w)if(k.call(w,i)){const a=w[i];typeof a=="object"&&!Object.isFrozen(a)&&!(0,P.$mg)(a)&&O.push(a)}}return c}const k=Object.prototype.hasOwnProperty;function C(c,O){return R(c,O,new Set)}function R(c,O,w){if((0,P.$sg)(c))return c;const i=O(c);if(typeof i<"u")return i;if(Array.isArray(c)){const a=[];for(const n of c)a.push(R(n,O,w));return a}if((0,P.$lg)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const a={};for(const n in c)k.call(c,n)&&(a[n]=R(c[n],O,w));return w.delete(c),a}return c}function m(c,O,w=!0){return(0,P.$lg)(c)?((0,P.$lg)(O)&&Object.keys(O).forEach(i=>{i in c?w&&((0,P.$lg)(c[i])&&(0,P.$lg)(O[i])?m(c[i],O[i],w):c[i]=O[i]):c[i]=O[i]}),c):O}function u(c,O){if(c===O)return!0;if(c==null||O===null||O===void 0||typeof c!=typeof O||typeof c!="object"||Array.isArray(c)!==Array.isArray(O))return!1;let w,i;if(Array.isArray(c)){if(c.length!==O.length)return!1;for(w=0;w<c.length;w++)if(!u(c[w],O[w]))return!1}else{const a=[];for(i in c)a.push(i);a.sort();const n=[];for(i in O)n.push(i);if(n.sort(),!u(a,n))return!1;for(w=0;w<a.length;w++)if(!u(c[a[w]],O[a[w]]))return!1}return!0}function d(c){const O=new Set;return JSON.stringify(c,(w,i)=>{if((0,P.$lg)(i)||Array.isArray(i)){if(O.has(i))return"[Circular]";O.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function f(c,O){const w=Object.create(null);return!c||!O||Object.keys(O).forEach(a=>{const n=c[a],r=O[a];u(n,r)||(w[a]=r)}),w}function $(c,O){const w=O.toLowerCase(),i=Object.keys(c).find(a=>a.toLowerCase()===w);return i?c[i]:c[O]}function h(c,O){const w=Object.create(null);for(const[i,a]of Object.entries(c))O(i,a)&&(w[i]=a);return w}function g(c){let O=[];for(;Object.prototype!==c;)O=O.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return O}function S(c){const O=[];for(const w of g(c))typeof c[w]=="function"&&O.push(w);return O}function b(c,O){const w=a=>function(){const n=Array.prototype.slice.call(arguments,0);return O(a,n)},i={};for(const a of c)i[a]=w(a);return i}function y(c,O){const w={};for(const[i,a]of Object.entries(c))w[i]=O(a,i);return w}}),define(le[43],he([0,1,31]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Cj=void 0,e.$yj=I,e.$zj=v,e.$Aj=k,e.$Bj=R,e.$Dj=S,P=be(P);function I(y){return v(y,0)}function v(y,c){switch(typeof y){case"object":return y===null?k(349,c):Array.isArray(y)?m(y,c):u(y,c);case"string":return R(y,c);case"boolean":return C(y,c);case"number":return k(y,c);case"undefined":return k(937,c);default:return k(617,c)}}function k(y,c){return(c<<5)-c+y|0}function C(y,c){return k(y?433:863,c)}function R(y,c){c=k(149417,c);for(let O=0,w=y.length;O<w;O++)c=k(y.charCodeAt(O),c);return c}function m(y,c){return c=k(104579,c),y.reduce((O,w)=>v(w,O),c)}function u(y,c){return c=k(181387,c),Object.keys(y).sort().reduce((O,w)=>(O=R(w,O),v(y[w],O)),c)}class d{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=v(c,this.g),this.g}}e.$Cj=d;var f;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(f||(f={}));function $(y,c,O=32){const w=O-c,i=~((1<<w)-1);return(y<<c|(i&y)>>>w)>>>0}function h(y,c=0,O=y.byteLength,w=0){for(let i=0;i<O;i++)y[c+i]=w}function g(y,c,O="0"){for(;y.length<c;)y=O+y;return y}function S(y,c=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(O=>O.toString(16).padStart(2,"0")).join(""):g((y>>>0).toString(16),c/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(f.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const O=c.length;if(O===0)return;const w=this.p;let i=this.r,a=this.u,n,r;for(a!==0?(n=a,r=-1,a=0):(n=c.charCodeAt(0),r=0);;){let t=n;if(P.$Of(n))if(r+1<O){const s=c.charCodeAt(r+1);P.$Pf(s)?(r++,t=P.$Qf(n,s)):t=f.UNICODE_REPLACEMENT}else{a=n;break}else P.$Pf(n)&&(t=f.UNICODE_REPLACEMENT);if(i=this.w(w,i,t),r++,r<O)n=c.charCodeAt(r);else break}this.r=i,this.u=a}w(c,O,w){return w<128?c[O++]=w:w<2048?(c[O++]=192|(w&1984)>>>6,c[O++]=128|(w&63)>>>0):w<65536?(c[O++]=224|(w&61440)>>>12,c[O++]=128|(w&4032)>>>6,c[O++]=128|(w&63)>>>0):(c[O++]=240|(w&1835008)>>>18,c[O++]=128|(w&258048)>>>12,c[O++]=128|(w&4032)>>>6,c[O++]=128|(w&63)>>>0),O>=f.BLOCK_SIZE&&(this.y(),O-=f.BLOCK_SIZE,this.t+=f.BLOCK_SIZE,c[0]=c[f.BLOCK_SIZE+0],c[1]=c[f.BLOCK_SIZE+1],c[2]=c[f.BLOCK_SIZE+2]),O}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,f.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=b.g,O=this.q;for(let l=0;l<64;l+=4)c.setUint32(l,O.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)c.setUint32(l,$(c.getUint32(l-12,!1)^c.getUint32(l-32,!1)^c.getUint32(l-56,!1)^c.getUint32(l-64,!1),1),!1);let w=this.h,i=this.l,a=this.m,n=this.n,r=this.o,t,s,o;for(let l=0;l<80;l++)l<20?(t=i&a|~i&n,s=1518500249):l<40?(t=i^a^n,s=1859775393):l<60?(t=i&a|i&n|a&n,s=2400959708):(t=i^a^n,s=3395469782),o=$(w,5)+t+r+s+c.getUint32(l*4,!1)&4294967295,r=n,n=a,a=$(i,30),i=w,w=o;this.h=this.h+w&4294967295,this.l=this.l+i&4294967295,this.m=this.m+a&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.$Ej=b}),define(le[56],he([0,1,31]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=be(P);var I;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(I||(I={})),function(v){const k="error",C="warning",R="warn",m="info",u="ignore";function d($){return $?P.$Kf(k,$)?v.Error:P.$Kf(C,$)||P.$Kf(R,$)?v.Warning:P.$Kf(m,$)?v.Info:v.Ignore:v.Ignore}v.fromValue=d;function f($){switch($){case v.Error:return k;case v.Warning:return C;case v.Info:return m;default:return u}}v.toString=f}(I||(I={})),e.default=I}),define(le[28],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=I;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(v){return P.test(v)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(R){for(let m=0;m<R.length;m++)R[m]=Math.floor(Math.random()*256);return R};const k=new Uint8Array(16),C=[];for(let R=0;R<256;R++)C.push(R.toString(16).padStart(2,"0"));return function(){v(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let m=0,u="";return u+=C[k[m++]],u+=C[k[m++]],u+=C[k[m++]],u+=C[k[m++]],u+="-",u+=C[k[m++]],u+=C[k[m++]],u+="-",u+=C[k[m++]],u+=C[k[m++]],u+="-",u+=C[k[m++]],u+=C[k[m++]],u+="-",u+=C[k[m++]],u+=C[k[m++]],u+=C[k[m++]],u+=C[k[m++]],u+=C[k[m++]],u+=C[k[m++]],u}}()}),define(le[82],he([0,1,35]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=k;const I=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(C){const R=C.replace(/\-/g,":").toLowerCase();return!I.has(R)}function k(){const C=(0,P.networkInterfaces)();for(const R in C){const m=C[R];if(m){for(const{mac:u}of m)if(v(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[83],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0,e.$cp=I;const P="Offline";function I(k){return k instanceof v?!0:k instanceof Error&&k.name===P&&k.message===P}class v extends Error{constructor(){super(P),this.name=this.message}}e.$dp=v}),define(le[84],he([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=u,e.$8m=d,e.$9m=f,e.$0m=$;const I=60,v=I*60,k=v*24,C=k*7,R=k*30,m=k*365;function u(h,g,S,b){typeof h!="number"&&(h=h.getTime());const y=Math.round((new Date().getTime()-h)/1e3);if(y<-30)return(0,P.localize)(42,null,u(new Date().getTime()+y*1e3,!1));if(!b&&y<30)return(0,P.localize)(43,null);let c;return y<I?(c=y,g?c===1?S?(0,P.localize)(44,null,c):(0,P.localize)(45,null,c):S?(0,P.localize)(46,null,c):(0,P.localize)(47,null,c):c===1?S?(0,P.localize)(48,null,c):(0,P.localize)(49,null,c):S?(0,P.localize)(50,null,c):(0,P.localize)(51,null,c)):y<v?(c=Math.floor(y/I),g?c===1?S?(0,P.localize)(52,null,c):(0,P.localize)(53,null,c):S?(0,P.localize)(54,null,c):(0,P.localize)(55,null,c):c===1?S?(0,P.localize)(56,null,c):(0,P.localize)(57,null,c):S?(0,P.localize)(58,null,c):(0,P.localize)(59,null,c)):y<k?(c=Math.floor(y/v),g?c===1?S?(0,P.localize)(60,null,c):(0,P.localize)(61,null,c):S?(0,P.localize)(62,null,c):(0,P.localize)(63,null,c):c===1?S?(0,P.localize)(64,null,c):(0,P.localize)(65,null,c):S?(0,P.localize)(66,null,c):(0,P.localize)(67,null,c)):y<C?(c=Math.floor(y/k),g?c===1?(0,P.localize)(68,null,c):(0,P.localize)(69,null,c):c===1?(0,P.localize)(70,null,c):(0,P.localize)(71,null,c)):y<R?(c=Math.floor(y/C),g?c===1?S?(0,P.localize)(72,null,c):(0,P.localize)(73,null,c):S?(0,P.localize)(74,null,c):(0,P.localize)(75,null,c):c===1?S?(0,P.localize)(76,null,c):(0,P.localize)(77,null,c):S?(0,P.localize)(78,null,c):(0,P.localize)(79,null,c)):y<m?(c=Math.floor(y/R),g?c===1?S?(0,P.localize)(80,null,c):(0,P.localize)(81,null,c):S?(0,P.localize)(82,null,c):(0,P.localize)(83,null,c):c===1?S?(0,P.localize)(84,null,c):(0,P.localize)(85,null,c):S?(0,P.localize)(86,null,c):(0,P.localize)(87,null,c)):(c=Math.floor(y/m),g?c===1?S?(0,P.localize)(88,null,c):(0,P.localize)(89,null,c):S?(0,P.localize)(90,null,c):(0,P.localize)(91,null,c):c===1?S?(0,P.localize)(92,null,c):(0,P.localize)(93,null,c):S?(0,P.localize)(94,null,c):(0,P.localize)(95,null,c))}function d(h,g,S){typeof h!="number"&&(h=h.getTime());const b=new Date;b.setHours(0,0,0,0);const y=new Date(b.getTime());return y.setDate(y.getDate()-1),h>b.getTime()?(0,P.localize)(96,null):h>y.getTime()?(0,P.localize)(97,null):u(h,g,S)}function f(h,g){const S=Math.abs(h/1e3);return S<1?g?(0,P.localize)(98,null,h):(0,P.localize)(99,null,h):S<I?g?(0,P.localize)(100,null,Math.round(h)/1e3):(0,P.localize)(101,null,Math.round(h)/1e3):S<v?g?(0,P.localize)(102,null,Math.round(h/(1e3*I))):(0,P.localize)(103,null,Math.round(h/(1e3*I))):S<k?g?(0,P.localize)(104,null,Math.round(h/(1e3*v))):(0,P.localize)(105,null,Math.round(h/(1e3*v))):(0,P.localize)(106,null,Math.round(h/(1e3*k)))}function $(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[38],he([0,1,19,3,4]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=m,e.$wj=u,e.$xj=d,P=be(P),I=be(I),v=be(v);function k(f,$){return $&&(f.stack||f.stacktrace)?v.localize(107,null,R(f),C(f.stack)||C(f.stacktrace)):R(f)}function C(f){return Array.isArray(f)?f.join(`
`):f}function R(f){return f.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${f.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?v.localize(108,null,f.message):f.message||v.localize(109,null)}function m(f=null,$=!1){if(!f)return v.localize(110,null);if(Array.isArray(f)){const h=P.$Lb(f),g=m(h[0],$);return h.length>1?v.localize(111,null,g,h.length):g}if(I.$jg(f))return f;if(f.detail){const h=f.detail;if(h.error)return k(h.error,$);if(h.exception)return k(h.exception,$)}return f.stack?k(f,$):f.message?f.message:v.localize(112,null)}function u(f){const $=f;return $ instanceof Error&&Array.isArray($.actions)}function d(f,$){let h;return typeof f=="string"?h=new Error(f):h=f,h.actions=$,h}}),define(le[85],he([0,1,4,34]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=v;function v(k){switch(k){case I.ParseErrorCode.InvalidSymbol:return(0,P.localize)(113,null);case I.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(114,null);case I.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(115,null);case I.ParseErrorCode.ValueExpected:return(0,P.localize)(116,null);case I.ParseErrorCode.ColonExpected:return(0,P.localize)(117,null);case I.ParseErrorCode.CommaExpected:return(0,P.localize)(118,null);case I.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(119,null);case I.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(120,null);case I.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(121,null);default:return""}}}),define(le[57],he([0,1,11]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=k,e.$rm=C;var I;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(I||(e.Source=I={}));var v;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(v||(e.TerminateResponseCode=v={}));function k(R,...m){const u=m.reduce(($,h)=>($[h]=!0,$),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter($=>!u[$]).forEach($=>{for(let h=0;h<d.length;h++)if($.search(d[h])!==-1){delete R[$];break}})}function C(R){R&&(delete R.DEBUG,P.$n&&delete R.LD_PRELOAD)}}),define(le[86],he([0,1,12]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=I,e.$mr=v,e.$nr=k,e.log=R;function I(u){const d=u;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function v(u){const d=[];let f;try{const $=JSON.parse(u.arguments),h=$[$.length-1];h&&h.__$stack&&($.pop(),f=h.__$stack),d.push(...$)}catch{d.push("Unable to log remote console arguments",u.arguments)}return{args:d,stack:f}}function k(u){if(typeof u!="string")return k(v(u).stack);const d=u;if(d){const f=C(d),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if($&&$.length===4)return{uri:P.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function C(u){if(!u)return u;const d=u.indexOf(`
`);return d===-1?u:u.substring(0,d)}function R(u,d){const{args:f,stack:$}=v(u),h=typeof f[0]=="string"&&f.length===1;let g=C($);g&&(g=`(${g.trim()})`);let S=[];if(typeof f[0]=="string"?g&&h?S=[`%c[${d}] %c${f[0]} %c${g}`,m("blue"),m(""),m("grey")]:S=[`%c[${d}] %c${f[0]}`,m("blue"),m(""),...f.slice(1)]:S=[`%c[${d}]%`,m("blue"),...f],g&&!h&&S.push(g),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,S)}function m(u){return`color: ${u}`}}),define(le[48],he([0,1,13,12,148]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=k,e.$gi=C,e.$hi=m;function k(u){return JSON.stringify(u,R)}function C(u){let d=JSON.parse(u);return d=m(d),d}function R(u,d){return d instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:d.source,flags:d.flags}:d}function m(u,d=0){if(!u||d>200)return u;if(typeof u=="object"){switch(u.$mid){case v.MarshalledId.Uri:return I.URI.revive(u);case v.MarshalledId.Regexp:return new RegExp(u.source,u.flags);case v.MarshalledId.Date:return new Date(u.source)}if(u instanceof P.$Se||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let f=0;f<u.length;++f)u[f]=m(u[f],d+1);else for(const f in u)Object.hasOwnProperty.call(u,f)&&(u[f]=m(u[f],d+1))}return u}}),define(le[58],he([0,1,75,14,11,3,12]),function(Q,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=f,e.$Aq=$,v=be(v);class R{constructor(g,S,b){this.id=g,this.dependencies=S,this.callback=b}}class m{static{this.INSTANCE=new m}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,S,b)=>{typeof g!="string"&&(b=S,S=g,g=null),(typeof S!="object"||!Array.isArray(S))&&(b=S,S=null),this.c.push(new R(g,S,b))},globalThis.define.amd=!0,this.b?this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith(`${I.Schemas.vscodeFileResource}://${I.$4g}`))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const S=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!S){console.warn(`Did not receive a define call from script ${g}`);return}const b={},y=[],c=[];if(Array.isArray(S.dependencies))for(const O of S.dependencies)O==="exports"?y.push(b):c.push(O);if(c.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${c.join(", ")}`);return typeof S.callback=="function"?S.callback(...y)??b:S.callback}h(g){return new Promise((S,b)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const c=()=>{y.removeEventListener("load",O),y.removeEventListener("error",w)},O=i=>{c(),S(this.c.pop())},w=i=>{c(),b(i)};y.addEventListener("load",O),y.addEventListener("error",w),this.f&&(g=this.f.createScriptURL(g)),y.setAttribute("src",g),window.document.getElementsByTagName("head")[0].appendChild(y)})}async i(g){return this.f&&(g=this.f.createScriptURL(g)),P.$V?await new Promise((S,b)=>{Q([g],S,b)}).then(be):importScripts(g),this.c.pop()}async j(g){try{const S=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,c=C.URI.parse(g).fsPath,O=S.readFileSync(c).toString(),w=y.wrap(O.replace(/^#!.*/,""));return new b.Script(w).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const u=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function f(h,g,S){if(P.$V){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[h]&&(h=d[h]);const b=g?`${h}/${g}`:h;if(u.has(b))return u.get(b);let y;if(/^\w[\w\d+.-]*:\/\//.test(b))y=b;else{const i=`${P.$W&&S&&!v.$r?I.$2g:I.$1g}/${b}`;y=I.$5g.asBrowserUri(i).toString(!0)}const c=m.INSTANCE.load(y);return u.set(b,c),c}else return await new Promise((b,y)=>{Q([h],b,y)}).then(be)}function $(h,g){(0,k.$tg)(P.$V);const b=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,y=P.$W&&b&&!v.$r,c=`${h}/${g}`,w=`${y?I.$2g:I.$1g}/${c}`;return I.$5g.asBrowserUri(w).toString(!0)}}),define(le[87],he([0,1,35,49,28,82,11]),function(Q,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Zn=m,e.$1n=f,e.$2n=$,v=be(v),e.$Yn=new class{c(h){return this.a||(this.a=I.$Qi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(h)}value(){if(this.b===void 0){let h=0,g=0;const S=(0,P.networkInterfaces)();for(const b in S){const y=S[b];if(y)for(const{mac:c,internal:O}of y)O||(g+=1,this.c(c.toUpperCase())&&(h+=1))}this.b=g>0?h/g:0}return this.b}};let R;async function m(h){return R||(R=(async()=>await u(h)||v.$7g())()),R}async function u(h){try{const g=await new Promise((b,y)=>{Q(["crypto"],b,y)}).then(be),S=(0,k.$Xn)();return g.createHash("sha256").update(S,"utf8").digest("hex")}catch(g){h(g);return}}const d="Software\\Microsoft\\SQMClient";async function f(h){if(C.$l){const g=await new Promise((S,b)=>{Q(["@vscode/windows-registry"],S,b)}).then(be);try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(S){return h(S),""}}return""}async function $(h){try{return await(await new Promise((b,y)=>{Q(["@vscode/deviceid"],b,y)}).then(be)).getDeviceId()}catch(g){return h(g),""}}}),define(le[88],he([0,1,35,15,29]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=c,e.$Cm=O,P=be(P),I=be(I),v=be(v);const k=/^\d+$/,C=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var m;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(m||(m={}));let u;switch(process.arch){case"ia32":u=m.x86;break;case"arm":case"arm64":u=m.ARM;break;default:u=m.x64;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?m.ARM:m.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=m.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=m.x86:d=m.x64;class f{constructor(i,a,n){this.exePath=i,this.displayName=a,this.a=n}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function $({useAlternateBitness:w=!1}={}){return w?u===m.x64?process.env["ProgramFiles(x86)"]||null:d===m.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:w=!1,findPreview:i=!1}={}){const a=$({useAlternateBitness:w});if(!a)return null;const n=I.$oc(a,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(n))return null;let r=-1,t=null;for(const l of await v.Promises.readdir(n)){let p=-1;if(i){const T=l.indexOf("-");if(T<0)continue;const N=l.substring(0,T);if(!k.test(N)||l.substring(T+1)!=="preview")continue;p=parseInt(N,10)}else{if(!k.test(l))continue;p=parseInt(l,10)}if(p<=r)continue;const A=I.$oc(n,l,"pwsh.exe");await v.SymlinkSupport.existsFile(A)&&(t=A,r=p)}if(!t)return null;const s=a.includes("x86")?" (x86)":"",o=i?" Preview":"";return new f(t,`PowerShell${o}${s}`,!0)}async function g({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const i=I.$oc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:a,pwshMsixName:n}=w?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await v.Promises.readdir(i))if(a.test(r)){const t=I.$oc(i,r,"pwsh.exe");return new f(t,n)}return null}function S(){const w=I.$oc(P.homedir(),".dotnet","tools","pwsh.exe");return new f(w,".NET Core PowerShell Global Tool")}function b(){const w=I.$oc(process.env.windir,u===m.x86&&d!==m.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(w,"Windows PowerShell",!0)}async function*y(){let w=await h();w&&(yield w),w=await h({useAlternateBitness:!0}),w&&(yield w),w=await g(),w&&(yield w),w=S(),w&&(yield w),w=await h({findPreview:!0}),w&&(yield w),w=await g({findPreview:!0}),w&&(yield w),w=await h({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=b(),w&&(yield w)}async function*c(){for await(const w of y())await w.exists()&&(yield w)}async function O(){for await(const w of c())return w;return null}}),define(le[59],he([0,1,32,15,11,36,57,3,29]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Dm=u,e.$Em=d,I=be(I),v=be(v),k=be(k),R=be(R),m=be(m),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function u($=k.env){return $.comspec||"cmd.exe"}function d($){let h=[],g=!1;const S=function(b){if(g){h.push(b);return}(!$.send(b,c=>{if(c&&console.error(c),g=!1,h.length>0){const O=h.slice(0);h=[],O.forEach(w=>S(w))}})||v.$l)&&(g=!0)};return{send:S}}var f;(function($){async function h(g,S,b){if(I.$nc(g))return g;if(S===void 0&&(S=k.cwd()),I.$rc(g)!=="."||(b===void 0&&R.$jg(k.env.PATH)&&(b=k.env.PATH.split(I.$yc)),b===void 0||b.length===0))return I.$oc(S,g);async function c(O){if(await m.Promises.exists(O)){let w;try{w=await P.promises.stat(O)}catch(i){i.message.startsWith("EACCES")&&(w=await P.promises.lstat(O))}return w?!w.isDirectory():!1}return!1}for(const O of b){let w;if(I.$nc(O)?w=I.$oc(O,g):w=I.$oc(S,O,g),await c(w))return w;let i=w+".com";if(await c(i)||(i=w+".exe",await c(i)))return i}return I.$oc(S,g)}$.findExecutable=h})(f||(e.win32=f={}))}),define(le[89],he([0,1,35,11,88,59]),function(Q,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=C,I=be(I),k=be(k);async function C(f,$){return f===I.OperatingSystem.Windows?I.$l?d():k.$Dm($):m(f,$)}let R=null;function m(f,$){if(I.$n&&f===I.OperatingSystem.Macintosh||I.$m&&f===I.OperatingSystem.Linux)return"/bin/bash";if(!R){let h;if(I.$l)h="/bin/bash";else{if(h=$.SHELL,!h)try{h=(0,P.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}R=h}return R}let u=null;async function d(){return u||(u=(await(0,v.$Cm)()).exePath),u}}),define(le[50],he([0,1,32,8,15,3,29,4]),function(Q,e,P,I,v,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0,e.zip=b,e.$Lq=y,e.$Mq=O,v=be(v),R=be(R),e.$Iq="end of central directory record signature not found";const m=new RegExp(e.$Iq);class u extends Error{constructor(i,a){let n=a.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=a}}e.$Jq=u;function d(w){const i=w.externalFileAttributes>>16||33188;return[448,56,7].map(a=>i&a).reduce((a,n)=>a+n,i&61440)}function f(w){if(w instanceof u)return w;let i;return m.test(w.message)&&(i="CorruptZip"),new u(i,w)}function $(w,i,a,n,r,t){const s=v.$rc(i),o=v.$oc(n,s);if(!o.startsWith(n))return Promise.reject(new Error(R.localize(142,null,i)));const l=v.$oc(n,i);let p;return t.onCancellationRequested(()=>{p?.destroy()}),Promise.resolve(P.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((A,T)=>{if(!t.isCancellationRequested)try{p=(0,P.createWriteStream)(l,{mode:a}),p.once("close",()=>A()),p.once("error",T),w.once("error",T),w.pipe(p)}catch(N){T(N)}}))}function h(w,i,a,n){let r=(0,I.$xh)(()=>Promise.resolve()),t=0;const s=n.onCancellationRequested(()=>{r.cancel(),w.close()});return new Promise((o,l)=>{const p=new I.$Fh,A=T=>{T.isCancellationRequested||(t++,w.readEntry())};w.once("error",l),w.once("close",()=>r.then(()=>{n.isCancellationRequested||w.entryCount===t?o():l(new u("Incomplete",new Error(R.localize(143,null,t,w.entryCount))))},l)),w.readEntry(),w.on("entry",T=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(T.fileName)){A(n);return}const N=T.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(N)){const x=v.$oc(i,N);r=(0,I.$xh)(Y=>P.promises.mkdir(x,{recursive:!0}).then(()=>A(Y)).then(void 0,l));return}const D=S(w,T),j=d(T);r=(0,I.$xh)(x=>p.queue(()=>D.then(Y=>$(Y,N,j,i,a,x).then(()=>A(x)))).then(null,l))})}).finally(()=>s.dispose())}async function g(w,i=!1){const{open:a}=await new Promise((n,r)=>{Q(["yauzl"],n,r)}).then(be);return new Promise((n,r)=>{a(w,i?{lazyEntries:!0}:void 0,(t,s)=>{t?r(f(t)):n((0,k.$ug)(s))})})}function S(w,i){return new Promise((a,n)=>{w.openReadStream(i,(r,t)=>{r?n(f(r)):a((0,k.$ug)(t))})})}async function b(w,i){const{ZipFile:a}=await new Promise((n,r)=>{Q(["yazl"],n,r)}).then(be);return new Promise((n,r)=>{const t=new a;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,P.createWriteStream)(w);t.outputStream.pipe(s),t.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(w))})}function y(w,i,a={},n){const r=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let t=g(w,!0);return a.overwrite&&(t=t.then(s=>C.Promises.rm(i).then(()=>s))),t.then(s=>h(s,i,{sourcePathRegex:r},n))}function c(w,i){return g(w).then(a=>new Promise((n,r)=>{a.on("entry",t=>{t.fileName===i&&S(a,t).then(s=>n(s),s=>r(s))}),a.once("close",()=>r(new Error(R.localize(144,null,i))))}))}function O(w,i){return c(w,i).then(a=>new Promise((n,r)=>{const t=[];a.once("error",r),a.on("data",s=>t.push(s)),a.on("end",()=>n(Buffer.concat(t)))}))}});var Ee=this&&this.__decorate||function(Q,e,P,I){var v=arguments.length,k=v<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,P):I,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Q,e,P,I);else for(var R=Q.length-1;R>=0;R--)(C=Q[R])&&(k=(v<3?C(k):v>3?C(e,P,k):C(e,P))||k);return v>3&&k&&Object.defineProperty(e,P,k),k};define(le[60],he([0,1,19,8,13,21,55,7,5,2,48,31,3]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.ProxyChannel=e.$si=e.$pi=e.$oi=e.$ni=e.RequestInitiator=e.$mi=e.$ji=e.$ii=void 0,e.$ki=o,e.$li=l,e.$qi=j,e.$ri=x,f=be(f);var h;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(h||(h={}));function g(M){switch(M){case h.Promise:return"req";case h.PromiseCancel:return"cancel";case h.EventListen:return"subscribe";case h.EventDispose:return"unsubscribe"}}var S;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(S||(S={}));function b(M){switch(M){case S.Initialize:return"init";case S.PromiseSuccess:return"reply:";case S.PromiseError:case S.PromiseErrorObj:return"replyErr:";case S.EventFire:return"event:"}}var y;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(y||(y={}));function c(M){let U=0;for(let H=0;;H+=7){const K=M.read(1);if(U|=(K.buffer[0]&127)<<H,!(K.buffer[0]&128))return U}}const O=r(0);function w(M,U){if(U===0){M.write(O);return}let H=0;for(let ie=U;ie!==0;ie=ie>>>7)H++;const K=v.$Se.alloc(H);for(let ie=0;U!==0;ie++)K.buffer[ie]=U&127,U=U>>>7,U>0&&(K.buffer[ie]|=128);M.write(K)}class i{constructor(U){this.b=U,this.a=0}read(U){const H=this.b.slice(this.a,this.a+U);return this.a+=H.byteLength,H}}e.$ii=i;class a{constructor(){this.a=[]}get buffer(){return v.$Se.concat(this.a)}write(U){this.a.push(U)}}e.$ji=a;var n;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(n||(n={}));function r(M){const U=v.$Se.alloc(1);return U.writeUInt8(M,0),U}const t={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(M,U){if(typeof U>"u")M.write(t.Undefined);else if(typeof U=="string"){const H=v.$Se.fromString(U);M.write(t.String),w(M,H.byteLength),M.write(H)}else if(s&&Buffer.isBuffer(U)){const H=v.$Se.wrap(U);M.write(t.Buffer),w(M,H.byteLength),M.write(H)}else if(U instanceof v.$Se)M.write(t.VSBuffer),w(M,U.byteLength),M.write(U);else if(Array.isArray(U)){M.write(t.Array),w(M,U.length);for(const H of U)o(M,H)}else if(typeof U=="number"&&(U|0)===U)M.write(t.Uint),w(M,U);else{const H=v.$Se.fromString(JSON.stringify(U));M.write(t.Object),w(M,H.byteLength),M.write(H)}}function l(M){switch(M.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return M.read(c(M)).toString();case n.Buffer:return M.read(c(M)).buffer;case n.VSBuffer:return M.read(c(M));case n.Array:{const H=c(M),K=[];for(let ie=0;ie<H;ie++)K.push(l(M));return K}case n.Object:return JSON.parse(M.read(c(M)).toString());case n.Int:return c(M)}}class p{constructor(U,H,K=null,ie=1e3){this.h=U,this.j=H,this.k=K,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:S.Initialize})}registerChannel(U,H){this.b.set(U,H),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case S.Initialize:{const H=this.o([U.type]);this.k?.logOutgoing(H,0,A.OtherSide,b(U.type));return}case S.PromiseSuccess:case S.PromiseError:case S.EventFire:case S.PromiseErrorObj:{const H=this.o([U.type,U.id],U.data);this.k?.logOutgoing(H,U.id,A.OtherSide,b(U.type),U.data);return}}}o(U,H=void 0){const K=new a;return o(K,U),o(K,H),this.p(K.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const H=new i(U),K=l(H),ie=l(H),se=K[0];switch(se){case h.Promise:return this.k?.logIncoming(U.byteLength,K[1],A.OtherSide,`${g(se)}: ${K[2]}.${K[3]}`,ie),this.s({type:se,id:K[1],channelName:K[2],name:K[3],arg:ie});case h.EventListen:return this.k?.logIncoming(U.byteLength,K[1],A.OtherSide,`${g(se)}: ${K[2]}.${K[3]}`,ie),this.t({type:se,id:K[1],channelName:K[2],name:K[3],arg:ie});case h.PromiseCancel:return this.k?.logIncoming(U.byteLength,K[1],A.OtherSide,`${g(se)}`),this.u({type:se,id:K[1]});case h.EventDispose:return this.k?.logIncoming(U.byteLength,K[1],A.OtherSide,`${g(se)}`),this.u({type:se,id:K[1]})}}s(U){const H=this.b.get(U.channelName);if(!H){this.v(U);return}const K=new k.$Be;let ie;try{ie=H.call(this.j,U.name,U.arg,K.token)}catch(V){ie=Promise.reject(V)}const se=U.id;ie.then(V=>{this.m({id:se,data:V,type:S.PromiseSuccess})},V=>{V instanceof Error?this.m({id:se,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split(`
`):void 0},type:S.PromiseError}):this.m({id:se,data:V,type:S.PromiseErrorObj})}).finally(()=>{L.dispose(),this.d.delete(U.id)});const L=(0,u.$Xc)(()=>K.cancel());this.d.set(U.id,L)}t(U){const H=this.b.get(U.channelName);if(!H){this.v(U);return}const K=U.id,se=H.listen(this.j,U.name,U.arg)(L=>this.m({id:K,data:L,type:S.EventFire}));this.d.set(U.id,se)}u(U){const H=this.d.get(U.id);H&&(H.dispose(),this.d.delete(U.id))}v(U){let H=this.g.get(U.channelName);H||(H=[],this.g.set(U.channelName,H));const K=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===h.Promise&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:S.PromiseError})},this.l);H.push({request:U,timeoutTimer:K})}w(U){const H=this.g.get(U);if(H){for(const K of H)switch(clearTimeout(K.timeoutTimer),K.request.type){case h.Promise:this.s(K.request);break;case h.EventListen:this.t(K.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$Uc)(this.d.values()),this.d.clear()}}e.$mi=p;var A;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class T{constructor(U,H=null){this.l=U,this.a=!1,this.b=y.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$qe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=H}getChannel(U){const H=this;return{call(K,ie,se){return H.a?Promise.reject(new R.$9):H.m(U,K,ie,se)},listen(K,ie){return H.a?m.Event.None:H.o(U,K,ie)}}}m(U,H,K,ie=k.CancellationToken.None){const se=this.g++,L=h.Promise,V={id:se,type:L,channelName:U,name:H,arg:K};if(ie.isCancellationRequested)return Promise.reject(new R.$9);let z;return new Promise((F,X)=>{if(ie.isCancellationRequested)return X(new R.$9);const J=()=>{const re=ce=>{switch(ce.type){case S.PromiseSuccess:this.f.delete(se),F(ce.data);break;case S.PromiseError:{this.f.delete(se);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,X(fe);break}case S.PromiseErrorObj:this.f.delete(se),X(ce.data);break}};this.f.set(se,re),this.p(V)};let G=null;this.b===y.Idle?J():(G=(0,I.$xh)(re=>this.u()),G.then(()=>{G=null,J()}));const q=()=>{G?(G.cancel(),G=null):this.p({id:se,type:h.PromiseCancel}),X(new R.$9)},Z=ie.onCancellationRequested(q);z=(0,u.$Wc)((0,u.$Xc)(q),Z),this.d.add(z)}).finally(()=>{z.dispose(),this.d.delete(z)})}o(U,H,K){const ie=this.g++,se=h.EventListen,L={id:ie,type:se,channelName:U,name:H,arg:K};let V=null;const z=new m.$qe({onWillAddFirstListener:()=>{V=(0,I.$xh)(F=>this.u()),V.then(()=>{V=null,this.d.add(z),this.p(L)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(z),this.p({id:ie,type:h.EventDispose}))}}),E=F=>z.fire(F.data);return this.f.set(ie,E),z.event}p(U){switch(U.type){case h.Promise:case h.EventListen:{const H=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(H,U.id,A.LocalSide,`${g(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case h.PromiseCancel:case h.EventDispose:{const H=this.q([U.type,U.id]);this.j?.logOutgoing(H,U.id,A.LocalSide,g(U.type));return}}}q(U,H=void 0){const K=new a;return o(K,U),o(K,H),this.r(K.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const H=new i(U),K=l(H),ie=l(H),se=K[0];switch(se){case S.Initialize:return this.j?.logIncoming(U.byteLength,0,A.LocalSide,b(se)),this.t({type:K[0]});case S.PromiseSuccess:case S.PromiseError:case S.EventFire:case S.PromiseErrorObj:return this.j?.logIncoming(U.byteLength,K[1],A.LocalSide,b(se),ie),this.t({type:K[0],id:K[1],data:ie})}}t(U){if(U.type===S.Initialize){this.b=y.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$Uc)(this.d.values()),this.d.clear()}}e.$ni=T,Ee([C.$ci],T.prototype,"onDidInitializePromise",null);class N{get connections(){const U=[];return this.f.forEach(H=>U.push(H)),U}constructor(U,H,K){this.a=new Map,this.f=new Set,this.g=new m.$qe,this.onDidAddConnection=this.g.event,this.h=new m.$qe,this.onDidRemoveConnection=this.h.event,this.j=new u.$Yc,this.j.add(U(({protocol:ie,onDidClientDisconnect:se})=>{const L=m.Event.once(ie.onMessage);this.j.add(L(V=>{const z=new i(V),E=l(z),F=new p(ie,E,H,K),X=new T(ie,H);this.a.forEach((G,q)=>F.registerChannel(q,G));const J={channelServer:F,channelClient:X,ctx:E};this.f.add(J),this.g.fire(J),this.j.add(se(()=>{F.dispose(),X.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(U,H){const K=this;return{call(ie,se,L){let V;if((0,$.$xg)(H)){const E=(0,P.$7b)(K.connections.filter(H));V=E?Promise.resolve(E):m.Event.toPromise(m.Event.filter(K.onDidAddConnection,H))}else V=H.routeCall(K,ie,se);const z=V.then(E=>E.channelClient.getChannel(U));return j(z).call(ie,se,L)},listen(ie,se){if((0,$.$xg)(H))return K.k(U,H,ie,se);const L=H.routeEvent(K,ie,se).then(V=>V.channelClient.getChannel(U));return j(L).listen(ie,se)}}}k(U,H,K,ie){const se=this;let L;const V=new m.$qe({onWillAddFirstListener:()=>{L=new u.$Yc;const z=new m.$we,E=new Map,F=J=>{const q=J.channelClient.getChannel(U).listen(K,ie),Z=z.add(q);E.set(J,Z)},X=J=>{const G=E.get(J);G&&(G.dispose(),E.delete(J))};se.connections.filter(H).forEach(F),m.Event.filter(se.onDidAddConnection,H)(F,void 0,L),se.onDidRemoveConnection(X,void 0,L),z.event(V.fire,V,L),L.add(z)},onDidRemoveLastListener:()=>{L?.dispose(),L=void 0}});return V.event}registerChannel(U,H){this.a.set(U,H);for(const K of this.f)K.channelServer.registerChannel(U,H)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$oi=N;class D{constructor(U,H,K=null){const ie=new a;o(ie,H),U.send(ie.buffer),this.a=new T(U,K),this.d=new p(U,H,K)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,H){this.d.registerChannel(U,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$pi=D;function j(M){return{call(U,H,K){return M.then(ie=>ie.call(U,H,K))},listen(U,H){const K=new m.$ze;return M.then(ie=>K.input=ie.listen(U,H)),K.event}}}function x(M){let U=!1;return{call(H,K,ie){return U?M.call(H,K,ie):(0,I.$Lh)(0).then(()=>U=!0).then(()=>M.call(H,K,ie))},listen(H,K){if(U)return M.listen(H,K);const ie=new m.$ze;return(0,I.$Lh)(0).then(()=>U=!0).then(()=>ie.input=M.listen(H,K)),ie.event}}}class Y{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const H of U.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await m.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$si=Y;var ne;(function(M){function U(se,L,V){const z=se,E=V&&V.disableMarshalling,F=new Map;for(const X in z)K(X)&&F.set(X,m.Event.buffer(z[X],!0,void 0,L));return new class{listen(X,J,G){const q=F.get(J);if(q)return q;const Z=z[J];if(typeof Z=="function"){if(ie(J))return Z.call(z,G);if(K(J))return F.set(J,m.Event.buffer(z[J],!0,void 0,L)),F.get(J)}throw new R.$fb(`Event not found: ${J}`)}call(X,J,G){const q=z[J];if(typeof q=="function"){if(!E&&Array.isArray(G))for(let re=0;re<G.length;re++)G[re]=(0,d.$hi)(G[re]);let Z=q.apply(z,G);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new R.$fb(`Method not found: ${J}`)}}}M.fromService=U;function H(se,L){const V=L&&L.disableMarshalling;return new Proxy({},{get(z,E){if(typeof E=="string")return L?.properties?.has(E)?L.properties.get(E):ie(E)?function(F){return se.listen(E,F)}:K(E)?se.listen(E):async function(...F){let X;L&&!(0,$.$sg)(L.context)?X=[L.context,...F]:X=F;const J=await se.call(E,X);return V?J:(0,d.$hi)(J)};throw new R.$fb(`Property not found: ${String(E)}`)}})}M.toService=H;function K(se){return se[0]==="o"&&se[1]==="n"&&f.$Jf(se.charCodeAt(2))}function ie(se){return/^onDynamic/.test(se)&&f.$Jf(se.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const U=M.toString();if(U!=="[object Object]")return U}return M}function me(M){return Array.isArray(M)?M.map(ue):ue(M)}function W(M,U,H,K,ie,se,L){L=me(L);const V=ae[ie],z=V[K%V.length];let E=[`%c[${M}]%c[${String(U).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(se)?(E=E.concat(L),E.push(")")):E.push(L),console.log.apply(console,E)}class _{constructor(U,H){this.d=U,this.f=H,this.a=0,this.b=0}logOutgoing(U,H,K,ie,se){this.b+=U,W(this.d,this.b,U,H,K,ie,se)}logIncoming(U,H,K,ie,se){this.a+=U,W(this.f,this.a,U,H,K,ie,se)}}e.$ti=_}),define(le[90],he([0,1,61,8,13,21,86,7,5,2,27,59,57,60]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0,R=be(R);class g extends h.$mi{constructor(y){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",c=>v.$Se.wrap(Buffer.from(c,"base64")))},y),process.once("disconnect",()=>this.dispose())}}e.$pr=g;class S{constructor(y,c){this.i=y,this.j=c,this.c=new Set,this.g=new Map,this.h=new m.$qe,this.onDidProcessExit=this.h.event;const O=c&&c.timeout?c.timeout:6e4;this.b=new I.$Hh(O),this.d=null,this.f=null}getChannel(y){const c=this;return{call(O,w,i){return c.k(y,O,w,i)},listen(O,w){return c.l(y,O,w)}}}k(y,c,O,w=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(R.$0());this.b.cancel();const i=this.n(y),a=(0,I.$xh)(t=>i.call(c,O,t)),n=w.onCancellationRequested(()=>a.cancel()),r=(0,u.$Xc)(()=>a.cancel());return this.c.add(r),a.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),a}l(y,c,O){if(!this.b)return m.Event.None;this.b.cancel();let w;const i=new m.$qe({onWillAddFirstListener:()=>{w=this.n(y).listen(c,O)(i.fire,i),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const y=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,d.$ko)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,$.$rm)(c.env),this.d=(0,P.fork)(this.i,y,c);const O=new m.$qe,i=m.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,C.$lr)(o)){(0,C.log)(o,`IPC Library: ${this.j.serverName}`);return}O.fire(v.$Se.wrap(Buffer.from(o,"base64")))}),a=this.j.useQueue?(0,f.$Em)(this.d):this.d,n=o=>this.d&&this.d.connected&&a.send(o.buffer.toString("base64")),r=O.event,t={send:n,onMessage:r};this.f=new h.$ni(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",s),i.dispose(),this.c.forEach(p=>(0,u.$Uc)(p)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(y){let c=this.g.get(y);return c||(c=this.m.getChannel(y),this.g.set(y,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qr=S}),define(le[91],he([0,1,8,5,2,48,3]),function(Q,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.StorageState=e.StorageHint=void 0,e.$jq=m;var R;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function m($){const h=$;return h?.changed instanceof Map||h?.deleted instanceof Set}var u;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(u||(e.StorageState=u={}));class d extends v.$Zc{static{this.a=100}constructor(h,g=Object.create(null)){super(),this.r=h,this.s=g,this.b=this.B(new I.$te),this.onDidChangeStorage=this.b.event,this.c=u.None,this.f=new Map,this.g=this.B(new P.$Ih(d.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach((g,S)=>this.w(S,g)),h.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(h,g){if(this.c===u.Closed)return;let S=!1;(0,C.$sg)(g)?S=this.f.delete(h):this.f.get(h)!==g&&(this.f.set(h,g),S=!0),S&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===u.None&&(this.c=u.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,g){const S=this.f.get(h);return(0,C.$sg)(S)?g:S}getBoolean(h,g){const S=this.get(h);return(0,C.$sg)(S)?g:S==="true"}getNumber(h,g){const S=this.get(h);return(0,C.$sg)(S)?g:parseInt(S,10)}getObject(h,g){const S=this.get(h);return(0,C.$sg)(S)?g:(0,k.$gi)(S)}async set(h,g,S=!1){if(this.c===u.Closed)return;if((0,C.$sg)(g))return this.delete(h,S);const b=(0,C.$lg)(g)||Array.isArray(g)?(0,k.$fi)(g):String(g);if(this.f.get(h)!==b)return this.f.set(h,b),this.j.set(h,b),this.h.delete(h),this.b.fire({key:h,external:S}),this.D()}async delete(h,g=!1){if(!(this.c===u.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:g}),this.D()}async optimize(){if(this.c!==u.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=u.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(!(this.c===u.Closed||this.m))return this.D(h)}async D(h){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$kq=d;class f{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((g,S)=>this.a.set(S,g)),h.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$lq=f}),define(le[92],he([0,1,93,7,4]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var k;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(k||(e.TokenType=k={}));function C(...d){switch(d.length){case 1:return(0,v.localize)(1693,null,d[0]);case 2:return(0,v.localize)(1694,null,d[0],d[1]);case 3:return(0,v.localize)(1695,null,d[0],d[1],d[2]);default:return}}const R=(0,v.localize)(1696,null),m=(0,v.localize)(1697,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return f.isTripleEq?"===":"==";case k.NotEq:return f.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return f.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return f.lexeme;case k.QuotedStr:return f.lexeme;case k.Error:return f.lexeme;case k.EOF:return"EOF";default:throw(0,I.$_)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(f){return this.c=f,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(k.LParen);break;case P.CharCode.CloseParen:this.k(k.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const $=this.h(P.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:$})}else this.k(k.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const $=this.h(P.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:$})}else this.h(P.CharCode.Tilde)?this.k(k.RegexOp):this.l(C("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?k.LtEq:k.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?k.GtEq:k.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(k.And):this.l(C("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(k.Or):this.l(C("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(f){return this.r()||this.c.charCodeAt(this.e)!==f?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k(f){this.f.push({type:f,offset:this.d})}l(f){const $=this.d,h=this.c.substring(this.d,this.e),g={type:k.Error,offset:this.d,lexeme:h};this.g.push({offset:$,lexeme:h,additionalInfo:f}),this.f.push(g)}n(){this.m.lastIndex=this.d;const f=this.m.exec(this.c);if(f){this.e=this.d+f[0].length;const $=this.c.substring(this.d,this.e),h=u.b.get($);h?this.k(h):this.f.push({type:k.Str,lexeme:$,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let f=this.e,$=!1,h=!1;for(;;){if(f>=this.c.length){this.e=f,this.l(m);return}const S=this.c.charCodeAt(f);if($)$=!1;else if(S===P.CharCode.Slash&&!h){f++;break}else S===P.CharCode.OpenSquareBracket?h=!0:S===P.CharCode.Backslash?$=!0:S===P.CharCode.CloseSquareBracket&&(h=!1);f++}for(;f<this.c.length&&u.a.has(this.c.charCodeAt(f));)f++;this.e=f;const g=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=u}),define(le[94],he([0,1,84,55,14,15,36,16,12]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=void 0,e.$an=d,e.$bn=f,e.$$m=/^([^.]+\..+)[:=](.+)$/;class u{get appRoot(){return(0,k.$rc)(v.$5g.asFileUri("").fsPath)}get userHome(){return m.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return m.URI.file((0,k.$oc)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.b.tmpDir)}get cacheHome(){return m.URI.file(this.userDataPath)}get stateResource(){return(0,R.$lh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$lh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,P.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$oc)(this.userDataPath,"logs",h)}return m.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$lh)(m.URI.file((0,k.$oc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$lh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$lh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$lh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=C.env.VSCODE_PORTABLE;return h?m.URI.file((0,k.$oc)(h,"argv.json")):(0,R.$lh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,k.$oc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,k.$pc)(h):(0,k.$mc)((0,k.$oc)(v.$5g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?m.URI.file((0,k.$pc)(h)):m.URI.file((0,k.$oc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,k.$pc)(h);const g=C.env.VSCODE_EXTENSIONS;if(g)return g;const S=C.env.VSCODE_PORTABLE;return S?(0,k.$oc)(S,"extensions"):(0,R.$lh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?m.URI.parse(g):m.URI.file((0,k.$mc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?m.URI.parse(h):m.URI.file((0,k.$mc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$$m.test(h))}get extensionLogLevel(){const h=[];for(const g of this.args.log||[]){const S=e.$$m.exec(g);S&&S[1]&&S[2]&&h.push([S[1],S[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$lh)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=C.env.VSCODE_PORTABLE;return h?m.URI.file((0,k.$oc)(h,"policy.json")):(0,R.$lh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,g,S){this.a=h,this.b=g,this.c=S,this.editSessionId=this.args.editSessionId}}e.$_m=u,Ee([I.$ci],u.prototype,"appRoot",null),Ee([I.$ci],u.prototype,"userHome",null),Ee([I.$ci],u.prototype,"userDataPath",null),Ee([I.$ci],u.prototype,"appSettingsHome",null),Ee([I.$ci],u.prototype,"tmpDir",null),Ee([I.$ci],u.prototype,"cacheHome",null),Ee([I.$ci],u.prototype,"stateResource",null),Ee([I.$ci],u.prototype,"userRoamingDataHome",null),Ee([I.$ci],u.prototype,"userDataSyncHome",null),Ee([I.$ci],u.prototype,"sync",null),Ee([I.$ci],u.prototype,"machineSettingsResource",null),Ee([I.$ci],u.prototype,"workspaceStorageHome",null),Ee([I.$ci],u.prototype,"localHistoryHome",null),Ee([I.$ci],u.prototype,"keyboardLayoutResource",null),Ee([I.$ci],u.prototype,"argvResource",null),Ee([I.$ci],u.prototype,"isExtensionDevelopment",null),Ee([I.$ci],u.prototype,"untitledWorkspacesHome",null),Ee([I.$ci],u.prototype,"builtinExtensionsPath",null),Ee([I.$ci],u.prototype,"extensionsPath",null),Ee([I.$ci],u.prototype,"extensionDevelopmentLocationURI",null),Ee([I.$ci],u.prototype,"extensionDevelopmentKind",null),Ee([I.$ci],u.prototype,"extensionTestsLocationURI",null),Ee([I.$ci],u.prototype,"debugExtensionHost",null),Ee([I.$ci],u.prototype,"logLevel",null),Ee([I.$ci],u.prototype,"extensionLogLevel",null),Ee([I.$ci],u.prototype,"serviceMachineIdResource",null),Ee([I.$ci],u.prototype,"disableTelemetry",null),Ee([I.$ci],u.prototype,"disableWorkspaceTrust",null),Ee([I.$ci],u.prototype,"useInMemorySecretStorage",null),Ee([I.$ci],u.prototype,"policyFile",null);function d($,h){return f($["inspect-extensions"],$["inspect-brk-extensions"],5870,h,$.debugId,$.extensionEnvironment)}function f($,h,g,S,b,y){const O=Number(h||$)||(S?null:g),w=O?!!h:!1;let i;if(y)try{i=JSON.parse(y)}catch{}return{port:O,break:w,debugId:b,env:i}}}),function(){function Q(e,P,I){function v(C,R){const m=k(C,R),u=[m];return e.isAbsolute(m)||u.unshift(I),e.resolve(...u)}function k(C,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,R);const d=C["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(f,"AppData","Roaming")}break;case"darwin":u=e.join(P.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,R)}return{getUserDataPath:v}}if(typeof define=="function")define(le[95],he([149,35,36]),function(e,P,I){return Q(e,P,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=Q(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[96],he([0,1,35,94,95]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$dn=C,e.$en=R;class k extends I.$_m{constructor(u,d){super(u,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,v.getUserDataPath)(u,d.nameShort)},d)}}e.$cn=k;function C(m,u){return(0,I.$bn)(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,u,m.extensionEnvironment)}function R(m,u){return(0,I.$bn)(m["inspect-sharedprocess"],m["inspect-brk-sharedprocess"],5879,u,m.extensionEnvironment)}}),define(le[97],he([0,1,3,4]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=v;function v(C,R,m,u){try{k(C,R,m,u)}catch(d){C.error(d?.message??d)}return R}function k(C,R,m,u){const d=(f,$,h)=>{const g=f[$];if((0,P.$jg)(g)){const S=g,b=S.length;if(b>1&&S[0]==="%"&&S[b-1]==="%"){const y=S.substr(1,b-2);let c=m[y];c===void 0&&u&&(c=u[y]);const O=typeof c=="string"?c:c?.message,w=u?.[y],i=typeof w=="string"?w:w?.message;if(!O){i||C.warn(`[${R.name}]: ${(0,I.localize)(1814,null,y)}`);return}if(h&&($==="title"||$==="category")&&i&&i!==O){const a={value:O,original:i};f[$]=a}else f[$]=O}}else if((0,P.$lg)(g))for(const S in g)g.hasOwnProperty(S)&&(S==="commands"?d(g,S,!0):d(g,S,h));else if(Array.isArray(g))for(let S=0;S<g.length;S++)d(g,S,h)};for(const f in R)R.hasOwnProperty(f)&&d(R,f)}}),define(le[98],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const P={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:5},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(P)}),define(le[51],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class P{constructor(v,k=[],C=!1){this.ctor=v,this.staticArguments=k,this.supportsDelayedInstantiation=C}}e.$Hi=P}),define(le[99],he([0,1,51]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Zs=k,e.$1s=C;const I=[];var v;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(v||(e.InstantiationType=v={}));function k(R,m,u){m instanceof P.$Hi||(m=new P.$Hi(m,[],!!u)),I.push([R,m])}function C(){return I}}),define(le[100],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;class P{constructor(k,C){this.key=k,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$Cr=P;class I{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const C of this.a.values())C.outgoing.size===0&&k.push(C);return k}insertEdge(k,C){const R=this.lookupOrInsertNode(k),m=this.lookupOrInsertNode(C);R.outgoing.set(m.key,m),m.incoming.set(R.key,R)}removeNode(k){const C=this.b(k);this.a.delete(C);for(const R of this.a.values())R.outgoing.delete(C),R.incoming.delete(C)}lookupOrInsertNode(k){const C=this.b(k);let R=this.a.get(C);return R||(R=new P(C,k),this.a.set(C,R)),R}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[C,R]of this.a)k.push(`${C}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,C]of this.a){const R=new Set([k]),m=this.c(C,R);if(m)return m}}c(k,C){for(const[R,m]of k.outgoing){if(C.has(R))return[...C,R].join(" -> ");C.add(R);const u=this.c(m,C);if(u)return u;C.delete(R)}}}e.$Dr=I}),define(le[30],he([0,1,3,12,10]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=k,e.$gj=C,e.$hj=m,e.$ij=u,e.$jj=d,e.$kj=f,e.$lj=$,e.$mj=g,e.$nj=S,e.$oj=b,P=be(P),e.$ej=(0,v.$Ki)("configurationService");function k(y){return y&&typeof y=="object"&&(!y.overrideIdentifier||typeof y.overrideIdentifier=="string")&&(!y.resource||y.resource instanceof I.URI)}function C(y){return y&&typeof y=="object"&&(!y.overrideIdentifiers||Array.isArray(y.overrideIdentifiers))&&!y.overrideIdentifier&&(!y.resource||y.resource instanceof I.URI)}var R;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.USER=2]="USER",y[y.USER_LOCAL=3]="USER_LOCAL",y[y.USER_REMOTE=4]="USER_REMOTE",y[y.WORKSPACE=5]="WORKSPACE",y[y.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",y[y.DEFAULT=7]="DEFAULT",y[y.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function m(y){switch(y){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function u(y){return y.applicationValue!==void 0||y.userValue!==void 0||y.userLocalValue!==void 0||y.userRemoteValue!==void 0||y.workspaceValue!==void 0||y.workspaceFolderValue!==void 0}function d(y,c){const O=Object.create(null);for(const w in y)f(O,w,y[w],c);return O}function f(y,c,O,w){const i=c.split("."),a=i.pop();let n=y;for(let r=0;r<i.length;r++){const t=i[r];let s=n[t];switch(typeof s){case"undefined":s=n[t]=Object.create(null);break;case"object":if(s===null){w(`Ignoring ${c} as ${i.slice(0,r+1).join(".")} is null`);return}break;default:w(`Ignoring ${c} as ${i.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[a]=O}catch{w(`Ignoring ${c} as ${i.join(".")} is ${JSON.stringify(n)}`)}else w(`Ignoring ${c} as ${i.join(".")} is ${JSON.stringify(n)}`)}function $(y,c){const O=c.split(".");h(y,O)}function h(y,c){const O=c.shift();if(c.length===0){delete y[O];return}if(Object.keys(y).indexOf(O)!==-1){const w=y[O];typeof w=="object"&&!Array.isArray(w)&&(h(w,c),Object.keys(w).length===0&&delete y[O])}}function g(y,c,O){function w(n,r){let t=n;for(const s of r){if(typeof t!="object"||t===null)return;t=t[s]}return t}const i=c.split("."),a=w(y,i);return typeof a>"u"?O:a}function S(y,c,O){Object.keys(c).forEach(w=>{w!=="__proto__"&&(w in y?P.$lg(y[w])&&P.$lg(c[w])?S(y[w],c[w],O):O&&(y[w]=c[w]):y[w]=c[w])})}function b(y){return y.replace(/[\[\]]/g,"")}}),define(le[101],he([0,1,93,11,31,92,10,4,7]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=d,e.$Jj=r,e.$Kj=t,e.$4j=se;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",I.$m),u.set("isLinux",I.$n),u.set("isWindows",I.$l),u.set("isWeb",I.$r),u.set("isMacNative",I.$m&&!I.$r),u.set("isEdge",I.$K),u.set("isFirefox",I.$I),u.set("isChrome",I.$H),u.set("isSafari",I.$J);function d(z,E){if(u.get(z)!==void 0)throw(0,m.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,E)}const f=Object.prototype.hasOwnProperty;var $;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})($||(e.ContextKeyExprType=$={}));const h={regexParsingWithErrorRecovery:!0},g=(0,R.localize)(1673,null),S=(0,R.localize)(1674,null),b=(0,R.localize)(1675,null),y=(0,R.localize)(1676,null),c=(0,R.localize)(1677,null),O=(0,R.localize)(1678,null),w=(0,R.localize)(1679,null),i=(0,R.localize)(1680,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(E=h){this.k=E,this.d=new k.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(E){if(E===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(E).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const X=this.D(),J=X.type===k.TokenType.Str?O:void 0;throw this.h.push({message:c,offset:X.offset,lexeme:k.$Fj.getLexeme(X),additionalInfo:J}),a.c}return F}catch(F){if(F!==a.c)throw F;return}}l(){return this.m()}m(){const E=[this.o()];for(;this.y(k.TokenType.Or);){const F=this.o();E.push(F)}return E.length===1?E[0]:n.or(...E)}o(){const E=[this.s()];for(;this.y(k.TokenType.And);){const F=this.s();E.push(F)}return E.length===1?E[0]:n.and(...E)}s(){if(this.y(k.TokenType.Neg)){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),o.INSTANCE;case k.TokenType.False:return this.z(),l.INSTANCE;case k.TokenType.LParen:{this.z();const F=this.l();return this.A(k.TokenType.RParen,y),F?.negate()}case k.TokenType.Str:return this.z(),j.create(E.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",E)}}return this.t()}t(){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),n.true();case k.TokenType.False:return this.z(),n.false();case k.TokenType.LParen:{this.z();const F=this.l();return this.A(k.TokenType.RParen,y),F}case k.TokenType.Str:{const F=E.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const J=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),J.type!==k.TokenType.RegexStr)throw this.B("REGEX",J);const G=J.lexeme,q=G.lastIndexOf("/"),Z=q===G.length-1?void 0:this.w(G.substring(q+1));let re;try{re=new RegExp(G.substring(1,q),Z)}catch{throw this.B("REGEX",J)}return me.create(F,re)}switch(J.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const G=[J.lexeme];this.z();let q=this.D(),Z=0;for(let de=0;de<J.lexeme.length;de++)J.lexeme.charCodeAt(de)===P.CharCode.OpenParen?Z++:J.lexeme.charCodeAt(de)===P.CharCode.CloseParen&&Z--;for(;!this.E()&&q.type!==k.TokenType.And&&q.type!==k.TokenType.Or;){switch(q.type){case k.TokenType.LParen:Z++;break;case k.TokenType.RParen:Z--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let de=0;de<q.lexeme.length;de++)q.lexeme.charCodeAt(de)===P.CharCode.OpenParen?Z++:J.lexeme.charCodeAt(de)===P.CharCode.CloseParen&&Z--}if(Z<0)break;G.push(k.$Fj.getLexeme(q)),this.z(),q=this.D()}const re=G.join(""),ce=re.lastIndexOf("/"),fe=ce===re.length-1?void 0:this.w(re.substring(ce+1));let we;try{we=new RegExp(re.substring(1,ce),fe)}catch{throw this.B("REGEX",J)}return n.regex(F,we)}case k.TokenType.QuotedStr:{const G=J.lexeme;this.z();let q=null;if(!(0,v.$hf)(G)){const Z=G.indexOf("/"),re=G.lastIndexOf("/");if(Z!==re&&Z>=0){const ce=G.slice(Z+1,re),fe=G[re+1]==="i"?"i":"";try{q=new RegExp(ce,fe)}catch{throw this.B("REGEX",J)}}}if(q===null)throw this.B("REGEX",J);return me.create(F,q)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,b);const J=this.u();return n.notIn(F,J)}switch(this.D().type){case k.TokenType.Eq:{this.z();const J=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.equals(F,J);switch(J){case"true":return n.has(F);case"false":return n.not(F);default:return n.equals(F,J)}}case k.TokenType.NotEq:{this.z();const J=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.notEquals(F,J);switch(J){case"true":return n.not(F);case"false":return n.has(F);default:return n.notEquals(F,J)}}case k.TokenType.Lt:return this.z(),ae.create(F,this.u());case k.TokenType.LtEq:return this.z(),ue.create(F,this.u());case k.TokenType.Gt:return this.z(),Y.create(F,this.u());case k.TokenType.GtEq:return this.z(),ne.create(F,this.u());case k.TokenType.In:return this.z(),n.in(F,this.u());default:return n.has(F)}}case k.TokenType.EOF:throw this.h.push({message:w,offset:E.offset,lexeme:"",additionalInfo:i}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const E=this.D();switch(E.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),E.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(E){return E.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(E){return this.C(E)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(E,F){if(this.C(E))return this.z();throw this.B(F,this.D())}B(E,F,X){const J=(0,R.localize)(1681,null,E,k.$Fj.getLexeme(F)),G=F.offset,q=k.$Fj.getLexeme(F);return this.h.push({message:J,offset:G,lexeme:q,additionalInfo:X}),a.c}C(E){return this.D().type===E}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Hj=a;class n{static false(){return o.INSTANCE}static true(){return l.INSTANCE}static has(E){return p.create(E)}static equals(E,F){return A.create(E,F)}static notEquals(E,F){return D.create(E,F)}static regex(E,F){return me.create(E,F)}static in(E,F){return T.create(E,F)}static notIn(E,F){return N.create(E,F)}static not(E){return j.create(E)}static and(...E){return M.create(E,null,!0)}static or(...E){return U.create(E,null,!0)}static greater(E,F){return Y.create(E,F)}static greaterEquals(E,F){return ne.create(E,F)}static smaller(E,F){return ae.create(E,F)}static smallerEquals(E,F){return ue.create(E,F)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(E){return E==null?void 0:this.c.parse(E)}}e.$Ij=n;function r(z){const E=new a({regexParsingWithErrorRecovery:!1});return z.map(F=>(E.parse(F),E.lexingErrors.length>0?E.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,R.localize)(1682,null,X.additionalInfo):(0,R.localize)(1683,null),offset:X.offset,length:X.lexeme.length})):E.parsingErrors.length>0?E.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}function t(z,E){const F=z?z.substituteConstants():void 0,X=E?E.substituteConstants():void 0;return!F&&!X?!0:!F||!X?!1:F.equals(X)}function s(z,E){return z.cmp(E)}class o{static{this.INSTANCE=new o}constructor(){this.type=$.False}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return l.INSTANCE}}e.$Lj=o;class l{static{this.INSTANCE=new l}constructor(){this.type=$.True}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return o.INSTANCE}}e.$Mj=l;class p{static create(E,F=null){const X=u.get(E);return typeof X=="boolean"?X?l.INSTANCE:o.INSTANCE:new p(E,F)}constructor(E,F){this.key=E,this.c=F,this.type=$.Defined}cmp(E){return E.type!==this.type?this.type-E.type:K(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=u.get(this.key);return typeof E=="boolean"?E?l.INSTANCE:o.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Nj=p;class A{static create(E,F,X=null){if(typeof F=="boolean")return F?p.create(E,X):j.create(E,X);const J=u.get(E);return typeof J=="boolean"?F===(J?"true":"false")?l.INSTANCE:o.INSTANCE:new A(E,F,X)}constructor(E,F,X){this.c=E,this.d=F,this.f=X,this.type=$.Equals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=u.get(this.c);if(typeof E=="boolean"){const F=E?"true":"false";return this.d===F?l.INSTANCE:o.INSTANCE}return this}evaluate(E){return E.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(E){return E.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Oj=A;class T{static create(E,F){return new T(E,F)}constructor(E,F){this.d=E,this.f=F,this.type=$.In,this.c=null}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.d,this.f,E.d,E.f)}equals(E){return E.type===this.type?this.d===E.d&&this.f===E.f:!1}substituteConstants(){return this}evaluate(E){const F=E.getValue(this.f),X=E.getValue(this.d);return Array.isArray(F)?F.includes(X):typeof X=="string"&&typeof F=="object"&&F!==null?f.call(F,X):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(E){return E.mapIn(this.d,this.f)}negate(){return this.c||(this.c=N.create(this.d,this.f)),this.c}}e.$Pj=T;class N{static create(E,F){return new N(E,F)}constructor(E,F){this.d=E,this.f=F,this.type=$.NotIn,this.c=T.create(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(E){return E.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=N;class D{static create(E,F,X=null){if(typeof F=="boolean")return F?j.create(E,X):p.create(E,X);const J=u.get(E);return typeof J=="boolean"?F===(J?"true":"false")?o.INSTANCE:l.INSTANCE:new D(E,F,X)}constructor(E,F,X){this.c=E,this.d=F,this.f=X,this.type=$.NotEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=u.get(this.c);if(typeof E=="boolean"){const F=E?"true":"false";return this.d===F?o.INSTANCE:l.INSTANCE}return this}evaluate(E){return E.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(E){return E.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Rj=D;class j{static create(E,F=null){const X=u.get(E);return typeof X=="boolean"?X?o.INSTANCE:l.INSTANCE:new j(E,F)}constructor(E,F){this.c=E,this.d=F,this.type=$.Not}cmp(E){return E.type!==this.type?this.type-E.type:K(this.c,E.c)}equals(E){return E.type===this.type?this.c===E.c:!1}substituteConstants(){const E=u.get(this.c);return typeof E=="boolean"?E?o.INSTANCE:l.INSTANCE:this}evaluate(E){return!E.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(E){return E.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Sj=j;function x(z,E){if(typeof z=="string"){const F=parseFloat(z);isNaN(F)||(z=F)}return typeof z=="string"||typeof z=="number"?E(z):o.INSTANCE}class Y{static create(E,F,X=null){return x(F,J=>new Y(E,J,X))}constructor(E,F,X){this.c=E,this.d=F,this.f=X,this.type=$.Greater}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Tj=Y;class ne{static create(E,F,X=null){return x(F,J=>new ne(E,J,X))}constructor(E,F,X){this.c=E,this.d=F,this.f=X,this.type=$.GreaterEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Uj=ne;class ae{static create(E,F,X=null){return x(F,J=>new ae(E,J,X))}constructor(E,F,X){this.c=E,this.d=F,this.f=X,this.type=$.Smaller}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Vj=ae;class ue{static create(E,F,X=null){return x(F,J=>new ue(E,J,X))}constructor(E,F,X){this.c=E,this.d=F,this.f=X,this.type=$.SmallerEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Wj=ue;class me{static create(E,F){return new me(E,F)}constructor(E,F){this.d=E,this.f=F,this.type=$.Regex,this.c=null}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.d<E.d)return-1;if(this.d>E.d)return 1;const F=this.f?this.f.source:"",X=E.f?E.f.source:"";return F<X?-1:F>X?1:0}equals(E){if(E.type===this.type){const F=this.f?this.f.source:"",X=E.f?E.f.source:"";return this.d===E.d&&F===X}return!1}substituteConstants(){return this}evaluate(E){const F=E.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const E=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${E}`}keys(){return[this.d]}map(E){return E.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$Xj=me;class W{static create(E){return new W(E)}constructor(E){this.c=E,this.type=$.NotRegex}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(E){return new W(this.c.map(E))}negate(){return this.c}}e.$Yj=W;function _(z){let E=null;for(let F=0,X=z.length;F<X;F++){const J=z[F].substituteConstants();if(z[F]!==J&&E===null){E=[];for(let G=0;G<F;G++)E[G]=z[G]}E!==null&&(E[F]=J)}return E===null?z:E}class M{static create(E,F,X){return M.d(E,F,X)}constructor(E,F){this.expr=E,this.c=F,this.type=$.And}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,X=this.expr.length;F<X;F++){const J=s(this.expr[F],E.expr[F]);if(J!==0)return J}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,X=this.expr.length;F<X;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}substituteConstants(){const E=_(this.expr);return E===this.expr?this:M.create(E,this.c,!1)}evaluate(E){for(let F=0,X=this.expr.length;F<X;F++)if(!this.expr[F].evaluate(E))return!1;return!0}static d(E,F,X){const J=[];let G=!1;for(const q of E)if(q){if(q.type===$.True){G=!0;continue}if(q.type===$.False)return o.INSTANCE;if(q.type===$.And){J.push(...q.expr);continue}J.push(q)}if(J.length===0&&G)return l.INSTANCE;if(J.length!==0){if(J.length===1)return J[0];J.sort(s);for(let q=1;q<J.length;q++)J[q-1].equals(J[q])&&(J.splice(q,1),q--);if(J.length===1)return J[0];for(;J.length>1;){const q=J[J.length-1];if(q.type!==$.Or)break;J.pop();const Z=J.pop(),re=J.length===0,ce=U.create(q.expr.map(fe=>M.create([fe,Z],null,X)),null,re);ce&&(J.push(ce),J.sort(s))}if(J.length===1)return J[0];if(X){for(let q=0;q<J.length;q++)for(let Z=q+1;Z<J.length;Z++)if(J[q].negate().equals(J[Z]))return o.INSTANCE;if(J.length===1)return J[0]}return new M(J,F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(const F of this.expr)E.push(...F.keys());return E}map(E){return new M(this.expr.map(F=>F.map(E)),null)}negate(){if(!this.c){const E=[];for(const F of this.expr)E.push(F.negate());this.c=U.create(E,this,!0)}return this.c}}e.$Zj=M;class U{static create(E,F,X){return U.d(E,F,X)}constructor(E,F){this.expr=E,this.c=F,this.type=$.Or}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,X=this.expr.length;F<X;F++){const J=s(this.expr[F],E.expr[F]);if(J!==0)return J}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,X=this.expr.length;F<X;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}substituteConstants(){const E=_(this.expr);return E===this.expr?this:U.create(E,this.c,!1)}evaluate(E){for(let F=0,X=this.expr.length;F<X;F++)if(this.expr[F].evaluate(E))return!0;return!1}static d(E,F,X){let J=[],G=!1;if(E){for(let q=0,Z=E.length;q<Z;q++){const re=E[q];if(re){if(re.type===$.False){G=!0;continue}if(re.type===$.True)return l.INSTANCE;if(re.type===$.Or){J=J.concat(re.expr);continue}J.push(re)}}if(J.length===0&&G)return o.INSTANCE;J.sort(s)}if(J.length!==0){if(J.length===1)return J[0];for(let q=1;q<J.length;q++)J[q-1].equals(J[q])&&(J.splice(q,1),q--);if(J.length===1)return J[0];if(X){for(let q=0;q<J.length;q++)for(let Z=q+1;Z<J.length;Z++)if(J[q].negate().equals(J[Z]))return l.INSTANCE;if(J.length===1)return J[0]}return new U(J,F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(const F of this.expr)E.push(...F.keys());return E}map(E){return new U(this.expr.map(F=>F.map(E)),null)}negate(){if(!this.c){const E=[];for(const F of this.expr)E.push(F.negate());for(;E.length>1;){const F=E.shift(),X=E.shift(),J=[];for(const G of V(F))for(const q of V(X))J.push(M.create([G,q],null,!1));E.unshift(U.create(J,null,!1))}this.c=U.create(E,this,!0)}return this.c}}e.$1j=U;class H extends p{static{this.d=[]}static all(){return H.d.values()}constructor(E,F,X){super(E,null),this.f=F,typeof X=="object"?H.d.push({...X,key:E}):X!==!0&&H.d.push({key:E,description:X,type:F!=null?typeof F:void 0})}bindTo(E){return E.createKey(this.key,this.f)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return A.create(this.key,E)}notEqualsTo(E){return D.create(this.key,E)}}e.$2j=H,e.$3j=(0,C.$Ki)("contextKeyService");function K(z,E){return z<E?-1:z>E?1:0}function ie(z,E,F,X){return z<F?-1:z>F?1:E<X?-1:E>X?1:0}function se(z,E){if(z.type===$.False||E.type===$.True)return!0;if(z.type===$.Or)return E.type===$.Or?L(z.expr,E.expr):!1;if(E.type===$.Or){for(const F of E.expr)if(se(z,F))return!0;return!1}if(z.type===$.And){if(E.type===$.And)return L(E.expr,z.expr);for(const F of z.expr)if(se(F,E))return!0;return!1}return z.equals(E)}function L(z,E){let F=0,X=0;for(;F<z.length&&X<E.length;){const J=z[F].cmp(E[X]);if(J<0)return!1;J===0&&F++,X++}return F===z.length}function V(z){return z.type===$.Or?z.expr:[z]}}),define(le[62],he([0,1,10]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=void 0,e.$8o=(0,P.$Ki)("downloadService")}),define(le[17],he([0,1,10]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,P.$Ki)("environmentService"),e.$Si=(0,P.$Li)(e.$Ri)}),define(le[63],he([0,1,13,7,4,9]),function(Q,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=C;async function C(d,f,$,h,g,S){let b;try{await R(d,f,$,h,g,S)}catch(y){b=y}finally{b&&g.errorTransformer&&(b=g.errorTransformer(b)),typeof b<"u"&&$.error(b),$.end()}}async function R(d,f,$,h,g,S){m(S);const b=await d.open(f,{create:!1});try{m(S);let y=0,c=0,O=g&&typeof g.length=="number"?g.length:void 0,w=P.$Se.alloc(Math.min(g.bufferSize,typeof O=="number"?O:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,a=0;do c=await d.read(b,i,w.buffer,a,w.byteLength-a),i+=c,a+=c,y+=c,typeof O=="number"&&(O-=c),a===w.byteLength&&(await $.write(h(w)),w=P.$Se.alloc(Math.min(g.bufferSize,typeof O=="number"?O:g.bufferSize)),a=0);while(c>0&&(typeof O!="number"||O>0)&&m(S)&&u(y,g));if(a>0){let n=a;typeof O=="number"&&(n=Math.min(a,O)),$.write(h(w.slice(0,n)))}}catch(y){throw(0,k.$tl)(y)}finally{await d.close(b)}}function m(d){if(d.isCancellationRequested)throw(0,I.$0)();return!0}function u(d,f){if(typeof f?.limits?.size=="number"&&d>f.limits.size)throw(0,k.$sl)((0,v.localize)(1898,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[102],he([0,1,32,2,52,5,9,12,8]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class u extends I.$Zc{constructor(){super(),this.a=this.B(new k.$qe),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$qe),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$qe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new I.$9c),this.m=new Set,this.n=this.B(new m.$Ih(this.y())),this.r=5007,this.s=new m.$8h,this.R=!1,this.B(this.f(f=>this.t(f)))}t(f){this.u(f)&&this.z(f)}u(f){return(0,v.$_q)(f)}async watch(f){this.s.isSettled||this.s.complete(),this.s=new m.$8h;try{this.h.clear(),this.g.clear();for(const $ of f)this.u($)?this.h.set($.correlationId,$):this.g.add($);for(const[$]of this.j)this.h.has($)||(this.j.deleteAndDispose($),this.m.delete($));return await this.w(!1)}finally{this.s.complete()}}w(f){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter($=>!this.j.has($.correlationId))]),f?this.y():0)}y(){return 800}isSuspended(f){return typeof f.correlationId!="number"?!1:this.m.has(f.correlationId)?"polling":this.j.has(f.correlationId)}async z(f){if(this.j.has(f.correlationId))return;const $=new I.$Yc;this.j.set(f.correlationId,$),await this.s.p,!$.isDisposed&&(this.D(f,$),this.w(!0))}C(f){this.j.deleteAndDispose(f.correlationId),this.m.delete(f.correlationId),this.w(!1)}D(f,$){this.F(f,$)?(this.P(`reusing an existing recursive watcher to monitor ${f.path}`),this.m.delete(f.correlationId)):(this.G(f,$),this.m.add(f.correlationId))}F(f,$){const h=this.O?.subscribe(f.path,(g,S)=>{$.isDisposed||(g?this.D(f,$):S?.type===C.FileChangeType.ADDED&&this.H(f))});return h?($.add(h),!0):!1}G(f,$){let h=!1;const g=(S,b)=>{if($.isDisposed)return;const y=this.I(S),c=this.I(b),O=h;h=y,!y&&(c||O)&&this.H(f)};this.P(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,P.watchFile)(f.path,{persistent:!1,interval:this.r},g)}catch(S){this.Q(`fs.watchFile() failed with error ${S} on path ${f.path} (correlationId: ${f.correlationId})`)}$.add((0,I.$Xc)(()=>{this.P(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,P.unwatchFile)(f.path,g)}catch(S){this.Q(`fs.unwatchFile() failed with error ${S} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}H(f){this.P(`detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const $={resource:R.URI.file(f.path),type:C.FileChangeType.ADDED,cId:f.correlationId};this.a.fire([$]),this.J($,f),this.C(f)}I(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(f,$){if(this.R){const h=` >> normalized ${f.type===C.FileChangeType.ADDED?"[ADDED]":f.type===C.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.L(h,$)}}L(f,$){this.R&&this.P(`${f}${typeof $.correlationId=="number"?` <${$.correlationId}> `:""}`)}M(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, filter: ${(0,v.$jr)(f.filter)}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}async setVerboseLogging(f){this.R=f}}e.$sr=u}),define(le[103],he([0,1,5,150,102,11,151,64]),function(Q,e,P,I,v,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class m extends v.$sr{constructor(d){super(),this.O=d,this.onDidError=P.Event.None,this.watchers=new Set}async N(d){d=this.Z(d);const f=[],$=new Set(Array.from(this.watchers));for(const h of d){const g=this.W(h);g&&(0,I.$Jk)(g.request.excludes,h.excludes)&&(0,I.$Jk)(g.request.includes,h.includes)?$.delete(g):f.push(h)}f.length&&this.P(`Request to start watching: ${f.map(h=>this.M(h)).join(",")}`),$.size&&this.P(`Request to stop watching: ${Array.from($).map(h=>this.M(h.request)).join(",")}`);for(const h of $)this.Y(h);for(const h of f)this.X(h)}W(d){for(const f of this.watchers)if(typeof d.correlationId=="number"||typeof f.request.correlationId=="number"){if(f.request.correlationId===d.correlationId)return f}else if((0,R.$Ig)(f.request.path,d.path,!k.$n))return f}X(d){const f=new C.$xr(d,this.O,h=>this.a.fire(h),()=>this.c.fire(d),h=>this.b.fire(h),this.R),$={request:d,instance:f};this.watchers.add($)}async stop(){await super.stop();for(const d of this.watchers)this.Y(d)}Y(d){this.P("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}Z(d){const f=new Map;for(const $ of d){const h=k.$n?$.path:$.path.toLowerCase();let g=f.get($.correlationId);g||(g=new Map,f.set($.correlationId,g)),g.has(h)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M($)}`),g.set(h,$)}return Array.from(f.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(d){super.setVerboseLogging(d);for(const f of this.watchers)f.instance.setVerboseLogging(d)}P(d,f){this.R&&this.b.fire({type:"trace",message:this.bb(d,f)})}Q(d){this.b.fire({type:"warn",message:this.bb(d)})}bb(d,f){return f?`[File Watcher (node.js)] ${d} (${this.M(f.request)})`:`[File Watcher (node.js)] ${d}`}}e.$zr=m}),define(le[104],he([0,1,52,103]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class v extends P.$cr{constructor(C,R,m){super(C,R,m),this.s()}r(C){return C.add(new I.$zr(void 0))}}e.$Ar=v}),define(le[105],he([0,1,14,60,90,52]),function(Q,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class C extends k.$dr{constructor(m,u,d){super(m,u,d),this.s()}r(m){const u=m.add(new v.$qr(P.$5g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(u.onDidProcessExit(({code:d,signal:f})=>this.t(`terminated by itself with code ${d}, signal: ${f} (ETERM)`))),I.ProxyChannel.toService((0,I.$ri)(u.getChannel("watcher")))}}e.$rr=C}),define(le[65],he([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class P{constructor(...v){this.a=new Map;for(const[k,C]of v)this.set(k,C)}set(v,k){const C=this.a.get(v);return this.a.set(v,k),C}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}e.$Ii=P}),define(le[106],he([0,1,8,7,2,51,100,10,65,152]),function(Q,e,P,I,v,k,C,R,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;const d=!1;class f extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class ${constructor(b=new m.$Ii,y=!1,c,O=d){this.i=b,this.j=y,this.k=c,this.l=O,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$Ji,this),this._globalGraph=O?c?._globalGraph??new C.$Dr(w=>w):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Uc)(this.h),this.h.clear();for(const b of this.g)(0,v.$Tc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,y){this.m();const c=this,O=new class extends ${dispose(){c.h.delete(O),super.dispose()}}(b,this.j,this,this.l);return this.h.add(O),y?.add(O),O}invokeFunction(b,...y){this.m();const c=g.traceInvocation(this.l,b);let O=!1;try{return b({get:i=>{if(O)throw(0,I.$_)("service accessor is only valid during the invocation of its target method");const a=this.s(i,c);if(!a)throw new Error(`[invokeFunction] unknown service '${i}'`);return a}},...y)}finally{O=!0,c.stop()}}createInstance(b,...y){this.m();let c,O;return b instanceof k.$Hi?(c=g.traceCreation(this.l,b.ctor),O=this.o(b.ctor,b.staticArguments.concat(y),c)):(c=g.traceCreation(this.l,b),O=this.o(b,y,c)),c.stop(),O}o(b,y=[],c){const O=R._util.getServiceDependencies(b).sort((a,n)=>a.index-n.index),w=[];for(const a of O){const n=this.s(a.id,c);n||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${a.id}.`,!1),w.push(n)}const i=O.length>0?O[0].index:y.length;if(y.length!==i){console.trace(`[createInstance] First service dependency of ${b.name} at position ${i+1} conflicts with ${y.length} static arguments`);const a=i-y.length;a>0?y=y.concat(new Array(a)):y=y.slice(0,i)}return Reflect.construct(b,y.concat(w))}q(b,y){if(this.i.get(b)instanceof k.$Hi)this.i.set(b,y);else if(this.k)this.k.q(b,y);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const y=this.i.get(b);return!y&&this.k?this.k.r(b):y}s(b,y){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const c=this.r(b);return c instanceof k.$Hi?this.u(b,c,y.branch(b,!0)):(y.branch(b,!1),c)}u(b,y,c){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,y,c)}finally{this.t.delete(b)}}v(b,y,c){const O=new C.$Dr(n=>n.id.toString());let w=0;const i=[{id:b,desc:y,_trace:c}],a=new Set;for(;i.length;){const n=i.pop();if(!a.has(String(n.id))){if(a.add(String(n.id)),O.lookupOrInsertNode(n),w++>1e3)throw new f(O);for(const r of R._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof k.$Hi){const s={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};O.insertEdge(n,s),i.push(s)}}}}for(;;){const n=O.roots();if(n.length===0){if(!O.isEmpty())throw new f(O);break}for(const{data:r}of n){if(this.r(r.id)instanceof k.$Hi){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}O.removeNode(r)}}return this.r(b)}w(b,y,c=[],O,w){if(this.i.get(b)instanceof k.$Hi)return this.x(b,y,c,O,w,this.g);if(this.k)return this.k.w(b,y,c,O,w);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}x(b,y,c=[],O,w,i){if(O){const a=new $(void 0,this.j,this,this.l);a.c=String(b);const n=new Map,r=new P.$4h(()=>{const t=a.o(y,c,w);for(const[s,o]of n){const l=t[s];if(typeof l=="function")for(const p of o)p.disposable=l.apply(t,p.listener)}return n.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let p=n.get(s);return p||(p=new u.$0c,n.set(s,p)),(T,N,D)=>{if(r.isInitialized)return r.value[s](T,N,D);{const j={listener:[T,N,D],disposable:void 0},x=p.push(j);return(0,v.$Xc)(()=>{x(),j.disposable?.dispose()})}}}if(s in t)return t[s];const o=r.value;let l=o[s];return typeof l!="function"||(l=l.bind(o),t[s]=l),l},set(t,s,o){return r.value[s]=o,!0},getPrototypeOf(t){return y.prototype}})}else{const a=this.o(y,c,w);return i.add(a),a}}y(b,y){if(y&&console.warn(b),this.j)throw new Error(b)}}e.$Er=$;var h;(function(S){S[S.None=0]="None",S[S.Creation=1]="Creation",S[S.Invocation=2]="Invocation",S[S.Branch=3]="Branch"})(h||(h={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(h.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,y){return b?new g(h.Invocation,y.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(b,y){return b?new g(h.Creation,y.name):g.c}static{this.f=0}constructor(b,y){this.type=b,this.name=y,this.g=Date.now(),this.h=[]}branch(b,y){const c=new g(h.Branch,b.toString());return this.h.push([b,y,c]),c}stop(){const b=Date.now()-this.g;g.f+=b;let y=!1;function c(w,i){const a=[],n=new Array(w+1).join("	");for(const[r,t,s]of i.h)if(t&&s){y=!0,a.push(`${n}CREATES -> ${r}`);const o=c(w+1,s);o&&a.push(o)}else a.push(`${n}uses -> ${r}`);return a.join(`
`)}const O=[`${this.type===h.Creation?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(b>2||y)&&g.all.add(O.join(`
`))}}e.$Fr=g}),define(le[6],he([0,1,4,38,5,43,2,25,11,16,3,12,101,10]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=S,e.log=y,e.$tk=l,e.$uk=p,e.$vk=A,e.$wk=T,P=be(P),e.$fk=(0,h.$Ki)("logService"),e.$gk=(0,h.$Ki)("loggerService");function g(){return new Date().toISOString()}function S(N){return(0,d.$ng)(N)}var b;(function(N){N[N.Off=0]="Off",N[N.Trace=1]="Trace",N[N.Debug=2]="Debug",N[N.Info=3]="Info",N[N.Warning=4]="Warning",N[N.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$ik=b.Info;function y(N,D,j){switch(D){case b.Trace:N.trace(j);break;case b.Debug:N.debug(j);break;case b.Info:N.info(j);break;case b.Warning:N.warn(j);break;case b.Error:N.error(j);break;case b.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function c(N,D=!1){let j="";for(let x=0;x<N.length;x++){let Y=N[x];if(Y instanceof Error&&(Y=(0,I.$vj)(Y,D)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}j+=(x>0?" ":"")+Y}return j}class O extends C.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new v.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==b.Off&&this.b<=D}}e.$kk=O;class w extends O{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...j){this.f(b.Trace)&&this.g(b.Trace,c([D,...j],!0))}debug(D,...j){this.f(b.Debug)&&this.g(b.Debug,c([D,...j]))}info(D,...j){this.f(b.Info)&&this.g(b.Info,c([D,...j]))}warn(D,...j){this.f(b.Warning)&&this.g(b.Warning,c([D,...j]))}error(D,...j){if(this.f(b.Error))if(D instanceof Error){const x=Array.prototype.slice.call(arguments);x[0]=D.stack,this.g(b.Error,c(x))}else this.g(b.Error,c([D,...j]))}flush(){}}e.$lk=w;class i extends O{constructor(D=e.$ik){super(),this.setLevel(D),this.g=!m.$l}trace(D,...j){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,D,...j):console.log(`[main ${g()}]`,D,...j))}debug(D,...j){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,D,...j):console.log(`[main ${g()}]`,D,...j))}info(D,...j){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,D,...j):console.log(`[main ${g()}]`,D,...j))}warn(D,...j){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,D,...j):console.warn(`[main ${g()}]`,D,...j))}error(D,...j){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,D,...j):console.error(`[main ${g()}]`,D,...j))}flush(){}}e.$mk=i;class a extends O{constructor(D=e.$ik,j=!0){super(),this.g=j,this.setLevel(D)}trace(D,...j){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...j):console.log(D,...j))}debug(D,...j){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...j):console.log(D,...j))}info(D,...j){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...j):console.log(D,...j))}warn(D,...j){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...j):console.log(D,...j))}error(D,...j){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...j):console.error(D,...j))}flush(){}}e.$nk=a;class n extends O{constructor(D,j=e.$ik){super(),this.g=D,this.setLevel(j)}trace(D,...j){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(D),...j])}debug(D,...j){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(D),...j])}info(D,...j){this.f(b.Info)&&this.g.log(b.Info,[this.h(D),...j])}warn(D,...j){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(D),...j])}error(D,...j){this.f(b.Error)&&this.g.log(b.Error,[this.h(D),...j])}h(D){return typeof D=="string"?D:(0,I.$vj)(D,this.f(b.Trace))}flush(){}}e.$ok=n;class r extends O{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const j of this.g)j.setLevel(D);super.setLevel(D)}trace(D,...j){for(const x of this.g)x.trace(D,...j)}debug(D,...j){for(const x of this.g)x.debug(D,...j)}info(D,...j){for(const x of this.g)x.info(D,...j)}warn(D,...j){for(const x of this.g)x.warn(D,...j)}error(D,...j){for(const x of this.g)x.error(D,...j)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose();super.dispose()}}e.$pk=r;class t extends C.$Zc{constructor(D,j,x){if(super(),this.h=D,this.j=j,this.b=new R.$Fc,this.c=this.B(new v.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$qe),this.onDidChangeVisibility=this.g.event,x)for(const Y of x)this.b.set(Y.resource,{logger:void 0,info:Y})}m(D){return(0,d.$jg)(D)?[...this.b.values()].find(j=>j.info.id===D):this.b.get(D)}getLogger(D){return this.m(D)?.logger}createLogger(D,j){const x=this.n(D),Y=(0,d.$jg)(D)?D:j?.id??(0,k.$yj)(x.toString()).toString(16);let ne=this.b.get(x)?.logger;const ae=j?.logLevel==="always"?b.Trace:j?.logLevel;ne||(ne=this.s(x,ae??this.getLogLevel(x)??this.h,{...j,id:Y}));const ue={logger:ne,info:{resource:x,id:Y,logLevel:ae,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(ue.info),this.b.set(x,ue),ne}n(D){return(0,d.$jg)(D)?(0,u.$lh)(this.j,`${D}.log`):D}setLogLevel(D,j){if(f.URI.isUri(D)){const x=D,Y=j,ne=this.b.get(x);ne&&Y!==ne.info.logLevel&&(ne.info.logLevel=Y===this.h?void 0:Y,ne.logger?.setLevel(Y),this.b.set(ne.info.resource,ne),this.f.fire([x,Y]))}else{this.h=D;for(const[x,Y]of this.b.entries())this.b.get(x)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,j){const x=this.m(D);x&&j!==!x.info.hidden&&(x.info.hidden=!j,this.b.set(x.info.resource,x),this.g.fire([x.info.resource,j]))}getLogLevel(D){let j;return D&&(j=this.b.get(D)?.info.logLevel),j??this.h}registerLogger(D){const j=this.b.get(D.resource);j?j.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const j=this.b.get(D);j&&(j.logger&&j.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=t;class s{constructor(){this.onDidChangeLogLevel=new v.$qe().event}setLevel(D){}getLevel(){return b.Info}trace(D,...j){}debug(D,...j){}info(D,...j){}warn(D,...j){}error(D,...j){}critical(D,...j){}dispose(){}flush(){}}e.$rk=s;class o extends s{}e.$sk=o;function l(N){if(N.verbose)return b.Trace;if(typeof N.logLevel=="string"){const D=T(N.logLevel.toLowerCase());if(D!==void 0)return D}return e.$ik}function p(N){switch(N){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function A(N){switch(N){case b.Trace:return{original:"Trace",value:P.localize(1959,null)};case b.Debug:return{original:"Debug",value:P.localize(1960,null)};case b.Info:return{original:"Info",value:P.localize(1961,null)};case b.Warning:return{original:"Warning",value:P.localize(1962,null)};case b.Error:return{original:"Error",value:P.localize(1963,null)};case b.Off:return{original:"Off",value:P.localize(1964,null)}}}function T(N){switch(N){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$xk=new $.$2j("logLevel",p(b.Info))}),define(le[107],he([0,1,19,8,7,5,64,2,15,52,6]),function(Q,e,P,I,v,k,C,R,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class f extends R.$Zc{constructor(h,g){super(),this.a=h,this.b=g,this.c=this.B(new k.$qe),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$qe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new I.$Ih(0)),this.w=[],this.y=this.B(new I.$Ih(0))}watch(h,g){return g.recursive||this.b?.watcher?.forceUniversal?this.n(h,g):this.z(h,g)}n(h,g){const S={path:this.J(h),excludes:g.excludes,includes:g.includes,recursive:g.recursive,filter:g.filter,correlationId:g.correlationId},b=(0,P.$Xb)(this.j,S);return this.r(),(0,R.$Xc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(h=>(0,v.$4)(h))}s(){this.h||(this.h=this.B(this.t(g=>this.c.fire((0,u.$er)(g)),g=>this.G(g),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const h=this.b?.watcher?.recursive?.usePolling;if(h===!0)for(const g of this.j)(0,u.$ar)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const g of this.j)(0,u.$ar)(g)&&h.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(h,g){const S={path:this.J(h),excludes:g.excludes,includes:g.includes,recursive:!1,filter:g.filter,correlationId:g.correlationId},b=(0,P.$Xb)(this.w,S);return this.C(),(0,R.$Xc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(h=>(0,v.$4)(h))}D(){return this.u||(this.u=this.B(this.F(h=>this.c.fire((0,u.$er)(h)),h=>this.G(h),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(h){h.type==="error"&&this.g.fire(h.message),this.H(h)}H(h){this.a[h.type](h.message)}I(h){return(0,m.$mc)(h.fsPath)}J(h){const g=this.I(h);return(0,C.$Mg)(g)}}e.$kr=f});var oe=this&&this.__param||function(Q,e){return function(P,I){e(P,I,Q)}};define(le[108],he([0,1,19,8,13,21,5,43,66,2,49,14,109,16,47,4,9,63,6,7]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let i=class extends u.$Zc{static{w=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new C.$qe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$qe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$qe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$qe),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$qe),this.Y=this.B(new C.$qe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$qe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new I.$Th)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${n}`);const t=new u.$Yc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(s=>{const o=new b.$yl(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,u.$Xc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,u.$Uc)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await I.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return m.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,h.$ph)(n))throw new b.$Al((0,S.localize)(1871,null,this.sb(n)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new O.$fb;throw t.message=(0,S.localize)(1872,null,n.toString()),t}return r}async m(n){const r=await this.j(n);if((0,b.$ll)(r)||(0,b.$il)(r)||(0,b.$ml)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,b.$ll)(r)||(0,b.$il)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(t){throw(0,b.$vl)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$Al((0,S.localize)(1873,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$tl)(t)}}async s(n,r){const t=await this.j(n),s=this.S(t),o=r?.resolveTo,l=r?.resolveSingleChildDescendants,p=r?.resolveMetadata,A=await t.stat(n);let T;return this.t(t,n,A,void 0,!!p,(N,D)=>(T||(T=d.$Qi.forUris(()=>!s),T.set(n,!0),o&&T.fill(!0,o)),T.get(N.resource)||T.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&l?D===1:!1))}async t(n,r,t,s,o,l){const{providerExtUri:p}=this.R(n),A={resource:r,name:p.basename(r),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(n.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Ll)({mtime:t.mtime,size:t.size}),children:void 0};if(A.isDirectory&&l(A,s)){try{const T=await n.readdir(r),N=await I.Promises.settled(T.map(async([D,j])=>{try{const x=p.joinPath(r,D),Y=o?await n.stat(x):{type:j};return await this.t(n,x,Y,T.length,o,l)}catch(x){return this.b.trace(x),null}}));A.children=(0,P.$Lb)(N)}catch(T){this.b.trace(T),A.children=[]}return A}return A}async resolveAll(n){return I.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.t(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(t){return t}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new b.$Al((0,S.localize)(1874,null,this.sb(n)),b.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=v.$Se.fromString(""),t){await this.u(n,t);const s=await this.writeFile(n,r);return this.r.fire(new b.$xl(n,b.FileOperation.CREATE,s)),s}async writeFile(n,r,t){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let l=t;if((0,b.$ol)(s)&&!l?.atomic){const p=s.enforceAtomicWriteFile?.(n);p&&(l={...t,atomic:p})}try{await this.w(s,n,l)||await this.U(s,o.dirname(n));let A;if((0,b.$il)(s)&&!(r instanceof v.$Se))if((0,g.$Ee)(r)){const T=await(0,g.$Le)(r,3);T.ended?A=v.$Se.concat(T.buffer):A=T}else A=(0,g.$Ie)(r,T=>v.$Se.concat(T),3);else A=r;!(0,b.$ll)(s)||(0,b.$il)(s)&&A instanceof v.$Se||(0,b.$il)(s)&&(0,b.$ol)(s)&&l?.atomic?await this.hb(s,n,l,A):await this.db(s,n,l,A instanceof v.$Se?(0,v.$4e)(A):A),this.r.fire(new b.$xl(n,b.FileOperation.WRITE))}catch(p){throw new b.$Al((0,S.localize)(1875,null,this.sb(n),(0,b.$tl)(p).toString()),(0,b.$wl)(p),l)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,t){const s=!!t?.unlock;if(s&&!(n.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,S.localize)(1876,null,this.sb(r)));if(!!t?.atomic){if(!(n.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,S.localize)(1877,null,this.sb(r)));if(!(n.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,S.localize)(1878,null,this.sb(r)));if(s)throw new Error((0,S.localize)(1879,null,this.sb(r)))}let l;try{l=await n.stat(r)}catch{return}if(l.type&b.FileType.Directory)throw new b.$Al((0,S.localize)(1880,null,this.sb(r)),b.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(r,l),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$Kl&&typeof l.mtime=="number"&&typeof l.size=="number"&&t.mtime<l.mtime&&t.etag!==(0,b.$Ll)({mtime:t.mtime,size:l.size}))throw new b.$Al((0,S.localize)(1881,null),b.FileOperationResult.FILE_MODIFIED_SINCE,t);return l}async readFile(n,r,t){const s=await this.m(n);return r?.atomic?this.z(s,n,r,t):this.C(s,n,r,t)}async z(n,r,t,s){return new Promise((o,l)=>{this.cb.queueFor(r,async()=>{try{const p=await this.C(n,r,t,s);o(p)}catch(p){l(p)}},this.R(n).providerExtUri)})}async C(n,r,t,s){const o=await this.D(n,r,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,v.$5e)(o.value)}}async readFileStream(n,r,t){const s=await this.m(n);return this.D(s,n,r,t)}async D(n,r,t,s){const o=new k.$Be(s);let l=t;(0,b.$nl)(n)&&n.enforceAtomicReadFile?.(r)&&(l={...t,atomic:!0});const p=this.J(r,l).then(T=>T,T=>{throw o.dispose(!0),T});let A;try{return typeof l?.etag=="string"&&l.etag!==b.$Kl&&await p,l?.atomic&&(0,b.$nl)(n)||!((0,b.$ll)(n)||(0,b.$ml)(n))||(0,b.$il)(n)&&l?.preferUnbuffered?A=this.I(n,r,l):(0,b.$ml)(n)?A=this.G(n,r,o.token,l):A=this.H(n,r,o.token,l),A.on("end",()=>o.dispose()),A.on("error",()=>o.dispose()),{...await p,value:A}}catch(T){throw A&&await(0,g.$Je)(A),this.F(T,r,l)}}F(n,r,t){const s=(0,S.localize)(1882,null,this.sb(r),(0,b.$tl)(n).toString());return n instanceof b.$Cl?new b.$Cl(s,n.stat,t):n instanceof b.$Bl?new b.$Bl(s,n.fileOperationResult,n.size,n.options):new b.$Al(s,(0,b.$wl)(n),t)}G(n,r,t,s=Object.create(null)){const o=n.readFileStream(r,s,t);return(0,g.$Pe)(o,{data:l=>l instanceof v.$Se?l:v.$Se.wrap(l),error:l=>this.F(l,r,s)},l=>v.$Se.concat(l))}H(n,r,t,s=Object.create(null)){const o=(0,v.$9e)();return(0,y.$0q)(n,r,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,r,s)},t),o}I(n,r,t){const s=(0,g.$Ge)(o=>v.$Se.concat(o));return(async()=>{try{let o;t?.atomic&&(0,b.$nl)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(r,o.byteLength,t),s.end(v.$Se.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new b.$Al((0,S.localize)(1883,null,this.sb(n)),b.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==b.$Kl&&r.etag===t.etag)throw new b.$Cl((0,S.localize)(1884,null),t,r);return this.L(n,t.size,r),t}L(n,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new b.$Bl((0,S.localize)(1885,null,this.sb(n)),b.FileOperationResult.FILE_TOO_LARGE,r,t)}async canMove(n,r,t){return this.M(n,r,"move",t)}async canCopy(n,r,t){return this.M(n,r,"copy",t)}async M(n,r,t,s){if(n.toString()!==r.toString())try{const o=t==="move"?this.qb(await this.n(n),n):await this.m(n),l=this.qb(await this.n(r),r);await this.Q(o,n,l,r,t,s)}catch(o){return o}return!0}async move(n,r,t){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),l=await this.N(s,n,o,r,"move",!!t),p=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$xl(n,l==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,p)),p}async copy(n,r,t){const s=await this.m(n),o=this.qb(await this.n(r),r),l=await this.N(s,n,o,r,"copy",!!t),p=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$xl(n,l==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,p)),p}async N(n,r,t,s,o,l){if(r.toString()===s.toString())return o;const{exists:p,isSameResourceWithDifferentPathCase:A}=await this.Q(n,r,t,s,o,l);if(p&&!A&&l&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),o==="copy"){if(n===t&&(0,b.$jl)(n))await n.copy(r,s,{overwrite:l});else{const T=await this.resolve(r);T.isDirectory?await this.P(n,T,t,s):await this.O(n,r,t,s)}return o}else return n===t?(await n.rename(r,s,{overwrite:l}),o):(await this.N(n,r,t,s,"copy",l),await this.del(r,{recursive:!0}),"copy")}async O(n,r,t,s){if((0,b.$ll)(n)&&(0,b.$ll)(t))return this.jb(n,r,t,s);if((0,b.$ll)(n)&&(0,b.$il)(t))return this.pb(n,r,t,s);if((0,b.$il)(n)&&(0,b.$ll)(t))return this.nb(n,r,t,s);if((0,b.$il)(n)&&(0,b.$il)(t))return this.lb(n,r,t,s)}async P(n,r,t,s){await t.mkdir(s),Array.isArray(r.children)&&await I.Promises.settled(r.children.map(async o=>{const l=this.R(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),t,l):this.O(n,o.resource,t,l)}))}async Q(n,r,t,s,o,l){let p=!1;if(n===t){const{providerExtUri:T,isPathCaseSensitive:N}=this.R(n);if(N||(p=T.isEqual(r,s)),p&&o==="copy")throw new Error((0,S.localize)(1886,null,this.sb(r),this.sb(s)));if(!p&&T.isEqualOrParent(s,r))throw new Error((0,S.localize)(1887,null,this.sb(r),this.sb(s)))}const A=await this.exists(s);if(A&&!p){if(!l)throw new b.$Al((0,S.localize)(1888,null,this.sb(r),this.sb(s)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(n===t){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(r,s))throw new Error((0,S.localize)(1889,null,this.sb(r),this.sb(s)))}}return{exists:A,isSameResourceWithDifferentPathCase:p}}R(n){const r=this.S(n);return{providerExtUri:r?h.$bh:h.$dh,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new b.$xl(n,b.FileOperation.CREATE,t)),t}async U(n,r){const t=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&b.FileType.Directory))throw new Error((0,S.localize)(1890,null,this.sb(r)));break}catch(o){if((0,b.$vl)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(r)),r=s.dirname(r)}for(let o=t.length-1;o>=0;o--){r=s.joinPath(r,t[o]);try{await n.mkdir(r)}catch(l){if((0,b.$vl)(l)!==b.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(n,r){try{await this.W(n,r)}catch(t){return t}return!0}async W(n,r){const t=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(t.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,S.localize)(1891,null,this.sb(n)));const o=r?.atomic;if(o&&!(t.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,S.localize)(1892,null,this.sb(n)));if(s&&o)throw new Error((0,S.localize)(1893,null,this.sb(n)));let l;try{l=await t.stat(n)}catch{}if(l)this.rb(n,l);else throw new b.$Al((0,S.localize)(1894,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const A=await this.resolve(n);if(A.isDirectory&&Array.isArray(A.children)&&A.children.length>0)throw new Error((0,S.localize)(1895,null,this.sb(n)))}return t}async del(n,r){const t=await this.W(n,r);let s=r;if((0,b.$pl)(t)&&!s?.atomic){const A=t.enforceAtomicDelete?.(n);A&&(s={...r,atomic:A})}const o=!!s?.useTrash,l=!!s?.recursive,p=s?.atomic??!1;await t.delete(n,{recursive:l,useTrash:o,atomic:p}),this.r.fire(new b.$xl(n,b.FileOperation.DELETE))}async cloneFile(n,r){const t=await this.j(n),s=this.qb(await this.n(r),r);if(!(t===s&&this.R(t).providerExtUri.isEqual(n,r)))return t===s&&(0,b.$kl)(t)?t.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),t===s&&(0,b.$jl)(t)?this.cb.queueFor(n,()=>t.copy(n,r,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(n,()=>this.O(t,n,s,r),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:w.ab++})}watch(n,r={recursive:!1,excludes:[]}){const t=new u.$Yc;let s=!1,o=()=>{s=!0};t.add((0,u.$Xc)(()=>o())),(async()=>{try{const p=await this.bb(n,r);s?(0,u.$Uc)(p):o=()=>(0,u.$Uc)(p)}catch(p){this.b.error(p)}})();const l=r.correlationId;if(typeof l=="number"){const p=t.add(new C.$qe);return t.add(this.X.event(T=>{T.correlates(l)&&p.fire(T)})),{onDidChange:p.event,dispose:()=>t.dispose()}}return t}async bb(n,r){const t=await this.j(n),s=(0,R.$yj)([this.R(t).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:t.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,u.$Xc)(()=>{o&&(o.count--,o.count===0&&((0,u.$Uc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,u.$Uc)(n.disposable);this.$.clear()}async db(n,r,t,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,g.$Ee)(s)||(0,g.$Fe)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(l){throw(0,b.$tl)(l)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,t){let s=0,o;if((0,g.$Fe)(t)){if(t.buffer.length>0){const l=v.$Se.concat(t.buffer);await this.gb(n,r,l,l.byteLength,s,0),s+=l.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((l,p)=>{(0,g.$Ke)(o,{onData:async A=>{o.pause();try{await this.gb(n,r,A,A.byteLength,s,0)}catch(T){return p(T)}s+=A.byteLength,setTimeout(()=>o.resume())},onError:A=>p(A),onEnd:()=>l()})})}async fb(n,r,t){let s=0,o;for(;(o=t.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,t,s,o,l){let p=0;for(;p<s;){const A=await n.write(r,o+p,t.buffer,l+p,s-p);p+=A}}async hb(n,r,t,s){return this.cb.queueFor(r,()=>this.ib(n,r,t,s),this.R(n).providerExtUri)}async ib(n,r,t,s){let o;s instanceof v.$Se?o=s:(0,g.$Ee)(s)?o=await(0,v.$5e)(s):(0,g.$Fe)(s)?o=await(0,v.$6e)(s):o=(0,v.$3e)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(n,r,t,s){return this.cb.queueFor(s,()=>this.kb(n,r,t,s),this.R(t).providerExtUri)}async kb(n,r,t,s){let o,l;try{o=await n.open(r,{create:!1}),l=await t.open(s,{create:!0,unlock:!1});const p=v.$Se.alloc(this.a);let A=0,T=0,N=0;do N=await n.read(o,A,p.buffer,T,p.byteLength-T),await this.gb(t,l,p,N,A,T),A+=N,T+=N,T===p.byteLength&&(T=0);while(N>0)}catch(p){throw(0,b.$tl)(p)}finally{await I.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof l=="number"?t.close(l):Promise.resolve()])}}async lb(n,r,t,s){return this.cb.queueFor(s,()=>this.mb(n,r,t,s),this.R(t).providerExtUri)}async mb(n,r,t,s){return t.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,t,s){return this.cb.queueFor(s,()=>this.ob(n,r,t,s),this.R(t).providerExtUri)}async ob(n,r,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const l=await n.readFile(r);await this.gb(t,o,v.$Se.wrap(l),l.byteLength,0,0)}catch(l){throw(0,b.$tl)(l)}finally{await t.close(o)}}async pb(n,r,t,s){const o=await(0,v.$5e)(this.H(n,r,k.CancellationToken.None));await this.hb(t,s,void 0,o)}qb(n,r){if(n.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$Al((0,S.localize)(1896,null,this.sb(r)),b.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$Al((0,S.localize)(1897,null,this.sb(n)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===f.Schemas.file?n.fsPath:n.toString(!0)}};e.$$q=i,e.$$q=i=w=Ee([oe(0,c.$fk)],i)}),define(le[110],he([0,1,32,8,25,13,5,64,2,15,11,16,47,29,4,9,63,107,105,104]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class w extends y.$kr{static{this.L=!1}constructor(a,n){super(a,n),this.onDidChangeCapabilities=C.Event.None,this.P=new v.$Fc(r=>f.$ch.getComparisonKey(r)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=S.FileSystemProviderCapabilities.FileReadWrite|S.FileSystemProviderCapabilities.FileOpenReadWriteClose|S.FileSystemProviderCapabilities.FileReadStream|S.FileSystemProviderCapabilities.FileFolderCopy|S.FileSystemProviderCapabilities.FileWriteUnlock|S.FileSystemProviderCapabilities.FileAtomicRead|S.FileSystemProviderCapabilities.FileAtomicWrite|S.FileSystemProviderCapabilities.FileAtomicDelete|S.FileSystemProviderCapabilities.FileClone,d.$n&&(this.M|=S.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(a){try{const{stat:n,symbolicLink:r}=await h.SymlinkSupport.stat(this.I(a));return{type:this.O(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:S.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const n=await h.Promises.readdir(this.I(a),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,f.$lh)(a,t.name))).type:s=this.O(t),r.push([t.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.hb(n)}}O(a,n){let r;return n?.dangling?r=S.FileType.Unknown:a.isFile()?r=S.FileType.File:a.isDirectory()?r=S.FileType.Directory:r=S.FileType.Unknown,n&&(r|=S.FileType.SymbolicLink),r}async Q(a){const n=this.I(a);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.P.get(a);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const t=new I.$Jh;return this.P.set(a,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,m.$Xc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(a)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(a)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),t.open()})}async readFile(a,n){let r;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),r=await this.Q(a));const t=this.I(a);return await P.promises.readFile(t)}catch(t){throw this.hb(t)}finally{r?.dispose()}}R(a){w.L&&this.a.trace(a)}readFileStream(a,n,r){const t=(0,$.$Ge)(s=>k.$Se.concat(s.map(o=>k.$Se.wrap(o))).buffer);return(0,b.$0q)(this,a,t,s=>s.buffer,{...n,bufferSize:256*1024},r),t}async writeFile(a,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.S(a)?this.U(a,(0,f.$lh)((0,f.$kh)(a),`${(0,f.$ih)(a)}${r.atomic.postfix}`),n,r):this.W(a,n,r)}async S(a){try{const n=this.I(a),{symbolicLink:r}=await h.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async U(a,n,r,t){const s=new m.$Yc;try{s.add(await this.Q(a)),s.add(await this.Q(n)),await this.W(n,r,t,!0);try{await this.rename(n,a,{overwrite:!0})}catch(o){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{s.dispose()}}async W(a,n,r,t){let s;try{const o=this.I(a);if(!r.create||!r.overwrite){if(await h.Promises.exists(o)){if(!r.overwrite)throw(0,S.$sl)((0,g.localize)(1901,null),S.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,S.$sl)((0,g.localize)(1902,null),S.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(a,{create:!0,unlock:r.unlock},t),await this.write(s,0,n,0,n.byteLength)}catch(o){throw await this.ib(a,o)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(a){w.$=a}async open(a,n,r){const t=this.I(a);let s;(0,S.$gl)(n)&&!r&&(s=await this.Q(a));let o;try{if((0,S.$gl)(n)&&n.unlock)try{const{stat:p}=await h.SymlinkSupport.stat(t);p.mode&128||await P.promises.chmod(t,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let l;if((0,S.$gl)(n)){if(d.$l)try{await P.promises.truncate(t,0),l="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}l||(l="w")}else l="r";o=await h.Promises.open(t,l)}catch(l){throw s?.dispose(),(0,S.$gl)(n)?await this.ib(a,l):this.hb(l)}if(this.X.set(o,0),(0,S.$gl)(n)&&this.Z.set(o,a),s){const l=this.Y.get(o);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.Y.set(o,s),l&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),l.dispose())}return o}async close(a){const n=this.Y.get(a);try{if(this.X.delete(a),this.Z.delete(a)&&w.$)try{await h.Promises.fdatasync(a)}catch(r){w.configureFlushOnWrite(!1),this.a.error(r)}return await h.Promises.close(a)}catch(r){throw this.hb(r)}finally{n&&(this.Y.get(a)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.Y.delete(a)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),n.dispose())}}async read(a,n,r,t,s){const o=this.ab(a,n);let l=null;try{l=(await h.Promises.read(a,r,t,s,o)).bytesRead}catch(p){throw this.hb(p)}finally{this.bb(a,o,l)}return l}ab(a,n){return n===this.X.get(a)?null:n}bb(a,n,r){const t=this.X.get(a);typeof t=="number"&&(typeof n=="number"||(typeof r=="number"?this.X.set(a,t+r):this.X.delete(a)))}async write(a,n,r,t,s){return(0,I.$5h)(()=>this.cb(a,n,r,t,s),100,3)}async cb(a,n,r,t,s){const o=this.ab(a,n);let l=null;try{l=(await h.Promises.write(a,r,t,s,o)).bytesWritten}catch(p){throw await this.ib(this.Z.get(a),p)}finally{this.bb(a,o,l)}return l}async mkdir(a){try{await P.promises.mkdir(this.I(a))}catch(n){throw this.hb(n)}}async delete(a,n){try{const r=this.I(a);if(n.recursive){let t;n?.atomic!==!1&&n.atomic.postfix&&(t=(0,u.$oc)((0,u.$rc)(r),`${(0,u.$sc)(r)}${n.atomic.postfix}`)),await h.Promises.rm(r,h.RimRafMode.MOVE,t)}else try{await P.promises.unlink(r)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:o,symbolicLink:l}=await h.SymlinkSupport.stat(r);s=o.isDirectory()&&!l}catch{}if(s)await P.promises.rmdir(r);else throw t}else throw t}}catch(r){throw this.hb(r)}}async rename(a,n,r){const t=this.I(a),s=this.I(n);if(t!==s)try{await this.db(a,n,"move",r.overwrite),await h.Promises.rename(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,g.localize)(1903,null,(0,u.$sc)(t),(0,u.$sc)((0,u.$rc)(s)),o.toString()))),this.hb(o)}}async copy(a,n,r){const t=this.I(a),s=this.I(n);if(t!==s)try{await this.db(a,n,"copy",r.overwrite),await h.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,g.localize)(1904,null,(0,u.$sc)(t),(0,u.$sc)((0,u.$rc)(s)),o.toString()))),this.hb(o)}}async db(a,n,r,t){const s=this.I(a),o=this.I(n);let l=!1;if(!!(this.capabilities&S.FileSystemProviderCapabilities.PathCaseSensitive)||(l=(0,R.$Ig)(s,o,!0)),l){if(r==="copy")throw(0,S.$sl)((0,g.localize)(1905,null),S.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const A=await this.N(a);if(!A)throw(0,S.$sl)((0,g.localize)(1906,null),S.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(n);if(T){if(!t)throw(0,S.$sl)((0,g.localize)(1907,null),S.FileSystemProviderErrorCode.FileExists);A.type&S.FileType.File&&T.type&S.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,n){return this.eb(a,n,!1)}async eb(a,n,r){const t=this.I(a),s=this.I(n),o=!!(this.capabilities&S.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.$Ig)(t,s,!o))return;const l=new m.$Yc;try{l.add(await this.Q(a)),l.add(await this.Q(n)),r&&await P.promises.mkdir((0,u.$rc)(s),{recursive:!0}),await P.promises.copyFile(t,s)}catch(p){if(p.code==="ENOENT"&&!r)return this.eb(a,n,!0);throw this.hb(p)}finally{l.dispose()}}t(a,n,r){return new c.$rr(t=>a(t),t=>n(t),r)}F(a,n,r){return new O.$Ar(t=>a(t),t=>n(t),r)}hb(a){if(a instanceof S.$rl)return a;let n=a,r;switch(a.code){case"ENOENT":r=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=S.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=S.FileSystemProviderErrorCode.Unknown;break;default:r=S.FileSystemProviderErrorCode.Unknown}return(0,S.$sl)(n,r)}async ib(a,n){let r=this.hb(n);if(a&&r.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await h.SymlinkSupport.stat(this.I(a));t.mode&128||(r=(0,S.$sl)(n,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return r}}e.$Br=w}),define(le[111],he([0,1,2,6]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0R=void 0;class v extends P.$Zc{constructor(C,R=[]){super(),this.a=new I.$pk([C,...R]),this.B(C.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...R){this.a.trace(C,...R)}debug(C,...R){this.a.debug(C,...R)}info(C,...R){this.a.info(C,...R)}warn(C,...R){this.a.warn(C,...R)}error(C,...R){this.a.error(C,...R)}flush(){this.a.flush()}}e.$0R=v}),define(le[112],he([0,1,9,6]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=void 0;var v;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(v||(v={}));async function k(u,d,f,$,h){try{const g=await new Promise((b,y)=>{Q(["@vscode/spdlog"],b,y)}).then(be);g.setFlushOn(v.Trace);const S=await g.createAsyncRotatingLogger(u,d,f,$);return h?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(g){console.error(g)}return null}function C(u,d,f){switch(d){case I.LogLevel.Trace:u.trace(f);break;case I.LogLevel.Debug:u.debug(f);break;case I.LogLevel.Info:u.info(f);break;case I.LogLevel.Warning:u.warn(f);break;case I.LogLevel.Error:u.error(f);break;case I.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function R(u,d){switch(d){case I.LogLevel.Trace:u.setLevel(v.Trace);break;case I.LogLevel.Debug:u.setLevel(v.Debug);break;case I.LogLevel.Info:u.setLevel(v.Info);break;case I.LogLevel.Warning:u.setLevel(v.Warning);break;case I.LogLevel.Error:u.setLevel(v.Error);break;case I.LogLevel.Off:u.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class m extends I.$lk{constructor(d,f,$,h,g){super(),this.m=[],this.setLevel(g),this.n=this.s(d,f,$,h),this.B(this.onDidChangeLogLevel(S=>{this.r&&R(this.r,S)}))}async s(d,f,$,h){const g=$?6:1,S=30/g*P.$Nl.MB,b=await k(d,f,S,g,h);if(b){this.r=b,R(this.r,this.getLevel());for(const{level:y,message:c}of this.m)C(this.r,y,c);this.m=[]}}g(d,f){this.r?C(this.r,d,f):this.getLevel()<=d&&this.m.push({level:d,message:f})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$YR=m}),define(le[113],he([0,1,28,6,112]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZR=void 0;class k extends I.$qk{s(R,m,u){return new v.$YR((0,P.$7g)(),R.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,m)}}e.$ZR=k}),define(le[39],he([0,1,5,66,2,10]),function(Q,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=void 0,e.$zo=(0,k.$Ki)("policy");class C extends v.$Zc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$qe),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const d=Object.keys(this.f).length;return this.f={...u,...this.f},d!==Object.keys(this.f).length&&await this.j(u),I.Iterable.reduce(this.g.entries(),(f,[$,h])=>({...f,[$]:h}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return I.Iterable.reduce(Object.entries(this.f),(u,[d,f])=>({...u,[d]:{definition:f,value:this.g.get(d)}}),{})}}e.$Ao=C;class R{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Bo=R}),define(le[114],he([0,1,8,5,66,3,9,6,39]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=void 0;function u(f,$){const h=[];for(const g of new Set(v.Iterable.concat(f.keys(),$.keys())))f.get(g)!==$.get(g)&&h.push(g);return h}let d=class extends m.$Ao{constructor($,h,g){super(),this.m=$,this.n=h,this.s=g,this.c=this.B(new P.$Ih(500));const S=I.Event.filter(h.onDidFilesChange,b=>b.affects($));this.B(h.watch($)),this.B(S(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const $=new Map;try{const h=await this.n.readFile(this.m),g=JSON.parse(h.value.toString());if(!(0,k.$lg)(g))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(g))this.f[S]&&$.set(S,g[S])}catch(h){h.fileOperationResult!==C.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",h)}return $}async w(){const $=await this.u(),h=u(this.g,$);this.g=$,h.length>0&&this.h.fire(h)}};e.$0ic=d,e.$0ic=d=Ee([oe(1,C.$fl),oe(2,R.$fk)],d)}),define(le[115],he([0,1,39,8,2,6]),function(Q,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=void 0;let C=class extends P.$Ao{constructor(m,u){super(),this.m=m,this.n=u,this.a=new I.$Eh,this.b=this.B(new v.$1c)}async j(m){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(m).length} policy definitions`);const{createWatcher:u}=await new Promise((d,f)=>{Q(["@vscode/policy-watcher"],d,f)}).then(be);await this.a.queue(()=>new Promise((d,f)=>{try{this.b.value=u(this.n,m,$=>{this.t($),d()})}catch($){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",$),f($)}}))}t(m){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(m)}`);for(const u in m){const d=m[u];d===void 0?this.g.delete(u):this.g.set(u,d)}this.h.fire(Object.keys(m))}};e.$9ic=C,e.$9ic=C=Ee([oe(0,k.$fk)],C)}),define(le[33],he([0,1,10]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,P.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"}),define(le[37],he([0,1,76,3]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0,P=be(P),I=be(I);class v{constructor(){this.a=new Map}add(C,R){P.ok(I.$jg(C)),P.ok(I.$lg(R)),P.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,R)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$xo=new v}),define(le[116],he([0,1,5,79,37]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=void 0,v=be(v),e.$yo={JSONContribution:"base.contributions.json"};function k(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class C{constructor(){this.b=new P.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,d){this.a[k(u)]=d,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(u){const d=this.a[u];return d?(0,I.$ak)(d):void 0}hasSchemaContent(u){return!!this.a[u]}}const R=new C;v.$xo.add(e.$yo.JSONContribution,R)}),define(le[40],he([0,1,19,5,3,4,30,116,37]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ConfigurationScope=e.$Co=e.EditPresentationTypes=void 0,e.$No=S,e.$Oo=b,e.$Po=y,e.$Qo=O,e.$Ro=w,e.$So=i,e.$To=a,v=be(v),k=be(k);var u;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.$Co={Configuration:"base.contributions.configuration"};var d;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo="vscode://schemas/settings/resourceLanguage",e.$Ko="vscode://schemas/settings/configurationDefaults";const f=m.$xo.as(R.$yo.JSONContribution);class ${constructor(){this.a=[],this.i=new Set,this.j=new I.$qe,this.onDidSchemaChange=this.j.event,this.k=new I.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:k.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},f.registerSchema(e.$Jo,this.h),this.z()}registerConfiguration(r,t=!0){this.registerConfigurations([r],t)}registerConfigurations(r,t=!0){const s=new Set;this.r(r,t,s),f.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(r){const t=new Set;this.s(r,t),f.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:r,remove:t}){const s=new Set;this.s(t,s),this.r(r,!1,s),f.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(r){const t=new Set;this.l(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(r,t){this.a.push(...r);const s=[];for(const{overrides:o,source:l}of r)for(const p in o){t.add(p);const A=this.b.get(p)??this.b.set(p,{configurationDefaultOverrides:[]}).get(p),T=o[p];if(A.configurationDefaultOverrides.push({value:T,source:l}),e.$Mo.test(p)){const N=this.o(p,T,l,A.configurationDefaultOverrideValue);if(!N)continue;A.configurationDefaultOverrideValue=N,this.n(p,N,l),s.push(...S(p))}else{const N=this.p(p,T,l,A.configurationDefaultOverrideValue);if(!N)continue;A.configurationDefaultOverrideValue=N;const D=this.e[p];D&&(this.A(p,D),this.w(p,D))}}this.q(s)}deregisterDefaultConfigurations(r){const t=new Set;this.m(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(r,t){for(const s of r){const o=this.a.indexOf(s);o!==-1&&this.a.splice(o,1)}for(const{overrides:s,source:o}of r)for(const l in s){const p=this.b.get(l);if(!p)continue;const A=p.configurationDefaultOverrides.findIndex(T=>o?T.source?.id===o.id:T.value===s[l]);if(A!==-1){if(p.configurationDefaultOverrides.splice(A,1),p.configurationDefaultOverrides.length===0&&this.b.delete(l),e.$Mo.test(l)){let T;for(const N of p.configurationDefaultOverrides)T=this.o(l,N.value,N.source,T);T&&!v.$wg(T.value)?(p.configurationDefaultOverrideValue=T,this.n(l,T,o)):(this.b.delete(l),delete this.e[l],delete this.c.properties[l])}else{let T;for(const D of p.configurationDefaultOverrides)T=this.p(l,D.value,D.source,T);p.configurationDefaultOverrideValue=T;const N=this.e[l];N&&(this.A(l,N),this.w(l,N))}t.add(l)}}this.y()}n(r,t,s){const o={type:"object",default:t.value,description:k.localize(1663,null,(0,C.$oj)(r)),$ref:e.$Jo,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[r]=o,this.c.properties[r]=o}o(r,t,s,o){const l=o?.value||{},p=o?.source??new Map;if(!(p instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const A of Object.keys(t)){const T=t[A];if(v.$lg(T)&&(v.$qg(l[A])||v.$lg(l[A]))){if(l[A]={...l[A]??{},...T},s)for(const D in T)p.set(`${A}.${D}`,s)}else l[A]=T,s?p.set(A,s):p.delete(A)}return{value:l,source:p}}p(r,t,s,o){const l=this.e[r],p=o?.value??l?.defaultDefaultValue;let A=s;if(v.$lg(t)&&(l!==void 0&&l.type==="object"||l===void 0&&(v.$qg(p)||v.$lg(p)))){if(A=o?.source??new Map,!(A instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const N in t)s&&A.set(`${r}.${N}`,s);t={...v.$lg(p)?p:{},...t}}return{value:t,source:A}}deltaConfiguration(r){let t=!1;const s=new Set;r.removedDefaults&&(this.m(r.removedDefaults,s),t=!0),r.addedDefaults&&(this.l(r.addedDefaults,s),t=!0),r.removedConfigurations&&this.s(r.removedConfigurations,s),r.addedConfigurations&&this.r(r.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...r){this.j.fire()}registerOverrideIdentifiers(r){this.q(r),this.j.fire()}q(r){for(const t of r)this.i.add(t);this.y()}r(r,t,s){r.forEach(o=>{this.u(o,t,o.extensionInfo,o.restrictedProperties,void 0,s),this.d.push(o),this.v(o)})}s(r,t){const s=o=>{if(o.properties)for(const l in o.properties){t.add(l);const p=this.e[l];p?.policy?.name&&this.f.delete(p.policy.name),delete this.e[l],this.x(l,o.properties[l])}o.allOf?.forEach(l=>s(l))};for(const o of r){s(o);const l=this.d.indexOf(o);l!==-1&&this.d.splice(l,1)}}u(r,t=!0,s,o,l=d.WINDOW,p){l=v.$sg(r.scope)?l:r.scope;const A=r.properties;if(A)for(const N in A){const D=A[N];if(t&&O(N,D)){delete A[N];continue}if(D.source=s,D.defaultDefaultValue=A[N].default,this.A(N,D),e.$Mo.test(N)?D.scope=void 0:(D.scope=v.$sg(D.scope)?l:D.scope,D.restricted=v.$sg(D.restricted)?!!o?.includes(N):D.restricted),A[N].hasOwnProperty("included")&&!A[N].included){this.g[N]=A[N],delete A[N];continue}else this.e[N]=A[N],A[N].policy?.name&&this.f.set(A[N].policy.name,N);!A[N].deprecationMessage&&A[N].markdownDeprecationMessage&&(A[N].deprecationMessage=A[N].markdownDeprecationMessage),p.add(N)}const T=r.allOf;if(T)for(const N of T)this.u(N,t,s,o,l,p)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const r=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&r.set(t,s.configurationDefaultOverrideValue);return r}v(r){const t=s=>{const o=s.properties;if(o)for(const p in o)this.w(p,o[p]);s.allOf?.forEach(t)};t(r)}w(r,t){switch(e.$Do.properties[r]=t,t.scope){case d.APPLICATION:e.$Eo.properties[r]=t;break;case d.MACHINE:e.$Fo.properties[r]=t;break;case d.MACHINE_OVERRIDABLE:e.$Go.properties[r]=t;break;case d.WINDOW:e.$Ho.properties[r]=t;break;case d.RESOURCE:e.$Io.properties[r]=t;break;case d.LANGUAGE_OVERRIDABLE:e.$Io.properties[r]=t,this.h.properties[r]=t;break}}x(r,t){switch(delete e.$Do.properties[r],t.scope){case d.APPLICATION:delete e.$Eo.properties[r];break;case d.MACHINE:delete e.$Fo.properties[r];break;case d.MACHINE_OVERRIDABLE:delete e.$Go.properties[r];break;case d.WINDOW:delete e.$Ho.properties[r];break;case d.RESOURCE:case d.LANGUAGE_OVERRIDABLE:delete e.$Io.properties[r],delete this.h.properties[r];break}}y(){for(const r of this.i.values()){const t=`[${r}]`,s={type:"object",description:k.localize(1664,null),errorMessage:k.localize(1665,null),$ref:e.$Jo};this.A(t,s),e.$Do.properties[t]=s,e.$Eo.properties[t]=s,e.$Fo.properties[t]=s,e.$Go.properties[t]=s,e.$Ho.properties[t]=s,e.$Io.properties[t]=s}}z(){const r={type:"object",description:k.localize(1666,null),errorMessage:k.localize(1667,null),$ref:e.$Jo};e.$Do.patternProperties[e.$Lo]=r,e.$Eo.patternProperties[e.$Lo]=r,e.$Fo.patternProperties[e.$Lo]=r,e.$Go.patternProperties[e.$Lo]=r,e.$Ho.patternProperties[e.$Lo]=r,e.$Io.patternProperties[e.$Lo]=r,this.j.fire()}A(r,t){const s=this.b.get(r)?.configurationDefaultOverrideValue;let o,l;s&&(!t.disallowConfigurationDefault||!s.source)&&(o=s.value,l=s.source),v.$qg(o)&&(o=t.defaultDefaultValue,l=void 0),v.$qg(o)&&(o=y(t.type)),t.default=o,t.defaultValueSource=l}}const h="\\[([^\\]]+)\\]",g=new RegExp(h,"g");e.$Lo=`^(${h})+$`,e.$Mo=new RegExp(e.$Lo);function S(n){const r=[];if(e.$Mo.test(n)){let t=g.exec(n);for(;t?.length;){const s=t[1].trim();s&&r.push(s),t=g.exec(n)}}return(0,P.$Qb)(r)}function b(n){return n.reduce((r,t)=>`${r}[${t}]`,"")}function y(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const c=new $;m.$xo.add(e.$Co.Configuration,c);function O(n,r){return n.trim()?e.$Mo.test(n)?k.localize(1669,null,n):c.getConfigurationProperties()[n]!==void 0?k.localize(1670,null,n):r.policy?.name&&c.getPolicyConfigurations().get(r.policy?.name)!==void 0?k.localize(1671,null,n,r.policy?.name,c.getPolicyConfigurations().get(r.policy?.name)):null:k.localize(1668,null)}function w(){const n=[],r=c.getConfigurationProperties();for(const t of Object.keys(r))n.push([t,r[t].scope]);return n.push(["launch",d.RESOURCE]),n.push(["task",d.RESOURCE]),n}function i(n){const r={};for(const t of n){const s=t.properties;if(v.$lg(s))for(const o in s)r[o]=s[o];t.allOf&&Object.assign(r,i(t.allOf))}return r}function a(n){switch(n){case"application":return d.APPLICATION;case"machine":return d.MACHINE;case"resource":return d.RESOURCE;case"machine-overridable":return d.MACHINE_OVERRIDABLE;case"language-overridable":return d.LANGUAGE_OVERRIDABLE;default:return d.WINDOW}}}),define(le[67],he([0,1,19,5,34,2,25,27,3,12,30,40,9,37]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Yo=w,P=be(P),v=be(v),R=be(R),m=be(m);function g(r){return Object.isFrozen(r)?r:R.$lo(r)}class S{static createEmptyModel(t){return new S({},[],[],void 0,t)}constructor(t,s,o,l,p){this.b=t,this.c=s,this.d=o,this.raw=l,this.f=p,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof S)return s;const o=new b("",this.f);return o.parseRaw(s),o.configurationModel});this.g=t.reduce((s,o)=>o===s?o:s.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,d.$mj)(this.contents,t):this.contents}inspect(t,s){const o=this;return{get value(){return g(o.rawConfiguration.getValue(t))},get override(){return s?g(o.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return g(s?o.rawConfiguration.override(s).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const l=[];for(const{contents:p,identifiers:A,keys:T}of o.rawConfiguration.overrides){const N=new S(p,T,[],void 0,o.f).getValue(t);N!==void 0&&l.push({identifiers:A,value:N})}return l.length?g(l):void 0}}}getOverrideValue(t,s){const o=this.j(s);return o?t?(0,d.$mj)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const o of this.overrides)o.identifiers.includes(t)&&s.push(...o.keys);return P.$Qb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return P.$Qb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=R.$ko(this.contents),o=R.$ko(this.overrides),l=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const A of t)if(p.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.i(s,A.contents);for(const T of A.overrides){const[N]=o.filter(D=>P.$yb(D.identifiers,T.identifiers));N?(this.i(N.contents,T.contents),N.keys.push(...T.keys),N.keys=P.$Qb(N.keys)):o.push(R.$ko(T))}for(const T of A.keys)l.indexOf(T)===-1&&l.push(T)}return new S(s,l,o,p.every(A=>A instanceof S)?void 0:p,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const l of P.$Qb([...Object.keys(this.contents),...Object.keys(s)])){let p=this.contents[l];const A=s[l];A&&(typeof p=="object"&&typeof A=="object"?(p=R.$ko(p),this.i(p,A)):p=A),o[l]=p}return new S(o,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const o of Object.keys(s)){if(o in t&&m.$lg(t[o])&&m.$lg(s[o])){this.i(t[o],s[o]);continue}t[o]=R.$ko(s[o])}}j(t){let s=null,o=null;const l=p=>{p&&(o?this.i(o,p):o=R.$ko(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===t?s=p.contents:p.identifiers.includes(t)&&l(p.contents);return l(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,d.$lj)(this.contents,t),f.$Mo.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>P.$yb(o.identifiers,(0,f.$No)(t))),1))}k(t,s,o){if((0,d.$kj)(this.contents,t,s,l=>this.f.error(l)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),f.$Mo.test(t)){const l=(0,f.$No)(t),p={identifiers:l,keys:Object.keys(this.contents[t]),contents:(0,d.$jj)(this.contents[t],T=>this.f.error(T))},A=this.overrides.findIndex(T=>P.$yb(T.identifiers,l));A!==-1?this.overrides[A]=p:this.overrides.push(p)}}}e.$Uo=S;class b{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||S.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!m.$sg(t)){const o=this.h(t);this.parseRaw(o,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:o,keys:l,overrides:p,restricted:A,hasExcludedProperties:T}=this.i(t,s);this.b=new S(o,l,p,T?[t]:void 0,this.g),this.c=A||[]}h(t){let s={},o=null,l=[];const p=[],A=[];function T(D){Array.isArray(l)?l.push(D):o!==null&&(l[o]=D)}const N={onObjectBegin:()=>{const D={};T(D),p.push(l),l=D,o=null},onObjectProperty:D=>{o=D},onObjectEnd:()=>{l=p.pop()},onArrayBegin:()=>{const D=[];T(D),p.push(l),l=D,o=null},onArrayEnd:()=>{l=p.pop()},onLiteralValue:T,onError:(D,j,x)=>{A.push({error:D,offset:j,length:x})}};if(t)try{v.$_n(t,N),s=l[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return s}i(t,s){const o=h.$xo.as(f.$Co.Configuration).getConfigurationProperties(),l=this.j(t,o,!0,s);t=l.raw;const p=(0,d.$jj)(t,N=>this.g.error(`Conflict in settings file ${this.f}: ${N}`)),A=Object.keys(t),T=this.l(t,N=>this.g.error(`Conflict in settings file ${this.f}: ${N}`));return{contents:p,keys:A,overrides:T,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(t,s,o,l){let p=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:p};const A={},T=[];for(const N in t)if(f.$Mo.test(N)&&o){const D=this.j(t[N],s,!1,l);A[N]=D.raw,p=p||D.hasExcludedProperties,T.push(...D.restricted)}else{const D=s[N],j=D?typeof D.scope<"u"?D.scope:f.ConfigurationScope.WINDOW:void 0;D?.restricted&&T.push(N),!l.exclude?.includes(N)&&(l.include?.includes(N)||(j===void 0||l.scopes===void 0||l.scopes.includes(j))&&!(l.skipRestricted&&D?.restricted))?A[N]=t[N]:p=!0}return{raw:A,restricted:T,hasExcludedProperties:p}}l(t,s){const o=[];for(const l of Object.keys(t))if(f.$Mo.test(l)){const p={};for(const A in t[l])p[A]=t[l][A];o.push({identifiers:(0,f.$No)(l),keys:Object.keys(p),contents:(0,d.$jj)(p,s)})}return o}}e.$Vo=b;class y extends k.$Zc{constructor(t,s,o,l,p){super(),this.c=t,this.f=s,this.g=l,this.h=p,this.b=this.B(new I.$qe),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),p),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(I.Event.any(I.Event.filter(this.g.onDidFilesChange,A=>A.contains(this.c)),I.Event.filter(this.g.onDidRunOperation,A=>(A.isOperation($.FileOperation.CREATE)||A.isOperation($.FileOperation.COPY)||A.isOperation($.FileOperation.DELETE)||A.isOperation($.FileOperation.WRITE))&&o.isEqual(A.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return S.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Wo=y;class c{constructor(t,s,o,l,p,A,T,N,D,j,x,Y,ne){this.a=t,this.b=s,this.c=o,this.overrideIdentifiers=l,this.d=p,this.f=A,this.g=T,this.h=N,this.i=D,this.j=j,this.k=x,this.l=Y,this.m=ne}get value(){return g(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class O{constructor(t,s,o,l,p,A,T,N,D,j){this.j=t,this.l=s,this.m=o,this.n=l,this.p=p,this.q=A,this.r=T,this.s=N,this.t=D,this.u=j,this.h=null,this.i=new C.$Fc,this.v=null}getValue(t,s,o){return this.w(t,s,o).getValue(t)}updateValue(t,s,o={}){let l;o.resource?(l=this.t.get(o.resource),l||(l=S.createEmptyModel(this.u),this.t.set(o.resource,l))):l=this.s,s===void 0?l.removeValue(t):l.setValue(t,s),o.resource||(this.h=null)}inspect(t,s,o){const l=this.w(t,s,o),p=this.A(s.resource,o),A=s.resource?this.t.get(s.resource)||this.s:this.s,T=new Set;for(const N of l.overrides)for(const D of N.identifiers)l.getOverrideValue(t,D)!==void 0&&T.add(D);return new c(t,s,l.getValue(t),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,p||void 0,A)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=[];if(!s){const{added:l,updated:p,removed:A}=a(this.j,t);s=[...l,...p,...A]}for(const l of s)for(const p of(0,f.$No)(l)){const A=this.j.getKeysForOverrideIdentifier(p),T=t.getKeysForOverrideIdentifier(p),N=[...T.filter(D=>A.indexOf(D)===-1),...A.filter(D=>T.indexOf(D)===-1),...A.filter(D=>!R.$oo(this.j.override(p).getValue(D),t.override(p).getValue(D)))];o.push([p,N])}return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:o,removed:l}=a(this.l,t),p=[...s,...o,...l];return p.length&&this.updatePolicyConfiguration(t),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:o,removed:l,overrides:p}=a(this.applicationConfiguration,t),A=[...s,...o,...l];return A.length&&this.updateApplicationConfiguration(t),{keys:A,overrides:p}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:l,overrides:p}=a(this.localUserConfiguration,t),A=[...s,...o,...l];return A.length&&this.updateLocalUserConfiguration(t),{keys:A,overrides:p}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:l,overrides:p}=a(this.remoteUserConfiguration,t),A=[...s,...o,...l];return A.length&&this.updateRemoteUserConfiguration(t),{keys:A,overrides:p}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:l,overrides:p}=a(this.workspaceConfiguration,t),A=[...s,...o,...l];return A.length&&this.updateWorkspaceConfiguration(t),{keys:A,overrides:p}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:l,updated:p,removed:A,overrides:T}=a(o,s),N=[...l,...p,...A];return(N.length||!o)&&this.updateFolderConfiguration(t,s),{keys:N,overrides:T}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:l,removed:p,overrides:A}=a(s,void 0);return{keys:[...o,...l,...p],overrides:A}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,o){let l=this.x(s,o);return s.overrideIdentifier&&(l=l.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(l=l.merge(this.l)),l}x({resource:t},s){let o=this.y();if(s&&t){const l=s.getFolder(t);l&&(o=this.z(l.uri)||o);const p=this.t.get(t);p&&(o=o.merge(p))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const o=this.y(),l=this.r.get(t);l?(s=o.merge(l),this.i.set(t,s)):s=o}return s}A(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:o,overrides:l,keys:p}=this.r.get(s);return t.push([s,{contents:o,overrides:l,keys:p}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(l=>s.add(l))),[...s.values()]}static parse(t,s){const o=this.E(t.defaults,s),l=this.E(t.policy,s),p=this.E(t.application,s),A=this.E(t.user,s),T=this.E(t.workspace,s),N=t.folders.reduce((D,j)=>(D.set(u.URI.revive(j[0]),this.E(j[1],s)),D),new C.$Fc);return new O(o,l,p,A,S.createEmptyModel(s),T,N,S.createEmptyModel(s),new C.$Fc,s)}static E(t,s){return new S(t.contents,t.keys,t.overrides,void 0,s)}}e.$Xo=O;function w(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,s=new Map;for(const l of r)l.keys.forEach(p=>t.add(p)),l.overrides.forEach(([p,A])=>{const T=(0,C.$Cc)(s,p,new Set);A.forEach(N=>T.add(N))});const o=[];return s.forEach((l,p)=>o.push([p,[...l.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,s,o,l,p){this.change=t,this.f=s,this.g=o,this.h=l,this.i=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const A of t.keys)this.affectedKeys.add(A);for(const[,A]of t.overrides)for(const T of A)this.affectedKeys.add(T);this.d=this.a;for(const A of this.affectedKeys)this.d+=A+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=O.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const o=this.a+t,l=this.d.indexOf(o);if(l<0)return!1;const p=l+o.length;if(p>=this.d.length)return!1;const A=this.d.charCodeAt(p);if(A!==this.b&&A!==this.c)return!1;if(s){const T=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,N=this.g.getValue(t,s,this.h);return!R.$oo(T,N)}return!0}}e.$Zo=i;function a(r,t){const{added:s,removed:o,updated:l}=n(t?.rawConfiguration,r?.rawConfiguration),p=[],A=r?.getAllOverrideIdentifiers()||[],T=t?.getAllOverrideIdentifiers()||[];if(t){const N=T.filter(D=>!A.includes(D));for(const D of N)p.push([D,t.getKeysForOverrideIdentifier(D)])}if(r){const N=A.filter(D=>!T.includes(D));for(const D of N)p.push([D,r.getKeysForOverrideIdentifier(D)])}if(t&&r){for(const N of A)if(T.includes(N)){const D=n({contents:r.getOverrideValue(void 0,N)||{},keys:r.getKeysForOverrideIdentifier(N)},{contents:t.getOverrideValue(void 0,N)||{},keys:t.getKeysForOverrideIdentifier(N)});p.push([N,[...D.added,...D.removed,...D.updated]])}}return{added:s,removed:o,updated:l,overrides:p}}function n(r,t){const s=r?t?r.keys.filter(p=>t.keys.indexOf(p)===-1):[...r.keys]:[],o=t?r?t.keys.filter(p=>r.keys.indexOf(p)===-1):[...t.keys]:[],l=[];if(r&&t){for(const p of t.keys)if(r.keys.indexOf(p)!==-1){const A=(0,d.$mj)(t.contents,p),T=(0,d.$mj)(r.contents,p);R.$oo(A,T)||l.push(p)}}return{added:s,removed:o,updated:l}}}),define(le[117],he([0,1,19,5,2,27,3,67,40,6,39,37]),function(Q,e,P,I,v,k,C,R,m,u,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=void 0;class $ extends v.$Zc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new I.$qe),this.onDidChangeConfiguration=this.a.event,this.b=R.$Uo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(f.$xo.as(m.$Co.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:y})=>this.f(Array.from(b),y))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,y){this.j(b,f.$xo.as(m.$Co.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=R.$Uo.createEmptyModel(this.c);const b=f.$xo.as(m.$Co.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,y){const c=this.g();for(const O of b){const w=c[O],i=y[O];w!==void 0?this.b.setValue(O,w):i?this.b.setValue(O,i.default):this.b.removeValue(O)}}}e.$1o=$;class h{constructor(){this.onDidChangeConfiguration=I.Event.None,this.configurationModel=R.$Uo.createEmptyModel(new u.$sk)}async initialize(){return this.configurationModel}}e.$2o=h;let g=class extends v.$Zc{get configurationModel(){return this.b}constructor(b,y,c){super(),this.c=b,this.f=y,this.g=c,this.a=this.B(new I.$qe),this.onDidChangeConfiguration=this.a.event,this.b=R.$Uo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const y={},c=[],O=f.$xo.as(m.$Co.Configuration).getConfigurationProperties();for(const w of b){const i=O[w];if(!i){c.push(w);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}c.push(w),y[i.policy.name]={type:i.type}}}return(0,C.$wg)(y)||await this.f.updatePolicyDefinitions(y),c}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const y=f.$xo.as(m.$Co.Configuration).getPolicyConfigurations(),c=(0,P.$Lb)(b.map(O=>y.get(O)));this.m(c,!0)}m(b,y){this.g.trace("PolicyConfiguration#update",b);const c=f.$xo.as(m.$Co.Configuration).getConfigurationProperties(),O=[],w=this.b.isEmpty();for(const i of b){const a=c[i]?.policy?.name;if(a){const n=this.f.getPolicyValue(a);(w?n!==void 0:!(0,k.$oo)(this.b.getValue(i),n))&&O.push([i,n])}else this.b.getValue(i)!==void 0&&O.push([i,void 0])}if(O.length){this.g.trace("PolicyConfiguration#changed",O);const i=this.b;this.b=R.$Uo.createEmptyModel(this.g);for(const a of i.keys)this.b.setValue(a,i.getValue(a));for(const[a,n]of O)n===void 0?this.b.removeValue(a):this.b.setValue(a,n);y&&this.a.fire(this.b)}}};e.$3o=g,e.$3o=g=Ee([oe(1,d.$zo),oe(2,u.$fk)],g)}),define(le[118],he([0,1,19,8,13,5,34,78,2,25,27,11,16,30,67,40,117,9,39]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;class O extends m.$Zc{constructor(a,n,r,t){super(),this.m=a,this.n=t,this.h=this.B(new k.$qe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$1o(t)),this.c=r instanceof c.$Bo?new b.$2o:this.B(new b.$3o(this.b,r,t)),this.f=this.B(new g.$Wo(this.m,{},$.$ch,n,t)),this.a=new g.$Xo(this.b.configurationModel,this.c.configurationModel,g.$Uo.createEmptyModel(t),g.$Uo.createEmptyModel(t),g.$Uo.createEmptyModel(t),g.$Uo.createEmptyModel(t),new u.$Fc,g.$Uo.createEmptyModel(t),new u.$Fc,t),this.j=new w(a,n,this),this.g=this.B(new I.$Wh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new g.$Xo(a,n,g.$Uo.createEmptyModel(this.n),r,g.$Uo.createEmptyModel(this.n),g.$Uo.createEmptyModel(this.n),new u.$Fc,g.$Uo.createEmptyModel(this.n),new u.$Fc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,n){const r=typeof a=="string"?a:void 0,t=(0,h.$fj)(a)?a:(0,h.$fj)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(a,n,r,t,s){const o=(0,h.$gj)(r)?r:(0,h.$fj)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,l=o?t:r;if(l!==void 0&&l!==h.ConfigurationTarget.USER_LOCAL&&l!==h.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${l}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,P.$Qb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const p=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(p.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,d.$oo)(n,p.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),N=this.a.localUserConfiguration.overrides.find(D=>(0,P.$yb)([...D.identifiers].sort(),T));N&&(o.overrideIdentifiers=N.identifiers)}const A=o?.overrideIdentifiers?.length?[(0,S.$Oo)(o.overrideIdentifiers),a]:[a];await this.j.write(A,n),await this.reloadConfiguration()}inspect(a,n={}){return this.a.inspect(a,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,n,h.ConfigurationTarget.USER)}s(a,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(a,n);this.u(t,r,h.ConfigurationTarget.DEFAULT)}t(a){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,n,h.ConfigurationTarget.DEFAULT)}u(a,n,r){const t=new g.$Zo(a,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$4o=O;class w{constructor(a,n,r){this.b=a,this.c=n,this.d=r,this.a=new I.$Rh}write(a,n){return this.a.queue(()=>this.e(a,n))}async e(a,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===y.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const t=[];if((0,C.$5n)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,a,n);r=(0,R.$jo)(r,s),await this.c.writeFile(this.b,v.$Se.fromString(r))}f(a,n,r){const{tabSize:t,insertSpaces:s,eol:o}=this.h;if(!n.length){const l=JSON.stringify(r,null,s?" ".repeat(t):"	");return[{content:l,length:l.length,offset:0}]}return(0,R.$go)(a,n,r,{tabSize:t,insertSpaces:s,eol:o})}get h(){if(!this.g){let a=f.OS===f.OperatingSystem.Linux||f.OS===f.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(a=n),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[68],he([0,1,14]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=I,e.$on=v,e.$pn=k,e.$qn=C;function I(m){return m.scheme===P.Schemas.vscodeRemote?m.authority:void 0}function v(m){if(!m)return;const u=m.indexOf("+");return u<0?m:m.substr(0,u)}function k(m){const{host:u,port:d}=R(m);if(typeof d>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:u,port:d}}function C(m,u){let{host:d,port:f}=R(m);return typeof f>"u"&&(f=u),{host:d,port:f}}function R(m){const u=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(u)return{host:u[1],port:parseInt(u[2],10)};const d=m.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const f=m.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:m,port:void 0}}}),define(le[22],he([0,1,31,10,68]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$zn=e.$yn=e.$xn=e.TargetPlatform=e.ExtensionType=e.$wn=e.$un=e.$tn=e.$sn=e.$rn=void 0,e.$vn=k,e.$An=f,e.$Bn=$,e.$Cn=h,e.$Dn=g,e.$En=S,e.$Fn=b,P=be(P),e.$rn="extensions.user.cache",e.$sn="extensions.builtin.cache",e.$tn="undefined_publisher",e.$un=["ui","workspace","web"];function k(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$wn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(C||(e.ExtensionType=C={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class m{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,O){if(typeof c>"u"||c===null)return typeof O>"u"||O===null;if(typeof O>"u"||O===null)return!1;if(typeof c=="string"||typeof O=="string"){const w=typeof c=="string"?c:c.value,i=typeof O=="string"?O:O.value;return P.$Kf(w,i)}return c._lower===O._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$xn=m;class u{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const O of c)this.add(O)}add(c){this.c.add(m.toKey(c))}delete(c){return this.c.delete(m.toKey(c))}has(c){return this.c.has(m.toKey(c))}}e.$yn=u;class d{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(m.toKey(c))}get(c){return this.c.get(m.toKey(c))}has(c){return this.c.has(m.toKey(c))}set(c,O){this.c.set(m.toKey(c),O)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zn=d;function f(y){return $(y)}function $(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function h(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function g(y,c){if(c){const O=`onResolveRemoteAuthority:${(0,v.$on)(c)}`;return!!y.activationEvents?.includes(O)}return!1}function S(y){return y.map(c=>{const[O,w]=c.split("@");return{proposalName:O,version:w?parseInt(w):void 0}})}function b(y){return y.map(c=>c.split("@")[0])}e.$Gn=(0,I.$Ki)("IBuiltinExtensionsScannerService")}),define(le[20],he([0,1,11,4,22,10]),function(Q,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.ExtensionManagementErrorCode=e.$sp=e.ExtensionGalleryErrorCode=e.$rp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=R,e.$mp=m,e.$np=u,e.$op=d,e.$pp=f,e.$qp=$,e.$ep="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$fp=new RegExp(e.$ep),e.$gp="__web_extension",e.$hp="skipWalkthrough",e.$ip="extensionInstallSource",e.$jp="dependecyOrPackExtensionInstall",e.$kp="clientTargetPlatform";var C;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(C||(e.ExtensionInstallSource=C={}));function R(i){switch(i){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function m(i){switch(i){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function u(i,a){switch(i){case P.Platform.Windows:return a==="x64"?v.TargetPlatform.WIN32_X64:a==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Linux:return a==="x64"?v.TargetPlatform.LINUX_X64:a==="arm64"?v.TargetPlatform.LINUX_ARM64:a==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?v.TargetPlatform.ALPINE_X64:a==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Mac:return a==="x64"?v.TargetPlatform.DARWIN_X64:a==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case P.Platform.Web:return v.TargetPlatform.WEB}}function d(i,a){return a===v.TargetPlatform.WEB&&!i.includes(v.TargetPlatform.WEB)}function f(i,a,n){return d(a,n)?!1:i===v.TargetPlatform.UNDEFINED||i===v.TargetPlatform.UNIVERSAL?!0:i===v.TargetPlatform.UNKNOWN?!1:i===n}function $(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var h;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(h||(e.SortBy=h={}));var g;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var S;(function(i){i.Install="install",i.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$rp=(0,k.$Ki)("extensionGalleryService");var y;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting",i.Offline="Offline"})(y||(e.ExtensionGalleryErrorCode=y={}));class c extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}e.$sp=c;var O;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(O||(e.ExtensionManagementErrorCode=O={}));class w extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}e.$tp=w,e.$up=(0,k.$Ki)("extensionManagementService"),e.$vp="extensionsIdentifiers/disabled",e.$wp="extensionsIdentifiers/enabled",e.$xp=(0,k.$Ki)("IGlobalExtensionEnablementService"),e.$yp=(0,k.$Ki)("IExtensionTipsService"),e.$zp=(0,I.localize2)(1780,"Extensions"),e.$Ap=(0,I.localize2)(1781,"Preferences")}),define(le[119],he([0,1,2,22,9]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class k extends P.$Zc{constructor(R,m,u,d,f){super(),this.a=R,this.b=m,this.c=u,this.f=f,this.B(d.onDidInstallExtensions($=>this.g($))),this.B(d.onDidUninstallExtension($=>this.h($)))}g(R){for(const m of R)m.local&&this.invalidate(m.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const m of this.a.profiles)this.c.extUri.isEqual(m.extensionsResource,R)&&await this.j(m);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,I.$rn))}catch(m){(0,v.$wl)(m)!==v.FileOperationResult.FILE_NOT_FOUND&&this.f.error(m)}}}e.$5q=k});var ze=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(le[44],he([0,1,16,56,4,45,22,98]),function(Q,e,P,I,v,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=d,e.$7p=f,e.$8p=$,e.$9p=h,e.$0p=g,e.$$p=S,e.$_p=b,e.$aq=y,I=ze(I),v=be(v),k=be(k);const m=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,u=/^-(\d{4})(\d{2})(\d{2})$/;function d(w){return w=w.trim(),w==="*"||m.test(w)}function f(w){if(!d(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=w.match(m);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function $(w){if(!w)return null;const i=w.majorBase,a=w.majorMustEqual,n=w.minorBase;let r=w.minorMustEqual;const t=w.patchBase;let s=w.patchMustEqual;w.hasCaret&&(i===0||(r=!1),s=!1);let o=0;if(w.preRelease){const l=u.exec(w.preRelease);if(l){const[,p,A,T]=l;o=Date.UTC(Number(p),Number(A)-1,Number(T))}}return{majorBase:i,majorMustEqual:a,minorBase:n,minorMustEqual:r,patchBase:t,patchMustEqual:s,isMinimum:w.hasGreaterEquals,notBefore:o}}function h(w,i,a){let n;typeof w=="string"?n=$(f(w)):n=w;let r;i instanceof Date?r=i.getTime():typeof i=="string"&&(r=new Date(i).getTime());let t;if(typeof a=="string"?t=$(f(a)):t=a,!n||!t)return!1;const s=n.majorBase,o=n.minorBase,l=n.patchBase;let p=t.majorBase,A=t.minorBase,T=t.patchBase;const N=t.notBefore;let D=t.majorMustEqual,j=t.minorMustEqual,x=t.patchMustEqual;return t.isMinimum?s>p?!0:s<p?!1:o>A?!0:o<A||r&&r<N?!1:l>=T:(s===1&&p===0&&(!D||!j||!x)&&(p=1,A=0,T=0,D=!0,j=!1,x=!1),s<p?!1:s>p?!D:o<A?!1:o>A?!j:l<T?!1:l>T?!x:!(r&&r<N))}function g(w,i,a,n,r,t){const s=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return s.push([I.default.Error,v.localize(1832,null)]),s;if(typeof n.name!="string")return s.push([I.default.Error,v.localize(1833,null,"name")]),s;if(typeof n.version!="string")return s.push([I.default.Error,v.localize(1834,null,"version")]),s;if(!n.engines)return s.push([I.default.Error,v.localize(1835,null,"engines")]),s;if(typeof n.engines.vscode!="string")return s.push([I.default.Error,v.localize(1836,null,"engines.vscode")]),s;if(typeof n.extensionDependencies<"u"&&!O(n.extensionDependencies))return s.push([I.default.Error,v.localize(1837,null,"extensionDependencies")]),s;if(typeof n.activationEvents<"u"){if(!O(n.activationEvents))return s.push([I.default.Error,v.localize(1838,null,"activationEvents")]),s;if(typeof n.main>"u"&&typeof n.browser>"u")return s.push([I.default.Error,v.localize(1839,null,"activationEvents","main","browser")]),s}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&s.push([I.default.Warning,v.localize(1840,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return s.push([I.default.Error,v.localize(1841,null,"main")]),s;{const p=(0,P.$lh)(a,n.main);(0,P.$fh)(p,a)||s.push([I.default.Warning,v.localize(1842,null,p.path,a.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return s.push([I.default.Error,v.localize(1843,null,"browser")]),s;{const p=(0,P.$lh)(a,n.browser);(0,P.$fh)(p,a)||s.push([I.default.Warning,v.localize(1844,null,p.path,a.path)])}}if(!k.valid(n.version))return s.push([I.default.Error,v.localize(1845,null)]),s;const o=[];if(!S(w,i,n,r,o))for(const p of o)s.push([I.default.Error,p]);if(t&&n.enabledApiProposals?.length){const p=[];if(!y([...n.enabledApiProposals],p))for(const A of p)s.push([I.default.Error,A])}return s}function S(w,i,a,n,r){return n||typeof a.main>"u"&&typeof a.browser>"u"?!0:c(w,i,a.engines.vscode,r)}function b(w,i,a){return w==="*"||c(i,a,w)}function y(w,i){if(w.length===0)return!0;const a=Array.isArray(i)?i:void 0,n=(a?void 0:i)??R.allApiProposals,r=[],t=(0,C.$En)(w);for(const{proposalName:s,version:o}of t){const l=n[s];l&&o&&l.version!==o&&r.push(v.localize(1846,null,s))}return a?.push(...r),r.length===0}function c(w,i,a,n=[]){const r=$(f(a));if(!r)return n.push(v.localize(1847,null,a)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return n.push(v.localize(1848,null,a)),!1}else if(!r.majorMustEqual)return n.push(v.localize(1849,null,a)),!1;return h(w,i,r)?!0:(n.push(v.localize(1850,null,w,a)),!1)}function O(w){if(!Array.isArray(w))return!1;for(let i=0,a=w.length;i<a;i++)if(typeof w[i]!="string")return!1;return!0}}),define(le[69],he([0,1,21,2,11,4,20,10]),function(Q,e,P,I,v,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=void 0,e.$gs=m;function m(d){return d.tags.find(f=>f.startsWith("lp-"))?.split("lp-")[1]}e.$hs=(0,R.$Ki)("languagePackService");let u=class extends I.$Zc{constructor(f){super(),this.c=f}async getAvailableLanguages(){const f=new P.$Be;setTimeout(()=>f.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},f.token)}catch{return[]}const g=$.firstPage.filter(S=>S.properties.localizedLanguages?.length&&S.tags.some(b=>b.startsWith("lp-"))).map(S=>{const b=S.properties.localizedLanguages?.[0],y=m(S);return{...this.f(y,b,S),extensionId:S.identifier.id,galleryExtension:S}});return g.push(this.f("en","English")),g}f(f,$,h){const g=$??f;let S;if(g!==f&&(S=`(${f})`),f.toLowerCase()===v.$z.toLowerCase()&&(S??="",S+=(0,k.localize)(1928,null)),h?.installCount){S??="";const b=h.installCount;let y;b>1e6?y=`${Math.floor(b/1e5)/10}M`:b>1e3?y=`${Math.floor(b/1e3)}K`:y=String(b),S+=` $(cloud-download) ${y}`}return{id:f,label:g,description:S}}};e.$is=u,e.$is=u=Ee([oe(0,C.$rp)],u)}),define(le[46],he([0,1,13,7,2,4,40,10,6,37]),function(Q,e,P,I,v,k,C,R,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$dq=$,e.$eq=h,e.$fq=g,e.$gq=S,e.$hq=b,e.$iq=y,e.$bq=(0,R.$Ki)("requestService");class d{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?i[a]="*****":i[a]=this.b[a];this.a=i}return this.a}}class f extends v.$Zc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,k.localize)(2050,null),when:m.$xk.isEqualTo((0,m.$uk)(m.LogLevel.Trace)).serialize()})}async c(i,a,n){const r=`${i} #${++this.b}: ${a.url}`;this.a.trace(`${r} - begin`,a.type,new d(a.headers??{}));try{const t=await n();return this.a.trace(`${r} - end`,a.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,a.type,(0,I.$bb)(t)),t}}}e.$cq=f;function $(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}function h(w){return w.res.statusCode===204}async function g(w){return h(w)?null:(await(0,P.$5e)(w.stream)).toString()}async function S(w){if(!$(w))throw new Error("Server returned "+w.res.statusCode);return g(w)}async function b(w){if(!$(w))throw new Error("Server returned "+w.res.statusCode);if(h(w))return null;const a=(await(0,P.$5e)(w.stream)).toString();try{return JSON.parse(a)}catch(n){throw n.message+=`:
`+a,n}}function y(w){O(w)}let c;function O(w){const i=u.$xo.as(C.$Co.Configuration),a=c;c={id:"http",order:15,title:(0,k.localize)(2051,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(2057,null),(0,k.localize)(2058,null),(0,k.localize)(2059,null),(0,k.localize)(2060,null)],default:"override",description:(0,k.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(2063,null),restricted:!0}}},i.updateConfigurations({add:[c],remove:a?[a]:[]})}O(C.ConfigurationScope.APPLICATION)}),define(le[120],he([0,1,21,14,9,46]),function(Q,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oS=void 0;let C=class{constructor(m,u){this.a=m,this.b=u}async download(m,u,d=P.CancellationToken.None){if(m.scheme===I.Schemas.file||m.scheme===I.Schemas.vscodeRemote){await this.b.copy(m,u);return}const f={type:"GET",url:m.toString(!0)},$=await this.a.request(f,d);if($.res.statusCode===200)await this.b.writeFile(u,$.stream);else{const h=await(0,k.$gq)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${h}`)}}};e.$oS=C,e.$oS=C=Ee([oe(0,k.$bq),oe(1,v.$fl)],C)}),define(le[121],he([0,1,122,3]),function(Q,e,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=k;function v(C,R){return C.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:C.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function k(C,R,m={}){const u=(0,P.parse)(C),d=m.proxyUrl||v(u,R);if(!d)return null;const f=(0,P.parse)(d);if(!/^https?:$/.test(f.protocol||""))return null;const $={host:f.hostname||"",port:(f.port?+f.port:0)||(f.protocol==="https"?443:80),auth:f.auth,rejectUnauthorized:(0,I.$pg)(m.strictSSL)?m.strictSSL:!0};if(u.protocol==="http:"){const h=await new Promise((g,S)=>{Q(["http-proxy-agent"],g,S)}).then(be);return new h.HttpProxyAgent(d,$)}else{const h=await new Promise((g,S)=>{Q(["https-proxy-agent"],g,S)}).then(be);return new h.HttpsProxyAgent(d,$)}}}),define(le[123],he([0,1,61,15,4,21,38,7,11,28,89,153,8,80]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=S;let g;async function S(y,c,O,w){return O["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):m.$l?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,f.$Pm)(w)&&!O["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,f.$Pm)(w)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=$.Promises.withAsyncBody(async(i,a)=>{const n=new k.$Be;let r=1e4;const t=y.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,h.$Qm)(t,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),a(new Error((0,v.localize)(2064,null)))},r);try{i(await b(c,n.token))}catch(o){!(0,R.$8)(o)&&!n.token.isCancellationRequested?a(new Error((0,v.localize)(2065,null,(0,C.$vj)(o)))):i({})}finally{clearTimeout(s),n.dispose()}})),g)}async function b(y,c){const O=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",O);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",w);const i=(0,u.$7g)().replace(/-/g,"").substr(0,12),a=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};y.trace("getUnixShellEnvironment#env",n);const r=await(0,d.$Fm)(m.OS,n);return y.trace("getUnixShellEnvironment#shell",r),new Promise((t,s)=>{if(c.isCancellationRequested)return s(new R.$9);const o=(0,I.$sc)(r);let l,p;const A="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${A} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,p=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${A} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,p=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,p=["-i","-l","-c"]):(l=`'${process.execPath}' ${A} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?p=["-ic"]:p=["-i","-l","-c"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),l);const T=(0,P.spawn)(r,[...p,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});c.onCancellationRequested(()=>(T.kill(),s(new R.$9))),T.on("error",j=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,C.$vj)(j)),s(j)});const N=[];T.stdout.on("data",j=>N.push(j));const D=[];T.stderr.on("data",j=>D.push(j)),T.on("close",(j,x)=>{const Y=Buffer.concat(N).toString("utf8");y.trace("getUnixShellEnvironment#raw",Y);const ne=Buffer.concat(D).toString("utf8");if(ne.trim()&&y.trace("getUnixShellEnvironment#stderr",ne),j||x)return s(new Error((0,v.localize)(2066,null,j,x)));const ae=a.exec(Y),ue=ae?ae[1]:"{}";try{const me=JSON.parse(ue);O?me.ELECTRON_RUN_AS_NODE=O:delete me.ELECTRON_RUN_AS_NODE,w?me.ELECTRON_NO_ATTACH_CONSOLE=w:delete me.ELECTRON_NO_ATTACH_CONSOLE,delete me.VSCODE_RESOLVING_ENVIRONMENT,delete me.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",me),t(me)}catch(me){y.error("getUnixShellEnvironment#errorCaught",(0,C.$vj)(me)),s(me)}})})}}),define(le[124],he([0,1,10]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2R=e.$1R=void 0,e.$1R=(0,P.$Ki)("stateReadService"),e.$2R=(0,P.$Ki)("stateService")}),define(le[70],he([0,1,8,13,2,3,17,9,6]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5R=e.$4R=e.$3R=e.SaveStrategy=void 0;var u;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class d extends v.$Zc{constructor(g,S,b,y){super(),this.h=g,this.j=S,this.m=b,this.n=y,this.a=Object.create(null),this.b="",this.c=this.B(new P.$Ih(this.j===u.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(g){g.fileOperationResult!==R.FileOperationResult.FILE_NOT_FOUND&&this.m.error(g)}}getItem(g,S){const b=this.a[g];return(0,k.$sg)(b)?S:b}setItem(g,S){this.setItems([{key:g,data:S}])}setItems(g){let S=!1;for(const{key:b,data:y}of g)this.a[b]!==y&&((0,k.$sg)(y)?(0,k.$qg)(this.a[b])||(this.a[b]=void 0,S=!0):(this.a[b]=y,S=!0));S&&this.s()}removeItem(g){(0,k.$qg)(this.a[g])||(this.a[g]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const g=JSON.stringify(this.a,null,4);if(g!==this.b)try{await this.n.writeFile(this.h,I.$Se.fromString(g),{atomic:{postfix:".vsctmp"}}),this.b=g}catch(S){this.m.error(S)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$3R=d;let f=class extends v.$Zc{constructor(g,S,b,y){super(),this.a=this.B(new d(S.stateResource,g,b,y))}async init(){await this.a.init()}getItem(g,S){return this.a.getItem(g,S)}};e.$4R=f,e.$4R=f=Ee([oe(1,C.$Ri),oe(2,m.$fk),oe(3,R.$fl)],f);class $ extends f{setItem(g,S){this.a.setItem(g,S)}setItems(g){this.a.setItems(g)}removeItem(g){this.a.removeItem(g)}close(){return this.a.close()}}e.$5R=$}),define(le[71],he([0,1,11,36,28]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=C,e.$Cp=R;function k(m){if(P.$x===P.Platform.Linux&&/^penguin(\.|$)/i.test(m))return"chromebook"}function C(m,u,d,f,$,h,g,S,b,y){const c=Object.create(null);c["common.machineId"]=h,c["common.sqmId"]=g,c["common.devDeviceId"]=S,c.sessionID=(0,v.$7g)()+Date.now(),c.commitHash=f,c.version=$,c["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,P.$k)(P.$x),c["common.nodePlatform"]=I.$ic,c["common.nodeArch"]=d,c["common.product"]=y||"desktop",b&&(c["common.msftInternal"]=b);let O=0;const w=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>O++,enumerable:!0}}),P.$o&&(c["common.snap"]="true");const i=k(u);return i&&(c["common.platformDetail"]=i),c}function R(m){const u=I.env.USERDNSDOMAIN;if(!u)return!1;const d=u.toLowerCase();return m.some(f=>d===f)}}),define(le[18],he([0,1,10]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,P.$Ki)("telemetryService"),e.$fm=(0,P.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var I;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(I||(e.TelemetryLevel=I={}));var v;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(v||(e.TelemetryConfiguration=v={}))}),define(le[72],he([0,1,58,7,10,6,18]),function(Q,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.ExtensionSignatureVerificationCode=e.$Bq=void 0,e.$Bq=(0,v.$Ki)("IExtensionSignatureVerificationService");var R;(function(d){d.Success="Success",d.RequiredArgumentMissing="RequiredArgumentMissing",d.InvalidArgument="InvalidArgument",d.PackageIsUnreadable="PackageIsUnreadable",d.UnhandledException="UnhandledException",d.SignatureManifestIsMissing="SignatureManifestIsMissing",d.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",d.SignatureIsMissing="SignatureIsMissing",d.SignatureIsUnreadable="SignatureIsUnreadable",d.CertificateIsUnreadable="CertificateIsUnreadable",d.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",d.FileAlreadyExists="FileAlreadyExists",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",d.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",d.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",d.SignatureIsInvalid="SignatureIsInvalid",d.SignatureManifestIsInvalid="SignatureManifestIsInvalid",d.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",d.EntryIsMissing="EntryIsMissing",d.EntryIsTampered="EntryIsTampered",d.Untrusted="Untrusted",d.CertificateRevoked="CertificateRevoked",d.SignatureIsNotValid="SignatureIsNotValid",d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(R||(e.ExtensionSignatureVerificationCode=R={}));class m extends Error{constructor(f){super(f),this.code=f}}e.$Cq=m;let u=class{constructor(f,$){this.b=f,this.c=$}d(){return this.a||(this.a=this.f()),this.a}async f(){return(0,P.$zq)("@vscode/vsce-sign","src/main.js")}async verify(f,$,h,g){let S;const b=f.identifier.id;try{S=await this.d()}catch(w){return this.b.error("Could not load vsce-sign module",(0,I.$bb)(w)),this.b.info(`Extension signature verification is not done: ${b}`),!1}const y=new Date().getTime();let c;try{this.b.trace(`Verifying extension signature for ${b}...`),c=await S.verify($,h,this.b.getLevel()===k.LogLevel.Trace)}catch(w){c={code:R.UnknownError,didExecute:!1,output:(0,I.$bb)(w)}}const O=new Date().getTime()-y;if(this.b.info(`Extension signature verification result for ${b}: ${c.code}. Executed: ${c.didExecute}. Duration: ${O}ms.`),this.b.trace(`Extension signature verification output for ${b}:
${c.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:b,extensionVersion:f.version,code:c.code,internalCode:c.internalCode,duration:O,didExecute:c.didExecute,clientTargetPlatform:g}),c.code===R.Success)return!0;throw new m(c.code)}};e.$Dq=u,e.$Dq=u=Ee([oe(0,k.$fk),oe(1,C.$em)],u)}),define(le[41],he([0,1,27,3,68,71,18]),function(Q,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Kp=d,e.$Lp=f,e.$Mp=$,e.$Np=h,e.$Op=S,e.$Pp=y,e.$Qp=c,e.$Rp=i;class R{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Dp=R;class m{constructor(){this.telemetryLevel=C.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ep=m,e.$Fp=new m;class u{async publicLog(n,r,t){}async publicLogError(n,r,t){}}e.$Gp=u,e.$Hp="telemetry",e.$Ip="extensionTelemetryLog",e.$Jp={log:()=>null,flush:()=>Promise.resolve(null)};function d(a,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!a.enableTelemetry)}function f(a,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function $(a){const n=a.getValue(C.$nm),r=a.getValue(C.$om);if(a.getValue(C.$pm)===!1||r===!1)return C.TelemetryLevel.NONE;switch(n??C.TelemetryConfiguration.ON){case C.TelemetryConfiguration.ON:return C.TelemetryLevel.USAGE;case C.TelemetryConfiguration.ERROR:return C.TelemetryLevel.ERROR;case C.TelemetryConfiguration.CRASH:return C.TelemetryLevel.CRASH;case C.TelemetryConfiguration.OFF:return C.TelemetryLevel.NONE}}function h(a){const n={},r={},t={};b(a,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const o=t[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function S(a){if(!a)return"none";const n=(0,v.$on)(a);return g.has(n)?n:"other"}function b(a,n,r=0,t){if(a)for(const s of Object.getOwnPropertyNames(a)){const o=a[s],l=t?t+s:s;Array.isArray(o)?n[l]=(0,P.$po)(o):o instanceof Date?n[l]=o.toISOString():(0,I.$lg)(o)?r<2?b(o,n,r+1,l+"."):n[l]=(0,P.$po)(o):n[l]=o}}function y(a,n){const r=a.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,k.$Cp)(r)||t}function c(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function O(a,n){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let r=a;const t=[];for(const p of n)for(;;){const A=p.exec(a);if(!A)break;t.push([A.index,p.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const p=o.exec(a);if(!p)break;const A=t.some(([T,N])=>p.index<N&&T<o.lastIndex);!s.test(p[0])&&!A&&(r+=a.substring(l,p.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<a.length&&(r+=a.substr(l)),r}function w(a){if(!a)return a;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(a))return`<REDACTED: ${r.label}>`;return a}function i(a,n){return(0,P.$mo)(a,r=>{if(r instanceof R||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let t=r.replaceAll("%20"," ");t=O(t,n);for(const s of n)t=t.replace(s,"");return t=w(t),t}})}}),define(le[26],he([0,1,31,20,22,11,12,7,36,41]),function(Q,e,P,I,v,k,C,R,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Tp=void 0,e.$Sp=d,e.$Up=g,e.$Vp=S,e.$Wp=b,e.$Xp=y,e.$Yp=c,e.$Zp=O,e.$1p=w,e.$3p=i,e.$4p=n;function d(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,P.$Ff)(r.id,t.id)===0}const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new $(t.identifier,s,o)}static parse(t){const s=f.exec(t);return s&&s[1]&&s[2]?new $({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o=v.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof $?d(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Tp=$;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(r){const t=h.exec(r);return t&&t[1]?[b(t[1]),t[2]]:[b(r),void 0]}function S(r,t){return`${r}.${t}`}function b(r){return r.toLowerCase()}function y(r,t){return b(S(r??v.$tn,t))}function c(r,t){const s=[],o=l=>{for(const p of s)if(p.some(A=>d(t(A),t(l))))return p;return null};for(const l of r){const p=o(l);p?p.push(l):s.push([l])}return s}function O(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function w(r){return{id:new u.$Dp(r.identifier.id),name:new u.$Dp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$2p=new v.$xn("pprice.better-merge");function i(r,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(p=>!d(p.identifier,{id:l}))){const p=r.filter(A=>d(A.identifier,{id:l}));p.length===1&&(s.push(p[0]),o.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function a(r,t){if(!k.$n)return!1;let s;try{s=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,R.$bb)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,t){const s=await a(r,t),o=(0,I.$np)(s?"alpine":k.$x,m.$jc);return t.debug("ComputeTargetPlatform:",o),o}}),define(le[125],he([0,1,21,7,14,16,45,12,4,20,26,22]),function(Q,e,P,I,v,k,C,R,m,u,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;const $=S=>(0,m.localize)(1782,null,S),h=(0,m.localize)(1783,null,"ms-dotnettools.csharp");let g=class{constructor(b,y,c){this.a=b,this.b=y,this.d=c}get f(){}async listExtensions(b,y,c){let O=await this.b.getInstalled(f.ExtensionType.User,c);const w=f.$wn.map(a=>a.toLowerCase());if(y&&y!==""){if(w.indexOf(y.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}O=O.filter(a=>a.manifest.categories?a.manifest.categories.map(r=>r.toLowerCase()).indexOf(y.toLowerCase())>-1:!1)}else if(y===""){this.a.info("Possible Categories: "),w.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,m.localize)(1784,null,this.f)),O=O.sort((a,n)=>a.identifier.id.localeCompare(n.identifier.id));let i;for(const a of O)i!==a.identifier.id&&(i=a.identifier.id,this.a.info(b?`${i}@${a.manifest.version}`:i))}async installExtensions(b,y,c,O){const w=[];try{b.length&&this.a.info(this.f?(0,m.localize)(1785,null,this.f):(0,m.localize)(1786,null));const i=[],a=[],n=(t,s,o)=>{a.push({id:t,version:s!=="prerelease"?s:void 0,installOptions:{...c,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||c.installPreReleaseVersion}})};for(const t of b)if(t instanceof R.URI)i.push({vsix:t,installOptions:c});else{const[s,o]=(0,d.$Up)(t);n(s,o,!1)}for(const t of y)if(t instanceof R.URI)i.push({vsix:t,installOptions:{...c,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,d.$Up)(t);n(s,o,!0)}const r=await this.b.getInstalled(void 0,c.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:s})=>{try{await this.h(t,s,O,r)}catch(o){this.a.error(o),w.push(t.toString())}})),a.length){const t=await this.g(a,r,O);w.push(...t)}}catch(i){throw this.a.error((0,m.localize)(1787,null,(0,I.$bb)(i))),i}if(w.length)throw new Error((0,m.localize)(1788,null,w.join(", ")))}async updateExtensions(b){const y=await this.b.getInstalled(f.ExtensionType.User,b),c=[];for(const a of y)a.identifier.uuid&&c.push({...a.identifier,preRelease:a.preRelease});this.a.trace((0,m.localize)(1789,null,c.length));const O=await this.d.getExtensions(c,{compatible:!0},P.CancellationToken.None),w=[];for(const a of O)for(const n of y)(0,d.$Sp)(n.identifier,a.identifier)&&(0,C.gt)(a.version,n.manifest.version)&&w.push({extension:a,options:{operation:u.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:b,isApplicationScoped:n.isApplicationScoped}});if(!w.length){this.a.info((0,m.localize)(1790,null));return}this.a.info((0,m.localize)(1791,null,w.map(a=>a.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions(w);for(const a of i)a.error?this.a.error((0,m.localize)(1792,null,a.identifier.id,(0,I.$bb)(a.error))):this.a.info((0,m.localize)(1793,null,a.identifier.id,a.local?.manifest.version))}async g(b,y,c){if(b=b.filter(({id:a,version:n})=>{const r=y.find(t=>(0,d.$Sp)(t.identifier,{id:a}));if(r){if(!c&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,m.localize)(1794,null,a,r.manifest.version,a)),!1;if(n&&r.manifest.version===n)return this.a.info((0,m.localize)(1795,null,`${a}@${n}`)),!1}return!0}),!b.length)return[];const O=[],w=[],i=await this.j(b);if(await Promise.all(b.map(async({id:a,version:n,installOptions:r})=>{const t=i.get(a.toLowerCase());if(!t){this.a.error(`${$(n?`${a}@${n}`:a)}
${h}`),O.push(a);return}try{const o=await this.d.getManifest(t,P.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),O.push(a);return}const s=y.find(o=>(0,d.$Sp)(o.identifier,t.identifier));if(s){if(t.version===s.manifest.version){this.a.info((0,m.localize)(1796,null,n?`${a}@${n}`:a));return}this.a.info((0,m.localize)(1797,null,a,t.version))}r.isBuiltin?this.a.info(n?(0,m.localize)(1798,null,a,n):(0,m.localize)(1799,null,a)):this.a.info(n?(0,m.localize)(1800,null,a,n):(0,m.localize)(1801,null,a)),w.push({extension:t,options:{...r,installGivenVersion:!!n,isApplicationScoped:r.isApplicationScoped||s?.isApplicationScoped}})})),w.length){const a=await this.b.installGalleryExtensions(w);for(const n of a)n.error?(this.a.error((0,m.localize)(1802,null,n.identifier.id,(0,I.$bb)(n.error))),O.push(n.identifier.id)):this.a.info((0,m.localize)(1803,null,n.identifier.id,n.local?.manifest.version))}return O}async h(b,y,c,O){const w=await this.b.getManifest(b);if(!w)throw new Error("Invalid vsix");if(await this.l(w,c,y.profileLocation,O))try{await this.b.install(b,{...y,installGivenVersion:!0}),this.a.info((0,m.localize)(1804,null,(0,k.$ih)(b)))}catch(a){if((0,I.$8)(a))this.a.info((0,m.localize)(1805,null,(0,k.$ih)(b)));else throw a}}async j(b){const y=new Map,c=b.some(i=>i.installOptions.installPreReleaseVersion),O=await this.b.getTargetPlatform(),w=[];for(const i of b)u.$fp.test(i.id)&&w.push({...i,preRelease:c});if(w.length){const i=await this.d.getExtensions(w,{targetPlatform:O},P.CancellationToken.None);for(const a of i)y.set(a.identifier.id.toLowerCase(),a)}return y}k(b){return!0}async l(b,y,c,O){if(!y){const w={id:(0,d.$Xp)(b.publisher,b.name)},i=O.find(a=>(0,d.$Sp)(w,a.identifier)&&(0,C.gt)(a.manifest.version,b.version));if(i)return this.a.info((0,m.localize)(1806,null,i.identifier.id,i.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,y,c){const O=async i=>{if(i instanceof R.URI){const a=await this.b.getManifest(i);return(0,d.$Vp)(a.publisher,a.name)}return i},w=[];for(const i of b){const a=await O(i),r=(await this.b.getInstalled(void 0,c)).filter(t=>(0,d.$Sp)(t.identifier,{id:a}));if(!r.length)throw new Error(`${this.m(a)}
${h}`);if(r.some(t=>t.type===f.ExtensionType.System)){this.a.info((0,m.localize)(1807,null,a));return}if(!y&&r.some(t=>t.isBuiltin)){this.a.info((0,m.localize)(1808,null,a));return}this.a.info((0,m.localize)(1809,null,a));for(const t of r)await this.b.uninstall(t,{profileLocation:c}),w.push(t);this.f?this.a.info((0,m.localize)(1810,null,a,this.f)):this.a.info((0,m.localize)(1811,null,a))}}async locateExtension(b){const y=await this.b.getInstalled();b.forEach(c=>{y.forEach(O=>{if(O.identifier.id===c&&O.location.scheme===v.Schemas.file){this.a.info(O.location.fsPath);return}})})}m(b){return this.f?(0,m.localize)(1812,null,b,this.f):(0,m.localize)(1813,null,b)}};e.$Eq=g,e.$Eq=g=Ee([oe(1,u.$up),oe(2,u.$rp)],g)}),define(le[126],he([0,1,7,5,2,25,26,22,9]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class u extends v.$Zc{constructor(f,$,h,g,S,b,y){super(),this.f=f,this.g=$,this.h=h,this.j=g,this.m=S,this.n=b,this.r=y,this.a=this.B(new I.$qe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new v.$9c),this.s().then(null,c=>y.error("Error while initializing Extensions Watcher",(0,P.$bb)(c)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(f=>this.u(f.added))),this.B(this.j.onAddExtensions(f=>this.w(f))),this.B(this.j.onDidAddExtensions(f=>this.y(f))),this.B(this.j.onRemoveExtensions(f=>this.z(f))),this.B(this.j.onDidRemoveExtensions(f=>this.C(f))),this.B(this.n.onDidFilesChange(f=>this.D(f)))}async u(f){try{f.length&&await Promise.all(f.map($=>(this.c.set($.id,(0,v.$Wc)(this.n.watch(this.m.extUri.dirname($.extensionsResource)),this.n.watch($.extensionsResource))),this.G($.extensionsResource))))}catch($){throw this.r.error($),$}}async w(f){for(const $ of f.extensions)this.I(this.L($.identifier,$.version),f.profileLocation)}async y(f){for(const $ of f.extensions){const h=this.L($.identifier,$.version);f.error?this.J(h,f.profileLocation):this.I(h,f.profileLocation)}}async z(f){for(const $ of f.extensions)this.J(this.L($.identifier,$.version),f.profileLocation)}async C(f){const $=[],h=[];for(const g of f.extensions){const S=this.L(g.identifier,g.version);f.error?this.I(S,f.profileLocation):(this.J(S,f.profileLocation),this.b.has(S)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),h.push(this.f.scanInstalledExtensionAtLocation(g.location).then(b=>{b?$.push(b):this.r.info("Extension not found at the location",g.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(h),$.length&&await this.H($)}catch(g){this.r.error(g)}}D(f){for(const $ of this.h.profiles)f.contains($.extensionsResource,m.FileChangeType.UPDATED,m.FileChangeType.ADDED)&&this.F($.extensionsResource)}async F(f){const $=[],h=[],g=await this.j.scanProfileExtensions(f),S=new Set,b=new Set;for(const[y,c]of this.b)c.has(f)&&b.add(y);for(const y of g){const c=this.L(y.identifier,y.version);S.add(c),b.has(c)||($.push(y.identifier),this.I(c,f))}for(const y of b)if(!S.has(y)){const c=this.M(y);c&&(h.push(c.identifier),this.J(y,f))}($.length||h.length)&&this.a.fire({added:$.length?{extensions:$,profileLocation:f}:void 0,removed:h.length?{extensions:h,profileLocation:f}:void 0})}async G(f){const $=await this.j.scanProfileExtensions(f);for(const h of $)this.I(this.L(h.identifier,h.version),f)}async H(f){f||(f=(await this.f.scanAllUserInstalledExtensions()).filter(h=>!this.b.has(this.L(h.identifier,h.manifest.version)))),f.length&&await this.f.markAsUninstalled(...f)}I(f,$){let h=this.b.get(f);h||this.b.set(f,h=new k.$Gc(g=>this.m.extUri.getComparisonKey(g))),h.add($)}J(f,$){const h=this.b.get(f);h&&h.delete($),h?.size||this.b.delete(f)}L(f,$){return`${R.$xn.toKey(f.id)}@${$}`}M(f){const[$,h]=(0,C.$Up)(f);return h?{identifier:{id:$},version:h}:void 0}}e.$6q=u}),define(le[127],he([0,1,32,154,19,8,2,14,15,29,17,20,26,6,69,12]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0,P=be(P);let b=class extends g.$is{constructor(w,i,a,n){super(a),this.h=w,this.j=n,this.g=this.B(new y(i,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(w,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const r=n.translations[w];return r?S.URI.file(r):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),i=Object.keys(w).map(a=>{const n=w[a];return{...this.f(a,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((a,n)=>a.label.localeCompare(n.label)),i}async m(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",w.identifier.id),await this.update())}async n(w){const i=await this.g.getLanguagePacks();Object.keys(i).some(a=>i[a]&&i[a].extensions.some(n=>(0,$.$Sp)(n.extensionIdentifier,w.identifier)))&&(this.j.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),a=await this.g.update(i);return!(0,v.$yb)(Object.keys(w),Object.keys(a))}};e.$js=b,e.$js=b=Ee([oe(0,f.$up),oe(1,d.$Si),oe(2,f.$rp),oe(3,h.$fk)],b);let y=class extends C.$Zc{constructor(w,i){super(),this.j=i,this.c={},this.f=(0,m.$oc)(w.userDataPath,"languagepacks.json"),this.g=new k.$Rh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.s(i=>{Object.keys(i).forEach(a=>delete i[a]),this.m(i,...w)}).then(()=>this.c)}m(w,...i){for(const a of i)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.n(w,a);Object.keys(w).forEach(a=>this.r(w[a]))}n(w,i){const a=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const r of n)if(i.location.scheme===R.Schemas.file&&c(r)){let t=w[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},w[r.languageId]=t);const s=t.extensions.filter(o=>(0,$.$Sp)(o.extensionIdentifier,a))[0];s?s.version=i.manifest.version:t.extensions.push({extensionIdentifier:a,version:i.manifest.version});for(const o of r.translations)t.translations[o.id]=(0,m.$oc)(i.location.fsPath,o.path)}}r(w){if(w){const i=(0,I.createHash)("md5");for(const a of w.extensions)i.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);w.hash=i.digest("hex")}}s(w=()=>null){return this.g.queue(()=>{let i=null;return P.promises.readFile(this.f,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(i=w(a),a)).then(a=>{for(const r of Object.keys(a))a[r]||delete a[r];this.c=a,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),u.Promises.writeFile(this.f,n)}).then(()=>i,a=>this.j.error(a))})}};y=Ee([oe(0,d.$Si),oe(1,h.$fk)],y);function c(O){if(typeof O.languageId!="string"||!Array.isArray(O.translations)||O.translations.length===0)return!1;for(const w of O.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(O.languageName&&typeof O.languageName!="string"||O.localizedLanguageName&&typeof O.localizedLanguageName!="string")}}),define(le[128],he([0,1,58,7,27,11,41]),function(Q,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WR=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",m="https://mobile.events.data.microsoft.com/ping";async function u(f,$,h){k.$r;const g=await(0,P.$zq)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,P.$zq)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new g.AppInsightsCore,y=new S.PostChannel,c={instrumentationKey:f,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(h){c.extensionConfig={};const O={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};c.extensionConfig[y.identifier]=O}return b.initialize(c,[]),b.addTelemetryInitializer(O=>{O.ext=O.ext??{},O.ext.web=O.ext.web??{},O.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',$&&(O.ext.utc=O.ext.utc??{},O.ext.utc.flags=8462029)}),b}class d{constructor($,h,g,S,b){this.e=$,this.f=h,this.g=g,this.h=b,this.c=R,this.d=m,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i($){if(this.a){if(typeof this.a!="string"){$(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(h=>{$(h)},h=>{(0,I.$4)(h),console.error(h)})}}log($,h){if(!this.a)return;h=(0,v.$no)(h,this.g),h=(0,C.$Np)(h);const g=this.f+"/"+$;try{this.i(S=>{S.pluginVersionString=h?.properties.version??"Unknown",S.track({name:g,baseData:{name:g,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise($=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,$(void 0)})})}):Promise.resolve(void 0)}}e.$WR=d});var ze=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(le[129],he([0,1,2,27,11,31,4,30,40,130,33,37,18,41]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0,u=ze(u);let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(y,c,O){this.k=c,this.l=O,this.d={},this.i=new P.$Yc,this.j=[],this.b=y.appenders,this.c=y.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=y.piiPaths||[],this.g=$.TelemetryLevel.USAGE,this.h=!!y.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,k.$mf)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$mf)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration($.$nm)||w.affectsConfiguration($.$pm)||w.affectsConfiguration($.$om))&&this.m()}))}setExperimentProperty(y,c){this.d[y]=c}m(){let y=(0,h.$Mp)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const O=c.usage?$.TelemetryLevel.USAGE:c.error?$.TelemetryLevel.ERROR:$.TelemetryLevel.NONE;y=Math.min(y,O)}this.g=y}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(y,c,O){this.g<c||(O=(0,I.$no)(O,this.d),O=(0,h.$Rp)(O,this.j),O=(0,I.$no)(O,this.c),this.b.forEach(w=>w.log(y,O)))}publicLog(y,c){this.n(y,$.TelemetryLevel.USAGE,c)}publicLog2(y,c){this.publicLog(y,c)}publicLogError(y,c){this.h&&this.n(y,$.TelemetryLevel.ERROR,c)}publicLogError2(y,c){this.publicLogError(y,c)}};e.$ps=g,e.$ps=g=Ee([oe(1,R.$ej),oe(2,d.$yk)],g);function S(){const b=(0,C.localize)(2068,null,u.default.nameLong),y=u.default.privacyStatementUrl?(0,C.localize)(2070,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,C.localize)(2069,null,"https://aka.ms/vscode-telemetry"),c=v.$r?"":(0,C.localize)(2071,null),O=(0,C.localize)(2072,null),w=(0,C.localize)(2073,null),i=(0,C.localize)(2074,null),a=(0,C.localize)(2075,null),n=`
|       | ${O} | ${w} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(2076,null);return`
${b} ${y} ${c}

&nbsp;

${a}
${n}

&nbsp;

${r}
`}f.$xo.as(m.$Co.Configuration).registerConfiguration({id:$.$mm,order:1,type:"object",title:(0,C.localize)(2077,null),properties:{[$.$nm]:{type:"string",enum:[$.TelemetryConfiguration.ON,$.TelemetryConfiguration.ERROR,$.TelemetryConfiguration.CRASH,$.TelemetryConfiguration.OFF],enumDescriptions:[(0,C.localize)(2078,null),(0,C.localize)(2079,null),(0,C.localize)(2080,null),(0,C.localize)(2081,null)],markdownDescription:S(),default:$.TelemetryConfiguration.ON,restricted:!0,scope:m.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),f.$xo.as(m.$Co.Configuration).registerConfiguration({id:$.$mm,order:110,type:"object",title:(0,C.localize)(2082,null),properties:{[$.$pm]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,C.localize)(2084,null,u.default.nameLong,u.default.privacyStatementUrl):(0,C.localize)(2083,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(2085,null,`\`#${$.$nm}#\``),scope:m.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[131],he([0,1,13,21,155,128]),function(Q,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XR=void 0,v=be(v);async function C(d,f){const $=await f.request(d,I.CancellationToken.None),h=(await(0,P.$5e)($.stream)).toString(),g=$.res.statusCode??200;return{headers:$.res.headers,statusCode:g,responseData:h}}async function R(d){const f={method:d.type,headers:d.headers};return new Promise((h,g)=>{const S=v.request(d.url??"",f,b=>{b.on("data",function(y){h({headers:b.headers,statusCode:b.statusCode??200,responseData:y.toString()})}),b.on("error",function(y){g(y)})});S.write(d.data,b=>{b&&g(b)}),S.end()})}async function m(d,f,$){const h=typeof f.data=="string"?f.data:new TextDecoder().decode(f.data),g={type:"POST",headers:{...f.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(f.data).toString()},url:f.urlString,data:h};try{const S=d?await C(g,d):await R(g);$(S.statusCode,S.headers,S.responseData)}catch{$(0,{})}}class u extends k.$WR{constructor(f,$,h,g,S){const b={sendPOST:(y,c)=>{m(f,y,c)}};super($,h,g,S,b)}}e.$XR=u}),define(le[132],he([0,1,32,15,29]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=k,P=be(P);async function k(C,R){const m=Object.create(null),u=(f,$)=>{const h=JSON.parse(f);m[$]=h};if(R){const f=[],$=await v.Promises.readdir(R);for(const g of $)try{(await P.promises.stat((0,I.$oc)(R,g))).isDirectory()&&f.push(g)}catch{}const h=[];for(const g of f)(await v.Promises.readdir((0,I.$oc)(R,g))).filter(b=>b==="telemetry.json").length===1&&h.push(g);for(const g of h){const S=(await P.promises.readFile((0,I.$oc)(R,g,"telemetry.json"))).toString();u(S,g)}}let d=(await P.promises.readFile((0,I.$oc)(C,"telemetry-core.json"))).toString();return u(d,"vscode-core"),d=(await P.promises.readFile((0,I.$oc)(C,"telemetry-extensions.json"))).toString(),u(d,"vscode-extensions"),JSON.stringify(m,null,4)}}),define(le[133],he([0,1,11,87,18]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=k,e.$Lic=C,e.$Mic=R;async function k(m,u){let d=m.getItem(v.$jm);return(typeof d!="string"||P.$m&&d==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(d=await(0,I.$Zn)(u.error.bind(u))),d}async function C(m,u){let d=m.getItem(v.$km);return typeof d!="string"&&(d=await(0,I.$1n)(u.error.bind(u))),d}async function R(m,u){let d=m.getItem(v.$lm);return typeof d!="string"&&(d=await(0,I.$2n)(u.error.bind(u))),d}}),define(le[23],he([0,1,10]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,P.$Ki)("IUriIdentityService")}),define(le[134],he([0,1,23,99,9,16,81,5,2]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0;class u{static{this._clock=0}constructor($){this.uri=$,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let d=class{constructor($){this.g=$,this.c=new m.$Yc,this.f=2**16;const h=new Map,g=S=>{let b=h.get(S.scheme);return b===void 0&&(b=$.hasProvider(S)&&!this.g.hasCapability(S,v.FileSystemProviderCapabilities.PathCaseSensitive),h.set(S.scheme,b)),b};this.c.add(R.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(S=>{h.delete(S.scheme)})),this.extUri=new k.$ah(g),this.d=new C.$2s((S,b)=>this.extUri.compare(S,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,k.$mh)($));const h=this.d.get($);return h?h.touch().uri.with({fragment:$.fragment}):(this.d.set($,new u($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((g,S)=>g[1].time<S[1].time?1:g[1].time>S[1].time?-1:0);u._clock=0,this.d.clear();const h=this.f*.5;for(let g=0;g<h;g++)this.d.set($[g][0],$[g][1].touch())}};e.$3s=d,e.$3s=d=Ee([oe(0,v.$fl)],d),(0,I.$Zs)(P.$Pl,d,I.InstantiationType.Delayed)}),define(le[135],he([0,1,5,2,9,49,25]),function(Q,e,P,I,v,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=void 0;class R extends I.$Zc{constructor(u,d,f,$,h,g){super(),this.f=u,this.g=d,this.h=f,this.j=$,this.m=h,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$qe),this.onDidChangeFile=this.a.event,this.b=k.$Qi.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new C.$Gc(S=>this.m.extUri.getComparisonKey(this.t(S))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(S=>this.s(S)))}r(){this.c.clear();for(const u of this.j.profiles)this.c.add(u.settingsResource),this.c.add(u.keybindingsResource),this.c.add(u.tasksResource),this.c.add(u.extensionsResource)}open(u,d){return this.g.open(this.t(u),d)}close(u){return this.g.close(u)}read(u,d,f,$,h){return this.g.read(u,d,f,$,h)}write(u,d,f,$,h){return this.g.write(u,d,f,$,h)}watch(u,d){this.b.set(u,u);const f=this.g.watch(this.t(u),d);return(0,I.$Xc)(()=>{this.b.delete(u),f.dispose()})}stat(u){return this.g.stat(this.t(u))}mkdir(u){return this.g.mkdir(this.t(u))}rename(u,d,f){return this.g.rename(this.t(u),this.t(d),f)}readFile(u,d){return this.g.readFile(this.t(u),d)}readFileStream(u,d,f){return this.g.readFileStream(this.t(u),d,f)}readdir(u){return this.g.readdir(this.t(u))}enforceAtomicReadFile(u){return this.c.has(u)}writeFile(u,d,f){return this.g.writeFile(this.t(u),d,f)}enforceAtomicWriteFile(u){return this.c.has(u)?{postfix:".vsctmp"}:!1}delete(u,d){return this.g.delete(this.t(u),d)}copy(u,d,f){if((0,v.$jl)(this.g))return this.g.copy(this.t(u),this.t(d),f);throw new Error("copy not supported")}cloneFile(u,d){if((0,v.$kl)(this.g))return this.g.cloneFile(this.t(u),this.t(d));throw new Error("clone not supported")}s(u){const d=[];for(const f of u){if(f.resource.scheme!==this.f)continue;const $=this.u(f.resource);this.b.findSubstr($)&&d.push({resource:$,type:f.type,cId:f.cId})}d.length&&(this.n.debug("User data changed"),this.a.fire(d))}t(u){return u.with({scheme:this.f})}u(u){return u.with({scheme:this.h})}}e.$$ic=R}),define(le[136],he([0,1,4,15,49,16,12,10,14]),function(Q,e,P,I,v,k,C,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=u,e.$Vi=d,e.$Yi=f,e.$Zi=$,e.$1i=h,e.$2i=S,e.$3i=b,e.$6i=O,e.$$i=w,e.$_i=i,e.$bj=a,e.$cj=n,e.$dj=r,e.$Ti=(0,R.$Ki)("contextService");function u(t){const s=t;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}function d(t){return typeof t?.id=="string"&&!u(t)&&!$(t)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function f(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,I.$sc)(t)}:s?e.$Wi:e.$Xi;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function $(t){const s=t;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}function h(t){const s=t;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var g;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function S(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function b(t){const s=t;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class y{constructor(s,o,l,p,A){this.h=s,this.j=l,this.k=p,this.l=A,this.c=v.$Qi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=v.$Qi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=y;class c{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,k.$lh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=c;function O(t){return new c({uri:t,index:0,name:(0,k.$hh)(t)},{uri:t.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,P.localize)(2489,null),extensions:[e.$7i]}],e.$0i="workspace.json";function w(t,s){return k.$ch.isEqualOrParent(t,s.untitledWorkspacesHome)}function i(t){let s;return C.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===m.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(t){return t.id===e.$aj}function n(t,s){return!w(t,s)&&!i(t)}function r(t){return(typeof t=="string"?(0,I.$tc)(t):(0,k.$jh)(t))===e.$8i}}),define(le[24],he([0,1,43,5,2,16,12,4,17,9,10,6,136,25,23,8,28,31,3]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=w,e.$Sl=i,e.$Tl=a;var O;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(O||(e.ProfileResourceType=O={}));function w(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&C.URI.isUri(s.location)&&C.URI.isUri(s.globalStorageHome)&&C.URI.isUri(s.settingsResource)&&C.URI.isUri(s.keybindingsResource)&&C.URI.isUri(s.tasksResource)&&C.URI.isUri(s.snippetsHome)&&C.URI.isUri(s.extensionsResource))}e.$Rl=(0,d.$Ki)("IUserDataProfilesService");function i(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:s}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function a(t,s,o,l,p,A){return{id:t,name:s,location:o,isDefault:!1,shortName:p?.shortName,icon:p?.icon,globalStorageHome:A&&p?.useDefaultFlags?.globalState?A.globalStorageHome:(0,k.$lh)(o,"globalStorage"),settingsResource:A&&p?.useDefaultFlags?.settings?A.settingsResource:(0,k.$lh)(o,"settings.json"),keybindingsResource:A&&p?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,k.$lh)(o,"keybindings.json"),tasksResource:A&&p?.useDefaultFlags?.tasks?A.tasksResource:(0,k.$lh)(o,"tasks.json"),snippetsHome:A&&p?.useDefaultFlags?.snippets?A.snippetsHome:(0,k.$lh)(o,"snippets"),extensionsResource:A&&p?.useDefaultFlags?.extensions?A.extensionsResource:(0,k.$lh)(o,"extensions.json"),cacheHome:(0,k.$lh)(l,t),useDefaultFlags:p?.useDefaultFlags,isTransient:p?.transient}}let n=class extends v.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,p){super(),this.t=s,this.u=o,this.w=l,this.y=p,this.f=!0,this.h=this.B(new I.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new I.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new I.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new I.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new h.$Fc,workspaces:new h.$Fc,emptyWindows:new Map},this.profilesHome=(0,k.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const A of this.O()){if(!A.name||!(0,c.$jg)(A.name)||!A.location){this.y.warn("Skipping the invalid stored profile",A.location||A.name);continue}o.push(a((0,k.$ih)(A.location),A.name,A.location,this.g,{shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags},s))}}catch(A){this.y.error(A)}const l=new h.$Fc,p=new Map;if(o.length)try{const A=this.Q();if(A.workspaces)for(const[T,N]of Object.entries(A.workspaces)){const D=C.URI.parse(T),j=o.find(x=>x.id===N);j&&l.set(D,j)}if(A.emptyWindows)for(const[T,N]of Object.entries(A.emptyWindows)){const D=o.find(j=>j.id===N);D&&p.set(T,D)}}catch(A){this.y.error(A)}this.z={profiles:o,workspaces:l,emptyWindows:p}}return this.z}D(){const s=a("__default__profile__",(0,R.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,y.$mf)(o)}\\s(\\d+)`);let p=0;for(const T of this.profiles){const N=l.exec(T.name),D=N?parseInt(N[1]):0;p=D>p?D:p}const A=`${o} ${p+1}`;return this.createProfile((0,P.$yj)((0,b.$7g)()).toString(16),A,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,P.$yj)((0,b.$7g)()).toString(16),s,o,l)}async createProfile(s,o,l,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.F(s,o,l);return p&&await this.setProfileForWorkspace(p,A),A}async F(s,o,l){if(!(0,c.$jg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let p=this.r.get(o);return p||(p=(async()=>{try{if(this.profiles.find(D=>D.name===o||D.id===s))throw new Error(`Profile with ${o} name already exists`);const T=a(s,o,(0,k.$lh)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(T.location);const N=[];return this.j.fire({profile:T,join(D){N.push(D)}}),await S.Promises.settled(N),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,p)),p}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(p=>p.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=a(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(p=>p.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(p){l.push(p)}});try{await Promise.allSettled(l)}catch(p){this.y.error(p)}for(const p of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(p)?.id&&this.C.emptyWindows.delete(p);for(const p of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(p)?.id&&this.C.workspaces.delete(p);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(p){(0,u.$wl)(p)!==u.FileOperationResult.FILE_NOT_FOUND&&this.y.error(p)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(p=>p.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),l=C.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return l||((0,$.$Ui)(s)?this.s.folders.get(s.uri):(0,$.$Zi)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,$.$Ui)(s)?s.uri:(0,$.$Zi)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const p=[...this.profiles,...s],A=[],T=this.s.profiles;this.s.profiles=[];for(let N of p){if(N.isDefault||o.some(j=>N.id===j.id))continue;N=l.find(j=>N.id===j.id)??N;const D=T.find(j=>N.id===j.id);if(N.isTransient)this.s.profiles.push(N);else{if(D){for(const[j,x]of this.s.emptyWindows.entries())if(N.id===x.id){this.L({id:j},N);break}for(const[j,x]of this.s.workspaces.entries())if(N.id===x.id){this.L({id:"",configPath:j},N);break}for(const[j,x]of this.s.folders.entries())if(N.id===x.id){this.L({id:"",uri:j},N);break}}A.push({location:N.location,name:N.name,shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags})}}this.P(A),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){if(l=o?.isTransient?!0:l,l)(0,$.$Ui)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,$.$Zi)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const p=this.G(s);C.URI.isUri(p)?(this.C.workspaces.delete(p),o&&this.C.workspaces.set(p,o)):(this.C.emptyWindows.delete(p),o&&this.C.emptyWindows.set(p,o)),this.M()}}M(){const s={};for(const[l,p]of this.C.workspaces.entries())s[l.toString()]=p.id;const o={};for(const[l,p]of this.C.emptyWindows.entries())o[l.toString()]=p.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[A,T]of Object.entries(s.workspaces)){const N=C.URI.parse(T);o[A]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}const p={};if(s.emptyWindows)for(const[A,T]of Object.entries(s.emptyWindows)){const N=C.URI.parse(T);p[A]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}return{workspaces:o,emptyWindows:p}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Ul=n,e.$Ul=n=Ee([oe(0,m.$Ri),oe(1,u.$fl),oe(2,g.$Pl),oe(3,f.$fk)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Vl=r}),define(le[53],he([0,1,19,8,21,7,5,2,25,11,3,12,4,20,26,22,44,6,33,18,23,24]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c,O,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=void 0,e.$Oq=n,$=be($);let a=class extends R.$Zc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(o,l,p,A,T,N){super(),this.z=o,this.C=l,this.D=p,this.F=A,this.G=T,this.H=N,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new C.$qe),this.s=this.B(new C.$qe),this.t=this.B(new C.$qe),this.u=this.B(new C.$qe),this.w=this.B(new C.$qe),this.y=[],this.B((0,R.$Xc)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.m.forEach(D=>D.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(o){const l=await this.getTargetPlatform();return o.allTargetPlatforms.some(p=>(0,h.$pp)(p,o.allTargetPlatforms,l))}async installFromGallery(o,l={}){try{const A=(await this.installGalleryExtensions([{extension:o,options:l}])).find(({identifier:T})=>(0,g.$Sp)(T,o.identifier));if(A?.local)return A?.local;throw A?.error?A.error:new h.$tp(`Unknown error while installing extension ${o.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(p){throw n(p)}}async installGalleryExtensions(o){if(!this.z.isEnabled())throw new h.$tp($.localize(1767,null),h.ExtensionManagementErrorCode.NotAllowed);const l=[],p=[];return await Promise.allSettled(o.map(async({extension:A,options:T})=>{try{const N=await this.N(A,!!T?.installGivenVersion,!!T?.installPreReleaseVersion,T.productVersion??{version:this.G.version,date:this.G.date});p.push({...N,options:T})}catch(N){l.push({identifier:A.identifier,operation:h.InstallOperation.Install,source:A,error:N,profileLocation:T.profileLocation??this.W()})}})),p.length&&l.push(...await this.I(p)),l}async uninstall(o,l){return this.F.trace("ExtensionManagementService#uninstall",o.identifier.id),this.uninstallExtensions([{extension:o,options:l}])}async toggleAppliationScope(o,l){if((0,S.$An)(o.manifest)||o.isBuiltin)return o;if(o.isApplicationScoped){let p=await this.updateMetadata(o,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(l,this.H.defaultProfile.extensionsResource)||(p=await this.Z(o,this.H.defaultProfile.extensionsResource,l));for(const A of this.H.profiles){const T=(await this.getInstalled(S.ExtensionType.User,A.extensionsResource)).find(N=>(0,g.$Sp)(N.identifier,o.identifier));T?this.w.fire({local:T,profileLocation:A.extensionsResource}):this.u.fire({identifier:o.identifier,profileLocation:A.extensionsResource})}return p}else{const p=this.D.extUri.isEqual(l,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(o,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(o,l,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:p.identifier,operation:h.InstallOperation.Install,local:p,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),p}}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.g||o-this.h>1e3*60*5)&&(this.g=this.U(),this.h=o),this.g}registerParticipant(o){this.y.push(o)}async resetPinnedStateForAllUserExtensions(o){try{await this.L(this.H.profiles.map(async l=>{const p=await this.getInstalled(S.ExtensionType.User,l.extensionsResource);await this.L(p.map(async A=>{A.pinned!==o&&await this.updateMetadata(A,{pinned:o},l.extensionsResource)}))}))}catch(l){throw this.F.error("Error while resetting pinned state for all user extensions",(0,k.$bb)(l)),l}}async I(o){const l=new Map,p=new Map,A=[],T=(D,j)=>`${g.$Tp.create(D).toString()}-${j.toString()}`,N=(D,j,x,Y)=>{const ne=this.X(D,j,x),ae=`${(0,g.$Xp)(D.publisher,D.name)}-${x.profileLocation.toString()}`;p.set(ae,{task:ne,root:Y}),this.n.fire({identifier:ne.identifier,source:j,profileLocation:x.profileLocation}),this.F.info("Installing extension:",ne.identifier.id,x),f.URI.isUri(j)||this.j.set(T(j,x.profileLocation),{task:ne,waitingTasks:[]})};try{for(const{manifest:D,extension:j,options:x}of o){const Y=x.isApplicationScoped||x.isBuiltin||(0,S.$An)(D),ne={...x,installOnlyNewlyAddedFromExtensionPack:x.installOnlyNewlyAddedFromExtensionPack??!f.URI.isUri(j),isApplicationScoped:Y,profileLocation:Y?this.H.defaultProfile.extensionsResource:x.profileLocation??this.W(),productVersion:x.productVersion??{version:this.G.version,date:this.G.date}},ae=f.URI.isUri(j)?void 0:this.j.get(T(j,ne.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,ne.profileLocation.toString()),A.push(ae.task.waitUntilTaskIsFinished())):N(D,j,ne,void 0)}return await Promise.all([...p.values()].map(async({task:D})=>{if(D.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",D.identifier.id);else try{const j=await this.M(D.identifier,D.manifest,!!D.options.installOnlyNewlyAddedFromExtensionPack,!!D.options.installPreReleaseVersion,D.options.profileLocation,D.options.productVersion),x=await this.getInstalled(void 0,D.options.profileLocation,D.options.productVersion),Y={...D.options,context:{...D.options.context,[h.$jp]:!0}};for(const{gallery:ne,manifest:ae}of(0,P.$Qb)(j,({gallery:ue})=>ue.identifier.id)){if(p.has(`${ne.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const ue=this.j.get(T(ne,Y.profileLocation));if(ue){if(this.J(D,ue.task)){const me=ue.task.identifier;this.F.info("Waiting for already requested installing extension",me.id,D.identifier.id,Y.profileLocation.toString()),ue.waitingTasks.push(D),A.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,W=>W.some(_=>(0,g.$Sp)(_.identifier,me)))).then(W=>{if(this.F.info("Finished waiting for already requested installing extension",me.id,D.identifier.id,Y.profileLocation.toString()),!W.find(M=>(0,g.$Sp)(M.identifier,me))?.local)throw new Error(`Extension ${me.id} is not installed`)}))}}else x.some(({identifier:me})=>(0,g.$Sp)(me,ne.identifier))||N(ae,ne,Y,D)}}catch(j){if(f.URI.isUri(D.source))(0,P.$Pb)(D.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",D.identifier.id,j.message),(0,P.$Pb)(D.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",D.identifier.id,j.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",D.identifier.id),j}})),await this.L([...p.entries()].map(async([D,{task:j}])=>{const x=new Date().getTime();let Y;try{Y=await j.run(),await this.L(this.y.map(ne=>ne.postInstall(Y,j.source,j.options,v.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(ne){const ae=n(ne);throw f.URI.isUri(j.source)||r(this.C,j.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.$1p)(j.source),error:ae,source:j.options.context?.[h.$ip]}),l.set(D,{error:ae,identifier:j.identifier,operation:j.operation,source:j.source,context:j.options.context,profileLocation:j.options.profileLocation,applicationScoped:j.options.isApplicationScoped}),this.F.error("Error while installing the extension",j.identifier.id,(0,k.$bb)(ae),j.options.profileLocation.toString()),ae}if(!f.URI.isUri(j.source)){const ne=j.operation===h.InstallOperation.Update,ae=ne?void 0:(new Date().getTime()-j.source.lastUpdated)/1e3;if(r(this.C,ne?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.$1p)(j.source),verificationStatus:j.verificationStatus,duration:new Date().getTime()-x,durationSinceUpdate:ae,source:j.options.context?.[h.$ip]}),u.$r&&j.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,h.StatisticType.Install)}catch{}}l.set(D,{local:Y,identifier:j.identifier,operation:j.operation,source:j.source,context:j.options.context,profileLocation:j.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),A.length&&await this.L(A),[...l.values()]}catch(D){const j=(ne,ae,ue)=>{const me=[];ne.manifest.extensionDependencies?.length&&me.push(...ne.manifest.extensionDependencies),ne.manifest.extensionPack?.length&&me.push(...ne.manifest.extensionPack);for(const W of me){if(ue.includes(W.toLowerCase()))continue;ue.push(W.toLowerCase());const _=l.get(`${W.toLowerCase()}-${ae.toString()}`);_?.local&&(ue=j(_.local,ae,ue))}return ue},x=ne=>({identifier:ne.identifier,operation:h.InstallOperation.Install,source:ne.source,context:ne.options.context,profileLocation:ne.options.profileLocation,error:D}),Y=[];for(const[ne,{task:ae,root:ue}]of p){const me=l.get(ne);me?me.local&&ue&&!l.get(`${ue.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(Y.push(this.Y(me.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),l.set(ne,x(ae))):(ae.cancel(),l.set(ne,x(ae)))}for(const[ne,{task:ae}]of p){const ue=l.get(ne);if(!ue?.local||ae.options.donotIncludePackAndDependencies)continue;j(ue.local,ae.options.profileLocation,[ue.local.identifier.id.toLowerCase()]).slice(1).some(W=>p.has(`${W.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!l.get(`${W.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(Y.push(this.Y(ue.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),l.set(ne,x(ae)))}throw Y.length&&await Promise.allSettled(Y.map(async ne=>{try{await ne.run(),this.F.info("Rollback: Uninstalled extension",ne.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",ne.extension.identifier.id,(0,k.$bb)(ae))}})),D}finally{for(const{task:D}of p.values())D.source&&!f.URI.isUri(D.source)&&this.j.delete(T(D.source,D.options.profileLocation));if(l.size){const D=[...l.values()];for(const j of D)j.local&&this.F.info("Extension installed successfully:",j.identifier.id,j.profileLocation.toString());this.s.fire(D)}}}J(o,l){for(const[,{task:p,waitingTasks:A}]of this.j.entries())if(p===o&&(A.includes(l)||A.some(T=>this.J(T,l)))||p===l&&A[0]&&!this.J(o,A[0]))return!1;return!0}async L(o,l){const p=[],A=[],T=await Promise.allSettled(o);for(const D of T)D.status==="fulfilled"?p.push(D.value):A.push(n(D.reason,l));if(!A.length)return p;if(A.length===1)throw A[0];let N=new h.$tp("",h.ExtensionManagementErrorCode.Unknown);for(const D of A)N=new h.$tp(N.message?`${N.message}, ${D.message}`:D.message,D.code!==h.ExtensionManagementErrorCode.Unknown&&D.code!==h.ExtensionManagementErrorCode.Internal?D.code:N.code);throw N}async M(o,l,p,A,T,N){if(!this.z.isEnabled())return[];const D=await this.getInstalled(void 0,T,N),j=[],x=[],Y=async(ne,ae)=>{j.push(ne);const ue=ae.extensionDependencies||[],me=[...ue];if(ae.extensionPack){const W=p?D.find(_=>(0,g.$Sp)(_.identifier,ne)):void 0;for(const _ of ae.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(M=>(0,g.$Sp)({id:M},{id:_}))||me.every(M=>!(0,g.$Sp)({id:M},{id:_}))&&me.push(_)}if(me.length){const W=me.filter(_=>j.every(M=>!(0,g.$Sp)(M,{id:_})));if(W.length){const _=await this.z.getExtensions(W.map(M=>({id:M,preRelease:A})),v.CancellationToken.None);for(const M of _){if(j.find(K=>(0,g.$Sp)(K,M.identifier)))continue;const U=ue.some(K=>(0,g.$Sp)({id:K},M.identifier));let H;try{H=await this.N(M,!1,A,N)}catch(K){if(U)throw K;this.F.info("Skipping the packed extension as it cannot be installed",M.identifier.id,(0,k.$bb)(K));continue}x.push({gallery:H.extension,manifest:H.manifest}),await Y(H.extension.identifier,H.manifest)}}}};return await Y(o,l),x}async N(o,l,p,A){let T;const N=await this.getExtensionsControlManifest();if(N.malicious.some(x=>(0,g.$Sp)(o.identifier,x)))throw new h.$tp($.localize(1768,null,o.identifier.id),h.ExtensionManagementErrorCode.Malicious);const D=N.deprecated[o.identifier.id.toLowerCase()];if(D?.extension?.autoMigrate){if(this.F.info(`The '${o.identifier.id}' extension is deprecated, fetching the compatible '${D.extension.id}' extension instead.`),T=(await this.z.getExtensions([{id:D.extension.id,preRelease:D.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:A},v.CancellationToken.None))[0],!T)throw new h.$tp($.localize(1769,null,o.identifier.id,D.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(o)){const x=await this.getTargetPlatform();throw new h.$tp($.localize(1770,null,o.identifier.id,this.G.nameLong,(0,h.$lp)(x)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(T=await this.O(o,l,p,A),!T){const x=[];throw(0,b.$aq)(o.properties.enabledApiProposals??[],x)?!p&&o.properties.isPreReleaseVersion&&(await this.z.getExtensions([o.identifier],v.CancellationToken.None))[0]?new h.$tp($.localize(1772,null,o.displayName??o.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$tp($.localize(1773,null,o.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible):new h.$tp($.localize(1771,null,o.displayName??o.identifier.id,x[0]),h.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",T.identifier.id);const j=await this.z.getManifest(T,v.CancellationToken.None);if(j===null)throw new h.$tp(`Missing manifest for extension ${T.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(j.version!==T.version)throw new h.$tp(`Cannot install '${T.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:T,manifest:j}}async O(o,l,p,A){const T=await this.getTargetPlatform();let N=null;return!l&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==p&&(N=(await this.z.getExtensions([{...o.identifier,preRelease:p}],{targetPlatform:T,compatible:!0,productVersion:A},v.CancellationToken.None))[0]||null),!N&&await this.z.isExtensionCompatible(o,p,T,A)&&(N=o),N||(l?N=(await this.z.getExtensions([{...o.identifier,version:o.version}],{targetPlatform:T,compatible:!0,productVersion:A},v.CancellationToken.None))[0]||null:N=await this.z.getCompatibleExtension(o,p,T,A)),N}async uninstallExtensions(o){const l=(x,Y)=>`${x.identifier.id.toLowerCase()}${Y.versionOnly?`-${x.manifest.version}`:""}@${Y.profileLocation.toString()}`,p=(x,Y)=>{const ne=this.Y(x,Y);return this.m.set(l(ne.extension,Y),ne),this.F.info("Uninstalling extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,Y.profileLocation.toString()),this.t.fire({identifier:x.identifier,profileLocation:Y.profileLocation,applicationScoped:x.isApplicationScoped}),ne},A=(x,Y,ne)=>{ne?this.F.error("Failed to uninstall extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,Y.profileLocation.toString(),ne.message):this.F.info("Successfully uninstalled extension from the profile",`${x.identifier.id}@${x.manifest.version}`,Y.profileLocation.toString()),r(this.C,"extensionGallery:uninstall",{extensionData:(0,g.$Zp)(x),error:ne}),this.u.fire({identifier:x.identifier,error:ne?.code,profileLocation:Y.profileLocation,applicationScoped:x.isApplicationScoped})},T=[],N=[],D=[],j=new m.$Fc;for(const{extension:x,options:Y}of o){const ne={...Y,profileLocation:x.isApplicationScoped?this.H.defaultProfile.extensionsResource:Y?.profileLocation??this.W()},ae=this.m.get(l(x,ne));ae?(this.F.info("Extensions is already requested to uninstall",x.identifier.id),D.push(ae.waitUntilTaskIsFinished())):T.push(p(x,ne))}try{for(const x of T.slice(0)){let Y=j.get(x.options.profileLocation);if(Y||j.set(x.options.profileLocation,Y=await this.getInstalled(S.ExtensionType.User,x.options.profileLocation)),x.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${x.extension.identifier.id}@${x.extension.manifest.version}`);else{const ne=this.R(x.extension,Y);for(const ae of ne)this.m.has(l(ae,x.options))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):T.push(p(ae,x.options))}x.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${x.extension.identifier.id}@${x.extension.manifest.version}`):this.P(T.map(ne=>ne.extension),Y,x.extension)}await this.L(T.map(async x=>{try{if(await x.run(),await this.L(this.y.map(Y=>Y.postUninstall(x.extension,x.options,v.CancellationToken.None))),x.extension.identifier.uuid)try{await this.z.reportStatistic(x.extension.manifest.publisher,x.extension.manifest.name,x.extension.manifest.version,h.StatisticType.Uninstall)}catch{}}catch(Y){const ne=n(Y);throw A(x.extension,x.options,ne),ne}finally{N.push(x)}})),D.length&&await this.L(D);for(const x of T)A(x.extension,x.options)}catch(x){const Y=n(x);for(const ne of T){try{ne.cancel()}catch{}N.includes(ne)||A(ne.extension,ne.options,Y)}throw Y}finally{for(const x of T)this.m.delete(l(x.extension,x.options))||this.F.warn("Uninstallation task is not found in the cache",x.extension.identifier.id)}}P(o,l,p){for(const A of o){const T=this.S(A,l);if(T.length){const N=T.filter(D=>!o.some(j=>(0,g.$Sp)(j.identifier,D.identifier)));if(N.length)throw new Error(this.Q(A,N,p))}}}Q(o,l,p){return p===o?l.length===1?$.localize(1774,null,p.manifest.displayName||p.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?$.localize(1775,null,p.manifest.displayName||p.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):$.localize(1776,null,p.manifest.displayName||p.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):l.length===1?$.localize(1777,null,p.manifest.displayName||p.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?$.localize(1778,null,p.manifest.displayName||p.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):$.localize(1779,null,p.manifest.displayName||p.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name)}R(o,l,p=[]){if(p.indexOf(o)!==-1)return[];p.push(o);const A=o.manifest.extensionPack?o.manifest.extensionPack:[];if(A.length){const T=l.filter(D=>!D.isBuiltin&&A.some(j=>(0,g.$Sp)({id:j},D.identifier))),N=[];for(const D of T)N.push(...this.R(D,l,p));return[...T,...N]}return[]}S(o,l){return l.filter(p=>p.manifest.extensionDependencies&&p.manifest.extensionDependencies.some(A=>(0,g.$Sp)({id:A},o.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(o){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$bb)(o)),{malicious:[],deprecated:{},search:[]}}}};e.$Nq=a,e.$Nq=a=Ee([oe(0,h.$rp),oe(1,O.$em),oe(2,w.$Pl),oe(3,y.$fk),oe(4,c.$yk),oe(5,i.$Rl)],a);function n(s,o){if(s instanceof h.$tp)return s;let l;return s instanceof h.$sp?l=new h.$tp(s.message,s.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):l=new h.$tp(s.message,(0,k.$8)(s)?h.ExtensionManagementErrorCode.Cancelled:o??h.ExtensionManagementErrorCode.Internal),l.stack=s.stack,l}function r(s,o,{extensionData:l,verificationStatus:p,duration:A,error:T,source:N,durationSinceUpdate:D}){let j,x;(0,d.$rg)(p)&&(p===!0?p="Verified":(p===!1||(j=h.ExtensionManagementErrorCode.Signature,x=p),p="Unverified")),T&&(j=T.code,T.code===h.ExtensionManagementErrorCode.Signature&&(x=T.message)),s.publicLog(o,{...l,verificationStatus:p,success:!T,duration:A,errorcode:j,errorcodeDetail:x,durationSinceUpdate:D,source:N})}class t{constructor(){this.d=new I.$Jh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,I.$xh)(o=>this.h(o))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,I.$xh)(o=>new Promise((l,p)=>{const A=o.onCancellationRequested(()=>{A.dispose(),p(new k.$9)})})),this.d.open()),this.g.cancel()}}e.$Pq=t}),define(le[42],he([0,1,8,13,2,5,25,12,20,26,9,10,6,24,23,3,7,18]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=e.$Qq=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class O extends Error{constructor(r,t){super(r),this.code=t}}e.$Qq=O,e.$Rq=(0,f.$Ki)("IExtensionsProfileScannerService");let w=class extends v.$Zc{constructor(r,t,s,o,l,p){super(),this.j=r,this.m=t,this.n=s,this.r=o,this.s=l,this.t=p,this.b=this.B(new k.$qe),this.onAddExtensions=this.b.event,this.c=this.B(new k.$qe),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$qe),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$qe),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Fc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t,s){const o=[],l=[];try{return await this.u(t,p=>{const A=[];if(s)A.push(...p);else for(const T of p)r.some(([N])=>(0,u.$Sp)(N.identifier,T.identifier)&&N.manifest.version!==T.version)?o.push(T):A.push(T);for(const[T,N]of r){const D=A.findIndex(x=>(0,u.$Sp)(x.identifier,T.identifier)&&x.version===T.manifest.version),j={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:N};D===-1?(l.push(j),A.push(j)):A.splice(D,1,j)}return l.length&&this.b.fire({extensions:l,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),A}),l.length&&this.c.fire({extensions:l,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),l}catch(p){throw l.length&&this.c.fire({extensions:l,error:p,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:p,profileLocation:t}),p}}async updateMetadata(r,t){const s=[];return await this.u(t,o=>{const l=[];for(const p of o){const A=r.find(([T])=>(0,u.$Sp)(T.identifier,p.identifier)&&T.manifest.version===p.version);A&&(p.metadata={...p.metadata,...A[1]},s.push(p)),l.push(p)}return l}),s}async removeExtensionFromProfile(r,t){const s=[];try{await this.u(t,o=>{const l=[];for(const p of o)(0,u.$Sp)(p.identifier,r.identifier)?s.push(p):l.push(p);return s.length&&this.f.fire({extensions:s,profileLocation:t}),l}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:t}),o}}async u(r,t,s){return this.F(r).queue(async()=>{let o=[],l;try{const p=await this.m.readFile(r);l=JSON.parse(p.value.toString().trim()||"[]")}catch(p){if((0,d.$wl)(p)!==d.FileOperationResult.FILE_NOT_FOUND)throw p;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new O((0,b.$bb)(p),c.ERROR_PROFILE_NOT_FOUND)}if(l){Array.isArray(l)||this.w(r);let p=!1;for(const A of l){i(A)||this.w(r);let T;if((0,S.$jg)(A.relativeLocation)&&A.relativeLocation)T=this.z(A.relativeLocation);else if((0,S.$jg)(A.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${A.location}`);continue}else{T=R.URI.revive(A.location);const N=this.y(T);N&&(p=!0,A.relativeLocation=N)}(0,S.$qg)(A.metadata?.hasPreReleaseVersion)&&A.metadata?.preRelease&&(p=!0,A.metadata.hasPreReleaseVersion=!0),o.push({identifier:A.identifier,location:T,version:A.version,metadata:A.metadata})}p&&await this.m.writeFile(r,I.$Se.fromString(JSON.stringify(l)))}if(t){o=t(o);const p=o.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.y(A.location),metadata:A.metadata}));await this.m.writeFile(r,I.$Se.fromString(JSON.stringify(p)))}return o})}w(r){const t=new O(`Invalid extensions content in ${r.toString()}`,c.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(l){if((0,d.$wl)(l)===d.FileOperationResult.FILE_NOT_FOUND)return;throw l}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(p=>i(p))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,I.$Se.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,d.$wl)(l)===d.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(r)}catch(l){(0,d.$wl)(l)!==d.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}try{await this.m.del(t)}catch(l){(0,d.$wl)(l)!==d.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}return o})()),this.C}F(r){let t=this.h.get(r);return t||(t=new P.$Rh,this.h.set(r,t)),t}};e.$Sq=w,e.$Sq=w=Ee([oe(1,d.$fl),oe(2,h.$Rl),oe(3,g.$Pl),oe(4,y.$em),oe(5,$.$fk)],w);function i(n){return(0,S.$lg)(n)&&(0,m.$qp)(n.identifier)&&(a(n.location)||(0,S.$jg)(n.location)&&n.location)&&((0,S.$qg)(n.relativeLocation)||(0,S.$jg)(n.relativeLocation))&&n.version&&(0,S.$jg)(n.version)}function a(n){return n?(0,S.$jg)(n.path)&&(0,S.$jg)(n.scheme):!1}});var ze=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(le[54],he([0,1,19,8,27,13,7,34,85,2,14,15,11,16,45,56,3,12,4,17,26,22,44,9,10,6,33,5,48,42,24,23,97]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c,O,w,i,a,n,r,t,s,o,l,p,A,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Xq=e.$Wq=e.$Vq=e.Translations=void 0,e.$Yq=ae,v=be(v),f=be(f),$=be($),g=be(g),S=ze(S);var D;(function(me){function W(_,M){if(_===M)return!0;const U=Object.keys(_),H=new Set;for(const K of Object.keys(M))H.add(K);if(U.length!==H.size)return!1;for(const K of U){if(_[K]!==M[K])return!1;H.delete(K)}return H.size===0}me.equals=W})(D||(e.Translations=D={})),e.$Vq=(0,r.$Ki)("IExtensionsScannerService");let j=class extends u.$Zc{constructor(W,_,M,U,H,K,ie,se,L,V,z,E){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=_,this.r=M,this.s=U,this.t=H,this.u=K,this.w=ie,this.y=se,this.z=L,this.C=V,this.D=z,this.F=E,this.g=this.B(new o.$qe),this.onDidChangeCache=this.g.event,this.h=(0,h.$lh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ne,this.s,this.h)),this.m=this.B(this.F.createInstance(ne,this.s,this.h)),this.n=this.B(this.F.createInstance(Y,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,w.$4p)(this.w,this.y)),this.G}async scanAllExtensions(W,_,M){const[U,H]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(_)]),K=M?await this.scanExtensionsUnderDevelopment(W,[...U,...H]):[];return this.L(U,H,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const _=[];_.push(this.M(!!W.useCache,W.language)),_.push(this.N(W.language,!!W.checkControlFile));const[M,U]=await Promise.all(_);return this.J([...M,...U],i.ExtensionType.System,W,!1)}async scanUserExtensions(W){const _=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const M=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(_,!!W.profileLocation,i.ExtensionType.User,!W.includeUninstalled,W.language,!0,M,W.productVersion??this.R()),H=W.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let K;try{K=await H.scanExtensions(U)}catch(ie){if(ie instanceof p.$Qq&&ie.code===p.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),K=await H.scanExtensions(U);else throw ie}return K=await this.J(K,i.ExtensionType.User,W,!0),this.y.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(W,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===d.Schemas.file).map(async U=>{const H=await this.P(U,!1,i.ExtensionType.User,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(H)).map(ie=>(ie.type=_.find(se=>(0,w.$Sp)(se.identifier,ie.identifier))?.type??ie.type,this.n.validate(ie,H)))}))).flat();return this.J(M,"development",W,!0)}return[]}async scanExistingExtension(W,_,M){const U=await this.P(W,!1,_,!0,M.language,!0,void 0,M.productVersion??this.R()),H=await this.n.scanExtension(U);return!H||!M.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(W,_,M){const U=await this.P(W,!1,_,!0,M.language,!0,void 0,M.productVersion??this.R()),H=await this.n.scanOneOrMultipleExtensions(U);return this.J(H,_,M,!0)}async scanMultipleExtensions(W,_,M){const U=[];return await Promise.all(W.map(async H=>{const K=await this.scanOneOrMultipleExtensions(H,_,M);U.push(...K)})),this.J(U,_,M,!0)}async scanMetadata(W){const _=(0,h.$lh)(W,"package.json"),M=(await this.w.readFile(_)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(W,_){const M=(0,h.$lh)(W,"package.json"),U=(await this.w.readFile(M)).value.toString(),H=JSON.parse(U);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,H.__metadata={...H.__metadata,..._},await this.w.writeFile((0,h.$lh)(W,"package.json"),k.$Se.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof p.$Qq&&W.code===p.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Se.fromString(JSON.stringify([])))}catch(_){(0,n.$wl)(_)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$bb)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,_,M,U){return M.includeAllVersions||(W=this.L(_===i.ExtensionType.System?W:void 0,_===i.ExtensionType.User?W:void 0,_==="development"?W:void 0,await this.getTargetPlatform(),U)),M.includeInvalid||(W=W.filter(H=>H.isValid)),W.sort((H,K)=>{const ie=f.$sc(H.location.fsPath),se=f.$sc(K.location.fsPath);return ie<se?-1:ie>se?1:0})}L(W,_,M,U,H){const K=(se,L,V)=>{if(se.isValid&&!L.isValid)return!1;if(se.isValid===L.isValid){if(H&&g.gt(se.manifest.version,L.manifest.version))return this.y.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(g.eq(se.manifest.version,L.manifest.version)){if(se.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${L.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===U)return this.y.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return V?this.y.warn(`Overwriting user extension ${se.location.path} with ${L.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${L.location.path}.`),!0},ie=new i.$zn;return W?.forEach(se=>{const L=ie.get(se.identifier.id);(!L||K(L,se,!1))&&ie.set(se.identifier.id,se)}),_?.forEach(se=>{const L=ie.get(se.identifier.id);if(!L&&W&&se.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!L||K(L,se,!1))&&ie.set(se.identifier.id,se)}),M?.forEach(se=>{const L=ie.get(se.identifier.id);(!L||K(L,se,!0))&&ie.set(se.identifier.id,se),ie.set(se.identifier.id,se)}),[...ie.values()]}async M(W,_){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,_,!0,void 0,this.R()),H=await(W&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",H.length),H}async N(W,_){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const U=_?await this.O():{},H=[],K=y.URI.file(f.$mc(f.$oc(d.$5g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of M){const L=U[se.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":H.push((0,h.$lh)(K,se.name));break;default:H.push(y.URI.file(L));break}}const ie=await Promise.all(H.map(async se=>this.n.scanExtension(await this.P(se,!1,i.ExtensionType.System,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ie.length),(0,P.$Lb)(ie)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,_,M,U,H,K,ie,se){const L=await this.f(H??$.$z),V=await this.Q(W),z=_&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=z?await this.Q(z):void 0;return new x(W,V,z,E,_,ie,M,U,K,se.version,se.date,this.C.commit,!this.z.isBuilt,H,L)}async Q(W){try{const _=await this.w.stat(W);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Wq=j,e.$Wq=j=Ee([oe(4,A.$Rl),oe(5,p.$Rq),oe(6,n.$fl),oe(7,t.$fk),oe(8,O.$Ri),oe(9,s.$yk),oe(10,T.$Pl),oe(11,r.$Ji)],j);class x{constructor(W,_,M,U,H,K,ie,se,L,V,z,E,F,X,J){this.location=W,this.mtime=_,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=U,this.profile=H,this.profileScanOptions=K,this.type=ie,this.excludeObsolete=se,this.validate=L,this.productVersion=V,this.productDate=z,this.productCommit=E,this.devMode=F,this.language=X,this.translations=J}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,_){return(0,h.$eh)(W.location,_.location)&&W.mtime===_.mtime&&(0,h.$eh)(W.applicationExtensionslocation,_.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&W.profile===_.profile&&v.$oo(W.profileScanOptions,_.profileScanOptions)&&W.type===_.type&&W.excludeObsolete===_.excludeObsolete&&W.validate===_.validate&&W.productVersion===_.productVersion&&W.productDate===_.productDate&&W.productCommit===_.productCommit&&W.devMode===_.devMode&&W.language===_.language&&D.equals(W.translations,_.translations)}}e.$Xq=x;let Y=class extends u.$Zc{constructor(W,_,M,U,H,K,ie){super(),this.g=W,this.h=_,this.j=M,this.m=U,this.n=K,this.r=ie,this.f=H.extensionsEnabledWithApiProposalVersion?.map(se=>se.toLowerCase())??[]}async scanExtensions(W){const _=W.profile?await this.t(W):await this.s(W);let M={};if(W.excludeObsolete&&W.type===i.ExtensionType.User)try{const U=(await this.m.readFile(this.g)).value.toString();M=JSON.parse(U)}catch{}return(0,b.$wg)(M)?_:_.filter(U=>!M[w.$Tp.create(U).toString()])}async s(W){const _=await this.m.resolve(W.location);if(!_.children?.length)return[];const M=await Promise.all(_.children.map(async U=>{if(!U.isDirectory||W.type===i.ExtensionType.User&&(0,h.$ih)(U.resource).indexOf(".")===0)return null;const H=new x(U.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(H)}));return(0,P.$Lb)(M).sort((U,H)=>U.location.path<H.location.path?-1:1)}async t(W){let _=await this.u(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.j.extUri.isEqual(W.location,W.applicationExtensionslocation)){_=_.filter(U=>!U.metadata?.isApplicationScoped);const M=await this.u(W.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,W);_.push(...M)}return _}async u(W,_,M){const U=await this.h.scanProfileExtensions(W,M.profileScanOptions);if(!U.length)return[];const H=await Promise.all(U.map(async K=>{if(_(K)){const ie=new x(K.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(ie,K.metadata)}return null}));return(0,P.$Lb)(H)}async scanOneOrMultipleExtensions(W){try{if(await this.m.exists((0,h.$lh)(W.location,"package.json"))){const _=await this.scanExtension(W);return _?[_]:[]}else return await this.scanExtensions(W)}catch(_){return this.r.error(`Error scanning extensions at ${W.location.path}:`,(0,C.$bb)(_)),[]}}async scanExtension(W,_){try{let M=await this.w(W.location);if(M){M.publisher||(M.publisher=i.$tn),_=_??M.__metadata,delete M.__metadata;const U=(0,w.$Xp)(M.publisher,M.name),H=_?.id?{id:U,uuid:_.id}:{id:U},K=_?.isSystem?i.ExtensionType.System:W.type,ie=K===i.ExtensionType.System||!!_?.isBuiltin;M=await this.y(W.location,M,x.createNlsConfiguration(W));let se={type:K,identifier:H,manifest:M,location:W.location,isBuiltin:ie,targetPlatform:_?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return W.validate&&(se=this.validate(se,W)),M.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(U.toLowerCase()))&&(M.originalEnabledApiProposals=M.enabledApiProposals,M.enabledApiProposals=(0,i.$Fn)([...M.enabledApiProposals])),se}}catch(M){W.type!==i.ExtensionType.System&&this.r.error(M)}return null}validate(W,_){let M=!0;const U=this.n.isBuilt&&this.f.includes(W.identifier.id.toLowerCase()),H=(0,a.$0p)(_.productVersion,_.productDate,_.location,W.manifest,W.isBuiltin,U);for(const[K,ie]of H)K===S.default.Error&&(M=!1,this.r.error(this.F(_.location,ie)));return W.isValid=M,W.validations=H,W}async w(W){const _=(0,h.$lh)(W,"package.json");let M;try{M=(await this.m.readFile(_)).value.toString()}catch(H){return(0,n.$wl)(H)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(W,(0,c.localize)(1815,null,_.path,H.message))),null}let U;try{U=JSON.parse(M)}catch{const K=[];(0,R.$5n)(M,K);for(const ie of K)this.r.error(this.F(W,(0,c.localize)(1816,null,_.path,ie.offset,ie.length,(0,m.$Tq)(ie.error))));return null}return(0,R.$ao)(U)!=="object"?(this.r.error(this.F(W,(0,c.localize)(1817,null,_.path))),null):U}async y(W,_,M){const U=await this.z(W,_,M);if(U)try{const H=[],K=await this.C(U.default,H);if(H.length>0)return H.forEach(se=>{this.r.error(this.F(W,(0,c.localize)(1818,null,U.default?.path,(0,m.$Tq)(se.error))))}),_;if((0,R.$ao)(U)!=="object")return this.r.error(this.F(W,(0,c.localize)(1819,null,U.default?.path))),_;const ie=U.values||Object.create(null);return(0,N.$Uq)(this.r,_,ie,K)}catch{}return _}async z(W,_,M){const U=(0,h.$lh)(W,"package.nls.json"),H=(L,V)=>{V.forEach(z=>{this.r.error(this.F(W,(0,c.localize)(1820,null,L?.path,(0,m.$Tq)(z.error))))})},K=L=>{this.r.error(this.F(W,(0,c.localize)(1821,null,L?.path)))},ie=`${_.publisher}.${_.name}`,se=M.translations[ie];if(se)try{const L=y.URI.file(se),V=(await this.m.readFile(L)).value.toString(),z=[],E=(0,R.$5n)(V,z);return z.length>0?(H(L,z),{values:void 0,default:U}):(0,R.$ao)(E)!=="object"?(K(L),{values:void 0,default:U}):{values:E.contents?E.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.m.exists(U))return;let V;try{V=await this.D(W,M)}catch{return}if(!V.localized)return{values:void 0,default:V.original};try{const z=(await this.m.readFile(V.localized)).value.toString(),E=[],F=(0,R.$5n)(z,E);return E.length>0?(H(V.localized,E),{values:void 0,default:V.original}):(0,R.$ao)(F)!=="object"?(K(V.localized),{values:void 0,default:V.original}):{values:F,default:V.original}}catch{return{values:void 0,default:V.original}}}}async C(W,_){if(W)try{const M=(await this.m.readFile(W)).value.toString();return(0,R.$5n)(M,_)}catch{}}D(W,_){return new Promise((M,U)=>{const H=K=>{const ie=(0,h.$lh)(W,`package.nls.${K}.json`);this.m.exists(ie).then(se=>{se&&M({localized:ie,original:(0,h.$lh)(W,"package.nls.json")});const L=K.lastIndexOf("-");L===-1?M({localized:(0,h.$lh)(W,"package.nls.json"),original:null}):(K=K.substring(0,L),H(K))})};if(_.devMode||_.pseudo||!_.language)return M({localized:(0,h.$lh)(W,"package.nls.json"),original:null});H(_.language)})}F(W,_){return`[${W.path}]: ${_}`}};Y=Ee([oe(1,p.$Rq),oe(2,T.$Pl),oe(3,n.$fl),oe(4,s.$yk),oe(5,O.$Ri),oe(6,t.$fk)],Y);let ne=class extends Y{constructor(W,_,M,U,H,K,ie,se,L){super(_,U,H,K,ie,se,L),this.J=W,this.L=M,this.H=this.B(new I.$Ih(3e3)),this.I=this.B(new o.$qe),this.onDidChangeCache=this.I.event}async scanExtensions(W){const _=this.P(W),M=await this.M(_);if(this.G=W,M&&M.input&&x.equals(M.input,this.G))return this.r.debug("Using cached extensions scan result",W.type===i.ExtensionType.System?"system":"user",W.location.toString()),this.H.trigger(()=>this.O()),M.result.map(H=>(H.location=y.URI.revive(H.location),H));const U=await super.scanExtensions(W);return await this.N(_,{input:W,result:U}),U}async M(W){try{const _=await this.m.readFile(W),M=JSON.parse(_.value.toString());return{result:M.result,input:(0,l.$hi)(M.input)}}catch(_){this.r.debug("Error while reading the extension cache file:",W.path,(0,C.$bb)(_))}return null}async N(W,_){try{await this.m.writeFile(W,k.$Se.fromString(JSON.stringify(_)))}catch(M){this.r.debug("Error while writing the extension cache file:",W.path,(0,C.$bb)(M))}}async O(){if(!this.G)return;const W=this.P(this.G),_=await this.M(W);if(!_)return;const M=_.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!v.$oo(U,M))try{this.r.info("Invalidating Cache",M,U),await this.m.del(W),this.I.fire()}catch(H){this.r.error(H)}}P(W){const _=this.Q(W);return this.j.extUri.joinPath(_.cacheHome,W.type===i.ExtensionType.System?i.$sn:i.$rn)}Q(W){return W.type===i.ExtensionType.System?this.L.defaultProfile:W.profile?this.j.extUri.isEqual(W.location,this.J.extensionsResource)?this.J:this.L.profiles.find(_=>this.j.extUri.isEqual(W.location,_.extensionsResource))??this.J:this.L.defaultProfile}};ne=Ee([oe(2,A.$Rl),oe(3,p.$Rq),oe(4,T.$Pl),oe(5,n.$fl),oe(6,s.$yk),oe(7,O.$Ri),oe(8,t.$fk)],ne);function ae(me,W){const _=(0,w.$Vp)(me.manifest.publisher,me.manifest.name);return{id:_,identifier:new i.$xn(_),isBuiltin:me.type===i.ExtensionType.System,isUserBuiltin:me.type===i.ExtensionType.User&&me.isBuiltin,isUnderDevelopment:W,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,publisherDisplayName:me.publisherDisplayName,...me.manifest}}class ue extends j{constructor(W,_,M,U,H,K,ie,se,L,V,z,E){super(W,_,(0,h.$lh)(M,".vscode-oss-dev","extensions","control.json"),U,H,K,ie,se,L,V,z,E),this.S=(async()=>{if($.$C)try{const F=await this.w.readFile(y.URI.file($.$C));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$Zq=ue}),define(le[137],he([0,1,61,8,38,5,2,14,15,29,6,24]),function(Q,e,P,I,v,k,C,R,m,u,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let $=class extends C.$Zc{constructor(g,S){super(),this.b=g,this.f=S,this.a=new I.$Qh(5)}async postUninstall(g){const S=this.g(g,"uninstall");S&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(S.script,"uninstall",S.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(b)}}));try{await u.Promises.rm(this.m(g))}catch(b){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(b)}}g(g,S){const b=`vscode:${S}`;if(g.location.scheme===R.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[b]=="string"){const y=g.manifest.scripts[b].split(" ");return y.length<2||y[0]!=="node"||!y[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${b} should be a node script`),null):{script:(0,m.$oc)(g.location.fsPath,y[1]),args:y.slice(2)||[]}}return null}h(g,S,b,y,c){return new Promise((O,w)=>{const i=this.j(g,S,b,c);let a;const n=r=>{a&&(clearTimeout(a),a=null),r?w(r):O(void 0)};i.on("error",r=>{n((0,v.$vj)(r)||"Unknown")}),i.on("exit",(r,t)=>{n(r?`post-${S} process exited with code ${r}`:void 0)}),y&&(a=setTimeout(()=>{a=null,i.kill(),w("timed out")},5e3))})}j(g,S,b,y){const c={silent:!0,execArgv:void 0},O=(0,P.fork)(g,[`--type=extension-post-${S}`,...b],c);O.stdout.setEncoding("utf8"),O.stderr.setEncoding("utf8");const w=k.Event.fromNodeEventEmitter(O.stdout,"data"),i=k.Event.fromNodeEventEmitter(O.stderr,"data");this.B(w(r=>this.f.info(y.identifier.id,y.manifest.version,`post-${S}`,r))),this.B(i(r=>this.f.error(y.identifier.id,y.manifest.version,`post-${S}`,r)));const a=k.Event.any(k.Event.map(w,r=>({data:`%c${r}`,format:[""]}),this.q),k.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return k.Event.debounce(a,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(y.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),O}m(g){return(0,m.$oc)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$4q=$,e.$4q=$=Ee([oe(0,f.$Rl),oe(1,d.$fk)],$)}),define(le[73],he([0,1,50,4,53,20]),function(Q,e,P,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=C,e.$2q=R;function C(m){let u=k.ExtensionManagementErrorCode.Extract;return m instanceof P.$Jq&&(m.type==="CorruptZip"?u=k.ExtensionManagementErrorCode.CorruptZip:m.type==="Incomplete"&&(u=k.ExtensionManagementErrorCode.IncompleteZip)),(0,v.$Oq)(m,u)}async function R(m){let u;try{u=await(0,P.$Mq)(m,"extension/package.json")}catch(d){throw C(d)}try{return JSON.parse(u.toString("utf8"))}catch{throw new k.$tp((0,I.localize)(1831,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(le[138],he([0,1,8,7,2,14,16,45,3,28,29,50,30,17,53,20,26,73,72,9,6,18]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c,O,w,i){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0,R=be(R);let n=class extends v.$Zc{static{a=this}static{this.c=".sigzip"}constructor(t,s,o,l,p,A,T){super(),this.h=s,this.j=o,this.m=l,this.n=p,this.r=A,this.t=T,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,o,l){await this.g;const p=await this.w(t,s);let A=!1;if(o&&this.u(t)){let T;try{T=await this.y(t)}catch(N){try{await this.delete(p)}catch(D){this.t.error(D)}throw N}try{A=await this.n.verify(t,p.fsPath,T.fsPath,l)}catch(N){if(A=N.code,A===c.ExtensionSignatureVerificationCode.PackageIsInvalidZip||A===c.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(p)}catch(D){this.t.error(D)}throw new S.$tp(f.$Iq,S.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(N){this.t.error(N)}}}return{location:p,verificationStatus:A}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,m.$pg)(s)?s:!0}async w(t,s){try{const o=(0,C.$lh)(this.extensionsDownloadDir,this.G(t)),l=await this.C(t,"vsix",async()=>{await this.z(t,o,p=>this.j.download(t,p,s));try{await this.D(o.fsPath,"extension/package.json")}catch(p){try{await this.h.del(o)}catch(A){this.t.warn(`Error while deleting: ${o.path}`,(0,I.$bb)(A))}throw p}},2);return l>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:l}),o}catch(o){throw(0,g.$Oq)(o,S.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,C.$lh)(this.extensionsDownloadDir,`.${(0,u.$7g)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(l){try{await this.h.del(s)}catch(p){this.t.warn(`Error while deleting: ${s.path}`,(0,I.$bb)(p))}throw l}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),s}catch(s){throw(0,g.$Oq)(s,S.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,o){if(await this.h.exists(s))return;if(s.scheme!==k.Schemas.file){await o(s);return}const l=(0,C.$lh)(this.extensionsDownloadDir,`.${(0,u.$7g)()}`);try{await o(l)}catch(p){try{await this.h.del(l)}catch{}throw p}try{await d.Promises.rename(l.fsPath,s.fsPath,2*60*1e3)}catch(p){try{await this.h.del(l)}catch{}let A=!1;try{A=await this.h.exists(s)}catch{}if(A)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,I.$bb)(p)}. Deleted the file from downloaded location`,l.path),p}}async C(t,s,o,l){let p=1;for(;;)try{return await o(),p}catch(A){if(p++>l)throw A;this.t.warn(`Failed downloading ${s}. ${(0,I.$bb)(A)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,f.$Mq)(t,s)}catch(o){throw(0,y.$1q)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],o=[],l=[];for(const T of t.children)if(T.name.endsWith(a.c))l.push(T.resource);else{const N=b.$Tp.parse(T.name);N&&o.push([N,T])}const p=(0,b.$Yp)(o,([T])=>T),A=[];for(const T of p)T.sort((N,D)=>R.rcompare(N[0].version,D[0].version)),s.push(...T.slice(1).map(N=>N[1].resource)),A.push(T[0][1]);A.sort((T,N)=>T.mtime-N.mtime),s.push(...A.slice(0,Math.max(0,A.length-this.f)).map(T=>T.resource)),s.push(...l),await P.Promises.settled(s.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(t){this.t.error(t)}}G(t){return this.f?b.$Tp.create(t).toString().toLowerCase():(0,u.$7g)()}};e.$3q=n,e.$3q=n=a=Ee([oe(0,h.$Si),oe(1,O.$fl),oe(2,S.$rp),oe(3,$.$ej),oe(4,c.$Bq),oe(5,i.$em),oe(6,w.$fk)],n)}),define(le[139],he([0,1,32,8,13,21,38,7,5,43,2,25,14,15,16,45,3,12,28,29,50,4,62,17,53,20,26,42,54,138,137,73,119,126,22,44,9,10,6,33,18,23,24]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c,O,w,i,a,n,r,t,s,o,l,p,A,T,N,D,j,x,Y,ne,ae,ue,me,W,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=void 0,P=be(P),h=be(h),S=be(S),O=be(O),i=be(i),e.$7q=(0,ne.$Li)(t.$up);const M=".vsctmp";let U=class extends r.$Nq{constructor(L,V,z,E,F,X,J,G,q,Z,re,ce){super(L,V,re,z,Z,ce),this.db=F,this.eb=X,this.fb=J,this.gb=G,this.hb=q,this.cb=new Map,this.sb=new f.$Gc;const fe=this.B(G.createInstance(A.$4q));this.$=this.B(G.createInstance(H,de=>fe.postUninstall(de))),this.ab=this.B(new N.$5q(ce,q,re,this,this.F)),this.bb=this.B(G.createInstance(p.$3q));const we=this.B(new D.$6q(this,this.db,ce,X,re,q,z));this.B(we.onDidChangeExtensionsByAnotherSource(de=>this.rb(de))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$4p)(this.hb,this.F)),this.ib}async zip(L){this.F.trace("ExtensionManagementService#zip",L.identifier.id);const V=await this.qb(L),z=await(0,w.zip)((0,g.$lh)(this.bb.extensionsDownloadDir,(0,c.$7g)()).fsPath,V);return y.URI.file(z)}async getManifest(L){const{location:V,cleanup:z}=await this.kb(L),E=h.$pc(V.fsPath);try{return await(0,T.$2q)(E)}finally{await z()}}getInstalled(L,V=this.H.defaultProfile.extensionsResource,z={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(L??null,V,z)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(L){return this.$.scanUserExtensionAtLocation(L)}async install(L,V={}){this.F.trace("ExtensionManagementService#install",L.toString());const{location:z,cleanup:E}=await this.kb(L);try{const F=await(0,T.$2q)(h.$pc(z.fsPath)),X=(0,s.$Xp)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,x.$_p)(F.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(1822,null,X,this.G.version));const G=(await this.I([{manifest:F,extension:z,options:V}])).find(({identifier:q})=>(0,s.$Sp)(q,{id:X}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$Oq)(new Error(`Unknown error while installing extension ${X}`))}finally{await E()}}async installFromLocation(L,V){this.F.trace("ExtensionManagementService#installFromLocation",L.toString());const z=await this.$.scanUserExtensionAtLocation(L);if(!z||!z.manifest.name||!z.manifest.version)throw new Error(`Cannot find a valid extension from the location ${L.toString()}`);return await this.vb([[z,{source:"resource"}]],V),this.F.info("Successfully installed extension",z.identifier.id,V.toString()),z}async installExtensionsFromProfile(L,V,z){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",L,V.toString(),z.toString());const E=(await this.getInstalled(j.ExtensionType.User,V)).filter(F=>L.some(X=>(0,s.$Sp)(X,F.identifier)));if(E.length){const F=await Promise.all(E.map(X=>this.$.scanMetadata(X,V)));await this.vb(E.map((X,J)=>[X,F[J]]),z),this.F.info("Successfully installed extensions",E.map(X=>X.identifier.id),z.toString())}return E}async updateMetadata(L,V,z){return this.F.trace("ExtensionManagementService#updateMetadata",L.identifier.id),V.isPreReleaseVersion&&(V.preRelease=!0,V.hasPreReleaseVersion=!0),V.isMachineScoped===!1&&(V.isMachineScoped=void 0),V.isBuiltin===!1&&(V.isBuiltin=void 0),V.pinned===!1&&(V.pinned=void 0),L=await this.$.updateMetadata(L,V,z),this.ab.invalidate(z),this.w.fire({local:L,profileLocation:z}),L}async reinstallFromGallery(L){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",L.identifier.id),!this.z.isEnabled())throw new Error(i.localize(1823,null));const V=await this.getTargetPlatform(),[z]=await this.z.getExtensions([{...L.identifier,preRelease:L.preRelease}],{targetPlatform:V,compatible:!0},k.CancellationToken.None);if(!z)throw new Error(i.localize(1824,null));await this.$.setUninstalled(L);try{await this.$.removeUninstalledExtension(L)}catch(E){throw new Error(i.localize(1825,null,(0,C.$vj)(E)))}return this.installFromGallery(z)}Z(L,V,z,E){return this.$.copyExtension(L,V,z,E)}copyExtensions(L,V){return this.$.copyExtensions(L,V,{version:this.G.version,date:this.G.date})}markAsUninstalled(...L){return this.$.setUninstalled(...L)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(L){this.F.error(L)}}async download(L,V,z){const{location:E}=await this.bb.download(L,V,!z);return E}async kb(L){if(L.scheme===$.Schemas.file)return{location:L,async cleanup(){}};this.F.trace("Downloading extension from",L.toString());const V=(0,g.$lh)(this.bb.extensionsDownloadDir,(0,c.$7g)());return await this.fb.download(L,V),this.F.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.hb.del(V)}catch(E){this.F.error(E)}}}}W(){return this.H.defaultProfile.extensionsResource}X(L,V,z){const E=V instanceof y.URI?new s.$Tp({id:(0,s.$Xp)(L.publisher,L.name)},L.version):s.$Tp.create(V);return this.gb.createInstance(K,E,L,V,z,(F,X)=>{if(V instanceof y.URI)return this.pb(E,V,z,X);let J=this.cb.get(E.toString());return J||(this.cb.set(E.toString(),J=this.ob(E,V,F,z,X)),J.finally(()=>this.cb.delete(E.toString()))),J},this.$)}Y(L,V){return new ie(L,V,this.eb)}async ob(L,V,z,E,F){const{verificationStatus:X,location:J}=await this.bb.download(V,z,!E.donotVerifySignature,E.context?.[t.$kp]);try{if(F.isCancellationRequested)throw new R.$9;const G=await(0,T.$2q)(J.fsPath);if(!new s.$Tp(V.identifier,V.version).equals(new s.$Tp({id:(0,s.$Xp)(G.publisher,G.name)},G.version)))throw new t.$tp(i.localize(1826,null,V.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(L,J.fsPath,{id:V.identifier.uuid,publisherId:V.publisherId,publisherDisplayName:V.publisherDisplayName,targetPlatform:V.properties.targetPlatform,isApplicationScoped:E.isApplicationScoped,isMachineScoped:E.isMachineScoped,isBuiltin:E.isBuiltin,isPreReleaseVersion:V.properties.isPreReleaseVersion,hasPreReleaseVersion:V.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:E.installGivenVersion?!0:!!E.pinned,preRelease:(0,b.$pg)(E.preRelease)?E.preRelease:E.installPreReleaseVersion||V.properties.isPreReleaseVersion,source:"gallery"},!1,F),verificationStatus:X}}catch(G){try{await this.bb.delete(J)}catch(q){this.F.warn("Error while deleting the downloaded file",J.toString(),(0,R.$bb)(q))}throw(0,r.$Oq)(G)}}async pb(L,V,z,E){return{local:await this.$.extractUserExtension(L,h.$pc(V.fsPath),{isApplicationScoped:z.isApplicationScoped,isMachineScoped:z.isMachineScoped,isBuiltin:z.isBuiltin,installedTimestamp:Date.now(),pinned:z.installGivenVersion?!0:!!z.pinned,source:"vsix"},z.keepExisting??!0,E)}}async qb(L){const V=async E=>{let F=await O.Promises.readdir(E);F=F.map(G=>h.$oc(E,G));const X=await Promise.all(F.map(G=>P.promises.stat(G)));let J=Promise.resolve([]);return X.forEach((G,q)=>{const Z=F[q];G.isFile()&&(J=J.then(re=>[...re,Z])),G.isDirectory()&&(J=J.then(re=>V(Z).then(ce=>[...re,...ce])))}),J};return(await V(L.location.fsPath)).map(E=>({path:`extension/${h.$qc(L.location.fsPath,E)}`,localPath:E}))}async rb({added:L,removed:V}){if(V){const z=L&&this.D.extUri.isEqual(V.profileLocation,L.profileLocation)?V.extensions.filter(E=>L.extensions.every(F=>!(0,s.$Sp)(F,E))):V.extensions;for(const E of z)this.F.info("Extensions removed from another source",E.id,V.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:V.profileLocation})}if(L){const E=(await this.getInstalled(j.ExtensionType.User,L.profileLocation)).filter(F=>L.extensions.some(X=>(0,s.$Sp)(X,F.identifier)));this.s.fire(E.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,L.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:L.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(V=>this.sb.add(V)));const L=await this.hb.resolve(this.db.userExtensionsLocation);for(const V of L.children??[])V.isDirectory&&this.sb.add(V.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(V=>this.ub(V)))}async ub(L){if(!L.affects(this.db.userExtensionsLocation,Y.FileChangeType.ADDED))return;const V=[];for(const z of L.rawAdded){if(this.sb.has(z)||!this.D.extUri.isEqual(this.D.extUri.dirname(z),this.db.userExtensionsLocation)||this.D.extUri.isEqual(z,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(z).startsWith(".")||!(await this.hb.stat(z)).isDirectory)continue;const E=await this.$.scanUserExtensionAtLocation(z);E&&E.installedTimestamp===void 0&&(this.sb.add(z),V.push(E))}V.length&&(await this.vb(V.map(z=>[z,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",V.map(z=>z.identifier.id)))}async vb(L,V){const z=L.map(E=>E[0]);await this.wb(z),await this.eb.addExtensionsToProfile(L,V),this.s.fire(z.map(E=>({local:E,identifier:E.identifier,operation:t.InstallOperation.None,profileLocation:V})))}async wb(L){const V=await this.$.getUninstalledExtensions();for(const z of L){const E=s.$Tp.create(z);V[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.$.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$8q=U,e.$8q=U=Ee([oe(0,t.$rp),oe(1,me.$em),oe(2,ae.$fk),oe(3,n.$Si),oe(4,l.$Vq),oe(5,o.$Rq),oe(6,a.$8o),oe(7,ne.$Ji),oe(8,Y.$fl),oe(9,ue.$yk),oe(10,W.$Pl),oe(11,_.$Rl)],U);let H=class extends d.$Zc{constructor(L,V,z,E,F,X,J){super(),this.n=L,this.s=V,this.t=z,this.u=E,this.w=F,this.y=X,this.z=J,this.h=this.B(new m.$qe),this.onExtract=this.h.event,this.j=new f.$Fc,this.m=new f.$Fc,this.c=(0,g.$lh)(this.t.userExtensionsLocation,".obsolete"),this.g=new I.$Rh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(L,V,z){try{const E={includeInvalid:!0,profileLocation:V,productVersion:z};let F=[];if(L===null||L===j.ExtensionType.System){let X=this.j.get(V);X||(X=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},E,!1).finally(()=>this.j.delete(V)),this.j.set(V,X)),F.push(...await X)}else if(L===j.ExtensionType.User){let X=this.m.get(V);X||(X=this.t.scanUserExtensions(E).finally(()=>this.m.delete(V)),this.m.set(V,X)),F.push(...await X)}return F=L!==null?F.filter(X=>X.type===L):F,await Promise.all(F.map(X=>this.H(X)))}catch(E){throw(0,r.$Oq)(E,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(L){try{const V=await this.t.scanUserExtensions({includeAllVersions:!L,includeInvalid:!0});return await Promise.all(V.map(z=>this.H(z)))}catch(V){throw(0,r.$Oq)(V,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(L){try{const V=await this.t.scanExistingExtension(L,j.ExtensionType.User,{includeInvalid:!0});if(V)return await this.H(V)}catch(V){this.z.error(V)}return null}async extractUserExtension(L,V,z,E,F){const X=L.toString(),J=y.URI.file(h.$oc(this.t.userExtensionsLocation.fsPath,`.${(0,c.$7g)()}`)),G=y.URI.file(h.$oc(this.t.userExtensionsLocation.fsPath,X));if(await this.s.exists(G)){if(!E)try{return await this.scanLocalExtension(G,j.ExtensionType.User)}catch(q){this.z.warn(`Error while scanning the existing extension at ${G.path}. Deleting the existing extension and extracting it.`,(0,R.$bb)(q))}try{await this.D(L.id,G,"removeExisting")}catch{throw new t.$tp(i.localize(1827,null,G.fsPath,L.id),t.ExtensionManagementErrorCode.Delete)}}try{if(F.isCancellationRequested)throw new R.$9;try{this.z.trace(`Started extracting the extension from ${V} to ${G.fsPath}`),await(0,w.$Lq)(V,J.fsPath,{sourcePath:"extension",overwrite:!0},F),this.z.info(`Extracted extension to ${G}:`,L.id)}catch(q){throw(0,T.$1q)(q)}try{await this.t.updateMetadata(J,z)}catch(q){throw this.y.publicLog2("extension:extract",{extensionId:L.id,code:`${(0,Y.$wl)(q)}`}),(0,r.$Oq)(q,t.ExtensionManagementErrorCode.UpdateMetadata)}if(F.isCancellationRequested)throw new R.$9;try{this.z.trace(`Started renaming the extension from ${J.fsPath} to ${G.fsPath}`),await this.G(J.fsPath,G.fsPath),this.z.info("Renamed to",G.fsPath)}catch(q){if(q.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",L.id);try{await this.s.del(J,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,R.$bb)(q)}. Deleted from extracted location`,J),q}this.h.fire(G)}catch(q){try{await this.s.del(J,{recursive:!0})}catch{}throw q}return this.scanLocalExtension(G,j.ExtensionType.User)}async scanMetadata(L,V){return V?(await this.C(L,V))?.metadata:this.t.scanMetadata(L.location)}async C(L,V){return(await this.u.scanProfileExtensions(V)).find(E=>(0,s.$Sp)(E.identifier,L.identifier))}async updateMetadata(L,V,z){try{z?await this.u.updateMetadata([[L,V]],z):await this.t.updateMetadata(L.location,V)}catch(E){throw this.y.publicLog2("extension:extract",{extensionId:L.identifier.id,code:`${(0,Y.$wl)(E)}`,isProfile:!!z}),(0,r.$Oq)(E,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(L.location,L.type,z)}async getUninstalledExtensions(){try{return await this.F()}catch(L){throw(0,r.$Oq)(L,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...L){const V=L.map(z=>s.$Tp.create(z));await this.F(z=>V.forEach(E=>{z[E.toString()]=!0,this.z.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(L){try{await this.F(V=>delete V[L.toString()])}catch(V){throw(0,r.$Oq)(V,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(L,V){if(this.w.extUri.isEqualOrParent(L.location,this.t.userExtensionsLocation))return this.D(L.identifier.id,L.location,V)}async removeUninstalledExtension(L){await this.removeExtension(L,"uninstalled"),await this.F(V=>delete V[s.$Tp.create(L).toString()])}async copyExtension(L,V,z,E){const F=await this.C(L,V),X=await this.C(L,z);if(E={...F?.metadata,...E},X)if(this.w.extUri.isEqual(X.location,L.location))await this.u.updateMetadata([[L,{...X.metadata,...E}]],z);else{const J=await this.scanLocalExtension(X.location,L.type,z);await this.u.removeExtensionFromProfile(J,z),await this.u.addExtensionsToProfile([[L,{...X.metadata,...E}]],z)}else await this.u.addExtensionsToProfile([[L,E]],z);return this.scanLocalExtension(L.location,L.type,z)}async copyExtensions(L,V,z){const E=await this.scanExtensions(j.ExtensionType.User,L,z),F=await Promise.all(E.filter(X=>!X.isApplicationScoped).map(async X=>[X,await this.scanMetadata(X,L)]));await this.u.addExtensionsToProfile(F,V)}async D(L,V,z){this.z.trace(`Deleting ${z} extension from disk`,L,V.fsPath);const E=this.w.extUri.joinPath(this.w.extUri.dirname(V),`${this.w.extUri.basename(V)}.${(0,u.$yj)((0,c.$7g)()).toString(16)}${M}`);await this.G(V.fsPath,E.fsPath),await this.s.del(E,{recursive:!0}),this.z.info(`Deleted ${z} extension from disk`,L,V.fsPath)}F(L){return this.g.queue(async()=>{let V;try{V=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,Y.$wl)(E)!==Y.FileOperationResult.FILE_NOT_FOUND)throw E}let z={};if(V)try{z=JSON.parse(V)}catch{}return L&&(L(z),Object.keys(z).length?await this.s.writeFile(this.c,v.$Se.fromString(JSON.stringify(z))):await this.s.del(this.c)),z})}async G(L,V){try{await O.Promises.rename(L,V,2*60*1e3)}catch(z){throw(0,r.$Oq)(z,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(L,V,z){try{if(z){const F=(await this.t.scanUserExtensions({profileLocation:z})).find(X=>this.w.extUri.isEqual(X.location,L));if(F)return await this.H(F)}else{const E=await this.t.scanExistingExtension(L,V,{includeInvalid:!0});if(E)return await this.H(E)}throw new t.$tp(i.localize(1828,null,L.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(E){throw(0,r.$Oq)(E,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(L){const V=await this.s.resolve(L.location);let z,E;return V.children&&(z=V.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,E=V.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:L.identifier,type:L.type,isBuiltin:L.isBuiltin||!!L.metadata?.isBuiltin,location:L.location,manifest:L.manifest,targetPlatform:L.targetPlatform,validations:L.validations,isValid:L.isValid,readmeUrl:z,changelogUrl:E,publisherDisplayName:L.metadata?.publisherDisplayName,publisherId:L.metadata?.publisherId||null,isApplicationScoped:!!L.metadata?.isApplicationScoped,isMachineScoped:!!L.metadata?.isMachineScoped,isPreReleaseVersion:!!L.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!L.metadata?.hasPreReleaseVersion,preRelease:!!L.metadata?.preRelease,installedTimestamp:L.metadata?.installedTimestamp,updated:!!L.metadata?.updated,pinned:!!L.metadata?.pinned,isWorkspaceScoped:!1,source:L.metadata?.source??(L.identifier.uuid?"gallery":"vsix")}}async I(){const L=await this.getUninstalledExtensions();if(Object.keys(L).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(L));const V=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),z=new Set;for(const F of V)L[s.$Tp.create(F).toString()]||z.add(F.identifier.id.toLowerCase());try{const F=(0,s.$Yp)(V,X=>X.identifier);await I.Promises.settled(F.map(async X=>{const J=X.sort((G,q)=>S.rcompare(G.manifest.version,q.manifest.version))[0];z.has(J.identifier.id.toLowerCase())||await this.n(await this.H(J))}))}catch(F){this.z.error(F)}const E=V.filter(F=>F.metadata&&L[s.$Tp.create(F).toString()]);await Promise.allSettled(E.map(F=>this.removeUninstalledExtension(F)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let L;try{L=await this.s.resolve(this.t.userExtensionsLocation)}catch(V){(0,Y.$wl)(V)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(V);return}if(L?.children)try{await Promise.allSettled(L.children.map(async V=>{if(!(!V.isDirectory||!V.name.endsWith(M))){this.z.trace("Deleting the temporarily deleted folder",V.resource.toString());try{await this.s.del(V.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",V.resource.toString())}catch(z){(0,Y.$wl)(z)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(z)}}}))}catch{}}};e.$9q=H,e.$9q=H=Ee([oe(1,Y.$fl),oe(2,l.$Vq),oe(3,o.$Rq),oe(4,W.$Pl),oe(5,me.$em),oe(6,ae.$fk)],H);let K=class extends r.$Pq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(L,V,z,E,F,X,J,G,q,Z,re,ce){super(),this.l=L,this.manifest=V,this.source=z,this.options=E,this.m=F,this.n=X,this.o=J,this.p=G,this.q=q,this.s=Z,this.t=re,this.u=ce,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(L){const z=(await this.n.scanExtensions(j.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(J=>(0,s.$Sp)(J.identifier,this.identifier));z&&(this.j=t.InstallOperation.Update);const E={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===j.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:this.source instanceof y.URI?"vsix":"gallery"};let F;if(this.source instanceof y.URI){if(z&&this.l.equals(new s.$Tp(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(i.localize(1829,null,this.manifest.displayName||this.manifest.name))}const J=await this.w(this.l);if(J)try{await this.n.removeExtension(J,"existing")}catch{throw new Error(i.localize(1830,null,this.manifest.displayName||this.manifest.name))}}else{if(E.id=this.source.identifier.uuid,E.publisherId=this.source.publisherId,E.publisherDisplayName=this.source.publisherDisplayName,E.targetPlatform=this.source.properties.targetPlatform,E.updated=!!z,E.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,E.hasPreReleaseVersion=z?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,E.preRelease=(0,b.$pg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||z?.preRelease,z&&z.type!==j.ExtensionType.System&&z.manifest.version===this.source.version)return this.n.updateMetadata(z,E,this.options.profileLocation);F=await this.w(this.l)}if(L.isCancellationRequested)throw(0,r.$Oq)(new R.$9);if(!F){const J=await this.m(this.operation,L);F=J.local,this.k=J.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(J){throw(0,r.$Oq)(J,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(L.isCancellationRequested)throw(0,r.$Oq)(new R.$9);try{await this.t.addExtensionsToProfile([[F,E]],this.options.profileLocation,!F.isValid)}catch(J){throw(0,r.$Oq)(J,t.ExtensionManagementErrorCode.AddToProfile)}const X=await this.n.scanLocalExtension(F.location,j.ExtensionType.User,this.options.profileLocation);if(!X)throw new t.$tp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof y.URI&&this.x(F,L),X}async w(L){return(await this.n.getUninstalledExtensions())[L.toString()]?(this.u.trace("Removing the extension from uninstalled list:",L.id),await this.n.setInstalled(L),this.u.info("Removed the extension from uninstalled list:",L.id),(await this.n.scanAllUserExtensions(!0)).find(E=>s.$Tp.create(E).equals(L))):void 0}async x(L,V){try{let[z]=await this.p.getExtensions([{id:L.identifier.id,version:L.manifest.version}],V);if(z||([z]=await this.p.getExtensions([{id:L.identifier.id}],V)),z){const E={id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:L.hasPreReleaseVersion||z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(L,E,this.options.profileLocation)}}catch{}}};K=Ee([oe(6,W.$Pl),oe(7,t.$rp),oe(8,_.$Rl),oe(9,l.$Vq),oe(10,o.$Rq),oe(11,ae.$fk)],K);class ie extends r.$Pq{constructor(L,V,z){super(),this.extension=L,this.options=V,this.j=z}async h(L){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(le[140],he([0,1,6,24,23,18,42,9,17,12]),function(Q,e,P,I,v,k,C,R,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9R=void 0;let d=class extends C.$Sq{constructor($,h,g,S,b,y){super(u.URI.file($.extensionsPath),h,g,S,b,y)}};e.$9R=d,e.$9R=d=Ee([oe(0,m.$Si),oe(1,R.$fl),oe(2,I.$Rl),oe(3,v.$Pl),oe(4,k.$em),oe(5,P.$fk)],d)}),define(le[141],he([0,1,12,17,42,54,9,10,6,33,23,24]),function(Q,e,P,I,v,k,C,R,m,u,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;let $=class extends k.$Zq{constructor(g,S,b,y,c,O,w,i){super(P.URI.file(c.builtinExtensionsPath),P.URI.file(c.extensionsPath),c.userHome,g.defaultProfile,g,S,b,y,c,O,w,i)}};e.$Hic=$,e.$Hic=$=Ee([oe(0,f.$Rl),oe(1,v.$Rq),oe(2,C.$fl),oe(3,m.$fk),oe(4,I.$Si),oe(5,u.$yk),oe(6,d.$Pl),oe(7,R.$Ji)],$)}),define(le[74],he([0,1,8,5,2,109,3,91,10,24]),function(Q,e,P,I,v,k,C,R,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$qq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$oq=e.$nq=e.$mq=void 0,e.$pq=h,e.$rq=S,e.$tq=y,e.$mq="__$__isNewStorageMarker",e.$nq="__$__targetStorageMarker",e.$oq=(0,m.$Ki)("storageService");var d;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var f;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(f||(e.StorageScope=f={}));var $;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function h(c){const O=c.get(e.$nq);if(O)try{return JSON.parse(O)}catch{}return Object.create(null)}class g extends v.$Zc{static{this.a=60*1e3}constructor(O={flushInterval:g.a}){super(),this.m=O,this.b=this.B(new I.$te),this.c=this.B(new I.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new I.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(O,w,i){return I.Event.filter(this.b.event,a=>a.scope===O&&(w===void 0||a.key===w),i)}n(){this.j.value=(0,P.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(O,w){const{key:i,external:a}=w;if(i===e.$nq){switch(O){case f.APPLICATION:this.H=void 0;break;case f.PROFILE:this.F=void 0;break;case f.WORKSPACE:this.C=void 0;break}this.c.fire({scope:O})}else this.b.fire({scope:O,key:i,target:this.J(O)[i],external:a})}w(O){this.f.fire({reason:O})}get(O,w,i){return this.P(w)?.get(O,i)}getBoolean(O,w,i){return this.P(w)?.getBoolean(O,i)}getNumber(O,w,i){return this.P(w)?.getNumber(O,i)}getObject(O,w,i){return this.P(w)?.getObject(O,i)}storeAll(O,w){this.y(()=>{for(const i of O)this.store(i.key,i.value,i.scope,i.target,w)})}store(O,w,i,a,n=!1){if((0,C.$sg)(w)){this.remove(O,i,n);return}this.y(()=>{this.z(O,i,a),this.P(i)?.set(O,w,n)})}remove(O,w,i=!1){this.y(()=>{this.z(O,w,void 0),this.P(w)?.delete(O,i)})}y(O){this.b.pause(),this.c.pause();try{O()}finally{this.b.resume(),this.c.resume()}}keys(O,w){const i=[],a=this.J(O);for(const n of Object.keys(a))a[n]===w&&i.push(n);return i}z(O,w,i,a=!1){const n=this.J(w);typeof i=="number"?n[O]!==i&&(n[O]=i,this.P(w)?.set(e.$nq,JSON.stringify(n),a)):typeof n[O]=="number"&&(delete n[O],this.P(w)?.set(e.$nq,JSON.stringify(n),a))}get D(){return this.C||(this.C=this.L(f.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(f.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(f.APPLICATION)),this.H}J(O){switch(O){case f.APPLICATION:return this.I;case f.PROFILE:return this.G;default:return this.D}}L(O){const w=this.P(O);return w?h(w):Object.create(null)}isNew(O){return this.getBoolean(e.$mq,O)===!0}async flush(O=d.NONE){this.f.fire({reason:O});const w=this.P(f.APPLICATION),i=this.P(f.PROFILE),a=this.P(f.WORKSPACE);switch(O){case d.NONE:await P.Promises.settled([w?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await P.Promises.settled([w?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const O=this.P(f.APPLICATION)?.items??new Map,w=this.P(f.PROFILE)?.items??new Map,i=this.P(f.WORKSPACE)?.items??new Map;return y(O,w,i,this.Q(f.APPLICATION)??"",this.Q(f.PROFILE)??"",this.Q(f.WORKSPACE)??"")}async optimize(O){return await this.flush(),this.P(O)?.optimize()}async switch(O,w){return this.w(d.NONE),(0,u.$Ql)(O)?this.R(O,w):this.S(O,w)}M(O,w){return!(O.id===w.id||S(w)&&S(O))}N(O,w,i){this.y(()=>{const a=new Set;for(const[n,r]of O)a.add(n),w.get(n)!==r&&this.u(i,{key:n,external:!0});for(const[n]of w.items)a.has(n)||this.u(i,{key:n,external:!0})})}}e.$qq=g;function S(c){return c.isDefault||!!c.useDefaultFlags?.globalState}class b extends g{constructor(){super(),this.U=this.B(new R.$kq(new R.$lq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$kq(new R.$lq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$kq(new R.$lq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(O=>this.u(f.WORKSPACE,O))),this.B(this.W.onDidChangeStorage(O=>this.u(f.PROFILE,O))),this.B(this.U.onDidChangeStorage(O=>this.u(f.APPLICATION,O)))}P(O){switch(O){case f.APPLICATION:return this.U;case f.PROFILE:return this.W;default:return this.X}}Q(O){switch(O){case f.APPLICATION:return"inMemory (application)";case f.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(O){return!1}}e.$sq=b;async function y(c,O,w,i,a,n){const r=D=>{try{return JSON.parse(D)}catch{return D}},t=new Map,s=new Map;c.forEach((D,j)=>{t.set(j,D),s.set(j,r(D))});const o=new Map,l=new Map;O.forEach((D,j)=>{o.set(j,D),l.set(j,r(D))});const p=new Map,A=new Map;w.forEach((D,j)=>{p.set(j,D),A.set(j,r(D))}),console.group(i!==a?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const T=[];if(t.forEach((D,j)=>{T.push({key:j,value:D})}),console.table(T),console.groupEnd(),console.log(s),i!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const D=[];o.forEach((j,x)=>{D.push({key:x,value:j})}),console.table(D),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${n})`);const N=[];p.forEach((D,j)=>{N.push({key:j,value:D})}),console.table(N),console.groupEnd(),console.log(A)}}),define(le[142],he([0,1,13,28,74]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=k;async function k(C,R,m){let u=m&&m.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(u)return u;try{const f=(await R.readFile(C.serviceMachineIdResource)).value.toString();u=(0,I.$6g)(f)?f:null}catch{u=null}if(!u){u=(0,I.$7g)();try{await R.writeFile(C.serviceMachineIdResource,P.$Se.fromString(u))}catch{}}return m?.store("storage.serviceMachineId",u,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),u}}),define(le[143],he([0,1,142,18,41]),function(Q,e,P,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=k;async function k(C,R,m,u,d,f,$){const h={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${R.nameShort})`};if((0,v.$Kp)(R,m)&&(0,v.$Mp)(u)===I.TelemetryLevel.USAGE){const g=await(0,P.$uq)(m,d,f);h["X-Market-User-Id"]=g,h["VSCode-SessionId"]=$.machineId||g}return h}}),define(le[144],he([0,1,19,21,7,11,36,3,12,83,30,17,20,26,22,44,9,6,33,46,143,74,18,156]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c,O,w,i,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0,e.$wq=V;const r=k.$r?g.TargetPlatform.WEB:(0,$.$np)(k.$x,C.$jc),t="X-Market-Search-Activity-Id";var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished",G[G.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function o(...G){return String(G.reduce((q,Z)=>q|Z,0))}var l;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(l||(l={}));const p={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},A={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},N={pageNumber:1,pageSize:10,sortBy:$.SortBy.NoneOrRelevance,sortOrder:$.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class D{constructor(q=N){this.d=q}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(q,Z=this.d.pageSize){return new D({...this.d,pageNumber:q,pageSize:Z})}withFilter(q,...Z){const re=[...this.d.criteria,...Z.length?Z.map(ce=>({filterType:q,value:ce})):[{filterType:q}]];return new D({...this.d,criteria:re})}withSortBy(q){return new D({...this.d,sortBy:q})}withSortOrder(q){return new D({...this.d,sortOrder:q})}withFlags(...q){return new D({...this.d,flags:q.reduce((Z,re)=>Z|re,0)})}withAssetTypes(...q){return new D({...this.d,assetTypes:q})}withSource(q){return new D({...this.d,source:q})}get raw(){const{criteria:q,pageNumber:Z,pageSize:re,sortBy:ce,sortOrder:fe,flags:we,assetTypes:de}=this.d;return{filters:[{criteria:q,pageNumber:Z,pageSize:re,sortBy:ce,sortOrder:fe}],assetTypes:de,flags:we}}get searchText(){const q=this.d.criteria.filter(Z=>Z.filterType===l.SearchText)[0];return q&&q.value?q.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(q=>String(q.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(G,q){const Z=(G||[]).filter(re=>re.statisticName===q)[0];return Z?Z.value:0}function x(G){const q="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(re=>re.assetType.indexOf(q)===0).reduce((re,ce)=>{const fe=ae(G,ce.assetType);return fe&&re.push([ce.assetType.substring(q.length),fe]),re},[])}function Y(G){if(G.properties){const q=G.properties.filter(ce=>ce.key===p.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=q.filter(ce=>Z.test(ce.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return ae(G,p.Repository)}function ne(G){return{uri:`${G.fallbackAssetUri}/${p.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${p.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function ae(G,q){return G.files.filter(re=>re.assetType===q)[0]?{uri:`${G.assetUri}/${q}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${q}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}:null}function ue(G,q){const Z=G.properties?G.properties.filter(ce=>ce.key===q):[],re=Z.length>0&&Z[0].value;return re?re.split(",").map(ce=>(0,h.$Wp)(ce)):[]}function me(G){const q=G.properties?G.properties.filter(Z=>Z.key===A.Engine):[];return q.length>0&&q[0].value||""}function W(G){const q=G.properties?G.properties.filter(Z=>Z.key===A.PreRelease):[];return q.length>0&&q[0].value==="true"}function _(G){const q=G.properties?G.properties.filter(Z=>Z.key===A.ExecutesCode):[];return q.length>0?q[0].value==="true":void 0}function M(G){const q=G.properties?G.properties.filter(re=>re.key===A.EnabledApiProposals):[],Z=q.length>0&&q[0].value||"";return Z?Z.split(","):[]}function U(G){const q=G.properties?G.properties.filter(re=>re.key===A.LocalizedLanguages):[],Z=q.length>0&&q[0].value||"";return Z?Z.split(","):[]}function H(G){return G.properties?.find(q=>q.key===A.SponsorLink)?.value}function K(G){return G.properties?.find(q=>q.key===A.SupportLink)?.value}function ie(G){return G.indexOf("preview")!==-1}function se(G){return G.targetPlatform?(0,$.$mp)(G.targetPlatform):g.TargetPlatform.UNDEFINED}function L(G){const q=(0,P.$Qb)(G.versions.map(se)),Z=!!G.tags?.includes($.$gp),re=q.indexOf(g.TargetPlatform.WEB);return Z?re===-1&&q.push(g.TargetPlatform.WEB):re!==-1&&q.splice(re,1),q}function V(G,q){for(let Z=0;Z<G.length;Z++){const re=G[Z];if(re.version===G[Z-1]?.version){let ce=Z;if(se(re)===q)for(;ce>0&&G[ce-1].version===re.version;)ce--;ce!==Z&&(G.splice(Z,1),G.splice(ce,0,re))}}return G}function z(G,q,Z){G.telemetryData={index:q,querySource:Z,queryActivityId:G.queryContext?.[t]}}function E(G,q,Z,re){const ce=G.versions[0],fe={manifest:ae(q,p.Manifest),readme:ae(q,p.Details),changelog:ae(q,p.Changelog),license:ae(q,p.License),repository:Y(q),download:ne(q),icon:ae(q,p.Icon),signature:ae(q,p.Signature),coreTranslations:x(q)};return{type:"gallery",identifier:{id:(0,h.$Xp)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:q.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(ce),description:G.shortDescription??"",installCount:j(G.statistics,"install"),rating:j(G.statistics,"averagerating"),ratingCount:j(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:Z,assets:fe,properties:{dependencies:ue(q,A.Dependency),extensionPack:ue(q,A.ExtensionPack),engine:me(q),enabledApiProposals:M(q),localizedLanguages:U(q),targetPlatform:se(q),isPreReleaseVersion:W(q),executesCode:_(q)},hasPreReleaseVersion:W(ce),hasReleaseVersion:!0,preview:ie(G.flags),isSigned:!!fe.signature,queryContext:re,supportLink:K(ce)}}let F=class{constructor(q,Z,re,ce,fe,we,de,pe){this.l=Z,this.n=re,this.o=ce,this.q=fe,this.u=we,this.w=de,this.x=pe;const ye=de.extensionsGallery,$e=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=$e?ye.servicePPEUrl:ye?.serviceUrl,this.g=$e?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.k=de.extensionsEnabledWithApiProposalVersion?.map(ve=>ve.toLowerCase())??[],this.j=(0,w.$vq)(de.version,de,this.o,this.x,this.u,q,this.q)}y(q=""){return`${this.d}${q}`}isEnabled(){return!!this.d}async getExtensions(q,Z,re){const ce=I.CancellationToken.isCancellationToken(Z)?{}:Z,fe=I.CancellationToken.isCancellationToken(Z)?Z:re,we=[],de=[],pe=[],ye=[];let $e=!0;for(const ee of q){ee.uuid?de.push(ee.uuid):we.push(ee.id);const te=!!(ee.version||ee.preRelease);pe.push({id:ee.id,uuid:ee.uuid,includePreRelease:te}),ee.version&&ye.push({id:ee.id,uuid:ee.uuid,version:ee.version}),$e=$e&&!!ee.hasPreRelease&&!te}if(!de.length&&!we.length)return[];let ve=new D().withPage(1,q.length);de.length&&(ve=ve.withFilter(l.ExtensionId,...de)),we.length&&(ve=ve.withFilter(l.ExtensionName,...we)),(ce.queryAllVersions||$e)&&(ve=ve.withFlags(ve.flags,s.IncludeVersions)),ce.source&&(ve=ve.withSource(ce.source));const{extensions:B}=await this.B(ve,{targetPlatform:ce.targetPlatform??r,includePreRelease:pe,versions:ye,compatible:!!ce.compatible,productVersion:ce.productVersion??{version:this.w.version,date:this.w.date}},fe);return ce.source&&B.forEach((ee,te)=>z(ee,te,ce.source)),B}async getCompatibleExtension(q,Z,re,ce={version:this.w.version,date:this.w.date}){if((0,$.$op)(q.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(q,Z,re))return q;const fe=new D().withFlags(s.IncludeVersions).withPage(1,1).withFilter(l.ExtensionId,q.identifier.uuid),{extensions:we}=await this.B(fe,{targetPlatform:re,compatible:!0,includePreRelease:Z,productVersion:ce},I.CancellationToken.None);return we[0]||null}async isExtensionCompatible(q,Z,re,ce={version:this.w.version,date:this.w.date}){if(!(0,$.$pp)(q.properties.targetPlatform,q.allTargetPlatforms,re)||!Z&&q.properties.isPreReleaseVersion)return!1;let fe=q.properties.engine;if(!fe){const we=await this.getManifest(q,I.CancellationToken.None);if(!we)throw new Error("Manifest was not found");fe=we.engines.vscode}return!(!(0,S.$_p)(fe,ce.version,ce.date)||!this.z(q.identifier,q.properties.enabledApiProposals))}z(q,Z){return!Z||!this.k.includes(q.id.toLowerCase())?!0:(0,S.$aq)(Z)}async A(q,Z,re,ce,fe,we,de={version:this.w.version,date:this.w.date}){if(!(0,$.$pp)(se(Z),fe,we)||re!=="any"&&W(Z)!==(re==="prerelease"))return!1;if(ce)try{const pe=await this.G(q,Z);if(!(0,S.$_p)(pe,de.version,de.date))return!1}catch(pe){return this.n.error(`Error while getting the engine for the version ${Z.version}.`,(0,v.$bb)(pe)),!1}return!0}async query(q,Z){let re=q.text||"";const ce=q.pageSize??50;let fe=new D().withPage(1,ce);re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,ve,B)=>(fe=fe.withFilter(l.Category,B||ve),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,ve,B)=>(fe=fe.withFilter(l.Tag,B||ve),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(fe=fe.withFilter(l.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),fe=fe.withFilter(l.SearchText,re)),fe=fe.withSortBy($.SortBy.NoneOrRelevance)):q.ids?fe=fe.withFilter(l.ExtensionId,...q.ids):q.names?fe=fe.withFilter(l.ExtensionName,...q.names):fe=fe.withSortBy($.SortBy.InstallCount),typeof q.sortBy=="number"&&(fe=fe.withSortBy(q.sortBy)),typeof q.sortOrder=="number"&&(fe=fe.withSortOrder(q.sortOrder)),q.source&&(fe=fe.withSource(q.source));const we=async($e,ve)=>{const{extensions:B,total:ee}=await this.B($e,{targetPlatform:r,compatible:!1,includePreRelease:!!q.includePreRelease,productVersion:q.productVersion??{version:this.w.version,date:this.w.date}},ve);return B.forEach((te,ge)=>z(te,($e.pageNumber-1)*$e.pageSize+ge,q.source)),{extensions:B,total:ee}},{extensions:de,total:pe}=await we(fe,Z),ye=async($e,ve)=>{if(ve.isCancellationRequested)throw new v.$9;const{extensions:B}=await we(fe.withPage($e+1),ve);return B};return{firstPage:de,total:pe,pageSize:fe.pageSize,getPage:ye}}async B(q,Z,re){const ce=q.flags;q.flags&s.IncludeLatestVersionOnly&&q.flags&s.IncludeVersions&&(q=q.withFlags(q.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(q.flags&s.IncludeLatestVersionOnly)&&!(q.flags&s.IncludeVersions)&&(q=q.withFlags(q.flags,s.IncludeLatestVersionOnly)),Z.versions?.length&&(q=q.withFlags(q.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),q=q.withFlags(q.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:fe,total:we,context:de}=await this.D(q,re);if(!(q.flags&s.IncludeLatestVersionOnly)){const ve=[];for(const B of fe){const ee=await this.C(B,Z,de);ee&&ve.push(ee)}return{extensions:ve,total:we}}const ye=[],$e=new Map;for(let ve=0;ve<fe.length;ve++){const B=fe[ve],ee={id:(0,h.$Xp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},te=(0,R.$pg)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(Se=>(0,h.$Sp)(Se,ee))?.includePreRelease;if(Z.compatible&&(0,$.$op)(L(B),Z.targetPlatform))continue;const ge=await this.C(B,Z,de);!ge||ge.properties.isPreReleaseVersion&&(!te||!ge.hasReleaseVersion)||!ge.properties.isPreReleaseVersion&&ge.properties.targetPlatform!==Z.targetPlatform&&ge.hasPreReleaseVersion?$e.set(B.extensionId,ve):ye.push([ve,ge])}if($e.size){const ve=new n.$ke,B=new D().withFlags(ce&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,$e.size).withFilter(l.ExtensionId,...$e.keys()),{extensions:ee}=await this.B(B,Z,re);this.q.publicLog2("galleryService:additionalQuery",{duration:ve.elapsed(),count:$e.size});for(const te of ee){const ge=$e.get(te.identifier.uuid);ye.push([ge,te])}}return{extensions:ye.sort((ve,B)=>ve[0]-B[0]).map(([,ve])=>ve),total:we}}async C(q,Z,re){const ce={id:(0,h.$Xp)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},fe=Z.versions?.find(ye=>(0,h.$Sp)(ye,ce))?.version,we=(0,R.$pg)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(ye=>(0,h.$Sp)(ye,ce))?.includePreRelease,de=L(q),pe=V(q.versions,Z.targetPlatform);if(Z.compatible&&(0,$.$op)(de,Z.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const $e=pe[ye];if(!(fe&&$e.version!==fe)){if(await this.A(ce.id,$e,we?"any":"release",Z.compatible,de,Z.targetPlatform,Z.productVersion))return Z.compatible&&!this.z(ce,M($e))?null:E(q,$e,de,re);if(fe&&$e.version===fe)return null}}return fe||Z.compatible?null:E(q,q.versions[0],de)}async D(q,Z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");q=q.withFlags(q.flags,s.ExcludeNonValidated).withFilter(l.Target,"Microsoft.VisualStudio.Code").withFilter(l.ExcludeWithFlags,o(s.Unpublished));const re=await this.j,ce=JSON.stringify(q.raw),fe={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},we=new n.$ke;let de,pe,ye=0;try{if(de=await this.l.request({type:"POST",url:this.g&&q.criteria.some(ve=>ve.filterType===l.SearchText)?this.g:this.y("/extensionquery"),data:ce,headers:fe},Z),de.res.statusCode&&de.res.statusCode>=400&&de.res.statusCode<500)return{galleryExtensions:[],total:ye};const $e=await(0,O.$hq)(de);if($e){const ve=$e.results[0],B=ve.extensions,ee=ve.resultMetadata&&ve.resultMetadata.filter(te=>te.metadataType==="ResultCount")[0];return ye=ee&&ee.metadataItems.filter(te=>te.name==="TotalCount")[0].count||0,{galleryExtensions:B,total:ye,context:de.res.headers.activityid?{[t]:de.res.headers.activityid}:{}}}return{galleryExtensions:[],total:ye}}catch($e){if((0,v.$8)($e))throw pe=$.ExtensionGalleryErrorCode.Cancelled,$e;{const ve=(0,v.$bb)($e);throw pe=(0,u.$cp)($e)?$.ExtensionGalleryErrorCode.Offline:ve.startsWith("XHR timeout")?$.ExtensionGalleryErrorCode.Timeout:$.ExtensionGalleryErrorCode.Failed,new $.$sp(ve,pe)}}finally{this.q.publicLog2("galleryService:query",{...q.telemetryData,requestBodySize:String(ce.length),duration:we.elapsed(),success:!!de&&(0,O.$dq)(de),responseBodySize:de?.res.headers["Content-Length"],statusCode:de?String(de.res.statusCode):void 0,errorCode:pe,count:String(ye)})}}async reportStatistic(q,Z,re,ce){if(!this.isEnabled())return;const fe=k.$r?this.y(`/itemName/${q}.${Z}/version/${re}/statType/${ce===$.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${q}/extensions/${Z}/${re}/stats?statType=${ce}`),we=k.$r?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:we};try{await this.l.request({type:"POST",url:fe,headers:pe},I.CancellationToken.None)}catch{}}async download(q,Z,re){this.n.trace("ExtensionGalleryService#download",q.identifier.id);const ce=(0,h.$1p)(q),fe=new Date().getTime(),we=re===$.InstallOperation.Install?"install":re===$.InstallOperation.Update?"update":"",de=we?{uri:`${q.assets.download.uri}${m.URI.parse(q.assets.download.uri).query?"&":"?"}${we}=true`,fallbackUri:`${q.assets.download.fallbackUri}${m.URI.parse(q.assets.download.fallbackUri).query?"&":"?"}${we}=true`}:q.assets.download,pe=q.queryContext?.[t]?{[t]:q.queryContext[t]}:void 0,ye=await this.F(q.identifier.id,de,p.VSIX,pe?{headers:pe}:void 0);try{await this.u.writeFile(Z,ye.stream)}catch($e){try{await this.u.del(Z)}catch(ve){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,v.$bb)(ve))}throw new $.$sp((0,v.$bb)($e),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ce,duration:new Date().getTime()-fe})}async downloadSignatureArchive(q,Z){if(!q.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",q.identifier.id);const re=await this.F(q.identifier.id,q.assets.signature,p.Signature);try{await this.u.writeFile(Z,re.stream)}catch(ce){try{await this.u.del(Z)}catch(fe){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,v.$bb)(fe))}throw new $.$sp((0,v.$bb)(ce),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(q,Z){if(q.assets.readme){const re=await this.F(q.identifier.id,q.assets.readme,p.Details,{},Z);return await(0,O.$gq)(re)||""}return""}async getManifest(q,Z){if(q.assets.manifest){const re=await this.F(q.identifier.id,q.assets.manifest,p.Manifest,{},Z),ce=await(0,O.$gq)(re);return ce?JSON.parse(ce):null}return null}async E(q,Z,re){const ce=ae(Z,p.Manifest);if(!ce)throw new Error("Manifest was not found");const fe={"Accept-Encoding":"gzip"},we=await this.F(q,ce,p.Manifest,{headers:fe});return await(0,O.$hq)(we)}async getCoreTranslation(q,Z){const re=q.assets.coreTranslations.filter(ce=>ce[0]===Z.toUpperCase())[0];if(re){const ce=await this.F(q.identifier.id,re[1],re[0]),fe=await(0,O.$gq)(ce);return fe?JSON.parse(fe):null}return null}async getChangelog(q,Z){if(q.assets.changelog){const re=await this.F(q.identifier.id,q.assets.changelog,p.Changelog,{},Z);return await(0,O.$gq)(re)||""}return""}async getAllCompatibleVersions(q,Z,re){let ce=new D().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);q.uuid?ce=ce.withFilter(l.ExtensionId,q.uuid):ce=ce.withFilter(l.ExtensionName,q.id);const{galleryExtensions:fe}=await this.D(ce,I.CancellationToken.None);if(!fe.length)return[];const we=L(fe[0]);if((0,$.$op)(we,re))return[];const de=[];await Promise.all(fe[0].versions.map(async $e=>{try{await this.A(q.id,$e,Z?"any":"release",!0,we,re)&&this.z(q,M($e))&&de.push($e)}catch{}}));const pe=[],ye=new Set;for(const $e of V(de,re))ye.has($e.version)||(ye.add($e.version),pe.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:W($e)}));return pe}async F(q,Z,re,ce={},fe=I.CancellationToken.None){const we=await this.j,de={type:"GET"},pe={...we,...ce.headers||{}};ce={...ce,...de,headers:pe};const ye=Z.uri,$e=Z.fallbackUri,ve={...ce,url:ye};try{const B=await this.l.request(ve,fe);if(B.res.statusCode===200)return B;const ee=await(0,O.$gq)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${ee}`)}catch(B){if((0,v.$8)(B))throw B;const ee=(0,v.$bb)(B);this.q.publicLog2("galleryService:cdnFallback",{extension:q,assetType:re,message:ee});const te={...ce,url:$e};return this.l.request(te,fe)}}async G(q,Z){let re=me(Z);if(!re){this.q.publicLog2("galleryService:engineFallback",{extension:q,version:Z.version});const ce=await this.E(q,Z,I.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");re=ce.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const q=await this.l.request({type:"GET",url:this.h},I.CancellationToken.None);if(q.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,O.$hq)(q),re=[],ce={},fe=[],we=[];if(Z){for(const de of Z.malicious)re.push({id:de});if(Z.migrateToPreRelease)for(const[de,pe]of Object.entries(Z.migrateToPreRelease))(!pe.engine||(0,S.$_p)(pe.engine,this.w.version,this.w.date))&&(ce[de.toLowerCase()]={disallowInstall:!0,extension:{id:pe.id,displayName:pe.displayName,autoMigrate:{storage:!!pe.migrateStorage},preRelease:!0}});if(Z.deprecated)for(const[de,pe]of Object.entries(Z.deprecated))pe&&(ce[de.toLowerCase()]=(0,R.$pg)(pe)?{}:pe);if(Z.search)for(const de of Z.search)fe.push(de);if(Array.isArray(Z.extensionsEnabledWithPreRelease))for(const de of Z.extensionsEnabledWithPreRelease)we.push(de.toLowerCase())}return{malicious:re,deprecated:ce,search:fe,extensionsEnabledWithPreRelease:we}}};F=Ee([oe(1,O.$bq),oe(2,y.$fk),oe(3,f.$Ri),oe(4,a.$em),oe(5,b.$fl),oe(6,c.$yk),oe(7,d.$ej)],F);let X=class extends F{constructor(q,Z,re,ce,fe,we,de,pe){super(q,Z,re,ce,fe,we,de,pe)}};e.$xq=X,e.$xq=X=Ee([oe(0,i.$oq),oe(1,O.$bq),oe(2,y.$fk),oe(3,f.$Ri),oe(4,a.$em),oe(5,b.$fl),oe(6,c.$yk),oe(7,d.$ej)],X);let J=class extends F{constructor(q,Z,re,ce,fe,we,de){super(void 0,q,Z,re,ce,fe,we,de)}};e.$yq=J,e.$yq=J=Ee([oe(0,O.$bq),oe(1,y.$fk),oe(2,f.$Ri),oe(3,a.$em),oe(4,b.$fl),oe(5,c.$yk),oe(6,d.$ej)],J)}),define(le[145],he([0,1,12,17,9,6,124,23,24,3,70]),function(Q,e,P,I,v,k,C,R,m,u,d){"use strict";var f,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$8R=e.$7R=e.$6R=void 0;let h=class extends m.$Ul{static{f=this}static{this.a="profileAssociationsMigration"}constructor(y,c,O,w,i){super(O,w,c,i),this.U=y,this.W=O}O(){return this.U.getItem(f.b,[]).map(c=>({...c,location:(0,u.$jg)(c.location)?this.w.extUri.joinPath(this.profilesHome,c.location):P.URI.revive(c.location)}))}Q(){const y=this.U.getItem(f.c,{});return this.U.getItem(f.a,!1)?y:this.N(y)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$6R=h,e.$6R=h=f=Ee([oe(0,C.$1R),oe(1,R.$Pl),oe(2,I.$Si),oe(3,v.$fl),oe(4,k.$fk)],h);let g=$=class extends h{constructor(y,c,O,w,i){super(y,c,O,w,i),this.$=y}P(y){y.length?this.$.setItem($.b,y.map(c=>({...c,location:this.w.extUri.basename(c.location)}))):this.$.removeItem($.b)}O(){const y=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(y),this.$.setItem("userDataProfilesMigration",!0)),y}R(y){y.emptyWindows||y.workspaces?this.$.setItem($.c,y):this.$.removeItem($.c)}Q(){const y="workspaceAndProfileInfo",c=this.$.getItem(y,void 0);if(c){this.$.removeItem(y);const w=c.reduce((i,{workspace:a,profile:n})=>(i[P.URI.revive(a).toString()]=P.URI.revive(n).toString(),i),{});this.$.setItem($.c,{workspaces:w})}const O=super.Q();return this.$.getItem($.a,!1)||(this.R(O),this.$.setItem($.a,!0)),O}};e.$7R=g,e.$7R=g=$=Ee([oe(0,C.$2R),oe(1,R.$Pl),oe(2,I.$Si),oe(3,v.$fl),oe(4,k.$fk)],g);let S=class extends g{constructor(y,c,O,w){super(new d.$5R(d.SaveStrategy.IMMEDIATE,c,w,O),y,c,O,w)}async init(){return await this.$.init(),super.init()}};e.$8R=S,e.$8R=S=Ee([oe(0,R.$Pl),oe(1,I.$Si),oe(2,v.$fl),oe(3,k.$fk)],S)}),define(le[146],he([0,1,122,8,13,7,3,30,17,123,6,46,121,157]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0,e.$os=b;let g=class extends f.$cq{constructor(c,O,w,i){super(i),this.m=c,this.n=O,this.r=w,this.s(),this.B(c.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.s()}))}s(){const c=this.m.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,O){const{f:w,g:i}=this;let a;try{a=await(0,u.$Wm)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$bb)(t)))}const n={...process.env,...a},r=c.agent?c.agent:await(0,$.$ms)(c.url||"",n,{proxyUrl:w,strictSSL:i});return c.agent=r,c.strictSSL=i,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>b(c,O))}async resolveProxy(c){}async lookupAuthorization(c){}async lookupKerberosAuthorization(c){try{const O=await new Promise((r,t)=>{Q(["kerberos"],r,t)}).then(be),w=new URL(c),i=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${w.hostname}`:`HTTP@${w.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${w}`,`spn:${i}`),"Negotiate "+await(await O.initializeClient(i)).step("")}catch(O){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",O);return}}async loadCertificates(){return(await new Promise((O,w)=>{Q(["@vscode/proxy-agent"],O,w)}).then(be)).loadSystemCertificates({log:this.r})}};e.$ns=g,e.$ns=g=Ee([oe(0,R.$ej),oe(1,m.$Si),oe(2,d.$fk),oe(3,d.$gk)],g);async function S(y){return((0,P.parse)(y.url).protocol==="https:"?await new Promise((w,i)=>{Q(["https"],w,i)}).then(be):await new Promise((w,i)=>{Q(["http"],w,i)}).then(be)).request}async function b(y,c){return I.Promises.withAsyncBody(async(O,w)=>{const i=(0,P.parse)(y.url),a=y.getRawRequest?y.getRawRequest(y):await S(y),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,C.$pg)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(n.auth=y.user+":"+y.password);const r=a(n,t=>{const s=(0,C.$ng)(y.followRedirects)?y.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&s>0&&t.headers.location)b({...y,url:t.headers.location,followRedirects:s-1},c).then(O,w);else{let o=t;!y.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,h.createGunzip)())),O({res:t,stream:(0,v.$8e)(o)})}});r.on("error",w),y.timeout&&r.setTimeout(y.timeout),y.isChromiumNetwork&&r.removeHeader("Content-Length"),y.data&&typeof y.data=="string"&&r.write(y.data),r.end(),c.onCancellationRequested(()=>{r.abort(),w(new k.$9)})})}});var ze=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(le[158],he([0,1,32,35,8,38,7,2,14,15,11,36,12,30,118,62,120,17,96,144,20,72,125,42,54,139,141,9,108,110,51,106,65,69,127,6,114,39,115,130,33,46,146,70,71,18,129,41,131,132,23,134,24,145,133,140,111,113,4,135,159]),function(Q,e,P,I,v,k,C,R,m,u,d,f,$,h,g,S,b,y,c,O,w,i,a,n,r,t,s,o,l,p,A,T,N,D,j,x,Y,ne,ae,ue,me,W,_,M,U,H,K,ie,se,L,V,z,E,F,X,J,G,q,Z,re,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=we,P=be(P),ue=ze(ue);class fe extends R.$Zc{constructor(pe){super(),this.b=pe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[pe,ye]=await this.f();return pe.invokeFunction(async $e=>{const ve=$e.get(x.$fk),B=$e.get(o.$fl),ee=$e.get(y.$Si),te=$e.get(E.$Rl);ve.info("CLI main",this.b),this.h(ve),await this.j(ee,B,te,pe),await Promise.all(ye.map(ge=>{(0,v.$Bh)(ge.flush(),1e3)}))})}async f(){const pe=new N.$Ii,ye={_serviceBrand:void 0,...ue.default};pe.set(me.$yk,ye);const $e=new c.$cn(this.b,ye);pe.set(y.$Si,$e),await Promise.all([this.g($e.appSettingsHome.with({scheme:m.Schemas.file}).fsPath),this.g($e.extensionsPath)].map(Ie=>Ie?P.promises.mkdir(Ie,{recursive:!0}):void 0));const ve=new q.$ZR((0,x.$tk)($e),$e.logsHome);pe.set(x.$gk,ve);const B=this.B(ve.createLogger("cli",{name:(0,Z.localize)(171,null)})),ee=[];ve.getLogLevel()===x.LogLevel.Trace&&ee.push(new x.$nk(ve.getLogLevel()));const te=this.B(new G.$0R(B,ee));pe.set(x.$fk,te);const ge=this.B(new l.$$q(te));pe.set(o.$fl,ge);const Se=this.B(new p.$Br(te));ge.registerProvider(m.Schemas.file,Se);const Ne=new z.$3s(ge);pe.set(V.$Pl,Ne);const ke=new M.$4R(M.SaveStrategy.DELAYED,$e,te,ge),Te=new F.$6R(ke,Ne,$e,ge,te);pe.set(E.$Rl,Te),ge.registerProvider(m.Schemas.vscodeUserData,new re.$$ic(m.Schemas.file,Se,m.Schemas.vscodeUserData,Te,Ne,te));const Oe=d.$l&&ye.win32RegValueName?this.B(new ae.$9ic(te,ye.win32RegValueName)):$e.policyFile?this.B(new Y.$0ic($e.policyFile,ge,te)):new ne.$Bo;pe.set(ne.$zo,Oe);const Ce=this.B(new g.$4o(Te.defaultProfile.settingsResource,ge,Oe,te));pe.set(h.$ej,Ce),await Promise.all([ke.init(),Ce.initialize()]);let Ue;try{Ue=await(0,X.$Kic)(ke,te)}catch(Ie){Ie.code!=="ENOENT"&&te.error(Ie)}const De=await(0,X.$Lic)(ke,te),Le=await(0,X.$Mic)(ke,te);Te.init(),pe.set(V.$Pl,new z.$3s(ge));const Fe=new _.$ns(Ce,$e,te,ve);pe.set(W.$bq,Fe),pe.set(S.$8o,new A.$Hi(b.$oS,void 0,!0)),pe.set(n.$Rq,new A.$Hi(J.$9R,void 0,!0)),pe.set(r.$Vq,new A.$Hi(s.$Hic,void 0,!0)),pe.set(i.$Bq,new A.$Hi(i.$Dq,void 0,!0)),pe.set(t.$7q,new A.$Hi(t.$8q,void 0,!0)),pe.set(w.$rp,new A.$Hi(O.$yq,void 0,!0)),pe.set(D.$hs,new A.$Hi(j.$js,void 0,!1));const qe=[],Pe=(0,ie.$Pp)(ye,Ce);if((0,ie.$Kp)(ye,$e)){ye.aiConfig&&ye.aiConfig.ariaKey&&qe.push(new se.$XR(Fe,Pe,"monacoworkbench",null,ye.aiConfig.ariaKey));const Ie={appenders:qe,sendErrorTelemetry:!1,commonProperties:(0,U.$Bp)((0,I.release)(),(0,I.hostname)(),process.arch,ye.commit,ye.version,Ue,De,Le,Pe),piiPaths:(0,ie.$Qp)($e)};pe.set(H.$em,new A.$Hi(K.$ps,[Ie],!1))}else pe.set(H.$em,ie.$Fp);return[new T.$Er(pe),qe]}g(pe){if(d.$l){const ye=(0,ce.getUNCHost)(pe);ye&&(0,ce.addUNCHostToAllowlist)(ye)}return pe}h(pe){(0,C.setUnexpectedErrorHandler)(ye=>{const $e=(0,k.$vj)(ye,!0);$e&&pe.error(`[uncaught exception in CLI]: ${$e}`)}),process.on("uncaughtException",ye=>{(0,C.$3)(ye)||(0,C.$4)(ye)}),process.on("unhandledRejection",ye=>(0,C.$4)(ye))}async j(pe,ye,$e,ve){let B;if(pe.args.profile&&(B=$e.profiles.find(te=>te.name===pe.args.profile),!B))throw new Error(`Profile '${pe.args.profile}' not found.`);const ee=(B??$e.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ve.createInstance(a.$Eq,new x.$nk(x.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return ve.createInstance(a.$Eq,new x.$nk(x.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),te,!!this.b.force)}else{if(this.b["uninstall-extension"])return ve.createInstance(a.$Eq,new x.$nk(x.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return ve.createInstance(a.$Eq,new x.$nk(x.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return ve.createInstance(a.$Eq,new x.$nk(x.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,L.$ojc)(pe.appRoot,pe.extensionsPath))}}m(pe){return pe.map(ye=>/\.vsix$/i.test(ye)?$.URI.file((0,u.$nc)(ye)?ye:(0,u.$oc)((0,f.cwd)(),ye)):ye)}}async function we(de){const pe=new fe(de);try{await pe.run()}finally{pe.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/36e4ddb4dbdf5d41bbeedfce2db4834085de2b87/core/vs/code/node/cliProcessMain.js.map
