/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/map","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","vs/amdX","child_process","vs/base/node/zip","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/nls.messages","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/jsonSchema","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/sandbox/node/electronTypes","vs/base/common/jsonErrorMessages","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],de=function(ce){for(var e=[],P=0,a=ce.length;P<a;P++)e[P]=fe[ce[P]];return e};define(fe[130],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=e.LoaderEventType=e.$W=e.$V=void 0,e.$V=!1,e.$W=!0;var P;(function(L){L[L.LoaderAvailable=1]="LoaderAvailable",L[L.BeginLoadingScript=10]="BeginLoadingScript",L[L.EndLoadingScriptOK=11]="EndLoadingScriptOK",L[L.EndLoadingScriptError=12]="EndLoadingScriptError",L[L.BeginInvokeFactory=21]="BeginInvokeFactory",L[L.EndInvokeFactory=22]="EndInvokeFactory",L[L.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",L[L.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",L[L.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",L[L.NodeEndNativeRequire=34]="NodeEndNativeRequire",L[L.CachedDataFound=60]="CachedDataFound",L[L.CachedDataMissed=61]="CachedDataMissed",L[L.CachedDataRejected=62]="CachedDataRejected",L[L.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class a{static get(){const k=new Map,T=new Map,C=new Map,A=new Map;function b(l,f){l.has(f.detail)||l.set(f.detail,-f.timestamp)}function R(l,f){const E=l.get(f.detail);E&&(E>=0||l.set(f.detail,E+f.timestamp))}let p=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(p=ce.getStats().slice(0).sort((l,f)=>l.timestamp-f.timestamp));for(const l of p)switch(l.type){case P.BeginLoadingScript:b(k,l);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:R(k,l);break;case P.BeginInvokeFactory:b(T,l);break;case P.EndInvokeFactory:R(T,l);break;case P.NodeBeginNativeRequire:b(C,l);break;case P.NodeEndNativeRequire:R(C,l);break;case P.NodeBeginEvaluatingScript:b(A,l);break;case P.NodeEndEvaluatingScript:R(A,l);break}let m=0;C.forEach(l=>m+=l);function g(l){const f=[];return l.forEach((E,w)=>f.push([w,E])),f}return{amdLoad:g(k),amdInvoke:g(T),nodeRequire:g(C),nodeEval:g(A),nodeRequireTotal:m}}static toMarkdownTable(k,T){let C="";const A=[];return k.forEach((b,R)=>{A[R]=b.length}),T.forEach(b=>{b.forEach((R,p)=>{typeof R>"u"&&(R=b[p]="-");const m=R.toString().length;A[p]=Math.max(m,A[p])})}),k.forEach((b,R)=>{C+=`| ${b+" ".repeat(A[R]-b.toString().length)} `}),C+=`|
`,k.forEach((b,R)=>{C+=`| ${"-".repeat(A[R])} `}),C+=`|
`,T.forEach(b=>{b.forEach((R,p)=>{typeof R<"u"&&(C+=`| ${R+" ".repeat(A[p]-R.toString().length)} `)}),C+=`|
`}),C}}e.$X=a}),define(fe[131],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=void 0,e.$jb=P,e.$kb=a,e.$lb=L,e.$mb=k,e.$nb=T,e.$ob=C,e.$pb=A,e.$rb=R,e.$sb=p,e.$tb=m,e.$ub=g,e.$vb=l;function P(f,E){const w=a(f,E);if(w!==-1)return f[w]}function a(f,E,w=f.length-1){for(let d=w;d>=0;d--){const I=f[d];if(E(I))return d}return-1}function L(f,E){const w=k(f,E);return w===-1?void 0:f[w]}function k(f,E,w=0,d=f.length){let I=w,$=d;for(;I<$;){const c=Math.floor((I+$)/2);E(f[c])?I=c+1:$=c}return I-1}function T(f,E){const w=C(f,E);return w===f.length?void 0:f[w]}function C(f,E,w=0,d=f.length){let I=w,$=d;for(;I<$;){const c=Math.floor((I+$)/2);E(f[c])?$=c:I=c+1}return I}function A(f,E,w=0,d=f.length){const I=C(f,E,w,d);return I===f.length?-1:I}class b{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(b.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!E(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const w=k(this.e,E,this.c);return this.c=w+1,w===-1?void 0:this.e[w]}}e.$qb=b;function R(f,E){if(f.length===0)return;let w=f[0];for(let d=1;d<f.length;d++){const I=f[d];E(I,w)>0&&(w=I)}return w}function p(f,E){if(f.length===0)return;let w=f[0];for(let d=1;d<f.length;d++){const I=f[d];E(I,w)>=0&&(w=I)}return w}function m(f,E){return R(f,(w,d)=>-E(w,d))}function g(f,E){if(f.length===0)return-1;let w=0;for(let d=1;d<f.length;d++){const I=f[d];E(I,f[w])>0&&(w=d)}return w}function l(f,E){for(const w of f){const d=E(w);if(d!==void 0)return d}}}),define(fe[39],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(P||(e.CharCode=P={}))}),define(fe[132],de([0,1]),function(ce,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$i=void 0,e.$e=a,e.$f=L,e.$g=k,e.$h=T;function a(A,b){const R=Object.create(null);for(const p of A){const m=b(p);let g=R[m];g||(g=R[m]=[]),g.push(p)}return R}function L(A,b){const R=[],p=[];for(const m of A)b.has(m)||R.push(m);for(const m of b)A.has(m)||p.push(m);return{removed:R,added:p}}function k(A,b){const R=[],p=[];for(const[m,g]of A)b.has(m)||R.push(g);for(const[m,g]of b)A.has(m)||p.push(g);return{removed:R,added:p}}function T(A,b){const R=new Set;for(const p of b)A.has(p)&&R.add(p);return R}class C{static{P=Symbol.toStringTag}constructor(b,R){this.b=R,this.a=new Map,this[P]="SetWithKey";for(const p of b)this.add(p)}get size(){return this.a.size}add(b){const R=this.b(b);return this.a.set(R,b),this}delete(b){return this.a.delete(this.b(b))}has(b){return this.a.has(this.b(b))}*entries(){for(const b of this.a.values())yield[b,b]}keys(){return this.values()}*values(){for(const b of this.a.values())yield b}clear(){this.a.clear()}forEach(b,R){this.a.forEach(p=>b.call(R,p,p,this))}[Symbol.iterator](){return this.values()}}e.$i=C}),define(fe[88],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=a,e.$di=L,e.$ei=k;function P(T){return(C,A,b)=>{let R=null,p=null;if(typeof b.value=="function"?(R="value",p=b.value):typeof b.get=="function"&&(R="get",p=b.get),!p)throw new Error("not supported");b[R]=T(p,A)}}function a(T,C,A){let b=null,R=null;if(typeof A.value=="function"?(b="value",R=A.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof A.get=="function"&&(b="get",R=A.get),!R)throw new Error("not supported");const p=`$memoize$${C}`;A[b]=function(...m){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[p]}}function L(T,C,A){return P((b,R)=>{const p=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...g){this[m]||(this[m]=A?A():void 0),clearTimeout(this[p]),C&&(this[m]=C(this[m],...g),g=[this[m]]),this[p]=setTimeout(()=>{b.apply(this,g),this[m]=A?A():void 0},T)}})}function k(T,C,A){return P((b,R)=>{const p=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,g=`$throttle$lastRun$${R}`,l=`$throttle$pending$${R}`;return function(...f){if(this[m]||(this[m]=A?A():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),C&&(this[m]=C(this[m],...f)),this[l])return;const E=this[g]+T;E<=Date.now()?(this[g]=Date.now(),b.apply(this,[this[m]]),this[m]=A?A():void 0):(this[l]=!0,this[p]=setTimeout(()=>{this[l]=!1,this[g]=Date.now(),b.apply(this,[this[m]]),this[m]=A?A():void 0},E-Date.now()))}})}}),define(fe[8],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=e.$fb=e.$eb=e.$db=e.$cb=e.$ab=e.$9=e.$1=e.$Z=void 0,e.setUnexpectedErrorHandler=a,e.$3=L,e.$4=k,e.$5=T,e.$6=C,e.$7=A,e.$8=R,e.$0=m,e.$$=g,e.$_=l,e.$bb=E;class P{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?$.isErrorNoTelemetry(i)?new $(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Z=P,e.$1=new P;function a(h){e.$1.setUnexpectedErrorHandler(h)}function L(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function k(h){R(h)||e.$1.onUnexpectedError(h)}function T(h){R(h)||e.$1.onUnexpectedExternalError(h)}function C(h){if(h instanceof Error){const{name:i,message:n}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:i,message:n,stack:t,noTelemetry:$.isErrorNoTelemetry(h)}}return h}function A(h){let i;return h.noTelemetry?i=new $:(i=new Error,i.name=h.name),i.message=h.message,i.stack=h.stack,i}const b="Canceled";function R(h){return h instanceof p?!0:h instanceof Error&&h.name===b&&h.message===b}class p extends Error{constructor(){super(b),this.name=this.message}}e.$9=p;function m(){const h=new Error(b);return h.name=h.message,h}function g(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function l(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class f extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$ab=f;function E(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$cb=w;class d extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$db=d;class I extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$eb=I;class $ extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof $)return i;const n=new $;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$fb=$;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$gb=c}),define(fe[17],de([0,1,8,131]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.$cc=e.$ac=e.$_b=e.CompareResult=void 0,e.$wb=L,e.$xb=k,e.$yb=T,e.$zb=C,e.$Ab=A,e.$Bb=b,e.$Cb=R,e.$Db=p,e.$Eb=m,e.$Fb=g,e.$Gb=l,e.$Hb=f,e.$Ib=E,e.top=w,e.$Kb=d,e.$Lb=$,e.$Mb=c,e.$Nb=h,e.$Ob=i,e.$Pb=n,e.$Qb=t,e.$Rb=s,e.$Sb=r,e.$Tb=o,e.$Ub=u,e.$Vb=y,e.$Wb=O,e.$Xb=S,e.$Yb=v,e.$Zb=N,e.$1b=F,e.$2b=U,e.$3b=j,e.$4b=G,e.$5b=W,e.$6b=x,e.$7b=V,e.$8b=te,e.$9b=B,e.$0b=ne,e.$$b=le,e.$bc=K,e.$fc=oe;function L(Q,Z=0){return Q[Q.length-(1+Z)]}function k(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}function T(Q,Z,M=(z,ie)=>z===ie){if(Q===Z)return!0;if(!Q||!Z||Q.length!==Z.length)return!1;for(let z=0,ie=Q.length;z<ie;z++)if(!M(Q[z],Z[z]))return!1;return!0}function C(Q,Z){const M=Q.length-1;Z<M&&(Q[Z]=Q[M]),Q.pop()}function A(Q,Z,M){return b(Q.length,z=>M(Q[z],Z))}function b(Q,Z){let M=0,z=Q-1;for(;M<=z;){const ie=(M+z)/2|0,ae=Z(ie);if(ae<0)M=ie+1;else if(ae>0)z=ie-1;else return ie}return-(M+1)}function R(Q,Z,M){if(Q=Q|0,Q>=Z.length)throw new TypeError("invalid index");const z=Z[Math.floor(Z.length*Math.random())],ie=[],ae=[],ue=[];for(const pe of Z){const be=M(pe,z);be<0?ie.push(pe):be>0?ae.push(pe):ue.push(pe)}return Q<ie.length?R(Q,ie,M):Q<ie.length+ue.length?ue[0]:R(Q-(ie.length+ue.length),ae,M)}function p(Q,Z){const M=[];let z;for(const ie of Q.slice(0).sort(Z))!z||Z(z[0],ie)!==0?(z=[ie],M.push(z)):z.push(ie);return M}function*m(Q,Z){let M,z;for(const ie of Q)z!==void 0&&Z(z,ie)?M.push(ie):(M&&(yield M),M=[ie]),z=ie;M&&(yield M)}function g(Q,Z){for(let M=0;M<=Q.length;M++)Z(M===0?void 0:Q[M-1],M===Q.length?void 0:Q[M])}function l(Q,Z){for(let M=0;M<Q.length;M++)Z(M===0?void 0:Q[M-1],Q[M],M+1===Q.length?void 0:Q[M+1])}function f(Q,Z,M){const z=[];function ie(pe,be,Ie){if(be===0&&Ie.length===0)return;const Ae=z[z.length-1];Ae&&Ae.start+Ae.deleteCount===pe?(Ae.deleteCount+=be,Ae.toInsert.push(...Ie)):z.push({start:pe,deleteCount:be,toInsert:Ie})}let ae=0,ue=0;for(;;){if(ae===Q.length){ie(ae,0,Z.slice(ue));break}if(ue===Z.length){ie(ae,Q.length-ae,[]);break}const pe=Q[ae],be=Z[ue],Ie=M(pe,be);Ie===0?(ae+=1,ue+=1):Ie<0?(ie(ae,1,[]),ae+=1):Ie>0&&(ie(ae,0,[be]),ue+=1)}return z}function E(Q,Z,M){const z=f(Q,Z,M),ie=[],ae=[];for(const ue of z)ie.push(...Q.slice(ue.start,ue.start+ue.deleteCount)),ae.push(...ue.toInsert);return{removed:ie,added:ae}}function w(Q,Z,M){if(M===0)return[];const z=Q.slice(0,M).sort(Z);return I(Q,Z,z,M,Q.length),z}function d(Q,Z,M,z,ie){return M===0?Promise.resolve([]):new Promise((ae,ue)=>{(async()=>{const pe=Q.length,be=Q.slice(0,M).sort(Z);for(let Ie=M,Ae=Math.min(M+z,pe);Ie<pe;Ie=Ae,Ae=Math.min(Ae+z,pe)){if(Ie>M&&await new Promise(ye=>setTimeout(ye)),ie&&ie.isCancellationRequested)throw new P.$9;I(Q,Z,be,Ie,Ae)}return be})().then(ae,ue)})}function I(Q,Z,M,z,ie){for(const ae=M.length;z<ie;z++){const ue=Q[z];if(Z(ue,M[ae-1])<0){M.pop();const pe=(0,a.$ob)(M,be=>Z(ue,be)<0);M.splice(pe,0,ue)}}}function $(Q){return Q.filter(Z=>!!Z)}function c(Q){let Z=0;for(let M=0;M<Q.length;M++)Q[M]&&(Q[Z]=Q[M],Z+=1);Q.length=Z}function h(Q,Z,M){Q.splice(M,0,Q.splice(Z,1)[0])}function i(Q){return!Array.isArray(Q)||Q.length===0}function n(Q){return Array.isArray(Q)&&Q.length>0}function t(Q,Z=M=>M){const M=new Set;return Q.filter(z=>{const ie=Z(z);return M.has(ie)?!1:(M.add(ie),!0)})}function s(Q){const Z=new Set;return M=>{const z=Q(M);return Z.has(z)?!1:(Z.add(z),!0)}}function r(Q,Z){return Q.length>0?Q[0]:Z}function o(Q,Z){return Q.length>0?Q[Q.length-1]:Z}function u(Q,Z,M=(z,ie)=>z===ie){let z=0;for(let ie=0,ae=Math.min(Q.length,Z.length);ie<ae&&M(Q[ie],Z[ie]);ie++)z++;return z}function y(Q,Z){let M=typeof Z=="number"?Q:0;typeof Z=="number"?M=Q:(M=0,Z=Q);const z=[];if(M<=Z)for(let ie=M;ie<Z;ie++)z.push(ie);else for(let ie=M;ie>Z;ie--)z.push(ie);return z}function O(Q,Z,M){return Q.reduce((z,ie)=>(z[Z(ie)]=M?M(ie):ie,z),Object.create(null))}function S(Q,Z){return Q.push(Z),()=>v(Q,Z)}function v(Q,Z){const M=Q.indexOf(Z);if(M>-1)return Q.splice(M,1),Z}function N(Q,Z,M){const z=Q.slice(0,Z),ie=Q.slice(Z);return z.concat(M,ie)}function F(Q,Z){let M;if(typeof Z=="number"){let z=Z;M=()=>{const ie=Math.sin(z++)*179426549;return ie-Math.floor(ie)}}else M=Math.random;for(let z=Q.length-1;z>0;z-=1){const ie=Math.floor(M()*(z+1)),ae=Q[z];Q[z]=Q[ie],Q[ie]=ae}}function U(Q,Z){const M=Q.indexOf(Z);M>-1&&(Q.splice(M,1),Q.unshift(Z))}function j(Q,Z){const M=Q.indexOf(Z);M>-1&&(Q.splice(M,1),Q.push(Z))}function G(Q,Z){for(const M of Z)Q.push(M)}function W(Q,Z){return Array.isArray(Q)?Q.map(Z):Z(Q)}function x(Q){return Array.isArray(Q)?Q:[Q]}function V(Q){return Q[Math.floor(Math.random()*Q.length)]}function te(Q,Z,M){const z=H(Q,Z),ie=Q.length,ae=M.length;Q.length=ie+ae;for(let ue=ie-1;ue>=z;ue--)Q[ue+ae]=Q[ue];for(let ue=0;ue<ae;ue++)Q[ue+z]=M[ue]}function B(Q,Z,M,z){const ie=H(Q,Z);let ae=Q.splice(ie,M);return ae===void 0&&(ae=[]),te(Q,ie,z),ae}function H(Q,Z){return Z<0?Math.max(Z+Q.length,0):Math.min(Z,Q.length)}var _;(function(Q){function Z(ae){return ae<0}Q.isLessThan=Z;function M(ae){return ae<=0}Q.isLessThanOrEqual=M;function z(ae){return ae>0}Q.isGreaterThan=z;function ie(ae){return ae===0}Q.isNeitherLessOrGreaterThan=ie,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ne(Q,Z){return(M,z)=>Z(Q(M),Q(z))}function le(...Q){return(Z,M)=>{for(const z of Q){const ie=z(Z,M);if(!_.isNeitherLessOrGreaterThan(ie))return ie}return _.neitherLessOrGreaterThan}}const ee=(Q,Z)=>Q-Z;e.$_b=ee;const X=(Q,Z)=>(0,e.$_b)(Q?1:0,Z?1:0);e.$ac=X;function K(Q){return(Z,M)=>-Q(Z,M)}class q{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let M=this.c;for(;M<this.g.length&&Z(this.g[M]);)M++;const z=M===this.c?null:this.g.slice(this.c,M);return this.c=M,z}takeFromEndWhile(Z){let M=this.d;for(;M>=0&&Z(this.g[M]);)M--;const z=M===this.d?null:this.g.slice(M+1,this.d+1);return this.d=M,z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const M=this.g.slice(this.c,this.c+Z);return this.c+=Z,M}}e.$cc=q;class D{static{this.empty=new D(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(M=>(Z(M),!0))}toArray(){const Z=[];return this.iterate(M=>(Z.push(M),!0)),Z}filter(Z){return new D(M=>this.iterate(z=>Z(z)?M(z):!0))}map(Z){return new D(M=>this.iterate(z=>M(Z(z))))}some(Z){let M=!1;return this.iterate(z=>(M=Z(z),!M)),M}findFirst(Z){let M;return this.iterate(z=>Z(z)?(M=z,!1):!0),M}findLast(Z){let M;return this.iterate(z=>(Z(z)&&(M=z),!0)),M}findLastMaxBy(Z){let M,z=!0;return this.iterate(ie=>((z||_.isGreaterThan(Z(ie,M)))&&(z=!1,M=ie),!0)),M}}e.$dc=D;class J{constructor(Z){this.c=Z}static createSortPermutation(Z,M){const z=Array.from(Z.keys()).sort((ie,ae)=>M(Z[ie],Z[ae]));return new J(z)}apply(Z){return Z.map((M,z)=>Z[this.c[z]])}inverse(){const Z=this.c.slice();for(let M=0;M<this.c.length;M++)Z[this.c[M]]=M;return new J(Z)}}e.$ec=J;async function oe(Q,Z){return(await Promise.all(Q.map(async(z,ie)=>({element:z,ok:await Z(z,ie)})))).find(z=>z.ok)?.element}}),define(fe[133],de([0,1,8]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$jd=L,e.$kd=k,e.$ld=T,e.$md=C,e.$nd=A;function a(b,R){if(!b)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}function L(b,R="Unreachable"){throw new Error(R)}function k(b,R="unexpected state"){if(!b)throw new P.$gb(`Assertion Failed: ${R}`)}function T(b){b||(0,P.$4)(new P.$gb("Soft Assertion Failed"))}function C(b){if(!b()){debugger;b(),(0,P.$4)(new P.$gb("Assertion Failed"))}}function A(b,R){let p=0;for(;p<b.length-1;){const m=b[p],g=b[p+1];if(!R(m,g))return!1;p++}return!0}}),define(fe[89],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hb=P;function P(a,L){const k=this;let T=!1,C;return function(){if(T)return C;if(T=!0,L)try{C=a.apply(k,arguments)}finally{L()}else C=a.apply(k,arguments);return C}}}),define(fe[63],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(a){function L(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}a.is=L;const k=Object.freeze([]);function T(){return k}a.empty=T;function*C(i){yield i}a.single=C;function A(i){return L(i)?i:C(i)}a.wrap=A;function b(i){return i||k}a.from=b;function*R(i){for(let n=i.length-1;n>=0;n--)yield i[n]}a.reverse=R;function p(i){return!i||i[Symbol.iterator]().next().done===!0}a.isEmpty=p;function m(i){return i[Symbol.iterator]().next().value}a.first=m;function g(i,n){let t=0;for(const s of i)if(n(s,t++))return!0;return!1}a.some=g;function l(i,n){for(const t of i)if(n(t))return t}a.find=l;function*f(i,n){for(const t of i)n(t)&&(yield t)}a.filter=f;function*E(i,n){let t=0;for(const s of i)yield n(s,t++)}a.map=E;function*w(i,n){let t=0;for(const s of i)yield*n(s,t++)}a.flatMap=w;function*d(...i){for(const n of i)yield*n}a.concat=d;function I(i,n,t){let s=t;for(const r of i)s=n(s,r);return s}a.reduce=I;function*$(i,n,t=i.length){for(n<0&&(n+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);n<t;n++)yield i[n]}a.slice=$;function c(i,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,i];const s=i[Symbol.iterator]();for(let r=0;r<n;r++){const o=s.next();if(o.done)return[t,a.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return s}}]}a.consume=c;async function h(i){const n=[];for await(const t of i)n.push(t);return Promise.resolve(n)}a.asyncToArray=h})(P||(e.Iterable=P={}))}),define(fe[36],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$3n=T,e.$4n=p,e.$5n=m,e.$6n=g,e.$7n=l,e.$8n=f,e.$9n=E,e.$0n=w,e.$$n=d,e.$_n=I,e.$ao=$;var P;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var a;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var L;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var k;(function(c){c.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function T(c,h=!1){let i=0;const n=c.length;let t="",s=0,r=a.Unknown,o=P.None;function u(U){let j=0,G=0;for(;j<U;){const W=c.charCodeAt(i);if(W>=R._0&&W<=R._9)G=G*16+W-R._0;else if(W>=R.A&&W<=R.F)G=G*16+W-R.A+10;else if(W>=R.a&&W<=R.f)G=G*16+W-R.a+10;else break;i++,j++}return j<U&&(G=-1),G}function y(U){i=U,t="",s=0,r=a.Unknown,o=P.None}function O(){const U=i;if(c.charCodeAt(i)===R._0)i++;else for(i++;i<c.length&&b(c.charCodeAt(i));)i++;if(i<c.length&&c.charCodeAt(i)===R.dot)if(i++,i<c.length&&b(c.charCodeAt(i)))for(i++;i<c.length&&b(c.charCodeAt(i));)i++;else return o=P.UnexpectedEndOfNumber,c.substring(U,i);let j=i;if(i<c.length&&(c.charCodeAt(i)===R.E||c.charCodeAt(i)===R.e))if(i++,(i<c.length&&c.charCodeAt(i)===R.plus||c.charCodeAt(i)===R.minus)&&i++,i<c.length&&b(c.charCodeAt(i))){for(i++;i<c.length&&b(c.charCodeAt(i));)i++;j=i}else o=P.UnexpectedEndOfNumber;return c.substring(U,j)}function S(){let U="",j=i;for(;;){if(i>=n){U+=c.substring(j,i),o=P.UnexpectedEndOfString;break}const G=c.charCodeAt(i);if(G===R.doubleQuote){U+=c.substring(j,i),i++;break}if(G===R.backslash){if(U+=c.substring(j,i),i++,i>=n){o=P.UnexpectedEndOfString;break}switch(c.charCodeAt(i++)){case R.doubleQuote:U+='"';break;case R.backslash:U+="\\";break;case R.slash:U+="/";break;case R.b:U+="\b";break;case R.f:U+="\f";break;case R.n:U+=`
`;break;case R.r:U+="\r";break;case R.t:U+="	";break;case R.u:{const x=u(4);x>=0?U+=String.fromCharCode(x):o=P.InvalidUnicode;break}default:o=P.InvalidEscapeCharacter}j=i;continue}if(G>=0&&G<=31)if(A(G)){U+=c.substring(j,i),o=P.UnexpectedEndOfString;break}else o=P.InvalidCharacter;i++}return U}function v(){if(t="",o=P.None,s=i,i>=n)return s=n,r=a.EOF;let U=c.charCodeAt(i);if(C(U)){do i++,t+=String.fromCharCode(U),U=c.charCodeAt(i);while(C(U));return r=a.Trivia}if(A(U))return i++,t+=String.fromCharCode(U),U===R.carriageReturn&&c.charCodeAt(i)===R.lineFeed&&(i++,t+=`
`),r=a.LineBreakTrivia;switch(U){case R.openBrace:return i++,r=a.OpenBraceToken;case R.closeBrace:return i++,r=a.CloseBraceToken;case R.openBracket:return i++,r=a.OpenBracketToken;case R.closeBracket:return i++,r=a.CloseBracketToken;case R.colon:return i++,r=a.ColonToken;case R.comma:return i++,r=a.CommaToken;case R.doubleQuote:return i++,t=S(),r=a.StringLiteral;case R.slash:{const j=i-1;if(c.charCodeAt(i+1)===R.slash){for(i+=2;i<n&&!A(c.charCodeAt(i));)i++;return t=c.substring(j,i),r=a.LineCommentTrivia}if(c.charCodeAt(i+1)===R.asterisk){i+=2;const G=n-1;let W=!1;for(;i<G;){if(c.charCodeAt(i)===R.asterisk&&c.charCodeAt(i+1)===R.slash){i+=2,W=!0;break}i++}return W||(i++,o=P.UnexpectedEndOfComment),t=c.substring(j,i),r=a.BlockCommentTrivia}return t+=String.fromCharCode(U),i++,r=a.Unknown}case R.minus:if(t+=String.fromCharCode(U),i++,i===n||!b(c.charCodeAt(i)))return r=a.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return t+=O(),r=a.NumericLiteral;default:for(;i<n&&N(U);)i++,U=c.charCodeAt(i);if(s!==i){switch(t=c.substring(s,i),t){case"true":return r=a.TrueKeyword;case"false":return r=a.FalseKeyword;case"null":return r=a.NullKeyword}return r=a.Unknown}return t+=String.fromCharCode(U),i++,r=a.Unknown}}function N(U){if(C(U)||A(U))return!1;switch(U){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function F(){let U;do U=v();while(U>=a.LineCommentTrivia&&U<=a.Trivia);return U}return{setPosition:y,getPosition:()=>i,scan:h?F:v,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>o}}function C(c){return c===R.space||c===R.tab||c===R.verticalTab||c===R.formFeed||c===R.nonBreakingSpace||c===R.ogham||c>=R.enQuad&&c<=R.zeroWidthSpace||c===R.narrowNoBreakSpace||c===R.mathematicalSpace||c===R.ideographicSpace||c===R.byteOrderMark}function A(c){return c===R.lineFeed||c===R.carriageReturn||c===R.lineSeparator||c===R.paragraphSeparator}function b(c){return c>=R._0&&c<=R._9}var R;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(R||(R={}));function p(c,h){const i=[],n=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function o(u,y,O,S){s.value=u,s.offset=y,s.length=O,s.type=S,s.colonOffset=void 0,t=s}try{I(c,{onObjectBegin:(u,y)=>{if(h<=u)throw n;t=void 0,r=h>u,i.push("")},onObjectProperty:(u,y,O)=>{if(h<y||(o(u,y,O,"property"),i[i.length-1]=u,h<=y+O))throw n},onObjectEnd:(u,y)=>{if(h<=u)throw n;t=void 0,i.pop()},onArrayBegin:(u,y)=>{if(h<=u)throw n;t=void 0,i.push(0)},onArrayEnd:(u,y)=>{if(h<=u)throw n;t=void 0,i.pop()},onLiteralValue:(u,y,O)=>{if(h<y||(o(u,y,O,$(u)),h<=y+O))throw n},onSeparator:(u,y,O)=>{if(h<=y)throw n;if(u===":"&&t&&t.type==="property")t.colonOffset=y,r=!1,t=void 0;else if(u===","){const S=i[i.length-1];typeof S=="number"?i[i.length-1]=S+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(u){if(u!==n)throw u}return{path:i,previousNode:t,isAtPropertyKey:r,matches:u=>{let y=0;for(let O=0;y<u.length&&O<i.length;O++)if(u[y]===i[O]||u[y]==="*")y++;else if(u[y]!=="**")return!1;return y===u.length}}}function m(c,h=[],i=k.DEFAULT){let n=null,t=[];const s=[];function r(u){Array.isArray(t)?t.push(u):n!==null&&(t[n]=u)}return I(c,{onObjectBegin:()=>{const u={};r(u),s.push(t),t=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const u=[];r(u),s.push(t),t=u,n=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:r,onError:(u,y,O)=>{h.push({error:u,offset:y,length:O})}},i),t[0]}function g(c,h=[],i=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function s(u){return n.children.push(u),u}I(c,{onObjectBegin:u=>{n=s({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,y,O)=>{n=s({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:y,length:O,parent:n})},onObjectEnd:(u,y)=>{n.length=u+y-n.offset,n=n.parent,t(u+y)},onArrayBegin:(u,y)=>{n=s({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,y)=>{n.length=u+y-n.offset,n=n.parent,t(u+y)},onLiteralValue:(u,y,O)=>{s({type:$(u),offset:y,length:O,parent:n,value:u}),t(y+O)},onSeparator:(u,y,O)=>{n.type==="property"&&(u===":"?n.colonOffset=y:u===","&&t(y))},onError:(u,y,O)=>{h.push({error:u,offset:y,length:O})}},i);const o=n.children[0];return o&&delete o.parent,o}function l(c,h){if(!c)return;let i=c;for(const n of h)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===n){i=s.children[1],t=!0;break}if(!t)return}else{const t=n;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function f(c){if(!c.parent||!c.parent.children)return[];const h=f(c.parent);if(c.parent.type==="property"){const i=c.parent.children[0].value;h.push(i)}else if(c.parent.type==="array"){const i=c.parent.children.indexOf(c);i!==-1&&h.push(i)}return h}function E(c){switch(c.type){case"array":return c.children.map(E);case"object":{const h=Object.create(null);for(const i of c.children){const n=i.children[1];n&&(h[i.children[0].value]=E(n))}return h}case"null":case"string":case"number":case"boolean":return c.value;default:return}}function w(c,h,i=!1){return h>=c.offset&&h<c.offset+c.length||i&&h===c.offset+c.length}function d(c,h,i=!1){if(w(c,h,i)){const n=c.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=h;t++){const s=d(n[t],h,i);if(s)return s}return c}}function I(c,h,i=k.DEFAULT){const n=T(c,!1);function t(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function s(ne){return ne?le=>ne(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const r=t(h.onObjectBegin),o=s(h.onObjectProperty),u=t(h.onObjectEnd),y=t(h.onArrayBegin),O=t(h.onArrayEnd),S=s(h.onLiteralValue),v=s(h.onSeparator),N=t(h.onComment),F=s(h.onError),U=i&&i.disallowComments,j=i&&i.allowTrailingComma;function G(){for(;;){const ne=n.scan();switch(n.getTokenError()){case P.InvalidUnicode:W(L.InvalidUnicode);break;case P.InvalidEscapeCharacter:W(L.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:W(L.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:U||W(L.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:W(L.UnexpectedEndOfString);break;case P.InvalidCharacter:W(L.InvalidCharacter);break}switch(ne){case a.LineCommentTrivia:case a.BlockCommentTrivia:U?W(L.InvalidCommentToken):N();break;case a.Unknown:W(L.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ne}}}function W(ne,le=[],ee=[]){if(F(ne),le.length+ee.length>0){let X=n.getToken();for(;X!==a.EOF;){if(le.indexOf(X)!==-1){G();break}else if(ee.indexOf(X)!==-1)break;X=G()}}}function x(ne){const le=n.getTokenValue();return ne?S(le):o(le),G(),!0}function V(){switch(n.getToken()){case a.NumericLiteral:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(W(L.InvalidNumberFormat),ne=0)}catch{W(L.InvalidNumberFormat)}S(ne);break}case a.NullKeyword:S(null);break;case a.TrueKeyword:S(!0);break;case a.FalseKeyword:S(!1);break;default:return!1}return G(),!0}function te(){return n.getToken()!==a.StringLiteral?(W(L.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(x(!1),n.getToken()===a.ColonToken?(v(":"),G(),_()||W(L.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):W(L.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function B(){r(),G();let ne=!1;for(;n.getToken()!==a.CloseBraceToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||W(L.ValueExpected,[],[]),v(","),G(),n.getToken()===a.CloseBraceToken&&j)break}else ne&&W(L.CommaExpected,[],[]);te()||W(L.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ne=!0}return u(),n.getToken()!==a.CloseBraceToken?W(L.CloseBraceExpected,[a.CloseBraceToken],[]):G(),!0}function H(){y(),G();let ne=!1;for(;n.getToken()!==a.CloseBracketToken&&n.getToken()!==a.EOF;){if(n.getToken()===a.CommaToken){if(ne||W(L.ValueExpected,[],[]),v(","),G(),n.getToken()===a.CloseBracketToken&&j)break}else ne&&W(L.CommaExpected,[],[]);_()||W(L.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ne=!0}return O(),n.getToken()!==a.CloseBracketToken?W(L.CloseBracketExpected,[a.CloseBracketToken],[]):G(),!0}function _(){switch(n.getToken()){case a.OpenBracketToken:return H();case a.OpenBraceToken:return B();case a.StringLiteral:return x(!0);default:return V()}}return G(),n.getToken()===a.EOF?i.allowEmptyContent?!0:(W(L.ValueExpected,[],[]),!1):_()?(n.getToken()!==a.EOF&&W(L.EndOfFileExpected,[],[]),!0):(W(L.ValueExpected,[],[]),!1)}function $(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}}),define(fe[45],de([0,1,36]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=a,e.$co=L,e.$do=C,e.$eo=A;function a(b,R,p){let m,g,l,f,E;if(R){for(f=R.offset,E=f+R.length,l=f;l>0&&!A(b,l-1);)l--;let o=E;for(;o<b.length&&!A(b,o);)o++;g=b.substring(l,o),m=T(g,p)}else g=b,m=0,l=0,f=0,E=b.length;const w=C(p,b);let d=!1,I=0,$;p.insertSpaces?$=k(" ",p.tabSize||4):$="	";const c=(0,P.$3n)(g,!1);let h=!1;function i(){return w+k($,m+I)}function n(){let o=c.scan();for(d=!1;o===P.SyntaxKind.Trivia||o===P.SyntaxKind.LineBreakTrivia;)d=d||o===P.SyntaxKind.LineBreakTrivia,o=c.scan();return h=o===P.SyntaxKind.Unknown||c.getTokenError()!==P.ScanError.None,o}const t=[];function s(o,u,y){!h&&u<E&&y>f&&b.substring(u,y)!==o&&t.push({offset:u,length:y-u,content:o})}let r=n();if(r!==P.SyntaxKind.EOF){const o=c.getTokenOffset()+l,u=k($,m);s(u,l,o)}for(;r!==P.SyntaxKind.EOF;){let o=c.getTokenOffset()+c.getTokenLength()+l,u=n(),y="";for(;!d&&(u===P.SyntaxKind.LineCommentTrivia||u===P.SyntaxKind.BlockCommentTrivia);){const S=c.getTokenOffset()+l;s(" ",o,S),o=c.getTokenOffset()+c.getTokenLength()+l,y=u===P.SyntaxKind.LineCommentTrivia?i():"",u=n()}if(u===P.SyntaxKind.CloseBraceToken)r!==P.SyntaxKind.OpenBraceToken&&(I--,y=i());else if(u===P.SyntaxKind.CloseBracketToken)r!==P.SyntaxKind.OpenBracketToken&&(I--,y=i());else{switch(r){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:I++,y=i();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:y=i();break;case P.SyntaxKind.BlockCommentTrivia:d?y=i():y=" ";break;case P.SyntaxKind.ColonToken:y=" ";break;case P.SyntaxKind.StringLiteral:if(u===P.SyntaxKind.ColonToken){y="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:u===P.SyntaxKind.LineCommentTrivia||u===P.SyntaxKind.BlockCommentTrivia?y=" ":u!==P.SyntaxKind.CommaToken&&u!==P.SyntaxKind.EOF&&(h=!0);break;case P.SyntaxKind.Unknown:h=!0;break}d&&(u===P.SyntaxKind.LineCommentTrivia||u===P.SyntaxKind.BlockCommentTrivia)&&(y=i())}const O=c.getTokenOffset()+l;s(y,o,O),r=u}return t}function L(b,R){const p=JSON.stringify(b,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?p.replace(/\r\n|\r|\n/g,R.eol):p}function k(b,R){let p="";for(let m=0;m<R;m++)p+=b;return p}function T(b,R){let p=0,m=0;const g=R.tabSize||4;for(;p<b.length;){const l=b.charAt(p);if(l===" ")m++;else if(l==="	")m+=g;else break;p++}return Math.floor(m/g)}function C(b,R){for(let p=0;p<R.length;p++){const m=R.charAt(p);if(m==="\r")return p+1<R.length&&R.charAt(p+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return b&&b.eol||`
`}function A(b,R){return`\r
`.indexOf(b.charAt(R))!==-1}}),define(fe[64],de([0,1,36,45]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=L,e.$go=k,e.$ho=T,e.$io=C,e.$jo=A;function L(b,R,p){return k(b,R,void 0,p)}function k(b,R,p,m,g){const l=R.slice(),f=[],E=(0,P.$6n)(b,f);let w,d;for(;l.length>0&&(d=l.pop(),w=(0,P.$7n)(E,l),w===void 0&&p!==void 0);)typeof d=="string"?p={[d]:p}:p=[p];if(w)if(w.type==="object"&&typeof d=="string"&&Array.isArray(w.children)){const I=(0,P.$7n)(w,[d]);if(I!==void 0)if(p===void 0){if(!I.parent)throw new Error("Malformed AST");const $=w.children.indexOf(I.parent);let c,h=I.parent.offset+I.parent.length;if($>0){const i=w.children[$-1];c=i.offset+i.length}else c=w.offset+1,w.children.length>1&&(h=w.children[1].offset);return T(b,{offset:c,length:h-c,content:""},m)}else return T(b,{offset:I.offset,length:I.length,content:JSON.stringify(p)},m);else{if(p===void 0)return[];const $=`${JSON.stringify(d)}: ${JSON.stringify(p)}`,c=g?g(w.children.map(i=>i.children[0].value)):w.children.length;let h;if(c>0){const i=w.children[c-1];h={offset:i.offset+i.length,length:0,content:","+$}}else w.children.length===0?h={offset:w.offset+1,length:0,content:$}:h={offset:w.offset+1,length:0,content:$+","};return T(b,h,m)}}else if(w.type==="array"&&typeof d=="number"&&Array.isArray(w.children))if(p!==void 0){const I=`${JSON.stringify(p)}`;let $;if(w.children.length===0||d===0)$={offset:w.offset+1,length:0,content:w.children.length===0?I:I+","};else{const c=d===-1||d>w.children.length?w.children.length:d,h=w.children[c-1];$={offset:h.offset+h.length,length:0,content:","+I}}return T(b,$,m)}else{const I=d,$=w.children[I];let c;if(w.children.length===1)c={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===I){const h=w.children[I-1],i=h.offset+h.length,n=w.offset+w.length;c={offset:i,length:n-2-i,content:""}}else c={offset:$.offset,length:w.children[I+1].offset-$.offset,content:""};return T(b,c,m)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${w.type}`);else return p===void 0?[]:T(b,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(p)},m)}function T(b,R,p){let m=C(b,R),g=R.offset,l=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;g>0&&!(0,a.$eo)(m,g-1);)g--;for(;l<m.length&&!(0,a.$eo)(m,l);)l++}const f=(0,a.$bo)(m,{offset:g,length:l-g},p);for(let w=f.length-1;w>=0;w--){const d=f[w];m=C(m,d),g=Math.min(g,d.offset),l=Math.max(l,d.offset+d.length),l+=d.content.length-d.length}const E=b.length-(m.length-l)-g;return[{offset:g,length:E,content:m.substring(g,l)}]}function C(b,R){return b.substring(0,R.offset)+R.content+b.substring(R.offset+R.length)}function A(b,R){const p=R.slice(0).sort((g,l)=>{const f=g.offset-l.offset;return f===0?g.length-l.length:f});let m=b.length;for(let g=p.length-1;g>=0;g--){const l=p[g];if(l.offset+l.length<=m)b=C(b,l);else throw new Error("Overlapping edit");m=l.offset}return b}}),define(fe[134],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=P;function P(k){let T=!1;const C=new Map,A=new Map;if(L(k,f=>{if(k===f)return!0;const E=JSON.stringify(f);if(E.length<30)return!0;const w=C.get(E);if(!w){const d={schemas:[f]};return C.set(E,d),A.set(f,d),!0}return w.schemas.push(f),A.set(f,w),T=!0,!1}),C.clear(),!T)return JSON.stringify(k);let R="$defs";for(;k.hasOwnProperty(R);)R+="_";const p=[];function m(f){return JSON.stringify(f,(E,w)=>{if(w!==f){const d=A.get(w);if(d&&d.schemas.length>1)return d.id||(d.id=`_${p.length}`,p.push(d.schemas[0])),{$ref:`#/${R}/${d.id}`}}return w})}const g=m(k),l=[];for(let f=0;f<p.length;f++)l.push(`"_${f}":${m(p[f])}`);return l.length?`${g.substring(0,g.length-1)},"${R}":{${l.join(",")}}}`:g}function a(k){return typeof k=="object"&&k!==null}function L(k,T){if(!k||typeof k!="object")return;const C=(...g)=>{for(const l of g)a(l)&&p.push(l)},A=(...g)=>{for(const l of g)if(a(l))for(const f in l){const E=l[f];a(E)&&p.push(E)}},b=(...g)=>{for(const l of g)if(Array.isArray(l))for(const f of l)a(f)&&p.push(f)},R=g=>{if(Array.isArray(g))for(const l of g)a(l)&&p.push(l);else a(g)&&p.push(g)},p=[k];let m=p.pop();for(;m;)T(m)&&(C(m.additionalItems,m.additionalProperties,m.not,m.contains,m.propertyNames,m.if,m.then,m.else,m.unevaluatedItems,m.unevaluatedProperties),A(m.definitions,m.$defs,m.properties,m.patternProperties,m.dependencies,m.dependentSchemas),b(m.anyOf,m.allOf,m.oneOf,m.prefixItems),R(m.items)),m=p.pop()}}),define(fe[53],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y=void 0;class P{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$Y=P}),define(fe[90],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(k){this.element=k,this.next=P.Undefined,this.prev=P.Undefined}}class a{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let k=this.a;for(;k!==P.Undefined;){const T=k.next;k.prev=P.Undefined,k.next=P.Undefined,k=T}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,T){const C=new P(k);if(this.a===P.Undefined)this.a=C,this.b=C;else if(T){const b=this.b;this.b=C,C.prev=b,b.next=C}else{const b=this.a;this.a=C,C.next=b,b.prev=C}this.c+=1;let A=!1;return()=>{A||(A=!0,this.e(C))}}shift(){if(this.a!==P.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==P.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==P.Undefined&&k.next!==P.Undefined){const T=k.prev;T.next=k.next,k.next.prev=T}else k.prev===P.Undefined&&k.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):k.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):k.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==P.Undefined;)yield k.element,k=k.next}}e.$0c=a}),define(fe[31],de([0,1]),function(ce,e){"use strict";var P,a,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.Touch=e.$Gc=e.$Fc=void 0,e.$Cc=k,e.$Dc=T,e.$Ec=C,e.$Nc=$;function k(c,h,i){let n=c.get(h);return n===void 0&&(n=i,c.set(h,n)),n}function T(c){const h=[];return c.forEach((i,n)=>{h.push(`${n} => ${i}`)}),`Map(${c.size}) {${h.join(", ")}}`}function C(c){const h=[];return c.forEach(i=>{h.push(i)}),`Set(${c.size}) {${h.join(", ")}}`}class A{constructor(h,i){this.uri=h,this.value=i}}function b(c){return Array.isArray(c)}class R{static{this.c=h=>h.toString()}constructor(h,i){if(this[P]="ResourceMap",h instanceof R)this.d=new Map(h.d),this.e=i??R.c;else if(b(h)){this.d=new Map,this.e=i??R.c;for(const[n,t]of h)this.set(n,t)}else this.d=new Map,this.e=h??R.c}set(h,i){return this.d.set(this.e(h),new A(h,i)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,i){typeof i<"u"&&(h=h.bind(i));for(const[n,t]of this.d)h(t.value,t.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Fc=R;class p{constructor(h,i){this[a]="ResourceSet",!h||typeof h=="function"?this.c=new R(h):(this.c=new R(i),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,i){this.c.forEach((n,t)=>h.call(i,t,t,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Gc=p;var m;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class g{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,i=m.None){const n=this.c.get(h);if(n)return i!==m.None&&this.m(n,i),n.value}set(h,i,n=m.None){let t=this.c.get(h);if(t)t.value=i,n!==m.None&&this.m(t,n);else{switch(t={key:h,value:i,next:void 0,previous:void 0},n){case m.None:this.k(t);break;case m.AsOld:this.j(t);break;case m.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(h,t),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const i=this.c.get(h);if(i)return this.c.delete(h),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.l(h),this.f--,h.value}forEach(h,i){const n=this.g;let t=this.d;for(;t;){if(i?h.bind(i)(t.value,t.key,this):h(t.value,t.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}values(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}entries(){const h=this,i=this.g;let n=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return t}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.d,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.next,n--;this.d=i,this.f=n,i&&(i.previous=void 0),this.g++}i(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.e,n=this.size;for(;i&&n>h;)this.c.delete(i.key),i=i.previous,n--;this.e=i,this.f=n,i&&(i.next=void 0),this.g++}j(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}k(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}l(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const i=h.next,n=h.previous;if(!i||!n)throw new Error("Invalid list");i.previous=n,n.next=i}h.next=void 0,h.previous=void 0,this.g++}m(h,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==m.AsOld&&i!==m.AsNew)){if(i===m.AsOld){if(h===this.d)return;const n=h.next,t=h.previous;h===this.e?(t.next=void 0,this.e=t):(n.previous=t,t.next=n),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(i===m.AsNew){if(h===this.e)return;const n=h.next,t=h.previous;h===this.d?(n.previous=void 0,this.d=n):(n.previous=t,t.next=n),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((i,n)=>{h.push([n,i])}),h}fromJSON(h){this.clear();for(const[i,n]of h)this.set(i,n)}}e.$Hc=g;class l extends g{constructor(h,i=1){super(),this.n=h,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(h){this.n=h,this.p()}get ratio(){return this.o}set ratio(h){this.o=Math.min(Math.max(0,h),1),this.p()}get(h,i=m.AsNew){return super.get(h,i)}peek(h){return super.get(h,m.None)}set(h,i){return super.set(h,i,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class f extends l{constructor(h,i=1){super(h,i)}q(h){this.h(h)}set(h,i){return super.set(h,i),this.p(),this}}e.$Ic=f;class E extends l{constructor(h,i=1){super(h,i)}q(h){this.i(h)}set(h,i){return this.n<=this.size&&!this.has(h)&&this.q(Math.round(this.n*this.o)-1),super.set(h,i),this}}e.$Jc=E;class w{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let i=this.c.get(h)||0;return i===0?!1:(i--,i===0?this.c.delete(h):this.c.set(h,i),!0)}has(h){return this.c.has(h)}}e.$Kc=w;class d{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[i,n]of h)this.set(i,n)}clear(){this.c.clear(),this.d.clear()}set(h,i){this.c.set(h,i),this.d.set(i,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const i=this.c.get(h);return i===void 0?!1:(this.c.delete(h),this.d.delete(i),!0)}forEach(h,i){this.c.forEach((n,t)=>{h.call(i,n,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Lc=d;class I{constructor(){this.c=new Map}add(h,i){let n=this.c.get(h);n||(n=new Set,this.c.set(h,n)),n.add(i)}delete(h,i){const n=this.c.get(h);n&&(n.delete(i),n.size===0&&this.c.delete(h))}forEach(h,i){const n=this.c.get(h);n&&n.forEach(i)}get(h){const i=this.c.get(h);return i||new Set}}e.$Mc=I;function $(c,h){if(c===h)return!0;if(c.size!==h.size)return!1;for(const[i,n]of c)if(!h.has(i)||h.get(i)!==n)return!1;for(const[i]of h)if(!c.has(i))return!1;return!0}}),define(fe[2],de([0,1,17,132,31,89,63]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Oc=void 0,e.$Pc=R,e.$Qc=p,e.$Rc=m,e.$Sc=f,e.$Tc=E,e.$Uc=w,e.$Vc=d,e.$Wc=I,e.$Xc=$,e.$8c=y;const C=!1;let A=null;class b{constructor(){this.b=new Map}static{this.a=0}c(v){let N=this.b.get(v);return N||(N={parent:null,source:null,isSingleton:!1,value:v,idx:b.a++},this.b.set(v,N)),N}trackDisposable(v){const N=this.c(v);N.source||(N.source=new Error().stack)}setParent(v,N){const F=this.c(v);F.parent=N}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,N){const F=N.get(v);if(F)return F;const U=v.parent?this.f(this.c(v.parent),N):v;return N.set(v,U),U}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,v).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(v=10,N){let F;if(N)F=N;else{const x=new Map,V=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,x).isSingleton);if(V.length===0)return;const te=new Set(V.map(B=>B.value));if(F=V.filter(B=>!(B.parent&&te.has(B.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function U(x){function V(B,H){for(;B.length>0&&H.some(_=>typeof _=="string"?_===B[0]:B[0].match(_));)B.shift()}const te=x.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return V(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const j=new L.$Mc;for(const x of F){const V=U(x);for(let te=0;te<=V.length;te++)j.add(V.slice(0,te).join(`
`),x)}F.sort((0,P.$0b)(x=>x.idx,P.$_b));let G="",W=0;for(const x of F.slice(0,v)){W++;const V=U(x),te=[];for(let B=0;B<V.length;B++){let H=V[B];H=`(shared with ${j.get(V.slice(0,B+1).join(`
`)).size}/${F.length} leaks) at ${H}`;const ne=j.get(V.slice(0,B).join(`
`)),le=(0,a.$e)([...ne].map(ee=>U(ee)[B]),ee=>ee);delete le[V[B]];for(const[ee,X]of Object.entries(le))te.unshift(`    - stacktraces of ${X.length} other leaks continue with ${ee}`);te.unshift(H)}G+=`


==================== Leaking disposable ${W}/${F.length}: ${x.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return F.length>v&&(G+=`


... and ${F.length-v} more leaking disposables

`),{leaks:F,details:G}}}e.$Oc=b;function R(S){A=S}if(C){const S="__is_disposable_tracked__";R(new class{trackDisposable(v){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[S]||console.log(N)},3e3)}setParent(v,N){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsDisposed(v){if(v&&v!==h.None)try{v[S]=!0}catch{}}markAsSingleton(v){}})}function p(S){return A?.trackDisposable(S),S}function m(S){A?.markAsDisposed(S)}function g(S,v){A?.setParent(S,v)}function l(S,v){if(A)for(const N of S)A.setParent(N,v)}function f(S){return A?.markAsSingleton(S),S}function E(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function w(S){if(T.Iterable.is(S)){const v=[];for(const N of S)if(N)try{N.dispose()}catch(F){v.push(F)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function d(S){for(const v of S)E(v)&&v.dispose();return[]}function I(...S){const v=$(()=>w(S));return l(S,v),v}function $(S){const v=p({dispose:(0,k.$hb)(()=>{m(v),S()})});return v}class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{w(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return g(v,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),g(v,null))}}e.$Yc=c;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,p(this),g(this.q,this)}dispose(){m(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Zc=h;class i{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&g(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&g(v,null),v}}e.$1c=i;class n{constructor(v){this.a=new i,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$2c=n;class t{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$3c=t;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(v){let N=v;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,m(this))},this}}e.$4c=s;class r{constructor(){this.a=new Map}acquire(v,...N){let F=this.a.get(v);F||(F={counter:0,object:this.b(v,...N)},this.a.set(v,F));const{object:U}=F,j=(0,k.$hb)(()=>{--F.counter===0&&(this.c(v,F.object),this.a.delete(v))});return F.counter++,{object:U,dispose:j}}}e.$5c=r;class o{constructor(v){this.a=v}async acquire(v,...N){const F=this.a.acquire(v,...N);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(U){throw F.dispose(),U}}}e.$6c=o;class u{constructor(v){this.object=v}dispose(){}}e.$7c=u;function y(S){const v=new c;try{S(v)}finally{v.dispose()}}class O{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{w(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,N,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(v)?.dispose(),this.a.set(v,N)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const N=this.a.get(v);return this.a.delete(v),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$9c=O}),define(fe[65],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var P;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(P||(e.MarshalledId=P={}))}),define(fe[91],de([0,1,31]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=void 0,e.$sm=L,e.$tm=T;const a=new P.$Ic(1e4);function L(b){return A(b,"NFC",a)}const k=new P.$Ic(1e4);function T(b){return A(b,"NFD",k)}const C=/[^\u0000-\u0080]/;function A(b,R,p){if(!b)return b;const m=p.get(b);if(m)return m;let g;return C.test(b)?g=b.normalize(R):g=b,p.set(b,g),g}e.$um=function(){const b=/[\u0300-\u036f]/g;return function(R){return T(R).replace(b,"")}}()}),function(){function ce(L){const k=[];typeof L=="number"&&k.push("code/timeOrigin",L);function T(A){k.push(A,Date.now())}function C(){const A=[];for(let b=0;b<k.length;b+=2)A.push({name:k[b],startTime:k[b+1]});return A}return{mark:T,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const T of performance.getEntriesByType("mark"))k.push({name:T.name,startTime:Math.round(L+T.startTime)});return k}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function P(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=P(a))}(),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var a in P)(typeof exports=="object"?exports:ce)[a]=P[a]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function P(a){if(e[a])return e[a].exports;var L=e[a]={i:a,l:!1,exports:{}};return ce[a].call(L.exports,L,L.exports,P),L.l=!0,L.exports}return P.m=ce,P.c=e,P.d=function(a,L,k){P.o(a,L)||Object.defineProperty(a,L,{enumerable:!0,get:k})},P.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},P.t=function(a,L){if(1&L&&(a=P(a)),8&L||4&L&&typeof a=="object"&&a&&a.__esModule)return a;var k=Object.create(null);if(P.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:a}),2&L&&typeof a!="string")for(var T in a)P.d(k,T,function(C){return a[C]}.bind(null,T));return k},P.n=function(a){var L=a&&a.__esModule?function(){return a.default}:function(){return a};return P.d(L,"a",L),L},P.o=function(a,L){return Object.prototype.hasOwnProperty.call(a,L)},P.p="",P(P.s=0)}([function(ce,e,P){(function(a){var L;e=ce.exports=X,L=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],A=e.src=[],b=0,R=b++;A[R]="0|[1-9]\\d*";var p=b++;A[p]="[0-9]+";var m=b++;A[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=b++;A[g]="("+A[R]+")\\.("+A[R]+")\\.("+A[R]+")";var l=b++;A[l]="("+A[p]+")\\.("+A[p]+")\\.("+A[p]+")";var f=b++;A[f]="(?:"+A[R]+"|"+A[m]+")";var E=b++;A[E]="(?:"+A[p]+"|"+A[m]+")";var w=b++;A[w]="(?:-("+A[f]+"(?:\\."+A[f]+")*))";var d=b++;A[d]="(?:-?("+A[E]+"(?:\\."+A[E]+")*))";var I=b++;A[I]="[0-9A-Za-z-]+";var $=b++;A[$]="(?:\\+("+A[I]+"(?:\\."+A[I]+")*))";var c=b++,h="v?"+A[g]+A[w]+"?"+A[$]+"?";A[c]="^"+h+"$";var i="[v=\\s]*"+A[l]+A[d]+"?"+A[$]+"?",n=b++;A[n]="^"+i+"$";var t=b++;A[t]="((?:<|>)?=?)";var s=b++;A[s]=A[p]+"|x|X|\\*";var r=b++;A[r]=A[R]+"|x|X|\\*";var o=b++;A[o]="[v=\\s]*("+A[r]+")(?:\\.("+A[r]+")(?:\\.("+A[r]+")(?:"+A[w]+")?"+A[$]+"?)?)?";var u=b++;A[u]="[v=\\s]*("+A[s]+")(?:\\.("+A[s]+")(?:\\.("+A[s]+")(?:"+A[d]+")?"+A[$]+"?)?)?";var y=b++;A[y]="^"+A[t]+"\\s*"+A[o]+"$";var O=b++;A[O]="^"+A[t]+"\\s*"+A[u]+"$";var S=b++;A[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=b++;A[v]="(?:~>?)";var N=b++;A[N]="(\\s*)"+A[v]+"\\s+",C[N]=new RegExp(A[N],"g");var F=b++;A[F]="^"+A[v]+A[o]+"$";var U=b++;A[U]="^"+A[v]+A[u]+"$";var j=b++;A[j]="(?:\\^)";var G=b++;A[G]="(\\s*)"+A[j]+"\\s+",C[G]=new RegExp(A[G],"g");var W=b++;A[W]="^"+A[j]+A[o]+"$";var x=b++;A[x]="^"+A[j]+A[u]+"$";var V=b++;A[V]="^"+A[t]+"\\s*("+i+")$|^$";var te=b++;A[te]="^"+A[t]+"\\s*("+h+")$|^$";var B=b++;A[B]="(\\s*)"+A[t]+"\\s*("+i+"|"+A[o]+")",C[B]=new RegExp(A[B],"g");var H=b++;A[H]="^\\s*("+A[o]+")\\s+-\\s+("+A[o]+")\\s*$";var _=b++;A[_]="^\\s*("+A[u]+")\\s+-\\s+("+A[u]+")\\s*$";var ne=b++;A[ne]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)L(le,A[le]),C[le]||(C[le]=new RegExp(A[le]));function ee(re,he){if(re instanceof X)return re;if(typeof re!="string"||re.length>k||!(he?C[n]:C[c]).test(re))return null;try{return new X(re,he)}catch{return null}}function X(re,he){if(re instanceof X){if(re.loose===he)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof X))return new X(re,he);L("SemVer",re,he),this.loose=he;var me=re.trim().match(he?C[n]:C[c]);if(!me)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<T)return Pe}return Se}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=ee,e.valid=function(re,he){var me=ee(re,he);return me?me.version:null},e.clean=function(re,he){var me=ee(re.trim().replace(/^[=v]+/,""),he);return me?me.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(re){return L("SemVer.compare",this.version,this.loose,re),re instanceof X||(re=new X(re,this.loose)),this.compareMain(re)||this.comparePre(re)},X.prototype.compareMain=function(re){return re instanceof X||(re=new X(re,this.loose)),q(this.major,re.major)||q(this.minor,re.minor)||q(this.patch,re.patch)},X.prototype.comparePre=function(re){if(re instanceof X||(re=new X(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var he=0;do{var me=this.prerelease[he],Se=re.prerelease[he];if(L("prerelease compare",he,me,Se),me===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(me===void 0)return-1;if(me!==Se)return q(me,Se)}while(++he)},X.prototype.inc=function(re,he){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,he,me,Se){typeof me=="string"&&(Se=me,me=void 0);try{return new X(re,me).inc(he,Se).version}catch{return null}},e.diff=function(re,he){if(Q(re,he))return null;var me=ee(re),Se=ee(he);if(me.prerelease.length||Se.prerelease.length){for(var Pe in me)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&me[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in me)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&me[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=q;var K=/^[0-9]+$/;function q(re,he){var me=K.test(re),Se=K.test(he);return me&&Se&&(re=+re,he=+he),me&&!Se?-1:Se&&!me?1:re<he?-1:re>he?1:0}function D(re,he,me){return new X(re,me).compare(new X(he,me))}function J(re,he,me){return D(re,he,me)>0}function oe(re,he,me){return D(re,he,me)<0}function Q(re,he,me){return D(re,he,me)===0}function Z(re,he,me){return D(re,he,me)!==0}function M(re,he,me){return D(re,he,me)>=0}function z(re,he,me){return D(re,he,me)<=0}function ie(re,he,me,Se){var Pe;switch(he){case"===":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Pe=re===me;break;case"!==":typeof re=="object"&&(re=re.version),typeof me=="object"&&(me=me.version),Pe=re!==me;break;case"":case"=":case"==":Pe=Q(re,me,Se);break;case"!=":Pe=Z(re,me,Se);break;case">":Pe=J(re,me,Se);break;case">=":Pe=M(re,me,Se);break;case"<":Pe=oe(re,me,Se);break;case"<=":Pe=z(re,me,Se);break;default:throw new TypeError("Invalid operator: "+he)}return Pe}function ae(re,he){if(re instanceof ae){if(re.loose===he)return re;re=re.value}if(!(this instanceof ae))return new ae(re,he);L("comparator",re,he),this.loose=he,this.parse(re),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(re,he){return q(he,re)},e.major=function(re,he){return new X(re,he).major},e.minor=function(re,he){return new X(re,he).minor},e.patch=function(re,he){return new X(re,he).patch},e.compare=D,e.compareLoose=function(re,he){return D(re,he,!0)},e.rcompare=function(re,he,me){return D(he,re,me)},e.sort=function(re,he){return re.sort(function(me,Se){return e.compare(me,Se,he)})},e.rsort=function(re,he){return re.sort(function(me,Se){return e.rcompare(me,Se,he)})},e.gt=J,e.lt=oe,e.eq=Q,e.neq=Z,e.gte=M,e.lte=z,e.cmp=ie,e.Comparator=ae;var ue={};function pe(re,he){if(re instanceof pe)return re.loose===he?re:new pe(re.raw,he);if(re instanceof ae)return new pe(re.value,he);if(!(this instanceof pe))return new pe(re,he);if(this.loose=he,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function be(re){return!re||re.toLowerCase()==="x"||re==="*"}function Ie(re,he,me,Se,Pe,De,Le,Ce,Fe,Me,We,je,Be){return((he=be(me)?"":be(Se)?">="+me+".0.0":be(Pe)?">="+me+"."+Se+".0":">="+he)+" "+(Ce=be(Fe)?"":be(Me)?"<"+(+Fe+1)+".0.0":be(We)?"<"+Fe+"."+(+Me+1)+".0":je?"<="+Fe+"."+Me+"."+We+"-"+je:"<="+Ce)).trim()}function Ae(re,he){for(var me=0;me<re.length;me++)if(!re[me].test(he))return!1;if(he.prerelease.length){for(me=0;me<re.length;me++)if(L(re[me].semver),re[me].semver!==ue&&re[me].semver.prerelease.length>0){var Se=re[me].semver;if(Se.major===he.major&&Se.minor===he.minor&&Se.patch===he.patch)return!0}return!1}return!0}function ye(re,he,me){try{he=new pe(he,me)}catch{return!1}return he.test(re)}function we(re,he,me,Se){var Pe,De,Le,Ce,Fe;switch(re=new X(re,Se),he=new pe(he,Se),me){case">":Pe=J,De=z,Le=oe,Ce=">",Fe=">=";break;case"<":Pe=oe,De=M,Le=J,Ce="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(re,he,Se))return!1;for(var Me=0;Me<he.set.length;++Me){var We=he.set[Me],je=null,Be=null;if(We.forEach(function(ze){ze.semver===ue&&(ze=new ae(">=0.0.0")),je=je||ze,Be=Be||ze,Pe(ze.semver,je.semver,Se)?je=ze:Le(ze.semver,Be.semver,Se)&&(Be=ze)}),je.operator===Ce||je.operator===Fe||(!Be.operator||Be.operator===Ce)&&De(re,Be.semver)||Be.operator===Fe&&Le(re,Be.semver))return!1}return!0}ae.prototype.parse=function(re){var he=this.loose?C[V]:C[te],me=re.match(he);if(!me)throw new TypeError("Invalid comparator: "+re);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new X(me[2],this.loose):this.semver=ue},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(re){return L("Comparator.test",re,this.loose),this.semver===ue||(typeof re=="string"&&(re=new X(re,this.loose)),ie(re,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(re,he){if(!(re instanceof ae))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(re.value,he),ye(this.value,me,he);if(re.operator==="")return me=new pe(this.value,he),ye(re.semver,me,he);var Se=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),De=this.semver.version===re.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Ce=ie(this.semver,"<",re.semver,he)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),Fe=ie(this.semver,">",re.semver,he)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return Se||Pe||De&&Le||Ce||Fe},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(re){var he=this.loose;re=re.trim(),L("range",re,he);var me=he?C[_]:C[H];re=re.replace(me,Ie),L("hyphen replace",re),re=re.replace(C[B],"$1$2$3"),L("comparator trim",re,C[B]),re=(re=(re=re.replace(C[N],"$1~")).replace(C[G],"$1^")).split(/\s+/).join(" ");var Se=he?C[V]:C[te],Pe=re.split(" ").map(function(De){return function(Le,Ce){return L("comp",Le),Le=function(Fe,Me){return Fe.trim().split(/\s+/).map(function(We){return function(je,Be){L("caret",je,Be);var ze=Be?C[x]:C[W];return je.replace(ze,function(He,Ne,se,ge,$e){var ve;return L("caret",je,He,Ne,se,ge,$e),be(Ne)?ve="":be(se)?ve=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":be(ge)?ve=Ne==="0"?">="+Ne+"."+se+".0 <"+Ne+"."+(+se+1)+".0":">="+Ne+"."+se+".0 <"+(+Ne+1)+".0.0":$e?(L("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ve=Ne==="0"?se==="0"?">="+Ne+"."+se+"."+ge+$e+" <"+Ne+"."+se+"."+(+ge+1):">="+Ne+"."+se+"."+ge+$e+" <"+Ne+"."+(+se+1)+".0":">="+Ne+"."+se+"."+ge+$e+" <"+(+Ne+1)+".0.0"):(L("no pr"),ve=Ne==="0"?se==="0"?">="+Ne+"."+se+"."+ge+" <"+Ne+"."+se+"."+(+ge+1):">="+Ne+"."+se+"."+ge+" <"+Ne+"."+(+se+1)+".0":">="+Ne+"."+se+"."+ge+" <"+(+Ne+1)+".0.0"),L("caret return",ve),ve})}(We,Me)}).join(" ")}(Le,Ce),L("caret",Le),Le=function(Fe,Me){return Fe.trim().split(/\s+/).map(function(We){return function(je,Be){var ze=Be?C[U]:C[F];return je.replace(ze,function(He,Ne,se,ge,$e){var ve;return L("tilde",je,He,Ne,se,ge,$e),be(Ne)?ve="":be(se)?ve=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":be(ge)?ve=">="+Ne+"."+se+".0 <"+Ne+"."+(+se+1)+".0":$e?(L("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ve=">="+Ne+"."+se+"."+ge+$e+" <"+Ne+"."+(+se+1)+".0"):ve=">="+Ne+"."+se+"."+ge+" <"+Ne+"."+(+se+1)+".0",L("tilde return",ve),ve})}(We,Me)}).join(" ")}(Le,Ce),L("tildes",Le),Le=function(Fe,Me){return L("replaceXRanges",Fe,Me),Fe.split(/\s+/).map(function(We){return function(je,Be){je=je.trim();var ze=Be?C[O]:C[y];return je.replace(ze,function(He,Ne,se,ge,$e,ve){L("xRange",je,He,Ne,se,ge,$e,ve);var ke=be(se),Te=ke||be(ge),qe=Te||be($e);return Ne==="="&&qe&&(Ne=""),ke?He=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&qe?(Te&&(ge=0),qe&&($e=0),Ne===">"?(Ne=">=",Te?(se=+se+1,ge=0,$e=0):qe&&(ge=+ge+1,$e=0)):Ne==="<="&&(Ne="<",Te?se=+se+1:ge=+ge+1),He=Ne+se+"."+ge+"."+$e):Te?He=">="+se+".0.0 <"+(+se+1)+".0.0":qe&&(He=">="+se+"."+ge+".0 <"+se+"."+(+ge+1)+".0"),L("xRange return",He),He})}(We,Me)}).join(" ")}(Le,Ce),L("xrange",Le),Le=function(Fe,Me){return L("replaceStars",Fe,Me),Fe.trim().replace(C[ne],"")}(Le,Ce),L("stars",Le),Le}(De,he)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(De){return!!De.match(Se)})),Pe=Pe.map(function(De){return new ae(De,he)})},pe.prototype.intersects=function(re,he){if(!(re instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Se){return re.set.some(function(Pe){return Pe.every(function(De){return Se.intersects(De,he)})})})})},e.toComparators=function(re,he){return new pe(re,he).set.map(function(me){return me.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new X(re,this.loose));for(var he=0;he<this.set.length;he++)if(Ae(this.set[he],re))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(re,he,me){var Se=null,Pe=null;try{var De=new pe(he,me)}catch{return null}return re.forEach(function(Le){De.test(Le)&&(Se&&Pe.compare(Le)!==-1||(Pe=new X(Se=Le,me)))}),Se},e.minSatisfying=function(re,he,me){var Se=null,Pe=null;try{var De=new pe(he,me)}catch{return null}return re.forEach(function(Le){De.test(Le)&&(Se&&Pe.compare(Le)!==1||(Pe=new X(Se=Le,me)))}),Se},e.validRange=function(re,he){try{return new pe(re,he).range||"*"}catch{return null}},e.ltr=function(re,he,me){return we(re,he,"<",me)},e.gtr=function(re,he,me){return we(re,he,">",me)},e.outside=we,e.prerelease=function(re,he){var me=ee(re,he);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(re,he,me){return re=new pe(re,me),he=new pe(he,me),re.intersects(he)},e.coerce=function(re){if(re instanceof X)return re;if(typeof re!="string")return null;var he=re.match(C[S]);return he==null?null:ee((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,P(1))},function(ce,e){var P,a,L=ce.exports={};function k(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function C(E){if(P===setTimeout)return setTimeout(E,0);if((P===k||!P)&&setTimeout)return P=setTimeout,setTimeout(E,0);try{return P(E,0)}catch{try{return P.call(null,E,0)}catch{return P.call(this,E,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:k}catch{P=k}try{a=typeof clearTimeout=="function"?clearTimeout:T}catch{a=T}})();var A,b=[],R=!1,p=-1;function m(){R&&A&&(R=!1,A.length?b=A.concat(b):p=-1,b.length&&g())}function g(){if(!R){var E=C(m);R=!0;for(var w=b.length;w;){for(A=b,b=[];++p<w;)A&&A[p].run();p=-1,w=b.length}A=null,R=!1,function(d){if(a===clearTimeout)return clearTimeout(d);if((a===T||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(d);try{a(d)}catch{try{return a.call(null,d)}catch{return a.call(this,d)}}}(E)}}function l(E,w){this.fun=E,this.array=w}function f(){}L.nextTick=function(E){var w=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)w[d-1]=arguments[d];b.push(new l(E,w)),b.length!==1||R||C(g)},l.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=f,L.addListener=f,L.once=f,L.off=f,L.removeListener=f,L.removeAllListeners=f,L.emit=f,L.prependListener=f,L.prependOnceListener=f,L.listeners=function(E){return[]},L.binding=function(E){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(E){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(fe[135],de([0,1]),function(ce,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0;class a{constructor(C,A,b){this.level=C,this.key=A,this.value=b,this.forward=[]}}const L=void 0;class k{constructor(C,A=2**16){this.comparator=C,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(A)|0),this.e=new a(this.c,L,L)}get size(){return this.f}clear(){this.e=new a(this.c,L,L),this.f=0}has(C){return!!k.g(this,C,this.comparator)}get(C){return k.g(this,C,this.comparator)?.value}set(C,A){return k.h(this,C,A,this.comparator)&&(this.f+=1),this}delete(C){const A=k.k(this,C,this.comparator);return A&&(this.f-=1),A}forEach(C,A){let b=this.e.forward[0];for(;b;)C.call(A,b.value,b.key,this),b=b.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this.e.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this.e.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this.e.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",A=this.e.forward[0];for(;A;)C+=`node(${A.key}, ${A.value}, lvl:${A.level})`,A=A.forward[0];return C}static g(C,A,b){let R=C.e;for(let p=C.d-1;p>=0;p--)for(;R.forward[p]&&b(R.forward[p].key,A)<0;)R=R.forward[p];if(R=R.forward[0],R&&b(R.key,A)===0)return R}static h(C,A,b,R){const p=[];let m=C.e;for(let g=C.d-1;g>=0;g--){for(;m.forward[g]&&R(m.forward[g].key,A)<0;)m=m.forward[g];p[g]=m}if(m=m.forward[0],m&&R(m.key,A)===0)return m.value=b,!1;{const g=k.j(C);if(g>C.d){for(let l=C.d;l<g;l++)p[l]=C.e;C.d=g}m=new a(g,A,b);for(let l=0;l<g;l++)m.forward[l]=p[l].forward[l],p[l].forward[l]=m;return!0}}static j(C,A=.5){let b=1;for(;Math.random()<A&&b<C.c;)b+=1;return b}static k(C,A,b){const R=[];let p=C.e;for(let m=C.d-1;m>=0;m--){for(;p.forward[m]&&b(p.forward[m].key,A)<0;)p=p.forward[m];R[m]=p}if(p=p.forward[0],!p||b(p.key,A)!==0)return!1;for(let m=0;m<C.d&&R[m].forward[m]===p;m++)R[m].forward[m]=p.forward[m];for(;C.d>0&&C.e.forward[C.d-1]===L;)C.d-=1;return!0}}e.$2s=k}),define(fe[54],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(k){return new a(k)}constructor(k){this.c=P&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ke=a}),define(fe[3],de([0,1,8,89,2,90,54]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$me=e.Event=void 0,e.$ne=g;const C=!1,A=!1,b=!1;var R;(function(U){U.None=()=>L.$Zc.None;function j(ye){if(b){const{onDidAddListener:we}=ye,re=f.create();let he=0;ye.onDidAddListener=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),we?.()}}}function G(ye,we){return X(ye,()=>{},0,void 0,!0,void 0,we)}U.defer=G;function W(ye){return(we,re=null,he)=>{let me=!1,Se;return Se=ye(Pe=>{if(!me)return Se?Se.dispose():me=!0,we.call(re,Pe)},null,he),me&&Se.dispose(),Se}}U.once=W;function x(ye,we){return U.once(U.filter(ye,we))}U.onceIf=x;function V(ye,we,re){return le((he,me=null,Se)=>ye(Pe=>he.call(me,we(Pe)),null,Se),re)}U.map=V;function te(ye,we,re){return le((he,me=null,Se)=>ye(Pe=>{we(Pe),he.call(me,Pe)},null,Se),re)}U.forEach=te;function B(ye,we,re){return le((he,me=null,Se)=>ye(Pe=>we(Pe)&&he.call(me,Pe),null,Se),re)}U.filter=B;function H(ye){return ye}U.signal=H;function _(...ye){return(we,re=null,he)=>{const me=(0,L.$Wc)(...ye.map(Se=>Se(Pe=>we.call(re,Pe))));return ee(me,he)}}U.any=_;function ne(ye,we,re,he){let me=re;return V(ye,Se=>(me=we(me,Se),me),he)}U.reduce=ne;function le(ye,we){let re;const he={onWillAddFirstListener(){re=ye(me.fire,me)},onDidRemoveLastListener(){re?.dispose()}};we||j(he);const me=new i(he);return we?.add(me),me.event}function ee(ye,we){return we instanceof Array?we.push(ye):we&&we.add(ye),ye}function X(ye,we,re=100,he=!1,me=!1,Se,Pe){let De,Le,Ce,Fe=0,Me;const We={leakWarningThreshold:Se,onWillAddFirstListener(){De=ye(Be=>{Fe++,Le=we(Le,Be),he&&!Ce&&(je.fire(Le),Le=void 0),Me=()=>{const ze=Le;Le=void 0,Ce=void 0,(!he||Fe>1)&&je.fire(ze),Fe=0},typeof re=="number"?(clearTimeout(Ce),Ce=setTimeout(Me,re)):Ce===void 0&&(Ce=0,queueMicrotask(Me))})},onWillRemoveListener(){me&&Fe>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,De.dispose()}};Pe||j(We);const je=new i(We);return Pe?.add(je),je.event}U.debounce=X;function K(ye,we=0,re){return U.debounce(ye,(he,me)=>he?(he.push(me),he):[me],we,void 0,!0,void 0,re)}U.accumulate=K;function q(ye,we=(he,me)=>he===me,re){let he=!0,me;return B(ye,Se=>{const Pe=he||!we(Se,me);return he=!1,me=Se,Pe},re)}U.latch=q;function D(ye,we,re){return[U.filter(ye,we,re),U.filter(ye,he=>!we(he),re)]}U.split=D;function J(ye,we=!1,re=[],he){let me=re.slice(),Se=ye(Le=>{me?me.push(Le):De.fire(Le)});he&&he.add(Se);const Pe=()=>{me?.forEach(Le=>De.fire(Le)),me=null},De=new i({onWillAddFirstListener(){Se||(Se=ye(Le=>De.fire(Le)),he&&he.add(Se))},onDidAddFirstListener(){me&&(we?setTimeout(Pe):Pe())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return he&&he.add(De),De.event}U.buffer=J;function oe(ye,we){return(he,me,Se)=>{const Pe=we(new Z);return ye(function(De){const Le=Pe.evaluate(De);Le!==Q&&he.call(me,Le)},void 0,Se)}}U.chain=oe;const Q=Symbol("HaltChainable");class Z{constructor(){this.f=[]}map(we){return this.f.push(we),this}forEach(we){return this.f.push(re=>(we(re),re)),this}filter(we){return this.f.push(re=>we(re)?re:Q),this}reduce(we,re){let he=re;return this.f.push(me=>(he=we(he,me),he)),this}latch(we=(re,he)=>re===he){let re=!0,he;return this.f.push(me=>{const Se=re||!we(me,he);return re=!1,he=me,Se?me:Q}),this}evaluate(we){for(const re of this.f)if(we=re(we),we===Q)break;return we}}function M(ye,we,re=he=>he){const he=(...De)=>Pe.fire(re(...De)),me=()=>ye.on(we,he),Se=()=>ye.removeListener(we,he),Pe=new i({onWillAddFirstListener:me,onDidRemoveLastListener:Se});return Pe.event}U.fromNodeEventEmitter=M;function z(ye,we,re=he=>he){const he=(...De)=>Pe.fire(re(...De)),me=()=>ye.addEventListener(we,he),Se=()=>ye.removeEventListener(we,he),Pe=new i({onWillAddFirstListener:me,onDidRemoveLastListener:Se});return Pe.event}U.fromDOMEventEmitter=z;function ie(ye){return new Promise(we=>W(ye)(we))}U.toPromise=ie;function ae(ye){const we=new i;return ye.then(re=>{we.fire(re)},()=>{we.fire(void 0)}).finally(()=>{we.dispose()}),we.event}U.fromPromise=ae;function ue(ye,we){return ye(re=>we.fire(re))}U.forward=ue;function pe(ye,we,re){return we(re),ye(he=>we(he))}U.runAndSubscribe=pe;class be{constructor(we,re){this._observable=we,this.f=0,this.g=!1;const he={onWillAddFirstListener:()=>{we.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{we.removeObserver(this)}};re||j(he),this.emitter=new i(he),re&&re.add(this.emitter)}beginUpdate(we){this.f++}handlePossibleChange(we){}handleChange(we,re){this.g=!0}endUpdate(we){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ie(ye,we){return new be(ye,we).emitter.event}U.fromObservable=Ie;function Ae(ye){return(we,re,he)=>{let me=0,Se=!1;const Pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(ye.reportChanges(),Se&&(Se=!1,we.call(re)))},handlePossibleChange(){},handleChange(){Se=!0}};ye.addObserver(Pe),ye.reportChanges();const De={dispose(){ye.removeObserver(Pe)}};return he instanceof L.$Yc?he.add(De):Array.isArray(he)&&he.push(De),De}}U.fromObservableLight=Ae})(R||(e.Event=R={}));class p{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${p.f++}`,p.all.add(this)}start(j){this.g=new T.$ke,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$me=p;let m=-1;function g(U){const j=m;return m=U,{dispose(){m=j}}}class l{static{this.f=1}constructor(j,G,W=(l.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=G,this.name=W,this.h=0}dispose(){this.g?.clear()}check(j,G){const W=this.threshold;if(W<=0||G<W)return;this.g||(this.g=new Map);const x=this.g.get(j.value)||0;if(this.g.set(j.value,x+1),this.h-=1,this.h<=0){this.h=W*.5;const[V,te]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${G} listeners already. MOST frequent listener (${te}):`;console.warn(B),console.warn(V);const H=new E(B,V);this.j(H)}return()=>{const V=this.g.get(j.value)||0;this.g.set(j.value,V-1)}}getMostFrequentStack(){if(!this.g)return;let j,G=0;for(const[W,x]of this.g)(!j||G<x)&&(j=[W,x],G=x);return j}}class f{static create(){const j=new Error;return new f(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E extends Error{constructor(j,G){super(j),this.name="ListenerLeakError",this.stack=G}}e.$oe=E;class w extends Error{constructor(j,G){super(j),this.name="ListenerRefusalError",this.stack=G}}e.$pe=w;let d=0;class I{constructor(j){this.value=j,this.id=d++}}const $=2,c=(U,j)=>{if(U instanceof I)j(U);else for(let G=0;G<U.length;G++){const W=U[G];W&&j(W)}};let h;if(C){const U=[];setInterval(()=>{U.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(U.join(`
`)),U.length=0)},3e3),h=new FinalizationRegistry(j=>{typeof j=="string"&&U.push(j)})}class i{constructor(j){this.z=0,this.f=j,this.g=m>0||this.f?.leakWarningThreshold?new l(j?.onListenerError??P.$4,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(A){const j=this.u;queueMicrotask(()=>{c(j,G=>G.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,G,W)=>{if(this.g&&this.z>this.g.threshold**2){const H=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(H);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new w(`${H}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||P.$4)(ne),L.$Zc.None}if(this.m)return L.$Zc.None;G&&(j=j.bind(G));const x=new I(j);let V,te;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=f.create(),V=this.g.check(x.stack,this.z+1)),A&&(x.stack=te??f.create()),this.u?this.u instanceof I?(this.w??=new t,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,L.$Xc)(()=>{h?.unregister(B),V?.(),this.A(x)});if(W instanceof L.$Yc?W.add(B):Array.isArray(W)&&W.push(B),h){const H=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(H);h.register(B,_?.[2]??H,B)}return B},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const G=this.u,W=G.indexOf(j);if(W===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,G[W]=void 0;const x=this.w.current===this;if(this.z*$<=G.length){let V=0;for(let te=0;te<G.length;te++)G[te]?G[V++]=G[te]:x&&(this.w.end--,V<this.w.i&&this.w.i--);G.length=V}}B(j,G){if(!j)return;const W=this.f?.onListenerError||P.$4;if(!W){j.value(G);return}try{j.value(G)}catch(x){W(x)}}C(j){const G=j.current.u;for(;j.i<j.end;)this.B(G[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof I)this.B(this.u,j);else{const G=this.w;G.enqueue(this,j,this.u.length),this.C(G)}this.j?.stop()}hasListeners(){return this.z>0}}e.$qe=i;const n=()=>new t;e.$re=n;class t{constructor(){this.i=-1,this.end=0}enqueue(j,G,W){this.i=0,this.end=W,this.current=j,this.value=G}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends i{async fireAsync(j,G,W){if(this.u)for(this.h||(this.h=new k.$0c),c(this.u,x=>this.h.push([x.value,j]));this.h.size>0&&!G.isCancellationRequested;){const[x,V]=this.h.shift(),te=[],B={...V,token:G,waitUntil:H=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");W&&(H=W(H,x)),te.push(H)}};try{x(B)}catch(H){(0,P.$4)(H);continue}Object.freeze(te),await Promise.allSettled(te).then(H=>{for(const _ of H)_.status==="rejected"&&(0,P.$4)(_.reason)})}}}e.$se=s;class r extends i{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new k.$0c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$te=r;class o extends r{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$ue=o;class u extends i{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(G=>super.fire(G)),this.h=[]}))}}e.$ve=u;class y{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const G={event:j,listener:null};this.h.push(G),this.g&&this.m(G);const W=()=>{this.g&&this.o(G);const x=this.h.indexOf(G);this.h.splice(x,1)};return(0,L.$Xc)((0,a.$hb)(W))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(G=>this.f.fire(G))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$we=y;class O{constructor(j,G,W,x){this.f=new L.$Yc;const V=this.f.add(new y),te=this.f.add(new L.$9c);function B(H){te.set(H,V.add(x(H)))}for(const H of j)B(H);this.f.add(G(H=>{B(H)})),this.f.add(W(H=>{te.deleteAndDispose(H)})),this.event=V.event}dispose(){this.f.dispose()}}e.$xe=O;class S{constructor(){this.f=[]}wrapEvent(j,G,W){return(x,V,te)=>j(B=>{const H=this.f[this.f.length-1];if(!G){H?H.buffers.push(()=>x.call(V,B)):x.call(V,B);return}const _=H;if(!_){x.call(V,G(W,B));return}_.items??=[],_.items.push(B),_.buffers.length===0&&H.buffers.push(()=>{_.reducedResult??=W?_.items.reduce(G,W):_.items.reduce(G),x.call(V,_.reducedResult)})},void 0,te)}bufferEvents(j){const G={buffers:new Array};this.f.push(G);const W=j();return this.f.pop(),G.buffers.forEach(x=>x()),W}}e.$ye=S;class v{constructor(){this.f=!1,this.g=R.None,this.h=L.$Zc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ze=v;class N{static const(j){return new F(j)}constructor(j){this.g=j,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$Ae=N;class F{constructor(j){this.value=j,this.onDidChange=R.None}}}),define(fe[25],de([0,1,3]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.CancellationToken=void 0,e.$Ce=C;const a=Object.freeze(function(A,b){const R=setTimeout(A.bind(b),0);return{dispose(){clearTimeout(R)}}});var L;(function(A){function b(R){return R===A.None||R===A.Cancelled||R instanceof k?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}A.isCancellationToken=b,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(L||(e.CancellationToken=L={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new P.$qe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new k),this.f}cancel(){this.f?this.f instanceof k&&this.f.cancel():this.f=L.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof k&&this.f.dispose():this.f=L.None}}e.$Be=T;function C(A){const b=new T;return A.add({dispose(){b.cancel()}}),b.token}}),define(fe[136],de([0,1,25]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ef=e.$df=e.$bf=void 0,e.$cf=L;class a{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new P.$Be,b=this.b(A.token);return this.a={promise:b,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.$bf=a;function L(C){return C}class k{constructor(A,b){this.a=void 0,this.b=void 0,typeof A=="function"?(this.c=A,this.d=L):(this.c=b,this.d=A.getCacheKey)}get(A){const b=this.d(A);return this.b!==b&&(this.b=b,this.a=this.c(A)),this.a}}e.$df=k;class T{get cachedValues(){return this.a}constructor(A,b){this.a=new Map,this.b=new Map,typeof A=="function"?(this.c=A,this.d=L):(this.c=b,this.d=A.getCacheKey)}get(A){const b=this.d(A);if(this.b.has(b))return this.b.get(b);const R=this.c(A);return this.a.set(A,R),this.b.set(b,R),R}}e.$ef=T}),define(fe[50],de([0,1,8,2]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=L,e.$Ee=k,e.$Fe=T,e.$Ge=C,e.$He=b,e.$Ie=R,e.$Je=p,e.$Ke=m,e.$Le=g,e.$Me=l,e.$Ne=f,e.$Oe=E,e.$Pe=w,e.$Qe=d,e.$Re=I;function L($){const c=$;return c?typeof c.read=="function":!1}function k($){const c=$;return c?[c.on,c.pause,c.resume,c.destroy].every(h=>typeof h=="function"):!1}function T($){const c=$;return c?k(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}function C($,c){return new A($,c)}class A{constructor(c,h){this.e=c,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(h=>h(c))}h(c){this.c.error.length===0?(0,P.$4)(c):this.c.error.slice(0).forEach(h=>h(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,h){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(c,h){if(this.a.destroyed)return;let i;switch(c){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const n=i.indexOf(h);n>=0&&i.splice(n,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b($,c){const h=[];let i;for(;(i=$.read())!==null;)h.push(i);return c(h)}function R($,c,h){const i=[];let n;for(;(n=$.read())!==null&&i.length<h;)i.push(n);return n===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return $.read()}}}function p($,c){return new Promise((h,i)=>{const n=[];m($,{onData:t=>{c&&n.push(t)},onError:t=>{c?i(t):h(void 0)},onEnd:()=>{h(c?c(n):void 0)}})})}function m($,c,h){$.on("error",i=>{h?.isCancellationRequested||c.onError(i)}),$.on("end",()=>{h?.isCancellationRequested||c.onEnd()}),$.on("data",i=>{h?.isCancellationRequested||c.onData(i)})}function g($,c){return new Promise((h,i)=>{const n=new a.$Yc,t=[],s=u=>{if(t.push(u),t.length>c)return n.dispose(),$.pause(),h({stream:$,buffer:t,ended:!1})},r=u=>(n.dispose(),i(u)),o=()=>(n.dispose(),h({stream:$,buffer:t,ended:!0}));n.add((0,a.$Xc)(()=>$.removeListener("error",r))),$.on("error",r),n.add((0,a.$Xc)(()=>$.removeListener("end",o))),$.on("end",o),n.add((0,a.$Xc)(()=>$.removeListener("data",s))),$.on("data",s)})}function l($,c){const h=C(c);return h.end($),h}function f(){const $=C(()=>{throw new Error("not supported")});return $.end(),$}function E($){let c=!1;return{read:()=>c?null:(c=!0,$)}}function w($,c,h){const i=C(h);return m($,{onData:n=>i.write(c.data(n)),onError:n=>i.error(c.error?c.error(n):n),onEnd:()=>i.end()}),i}function d($,c,h){let i=!1;return{read:()=>{const n=c.read();return i?n:(i=!0,n!==null?h([$,n]):$)}}}function I($,c,h){let i=!1;const n=C(h);return m(c,{onData:t=>i?n.write(t):(i=!0,n.write(h([$,t]))),onError:t=>n.error(t),onEnd:()=>{i||(i=!0,n.write($)),n.end()}}),n}});var kt=this&&this.__createBinding||(Object.create?function(ce,e,P,a){a===void 0&&(a=P);var L=Object.getOwnPropertyDescriptor(e,P);(!L||("get"in L?!e.__esModule:L.writable||L.configurable))&&(L={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(ce,a,L)}:function(ce,e,P,a){a===void 0&&(a=P),ce[a]=e[P]}),At=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),Oe=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var P in ce)P!=="default"&&Object.prototype.hasOwnProperty.call(ce,P)&&kt(e,ce,P);return At(e,ce),e};define(fe[14],de([0,1,53,50]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=b,e.$Ue=R,e.$Ve=p,e.$We=m,e.$Xe=g,e.$Ye=l,e.$Ze=f,e.$1e=E,e.$2e=w,e.$3e=d,e.$4e=I,e.$5e=$,e.$6e=c,e.$7e=h,e.$8e=i,e.$9e=n,e.$0e=t,e.$$e=s,e.$_e=r,e.$af=y,a=Oe(a);const L=typeof Buffer<"u",k=new P.$Y(()=>new Uint8Array(256));let T,C;class A{static alloc(S){return L?new A(Buffer.allocUnsafe(S)):new A(new Uint8Array(S))}static wrap(S){return L&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new A(S)}static fromString(S,v){return!(v?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(S)):(T||(T=new TextEncoder),new A(T.encode(S)))}static fromByteArray(S){const v=A.alloc(S.length);for(let N=0,F=S.length;N<F;N++)v.buffer[N]=S[N];return v}static concat(S,v){if(typeof v>"u"){v=0;for(let U=0,j=S.length;U<j;U++)v+=S[U].byteLength}const N=A.alloc(v);let F=0;for(let U=0,j=S.length;U<j;U++){const G=S[U];N.set(G,F),F+=G.byteLength}return N}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=A.alloc(this.byteLength);return S.set(this),S}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(S,v){return new A(this.buffer.subarray(S,v))}set(S,v){if(S instanceof A)this.buffer.set(S.buffer,v);else if(S instanceof Uint8Array)this.buffer.set(S,v);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),v);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return m(this.buffer,S)}writeUInt32BE(S,v){g(this.buffer,S,v)}readUInt32LE(S){return l(this.buffer,S)}writeUInt32LE(S,v){f(this.buffer,S,v)}readUInt8(S){return E(this.buffer,S)}writeUInt8(S,v){w(this.buffer,S,v)}indexOf(S,v=0){return b(this.buffer,S instanceof A?S.buffer:S,v)}}e.$Se=A;function b(O,S,v=0){const N=S.byteLength,F=O.byteLength;if(N===0)return 0;if(N===1)return O.indexOf(S[0]);if(N>F-v)return-1;const U=k.value;U.fill(S.length);for(let x=0;x<S.length;x++)U[S[x]]=S.length-x-1;let j=v+S.length-1,G=j,W=-1;for(;j<F;)if(O[j]===S[G]){if(G===0){W=j;break}j--,G--}else j+=Math.max(S.length-G,U[O[j]]),G=S.length-1;return W}function R(O,S){return O[S+0]<<0>>>0|O[S+1]<<8>>>0}function p(O,S,v){O[v+0]=S&255,S=S>>>8,O[v+1]=S&255}function m(O,S){return O[S]*2**24+O[S+1]*2**16+O[S+2]*2**8+O[S+3]}function g(O,S,v){O[v+3]=S,S=S>>>8,O[v+2]=S,S=S>>>8,O[v+1]=S,S=S>>>8,O[v]=S}function l(O,S){return O[S+0]<<0>>>0|O[S+1]<<8>>>0|O[S+2]<<16>>>0|O[S+3]<<24>>>0}function f(O,S,v){O[v+0]=S&255,S=S>>>8,O[v+1]=S&255,S=S>>>8,O[v+2]=S&255,S=S>>>8,O[v+3]=S&255}function E(O,S){return O[S]}function w(O,S,v){O[v]=S}function d(O){return a.$He(O,S=>A.concat(S))}function I(O){return a.$Oe(O)}function $(O){return a.$Je(O,S=>A.concat(S))}async function c(O){return O.ended?A.concat(O.buffer):A.concat([...O.buffer,await $(O.stream)])}function h(O){return a.$Me(O,S=>A.concat(S))}function i(O){return a.$Pe(O,{data:S=>typeof S=="string"?A.fromString(S):A.wrap(S)},S=>A.concat(S))}function n(O){return a.$Ge(S=>A.concat(S),O)}function t(O,S){return a.$Qe(O,S,v=>A.concat(v))}function s(O,S){return a.$Re(O,S,v=>A.concat(v))}function r(O){let S=0,v=0,N=0;const F=new Uint8Array(Math.floor(O.length/4*3)),U=G=>{switch(v){case 3:F[N++]=S|G,v=0;break;case 2:F[N++]=S|G>>>2,S=G<<6,v=3;break;case 1:F[N++]=S|G>>>4,S=G<<4,v=2;break;default:S=G<<2,v=1}};for(let G=0;G<O.length;G++){const W=O.charCodeAt(G);if(W>=65&&W<=90)U(W-65);else if(W>=97&&W<=122)U(W-97+26);else if(W>=48&&W<=57)U(W-48+52);else if(W===43||W===45)U(62);else if(W===47||W===95)U(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${O[G]}`)}}const j=N;for(;v>0;)U(0);return A.wrap(F).slice(0,j)}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:O},S=!0,v=!1){const N=v?u:o;let F="";const U=O.byteLength%3;let j=0;for(;j<O.byteLength-U;j+=3){const G=O[j+0],W=O[j+1],x=O[j+2];F+=N[G>>>2],F+=N[(G<<4|W>>>4)&63],F+=N[(W<<2|x>>>6)&63],F+=N[x&63]}if(U===1){const G=O[j+0];F+=N[G>>>2],F+=N[G<<4&63],S&&(F+="==")}else if(U===2){const G=O[j+0],W=O[j+1];F+=N[G>>>2],F+=N[(G<<4|W>>>4)&63],F+=N[W<<2&63],S&&(F+="=")}return F}}),define(fe[137],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=void 0,e.$le=Symbol("MicrotaskDelay")}),define(fe[12],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=P,e.$kg=a,e.$lg=L,e.$mg=k,e.$ng=T,e.$og=C,e.$pg=A,e.$qg=b,e.$rg=R,e.$sg=p,e.$tg=m,e.$ug=g,e.$vg=l,e.$wg=E,e.$xg=w,e.$yg=d,e.$zg=I,e.$Ag=$,e.$Bg=c;function P(h){return typeof h=="string"}function a(h){return Array.isArray(h)&&h.every(i=>P(i))}function L(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function k(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}function T(h){return typeof h=="number"&&!isNaN(h)}function C(h){return!!h&&typeof h[Symbol.iterator]=="function"}function A(h){return h===!0||h===!1}function b(h){return typeof h>"u"}function R(h){return!p(h)}function p(h){return b(h)||h===null}function m(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function g(h){if(p(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function l(...h){const i=[];for(let n=0;n<h.length;n++){const t=h[n];if(p(t))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(t)}return i}const f=Object.prototype.hasOwnProperty;function E(h){if(!L(h))return!1;for(const i in h)if(f.call(h,i))return!1;return!0}function w(h){return typeof h=="function"}function d(...h){return h.length>0&&h.every(w)}function I(h,i){const n=Math.min(h.length,i.length);for(let t=0;t<n;t++)$(h[t],i[t])}function $(h,i){if(P(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(w(i)){try{if(h instanceof i)return}catch{}if(!p(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function c(h){return h}}),define(fe[29],de([0,1,12]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=a,e.$lo=L,e.$mo=T,e.$no=A,e.$oo=b,e.$po=R,e.$qo=p,e.$ro=m,e.$so=g,e.$to=l,e.$uo=f,e.$vo=E,e.$wo=w;function a(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const I=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([$,c])=>{I[$]=c&&typeof c=="object"?a(c):c}),I}function L(d){if(!d||typeof d!="object")return d;const I=[d];for(;I.length>0;){const $=I.shift();Object.freeze($);for(const c in $)if(k.call($,c)){const h=$[c];typeof h=="object"&&!Object.isFrozen(h)&&!(0,P.$mg)(h)&&I.push(h)}}return d}const k=Object.prototype.hasOwnProperty;function T(d,I){return C(d,I,new Set)}function C(d,I,$){if((0,P.$sg)(d))return d;const c=I(d);if(typeof c<"u")return c;if(Array.isArray(d)){const h=[];for(const i of d)h.push(C(i,I,$));return h}if((0,P.$lg)(d)){if($.has(d))throw new Error("Cannot clone recursive data-structure");$.add(d);const h={};for(const i in d)k.call(d,i)&&(h[i]=C(d[i],I,$));return $.delete(d),h}return d}function A(d,I,$=!0){return(0,P.$lg)(d)?((0,P.$lg)(I)&&Object.keys(I).forEach(c=>{c in d?$&&((0,P.$lg)(d[c])&&(0,P.$lg)(I[c])?A(d[c],I[c],$):d[c]=I[c]):d[c]=I[c]}),d):I}function b(d,I){if(d===I)return!0;if(d==null||I===null||I===void 0||typeof d!=typeof I||typeof d!="object"||Array.isArray(d)!==Array.isArray(I))return!1;let $,c;if(Array.isArray(d)){if(d.length!==I.length)return!1;for($=0;$<d.length;$++)if(!b(d[$],I[$]))return!1}else{const h=[];for(c in d)h.push(c);h.sort();const i=[];for(c in I)i.push(c);if(i.sort(),!b(h,i))return!1;for($=0;$<h.length;$++)if(!b(d[h[$]],I[h[$]]))return!1}return!0}function R(d){const I=new Set;return JSON.stringify(d,($,c)=>{if((0,P.$lg)(c)||Array.isArray(c)){if(I.has(c))return"[Circular]";I.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function p(d,I){const $=Object.create(null);return!d||!I||Object.keys(I).forEach(h=>{const i=d[h],n=I[h];b(i,n)||($[h]=n)}),$}function m(d,I){const $=I.toLowerCase(),c=Object.keys(d).find(h=>h.toLowerCase()===$);return c?d[c]:d[I]}function g(d,I){const $=Object.create(null);for(const[c,h]of Object.entries(d))I(c,h)&&($[c]=h);return $}function l(d){let I=[];for(;Object.prototype!==d;)I=I.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return I}function f(d){const I=[];for(const $ of l(d))typeof d[$]=="function"&&I.push($);return I}function E(d,I){const $=h=>function(){const i=Array.prototype.slice.call(arguments,0);return I(h,i)},c={};for(const h of d)c[h]=$(h);return c}function w(d,I){const $={};for(const[c,h]of Object.entries(d))$[c]=I(h,c);return $}}),define(fe[138],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$ff=a,e.$gf=L;var P;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(e.Constants=P={}));function a(k){return k<0?0:k>P.MAX_UINT_8?P.MAX_UINT_8:k|0}function L(k){return k<0?0:k>P.MAX_UINT_32?P.MAX_UINT_32:k|0}}),define(fe[26],de([0,1,136,39,53,138]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=e.GraphemeBreakType=e.$9f=e.$1f=e.$Tf=e.$Sf=void 0,e.$hf=T,e.$if=A,e.$jf=R,e.$kf=p,e.$lf=m,e.$mf=g,e.$nf=l,e.$of=f,e.$pf=E,e.$qf=w,e.$rf=d,e.$sf=I,e.$tf=$,e.$uf=c,e.$vf=h,e.$wf=i,e.$xf=n,e.$yf=t,e.$zf=s,e.$Af=r,e.$Bf=o,e.$Cf=u,e.$Df=y,e.$Ef=O,e.$Ff=S,e.$Gf=v,e.$Hf=N,e.$If=F,e.$Jf=U,e.$Kf=j,e.$Lf=G,e.$Mf=W,e.$Nf=x,e.$Of=V,e.$Pf=te,e.$Qf=B,e.$Rf=H,e.$Uf=ee,e.$Vf=X,e.$Wf=K,e.$Xf=q,e.$Yf=oe,e.$Zf=Z,e.$2f=M,e.$3f=z,e.$4f=ie,e.$5f=ae,e.$6f=pe,e.$7f=be,e.$8f=Ae,e.$0f=ye,e.$$f=we,e.$_f=re,e.$ag=he,e.$bg=me,e.$cg=Se,e.$dg=Pe,e.$eg=De,e.$fg=We;function T(se){return!se||typeof se!="string"?!0:se.trim().length===0}const C=/{(\d+)}/g;function A(se,...ge){return ge.length===0?se:se.replace(C,function($e,ve){const ke=parseInt(ve,10);return isNaN(ke)||ke<0||ke>=ge.length?$e:ge[ke]})}const b=/{([^}]+)}/g;function R(se,ge){return Object.keys(ge).length===0?se:se.replace(b,($e,ve)=>ge[ve]??$e)}function p(se){return se.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function m(se){return se.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function g(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,ge){let $e=0,ve=se.indexOf(ge);for(;ve!==-1;)$e++,ve=se.indexOf(ge,ve+ge.length);return $e}function f(se,ge,$e="\u2026"){return se.length<=ge?se:`${se.substr(0,ge)}${$e}`}function E(se,ge,$e="\u2026"){if(se.length<=ge)return se;const ve=Math.ceil(ge/2)-$e.length/2,ke=Math.floor(ge/2)-$e.length/2;return`${se.substr(0,ve)}${$e}${se.substr(se.length-ke)}`}function w(se,ge=" "){const $e=d(se,ge);return I($e,ge)}function d(se,ge){if(!se||!ge)return se;const $e=ge.length;if($e===0||se.length===0)return se;let ve=0;for(;se.indexOf(ge,ve)===ve;)ve=ve+$e;return se.substring(ve)}function I(se,ge){if(!se||!ge)return se;const $e=ge.length,ve=se.length;if($e===0||ve===0)return se;let ke=ve,Te=-1;for(;Te=se.lastIndexOf(ge,ke-1),!(Te===-1||Te+$e!==ke);){if(Te===0)return"";ke=Te}return se.substring(0,ke)}function $(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(se){return se.replace(/\*/g,"")}function h(se,ge,$e={}){if(!se)throw new Error("Cannot create regex from empty string");ge||(se=g(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ve="";return $e.global&&(ve+="g"),$e.matchCase||(ve+="i"),$e.multiline&&(ve+="m"),$e.unicode&&(ve+="u"),new RegExp(se,ve)}function i(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function n(se){return se.split(/\r\n|\r|\n/)}function t(se){const ge=[],$e=se.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil($e.length/2);ve++)ge.push($e[2*ve]+($e[2*ve+1]??""));return ge}function s(se){for(let ge=0,$e=se.length;ge<$e;ge++){const ve=se.charCodeAt(ge);if(ve!==a.CharCode.Space&&ve!==a.CharCode.Tab)return ge}return-1}function r(se,ge=0,$e=se.length){for(let ve=ge;ve<$e;ve++){const ke=se.charCodeAt(ve);if(ke!==a.CharCode.Space&&ke!==a.CharCode.Tab)return se.substring(ge,ve)}return se.substring(ge,$e)}function o(se,ge=se.length-1){for(let $e=ge;$e>=0;$e--){const ve=se.charCodeAt($e);if(ve!==a.CharCode.Space&&ve!==a.CharCode.Tab)return $e}return-1}function u(se,ge,$e){const ve=[];let ke=0;for(const Te of se.matchAll(ge)){if(ve.push(se.slice(ke,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");ke=Te.index+Te[0].length,ve.push($e(Te[0],...Te.slice(1),Te.index,se,Te.groups))}return ve.push(se.slice(ke)),Promise.all(ve).then(Te=>Te.join(""))}function y(se,ge){return se<ge?-1:se>ge?1:0}function O(se,ge,$e=0,ve=se.length,ke=0,Te=ge.length){for(;$e<ve&&ke<Te;$e++,ke++){const Je=se.charCodeAt($e),Ye=ge.charCodeAt(ke);if(Je<Ye)return-1;if(Je>Ye)return 1}const qe=ve-$e,xe=Te-ke;return qe<xe?-1:qe>xe?1:0}function S(se,ge){return v(se,ge,0,se.length,0,ge.length)}function v(se,ge,$e=0,ve=se.length,ke=0,Te=ge.length){for(;$e<ve&&ke<Te;$e++,ke++){let Je=se.charCodeAt($e),Ye=ge.charCodeAt(ke);if(Je===Ye)continue;if(Je>=128||Ye>=128)return O(se.toLowerCase(),ge.toLowerCase(),$e,ve,ke,Te);F(Je)&&(Je-=32),F(Ye)&&(Ye-=32);const Ve=Je-Ye;if(Ve!==0)return Ve}const qe=ve-$e,xe=Te-ke;return qe<xe?-1:qe>xe?1:0}function N(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function F(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function U(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function j(se,ge){return se.length===ge.length&&v(se,ge)===0}function G(se,ge){const $e=ge.length;return ge.length>se.length?!1:v(se,ge,0,$e)===0}function W(se,ge){const $e=Math.min(se.length,ge.length);let ve;for(ve=0;ve<$e;ve++)if(se.charCodeAt(ve)!==ge.charCodeAt(ve))return ve;return $e}function x(se,ge){const $e=Math.min(se.length,ge.length);let ve;const ke=se.length-1,Te=ge.length-1;for(ve=0;ve<$e;ve++)if(se.charCodeAt(ke-ve)!==ge.charCodeAt(Te-ve))return ve;return $e}function V(se){return 55296<=se&&se<=56319}function te(se){return 56320<=se&&se<=57343}function B(se,ge){return(se-55296<<10)+(ge-56320)+65536}function H(se,ge,$e){const ve=se.charCodeAt($e);if(V(ve)&&$e+1<ge){const ke=se.charCodeAt($e+1);if(te(ke))return B(ve,ke)}return ve}function _(se,ge){const $e=se.charCodeAt(ge-1);if(te($e)&&ge>1){const ve=se.charCodeAt(ge-2);if(V(ve))return B(ve,$e)}return $e}class ne{get offset(){return this.e}constructor(ge,$e=0){this.c=ge,this.d=ge.length,this.e=$e}setOffset(ge){this.e=ge}prevCodePoint(){const ge=_(this.c,this.e);return this.e-=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=H(this.c,this.d,this.e);return this.e+=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Sf=ne;class le{get offset(){return this.c.offset}constructor(ge,$e=0){this.c=new ne(ge,$e)}nextGraphemeLength(){const ge=Fe.getInstance(),$e=this.c,ve=$e.offset;let ke=ge.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Te=$e.offset,qe=ge.getGraphemeBreakType($e.nextCodePoint());if(Le(ke,qe)){$e.setOffset(Te);break}ke=qe}return $e.offset-ve}prevGraphemeLength(){const ge=Fe.getInstance(),$e=this.c,ve=$e.offset;let ke=ge.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Te=$e.offset,qe=ge.getGraphemeBreakType($e.prevCodePoint());if(Le(qe,ke)){$e.setOffset(Te);break}ke=qe}return ve-$e.offset}eol(){return this.c.eol()}}e.$Tf=le;function ee(se,ge){return new le(se,ge).nextGraphemeLength()}function X(se,ge){return new le(se,ge).prevGraphemeLength()}function K(se,ge){ge>0&&te(se.charCodeAt(ge))&&ge--;const $e=ge+ee(se,ge);return[$e-X(se,$e),$e]}function q(se){const ge=new le(se);let $e=0;for(;!ge.eol();)$e++,ge.nextGraphemeLength();return $e}let D;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(se){return D||(D=J()),D.test(se)}const Q=/^[\t\n\r\x20-\x7E]*$/;function Z(se){return Q.test(se)}e.$1f=/[\u2028\u2029]/;function M(se){return e.$1f.test(se)}function z(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ie(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ae(se,ge,$e=""){const ve=se.trimStart();if(ve.length<ge)return ve;const ke=/\b/g;let Te=0;for(;ke.test(ve)&&!(ve.length-ke.lastIndex<ge);)Te=ke.lastIndex,ke.lastIndex+=1;return Te===0?ve:$e+ve.substring(Te).trimStart()}const ue=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(se){let ge=0;for(const $e of se.matchAll(ue))ge!==$e.index&&(yield{isCode:!1,str:se.substring(ge,$e.index)}),yield{isCode:!0,str:$e[0]},ge=$e.index+$e[0].length;ge!==se.length&&(yield{isCode:!1,str:se.substring(ge)})}function be(se){return se&&(se=se.replace(ue,"")),se}const Ie=/\\\[.*?\\\]/g;function Ae(se){return be(se).replace(Ie,"")}e.$9f=String.fromCharCode(a.CharCode.UTF8_BOM);function ye(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function we(se){return ye(se)?se.substr(1):se}function re(se,ge){if(!se||!ge||se.length<ge.length)return!1;const $e=ge.length,ve=se.toLowerCase();let ke=0,Te=-1;for(;ke<$e;){const qe=ve.indexOf(ge[ke],Te+1);if(qe<0)return!1;Te=qe,ke++}return!0}function he(se,ge=!1){return se?(ge&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Se(se,ge=1){if(ge===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),ge--;while(ge>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function Pe(se){const ge=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*ge),se<ge?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-ge)}function De(se){return Fe.getInstance().getGraphemeBreakType(se)}function Le(se,ge){return se===Ce.Other?ge!==Ce.Extend&&ge!==Ce.SpacingMark:se===Ce.CR&&ge===Ce.LF?!1:se===Ce.Control||se===Ce.CR||se===Ce.LF||ge===Ce.Control||ge===Ce.CR||ge===Ce.LF?!0:!(se===Ce.L&&(ge===Ce.L||ge===Ce.V||ge===Ce.LV||ge===Ce.LVT)||(se===Ce.LV||se===Ce.V)&&(ge===Ce.V||ge===Ce.T)||(se===Ce.LVT||se===Ce.T)&&ge===Ce.T||ge===Ce.Extend||ge===Ce.ZWJ||ge===Ce.SpacingMark||se===Ce.Prepend||se===Ce.ZWJ&&ge===Ce.Extended_Pictographic||se===Ce.Regional_Indicator&&ge===Ce.Regional_Indicator)}var Ce;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Fe{static{this.c=null}static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=Me()}getGraphemeBreakType(ge){if(ge<32)return ge===a.CharCode.LineFeed?Ce.LF:ge===a.CharCode.CarriageReturn?Ce.CR:Ce.Control;if(ge<127)return Ce.Other;const $e=this.d,ve=$e.length/3;let ke=1;for(;ke<=ve;)if(ge<$e[3*ke])ke=2*ke;else if(ge>$e[3*ke+1])ke=2*ke+1;else return $e[3*ke+2];return Ce.Other}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(se,ge){if(se===0)return 0;const $e=je(se,ge);if($e!==void 0)return $e;const ve=new ne(ge,se);return ve.prevCodePoint(),ve.offset}function je(se,ge){const $e=new ne(ge,se);let ve=$e.prevCodePoint();for(;Be(ve)||ve===ze.emojiVariantSelector||ve===ze.enclosingKeyCap;){if($e.offset===0)return;ve=$e.prevCodePoint()}if(!ie(ve))return;let ke=$e.offset;return ke>0&&$e.prevCodePoint()===ze.zwj&&(ke=$e.offset),ke}function Be(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$gg="\xA0";class He{static{this.c=new L.$Y(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$df({getCacheKey:JSON.stringify},ge=>{function $e(Ve){const _e=new Map;for(let Ze=0;Ze<Ve.length;Ze+=2)_e.set(Ve[Ze],Ve[Ze+1]);return _e}function ve(Ve,_e){const Ze=new Map(Ve);for(const[nt,at]of _e)Ze.set(nt,at);return Ze}function ke(Ve,_e){if(!Ve)return _e;const Ze=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Ze.set(nt,at);return Ze}const Te=this.c.value;let qe=ge.filter(Ve=>!Ve.startsWith("_")&&Ve in Te);qe.length===0&&(qe=["_default"]);let xe;for(const Ve of qe){const _e=$e(Te[Ve]);xe=ke(xe,_e)}const Je=$e(Te._common),Ye=ve(Je,xe);return new He(Ye)})}static getInstance(ge){return He.d.get(Array.from(ge))}static{this.e=new L.$Y(()=>Object.keys(He.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return He.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let $e=0;$e<ge.length;$e++){const ve=ge.codePointAt($e);if(typeof ve=="number"&&this.isAmbiguous(ve))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hg=He;class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(ge){return Ne.e().has(ge)}static containsInvisibleCharacter(ge){for(let $e=0;$e<ge.length;$e++){const ve=ge.codePointAt($e);if(typeof ve=="number"&&Ne.isInvisibleCharacter(ve))return!0}return!1}static get codePoints(){return Ne.e()}}e.$ig=Ne}),define(fe[55],de([0,1,26]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Cj=void 0,e.$yj=a,e.$zj=L,e.$Aj=k,e.$Bj=C,e.$Dj=f,P=Oe(P);function a(w){return L(w,0)}function L(w,d){switch(typeof w){case"object":return w===null?k(349,d):Array.isArray(w)?A(w,d):b(w,d);case"string":return C(w,d);case"boolean":return T(w,d);case"number":return k(w,d);case"undefined":return k(937,d);default:return k(617,d)}}function k(w,d){return(d<<5)-d+w|0}function T(w,d){return k(w?433:863,d)}function C(w,d){d=k(149417,d);for(let I=0,$=w.length;I<$;I++)d=k(w.charCodeAt(I),d);return d}function A(w,d){return d=k(104579,d),w.reduce((I,$)=>L($,I),d)}function b(w,d){return d=k(181387,d),Object.keys(w).sort().reduce((I,$)=>(I=C($,I),L(w[$],I)),d)}class R{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=L(d,this.g),this.g}}e.$Cj=R;var p;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function m(w,d,I=32){const $=I-d,c=~((1<<$)-1);return(w<<d|(c&w)>>>$)>>>0}function g(w,d=0,I=w.byteLength,$=0){for(let c=0;c<I;c++)w[d+c]=$}function l(w,d,I="0"){for(;w.length<d;)w=I+w;return w}function f(w,d=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(I=>I.toString(16).padStart(2,"0")).join(""):l((w>>>0).toString(16),d/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(p.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const I=d.length;if(I===0)return;const $=this.p;let c=this.r,h=this.u,i,n;for(h!==0?(i=h,n=-1,h=0):(i=d.charCodeAt(0),n=0);;){let t=i;if(P.$Of(i))if(n+1<I){const s=d.charCodeAt(n+1);P.$Pf(s)?(n++,t=P.$Qf(i,s)):t=p.UNICODE_REPLACEMENT}else{h=i;break}else P.$Pf(i)&&(t=p.UNICODE_REPLACEMENT);if(c=this.w($,c,t),n++,n<I)i=d.charCodeAt(n);else break}this.r=c,this.u=h}w(d,I,$){return $<128?d[I++]=$:$<2048?(d[I++]=192|($&1984)>>>6,d[I++]=128|($&63)>>>0):$<65536?(d[I++]=224|($&61440)>>>12,d[I++]=128|($&4032)>>>6,d[I++]=128|($&63)>>>0):(d[I++]=240|($&1835008)>>>18,d[I++]=128|($&258048)>>>12,d[I++]=128|($&4032)>>>6,d[I++]=128|($&63)>>>0),I>=p.BLOCK_SIZE&&(this.y(),I-=p.BLOCK_SIZE,this.t+=p.BLOCK_SIZE,d[0]=d[p.BLOCK_SIZE+0],d[1]=d[p.BLOCK_SIZE+1],d[2]=d[p.BLOCK_SIZE+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,p.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=E.g,I=this.q;for(let o=0;o<64;o+=4)d.setUint32(o,I.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)d.setUint32(o,m(d.getUint32(o-12,!1)^d.getUint32(o-32,!1)^d.getUint32(o-56,!1)^d.getUint32(o-64,!1),1),!1);let $=this.h,c=this.l,h=this.m,i=this.n,n=this.o,t,s,r;for(let o=0;o<80;o++)o<20?(t=c&h|~c&i,s=1518500249):o<40?(t=c^h^i,s=1859775393):o<60?(t=c&h|c&i|h&i,s=2400959708):(t=c^h^i,s=3395469782),r=m($,5)+t+n+s+d.getUint32(o*4,!1)&4294967295,n=i,i=h,h=m(c,30),c=$,$=r;this.h=this.h+$&4294967295,this.l=this.l+c&4294967295,this.m=this.m+h&4294967295,this.n=this.n+i&4294967295,this.o=this.o+n&4294967295}}e.$Ej=E}),define(fe[92],de([0,1,26]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=Oe(P);var a;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(a||(a={})),function(L){const k="error",T="warning",C="warn",A="info",b="ignore";function R(m){return m?P.$Kf(k,m)?L.Error:P.$Kf(T,m)||P.$Kf(C,m)?L.Warning:P.$Kf(A,m)?L.Info:L.Ignore:L.Ignore}L.fromValue=R;function p(m){switch(m){case L.Error:return k;case L.Warning:return T;case L.Info:return A;default:return b}}L.toString=p}(a||(a={})),e.default=a}),define(fe[51],de([0,1,17,39,26]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class k{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const f=l.charCodeAt(0),E=this.b.charCodeAt(this.c);return f-E}value(){return this.b[this.c]}}e.$Mi=k;class T{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,L.$Ef)(l,this.b,0,l.length,this.c,this.d):(0,L.$Gf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=T;class C{constructor(l=!0,f=!0){this.f=l,this.g=f}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let f=l.length-1;f>=0;f--,this.c--){const E=this.b.charCodeAt(f);if(!(E===a.CharCode.Slash||this.f&&E===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===a.CharCode.Slash||this.f&&f===a.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,L.$Ef)(l,this.b,0,l.length,this.d,this.e):(0,L.$Gf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=C;var A;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(A||(A={}));class b{constructor(l,f){this.f=l,this.g=f,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(A.Scheme),this.c.authority&&this.d.push(A.Authority),this.c.path&&(this.b=new C(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(A.Path)),this.g(l)||(this.c.query&&this.d.push(A.Query),this.c.fragment&&this.d.push(A.Fragment)),this.e=0,this}next(){return this.d[this.e]===A.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===A.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===A.Scheme)return(0,L.$Ff)(l,this.c.scheme);if(this.d[this.e]===A.Authority)return(0,L.$Ff)(l,this.c.authority);if(this.d[this.e]===A.Path)return this.b.cmp(l);if(this.d[this.e]===A.Query)return(0,L.$Df)(l,this.c.query);if(this.d[this.e]===A.Fragment)return(0,L.$Df)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===A.Scheme)return this.c.scheme;if(this.d[this.e]===A.Authority)return this.c.authority;if(this.d[this.e]===A.Path)return this.b.value();if(this.d[this.e]===A.Query)return this.c.query;if(this.d[this.e]===A.Fragment)return this.c.fragment;throw new Error}}e.$Pi=b;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(p||(p={}));class m{static forUris(l=()=>!1,f=()=>!1){return new m(new b(l,f))}static forPaths(l=!1){return new m(new C(void 0,!l))}static forStrings(){return new m(new k)}static forConfigKeys(){return new m(new T)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,f){if(f){const E=f.slice(0);(0,P.$1b)(E);for(const w of E)this.set(w,l)}else{const E=l.slice(0);(0,P.$1b)(E);for(const w of E)this.set(w[0],w[1])}}set(l,f){const E=this.b.reset(l);let w;this.c||(this.c=new R,this.c.segment=E.value());const d=[];for(w=this.c;;){const $=E.cmp(w.segment);if($>0)w.left||(w.left=new R,w.left.segment=E.value()),d.push([p.Left,w]),w=w.left;else if($<0)w.right||(w.right=new R,w.right.segment=E.value()),d.push([p.Right,w]),w=w.right;else if(E.hasNext())E.next(),w.mid||(w.mid=new R,w.mid.segment=E.value()),d.push([p.Mid,w]),w=w.mid;else break}const I=w.value;w.value=f,w.key=l;for(let $=d.length-1;$>=0;$--){const c=d[$][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=d[$][0],n=d[$+1][0];if(i===p.Right&&n===p.Right)d[$][1]=c.rotateLeft();else if(i===p.Left&&n===p.Left)d[$][1]=c.rotateRight();else if(i===p.Right&&n===p.Left)c.right=d[$+1][1]=d[$+1][1].rotateRight(),d[$][1]=c.rotateLeft();else if(i===p.Left&&n===p.Right)c.left=d[$+1][1]=d[$+1][1].rotateLeft(),d[$][1]=c.rotateRight();else throw new Error;if($>0)switch(d[$-1][0]){case p.Left:d[$-1][1].left=d[$][1];break;case p.Right:d[$-1][1].right=d[$][1];break;case p.Mid:d[$-1][1].mid=d[$][1];break}else this.c=d[0][1]}}return I}get(l){return this.d(l)?.value}d(l){const f=this.b.reset(l);let E=this.c;for(;E;){const w=f.cmp(E.segment);if(w>0)E=E.left;else if(w<0)E=E.right;else if(f.hasNext())f.next(),E=E.mid;else break}return E}has(l){const f=this.d(l);return!(f?.value===void 0&&f?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,f){const E=this.b.reset(l),w=[];let d=this.c;for(;d;){const I=E.cmp(d.segment);if(I>0)w.push([p.Left,d]),d=d.left;else if(I<0)w.push([p.Right,d]),d=d.right;else if(E.hasNext())E.next(),w.push([p.Mid,d]),d=d.mid;else break}if(d){if(f?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const I=this.f(d.right);if(I.key){const{key:$,value:c,segment:h}=I;this.e(I.key,!1),d.key=$,d.value=c,d.segment=h}}else{const I=d.left??d.right;if(w.length>0){const[$,c]=w[w.length-1];switch($){case p.Left:c.left=I;break;case p.Mid:c.mid=I;break;case p.Right:c.right=I;break}}else this.c=I}for(let I=w.length-1;I>=0;I--){const $=w[I][1];$.updateHeight();const c=$.balanceFactor();if(c>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),w[I][1]=$.rotateLeft()):c<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),w[I][1]=$.rotateRight()),I>0)switch(w[I-1][0]){case p.Left:w[I-1][1].left=w[I][1];break;case p.Right:w[I-1][1].right=w[I][1];break;case p.Mid:w[I-1][1].mid=w[I][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const f=this.b.reset(l);let E=this.c,w;for(;E;){const d=f.cmp(E.segment);if(d>0)E=E.left;else if(d<0)E=E.right;else if(f.hasNext())f.next(),w=E.value||w,E=E.mid;else break}return E&&E.value||w}findSuperstr(l){return this.g(l,!1)}g(l,f){const E=this.b.reset(l);let w=this.c;for(;w;){const d=E.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(E.hasNext())E.next(),w=w.mid;else return w.mid?this.h(w.mid):f?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[f,E]of this)l(E,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const f=[];return this.j(l,f),f[Symbol.iterator]()}j(l,f){l&&(l.left&&this.j(l.left,f),l.value&&f.push([l.key,l.value]),l.mid&&this.j(l.mid,f),l.right&&this.j(l.right,f))}_isBalanced(){const l=f=>{if(!f)return!0;const E=f.balanceFactor();return E<-1||E>1?!1:l(f.left)&&l(f.right)};return l(this.c)}}e.$Qi=m}),define(fe[32],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=a;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(L){return P.test(L)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(C){for(let A=0;A<C.length;A++)C[A]=Math.floor(Math.random()*256);return C};const k=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));return function(){L(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let A=0,b="";return b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+="-",b+=T[k[A++]],b+=T[k[A++]],b+="-",b+=T[k[A++]],b+=T[k[A++]],b+="-",b+=T[k[A++]],b+=T[k[A++]],b+="-",b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b+=T[k[A++]],b}}()}),define(fe[139],de([0,1,38]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=k;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(T){const C=T.replace(/\-/g,":").toLowerCase();return!a.has(C)}function k(){const T=(0,P.networkInterfaces)();for(const C in T){const A=T[C];if(A){for(const{mac:b}of A)if(L(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(fe[140],de([0,1,242,14]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gY=void 0;class L extends P.Transform{constructor(T){if(super(),typeof T=="number")this.b=T,this.c=1;else{const C=Buffer.isBuffer(T)?T:Buffer.from(T);this.b=C.length===1?C[0]:C,this.c=C.length}}_transform(T,C,A){this.a?this.a=Buffer.concat([this.a,T]):this.a=T;let b=0;for(;b<this.a.length;){const R=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,a.$Te)(this.a,this.b,b);if(R===-1)break;this.push(this.a.slice(b,R+this.c)),b=R+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),A()}_flush(T){this.a&&this.push(this.a),T()}}e.$gY=L}),define(fe[141],de([0,1,66]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=void 0,e.$9g=a,e.$$g=k,P=Oe(P);function a(C,A,b,R=1){let p=!1;return new Promise(m=>{const g=setTimeout(()=>{if(!p)return p=!0,m(0)},b);L(C,A,R,l=>{if(!p)return p=!0,clearTimeout(g),m(l)})})}function L(C,A,b,R){if(A===0)return R(0);const p=new P.Socket;p.once("connect",()=>(T(p),L(C+b,A-1,b,R))),p.once("data",()=>{}),p.once("error",m=>(T(p),m.code!=="ECONNREFUSED"?L(C+b,A-1,b,R):R(C))),p.connect(C,"127.0.0.1")}e.$0g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(C,A,b,R="127.0.0.1"){let p=!1,m,g=1;const l=P.createServer({pauseOnConnect:!0});function f(E,w){p||(p=!0,l.removeAllListeners(),l.close(),m&&clearTimeout(m),w(E))}return new Promise(E=>{m=setTimeout(()=>{f(0,E)},b),l.on("listening",()=>{f(C,E)}),l.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&g<A?(C++,g++,l.listen(C,R)):f(0,E)}),l.on("close",()=>{f(0,E)}),l.listen(C,R)})}function T(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(A){console.error(A)}}}),define(fe[142],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0,e.$cp=a;const P="Offline";function a(k){return k instanceof L?!0:k instanceof Error&&k.name===P&&k.message===P}class L extends Error{constructor(){super(P),this.name=this.message}}e.$dp=L}),define(fe[143],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yY=P;function P(a){return!!a.parentPort}}),define(fe[93],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a=P,e.$b=a;function P(){return globalThis._VSCODE_NLS_MESSAGES}function a(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(fe[9],de([0,1,93,93]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=T,e.localize2=A,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return a.$b}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return a.$a}});const L=(0,P.$b)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function k(b,R){let p;return R.length===0?p=b:p=b.replace(/\{(\d+)\}/g,(m,g)=>{const l=g[0],f=R[l];let E=m;return typeof f=="string"?E=f:(typeof f=="number"||typeof f=="boolean"||f===void 0||f===null)&&(E=String(f)),E}),L&&(p="\uFF3B"+p.replace(/[aouei]/g,"$&$&")+"\uFF3D"),p}function T(b,R,...p){return k(typeof b=="number"?C(b,R):R,p)}function C(b,R){const p=(0,P.$a)()?.[b];if(typeof p!="string"){if(typeof R=="string")return R;throw new Error(`!!! NLS MISSING: ${b} !!!`)}return p}function A(b,R,...p){let m;typeof b=="number"?m=C(b,R):m=R;const g=k(m,p);return{value:g,original:R===m?g:k(R,p)}}}),define(fe[67],de([0,1,9]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=b,e.$8m=R,e.$9m=p,e.$0m=m;const a=60,L=a*60,k=L*24,T=k*7,C=k*30,A=k*365;function b(g,l,f,E){typeof g!="number"&&(g=g.getTime());const w=Math.round((new Date().getTime()-g)/1e3);if(w<-30)return(0,P.localize)(42,null,b(new Date().getTime()+w*1e3,!1));if(!E&&w<30)return(0,P.localize)(43,null);let d;return w<a?(d=w,l?d===1?f?(0,P.localize)(44,null,d):(0,P.localize)(45,null,d):f?(0,P.localize)(46,null,d):(0,P.localize)(47,null,d):d===1?f?(0,P.localize)(48,null,d):(0,P.localize)(49,null,d):f?(0,P.localize)(50,null,d):(0,P.localize)(51,null,d)):w<L?(d=Math.floor(w/a),l?d===1?f?(0,P.localize)(52,null,d):(0,P.localize)(53,null,d):f?(0,P.localize)(54,null,d):(0,P.localize)(55,null,d):d===1?f?(0,P.localize)(56,null,d):(0,P.localize)(57,null,d):f?(0,P.localize)(58,null,d):(0,P.localize)(59,null,d)):w<k?(d=Math.floor(w/L),l?d===1?f?(0,P.localize)(60,null,d):(0,P.localize)(61,null,d):f?(0,P.localize)(62,null,d):(0,P.localize)(63,null,d):d===1?f?(0,P.localize)(64,null,d):(0,P.localize)(65,null,d):f?(0,P.localize)(66,null,d):(0,P.localize)(67,null,d)):w<T?(d=Math.floor(w/k),l?d===1?(0,P.localize)(68,null,d):(0,P.localize)(69,null,d):d===1?(0,P.localize)(70,null,d):(0,P.localize)(71,null,d)):w<C?(d=Math.floor(w/T),l?d===1?f?(0,P.localize)(72,null,d):(0,P.localize)(73,null,d):f?(0,P.localize)(74,null,d):(0,P.localize)(75,null,d):d===1?f?(0,P.localize)(76,null,d):(0,P.localize)(77,null,d):f?(0,P.localize)(78,null,d):(0,P.localize)(79,null,d)):w<A?(d=Math.floor(w/C),l?d===1?f?(0,P.localize)(80,null,d):(0,P.localize)(81,null,d):f?(0,P.localize)(82,null,d):(0,P.localize)(83,null,d):d===1?f?(0,P.localize)(84,null,d):(0,P.localize)(85,null,d):f?(0,P.localize)(86,null,d):(0,P.localize)(87,null,d)):(d=Math.floor(w/A),l?d===1?f?(0,P.localize)(88,null,d):(0,P.localize)(89,null,d):f?(0,P.localize)(90,null,d):(0,P.localize)(91,null,d):d===1?f?(0,P.localize)(92,null,d):(0,P.localize)(93,null,d):f?(0,P.localize)(94,null,d):(0,P.localize)(95,null,d))}function R(g,l,f){typeof g!="number"&&(g=g.getTime());const E=new Date;E.setHours(0,0,0,0);const w=new Date(E.getTime());return w.setDate(w.getDate()-1),g>E.getTime()?(0,P.localize)(96,null):g>w.getTime()?(0,P.localize)(97,null):b(g,l,f)}function p(g,l){const f=Math.abs(g/1e3);return f<1?l?(0,P.localize)(98,null,g):(0,P.localize)(99,null,g):f<a?l?(0,P.localize)(100,null,Math.round(g)/1e3):(0,P.localize)(101,null,Math.round(g)/1e3):f<L?l?(0,P.localize)(102,null,Math.round(g/(1e3*a))):(0,P.localize)(103,null,Math.round(g/(1e3*a))):f<k?l?(0,P.localize)(104,null,Math.round(g/(1e3*L))):(0,P.localize)(105,null,Math.round(g/(1e3*L))):(0,P.localize)(106,null,Math.round(g/(1e3*k)))}function m(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(fe[41],de([0,1,17,12,9]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=A,e.$wj=b,e.$xj=R,P=Oe(P),a=Oe(a),L=Oe(L);function k(p,m){return m&&(p.stack||p.stacktrace)?L.localize(107,null,C(p),T(p.stack)||T(p.stacktrace)):C(p)}function T(p){return Array.isArray(p)?p.join(`
`):p}function C(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?L.localize(108,null,p.message):p.message||L.localize(109,null)}function A(p=null,m=!1){if(!p)return L.localize(110,null);if(Array.isArray(p)){const g=P.$Lb(p),l=A(g[0],m);return g.length>1?L.localize(111,null,l,g.length):l}if(a.$jg(p))return p;if(p.detail){const g=p.detail;if(g.error)return k(g.error,m);if(g.exception)return k(g.exception,m)}return p.stack?k(p,m):p.message?p.message:L.localize(112,null)}function b(p){const m=p;return m instanceof Error&&Array.isArray(m.actions)}function R(p,m){let g;return typeof p=="string"?g=new Error(p):g=p,g.actions=m,g}}),define(fe[144],de([0,1,9,36]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=L;function L(k){switch(k){case a.ParseErrorCode.InvalidSymbol:return(0,P.localize)(113,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(114,null);case a.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(115,null);case a.ParseErrorCode.ValueExpected:return(0,P.localize)(116,null);case a.ParseErrorCode.ColonExpected:return(0,P.localize)(117,null);case a.ParseErrorCode.CommaExpected:return(0,P.localize)(118,null);case a.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(119,null);case a.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(120,null);case a.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(121,null);default:return""}}}),define(fe[5],de([0,1,9]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=e.$H=e.OS=e.OperatingSystem=e.$E=e.$D=e.$C=e.$B=e.$A=e.Language=e.$z=e.$y=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.Platform=e.$j=void 0,e.$k=i,e.$G=u,e.$M=y,P=Oe(P),e.$j="en";let a=!1,L=!1,k=!1,T=!1,C=!1,A=!1,b=!1,R=!1,p=!1,m=!1,g,l=e.$j,f=e.$j,E,w;const d=globalThis;let I;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?I=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(I=process);const $=typeof I?.versions?.electron=="string",c=$&&I?.type==="renderer";if(typeof I=="object"){a=I.platform==="win32",L=I.platform==="darwin",k=I.platform==="linux",T=k&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,b=$,p=!!I.env.CI||!!I.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.$j,l=e.$j;const O=I.env.VSCODE_NLS_CONFIG;if(O)try{const S=JSON.parse(O);g=S.userLocale,f=S.osLocale,l=S.resolvedLanguage||e.$j,E=S.languagePack?.translationsConfigFile}catch{}C=!0}else typeof navigator=="object"&&!c?(w=navigator.userAgent,a=w.indexOf("Windows")>=0,L=w.indexOf("Macintosh")>=0,R=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=w.indexOf("Linux")>=0,m=w?.indexOf("Mobi")>=0,A=!0,l=P.getNLSLanguage()||e.$j,g=navigator.language.toLowerCase(),f=g):console.error("Unable to resolve platform.");var h;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(h||(e.Platform=h={}));function i(O){switch(O){case h.Web:return"Web";case h.Mac:return"Mac";case h.Linux:return"Linux";case h.Windows:return"Windows"}}let n=h.Web;L?n=h.Mac:a?n=h.Windows:k&&(n=h.Linux),e.$l=a,e.$m=L,e.$n=k,e.$o=T,e.$p=C,e.$q=b,e.$r=A,e.$s=A&&typeof d.importScripts=="function",e.$t=e.$s?d.origin:void 0,e.$u=R,e.$v=m,e.$w=p,e.$x=n,e.$y=w,e.$z=l;var t;(function(O){function S(){return e.$z}O.value=S;function v(){return e.$z.length===2?e.$z==="en":e.$z.length>=3?e.$z[0]==="e"&&e.$z[1]==="n"&&e.$z[2]==="-":!1}O.isDefaultVariant=v;function N(){return e.$z==="en"}O.isDefault=N})(t||(e.Language=t={})),e.$A=g,e.$B=f,e.$C=E,e.$D=typeof d.postMessage=="function"&&!d.importScripts,e.$E=(()=>{if(e.$D){const O=[];d.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let N=0,F=O.length;N<F;N++){const U=O[N];if(U.id===v.data.vscodeScheduleAsyncWork){O.splice(N,1),U.callback();return}}});let S=0;return v=>{const N=++S;O.push({id:N,callback:v}),d.postMessage({vscodeScheduleAsyncWork:N},"*")}}return O=>setTimeout(O)})();var s;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=L||R?s.Macintosh:a?s.Windows:s.Linux;let r=!0,o=!1;function u(){if(!o){o=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,r=new Uint16Array(O.buffer)[0]===513}return r}e.$H=!!(e.$y&&e.$y.indexOf("Chrome")>=0),e.$I=!!(e.$y&&e.$y.indexOf("Firefox")>=0),e.$J=!!(!e.$H&&e.$y&&e.$y.indexOf("Safari")>=0),e.$K=!!(e.$y&&e.$y.indexOf("Edg/")>=0),e.$L=!!(e.$y&&e.$y.indexOf("Android")>=0);function y(O){return parseFloat(O)>=20}}),define(fe[37],de([0,1,5]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=e.$ic=e.env=e.cwd=void 0;let a;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const k=L.process;a={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return P.$l?"win32":P.$m?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$ic=a.platform,e.$jc=a.arch}),define(fe[145],de([0,1,37]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WX=T;var a;(function(C){C.UNKNOWN="UNKNOWN",C.CINNAMON="CINNAMON",C.DEEPIN="DEEPIN",C.GNOME="GNOME",C.KDE3="KDE3",C.KDE4="KDE4",C.KDE5="KDE5",C.KDE6="KDE6",C.PANTHEON="PANTHEON",C.UNITY="UNITY",C.XFCE="XFCE",C.UKUI="UKUI",C.LXQT="LXQT"})(a||(a={}));const L="XDG_CURRENT_DESKTOP",k="KDE_SESSION_VERSION";function T(){const C=P.env[L];if(C){const b=C.split(":").map(R=>R.trim()).filter(R=>R.length>0);for(const R of b)switch(R){case"Unity":{const p=P.env.DESKTOP_SESSION;return p&&p.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const p=P.env[k];return p==="5"?a.KDE5:p==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const A=P.env.DESKTOP_SESSION;if(A)switch(A){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return k in P.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in P.env?a.GNOME:"KDE_FULL_SESSION"in P.env?k in P.env?a.KDE4:a.KDE3:a.UNKNOWN}}),define(fe[13],de([0,1,37]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.sep=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=void 0,P=Oe(P);const a=65,L=97,k=90,T=122,C=46,A=47,b=92,R=58,p=63;class m extends Error{constructor(n,t,s){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const o=n.indexOf(".")!==-1?"property":"argument";let u=`The "${n}" ${o} ${r} of type ${t}`;u+=`. Received type ${typeof s}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,n){if(i===null||typeof i!="object")throw new m(n,"Object",i)}function l(i,n){if(typeof i!="string")throw new m(n,"string",i)}const f=P.$ic==="win32";function E(i){return i===A||i===b}function w(i){return i===A}function d(i){return i>=a&&i<=k||i>=L&&i<=T}function I(i,n,t,s){let r="",o=0,u=-1,y=0,O=0;for(let S=0;S<=i.length;++S){if(S<i.length)O=i.charCodeAt(S);else{if(s(O))break;O=A}if(s(O)){if(!(u===S-1||y===1))if(y===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const v=r.lastIndexOf(t);v===-1?(r="",o=0):(r=r.slice(0,v),o=r.length-1-r.lastIndexOf(t)),u=S,y=0;continue}else if(r.length!==0){r="",o=0,u=S,y=0;continue}}n&&(r+=r.length>0?`${t}..`:"..",o=2)}else r.length>0?r+=`${t}${i.slice(u+1,S)}`:r=i.slice(u+1,S),o=S-u-1;u=S,y=0}else O===C&&y!==-1?++y:y=-1}return r}function $(i){return i?`${i[0]==="."?"":"."}${i}`:""}function c(i,n){g(n,"pathObject");const t=n.dir||n.root,s=n.base||`${n.name||""}${$(n.ext)}`;return t?t===n.root?`${t}${s}`:`${t}${i}${s}`:s}e.$kc={resolve(...i){let n="",t="",s=!1;for(let r=i.length-1;r>=-1;r--){let o;if(r>=0){if(o=i[r],l(o,`paths[${r}]`),o.length===0)continue}else n.length===0?o=P.cwd():(o=P.env[`=${n}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==n.toLowerCase()&&o.charCodeAt(2)===b)&&(o=`${n}\\`));const u=o.length;let y=0,O="",S=!1;const v=o.charCodeAt(0);if(u===1)E(v)&&(y=1,S=!0);else if(E(v))if(S=!0,E(o.charCodeAt(1))){let N=2,F=N;for(;N<u&&!E(o.charCodeAt(N));)N++;if(N<u&&N!==F){const U=o.slice(F,N);for(F=N;N<u&&E(o.charCodeAt(N));)N++;if(N<u&&N!==F){for(F=N;N<u&&!E(o.charCodeAt(N));)N++;(N===u||N!==F)&&(O=`\\\\${U}\\${o.slice(F,N)}`,y=N)}}}else y=1;else d(v)&&o.charCodeAt(1)===R&&(O=o.slice(0,2),y=2,u>2&&E(o.charCodeAt(2))&&(S=!0,y=3));if(O.length>0)if(n.length>0){if(O.toLowerCase()!==n.toLowerCase())continue}else n=O;if(s){if(n.length>0)break}else if(t=`${o.slice(y)}\\${t}`,s=S,S&&n.length>0)break}return t=I(t,!s,"\\",E),s?`${n}\\${t}`:`${n}${t}`||"."},normalize(i){l(i,"path");const n=i.length;if(n===0)return".";let t=0,s,r=!1;const o=i.charCodeAt(0);if(n===1)return w(o)?"\\":i;if(E(o))if(r=!0,E(i.charCodeAt(1))){let y=2,O=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==O){const S=i.slice(O,y);for(O=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==O){for(O=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return`\\\\${S}\\${i.slice(O)}\\`;y!==O&&(s=`\\\\${S}\\${i.slice(O,y)}`,t=y)}}}else t=1;else d(o)&&i.charCodeAt(1)===R&&(s=i.slice(0,2),t=2,n>2&&E(i.charCodeAt(2))&&(r=!0,t=3));let u=t<n?I(i.slice(t),!r,"\\",E):"";return u.length===0&&!r&&(u="."),u.length>0&&E(i.charCodeAt(n-1))&&(u+="\\"),s===void 0?r?`\\${u}`:u:r?`${s}\\${u}`:`${s}${u}`},isAbsolute(i){l(i,"path");const n=i.length;if(n===0)return!1;const t=i.charCodeAt(0);return E(t)||n>2&&d(t)&&i.charCodeAt(1)===R&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,t;for(let o=0;o<i.length;++o){const u=i[o];l(u,"path"),u.length>0&&(n===void 0?n=t=u:n+=`\\${u}`)}if(n===void 0)return".";let s=!0,r=0;if(typeof t=="string"&&E(t.charCodeAt(0))){++r;const o=t.length;o>1&&E(t.charCodeAt(1))&&(++r,o>2&&(E(t.charCodeAt(2))?++r:s=!1))}if(s){for(;r<n.length&&E(n.charCodeAt(r));)r++;r>=2&&(n=`\\${n.slice(r)}`)}return e.$kc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n)return"";const t=e.$kc.resolve(i),s=e.$kc.resolve(n);if(t===s||(i=t.toLowerCase(),n=s.toLowerCase(),i===n))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===b;)r++;let o=i.length;for(;o-1>r&&i.charCodeAt(o-1)===b;)o--;const u=o-r;let y=0;for(;y<n.length&&n.charCodeAt(y)===b;)y++;let O=n.length;for(;O-1>y&&n.charCodeAt(O-1)===b;)O--;const S=O-y,v=u<S?u:S;let N=-1,F=0;for(;F<v;F++){const j=i.charCodeAt(r+F);if(j!==n.charCodeAt(y+F))break;j===b&&(N=F)}if(F!==v){if(N===-1)return s}else{if(S>v){if(n.charCodeAt(y+F)===b)return s.slice(y+F+1);if(F===2)return s.slice(y+F)}u>v&&(i.charCodeAt(r+F)===b?N=F:F===2&&(N=3)),N===-1&&(N=0)}let U="";for(F=r+N+1;F<=o;++F)(F===o||i.charCodeAt(F)===b)&&(U+=U.length===0?"..":"\\..");return y+=N,U.length>0?`${U}${s.slice(y,O)}`:(s.charCodeAt(y)===b&&++y,s.slice(y,O))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.$kc.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===b){if(n.charCodeAt(1)===b){const t=n.charCodeAt(2);if(t!==p&&t!==C)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(d(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===b)return`\\\\?\\${n}`;return i},dirname(i){l(i,"path");const n=i.length;if(n===0)return".";let t=-1,s=0;const r=i.charCodeAt(0);if(n===1)return E(r)?i:".";if(E(r)){if(t=s=1,E(i.charCodeAt(1))){let y=2,O=y;for(;y<n&&!E(i.charCodeAt(y));)y++;if(y<n&&y!==O){for(O=y;y<n&&E(i.charCodeAt(y));)y++;if(y<n&&y!==O){for(O=y;y<n&&!E(i.charCodeAt(y));)y++;if(y===n)return i;y!==O&&(t=s=y+1)}}}}else d(r)&&i.charCodeAt(1)===R&&(t=n>2&&E(i.charCodeAt(2))?3:2,s=t);let o=-1,u=!0;for(let y=n-1;y>=s;--y)if(E(i.charCodeAt(y))){if(!u){o=y;break}}else u=!1;if(o===-1){if(t===-1)return".";o=t}return i.slice(0,o)},basename(i,n){n!==void 0&&l(n,"suffix"),l(i,"path");let t=0,s=-1,r=!0,o;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(t=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,y=-1;for(o=i.length-1;o>=t;--o){const O=i.charCodeAt(o);if(E(O)){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),u>=0&&(O===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=t;--o)if(E(i.charCodeAt(o))){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=0,t=-1,s=0,r=-1,o=!0,u=0;i.length>=2&&i.charCodeAt(1)===R&&d(i.charCodeAt(0))&&(n=s=2);for(let y=i.length-1;y>=n;--y){const O=i.charCodeAt(y);if(E(O)){if(!o){s=y+1;break}continue}r===-1&&(o=!1,r=y+1),O===C?t===-1?t=y:u!==1&&(u=1):t!==-1&&(u=-1)}return t===-1||r===-1||u===0||u===1&&t===r-1&&t===s+1?"":i.slice(t,r)},format:c.bind(null,"\\"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.length;let s=0,r=i.charCodeAt(0);if(t===1)return E(r)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(E(r)){if(s=1,E(i.charCodeAt(1))){let N=2,F=N;for(;N<t&&!E(i.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&E(i.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&!E(i.charCodeAt(N));)N++;N===t?s=N:N!==F&&(s=N+1)}}}}else if(d(r)&&i.charCodeAt(1)===R){if(t<=2)return n.root=n.dir=i,n;if(s=2,E(i.charCodeAt(2))){if(t===3)return n.root=n.dir=i,n;s=3}}s>0&&(n.root=i.slice(0,s));let o=-1,u=s,y=-1,O=!0,S=i.length-1,v=0;for(;S>=s;--S){if(r=i.charCodeAt(S),E(r)){if(!O){u=S+1;break}continue}y===-1&&(O=!1,y=S+1),r===C?o===-1?o=S:v!==1&&(v=1):o!==-1&&(v=-1)}return y!==-1&&(o===-1||v===0||v===1&&o===y-1&&o===u+1?n.base=n.name=i.slice(u,y):(n.name=i.slice(u,o),n.base=i.slice(u,y),n.ext=i.slice(o,y))),u>0&&u!==s?n.dir=i.slice(0,u-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(f){const i=/\\/g;return()=>{const n=P.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>P.cwd()})();e.$lc={resolve(...i){let n="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const r=s>=0?i[s]:h();l(r,`paths[${s}]`),r.length!==0&&(n=`${r}/${n}`,t=r.charCodeAt(0)===A)}return n=I(n,!t,"/",w),t?`/${n}`:n.length>0?n:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===A,t=i.charCodeAt(i.length-1)===A;return i=I(i,!n,"/",w),i.length===0?n?"/":t?"./":".":(t&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===A},join(...i){if(i.length===0)return".";let n;for(let t=0;t<i.length;++t){const s=i[t];l(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.$lc.normalize(n)},relative(i,n){if(l(i,"from"),l(n,"to"),i===n||(i=e.$lc.resolve(i),n=e.$lc.resolve(n),i===n))return"";const t=1,s=i.length,r=s-t,o=1,u=n.length-o,y=r<u?r:u;let O=-1,S=0;for(;S<y;S++){const N=i.charCodeAt(t+S);if(N!==n.charCodeAt(o+S))break;N===A&&(O=S)}if(S===y)if(u>y){if(n.charCodeAt(o+S)===A)return n.slice(o+S+1);if(S===0)return n.slice(o+S)}else r>y&&(i.charCodeAt(t+S)===A?O=S:S===0&&(O=0));let v="";for(S=t+O+1;S<=s;++S)(S===s||i.charCodeAt(S)===A)&&(v+=v.length===0?"..":"/..");return`${v}${n.slice(o+O)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===A;let t=-1,s=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===A){if(!s){t=r;break}}else s=!1;return t===-1?n?"/":".":n&&t===1?"//":i.slice(0,t)},basename(i,n){n!==void 0&&l(n,"ext"),l(i,"path");let t=0,s=-1,r=!0,o;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let u=n.length-1,y=-1;for(o=i.length-1;o>=0;--o){const O=i.charCodeAt(o);if(O===A){if(!r){t=o+1;break}}else y===-1&&(r=!1,y=o+1),u>=0&&(O===n.charCodeAt(u)?--u===-1&&(s=o):(u=-1,s=y))}return t===s?s=y:s===-1&&(s=i.length),i.slice(t,s)}for(o=i.length-1;o>=0;--o)if(i.charCodeAt(o)===A){if(!r){t=o+1;break}}else s===-1&&(r=!1,s=o+1);return s===-1?"":i.slice(t,s)},extname(i){l(i,"path");let n=-1,t=0,s=-1,r=!0,o=0;for(let u=i.length-1;u>=0;--u){const y=i.charCodeAt(u);if(y===A){if(!r){t=u+1;break}continue}s===-1&&(r=!1,s=u+1),y===C?n===-1?n=u:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||s===-1||o===0||o===1&&n===s-1&&n===t+1?"":i.slice(n,s)},format:c.bind(null,"/"),parse(i){l(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const t=i.charCodeAt(0)===A;let s;t?(n.root="/",s=1):s=0;let r=-1,o=0,u=-1,y=!0,O=i.length-1,S=0;for(;O>=s;--O){const v=i.charCodeAt(O);if(v===A){if(!y){o=O+1;break}continue}u===-1&&(y=!1,u=O+1),v===C?r===-1?r=O:S!==1&&(S=1):r!==-1&&(S=-1)}if(u!==-1){const v=o===0&&t?1:o;r===-1||S===0||S===1&&r===u-1&&r===o+1?n.base=n.name=i.slice(v,u):(n.name=i.slice(v,r),n.base=i.slice(v,u),n.ext=i.slice(r,u))}return o>0?n.dir=i.slice(0,o-1):t&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$lc.win32=e.$kc.win32=e.$kc,e.$lc.posix=e.$kc.posix=e.$lc,e.$mc=f?e.$kc.normalize:e.$lc.normalize,e.$nc=f?e.$kc.isAbsolute:e.$lc.isAbsolute,e.$oc=f?e.$kc.join:e.$lc.join,e.$pc=f?e.$kc.resolve:e.$lc.resolve,e.$qc=f?e.$kc.relative:e.$lc.relative,e.$rc=f?e.$kc.dirname:e.$lc.dirname,e.$sc=f?e.$kc.basename:e.$lc.basename,e.$tc=f?e.$kc.extname:e.$lc.extname,e.$uc=f?e.$kc.format:e.$lc.format,e.$vc=f?e.$kc.parse:e.$lc.parse,e.$wc=f?e.$kc.toNamespacedPath:e.$lc.toNamespacedPath,e.sep=f?e.$kc.sep:e.$lc.sep,e.$yc=f?e.$kc.delimiter:e.$lc.delimiter}),define(fe[42],de([0,1,39,13,5,26,12]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=C,e.$Dg=A,e.$Eg=b,e.$Fg=R,e.$Gg=p,e.$Hg=f,e.$Ig=E,e.$Jg=w,e.$Kg=d,e.$Lg=I,e.$Mg=$,e.$Ng=c,e.$Og=h,e.$Pg=i,e.$Qg=n,e.$Rg=t,e.$Sg=o;function C(u){return u===P.CharCode.Slash||u===P.CharCode.Backslash}function A(u){return u.replace(/[\\/]/g,a.$lc.sep)}function b(u){return u.indexOf("/")===-1&&(u=A(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function R(u,y=a.$lc.sep){if(!u)return"";const O=u.length,S=u.charCodeAt(0);if(C(S)){if(C(u.charCodeAt(1))&&!C(u.charCodeAt(2))){let N=3;const F=N;for(;N<O&&!C(u.charCodeAt(N));N++);if(F!==N&&!C(u.charCodeAt(N+1))){for(N+=1;N<O;N++)if(C(u.charCodeAt(N)))return u.slice(0,N+1).replace(/[\\/]/g,y)}}return y}else if(d(S)&&u.charCodeAt(1)===P.CharCode.Colon)return C(u.charCodeAt(2))?u.slice(0,2)+y:u.slice(0,2);let v=u.indexOf("://");if(v!==-1){for(v+=3;v<O;v++)if(C(u.charCodeAt(v)))return u.slice(0,v+1)}return""}function p(u){if(!L.$l||!u||u.length<5)return!1;let y=u.charCodeAt(0);if(y!==P.CharCode.Backslash||(y=u.charCodeAt(1),y!==P.CharCode.Backslash))return!1;let O=2;const S=O;for(;O<u.length&&(y=u.charCodeAt(O),y!==P.CharCode.Backslash);O++);return!(S===O||(y=u.charCodeAt(O+1),isNaN(y)||y===P.CharCode.Backslash))}const m=/[\\/:\*\?"<>\|]/g,g=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(u,y=L.$l){const O=y?m:g;return!(!u||u.length===0||/^\s+$/.test(u)||(O.lastIndex=0,O.test(u))||y&&l.test(u)||u==="."||u===".."||y&&u[u.length-1]==="."||y&&u.length!==u.trim().length||u.length>255)}function E(u,y,O){const S=u===y;return!O||S?S:!u||!y?!1:(0,k.$Kf)(u,y)}function w(u,y,O,S=a.sep){if(u===y)return!0;if(!u||!y||y.length>u.length)return!1;if(O){if(!(0,k.$Lf)(u,y))return!1;if(y.length===u.length)return!0;let N=y.length;return y.charAt(y.length-1)===S&&N--,u.charAt(N)===S}return y.charAt(y.length-1)!==S&&(y+=S),u.indexOf(y)===0}function d(u){return u>=P.CharCode.A&&u<=P.CharCode.Z||u>=P.CharCode.a&&u<=P.CharCode.z}function I(u,y){return L.$l&&u.endsWith(":")&&(u+=a.sep),(0,a.$nc)(u)||(u=(0,a.$oc)(y,u)),u=(0,a.$mc)(u),$(u)}function $(u){return L.$l?(u=(0,k.$sf)(u,a.sep),u.endsWith(":")&&(u+=a.sep)):(u=(0,k.$sf)(u,a.sep),u||(u=a.sep)),u}function c(u){const y=(0,a.$mc)(u);return L.$l?u.length>3?!1:h(y)&&(u.length===2||y.charCodeAt(2)===P.CharCode.Backslash):y===a.$lc.sep}function h(u,y=L.$l){return y?d(u.charCodeAt(0))&&u.charCodeAt(1)===P.CharCode.Colon:!1}function i(u,y=L.$l){return h(u,y)?u[0]:void 0}function n(u,y,O){return y.length>u.length?-1:u===y?0:(O&&(u=u.toLowerCase(),y=y.toLowerCase()),u.indexOf(y))}function t(u){const y=u.split(":");let O,S,v;for(const N of y){const F=Number(N);(0,T.$ng)(F)?S===void 0?S=F:v===void 0&&(v=F):O=O?[O,N].join(":"):N}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:S!==void 0?S:void 0,column:v!==void 0?v:S!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(u,y,O=8){let S="";for(let N=0;N<O;N++){let F;N===0&&L.$l&&!y&&(O===3||O===4)?F=r:F=s,S+=F.charAt(Math.floor(Math.random()*F.length))}let v;return y?v=`${y}-${S}`:v=S,u?(0,a.$oc)(u,v):v}}),define(fe[146],de([0,1,13]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0,e.$ht=k,e.$it=T,e.$jt=C,e.$kt=b,e.$gt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(R){const p=(0,P.$tc)(R),m=a[p.toLowerCase()];return m!==void 0?m:T(R)}function T(R){const p=(0,P.$tc)(R);return L[p.toLowerCase()]}function C(R){for(const p in L)if(L[p]===R)return p}const A=/^(.+)\/(.+?)(;.+)?$/;function b(R,p){const m=A.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:p?void 0:R}}),define(fe[94],de([0,1,5]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=k,e.$rm=T;var a;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(a||(e.Source=a={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function k(C,...A){const b=A.reduce((m,g)=>(m[g]=!0,m),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(m=>!b[m]).forEach(m=>{for(let g=0;g<R.length;g++)if(m.search(R[g])!==-1){delete C[m];break}})}function T(C){C&&(delete C.DEBUG,P.$n&&delete C.LD_PRELOAD)}}),define(fe[10],de([0,1,39,65,13,5]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$Ac=E,e.$Bc=h,L=Oe(L);const T=/^\w[\w\d+.-]*$/,C=/^\//,A=/^\/\//;function b(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!T.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function R(r,o){return!r&&!o?"file":r}function p(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==g&&(o=g+o):o=g;break}return o}const m="",g="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(o){return o instanceof f?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,u,y,O,S,v=!1){typeof o=="object"?(this.scheme=o.scheme||m,this.authority=o.authority||m,this.path=o.path||m,this.query=o.query||m,this.fragment=o.fragment||m):(this.scheme=R(o,v),this.authority=u||m,this.path=p(this.scheme,y||m),this.query=O||m,this.fragment=S||m,b(this,v))}get fsPath(){return h(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:y,path:O,query:S,fragment:v}=o;return u===void 0?u=this.scheme:u===null&&(u=m),y===void 0?y=this.authority:y===null&&(y=m),O===void 0?O=this.path:O===null&&(O=m),S===void 0?S=this.query:S===null&&(S=m),v===void 0?v=this.fragment:v===null&&(v=m),u===this.scheme&&y===this.authority&&O===this.path&&S===this.query&&v===this.fragment?this:new d(u,y,O,S,v)}static parse(o,u=!1){const y=l.exec(o);return y?new d(y[2]||m,s(y[4]||m),s(y[5]||m),s(y[7]||m),s(y[9]||m),u):new d(m,m,m,m,m)}static file(o){let u=m;if(k.$l&&(o=o.replace(/\\/g,g)),o[0]===g&&o[1]===g){const y=o.indexOf(g,2);y===-1?(u=o.substring(2),o=g):(u=o.substring(2,y),o=o.substring(y)||g)}return new d("file",u,o,m,m)}static from(o,u){return new d(o.scheme,o.authority,o.path,o.query,o.fragment,u)}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return k.$l&&o.scheme==="file"?y=f.file(L.$kc.join(h(o,!0),...u)).path:y=L.$lc.join(o.path,...u),o.with({path:y})}toString(o=!1){return i(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof f)return o;{const u=new d(o);return u._formatted=o.external??null,u._fsPath=o._sep===w?o.fsPath??null:null,u}}else return o}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=f;function E(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const w=k.$l?1:void 0;class d extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(o=!1){return o?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const o={$mid:a.MarshalledId.Uri};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=w),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const I={[P.CharCode.Colon]:"%3A",[P.CharCode.Slash]:"%2F",[P.CharCode.QuestionMark]:"%3F",[P.CharCode.Hash]:"%23",[P.CharCode.OpenSquareBracket]:"%5B",[P.CharCode.CloseSquareBracket]:"%5D",[P.CharCode.AtSign]:"%40",[P.CharCode.ExclamationMark]:"%21",[P.CharCode.DollarSign]:"%24",[P.CharCode.Ampersand]:"%26",[P.CharCode.SingleQuote]:"%27",[P.CharCode.OpenParen]:"%28",[P.CharCode.CloseParen]:"%29",[P.CharCode.Asterisk]:"%2A",[P.CharCode.Plus]:"%2B",[P.CharCode.Comma]:"%2C",[P.CharCode.Semicolon]:"%3B",[P.CharCode.Equals]:"%3D",[P.CharCode.Space]:"%20"};function $(r,o,u){let y,O=-1;for(let S=0;S<r.length;S++){const v=r.charCodeAt(S);if(v>=P.CharCode.a&&v<=P.CharCode.z||v>=P.CharCode.A&&v<=P.CharCode.Z||v>=P.CharCode.Digit0&&v<=P.CharCode.Digit9||v===P.CharCode.Dash||v===P.CharCode.Period||v===P.CharCode.Underline||v===P.CharCode.Tilde||o&&v===P.CharCode.Slash||u&&v===P.CharCode.OpenSquareBracket||u&&v===P.CharCode.CloseSquareBracket||u&&v===P.CharCode.Colon)O!==-1&&(y+=encodeURIComponent(r.substring(O,S)),O=-1),y!==void 0&&(y+=r.charAt(S));else{y===void 0&&(y=r.substr(0,S));const N=I[v];N!==void 0?(O!==-1&&(y+=encodeURIComponent(r.substring(O,S)),O=-1),y+=N):O===-1&&(O=S)}}return O!==-1&&(y+=encodeURIComponent(r.substring(O))),y!==void 0?y:r}function c(r){let o;for(let u=0;u<r.length;u++){const y=r.charCodeAt(u);y===P.CharCode.Hash||y===P.CharCode.QuestionMark?(o===void 0&&(o=r.substr(0,u)),o+=I[y]):o!==void 0&&(o+=r[u])}return o!==void 0?o:r}function h(r,o){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===P.CharCode.Slash&&(r.path.charCodeAt(1)>=P.CharCode.A&&r.path.charCodeAt(1)<=P.CharCode.Z||r.path.charCodeAt(1)>=P.CharCode.a&&r.path.charCodeAt(1)<=P.CharCode.z)&&r.path.charCodeAt(2)===P.CharCode.Colon?o?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,k.$l&&(u=u.replace(/\//g,"\\")),u}function i(r,o){const u=o?c:$;let y="",{scheme:O,authority:S,path:v,query:N,fragment:F}=r;if(O&&(y+=O,y+=":"),(S||O==="file")&&(y+=g,y+=g),S){let U=S.indexOf("@");if(U!==-1){const j=S.substr(0,U);S=S.substr(U+1),U=j.lastIndexOf(":"),U===-1?y+=u(j,!1,!1):(y+=u(j.substr(0,U),!1,!1),y+=":",y+=u(j.substr(U+1),!1,!0)),y+="@"}S=S.toLowerCase(),U=S.lastIndexOf(":"),U===-1?y+=u(S,!1,!0):(y+=u(S.substr(0,U),!1,!0),y+=S.substr(U))}if(v){if(v.length>=3&&v.charCodeAt(0)===P.CharCode.Slash&&v.charCodeAt(2)===P.CharCode.Colon){const U=v.charCodeAt(1);U>=P.CharCode.A&&U<=P.CharCode.Z&&(v=`/${String.fromCharCode(U+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===P.CharCode.Colon){const U=v.charCodeAt(0);U>=P.CharCode.A&&U<=P.CharCode.Z&&(v=`${String.fromCharCode(U+32)}:${v.substr(2)}`)}y+=u(v,!0,!1)}return N&&(y+="?",y+=u(N,!1,!1)),F&&(y+="#",y+=o?F:$(F,!1,!1)),y}function n(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+n(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,o=>n(o)):r}}),define(fe[147],de([0,1,10]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=a,e.$mr=L,e.$nr=k,e.log=C;function a(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}function L(b){const R=[];let p;try{const m=JSON.parse(b.arguments),g=m[m.length-1];g&&g.__$stack&&(m.pop(),p=g.__$stack),R.push(...m)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:p}}function k(b){if(typeof b!="string")return k(L(b).stack);const R=b;if(R){const p=T(R),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(m&&m.length===4)return{uri:P.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function T(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function C(b,R){const{args:p,stack:m}=L(b),g=typeof p[0]=="string"&&p.length===1;let l=T(m);l&&(l=`(${l.trim()})`);let f=[];if(typeof p[0]=="string"?l&&g?f=[`%c[${R}] %c${p[0]} %c${l}`,A("blue"),A(""),A("grey")]:f=[`%c[${R}] %c${p[0]}`,A("blue"),A(""),...p.slice(1)]:f=[`%c[${R}]%`,A("blue"),...p],l&&!g&&f.push(l),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,f)}function A(b){return`color: ${b}`}}),define(fe[68],de([0,1,14,10,65]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=k,e.$gi=T,e.$hi=A;function k(b){return JSON.stringify(b,C)}function T(b){let R=JSON.parse(b);return R=A(R),R}function C(b,R){return R instanceof RegExp?{$mid:L.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function A(b,R=0){if(!b||R>200)return b;if(typeof b=="object"){switch(b.$mid){case L.MarshalledId.Uri:return a.URI.revive(b);case L.MarshalledId.Regexp:return new RegExp(b.source,b.flags);case L.MarshalledId.Date:return new Date(b.source)}if(b instanceof P.$Se||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let p=0;p<b.length;++p)b[p]=A(b[p],R+1);else for(const p in b)Object.hasOwnProperty.call(b,p)&&(b[p]=A(b[p],R+1))}return b}}),define(fe[22],de([0,1,8,5,26,10,13]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Xg=e.$Wg=e.$Vg=e.Schemas=void 0,e.$Tg=A,e.$Ug=b,e.$Yg=p,P=Oe(P),a=Oe(a),T=Oe(T);var C;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",l.vscodeNotebookMetadata="vscode-notebook-metadata",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting",l.outputChannel="output"})(C||(e.Schemas=C={}));function A(l,f){return k.URI.isUri(l)?(0,L.$Kf)(l.scheme,f):(0,L.$Lf)(l,f+":")}function b(l,...f){return f.some(E=>A(l,E))}e.$Vg="vscode-tkn",e.$Wg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f,E){this.f=p(f,E)}getServerRootPath(){return this.f}get g(){return T.$lc.join(this.f,C.vscodeRemoteResource)}set(f,E,w){this.a[f]=E,this.b[f]=w}setConnectionToken(f,E){this.c[f]=E}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(c){return P.$4(c),f}const E=f.authority;let w=this.a[E];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const d=this.b[E],I=this.c[E];let $=`path=${encodeURIComponent(f.path)}`;return typeof I=="string"&&($+=`&${e.$Wg}=${encodeURIComponent(I)}`),k.URI.from({scheme:a.$r?this.d:C.vscodeRemoteResource,authority:`${w}:${d}`,path:this.g,query:$})}}e.$Xg=new R;function p(l,f){return T.$lc.join(f??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Zg="vs/../../extensions",e.$1g="vs/../../node_modules",e.$2g="vs/../../node_modules.asar",e.$3g="vs/../../node_modules.asar.unpacked",e.$4g="vscode-app";class m{static{this.a=e.$4g}asBrowserUri(f){const E=this.b(f,ce);return this.uriToBrowserUri(E)}uriToBrowserUri(f){return f.scheme===C.vscodeRemote?e.$Xg.rewrite(f):f.scheme===C.file&&(a.$p||a.$t===`${C.vscodeFileResource}://${m.a}`)?f.with({scheme:C.vscodeFileResource,authority:f.authority||m.a,query:null,fragment:null}):f}asFileUri(f){const E=this.b(f,ce);return this.uriToFileUri(E)}uriToFileUri(f){return f.scheme===C.vscodeFileResource?f.with({scheme:C.file,authority:f.authority!==m.a?f.authority:null,query:null,fragment:null}):f}b(f,E){if(k.URI.isUri(f))return f;if(globalThis._VSCODE_FILE_ROOT){const w=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(w))return k.URI.joinPath(k.URI.parse(w,!0),f);const d=T.$oc(w,f);return k.URI.file(d)}return k.URI.parse(E.toUrl(f))}}e.$5g=new m;var g;(function(l){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(f.get("3"));const E="vscode-coi";function w(I){let $;typeof I=="string"?$=new URL(I).searchParams:I instanceof URL?$=I.searchParams:k.URI.isUri(I)&&($=new URL(I.toString(!0)).searchParams);const c=$?.get(E);if(c)return f.get(c)}l.getHeadersFromQuery=w;function d(I,$,c){if(!globalThis.crossOriginIsolated)return;const h=$&&c?"3":c?"2":"1";I instanceof URLSearchParams?I.set(E,h):I[E]=h}l.addSearchParam=d})(g||(e.COI=g={}))}),define(fe[69],de([0,1,130,22,5,12,10]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=p,e.$Aq=m,L=Oe(L);class C{constructor(l,f,E){this.id=l,this.dependencies=f,this.callback=E}}class A{static{this.INSTANCE=new A}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(l,f,E)=>{typeof l!="string"&&(E=f,f=l,l=null),(typeof f!="object"||!Array.isArray(f))&&(E=f,f=null),this.c.push(new C(l,f,E))},globalThis.define.amd=!0,this.b?this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith(`${a.Schemas.vscodeFileResource}://${a.$4g}`))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this.g();const f=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!f){console.warn(`Did not receive a define call from script ${l}`);return}const E={},w=[],d=[];if(Array.isArray(f.dependencies))for(const I of f.dependencies)I==="exports"?w.push(E):d.push(I);if(d.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${d.join(", ")}`);return typeof f.callback=="function"?f.callback(...w)??E:f.callback}h(l){return new Promise((f,E)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const d=()=>{w.removeEventListener("load",I),w.removeEventListener("error",$)},I=c=>{d(),f(this.c.pop())},$=c=>{d(),E(c)};w.addEventListener("load",I),w.addEventListener("error",$),this.f&&(l=this.f.createScriptURL(l)),w.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(w)})}async i(l){return this.f&&(l=this.f.createScriptURL(l)),P.$V?await new Promise((f,E)=>{ce([l],f,E)}).then(Oe):importScripts(l),this.c.pop()}async j(l){try{const f=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,d=T.URI.parse(l).fsPath,I=f.readFileSync(d).toString(),$=w.wrap(I.replace(/^#!.*/,""));return new E.Script($).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const b=new Map;let R={};typeof globalThis.require=="object"&&(R=globalThis.require.paths??{});async function p(g,l,f){if(P.$V){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),R[g]&&(g=R[g]);const E=l?`${g}/${l}`:g;if(b.has(E))return b.get(E);let w;if(/^\w[\w\d+.-]*:\/\//.test(E))w=E;else{const c=`${P.$W&&f&&!L.$r?a.$2g:a.$1g}/${E}`;w=a.$5g.asBrowserUri(c).toString(!0)}const d=A.INSTANCE.load(w);return b.set(E,d),d}else return await new Promise((E,w)=>{ce([g],E,w)}).then(Oe)}function m(g,l){(0,k.$tg)(P.$V);const E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,w=P.$W&&E&&!L.$r,d=`${g}/${l}`,$=`${w?a.$2g:a.$1g}/${d}`;return a.$5g.asBrowserUri($).toString(!0)}}),define(fe[20],de([0,1,39,42,22,13,5,26,10]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$_g=b,e.$uh=p,e.$vh=g,a=Oe(a),k=Oe(k);function b(l){return(0,A.$Bc)(l,!0)}class R{constructor(f){this.a=f}compare(f,E,w=!1){return f===E?0:(0,C.$Df)(this.getComparisonKey(f,w),this.getComparisonKey(E,w))}isEqual(f,E,w=!1){return f===E?!0:!f||!E?!1:this.getComparisonKey(f,w)===this.getComparisonKey(E,w)}getComparisonKey(f,E=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,E,w=!1){if(f.scheme===E.scheme){if(f.scheme===L.Schemas.file)return a.$Jg(b(f),b(E),this.a(f))&&f.query===E.query&&(w||f.fragment===E.fragment);if((0,e.$qh)(f.authority,E.authority))return a.$Jg(f.path,E.path,this.a(f),"/")&&f.query===E.query&&(w||f.fragment===E.fragment)}return!1}joinPath(f,...E){return A.URI.joinPath(f,...E)}basenameOrAuthority(f){return(0,e.$ih)(f)||f.authority}basename(f){return k.$lc.basename(f.path)}extname(f){return k.$lc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let E;return f.scheme===L.Schemas.file?E=A.URI.file(k.$rc(b(f))).path:(E=k.$lc.dirname(f.path),f.authority&&E.length&&E.charCodeAt(0)!==P.CharCode.Slash&&(console.error(`dirname("${f.toString})) resulted in a relative path`),E="/")),f.with({path:E})}normalizePath(f){if(!f.path.length)return f;let E;return f.scheme===L.Schemas.file?E=A.URI.file(k.$mc(b(f))).path:E=k.$lc.normalize(f.path),f.with({path:E})}relativePath(f,E){if(f.scheme!==E.scheme||!(0,e.$qh)(f.authority,E.authority))return;if(f.scheme===L.Schemas.file){const I=k.$qc(b(f),b(E));return T.$l?a.$Dg(I):I}let w=f.path||"/";const d=E.path||"/";if(this.a(f)){let I=0;for(const $=Math.min(w.length,d.length);I<$&&!(w.charCodeAt(I)!==d.charCodeAt(I)&&w.charAt(I).toLowerCase()!==d.charAt(I).toLowerCase());I++);w=d.substr(0,I)+w.substr(I)}return k.$lc.relative(w,d)}resolvePath(f,E){if(f.scheme===L.Schemas.file){const w=A.URI.file(k.$pc(b(f),E));return f.with({authority:w.authority,path:w.path})}return E=a.$Eg(E),f.with({path:k.$lc.resolve(f.path,E)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,E){return f===E||f!==void 0&&E!==void 0&&(0,C.$Kf)(f,E)}hasTrailingPathSeparator(f,E=k.sep){if(f.scheme===L.Schemas.file){const w=b(f);return w.length>a.$Fg(w).length&&w[w.length-1]===E}else{const w=f.path;return w.length>1&&w.charCodeAt(w.length-1)===P.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,E=k.sep){return(0,e.$rh)(f,E)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,E=k.sep){let w=!1;if(f.scheme===L.Schemas.file){const d=b(f);w=d!==void 0&&d.length===a.$Fg(d).length&&d[d.length-1]===E}else{E="/";const d=f.path;w=d.length===1&&d.charCodeAt(d.length-1)===P.CharCode.Slash}return!w&&!(0,e.$rh)(f,E)?f.with({path:f.path+"/"}):f}}e.$ah=R,e.$bh=new R(()=>!1),e.$ch=new R(l=>l.scheme===L.Schemas.file?!T.$n:!0),e.$dh=new R(l=>!0),e.$eh=e.$bh.isEqual.bind(e.$bh),e.$fh=e.$bh.isEqualOrParent.bind(e.$bh),e.$gh=e.$bh.getComparisonKey.bind(e.$bh),e.$hh=e.$bh.basenameOrAuthority.bind(e.$bh),e.$ih=e.$bh.basename.bind(e.$bh),e.$jh=e.$bh.extname.bind(e.$bh),e.$kh=e.$bh.dirname.bind(e.$bh),e.$lh=e.$bh.joinPath.bind(e.$bh),e.$mh=e.$bh.normalizePath.bind(e.$bh),e.$nh=e.$bh.relativePath.bind(e.$bh),e.$oh=e.$bh.resolvePath.bind(e.$bh),e.$ph=e.$bh.isAbsolutePath.bind(e.$bh),e.$qh=e.$bh.isEqualAuthority.bind(e.$bh),e.$rh=e.$bh.hasTrailingPathSeparator.bind(e.$bh),e.$sh=e.$bh.removeTrailingPathSeparator.bind(e.$bh),e.$th=e.$bh.addTrailingPathSeparator.bind(e.$bh);function p(l,f){const E=[];for(let w=0;w<l.length;w++){const d=f(l[w]);l.some((I,$)=>$===w?!1:(0,e.$fh)(d,f(I)))||E.push(l[w])}return E}var m;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function f(E){const w=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach($=>{const[c,h]=$.split(":");c&&h&&w.set(c,h)});const I=E.path.substring(0,E.path.indexOf(";"));return I&&w.set(l.META_DATA_MIME,I),w}l.parseMetaData=f})(m||(e.DataUri=m={}));function g(l,f,E){if(f){let w=l.path;return w&&w[0]!==k.$lc.sep&&(w=k.$lc.sep+w),l.with({scheme:E,authority:f,path:w})}return l.with({scheme:E})}}),define(fe[6],de([0,1,25,8,3,2,20,5,137,53]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$_h=e.$$h=e.$0h=e.$9h=e.Promises=e.$8h=e.$7h=e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0,e.$wh=R,e.$xh=p,e.$yh=m,e.$zh=g,e.$Ah=l,e.$Bh=f,e.$Ch=E,e.$Dh=w,e.$Lh=r,e.$Mh=o,e.$Nh=u,e.$Oh=y,e.$Ph=O,e.$5h=H,e.$ai=Q;function R(M){return!!M&&typeof M.then=="function"}function p(M){const z=new P.$Be,ie=M(z.token),ae=new Promise((ue,pe)=>{const be=z.token.onCancellationRequested(()=>{be.dispose(),pe(new a.$9)});Promise.resolve(ie).then(Ie=>{be.dispose(),z.dispose(),ue(Ie)},Ie=>{be.dispose(),z.dispose(),pe(Ie)})});return new class{cancel(){z.cancel(),z.dispose()}then(ue,pe){return ae.then(ue,pe)}catch(ue){return this.then(void 0,ue)}finally(ue){return ae.finally(ue)}}}function m(M,z,ie){return new Promise((ae,ue)=>{const pe=z.onCancellationRequested(()=>{pe.dispose(),ae(ie)});M.then(ae,ue).finally(()=>pe.dispose())})}function g(M,z){return new Promise((ie,ae)=>{const ue=z.onCancellationRequested(()=>{ue.dispose(),ae(new a.$9)});M.then(ie,ae).finally(()=>ue.dispose())})}async function l(M){let z=-1;const ie=M.map((ae,ue)=>ae.then(pe=>(z=ue,pe)));try{return await Promise.race(ie)}finally{M.forEach((ae,ue)=>{ue!==z&&ae.cancel()})}}function f(M,z,ie){let ae;const ue=setTimeout(()=>{ae?.(void 0),ie?.()},z);return Promise.race([M.finally(()=>clearTimeout(ue)),new Promise(pe=>ae=pe)])}function E(M){return new Promise((z,ie)=>{const ae=M();R(ae)?ae.then(z,ie):z(ae)})}function w(){let M,z;return{promise:new Promise((ae,ue)=>{M=ae,z=ue}),resolve:M,reject:z}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=z,!this.b){const ie=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(ie,ie).then(ae)})}return new Promise((ie,ae)=>{this.b.then(ie,ae)})}return this.a=z(),new Promise((ie,ae)=>{this.a.then(ue=>{this.a=null,ie(ue)},ue=>{this.a=null,ae(ue)})})}dispose(){this.f=!0}}e.$Eh=d;class I{constructor(){this.a=Promise.resolve(null)}queue(z){return this.a=this.a.then(()=>z(),()=>z())}}e.$Fh=I;class ${constructor(){this.a=new Map}queue(z,ie){const ue=(this.a.get(z)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(z)===ue&&this.a.delete(z)});return this.a.set(z,ue),ue}}e.$Gh=$;const c=(M,z)=>{let ie=!0;const ae=setTimeout(()=>{ie=!1,z()},M);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ae),ie=!1}}},h=M=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,M())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class i{constructor(z){this.defaultDelay=z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(z,ie=this.defaultDelay){this.g=z,this.h(),this.b||(this.b=new Promise((ue,pe)=>{this.d=ue,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=ie===A.$le?h(ae):c(ie,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$9),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Hh=i;class n{constructor(z){this.a=new i(z),this.b=new d}trigger(z,ie){return this.a.trigger(()=>this.b.queue(z),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ih=n;class t{constructor(){this.a=!1,this.b=new Promise((z,ie)=>{this.d=z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Jh=t;class s extends t{constructor(z){super(),this.f=setTimeout(()=>this.open(),z)}open(){clearTimeout(this.f),super.open()}}e.$Kh=s;function r(M,z){return z?new Promise((ie,ae)=>{const ue=setTimeout(()=>{pe.dispose(),ie()},M),pe=z.onCancellationRequested(()=>{clearTimeout(ue),pe.dispose(),ae(new a.$9)})}):p(ie=>r(M,ie))}function o(M,z=0,ie){const ae=setTimeout(()=>{M(),ie&&ue.dispose()},z),ue=(0,k.$Xc)(()=>{clearTimeout(ae),ie?.deleteAndLeak(ue)});return ie?.add(ue),ue}function u(M){const z=[];let ie=0;const ae=M.length;function ue(){return ie<ae?M[ie++]():null}function pe(be){be!=null&&z.push(be);const Ie=ue();return Ie?Ie.then(pe):Promise.resolve(z)}return Promise.resolve(null).then(pe)}function y(M,z=ae=>!!ae,ie=null){let ae=0;const ue=M.length,pe=()=>{if(ae>=ue)return Promise.resolve(ie);const be=M[ae++];return Promise.resolve(be()).then(Ae=>z(Ae)?Promise.resolve(Ae):pe())};return pe()}function O(M,z=ae=>!!ae,ie=null){if(M.length===0)return Promise.resolve(ie);let ae=M.length;const ue=()=>{ae=-1;for(const pe of M)pe.cancel?.()};return new Promise((pe,be)=>{for(const Ie of M)Ie.then(Ae=>{--ae>=0&&z(Ae)?(ue(),pe(Ae)):ae===0&&pe(ie)}).catch(Ae=>{--ae>=0&&(ue(),be(Ae))})})}class S{constructor(z){this.a=0,this.b=!1,this.f=z,this.g=[],this.d=0,this.h=new L.$qe}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,ae)=>{this.g.push({factory:z,c:ie,e:ae}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const z=this.g.shift();this.d++;const ie=z.factory();ie.then(z.c,z.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Qh=S;class v extends S{constructor(){super(1)}}e.$Rh=v;class N{constructor(){this.a=new _,this.b=0}queue(z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,z())):this.a.run(this.b++,z())}}e.$Sh=N;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const z=new ee;return this.b.add(z),z.p}g(){for(const[,z]of this.a)if(z.size>0)return!1;return!0}queueSize(z,ie=T.$bh){const ae=ie.getComparisonKey(z);return this.a.get(ae)?.size??0}queueFor(z,ie,ae=T.$bh){const ue=ae.getComparisonKey(z);let pe=this.a.get(ue);if(!pe){pe=new v;const be=this.f++,Ie=L.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new k.$9c),this.d.set(be,Ie),this.a.set(ue,pe)}return pe.queue(ie)}h(){this.g()&&this.j()}j(){for(const z of this.b)z.complete();this.b.clear()}dispose(){for(const[,z]of this.a)z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Th=F;class U{constructor(z,ie){this.b=!1,this.a=-1,typeof z=="function"&&typeof ie=="number"&&this.setIfNotSet(z,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(z,ie){if(this.b)throw new a.$gb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,z()},ie)}setIfNotSet(z,ie){if(this.b)throw new a.$gb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,z()},ie))}}e.$Uh=U;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(z,ie,ae=globalThis){if(this.f)throw new a.$gb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ue=ae.setInterval(()=>{z()},ie);this.d=(0,k.$Xc)(()=>{ae.clearInterval(ue),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Vh=j;class G{constructor(z,ie){this.b=-1,this.a=z,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(z=this.d){this.cancel(),this.b=setTimeout(this.f,z)}get delay(){return this.d}set delay(z){this.d=z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Wh=G;class W{constructor(z,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=z,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(z=this.b){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Xh=W;class x extends G{constructor(z,ie){super(z,ie),this.j=[]}work(z){this.j.push(z),this.isScheduled()||this.schedule()}h(){const z=this.j;this.j=[],this.a?.(z)}dispose(){this.j=[],super.dispose()}}e.$Yh=x;class V extends k.$Zc{constructor(z,ie){super(),this.g=z,this.h=ie,this.a=[],this.b=this.B(new k.$1c),this.f=!1}get pending(){return this.a.length}work(z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+z.length>this.g.maxBufferedWork)return!1}else if(this.pending+z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of z)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Zh=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$2h=(M,z)=>{(0,C.$E)(()=>{if(ie)return;const ae=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$2h=(M,z,ie)=>{const ae=M.requestIdleCallback(z,typeof ie=="number"?{timeout:ie}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,M.cancelIdleCallback(ae))}}},e.$1h=M=>(0,e.$2h)(globalThis,M)}();class te{constructor(z,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(ae){this.l=ae}finally{this.g=!0}},this.f=(0,e.$2h)(z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$3h=te;class B extends te{constructor(z){super(globalThis,z)}}e.$4h=B;async function H(M,z,ie){let ae;for(let ue=0;ue<ie;ue++)try{return await M()}catch(pe){ae=pe,await r(z)}throw ae}class _{isRunning(z){return typeof z=="number"?this.a?.taskId===z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(z,ie,ae){return this.a={taskId:z,cancel:()=>ae?.(),promise:ie},ie.then(()=>this.d(z),()=>this.d(z)),ie}d(z){this.a&&z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const z=this.b;this.b=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}queue(z){if(this.b)this.b.run=z;else{const{promise:ie,resolve:ae,reject:ue}=w();this.b={run:z,promise:ie,promiseResolve:ae,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$6h=_;class ne{constructor(z,ie=()=>Date.now()){this.d=z,this.f=ie,this.a=0,this.b=0}increment(){const z=this.f();return z-this.a>this.d&&(this.a=z,this.b=0),this.b++,this.b}}e.$7h=ne;var le;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(le||(le={}));class ee{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((z,ie)=>{this.a=z,this.b=ie})}complete(z){return new Promise(ie=>{this.a(z),this.d={outcome:le.Resolved,value:z},ie()})}error(z){return new Promise(ie=>{this.b(z),this.d={outcome:le.Rejected,value:z},ie()})}cancel(){return this.error(new a.$9)}}e.$8h=ee;var X;(function(M){async function z(ae){let ue;const pe=await Promise.all(ae.map(be=>be.then(Ie=>Ie,Ie=>{ue||(ue=Ie)})));if(typeof ue<"u")throw ue;return pe}M.settled=z;function ie(ae){return new Promise(async(ue,pe)=>{try{await ae(ue,pe)}catch(be){pe(be)}})}M.withAsyncBody=ie})(X||(e.Promises=X={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=z.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new a.$gb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$9h=K;class q{constructor(z){this.b=z,this.a=new b.$Y(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$0h=q;var D;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(D||(D={}));class J{static fromArray(z){return new J(ie=>{ie.emitMany(z)})}static fromPromise(z){return new J(async ie=>{ie.emitMany(await z)})}static fromPromises(z){return new J(async ie=>{await Promise.all(z.map(async ae=>ie.emitOne(await ae)))})}static merge(z){return new J(async ie=>{await Promise.all(z.map(async ae=>{for await(const ue of ae)ie.emitOne(ue)}))})}static{this.EMPTY=J.fromArray([])}constructor(z,ie){this.a=D.Initial,this.b=[],this.d=null,this.f=ie,this.g=new L.$qe,queueMicrotask(async()=>{const ae={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(z(ae)),this.k()}catch(ue){this.l(ue)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(z<this.b.length)return{done:!1,value:this.b[z++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(z,ie){return new J(async ae=>{for await(const ue of z)ae.emitOne(ie(ue))})}map(z){return J.map(this,z)}static filter(z,ie){return new J(async ae=>{for await(const ue of z)ie(ue)&&ae.emitOne(ue)})}filter(z){return J.filter(this,z)}static coalesce(z){return J.filter(z,ie=>!!ie)}coalesce(){return J.coalesce(this)}static async toPromise(z){const ie=[];for await(const ae of z)ie.push(ae);return ie}toPromise(){return J.toPromise(this)}h(z){this.a===D.Initial&&(this.b.push(z),this.g.fire())}j(z){this.a===D.Initial&&(this.b=this.b.concat(z),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(z){this.a===D.Initial&&(this.a=D.DoneError,this.d=z,this.g.fire())}}e.$$h=J;class oe extends J{constructor(z,ie){super(ie),this.m=z}cancel(){this.m.cancel()}}e.$_h=oe;function Q(M){const z=new P.$Be,ie=M(z.token);return new oe(z,async ae=>{const ue=z.token.onCancellationRequested(()=>{ue.dispose(),z.dispose(),ae.reject(new a.$9)});try{for await(const pe of ie){if(z.token.isCancellationRequested)return;ae.emitOne(pe)}ue.dispose(),z.dispose()}catch(pe){ue.dispose(),z.dispose(),ae.reject(pe)}})}class Z{constructor(z){this.a=new ee,this.b=new J(ue=>{if(ie){ue.reject(ie);return}return ae&&ue.emitMany(ae),this.d=pe=>ue.reject(pe),this.f=pe=>ue.emitOne(pe),this.a.p},z);let ie,ae;this.f=ue=>{ae||(ae=[]),ae.push(ue)},this.d=ue=>{ie||(ie=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(z){this.d(z),this.a.complete()}emitOne(z){this.f(z)}}e.$bi=Z}),define(fe[95],de([0,1,17,6,39,42,31,13,5,26]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=R,e.$Dk=f,e.$Ek=N,e.$Fk=F,e.$Gk=U,e.$Hk=j,e.$Ik=G,e.$Jk=te;function R(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const p="[/\\\\]",m="[^/\\\\]",g=/\//g;function l(B,H){switch(B){case 0:return"";case 1:return`${m}*?`;default:return`(?:${p}|${m}+${p}${H?`|${p}${m}+`:""})*?`}}function f(B,H){if(!B)return[];const _=[];let ne=!1,le=!1,ee="";for(const X of B){switch(X){case H:if(!ne&&!le){_.push(ee),ee="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":le=!0;break;case"]":le=!1;break}ee+=X}return ee&&_.push(ee),_}function E(B){if(!B)return"";let H="";const _=f(B,e.$Ck);if(_.every(ne=>ne===e.$Bk))H=".*";else{let ne=!1;_.forEach((le,ee)=>{if(le===e.$Bk){if(ne)return;H+=l(2,ee===_.length-1)}else{let X=!1,K="",q=!1,D="";for(const J of le){if(J!=="}"&&X){K+=J;continue}if(q&&(J!=="]"||!D)){let oe;J==="-"?oe=J:(J==="^"||J==="!")&&!D?oe="^":J===e.$Ck?oe="":oe=(0,b.$mf)(J),D+=oe;continue}switch(J){case"{":X=!0;continue;case"[":q=!0;continue;case"}":{const Q=`(?:${f(K,",").map(Z=>E(Z)).join("|")})`;H+=Q,X=!1,K="";break}case"]":{H+="["+D+"]",q=!1,D="";break}case"?":H+=m;continue;case"*":H+=l(1);continue;default:H+=(0,b.$mf)(J)}}ee<_.length-1&&(_[ee+1]!==e.$Bk||ee+2<_.length)&&(H+=p)}ne=le===e.$Bk})}return H}const w=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Ic(1e4),n=function(){return!1},t=function(){return null};function s(B,H){if(!B)return t;let _;typeof B!="string"?_=B.pattern:_=B,_=_.trim();const ne=`${_}_${!!H.trimForExclusions}`;let le=i.get(ne);if(le)return r(le,B);let ee;return w.test(_)?le=u(_.substr(4),_):(ee=d.exec(o(_,H)))?le=y(ee[1],_):(H.trimForExclusions?$:I).test(_)?le=O(_,H):(ee=c.exec(o(_,H)))?le=S(ee[1].substr(1),_,!0):(ee=h.exec(o(_,H)))?le=S(ee[1],_,!1):le=v(_),i.set(ne,le),r(le,B)}function r(B,H){if(typeof H=="string")return B;const _=function(ne,le){return(0,k.$Jg)(ne,H.base,!A.$n)?B((0,b.$rf)(ne.substr(H.base.length),C.sep),le):null};return _.allBasenames=B.allBasenames,_.allPaths=B.allPaths,_.basenames=B.basenames,_.patterns=B.patterns,_}function o(B,H){return H.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function u(B,H){return function(_,ne){return typeof _=="string"&&_.endsWith(B)?H:null}}function y(B,H){const _=`/${B}`,ne=`\\${B}`,le=function(X,K){return typeof X!="string"?null:K?K===B?H:null:X===B||X.endsWith(_)||X.endsWith(ne)?H:null},ee=[B];return le.basenames=ee,le.patterns=[H],le.allBasenames=ee,le}function O(B,H){const _=V(B.slice(1,-1).split(",").map(K=>s(K,H)).filter(K=>K!==t),B),ne=_.length;if(!ne)return t;if(ne===1)return _[0];const le=function(K,q){for(let D=0,J=_.length;D<J;D++)if(_[D](K,q))return B;return null},ee=_.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const X=_.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return X.length&&(le.allPaths=X),le}function S(B,H,_){const ne=C.sep===C.$lc.sep,le=ne?B:B.replace(g,C.sep),ee=C.sep+le,X=C.$lc.sep+B;let K;return _?K=function(q,D){return typeof q=="string"&&(q===le||q.endsWith(ee)||!ne&&(q===B||q.endsWith(X)))?H:null}:K=function(q,D){return typeof q=="string"&&(q===le||!ne&&q===B)?H:null},K.allPaths=[(_?"*/":"./")+B],K}function v(B){try{const H=new RegExp(`^${E(B)}$`);return function(_){return H.lastIndex=0,typeof _=="string"&&H.test(_)?B:null}}catch{return t}}function N(B,H,_){return!B||typeof H!="string"?!1:F(B)(H,void 0,_)}function F(B,H={}){if(!B)return n;if(typeof B=="string"||U(B)){const _=s(B,H);if(_===t)return n;const ne=function(le,ee){return!!_(le,ee)};return _.allBasenames&&(ne.allBasenames=_.allBasenames),_.allPaths&&(ne.allPaths=_.allPaths),ne}return W(B,H)}function U(B){const H=B;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function j(B){return B.allBasenames||[]}function G(B){return B.allPaths||[]}function W(B,H){const _=V(Object.getOwnPropertyNames(B).map(K=>x(K,B[K],H)).filter(K=>K!==t)),ne=_.length;if(!ne)return t;if(!_.some(K=>!!K.requiresSiblings)){if(ne===1)return _[0];const K=function(J,oe){let Q;for(let Z=0,M=_.length;Z<M;Z++){const z=_[Z](J,oe);if(typeof z=="string")return z;(0,a.$wh)(z)&&(Q||(Q=[]),Q.push(z))}return Q?(async()=>{for(const Z of Q){const M=await Z;if(typeof M=="string")return M}return null})():null},q=_.find(J=>!!J.allBasenames);q&&(K.allBasenames=q.allBasenames);const D=_.reduce((J,oe)=>oe.allPaths?J.concat(oe.allPaths):J,[]);return D.length&&(K.allPaths=D),K}const le=function(K,q,D){let J,oe;for(let Q=0,Z=_.length;Q<Z;Q++){const M=_[Q];M.requiresSiblings&&D&&(q||(q=(0,C.$sc)(K)),J||(J=q.substr(0,q.length-(0,C.$tc)(K).length)));const z=M(K,q,J,D);if(typeof z=="string")return z;(0,a.$wh)(z)&&(oe||(oe=[]),oe.push(z))}return oe?(async()=>{for(const Q of oe){const Z=await Q;if(typeof Z=="string")return Z}return null})():null},ee=_.find(K=>!!K.allBasenames);ee&&(le.allBasenames=ee.allBasenames);const X=_.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return X.length&&(le.allPaths=X),le}function x(B,H,_){if(H===!1)return t;const ne=s(B,_);if(ne===t)return t;if(typeof H=="boolean")return ne;if(H){const le=H.when;if(typeof le=="string"){const ee=(X,K,q,D)=>{if(!D||!ne(X,K))return null;const J=le.replace("$(basename)",()=>q),oe=D(J);return(0,a.$wh)(oe)?oe.then(Q=>Q?B:null):oe?B:null};return ee.requiresSiblings=!0,ee}}return ne}function V(B,H){const _=B.filter(K=>!!K.basenames);if(_.length<2)return B;const ne=_.reduce((K,q)=>{const D=q.basenames;return D?K.concat(D):K},[]);let le;if(H){le=[];for(let K=0,q=ne.length;K<q;K++)le.push(H)}else le=_.reduce((K,q)=>{const D=q.patterns;return D?K.concat(D):K},[]);const ee=function(K,q){if(typeof K!="string")return null;if(!q){let J;for(J=K.length;J>0;J--){const oe=K.charCodeAt(J-1);if(oe===L.CharCode.Slash||oe===L.CharCode.Backslash)break}q=K.substr(J)}const D=ne.indexOf(q);return D!==-1?le[D]:null};ee.basenames=ne,ee.patterns=le,ee.allBasenames=ne;const X=B.filter(K=>!K.basenames);return X.push(ee),X}function te(B,H){return(0,P.$yb)(B,H,(_,ne)=>typeof _=="string"&&typeof ne=="string"?_===ne:typeof _!="string"&&typeof ne!="string"?_.base===ne.base&&_.pattern===ne.pattern:!1)}}),define(fe[96],de([0,1,14,65,10]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=void 0,e.$Un=A,e.$Vn=R,e.$Wn=p;function k(m){return m.toJSON()}class T{constructor(g){this.a=g}transformIncoming(g){const l=this.a.transformIncoming(g);return l===g?g:k(L.URI.from(l))}transformOutgoing(g){const l=this.a.transformOutgoing(g);return l===g?g:k(L.URI.from(l))}transformOutgoingURI(g){const l=this.a.transformOutgoing(g);return l===g?g:L.URI.from(l)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Sn=T,e.$Tn=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function C(m,g,l){if(!m||l>200)return null;if(typeof m=="object"){if(m instanceof L.URI)return g.transformOutgoing(m);for(const f in m)if(Object.hasOwnProperty.call(m,f)){const E=C(m[f],g,l+1);E!==null&&(m[f]=E)}}return null}function A(m,g){const l=C(m,g,0);return l===null?m:l}function b(m,g,l,f){if(!m||f>200)return null;if(typeof m=="object"){if(m.$mid===a.MarshalledId.Uri)return l?L.URI.revive(g.transformIncoming(m)):g.transformIncoming(m);if(m instanceof P.$Se)return null;for(const E in m)if(Object.hasOwnProperty.call(m,E)){const w=b(m[E],g,l,f+1);w!==null&&(m[E]=w)}}return null}function R(m,g){const l=b(m,g,!1,0);return l===null?m:l}function p(m,g){const l=b(m,g,!0,0);return l===null?m:l}}),define(fe[148],de([0,1,38,51,32,139,5]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Zn=A,e.$1n=p,e.$2n=m,L=Oe(L),e.$Yn=new class{c(g){return this.a||(this.a=a.$Qi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,l=0;const f=(0,P.networkInterfaces)();for(const E in f){const w=f[E];if(w)for(const{mac:d,internal:I}of w)I||(l+=1,this.c(d.toUpperCase())&&(g+=1))}this.b=l>0?g/l:0}return this.b}};let C;async function A(g){return C||(C=(async()=>await b(g)||L.$7g())()),C}async function b(g){try{const l=await new Promise((E,w)=>{ce(["crypto"],E,w)}).then(Oe),f=(0,k.$Xn)();return l.createHash("sha256").update(f,"utf8").digest("hex")}catch(l){g(l);return}}const R="Software\\Microsoft\\SQMClient";async function p(g){if(T.$l){const l=await new Promise((f,E)=>{ce(["@vscode/windows-registry"],f,E)}).then(Oe);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",R,"MachineId")||""}catch(f){return g(f),""}}return""}async function m(g){try{return await(await new Promise((E,w)=>{ce(["@vscode/deviceid"],E,w)}).then(Oe)).getDeviceId()}catch(l){return g(l),""}}}),define(fe[149],de([0,1,33,13,37]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hY=b,e.$iY=R;const k="XDG_SESSION_TYPE",T="WAYLAND_DISPLAY",C="XDG_RUNTIME_DIR";var A;(function(p){p.Wayland="wayland",p.XWayland="xwayland",p.X11="x11",p.Unknown="unknown"})(A||(A={}));async function b(p){const m=L.env[k];if(m)return m===A.Wayland||m===A.X11?m:A.Unknown;if(L.env[T]){const l=L.env[C];if(l){const f=(0,a.$oc)(l,"wayland-0");try{return await P.promises.access(f,P.constants.R_OK),A.Wayland}catch(E){return p(E),A.Unknown}}else return A.Unknown}else return A.X11}function R(p,m){if(m)switch(m){case"auto":return p;case"x11":return p===A.Wayland?A.XWayland:A.X11;case"wayland":return A.Wayland;default:return A.Unknown}else return p===A.Wayland?A.XWayland:A.X11}}),define(fe[150],de([0,1,33,243,5]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=k,L=Oe(L);async function k(T){if(L.$m||L.$l)return;let C;for(const A of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{C=await P.promises.open(A,P.constants.R_OK);break}catch{}if(!C){T("Unable to retrieve release information from known identifier paths.");return}try{const A=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),b={id:"unknown"};for await(const R of(0,a.createInterface)({input:C.createReadStream(),crlfDelay:1/0})){if(!R.includes("="))continue;const p=R.split("=")[0].toUpperCase().trim();if(A.has(p)){const m=R.split("=")[1].replace(/"/g,"").toLowerCase().trim();p==="ID"||p==="DISTRIB_ID"?b.id=m:p==="ID_LIKE"?b.id_like=m:(p==="VERSION_ID"||p==="DISTRIB_RELEASE")&&(b.version_id=m)}}return b}catch(A){T(A)}}}),define(fe[30],de([0,1,33,38,244,6,42,91,13,5,20,10]),function(ce,e,P,a,L,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=E,e.readdirSync=I,e.whenDeleted=h,e.configureFlushOnWrite=r,e.writeFileSync=u,P=Oe(P);var m;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function g(W,x=m.UNLINK,V){if((0,T.$Ng)(W))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?f(W):l(W,V)}async function l(W,x=(0,T.$Sg)((0,a.tmpdir)())){try{try{await P.promises.rename(W,x)}catch(V){return V.code==="ENOENT"?void 0:f(W)}f(x).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function f(W){return P.promises.rm(W,{recursive:!0,force:!0,maxRetries:3})}function E(W){if((0,T.$Ng)(W))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}async function w(W,x){return $(await(x?d(W):P.promises.readdir(W)))}async function d(W){try{return await P.promises.readdir(W,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const x=[],V=await w(W);for(const te of V){let B=!1,H=!1,_=!1;try{const ne=await P.promises.lstat((0,A.$oc)(W,te));B=ne.isFile(),H=ne.isDirectory(),_=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:te,isFile:()=>B,isDirectory:()=>H,isSymbolicLink:()=>_})}return x}function I(W){return $(P.readdirSync(W))}function $(W){return W.map(x=>typeof x=="string"?b.$m?(0,C.$sm)(x):x:(x.name=b.$m?(0,C.$sm)(x.name):x.name,x))}async function c(W){const x=await w(W),V=[];for(const te of x)await i.existsDirectory((0,A.$oc)(W,te))&&V.push(te);return V}function h(W,x=1e3){return new Promise(V=>{let te=!1;const B=setInterval(()=>{te||(te=!0,P.access(W,H=>{te=!1,H&&(clearInterval(B),V(void 0))}))},x)})}var i;(function(W){async function x(B){let H;try{if(H=await P.promises.lstat(B),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await P.promises.stat(B),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(b.$l&&_.code==="EACCES")try{return{stat:await P.promises.stat(await P.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw ne}throw _}}W.stat=x;async function V(B){try{const{stat:H,symbolicLink:_}=await W.stat(B);return H.isFile()&&_?.dangling!==!0}catch{}return!1}W.existsFile=V;async function te(B){try{const{stat:H,symbolicLink:_}=await W.stat(B);return H.isDirectory()&&_?.dangling!==!0}catch{}return!1}W.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const n=new k.$Th;function t(W,x,V){return n.queueFor(p.URI.file(W),()=>{const te=y(V);return new Promise((B,H)=>o(W,x,te,_=>_?H(_):B()))},R.$ch)}let s=!0;function r(W){s=W}function o(W,x,V,te){if(!s)return P.writeFile(W,x,{mode:V.mode,flag:V.flag},te);P.open(W,V.flag,V.mode,(B,H)=>{if(B)return te(B);P.writeFile(H,x,_=>{if(_)return P.close(H,()=>te(_));P.fdatasync(H,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),P.close(H,le=>te(le))))})})}function u(W,x,V){const te=y(V);if(!s)return P.writeFileSync(W,x,{mode:te.mode,flag:te.flag});const B=P.openSync(W,te.flag,te.mode);try{P.writeFileSync(B,x);try{P.fdatasyncSync(B)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),r(!1)}}finally{P.closeSync(B)}}function y(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function O(W,x,V=6e4){if(W!==x)try{b.$l&&typeof V=="number"?await S(W,x,Date.now(),V):await P.promises.rename(W,x)}catch(te){if(W.toLowerCase()!==x.toLowerCase()&&te.code==="EXDEV"||W.endsWith("."))await v(W,x,{preserveSymlinks:!1}),await g(W,m.MOVE);else throw te}}async function S(W,x,V,te,B=0){try{return await P.promises.rename(W,x)}catch(H){if(H.code!=="EACCES"&&H.code!=="EPERM"&&H.code!=="EBUSY")throw H;if(Date.now()-V>=te)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${H}`),H;if(B===0){let _=!1;try{const{stat:ne}=await i.stat(x);ne.isFile()||(_=!0)}catch{}if(_)throw H}return await(0,k.$Lh)(Math.min(100,B*10)),S(W,x,V,te,B+1)}}async function v(W,x,V){return F(W,x,{root:{source:W,target:x},options:V,handledSourcePaths:new Set})}const N=511;async function F(W,x,V){if(V.handledSourcePaths.has(W))return;V.handledSourcePaths.add(W);const{stat:te,symbolicLink:B}=await i.stat(W);if(B){if(V.options.preserveSymlinks)try{return await G(W,x,V)}catch{}if(B.dangling)return}return te.isDirectory()?U(W,x,te.mode&N,V):j(W,x,te.mode&N)}async function U(W,x,V,te){await P.promises.mkdir(x,{recursive:!0,mode:V});const B=await w(W);for(const H of B)await F((0,A.$oc)(W,H),(0,A.$oc)(x,H),te)}async function j(W,x,V){await P.promises.copyFile(W,x),await P.promises.chmod(x,V)}async function G(W,x,V){let te=await P.promises.readlink(W);(0,T.$Jg)(te,V.root.source,!b.$n)&&(te=(0,A.$oc)(V.root.target,te.substr(V.root.source.length+1))),await P.promises.symlink(te,x)}e.Promises=new class{get read(){return(W,x,V,te,B)=>new Promise((H,_)=>{P.read(W,x,V,te,B,(ne,le,ee)=>ne?_(ne):H({bytesRead:le,buffer:ee}))})}get write(){return(W,x,V,te,B)=>new Promise((H,_)=>{P.write(W,x,V,te,B,(ne,le,ee)=>ne?_(ne):H({bytesWritten:le,buffer:ee}))})}get fdatasync(){return(0,L.promisify)(P.fdatasync)}get open(){return(0,L.promisify)(P.open)}get close(){return(0,L.promisify)(P.close)}get realpath(){return(0,L.promisify)(P.realpath)}async exists(W){try{return await P.promises.access(W),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return g}get rename(){return O}get copy(){return v}}}),define(fe[151],de([0,1,33,13,5,26,30]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=C,e.$ur=A,e.$vr=b,e.$wr=R,P=Oe(P);function C(m){if(L.$n)return m;const g=(0,a.$rc)(m);if(m===g)return m;const l=((0,a.$sc)(m)||m).toLowerCase();try{const E=(0,T.readdirSync)(g).filter(w=>w.toLowerCase()===l);if(E.length===1){const w=C(g);if(w)return(0,a.$oc)(w,E[0])}else if(E.length>1){const w=E.indexOf(l);if(w>=0){const d=C(g);if(d)return(0,a.$oc)(d,E[w])}}}catch{}return null}async function A(m,g){if(L.$n)return m;const l=(0,a.$rc)(m);if(m===l)return m;const f=((0,a.$sc)(m)||m).toLowerCase();try{if(g?.isCancellationRequested)return null;const w=(await T.Promises.readdir(l)).filter(d=>d.toLowerCase()===f);if(w.length===1){const d=await A(l,g);if(d)return(0,a.$oc)(d,w[0])}else if(w.length>1){const d=w.indexOf(f);if(d>=0){const I=await A(l,g);if(I)return(0,a.$oc)(I,w[d])}}}catch{}return null}async function b(m){try{return await T.Promises.realpath(m)}catch{const l=p(m);return await P.promises.access(l,P.constants.R_OK),l}}function R(m){try{return P.realpathSync(m)}catch{const l=p(m);return P.accessSync(l,P.constants.R_OK),l}}function p(m){return(0,k.$sf)((0,a.$mc)(m),a.sep)}}),define(fe[152],de([0,1,33,13,5,37,94,12,30]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Dm=b,e.$Em=R,a=Oe(a),L=Oe(L),k=Oe(k),C=Oe(C),A=Oe(A),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function b(m=k.env){return m.comspec||"cmd.exe"}function R(m){let g=[],l=!1;const f=function(E){if(l){g.push(E);return}(!m.send(E,d=>{if(d&&console.error(d),l=!1,g.length>0){const I=g.slice(0);g=[],I.forEach($=>f($))}})||L.$l)&&(l=!0)};return{send:f}}var p;(function(m){async function g(l,f,E){if(a.$nc(l))return l;if(f===void 0&&(f=k.cwd()),a.$rc(l)!=="."||(E===void 0&&C.$jg(k.env.PATH)&&(E=k.env.PATH.split(a.$yc)),E===void 0||E.length===0))return a.$oc(f,l);async function d(I){if(await A.Promises.exists(I)){let $;try{$=await P.promises.stat(I)}catch(c){c.message.startsWith("EACCES")&&($=await P.promises.lstat(I))}return $?!$.isDirectory():!1}return!1}for(const I of E){let $;if(a.$nc(I)?$=a.$oc(I,l):$=a.$oc(f,I,l),await d($))return $;let c=$+".com";if(await d(c)||(c=$+".exe",await d(c)))return c}return a.$oc(f,l)}m.findExecutable=g})(p||(e.win32=p={}))}),define(fe[153],de([0,1,70,22]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=L;function L(T){return new Promise((C,A)=>{let b;const R=new Map;function p(g,l,f,E,w){const d=R.get(l);if(g===T||d){const I={name:m(f),cmd:f,pid:g,ppid:l,load:E,mem:w};R.set(g,I),g===T&&(b=I),d&&(d.children||(d.children=[]),d.children.push(I),d.children.length>1&&(d.children=d.children.sort(($,c)=>$.pid-c.pid)))}}function m(g){const l=/--utility-sub-type=network/i,f=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,w=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(f.exec(g))return"electron-crash-reporter";if(E.exec(g))return"winpty-agent";if(w.exec(g))return"conpty-agent";let I=d.exec(g);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?l.exec(g)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const $=/[a-zA-Z-]+\.js/g;let c="";do I=$.exec(g),I&&(c+=I+" ");while(I);return c&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${c})`:g}if(process.platform==="win32"){const g=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,f)=>{ce(["@vscode/windows-process-tree"],l,f)}).then(Oe).then(l=>{l.getProcessList(T,f=>{if(!f){A(new Error(`Root process ${T} not found`));return}l.getProcessCpuUsage(f,E=>{const w=new Map;E.forEach(d=>{const I=g(d.commandLine||"");w.set(d.pid,{name:m(I),cmd:I,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),b=w.get(T),b?(w.forEach(d=>{const I=w.get(d.ppid);I&&(I.children||(I.children=[]),I.children.push(d))}),w.forEach(d=>{d.children&&(d.children=d.children.sort((I,$)=>I.pid-$.pid))}),C(b)):A(new Error(`Root process ${T} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let g=function(){let l=[b];const f=[];for(;l.length;){const w=l.shift();w&&(f.push(w.pid),w.children&&(l=l.concat(w.children)))}let E=JSON.stringify(a.$5g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+f.join(" "),(0,P.exec)(E,{},(w,d,I)=>{if(w||I)A(w||new Error(I.toString()));else{const $=d.toString().split(`
`);for(let c=0;c<f.length;c++){const h=R.get(f[c]);h.load=parseFloat($[c])}if(!b){A(new Error(`Root process ${T} not found`));return}C(b)}})};(0,P.exec)("which ps",{},(l,f,E)=>{if(l||E)if(process.platform!=="linux")A(l||new Error(E.toString()));else{const w=JSON.stringify(a.$5g.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(w,{},(d,I,$)=>{d||$?A(d||new Error($.toString())):(k(I,p),g())})}else{const w=f.toString().trim();(0,P.exec)(`${w} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(I,$,c)=>{I||c&&!c.includes("screen size is bogus")?A(I||new Error(c.toString())):(k($,p),process.platform==="linux"?g():b?C(b):A(new Error(`Root process ${T} not found`)))})}})}})}function k(T,C){const A=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const R of b){const p=A.exec(R.trim());p&&p.length===6&&C(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(fe[71],de([0,1,33,6,13,12,30,9]),function(ce,e,P,a,L,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0,e.zip=E,e.$Lq=w,e.$Mq=I,L=Oe(L),C=Oe(C),e.$Iq="end of central directory record signature not found";const A=new RegExp(e.$Iq);class b extends Error{constructor(c,h){let i=h.message;switch(c){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=c,this.cause=h}}e.$Jq=b;function R($){const c=$.externalFileAttributes>>16||33188;return[448,56,7].map(h=>c&h).reduce((h,i)=>h+i,c&61440)}function p($){if($ instanceof b)return $;let c;return A.test($.message)&&(c="CorruptZip"),new b(c,$)}function m($,c,h,i,n,t){const s=L.$rc(c),r=L.$oc(i,s);if(!r.startsWith(i))return Promise.reject(new Error(C.localize(142,null,c)));const o=L.$oc(i,c);let u;return t.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(P.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,O)=>{if(!t.isCancellationRequested)try{u=(0,P.createWriteStream)(o,{mode:h}),u.once("close",()=>y()),u.once("error",O),$.once("error",O),$.pipe(u)}catch(S){O(S)}}))}function g($,c,h,i){let n=(0,a.$xh)(()=>Promise.resolve()),t=0;const s=i.onCancellationRequested(()=>{n.cancel(),$.close()});return new Promise((r,o)=>{const u=new a.$Fh,y=O=>{O.isCancellationRequested||(t++,$.readEntry())};$.once("error",o),$.once("close",()=>n.then(()=>{i.isCancellationRequested||$.entryCount===t?r():o(new b("Incomplete",new Error(C.localize(143,null,t,$.entryCount))))},o)),$.readEntry(),$.on("entry",O=>{if(i.isCancellationRequested)return;if(!h.sourcePathRegex.test(O.fileName)){y(i);return}const S=O.fileName.replace(h.sourcePathRegex,"");if(/\/$/.test(S)){const F=L.$oc(c,S);n=(0,a.$xh)(U=>P.promises.mkdir(F,{recursive:!0}).then(()=>y(U)).then(void 0,o));return}const v=f($,O),N=R(O);n=(0,a.$xh)(F=>u.queue(()=>v.then(U=>m(U,S,N,c,h,F).then(()=>y(F)))).then(null,o))})}).finally(()=>s.dispose())}async function l($,c=!1){const{open:h}=await new Promise((i,n)=>{ce(["yauzl"],i,n)}).then(Oe);return new Promise((i,n)=>{h($,c?{lazyEntries:!0}:void 0,(t,s)=>{t?n(p(t)):i((0,k.$ug)(s))})})}function f($,c){return new Promise((h,i)=>{$.openReadStream(c,(n,t)=>{n?i(p(n)):h((0,k.$ug)(t))})})}async function E($,c){const{ZipFile:h}=await new Promise((i,n)=>{ce(["yazl"],i,n)}).then(Oe);return new Promise((i,n)=>{const t=new h;c.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const s=(0,P.createWriteStream)($);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>i($))})}function w($,c,h={},i){const n=new RegExp(h.sourcePath?`^${h.sourcePath}`:"");let t=l($,!0);return h.overwrite&&(t=t.then(s=>T.Promises.rm(c).then(()=>s))),t.then(s=>g(s,c,{sourcePathRegex:n},i))}function d($,c){return l($).then(h=>new Promise((i,n)=>{h.on("entry",t=>{t.fileName===c&&f(h,t).then(s=>i(s),s=>n(s))}),h.once("close",()=>n(new Error(C.localize(144,null,c))))}))}function I($,c){return d($,c).then(h=>new Promise((i,n)=>{const t=[];h.once("error",n),h.on("data",s=>t.push(s)),h.on("end",()=>i(Buffer.concat(t)))}))}});var Ee=this&&this.__decorate||function(ce,e,P,a){var L=arguments.length,k=L<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,P):a,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(ce,e,P,a);else for(var C=ce.length-1;C>=0;C--)(T=ce[C])&&(k=(L<3?T(k):L>3?T(e,P,k):T(e,P))||k);return L>3&&k&&Object.defineProperty(e,P,k),k};define(fe[43],de([0,1,17,6,14,25,88,8,3,2,68,26,12]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.ProxyChannel=e.$si=e.$pi=e.$oi=e.$ni=e.RequestInitiator=e.$mi=e.$ji=e.$ii=void 0,e.$ki=r,e.$li=o,e.$qi=N,e.$ri=F,p=Oe(p);var g;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(g||(g={}));function l(B){switch(B){case g.Promise:return"req";case g.PromiseCancel:return"cancel";case g.EventListen:return"subscribe";case g.EventDispose:return"unsubscribe"}}var f;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(f||(f={}));function E(B){switch(B){case f.Initialize:return"init";case f.PromiseSuccess:return"reply:";case f.PromiseError:case f.PromiseErrorObj:return"replyErr:";case f.EventFire:return"event:"}}var w;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(w||(w={}));function d(B){let H=0;for(let _=0;;_+=7){const ne=B.read(1);if(H|=(ne.buffer[0]&127)<<_,!(ne.buffer[0]&128))return H}}const I=n(0);function $(B,H){if(H===0){B.write(I);return}let _=0;for(let le=H;le!==0;le=le>>>7)_++;const ne=L.$Se.alloc(_);for(let le=0;H!==0;le++)ne.buffer[le]=H&127,H=H>>>7,H>0&&(ne.buffer[le]|=128);B.write(ne)}class c{constructor(H){this.b=H,this.a=0}read(H){const _=this.b.slice(this.a,this.a+H);return this.a+=_.byteLength,_}}e.$ii=c;class h{constructor(){this.a=[]}get buffer(){return L.$Se.concat(this.a)}write(H){this.a.push(H)}}e.$ji=h;var i;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(i||(i={}));function n(B){const H=L.$Se.alloc(1);return H.writeUInt8(B,0),H}const t={Undefined:n(i.Undefined),String:n(i.String),Buffer:n(i.Buffer),VSBuffer:n(i.VSBuffer),Array:n(i.Array),Object:n(i.Object),Uint:n(i.Int)},s=typeof Buffer<"u";function r(B,H){if(typeof H>"u")B.write(t.Undefined);else if(typeof H=="string"){const _=L.$Se.fromString(H);B.write(t.String),$(B,_.byteLength),B.write(_)}else if(s&&Buffer.isBuffer(H)){const _=L.$Se.wrap(H);B.write(t.Buffer),$(B,_.byteLength),B.write(_)}else if(H instanceof L.$Se)B.write(t.VSBuffer),$(B,H.byteLength),B.write(H);else if(Array.isArray(H)){B.write(t.Array),$(B,H.length);for(const _ of H)r(B,_)}else if(typeof H=="number"&&(H|0)===H)B.write(t.Uint),$(B,H);else{const _=L.$Se.fromString(JSON.stringify(H));B.write(t.Object),$(B,_.byteLength),B.write(_)}}function o(B){switch(B.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return B.read(d(B)).toString();case i.Buffer:return B.read(d(B)).buffer;case i.VSBuffer:return B.read(d(B));case i.Array:{const _=d(B),ne=[];for(let le=0;le<_;le++)ne.push(o(B));return ne}case i.Object:return JSON.parse(B.read(d(B)).toString());case i.Int:return d(B)}}class u{constructor(H,_,ne=null,le=1e3){this.h=H,this.j=_,this.k=ne,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:f.Initialize})}registerChannel(H,_){this.b.set(H,_),setTimeout(()=>this.w(H),0)}m(H){switch(H.type){case f.Initialize:{const _=this.o([H.type]);this.k?.logOutgoing(_,0,y.OtherSide,E(H.type));return}case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:{const _=this.o([H.type,H.id],H.data);this.k?.logOutgoing(_,H.id,y.OtherSide,E(H.type),H.data);return}}}o(H,_=void 0){const ne=new h;return r(ne,H),r(ne,_),this.p(ne.buffer)}p(H){try{return this.h.send(H),H.byteLength}catch{return 0}}q(H){const _=new c(H),ne=o(_),le=o(_),ee=ne[0];switch(ee){case g.Promise:return this.k?.logIncoming(H.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.s({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case g.EventListen:return this.k?.logIncoming(H.byteLength,ne[1],y.OtherSide,`${l(ee)}: ${ne[2]}.${ne[3]}`,le),this.t({type:ee,id:ne[1],channelName:ne[2],name:ne[3],arg:le});case g.PromiseCancel:return this.k?.logIncoming(H.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]});case g.EventDispose:return this.k?.logIncoming(H.byteLength,ne[1],y.OtherSide,`${l(ee)}`),this.u({type:ee,id:ne[1]})}}s(H){const _=this.b.get(H.channelName);if(!_){this.v(H);return}const ne=new k.$Be;let le;try{le=_.call(this.j,H.name,H.arg,ne.token)}catch(K){le=Promise.reject(K)}const ee=H.id;le.then(K=>{this.m({id:ee,data:K,type:f.PromiseSuccess})},K=>{K instanceof Error?this.m({id:ee,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split(`
`):void 0},type:f.PromiseError}):this.m({id:ee,data:K,type:f.PromiseErrorObj})}).finally(()=>{X.dispose(),this.d.delete(H.id)});const X=(0,b.$Xc)(()=>ne.cancel());this.d.set(H.id,X)}t(H){const _=this.b.get(H.channelName);if(!_){this.v(H);return}const ne=H.id,ee=_.listen(this.j,H.name,H.arg)(X=>this.m({id:ne,data:X,type:f.EventFire}));this.d.set(H.id,ee)}u(H){const _=this.d.get(H.id);_&&(_.dispose(),this.d.delete(H.id))}v(H){let _=this.g.get(H.channelName);_||(_=[],this.g.set(H.channelName,_));const ne=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===g.Promise&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:f.PromiseError})},this.l);_.push({request:H,timeoutTimer:ne})}w(H){const _=this.g.get(H);if(_){for(const ne of _)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case g.Promise:this.s(ne.request);break;case g.EventListen:this.t(ne.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Uc)(this.d.values()),this.d.clear()}}e.$mi=u;var y;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class O{constructor(H,_=null){this.l=H,this.a=!1,this.b=w.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new A.$qe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=_}getChannel(H){const _=this;return{call(ne,le,ee){return _.a?Promise.reject(new C.$9):_.m(H,ne,le,ee)},listen(ne,le){return _.a?A.Event.None:_.o(H,ne,le)}}}m(H,_,ne,le=k.CancellationToken.None){const ee=this.g++,X=g.Promise,K={id:ee,type:X,channelName:H,name:_,arg:ne};if(le.isCancellationRequested)return Promise.reject(new C.$9);let q;return new Promise((J,oe)=>{if(le.isCancellationRequested)return oe(new C.$9);const Q=()=>{const ie=ae=>{switch(ae.type){case f.PromiseSuccess:this.f.delete(ee),J(ae.data);break;case f.PromiseError:{this.f.delete(ee);const ue=new Error(ae.data.message);ue.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,ue.name=ae.data.name,oe(ue);break}case f.PromiseErrorObj:this.f.delete(ee),oe(ae.data);break}};this.f.set(ee,ie),this.p(K)};let Z=null;this.b===w.Idle?Q():(Z=(0,a.$xh)(ie=>this.u()),Z.then(()=>{Z=null,Q()}));const M=()=>{Z?(Z.cancel(),Z=null):this.p({id:ee,type:g.PromiseCancel}),oe(new C.$9)},z=le.onCancellationRequested(M);q=(0,b.$Wc)((0,b.$Xc)(M),z),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(H,_,ne){const le=this.g++,ee=g.EventListen,X={id:le,type:ee,channelName:H,name:_,arg:ne};let K=null;const q=new A.$qe({onWillAddFirstListener:()=>{K=(0,a.$xh)(J=>this.u()),K.then(()=>{K=null,this.d.add(q),this.p(X)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(q),this.p({id:le,type:g.EventDispose}))}}),D=J=>q.fire(J.data);return this.f.set(le,D),q.event}p(H){switch(H.type){case g.Promise:case g.EventListen:{const _=this.q([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(_,H.id,y.LocalSide,`${l(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case g.PromiseCancel:case g.EventDispose:{const _=this.q([H.type,H.id]);this.j?.logOutgoing(_,H.id,y.LocalSide,l(H.type));return}}}q(H,_=void 0){const ne=new h;return r(ne,H),r(ne,_),this.r(ne.buffer)}r(H){try{return this.l.send(H),H.byteLength}catch{return 0}}s(H){const _=new c(H),ne=o(_),le=o(_),ee=ne[0];switch(ee){case f.Initialize:return this.j?.logIncoming(H.byteLength,0,y.LocalSide,E(ee)),this.t({type:ne[0]});case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:return this.j?.logIncoming(H.byteLength,ne[1],y.LocalSide,E(ee),le),this.t({type:ne[0],id:ne[1],data:le})}}t(H){if(H.type===f.Initialize){this.b=w.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return A.Event.toPromise(this.onDidInitialize)}u(){return this.b===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Uc)(this.d.values()),this.d.clear()}}e.$ni=O,Ee([T.$ci],O.prototype,"onDidInitializePromise",null);class S{get connections(){const H=[];return this.f.forEach(_=>H.push(_)),H}constructor(H,_,ne){this.a=new Map,this.f=new Set,this.g=new A.$qe,this.onDidAddConnection=this.g.event,this.h=new A.$qe,this.onDidRemoveConnection=this.h.event,this.j=new b.$Yc,this.j.add(H(({protocol:le,onDidClientDisconnect:ee})=>{const X=A.Event.once(le.onMessage);this.j.add(X(K=>{const q=new c(K),D=o(q),J=new u(le,D,_,ne),oe=new O(le,_);this.a.forEach((Z,M)=>J.registerChannel(M,Z));const Q={channelServer:J,channelClient:oe,ctx:D};this.f.add(Q),this.g.fire(Q),this.j.add(ee(()=>{J.dispose(),oe.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(H,_){const ne=this;return{call(le,ee,X){let K;if((0,m.$xg)(_)){const D=(0,P.$7b)(ne.connections.filter(_));K=D?Promise.resolve(D):A.Event.toPromise(A.Event.filter(ne.onDidAddConnection,_))}else K=_.routeCall(ne,le,ee);const q=K.then(D=>D.channelClient.getChannel(H));return N(q).call(le,ee,X)},listen(le,ee){if((0,m.$xg)(_))return ne.k(H,_,le,ee);const X=_.routeEvent(ne,le,ee).then(K=>K.channelClient.getChannel(H));return N(X).listen(le,ee)}}}k(H,_,ne,le){const ee=this;let X;const K=new A.$qe({onWillAddFirstListener:()=>{X=new b.$Yc;const q=new A.$we,D=new Map,J=Q=>{const M=Q.channelClient.getChannel(H).listen(ne,le),z=q.add(M);D.set(Q,z)},oe=Q=>{const Z=D.get(Q);Z&&(Z.dispose(),D.delete(Q))};ee.connections.filter(_).forEach(J),A.Event.filter(ee.onDidAddConnection,_)(J,void 0,X),ee.onDidRemoveConnection(oe,void 0,X),q.event(K.fire,K,X),X.add(q)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return K.event}registerChannel(H,_){this.a.set(H,_);for(const ne of this.f)ne.channelServer.registerChannel(H,_)}dispose(){this.j.dispose();for(const H of this.f)H.channelClient.dispose(),H.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$oi=S;class v{constructor(H,_,ne=null){const le=new h;r(le,_),H.send(le.buffer),this.a=new O(H,ne),this.d=new u(H,_,ne)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,_){this.d.registerChannel(H,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$pi=v;function N(B){return{call(H,_,ne){return B.then(le=>le.call(H,_,ne))},listen(H,_){const ne=new A.$ze;return B.then(le=>ne.input=le.listen(H,_)),ne.event}}}function F(B){let H=!1;return{call(_,ne,le){return H?B.call(_,ne,le):(0,a.$Lh)(0).then(()=>H=!0).then(()=>B.call(_,ne,le))},listen(_,ne){if(H)return B.listen(_,ne);const le=new A.$ze;return(0,a.$Lh)(0).then(()=>H=!0).then(()=>le.input=B.listen(_,ne)),le.event}}}class U{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const _ of H.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await A.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.$si=U;var j;(function(B){function H(ee,X,K){const q=ee,D=K&&K.disableMarshalling,J=new Map;for(const oe in q)ne(oe)&&J.set(oe,A.Event.buffer(q[oe],!0,void 0,X));return new class{listen(oe,Q,Z){const M=J.get(Q);if(M)return M;const z=q[Q];if(typeof z=="function"){if(le(Q))return z.call(q,Z);if(ne(Q))return J.set(Q,A.Event.buffer(q[Q],!0,void 0,X)),J.get(Q)}throw new C.$fb(`Event not found: ${Q}`)}call(oe,Q,Z){const M=q[Q];if(typeof M=="function"){if(!D&&Array.isArray(Z))for(let ie=0;ie<Z.length;ie++)Z[ie]=(0,R.$hi)(Z[ie]);let z=M.apply(q,Z);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new C.$fb(`Method not found: ${Q}`)}}}B.fromService=H;function _(ee,X){const K=X&&X.disableMarshalling;return new Proxy({},{get(q,D){if(typeof D=="string")return X?.properties?.has(D)?X.properties.get(D):le(D)?function(J){return ee.listen(D,J)}:ne(D)?ee.listen(D):async function(...J){let oe;X&&!(0,m.$sg)(X.context)?oe=[X.context,...J]:oe=J;const Q=await ee.call(D,oe);return K?Q:(0,R.$hi)(Q)};throw new C.$fb(`Property not found: ${String(D)}`)}})}B.toService=_;function ne(ee){return ee[0]==="o"&&ee[1]==="n"&&p.$Jf(ee.charCodeAt(2))}function le(ee){return/^onDynamic/.test(ee)&&p.$Jf(ee.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const H=B.toString();if(H!=="[object Object]")return H}return B}function x(B){return Array.isArray(B)?B.map(W):W(B)}function V(B,H,_,ne,le,ee,X){X=x(X);const K=G[le],q=K[ne%K.length];let D=[`%c[${B}]%c[${String(H).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ee)?(D=D.concat(X),D.push(")")):D.push(X),console.log.apply(console,D)}class te{constructor(H,_){this.d=H,this.f=_,this.a=0,this.b=0}logOutgoing(H,_,ne,le,ee){this.b+=H,V(this.d,this.b,H,_,ne,le,ee)}logIncoming(H,_,ne,le,ee){this.a+=H,V(this.f,this.a,H,_,ne,le,ee)}}e.$ti=te}),define(fe[72],de([0,1,14,3,2,43]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.ProtocolConstants=e.$ui=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var C;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let r=0;function o(y,O){if(!s.has(y)){const S=String(++r);s.set(y,S)}return s.get(y)}function u(y,O,S,v){if(!t.enableDiagnostics)return;const N=o(y,O);if(v instanceof P.$Se||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const F=P.$Se.alloc(v.byteLength);F.set(v),t.records.push({timestamp:Date.now(),id:N,label:O,type:S,buff:F})}else t.records.push({timestamp:Date.now(),id:N,label:O,type:S,data:v})}t.traceSocketEvent=u})(C||(e.SocketDiagnostics=C={}));var A;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(A||(e.SocketCloseEventType=A={}));let b=null;function R(){return b||(b=P.$Se.alloc(0)),b}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,r){if(s===0)return R();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const O=this.a[0];return r&&(this.a.shift(),this.b-=s),O}if(this.a[0].byteLength>s){const O=this.a[0].slice(0,s);return r&&(this.a[0]=this.a[0].slice(s),this.b-=s),O}const o=P.$Se.alloc(s);let u=0,y=0;for(;s>0;){const O=this.a[y];if(O.byteLength>s){const S=O.slice(0,s);o.set(S,u),u+=s,r&&(this.a[y]=O.slice(s),this.b-=s),s-=s}else o.set(O,u),u+=O.byteLength,r?(this.a.shift(),this.b-=O.byteLength):y++,s-=O.byteLength}return o}}e.$ui=p;var m;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(m||(m={}));function g(t){switch(t){case m.None:return"None";case m.Regular:return"Regular";case m.Control:return"Control";case m.Ack:return"Ack";case m.Disconnect:return"Disconnect";case m.ReplayRequest:return"ReplayRequest";case m.Pause:return"PauseWriting";case m.Resume:return"ResumeWriting";case m.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class f{constructor(s,r,o,u){this.type=s,this.id=r,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends L.$Zc{constructor(s){super(),this.f=this.B(new a.$qe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:m.None,id:0,ack:0},this.a=s,this.b=!1,this.c=new p,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,u=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=m.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,r),this.f.fire(new f(o,u,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class w{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=P.$Se.alloc(l.HeaderLength);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,s.data),this.j(r,s.data)}g(s,r){const o=this.f===0;return this.d.push(s,r),this.f+=s.byteLength+r.byteLength,o}h(){const s=P.$Se.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,r){this.g(s,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:s.byteLength}),this.c.write(s)}}class d extends L.$Zc{constructor(s){super(),this.f=new a.$qe,this.onMessage=this.f.event,this.g=new a.$qe,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new w(this.a)),this.c=this.B(new E(this.a)),this.B(this.c.onMessage(r=>{r.type===m.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new f(m.Regular,0,0,s))}}e.$vi=d;class I extends k.$pi{static fromSocket(s,r){return new I(new d(s),r)}get onDidDispose(){return this.b.onDidDispose}constructor(s,r,o=null){super(s,r,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$wi=I;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$qe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$xi=$;class c{constructor(s){this.data=s,this.next=null}}class h{constructor(){this.a=null,this.b=null}length(){let s=0,r=this.a;for(;r;)r=r.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let r=0,o=this.a;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const r=new c(s);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const s=Date.now();for(let r=0;r<i.a;r++)this.c[r]=s-1e3*r;setInterval(()=>{for(let r=i.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),r=(1+i.a)*1e3;let o=0;for(let u=0;u<i.a;u++)s-this.c[u]<=r&&o++;return 1-o/i.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.d-this.f}constructor(s){this.v=new $,this.onControlMessage=this.v.event,this.w=new $,this.onMessage=this.w.event,this.x=new $,this.onDidDispose=this.x.event,this.y=new $,this.onSocketClose=this.y.event,this.z=new $,this.onSocketTimeout=this.z.event,this.t=s.loadEstimator??i.getInstance(),this.u=s.sendKeepAlive??!0,this.a=!1,this.c=new h,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new L.$Yc,this.p=s.socket,this.q=this.s.add(new w(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(r=>this.A(r))),this.s.add(this.p.onClose(r=>this.y.fire(r))),s.initialChunk&&this.r.acceptChunk(s.initialChunk),this.u?this.m=setInterval(()=>{this.E()},l.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const s=new f(m.Disconnect,0,0,R());this.q.write(s),this.q.flush()}}sendPause(){const s=new f(m.Pause,0,0,R());this.q.write(s)}sendResume(){const s=new f(m.Resume,0,0,R());this.q.write(s)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(s,r){this.a=!0,this.s.dispose(),this.s=new L.$Yc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=s,this.q=this.s.add(new w(this.p)),this.r=this.s.add(new E(this.p)),this.s.add(this.r.onMessage(o=>this.A(o))),this.s.add(this.p.onClose(o=>this.y.fire(o))),this.r.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.j=this.h;const s=new f(m.Ack,0,this.j,R());this.q.write(s);const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C()}acceptDisconnect(){this.x.fire()}A(s){if(s.ack>this.f){this.f=s.ack;do{const r=this.c.peek();if(r&&r.id<=s.ack)this.c.pop();else break}while(!0)}switch(s.type){case m.None:break;case m.Regular:{if(s.id>this.h)if(s.id!==this.h+1){const r=Date.now();r-this.n>1e4&&(this.n=r,this.q.write(new f(m.ReplayRequest,0,0,R())))}else this.h=s.id,this.k=Date.now(),this.B(),this.w.fire(s.data);break}case m.Control:{this.v.fire(s.data);break}case m.Ack:break;case m.Disconnect:{this.x.fire();break}case m.ReplayRequest:{const r=this.c.toArray();for(let o=0,u=r.length;o<u;o++)this.q.write(r[o]);this.C();break}case m.Pause:{this.q.pause();break}case m.Resume:{this.q.resume();break}case m.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(s){const r=++this.d;this.j=this.h;const o=new f(m.Regular,r,this.j,s);this.c.push(o),this.a||(this.q.write(o),this.C())}sendControl(s){const r=new f(m.Control,0,0,s);this.q.write(r)}B(){if(this.h<=this.j||this.l)return;const s=Date.now()-this.k;if(s>=l.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},l.AcknowledgeTime-s+5)}C(){if(this.d<=this.f||this.g||this.a)return;const s=this.c.peek(),r=Date.now()-s.writtenTime,o=Date.now()-this.r.lastReadTime,u=Date.now()-this.o;if(r>=l.TimeoutTime&&o>=l.TimeoutTime&&u>=l.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const y=Math.max(l.TimeoutTime-r,l.TimeoutTime-o,l.TimeoutTime-u,500);this.g=setTimeout(()=>{this.g=null,this.C()},y)}D(){if(this.h<=this.j)return;this.j=this.h;const s=new f(m.Ack,0,this.j,R());this.q.write(s)}E(){this.j=this.h;const s=new f(m.KeepAlive,0,this.j,R());this.q.write(s)}}e.$yi=n}),define(fe[97],de([0,1,70,6,14,25,147,8,3,2,29,152,94,43]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0,C=Oe(C);class l extends g.$mi{constructor(w){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:A.Event.fromNodeEventEmitter(process,"message",d=>L.$Se.wrap(Buffer.from(d,"base64")))},w),process.once("disconnect",()=>this.dispose())}}e.$pr=l;class f{constructor(w,d){this.i=w,this.j=d,this.c=new Set,this.g=new Map,this.h=new A.$qe,this.onDidProcessExit=this.h.event;const I=d&&d.timeout?d.timeout:6e4;this.b=new a.$Hh(I),this.d=null,this.f=null}getChannel(w){const d=this;return{call(I,$,c){return d.k(w,I,$,c)},listen(I,$){return d.l(w,I,$)}}}k(w,d,I,$=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(C.$0());this.b.cancel();const c=this.n(w),h=(0,a.$xh)(t=>c.call(d,I,t)),i=$.onCancellationRequested(()=>h.cancel()),n=(0,b.$Xc)(()=>h.cancel());return this.c.add(n),h.finally(()=>{i.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),h}l(w,d,I){if(!this.b)return A.Event.None;this.b.cancel();let $;const c=new A.$qe({onWillAddFirstListener:()=>{$=this.n(w).listen(d,I)(c.fire,c),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const w=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,R.$ko)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.$rm)(d.env),this.d=(0,P.fork)(this.i,w,d);const I=new A.$qe,c=A.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,T.$lr)(r)){(0,T.log)(r,`IPC Library: ${this.j.serverName}`);return}I.fire(L.$Se.wrap(Buffer.from(r,"base64")))}),h=this.j.useQueue?(0,p.$Em)(this.d):this.d,i=r=>this.d&&this.d.connected&&h.send(r.buffer.toString("base64")),n=I.event,t={send:i,onMessage:n};this.f=new g.$ni(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",s),c.dispose(),this.c.forEach(u=>(0,b.$Uc)(u)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(w){let d=this.g.get(w);return d||(d=this.m.getChannel(w),this.g.set(w,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qr=f}),define(fe[154],de([0,1,143,14,43,3,12,17]),function(ce,e,P,a,L,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zY=void 0,e.$AY=R;class A{constructor(m){this.a=m,this.onMessage=k.Event.fromNodeEventEmitter(this.a,"message",g=>g.data?a.$Se.wrap(g.data):a.$Se.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class b extends L.$oi{static b(m){(0,T.$tg)((0,P.$yY)(process),"Electron Utility Process");const g=new k.$qe;return process.parentPort.on("message",l=>{if(m?.handledClientConnection(l))return;const f=(0,C.$Sb)(l.ports);f&&g.fire(f)}),k.Event.map(g.event,l=>({protocol:new A(l),onDidClientDisconnect:k.Event.fromNodeEventEmitter(l,"close")}))}constructor(m){super(b.b(m))}}e.$zY=b;function R(p,m,g){const l=f=>{f.data===m&&(p.removeListener("message",l),g())};p.on("message",l)}}),define(fe[73],de([0,1,6,3,2,68,12]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.StorageState=e.StorageHint=void 0,e.$jq=A;var C;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function A(m){const g=m;return g?.changed instanceof Map||g?.deleted instanceof Set}var b;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(b||(e.StorageState=b={}));class R extends L.$Zc{static{this.a=100}constructor(g,l=Object.create(null)){super(),this.r=g,this.s=l,this.b=this.B(new a.$te),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new P.$Ih(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((l,f)=>this.w(f,l)),g.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(g,l){if(this.c===b.Closed)return;let f=!1;(0,T.$sg)(l)?f=this.f.delete(g):this.f.get(g)!==l&&(this.f.set(g,l),f=!0),f&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,l){const f=this.f.get(g);return(0,T.$sg)(f)?l:f}getBoolean(g,l){const f=this.get(g);return(0,T.$sg)(f)?l:f==="true"}getNumber(g,l){const f=this.get(g);return(0,T.$sg)(f)?l:parseInt(f,10)}getObject(g,l){const f=this.get(g);return(0,T.$sg)(f)?l:(0,k.$gi)(f)}async set(g,l,f=!1){if(this.c===b.Closed)return;if((0,T.$sg)(l))return this.delete(g,f);const E=(0,T.$lg)(l)||Array.isArray(l)?(0,k.$fi)(l):String(l);if(this.f.get(g)!==E)return this.f.set(g,E),this.j.set(g,E),this.h.delete(g),this.b.fire({key:g,external:f}),this.D()}async delete(g,l=!1){if(!(this.c===b.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:l}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(!(this.c===b.Closed||this.m))return this.D(g)}async D(g){return this.s.hint===C.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===C.STORAGE_IN_MEMORY}}e.$kq=R;class p{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((l,f)=>this.a.set(f,l)),g.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$lq=p}),define(fe[155],de([0,1,39,8,9]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var k;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(k||(e.TokenType=k={}));function T(...R){switch(R.length){case 1:return(0,L.localize)(1693,null,R[0]);case 2:return(0,L.localize)(1694,null,R[0],R[1]);case 3:return(0,L.localize)(1695,null,R[0],R[1],R[2]);default:return}}const C=(0,L.localize)(1696,null),A=(0,L.localize)(1697,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return p.isTripleEq?"===":"==";case k.NotEq:return p.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return p.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return p.lexeme;case k.QuotedStr:return p.lexeme;case k.Error:return p.lexeme;case k.EOF:return"EOF";default:throw(0,a.$_)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(k.LParen);break;case P.CharCode.CloseParen:this.k(k.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const m=this.h(P.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:m})}else this.k(k.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const m=this.h(P.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:m})}else this.h(P.CharCode.Tilde)?this.k(k.RegexOp):this.l(T("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?k.LtEq:k.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?k.GtEq:k.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(k.And):this.l(T("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(k.Or):this.l(T("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const m=this.d,g=this.c.substring(this.d,this.e),l={type:k.Error,offset:this.d,lexeme:g};this.g.push({offset:m,lexeme:g,additionalInfo:p}),this.f.push(l)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const m=this.c.substring(this.d,this.e),g=b.b.get(m);g?this.k(g):this.f.push({type:k.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,m=!1,g=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(A);return}const f=this.c.charCodeAt(p);if(m)m=!1;else if(f===P.CharCode.Slash&&!g){p++;break}else f===P.CharCode.OpenSquareBracket?g=!0:f===P.CharCode.Backslash?m=!0:f===P.CharCode.CloseSquareBracket&&(g=!1);p++}for(;p<this.c.length&&b.a.has(this.c.charCodeAt(p));)p++;this.e=p;const l=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=b}),define(fe[156],de([0,1,67,88,22,13,37,20,10]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=void 0,e.$an=R,e.$bn=p,e.$$m=/^([^.]+\..+)[:=](.+)$/;class b{get appRoot(){return(0,k.$rc)(L.$5g.asFileUri("").fsPath)}get userHome(){return A.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return A.URI.file((0,k.$oc)(this.userDataPath,"User"))}get tmpDir(){return A.URI.file(this.b.tmpDir)}get cacheHome(){return A.URI.file(this.userDataPath)}get stateResource(){return(0,C.$lh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.$lh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,P.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$oc)(this.userDataPath,"logs",g)}return A.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.$lh)(A.URI.file((0,k.$oc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.$lh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.$lh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.$lh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=T.env.VSCODE_PORTABLE;return g?A.URI.file((0,k.$oc)(g,"argv.json")):(0,C.$lh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return A.URI.file((0,k.$oc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,k.$pc)(g):(0,k.$mc)((0,k.$oc)(L.$5g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?A.URI.file((0,k.$pc)(g)):A.URI.file((0,k.$oc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,k.$pc)(g);const l=T.env.VSCODE_EXTENSIONS;if(l)return l;const f=T.env.VSCODE_PORTABLE;return f?(0,k.$oc)(f,"extensions"):(0,C.$lh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(l=>/^[^:/?#]+?:\/\//.test(l)?A.URI.parse(l):A.URI.file((0,k.$mc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?A.URI.parse(g):A.URI.file((0,k.$mc)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$$m.test(g))}get extensionLogLevel(){const g=[];for(const l of this.args.log||[]){const f=e.$$m.exec(l);f&&f[1]&&f[2]&&g.push([f[1],f[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,C.$lh)(A.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=T.env.VSCODE_PORTABLE;return g?A.URI.file((0,k.$oc)(g,"policy.json")):(0,C.$lh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,l,f){this.a=g,this.b=l,this.c=f,this.editSessionId=this.args.editSessionId}}e.$_m=b,Ee([a.$ci],b.prototype,"appRoot",null),Ee([a.$ci],b.prototype,"userHome",null),Ee([a.$ci],b.prototype,"userDataPath",null),Ee([a.$ci],b.prototype,"appSettingsHome",null),Ee([a.$ci],b.prototype,"tmpDir",null),Ee([a.$ci],b.prototype,"cacheHome",null),Ee([a.$ci],b.prototype,"stateResource",null),Ee([a.$ci],b.prototype,"userRoamingDataHome",null),Ee([a.$ci],b.prototype,"userDataSyncHome",null),Ee([a.$ci],b.prototype,"sync",null),Ee([a.$ci],b.prototype,"machineSettingsResource",null),Ee([a.$ci],b.prototype,"workspaceStorageHome",null),Ee([a.$ci],b.prototype,"localHistoryHome",null),Ee([a.$ci],b.prototype,"keyboardLayoutResource",null),Ee([a.$ci],b.prototype,"argvResource",null),Ee([a.$ci],b.prototype,"isExtensionDevelopment",null),Ee([a.$ci],b.prototype,"untitledWorkspacesHome",null),Ee([a.$ci],b.prototype,"builtinExtensionsPath",null),Ee([a.$ci],b.prototype,"extensionsPath",null),Ee([a.$ci],b.prototype,"extensionDevelopmentLocationURI",null),Ee([a.$ci],b.prototype,"extensionDevelopmentKind",null),Ee([a.$ci],b.prototype,"extensionTestsLocationURI",null),Ee([a.$ci],b.prototype,"debugExtensionHost",null),Ee([a.$ci],b.prototype,"logLevel",null),Ee([a.$ci],b.prototype,"extensionLogLevel",null),Ee([a.$ci],b.prototype,"serviceMachineIdResource",null),Ee([a.$ci],b.prototype,"disableTelemetry",null),Ee([a.$ci],b.prototype,"disableWorkspaceTrust",null),Ee([a.$ci],b.prototype,"useInMemorySecretStorage",null),Ee([a.$ci],b.prototype,"policyFile",null);function R(m,g){return p(m["inspect-extensions"],m["inspect-brk-extensions"],5870,g,m.debugId,m.extensionEnvironment)}function p(m,g,l,f,E,w){const I=Number(g||m)||(f?null:l),$=I?!!g:!1;let c;if(w)try{c=JSON.parse(w)}catch{}return{port:I,break:$,debugId:E,env:c}}}),function(){function ce(e,P,a){function L(T,C){const A=k(T,C),b=[A];return e.isAbsolute(A)||b.unshift(a),e.resolve(...b)}function k(T,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const A=process.env.VSCODE_PORTABLE;if(A)return e.join(A,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,C);const R=T["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(p,"AppData","Roaming")}break;case"darwin":b=e.join(P.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,C)}return{getUserDataPath:L}}if(typeof define=="function")define(fe[157],de([245,38,37]),function(e,P,a){return ce(e,P,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=ce(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(fe[158],de([0,1,38,156,157]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$dn=T,e.$en=C;class k extends a.$_m{constructor(b,R){super(b,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,L.getUserDataPath)(b,R.nameShort)},R)}}e.$cn=k;function T(A,b){return(0,a.$bn)(A["inspect-ptyhost"],A["inspect-brk-ptyhost"],5877,b,A.extensionEnvironment)}function C(A,b){return(0,a.$bn)(A["inspect-sharedprocess"],A["inspect-brk-sharedprocess"],5879,b,A.extensionEnvironment)}}),define(fe[159],de([0,1,12,9]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=L;function L(T,C,A,b){try{k(T,C,A,b)}catch(R){T.error(R?.message??R)}return C}function k(T,C,A,b){const R=(p,m,g)=>{const l=p[m];if((0,P.$jg)(l)){const f=l,E=f.length;if(E>1&&f[0]==="%"&&f[E-1]==="%"){const w=f.substr(1,E-2);let d=A[w];d===void 0&&b&&(d=b[w]);const I=typeof d=="string"?d:d?.message,$=b?.[w],c=typeof $=="string"?$:$?.message;if(!I){c||T.warn(`[${C.name}]: ${(0,a.localize)(1814,null,w)}`);return}if(g&&(m==="title"||m==="category")&&c&&c!==I){const h={value:I,original:c};p[m]=h}else p[m]=I}}else if((0,P.$lg)(l))for(const f in l)l.hasOwnProperty(f)&&(f==="commands"?R(l,f,!0):R(l,f,g));else if(Array.isArray(l))for(let f=0;f<l.length;f++)R(l,f,g)};for(const p in C)C.hasOwnProperty(p)&&R(C,p)}}),define(fe[160],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=e.$Vjc=void 0;class P{constructor(k){this.a=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k){return this.a.call("promptImportantExtensionsInstallNotification",[k])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Vjc=P;class a{constructor(k){this.a=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,C){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(C[0])}throw new Error(`Call not found: ${T}`)}}e.$Wjc=a}),define(fe[161],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const P={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:5},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(P)}),define(fe[74],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class P{constructor(L,k=[],T=!1){this.ctor=L,this.staticArguments=k,this.supportsDelayedInstantiation=T}}e.$Hi=P}),define(fe[162],de([0,1,74]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Zs=k,e.$1s=T;const a=[];var L;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function k(C,A,b){A instanceof P.$Hi||(A=new P.$Hi(A,[],!!b)),a.push([C,A])}function T(){return a}}),define(fe[163],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;class P{constructor(k,T){this.key=k,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$Cr=P;class a{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const T of this.a.values())T.outgoing.size===0&&k.push(T);return k}insertEdge(k,T){const C=this.lookupOrInsertNode(k),A=this.lookupOrInsertNode(T);C.outgoing.set(A.key,A),A.incoming.set(C.key,C)}removeNode(k){const T=this.b(k);this.a.delete(T);for(const C of this.a.values())C.outgoing.delete(T),C.incoming.delete(T)}lookupOrInsertNode(k){const T=this.b(k);let C=this.a.get(T);return C||(C=new P(T,k),this.a.set(T,C)),C}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[T,C]of this.a)k.push(`${T}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,T]of this.a){const C=new Set([k]),A=this.c(T,C);if(A)return A}}c(k,T){for(const[C,A]of k.outgoing){if(T.has(C))return[...T,C].join(" -> ");T.add(C);const b=this.c(A,T);if(b)return b;T.delete(C)}}}e.$Dr=a}),define(fe[4],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=L,e.$Li=k;var P;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function C(A){return A[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=C})(P||(e._util=P={})),e.$Ji=L("instantiationService");function a(T,C,A){C[P.DI_TARGET]===C?C[P.DI_DEPENDENCIES].push({id:T,index:A}):(C[P.DI_DEPENDENCIES]=[{id:T,index:A}],C[P.DI_TARGET]=C)}function L(T){if(P.serviceIds.has(T))return P.serviceIds.get(T);const C=function(A,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(C,A,R)};return C.toString=()=>T,P.serviceIds.set(T,C),C}function k(T){return T}}),define(fe[164],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0,e.$vjc=(0,P.$Ki)("checksumService")}),define(fe[21],de([0,1,12,10,4]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=k,e.$gj=T,e.$hj=A,e.$ij=b,e.$jj=R,e.$kj=p,e.$lj=m,e.$mj=l,e.$nj=f,e.$oj=E,P=Oe(P),e.$ej=(0,L.$Ki)("configurationService");function k(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof a.URI)}function T(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||Array.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof a.URI)}var C;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.USER=2]="USER",w[w.USER_LOCAL=3]="USER_LOCAL",w[w.USER_REMOTE=4]="USER_REMOTE",w[w.WORKSPACE=5]="WORKSPACE",w[w.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",w[w.DEFAULT=7]="DEFAULT",w[w.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function A(w){switch(w){case C.APPLICATION:return"APPLICATION";case C.USER:return"USER";case C.USER_LOCAL:return"USER_LOCAL";case C.USER_REMOTE:return"USER_REMOTE";case C.WORKSPACE:return"WORKSPACE";case C.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case C.DEFAULT:return"DEFAULT";case C.MEMORY:return"MEMORY"}}function b(w){return w.applicationValue!==void 0||w.userValue!==void 0||w.userLocalValue!==void 0||w.userRemoteValue!==void 0||w.workspaceValue!==void 0||w.workspaceFolderValue!==void 0}function R(w,d){const I=Object.create(null);for(const $ in w)p(I,$,w[$],d);return I}function p(w,d,I,$){const c=d.split("."),h=c.pop();let i=w;for(let n=0;n<c.length;n++){const t=c[n];let s=i[t];switch(typeof s){case"undefined":s=i[t]=Object.create(null);break;case"object":if(s===null){$(`Ignoring ${d} as ${c.slice(0,n+1).join(".")} is null`);return}break;default:$(`Ignoring ${d} as ${c.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[h]=I}catch{$(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(i)}`)}else $(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(i)}`)}function m(w,d){const I=d.split(".");g(w,I)}function g(w,d){const I=d.shift();if(d.length===0){delete w[I];return}if(Object.keys(w).indexOf(I)!==-1){const $=w[I];typeof $=="object"&&!Array.isArray($)&&(g($,d),Object.keys($).length===0&&delete w[I])}}function l(w,d,I){function $(i,n){let t=i;for(const s of n){if(typeof t!="object"||t===null)return;t=t[s]}return t}const c=d.split("."),h=$(w,c);return typeof h>"u"?I:h}function f(w,d,I){Object.keys(d).forEach($=>{$!=="__proto__"&&($ in w?P.$lg(w[$])&&P.$lg(d[$])?f(w[$],d[$],I):I&&(w[$]=d[$]):w[$]=d[$])})}function E(w){return w.replace(/[\[\]]/g,"")}}),define(fe[98],de([0,1,39,5,26,155,4,9,8]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=R,e.$Jj=n,e.$Kj=t,e.$4j=ee;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",a.$m),b.set("isLinux",a.$n),b.set("isWindows",a.$l),b.set("isWeb",a.$r),b.set("isMacNative",a.$m&&!a.$r),b.set("isEdge",a.$K),b.set("isFirefox",a.$I),b.set("isChrome",a.$H),b.set("isSafari",a.$J);function R(q,D){if(b.get(q)!==void 0)throw(0,A.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(q,D)}const p=Object.prototype.hasOwnProperty;var m;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const g={regexParsingWithErrorRecovery:!0},l=(0,C.localize)(1673,null),f=(0,C.localize)(1674,null),E=(0,C.localize)(1675,null),w=(0,C.localize)(1676,null),d=(0,C.localize)(1677,null),I=(0,C.localize)(1678,null),$=(0,C.localize)(1679,null),c=(0,C.localize)(1680,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=g){this.k=D,this.d=new k.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const oe=this.D(),Q=oe.type===k.TokenType.Str?I:void 0;throw this.h.push({message:d,offset:oe.offset,lexeme:k.$Fj.getLexeme(oe),additionalInfo:Q}),h.c}return J}catch(J){if(J!==h.c)throw J;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(k.TokenType.Or);){const J=this.o();D.push(J)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(k.TokenType.And);){const J=this.s();D.push(J)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(k.TokenType.Neg)){const D=this.D();switch(D.type){case k.TokenType.True:return this.z(),r.INSTANCE;case k.TokenType.False:return this.z(),o.INSTANCE;case k.TokenType.LParen:{this.z();const J=this.l();return this.A(k.TokenType.RParen,w),J?.negate()}case k.TokenType.Str:return this.z(),N.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case k.TokenType.True:return this.z(),i.true();case k.TokenType.False:return this.z(),i.false();case k.TokenType.LParen:{this.z();const J=this.l();return this.A(k.TokenType.RParen,w),J}case k.TokenType.Str:{const J=D.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const Q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Q.type!==k.TokenType.RegexStr)throw this.B("REGEX",Q);const Z=Q.lexeme,M=Z.lastIndexOf("/"),z=M===Z.length-1?void 0:this.w(Z.substring(M+1));let ie;try{ie=new RegExp(Z.substring(1,M),z)}catch{throw this.B("REGEX",Q)}return x.create(J,ie)}switch(Q.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const Z=[Q.lexeme];this.z();let M=this.D(),z=0;for(let be=0;be<Q.lexeme.length;be++)Q.lexeme.charCodeAt(be)===P.CharCode.OpenParen?z++:Q.lexeme.charCodeAt(be)===P.CharCode.CloseParen&&z--;for(;!this.E()&&M.type!==k.TokenType.And&&M.type!==k.TokenType.Or;){switch(M.type){case k.TokenType.LParen:z++;break;case k.TokenType.RParen:z--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let be=0;be<M.lexeme.length;be++)M.lexeme.charCodeAt(be)===P.CharCode.OpenParen?z++:Q.lexeme.charCodeAt(be)===P.CharCode.CloseParen&&z--}if(z<0)break;Z.push(k.$Fj.getLexeme(M)),this.z(),M=this.D()}const ie=Z.join(""),ae=ie.lastIndexOf("/"),ue=ae===ie.length-1?void 0:this.w(ie.substring(ae+1));let pe;try{pe=new RegExp(ie.substring(1,ae),ue)}catch{throw this.B("REGEX",Q)}return i.regex(J,pe)}case k.TokenType.QuotedStr:{const Z=Q.lexeme;this.z();let M=null;if(!(0,L.$hf)(Z)){const z=Z.indexOf("/"),ie=Z.lastIndexOf("/");if(z!==ie&&z>=0){const ae=Z.slice(z+1,ie),ue=Z[ie+1]==="i"?"i":"";try{M=new RegExp(ae,ue)}catch{throw this.B("REGEX",Q)}}}if(M===null)throw this.B("REGEX",Q);return x.create(J,M)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,E);const Q=this.u();return i.notIn(J,Q)}switch(this.D().type){case k.TokenType.Eq:{this.z();const Q=this.u();if(this.x().type===k.TokenType.QuotedStr)return i.equals(J,Q);switch(Q){case"true":return i.has(J);case"false":return i.not(J);default:return i.equals(J,Q)}}case k.TokenType.NotEq:{this.z();const Q=this.u();if(this.x().type===k.TokenType.QuotedStr)return i.notEquals(J,Q);switch(Q){case"true":return i.not(J);case"false":return i.has(J);default:return i.notEquals(J,Q)}}case k.TokenType.Lt:return this.z(),G.create(J,this.u());case k.TokenType.LtEq:return this.z(),W.create(J,this.u());case k.TokenType.Gt:return this.z(),U.create(J,this.u());case k.TokenType.GtEq:return this.z(),j.create(J,this.u());case k.TokenType.In:return this.z(),i.in(J,this.u());default:return i.has(J)}}case k.TokenType.EOF:throw this.h.push({message:$,offset:D.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),D.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,J){if(this.C(D))return this.z();throw this.B(J,this.D())}B(D,J,oe){const Q=(0,C.localize)(1681,null,D,k.$Fj.getLexeme(J)),Z=J.offset,M=k.$Fj.getLexeme(J);return this.h.push({message:Q,offset:Z,lexeme:M,additionalInfo:oe}),h.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Hj=h;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(D){return u.create(D)}static equals(D,J){return y.create(D,J)}static notEquals(D,J){return v.create(D,J)}static regex(D,J){return x.create(D,J)}static in(D,J){return O.create(D,J)}static notIn(D,J){return S.create(D,J)}static not(D){return N.create(D)}static and(...D){return B.create(D,null,!0)}static or(...D){return H.create(D,null,!0)}static greater(D,J){return U.create(D,J)}static greaterEquals(D,J){return j.create(D,J)}static smaller(D,J){return G.create(D,J)}static smallerEquals(D,J){return W.create(D,J)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Ij=i;function n(q){const D=new h({regexParsingWithErrorRecovery:!1});return q.map(J=>(D.parse(J),D.lexingErrors.length>0?D.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,C.localize)(1682,null,oe.additionalInfo):(0,C.localize)(1683,null),offset:oe.offset,length:oe.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function t(q,D){const J=q?q.substituteConstants():void 0,oe=D?D.substituteConstants():void 0;return!J&&!oe?!0:!J||!oe?!1:J.equals(oe)}function s(q,D){return q.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=m.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$Lj=r;class o{static{this.INSTANCE=new o}constructor(){this.type=m.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Mj=o;class u{static create(D,J=null){const oe=b.get(D);return typeof oe=="boolean"?oe?o.INSTANCE:r.INSTANCE:new u(D,J)}constructor(D,J){this.key=D,this.c=J,this.type=m.Defined}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=b.get(this.key);return typeof D=="boolean"?D?o.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Nj=u;class y{static create(D,J,oe=null){if(typeof J=="boolean")return J?u.create(D,oe):N.create(D,oe);const Q=b.get(D);return typeof Q=="boolean"?J===(Q?"true":"false")?o.INSTANCE:r.INSTANCE:new y(D,J,oe)}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.Equals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?o.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Oj=y;class O{static create(D,J){return new O(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=m.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:le(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.f),oe=D.getValue(this.d);return Array.isArray(J)?J.includes(oe):typeof oe=="string"&&typeof J=="object"&&J!==null?p.call(J,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Pj=O;class S{static create(D,J){return new S(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=m.NotIn,this.c=O.create(D,J)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=S;class v{static create(D,J,oe=null){if(typeof J=="boolean")return J?N.create(D,oe):u.create(D,oe);const Q=b.get(D);return typeof Q=="boolean"?J===(Q?"true":"false")?r.INSTANCE:o.INSTANCE:new v(D,J,oe)}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?r.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Rj=v;class N{static create(D,J=null){const oe=b.get(D);return typeof oe=="boolean"?oe?r.INSTANCE:o.INSTANCE:new N(D,J)}constructor(D,J){this.c=D,this.d=J,this.type=m.Not}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=b.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:o.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Sj=N;function F(q,D){if(typeof q=="string"){const J=parseFloat(q);isNaN(J)||(q=J)}return typeof q=="string"||typeof q=="number"?D(q):r.INSTANCE}class U{static create(D,J,oe=null){return F(J,Q=>new U(D,Q,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.Greater}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Tj=U;class j{static create(D,J,oe=null){return F(J,Q=>new j(D,Q,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Uj=j;class G{static create(D,J,oe=null){return F(J,Q=>new G(D,Q,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Vj=G;class W{static create(D,J,oe=null){return F(J,Q=>new W(D,Q,oe))}constructor(D,J,oe){this.c=D,this.d=J,this.f=oe,this.type=m.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:le(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Wj=W;class x{static create(D,J){return new x(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=m.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const J=this.f?this.f.source:"",oe=D.f?D.f.source:"";return J<oe?-1:J>oe?1:0}equals(D){if(D.type===this.type){const J=this.f?this.f.source:"",oe=D.f?D.f.source:"";return this.d===D.d&&J===oe}return!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$Xj=x;class V{static create(D){return new V(D)}constructor(D){this.c=D,this.type=m.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new V(this.c.map(D))}negate(){return this.c}}e.$Yj=V;function te(q){let D=null;for(let J=0,oe=q.length;J<oe;J++){const Q=q[J].substituteConstants();if(q[J]!==Q&&D===null){D=[];for(let Z=0;Z<J;Z++)D[Z]=q[Z]}D!==null&&(D[J]=Q)}return D===null?q:D}class B{static create(D,J,oe){return B.d(D,J,oe)}constructor(D,J){this.expr=D,this.c=J,this.type=m.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,oe=this.expr.length;J<oe;J++){const Q=s(this.expr[J],D.expr[J]);if(Q!==0)return Q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,oe=this.expr.length;J<oe;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:B.create(D,this.c,!1)}evaluate(D){for(let J=0,oe=this.expr.length;J<oe;J++)if(!this.expr[J].evaluate(D))return!1;return!0}static d(D,J,oe){const Q=[];let Z=!1;for(const M of D)if(M){if(M.type===m.True){Z=!0;continue}if(M.type===m.False)return r.INSTANCE;if(M.type===m.And){Q.push(...M.expr);continue}Q.push(M)}if(Q.length===0&&Z)return o.INSTANCE;if(Q.length!==0){if(Q.length===1)return Q[0];Q.sort(s);for(let M=1;M<Q.length;M++)Q[M-1].equals(Q[M])&&(Q.splice(M,1),M--);if(Q.length===1)return Q[0];for(;Q.length>1;){const M=Q[Q.length-1];if(M.type!==m.Or)break;Q.pop();const z=Q.pop(),ie=Q.length===0,ae=H.create(M.expr.map(ue=>B.create([ue,z],null,oe)),null,ie);ae&&(Q.push(ae),Q.sort(s))}if(Q.length===1)return Q[0];if(oe){for(let M=0;M<Q.length;M++)for(let z=M+1;z<Q.length;z++)if(Q[M].negate().equals(Q[z]))return r.INSTANCE;if(Q.length===1)return Q[0]}return new B(Q,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new B(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());this.c=H.create(D,this,!0)}return this.c}}e.$Zj=B;class H{static create(D,J,oe){return H.d(D,J,oe)}constructor(D,J){this.expr=D,this.c=J,this.type=m.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,oe=this.expr.length;J<oe;J++){const Q=s(this.expr[J],D.expr[J]);if(Q!==0)return Q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,oe=this.expr.length;J<oe;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=te(this.expr);return D===this.expr?this:H.create(D,this.c,!1)}evaluate(D){for(let J=0,oe=this.expr.length;J<oe;J++)if(this.expr[J].evaluate(D))return!0;return!1}static d(D,J,oe){let Q=[],Z=!1;if(D){for(let M=0,z=D.length;M<z;M++){const ie=D[M];if(ie){if(ie.type===m.False){Z=!0;continue}if(ie.type===m.True)return o.INSTANCE;if(ie.type===m.Or){Q=Q.concat(ie.expr);continue}Q.push(ie)}}if(Q.length===0&&Z)return r.INSTANCE;Q.sort(s)}if(Q.length!==0){if(Q.length===1)return Q[0];for(let M=1;M<Q.length;M++)Q[M-1].equals(Q[M])&&(Q.splice(M,1),M--);if(Q.length===1)return Q[0];if(oe){for(let M=0;M<Q.length;M++)for(let z=M+1;z<Q.length;z++)if(Q[M].negate().equals(Q[z]))return o.INSTANCE;if(Q.length===1)return Q[0]}return new H(Q,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new H(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());for(;D.length>1;){const J=D.shift(),oe=D.shift(),Q=[];for(const Z of K(J))for(const M of K(oe))Q.push(B.create([Z,M],null,!1));D.unshift(H.create(Q,null,!1))}this.c=H.create(D,this,!0)}return this.c}}e.$1j=H;class _ extends u{static{this.d=[]}static all(){return _.d.values()}constructor(D,J,oe){super(D,null),this.f=J,typeof oe=="object"?_.d.push({...oe,key:D}):oe!==!0&&_.d.push({key:D,description:oe,type:J!=null?typeof J:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return y.create(this.key,D)}notEqualsTo(D){return v.create(this.key,D)}}e.$2j=_,e.$3j=(0,T.$Ki)("contextKeyService");function ne(q,D){return q<D?-1:q>D?1:0}function le(q,D,J,oe){return q<J?-1:q>J?1:D<oe?-1:D>oe?1:0}function ee(q,D){if(q.type===m.False||D.type===m.True)return!0;if(q.type===m.Or)return D.type===m.Or?X(q.expr,D.expr):!1;if(D.type===m.Or){for(const J of D.expr)if(ee(q,J))return!0;return!1}if(q.type===m.And){if(D.type===m.And)return X(D.expr,q.expr);for(const J of q.expr)if(ee(J,D))return!0;return!1}return q.equals(D)}function X(q,D){let J=0,oe=0;for(;J<q.length&&oe<D.length;){const Q=q[J].cmp(D[oe]);if(Q<0)return!1;Q===0&&J++,oe++}return J===q.length}function K(q){return q.type===m.Or?q.expr:[q]}}),define(fe[99],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Ym=e.ID=void 0,e.$Zm=a,e.ID="diagnosticsService",e.$Ym=(0,P.$Ki)(e.ID);function a(k){return!!k.hostName&&!!k.errorMessage}class L{async getPerformanceInfo(T,C){return{}}async getSystemInfo(T,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,C){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$1m=L}),define(fe[100],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=void 0,e.$8o=(0,P.$Ki)("downloadService")}),define(fe[15],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,P.$Ki)("environmentService"),e.$Si=(0,P.$Li)(e.$Ri)}),define(fe[75],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D8b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$C8b=L;var a;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function L(T){switch(T){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var k;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(k||(e.RecommendationsNotificationResult=k={})),e.$D8b=(0,P.$Ki)("IExtensionRecommendationNotificationService")}),define(fe[7],de([0,1,51,13,26,12,10,9,4,5,22,53]),function(ce,e,P,a,L,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=m,e.$hl=E,e.$il=d,e.$jl=I,e.$kl=$,e.$ll=c,e.$ml=h,e.$nl=i,e.$ol=n,e.$pl=t,e.$ql=s,e.$sl=u,e.$tl=y,e.$ul=O,e.$vl=S,e.$wl=v,e.$zl=G,e.$Ll=H,e.$Ml=_,e.$Ol=le,e.$fl=(0,A.$Ki)("fileService");function m(ee){return ee.create===!0}var g;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var l;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var f;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(f||(e.FileChangeFilter=f={}));function E(ee){const X=ee;return!!X&&typeof X.onDidChange=="function"}var w;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function d(ee){return!!(ee.capabilities&w.FileReadWrite)}function I(ee){return!!(ee.capabilities&w.FileFolderCopy)}function $(ee){return!!(ee.capabilities&w.FileClone)}function c(ee){return!!(ee.capabilities&w.FileOpenReadWriteClose)}function h(ee){return!!(ee.capabilities&w.FileReadStream)}function i(ee){return d(ee)?!!(ee.capabilities&w.FileAtomicRead):!1}function n(ee){return d(ee)?!!(ee.capabilities&w.FileAtomicWrite):!1}function t(ee){return!!(ee.capabilities&w.FileAtomicDelete)}function s(ee){return!!(ee.capabilities&w.Readonly)}var r;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class o extends Error{static create(X,K){const q=new o(X.toString(),K);return O(q,K),q}constructor(X,K){super(X),this.code=K}}e.$rl=o;function u(ee,X){return o.create(ee,X)}function y(ee){return ee||u((0,C.localize)(1865,null),r.Unknown)}function O(ee,X){return ee.name=X?`${X} (FileSystemError)`:"FileSystemError",ee}function S(ee){if(!ee)return r.Unknown;if(ee instanceof o)return ee.code;const X=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!X)return r.Unknown;switch(X[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function v(ee){if(ee instanceof W)return ee.fileOperationResult;switch(S(ee)){case r.FileNotFound:return te.FILE_NOT_FOUND;case r.FileIsADirectory:return te.FILE_IS_DIRECTORY;case r.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return te.FILE_WRITE_LOCKED;case r.NoPermissions:return te.FILE_PERMISSION_DENIED;case r.FileExists:return te.FILE_MOVE_CONFLICT;case r.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var N;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class F{constructor(X,K,q){this.resource=X,this.operation=K,this.target=q}isOperation(X){return this.operation===X}}e.$xl=F;var U;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class j{static{this.a=null}constructor(X,K){this.c=K,this.b=void 0,this.d=new p.$Y(()=>{const q=P.$Qi.forUris(()=>this.c);return q.fill(this.rawAdded.map(D=>[D,!0])),q}),this.f=new p.$Y(()=>{const q=P.$Qi.forUris(()=>this.c);return q.fill(this.rawUpdated.map(D=>[D,!0])),q}),this.g=new p.$Y(()=>{const q=P.$Qi.forUris(()=>this.c);return q.fill(this.rawDeleted.map(D=>[D,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of X){switch(q.type){case U.ADDED:this.rawAdded.push(q.resource);break;case U.UPDATED:this.rawUpdated.push(q.resource);break;case U.DELETED:this.rawDeleted.push(q.resource);break}this.b!==j.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(X,...K){return this.h(X,{includeChildren:!1},...K)}affects(X,...K){return this.h(X,{includeChildren:!0},...K)}h(X,K,...q){if(!X)return!1;const D=q.length>0;return!!((!D||q.includes(U.ADDED))&&(this.d.value.get(X)||K.includeChildren&&this.d.value.findSuperstr(X))||(!D||q.includes(U.UPDATED))&&(this.f.value.get(X)||K.includeChildren&&this.f.value.findSuperstr(X))||(!D||q.includes(U.DELETED))&&(this.g.value.findSubstr(X)||K.includeChildren&&this.g.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.b===X}hasCorrelation(){return typeof this.b=="number"}}e.$yl=j;function G(ee,X,K){return!ee||!X||ee===X||X.length>ee.length?!1:(X.charAt(X.length-1)!==a.sep&&(X+=a.sep),K?(0,L.$Lf)(ee,X):ee.indexOf(X)===0)}class W extends Error{constructor(X,K,q){super(X),this.fileOperationResult=K,this.options=q}}e.$Al=W;class x extends W{constructor(X,K,q,D){super(X,K,D),this.fileOperationResult=K,this.size=q}}e.$Bl=x;class V extends W{constructor(X,K,q){super(X,te.FILE_NOT_MODIFIED_SINCE,q),this.stat=K}}e.$Cl=V;var te;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var B;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Kl="";function H(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function _(ee,X){if(!X.hasProvider(T.URI.from({scheme:ee.scheme})))return new Promise(K=>{const q=X.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===ee.scheme&&D.added&&(q.dispose(),K())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(X){return(0,k.$ng)(X)||(X=0),X<ne.KB?(0,C.localize)(1866,null,X.toFixed(0)):X<ne.MB?(0,C.localize)(1867,null,(X/ne.KB).toFixed(2)):X<ne.GB?(0,C.localize)(1868,null,(X/ne.MB).toFixed(2)):X<ne.TB?(0,C.localize)(1869,null,(X/ne.GB).toFixed(2)):(0,C.localize)(1870,null,(X/ne.TB).toFixed(2))}}e.$Nl=ne;function le(ee){const X=typeof ee=="string"||ee?.scheme===R.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===R.Schemas.file?1024*ne.MB:X?10*ne.MB:b.$r?50*ne.MB:1024*ne.MB}});var Y=this&&this.__param||function(ce,e){return function(P,a){e(P,a,ce)}};define(fe[165],de([0,1,76,50,7]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;let k=class{constructor(C){this.a=C}async checksum(C){const A=(await this.a.readFileStream(C)).value;return new Promise((b,R)=>{const p=(0,P.createHash)("sha256");(0,a.$Ke)(A,{onData:m=>p.update(m.buffer),onError:m=>R(m),onEnd:()=>b(p.digest("base64").replace(/=+$/,""))})})}};e.$wjc=k,e.$wjc=k=Ee([Y(0,L.$fl)],k)}),define(fe[101],de([0,1,14,8,9,7]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=T;async function T(R,p,m,g,l,f){let E;try{await C(R,p,m,g,l,f)}catch(w){E=w}finally{E&&l.errorTransformer&&(E=l.errorTransformer(E)),typeof E<"u"&&m.error(E),m.end()}}async function C(R,p,m,g,l,f){A(f);const E=await R.open(p,{create:!1});try{A(f);let w=0,d=0,I=l&&typeof l.length=="number"?l.length:void 0,$=P.$Se.alloc(Math.min(l.bufferSize,typeof I=="number"?I:l.bufferSize)),c=l&&typeof l.position=="number"?l.position:0,h=0;do d=await R.read(E,c,$.buffer,h,$.byteLength-h),c+=d,h+=d,w+=d,typeof I=="number"&&(I-=d),h===$.byteLength&&(await m.write(g($)),$=P.$Se.alloc(Math.min(l.bufferSize,typeof I=="number"?I:l.bufferSize)),h=0);while(d>0&&(typeof I!="number"||I>0)&&A(f)&&b(w,l));if(h>0){let i=h;typeof I=="number"&&(i=Math.min(h,I)),m.write(g($.slice(0,i)))}}catch(w){throw(0,k.$tl)(w)}finally{await R.close(E)}}function A(R){if(R.isCancellationRequested)throw(0,a.$0)();return!0}function b(R,p){if(typeof p?.limits?.size=="number"&&R>p.limits.size)throw(0,k.$sl)((0,L.localize)(1898,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(fe[46],de([0,1,95,2,13,5,10,7]),function(ce,e,P,a,L,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=void 0,e.$_q=A,e.$ar=b,e.$er=g,e.$fr=l,e.$gr=f,e.$hr=E,e.$ir=d,e.$jr=I;function A($){return typeof $.correlationId=="number"}function b($){return $.recursive===!0}class R extends a.$Zc{static{this.a=5}constructor(c,h,i,n){super(),this.h=c,this.j=h,this.m=i,this.n=n,this.c=this.B(new a.$1c),this.f=void 0,this.g=0}s(){const c=new a.$Yc;this.c.value=c,this.b=this.r(c),this.b.setVerboseLogging(this.m),c.add(this.b.onDidChangeFile(h=>this.h(h))),c.add(this.b.onDidLogMessage(h=>this.j(h))),c.add(this.b.onDidError(h=>this.t(h.error,h.request)))}t(c,h){this.u(c,h)?this.g<R.a&&this.f?(this.y(`restarting watcher after unexpected error: ${c}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${c}`):this.y(c)}u(c,h){return!(!this.n.restartOnError||h||c.indexOf("No space left on device")!==-1||c.indexOf("EMFILE")!==-1)}w(c){this.g++,this.s(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.m=c,await this.b?.setVerboseLogging(c)}y(c){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${c}`})}z(c){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$br=R;class p extends R{constructor(c,h,i){super(c,h,i,{type:"node.js",restartOnError:!1})}}e.$cr=p;class m extends R{constructor(c,h,i){super(c,h,i,{type:"universal",restartOnError:!0})}}e.$dr=m;function g($){return $.map(c=>({type:c.type,resource:T.URI.revive(c.resource),cId:c.cId}))}function l($){const c=new w;for(const h of $)c.processEvent(h);return c.coalesce()}function f($,c){return typeof c=="string"&&!c.startsWith(P.$Bk)&&!(0,L.$nc)(c)?{base:$,pattern:c}:c}function E($,c){const h=[];for(const i of c)h.push((0,P.$Fk)(f($,i)));return h}class w{constructor(){this.a=new Set,this.b=new Map}c(c){return k.$n?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const h=this.b.get(this.c(c));let i=!1;if(h){const n=h.type,t=c.type;h.resource.fsPath!==c.resource.fsPath&&(c.type===C.FileChangeType.DELETED||c.type===C.FileChangeType.ADDED)?i=!0:n===C.FileChangeType.ADDED&&t===C.FileChangeType.DELETED?(this.b.delete(this.c(c)),this.a.delete(h)):n===C.FileChangeType.DELETED&&t===C.FileChangeType.ADDED?h.type=C.FileChangeType.UPDATED:n===C.FileChangeType.ADDED&&t===C.FileChangeType.UPDATED||(h.type=t)}else i=!0;i&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],h=[];return Array.from(this.a).filter(i=>i.type!==C.FileChangeType.DELETED?(c.push(i),!1):!0).sort((i,n)=>i.resource.fsPath.length-n.resource.fsPath.length).filter(i=>h.some(n=>(0,C.$zl)(i.resource.fsPath,n,!k.$n))?!1:(h.push(i.resource.fsPath),!0)).concat(c)}}function d($,c){if(typeof c=="number")switch($.type){case C.FileChangeType.ADDED:return(c&C.FileChangeFilter.ADDED)===0;case C.FileChangeType.DELETED:return(c&C.FileChangeFilter.DELETED)===0;case C.FileChangeType.UPDATED:return(c&C.FileChangeFilter.UPDATED)===0}return!1}function I($){if(typeof $=="number"){const c=[];return $&C.FileChangeFilter.ADDED&&c.push("Added"),$&C.FileChangeFilter.DELETED&&c.push("Deleted"),$&C.FileChangeFilter.UPDATED&&c.push("Updated"),c.length===0?"<all>":`[${c.join(", ")}]`}return"<none>"}}),define(fe[166],de([0,1,14,41,8,3,2,50,32,7,46]),function(ce,e,P,a,L,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=e.$RR=void 0,e.$RR="localFilesystem";class p extends T.$Zc{constructor(g,l){super(),this.a=g,this.b=l,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.$qe),this.onDidChangeFile=this.f.event,this.g=this.B(new k.$qe),this.onDidWatchError=this.g.event,this.h=(0,A.$7g)(),this.j()}get capabilities(){return this.c||(this.c=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=b.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=b.FileSystemProviderCapabilities.Trash)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,l){const{buffer:f}=await this.a.call("readFile",[g,l]);return f}readFileStream(g,l,f){const E=(0,C.$Ge)(d=>P.$Se.concat(d.map(I=>P.$Se.wrap(I))).buffer),w=new T.$Yc;return w.add(this.a.listen("readFileStream",[g,l])(d=>{if(d instanceof P.$Se)E.write(d.buffer);else{if(d==="end")E.end();else{let I;if(d instanceof Error)I=d;else{const $=d;I=(0,b.$sl)($.message??(0,a.$vj)($),$.code??b.FileSystemProviderErrorCode.Unknown)}E.error(I),E.end()}w.dispose()}})),w.add(f.onCancellationRequested(()=>{E.error((0,L.$0)()),E.end(),w.dispose()})),E}writeFile(g,l,f){return this.a.call("writeFile",[g,P.$Se.wrap(l),f])}open(g,l){return this.a.call("open",[g,l])}close(g){return this.a.call("close",[g])}async read(g,l,f,E,w){const[d,I]=await this.a.call("read",[g,l,w]);return f.set(d.buffer.slice(0,I),E),I}write(g,l,f,E,w){return this.a.call("write",[g,l,P.$Se.wrap(f),E,w])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,l){return this.a.call("delete",[g,l])}rename(g,l,f){return this.a.call("rename",[g,l,f])}copy(g,l,f){return this.a.call("copy",[g,l,f])}cloneFile(g,l){return this.a.call("cloneFile",[g,l])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const l=g;this.f.fire((0,R.$er)(l))}else{const l=g;this.g.fire(l)}}))}watch(g,l){const f=(0,A.$7g)();return this.a.call("watch",[this.h,f,g,l]),(0,T.$Xc)(()=>this.a.call("unwatch",[this.h,f]))}}e.$SR=p}),define(fe[167],de([0,1,33,2,46,3,7,10,6]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class b extends a.$Zc{constructor(){super(),this.a=this.B(new k.$qe),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$qe),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$qe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$9c),this.m=new Set,this.n=this.B(new A.$Ih(this.y())),this.r=5007,this.s=new A.$8h,this.R=!1,this.B(this.f(p=>this.t(p)))}t(p){this.u(p)&&this.z(p)}u(p){return(0,L.$_q)(p)}async watch(p){this.s.isSettled||this.s.complete(),this.s=new A.$8h;try{this.h.clear(),this.g.clear();for(const m of p)this.u(m)?this.h.set(m.correlationId,m):this.g.add(m);for(const[m]of this.j)this.h.has(m)||(this.j.deleteAndDispose(m),this.m.delete(m));return await this.w(!1)}finally{this.s.complete()}}w(p){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))]),p?this.y():0)}y(){return 800}isSuspended(p){return typeof p.correlationId!="number"?!1:this.m.has(p.correlationId)?"polling":this.j.has(p.correlationId)}async z(p){if(this.j.has(p.correlationId))return;const m=new a.$Yc;this.j.set(p.correlationId,m),await this.s.p,!m.isDisposed&&(this.D(p,m),this.w(!0))}C(p){this.j.deleteAndDispose(p.correlationId),this.m.delete(p.correlationId),this.w(!1)}D(p,m){this.F(p,m)?(this.P(`reusing an existing recursive watcher to monitor ${p.path}`),this.m.delete(p.correlationId)):(this.G(p,m),this.m.add(p.correlationId))}F(p,m){const g=this.O?.subscribe(p.path,(l,f)=>{m.isDisposed||(l?this.D(p,m):f?.type===T.FileChangeType.ADDED&&this.H(p))});return g?(m.add(g),!0):!1}G(p,m){let g=!1;const l=(f,E)=>{if(m.isDisposed)return;const w=this.I(f),d=this.I(E),I=g;g=w,!w&&(d||I)&&this.H(p)};this.P(`starting fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,P.watchFile)(p.path,{persistent:!1,interval:this.r},l)}catch(f){this.Q(`fs.watchFile() failed with error ${f} on path ${p.path} (correlationId: ${p.correlationId})`)}m.add((0,a.$Xc)(()=>{this.P(`stopping fs.watchFile() on ${p.path} (correlationId: ${p.correlationId})`);try{(0,P.unwatchFile)(p.path,l)}catch(f){this.Q(`fs.unwatchFile() failed with error ${f} on path ${p.path} (correlationId: ${p.correlationId})`)}}))}H(p){this.P(`detected ${p.path} exists again, resuming watcher (correlationId: ${p.correlationId})`);const m={resource:C.URI.file(p.path),type:T.FileChangeType.ADDED,cId:p.correlationId};this.a.fire([m]),this.J(m,p),this.C(p)}I(p){return p.ctimeMs===0&&p.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(p,m){if(this.R){const g=` >> normalized ${p.type===T.FileChangeType.ADDED?"[ADDED]":p.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${p.resource.fsPath}`;this.L(g,m)}}L(p,m){this.R&&this.P(`${p}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}M(p){return`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"}, filter: ${(0,L.$jr)(p.filter)}, correlationId: ${typeof p.correlationId=="number"?p.correlationId:"<none>"})`}async setVerboseLogging(p){this.R=p}}e.$sr=b}),define(fe[168],de([0,1,33,6,25,42,2,91,13,5,20,10,151,30,7,46]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0,e.$yr=w;class E extends T.$Zc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(I,$,c,h,i,n){super(),this.s=I,this.t=$,this.u=c,this.w=h,this.y=i,this.z=n,this.c=this.B(new a.$Zh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new a.$Yh(t=>this.M(t),E.b)),this.g=(0,f.$hr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$hr)(this.s.path,this.s.includes):void 0,this.j=(0,f.$_q)(this.s)?this.s.filter:void 0,this.m=new L.$Be,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const I=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const $=await P.promises.stat(I);if(this.m.token.isCancellationRequested)return;this.B(await this.G(I,$.isDirectory()))}catch(I){I.code!=="ENOENT"?this.O(I):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${I})`),this.D()}}D(){this.r=!0,this.w?.()}async F(I){let $=I.path;try{$=await g.Promises.realpath(I.path),I.path===$&&($=await(0,m.$ur)(I.path,this.m.token)??I.path),I.path!==$&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${I.path}, real: ${$})`)}catch{}return $}async G(I,$){const c=new T.$Yc;return this.H(I,$,c)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(I,$,c)),c}H(I,$,c){if($)return!1;const h=p.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(n,t)=>{if(!c.isDisposed)if(n){const s=await this.G(I,$);c.isDisposed?s.dispose():c.add(s)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:t.type,cId:this.s.correlationId},!0)});return i?(c.add(i),!0):!1}async I(I,$,c){if(b.$m&&(0,k.$Jg)(I,"/Volumes/",!0)){this.O(`Refusing to watch ${I} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new L.$Be(this.m.token);c.add((0,T.$Xc)(()=>h.dispose(!0)));const i=new T.$Yc;c.add(i);try{const n=p.URI.file(this.s.path),t=(0,A.$sc)(I),s=(0,P.watch)(I);i.add((0,T.$Xc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${I}'`);const r=new Set;if($)try{for(const u of await g.Promises.readdir(I))r.add(u)}catch(u){this.O(u)}if(h.token.isCancellationRequested)return;const o=new Map;i.add((0,T.$Xc)(()=>{for(const[,u]of o)u.dispose();o.clear()})),s.on("error",(u,y)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${I} for changes using fs.watch() (${u}, ${y})`),this.D())}),s.on("change",(u,y)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${u}"] ${y}`);let O="";if(y&&(O=y.toString(),b.$m&&(O=(0,C.$sm)(O))),!(!O||u!=="change"&&u!=="rename"))if($)if(u==="rename"){o.get(O)?.dispose();const S=setTimeout(async()=>{if(o.delete(O),O===t&&!await g.Promises.exists(I)){this.J(n);return}if(h.token.isCancellationRequested)return;const v=await this.N((0,A.$oc)(I,O));if(h.token.isCancellationRequested)return;let N;v?r.has(O)?N=l.FileChangeType.UPDATED:(N=l.FileChangeType.ADDED,r.add(O)):(r.delete(O),N=l.FileChangeType.DELETED),this.L({resource:(0,R.$lh)(n,O),type:N,cId:this.s.correlationId})},E.a);o.set(O,(0,T.$Xc)(()=>clearTimeout(S)))}else{let S;r.has(O)?S=l.FileChangeType.UPDATED:(S=l.FileChangeType.ADDED,r.add(O)),this.L({resource:(0,R.$lh)(n,O),type:S,cId:this.s.correlationId})}else if(u==="rename"||O!==t){const S=setTimeout(async()=>{const v=await g.Promises.exists(I);h.token.isCancellationRequested||(v?(this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(I,!1))):this.J(n))},E.a);i.clear(),i.add((0,T.$Xc)(()=>clearTimeout(S)))}else this.L({resource:n,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(n){h.token.isCancellationRequested||this.O(`Failed to watch ${I} for changes using fs.watch() (${n.toString()})`),this.D()}}J(I){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:I,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(I,$=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${I.type===l.FileChangeType.ADDED?"[ADDED]":I.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`),!$&&this.g.some(c=>c(I.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${I.resource.fsPath}`):!$&&this.h&&this.h.length>0&&!this.h.some(c=>c(I.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${I.resource.fsPath}`):this.f.work(I))}M(I){const $=(0,f.$fr)(I),c=[];for(const i of $){if((0,f.$ir)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}c.push(i)}if(c.length===0)return;if(this.z)for(const i of c)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(I){if(b.$n)return g.Promises.exists(I);try{const $=(0,A.$sc)(I);return(await g.Promises.readdir((0,A.$rc)(I))).some(h=>h===$)}catch($){return this.Q($),!1}}setVerboseLogging(I){this.z=I}O(I){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${I}`})}P(I){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${I}`})}Q(I){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${I}`})}R(I){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${I}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$xr=E;async function w(d,I,$,c,h=512){const i=await g.Promises.open(d,"r"),n=Buffer.allocUnsafe(h),t=new L.$Be(c);let s,r=!1;const o={path:d,excludes:[],recursive:!1},u=new E(o,void 0,y=>{(async()=>{for(const{type:O}of y)if(O===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:S}=await g.Promises.read(i,n,0,h,null);if(!S||t.token.isCancellationRequested)break;I(n.slice(0,S))}}catch(S){s=new Error(S),t.dispose(!0)}finally{r=!1}}})()});return await u.ready,$(),new Promise((y,O)=>{t.token.onCancellationRequested(async()=>{u.dispose();try{await g.Promises.close(i)}catch(S){s=new Error(S)}s?O(s):y()})})}}),define(fe[169],de([0,1,3,95,167,5,168,42]),function(ce,e,P,a,L,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class A extends L.$sr{constructor(R){super(),this.O=R,this.onDidError=P.Event.None,this.watchers=new Set}async N(R){R=this.Z(R);const p=[],m=new Set(Array.from(this.watchers));for(const g of R){const l=this.W(g);l&&(0,a.$Jk)(l.request.excludes,g.excludes)&&(0,a.$Jk)(l.request.includes,g.includes)?m.delete(l):p.push(g)}p.length&&this.P(`Request to start watching: ${p.map(g=>this.M(g)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(g=>this.M(g.request)).join(",")}`);for(const g of m)this.Y(g);for(const g of p)this.X(g)}W(R){for(const p of this.watchers)if(typeof R.correlationId=="number"||typeof p.request.correlationId=="number"){if(p.request.correlationId===R.correlationId)return p}else if((0,C.$Ig)(p.request.path,R.path,!k.$n))return p}X(R){const p=new T.$xr(R,this.O,g=>this.a.fire(g),()=>this.c.fire(R),g=>this.b.fire(g),this.R),m={request:R,instance:p};this.watchers.add(m)}async stop(){await super.stop();for(const R of this.watchers)this.Y(R)}Y(R){this.P("stopping file watcher",R),this.watchers.delete(R),R.instance.dispose()}Z(R){const p=new Map;for(const m of R){const g=k.$n?m.path:m.path.toLowerCase();let l=p.get(m.correlationId);l||(l=new Map,p.set(m.correlationId,l)),l.has(g)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(m)}`),l.set(g,m)}return Array.from(p.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(R){super.setVerboseLogging(R);for(const p of this.watchers)p.instance.setVerboseLogging(R)}P(R,p){this.R&&this.b.fire({type:"trace",message:this.bb(R,p)})}Q(R){this.b.fire({type:"warn",message:this.bb(R)})}bb(R,p){return p?`[File Watcher (node.js)] ${R} (${this.M(p.request)})`:`[File Watcher (node.js)] ${R}`}}e.$zr=A}),define(fe[170],de([0,1,46,169]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class L extends P.$cr{constructor(T,C,A){super(T,C,A),this.s()}r(T){return T.add(new a.$zr(void 0))}}e.$Ar=L}),define(fe[171],de([0,1,22,43,97,46]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class T extends k.$dr{constructor(A,b,R){super(A,b,R),this.s()}r(A){const b=A.add(new L.$qr(P.$5g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return A.add(b.onDidProcessExit(({code:R,signal:p})=>this.t(`terminated by itself with code ${R}, signal: ${p} (ETERM)`))),a.ProxyChannel.toService((0,a.$ri)(b.getChannel("watcher")))}}e.$rr=T}),define(fe[77],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class P{constructor(...L){this.a=new Map;for(const[k,T]of L)this.set(k,T)}set(L,k){const T=this.a.get(L);return this.a.set(L,k),T}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$Ii=P}),define(fe[172],de([0,1,6,8,2,74,163,4,77,90]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;const R=!1;class p extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class m{constructor(E=new A.$Ii,w=!1,d,I=R){this.i=E,this.j=w,this.k=d,this.l=I,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(C.$Ji,this),this._globalGraph=I?d?._globalGraph??new T.$Dr($=>$):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Uc)(this.h),this.h.clear();for(const E of this.g)(0,L.$Tc)(E)&&E.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(E,w){this.m();const d=this,I=new class extends m{dispose(){d.h.delete(I),super.dispose()}}(E,this.j,this,this.l);return this.h.add(I),w?.add(I),I}invokeFunction(E,...w){this.m();const d=l.traceInvocation(this.l,E);let I=!1;try{return E({get:c=>{if(I)throw(0,a.$_)("service accessor is only valid during the invocation of its target method");const h=this.s(c,d);if(!h)throw new Error(`[invokeFunction] unknown service '${c}'`);return h}},...w)}finally{I=!0,d.stop()}}createInstance(E,...w){this.m();let d,I;return E instanceof k.$Hi?(d=l.traceCreation(this.l,E.ctor),I=this.o(E.ctor,E.staticArguments.concat(w),d)):(d=l.traceCreation(this.l,E),I=this.o(E,w,d)),d.stop(),I}o(E,w=[],d){const I=C._util.getServiceDependencies(E).sort((h,i)=>h.index-i.index),$=[];for(const h of I){const i=this.s(h.id,d);i||this.y(`[createInstance] ${E.name} depends on UNKNOWN service ${h.id}.`,!1),$.push(i)}const c=I.length>0?I[0].index:w.length;if(w.length!==c){console.trace(`[createInstance] First service dependency of ${E.name} at position ${c+1} conflicts with ${w.length} static arguments`);const h=c-w.length;h>0?w=w.concat(new Array(h)):w=w.slice(0,c)}return Reflect.construct(E,w.concat($))}q(E,w){if(this.i.get(E)instanceof k.$Hi)this.i.set(E,w);else if(this.k)this.k.q(E,w);else throw new Error("illegalState - setting UNKNOWN service instance")}r(E){const w=this.i.get(E);return!w&&this.k?this.k.r(E):w}s(E,w){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const d=this.r(E);return d instanceof k.$Hi?this.u(E,d,w.branch(E,!0)):(w.branch(E,!1),d)}u(E,w,d){if(this.t.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.t.add(E);try{return this.v(E,w,d)}finally{this.t.delete(E)}}v(E,w,d){const I=new T.$Dr(i=>i.id.toString());let $=0;const c=[{id:E,desc:w,_trace:d}],h=new Set;for(;c.length;){const i=c.pop();if(!h.has(String(i.id))){if(h.add(String(i.id)),I.lookupOrInsertNode(i),$++>1e3)throw new p(I);for(const n of C._util.getServiceDependencies(i.desc.ctor)){const t=this.r(n.id);if(t||this.y(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof k.$Hi){const s={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};I.insertEdge(i,s),c.push(s)}}}}for(;;){const i=I.roots();if(i.length===0){if(!I.isEmpty())throw new p(I);break}for(const{data:n}of i){if(this.r(n.id)instanceof k.$Hi){const s=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,s)}I.removeNode(n)}}return this.r(E)}w(E,w,d=[],I,$){if(this.i.get(E)instanceof k.$Hi)return this.x(E,w,d,I,$,this.g);if(this.k)return this.k.w(E,w,d,I,$);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}x(E,w,d=[],I,$,c){if(I){const h=new m(void 0,this.j,this,this.l);h.c=String(E);const i=new Map,n=new P.$4h(()=>{const t=h.o(w,d,$);for(const[s,r]of i){const o=t[s];if(typeof o=="function")for(const u of r)u.disposable=o.apply(t,u.listener)}return i.clear(),c.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!n.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let u=i.get(s);return u||(u=new b.$0c,i.set(s,u)),(O,S,v)=>{if(n.isInitialized)return n.value[s](O,S,v);{const N={listener:[O,S,v],disposable:void 0},F=u.push(N);return(0,L.$Xc)(()=>{F(),N.disposable?.dispose()})}}}if(s in t)return t[s];const r=n.value;let o=r[s];return typeof o!="function"||(o=o.bind(r),t[s]=o),o},set(t,s,r){return n.value[s]=r,!0},getPrototypeOf(t){return w.prototype}})}else{const h=this.o(w,d,$);return c.add(h),h}}y(E,w){if(w&&console.warn(E),this.j)throw new Error(E)}}e.$Er=m;var g;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(g||(g={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(g.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,w){return E?new l(g.Invocation,w.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(E,w){return E?new l(g.Creation,w.name):l.c}static{this.f=0}constructor(E,w){this.type=E,this.name=w,this.g=Date.now(),this.h=[]}branch(E,w){const d=new l(g.Branch,E.toString());return this.h.push([E,w,d]),d}stop(){const E=Date.now()-this.g;l.f+=E;let w=!1;function d($,c){const h=[],i=new Array($+1).join("	");for(const[n,t,s]of c.h)if(t&&s){w=!0,h.push(`${i}CREATES -> ${n}`);const r=d($+1,s);r&&h.push(r)}else h.push(`${i}uses -> ${n}`);return h.join(`
`)}const I=[`${this.type===g.Creation?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(E>2||w)&&l.all.add(I.join(`
`))}}e.$Fr=l}),define(fe[56],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=e.$_ic=void 0,e.$_ic=(0,P.$Ki)("mainProcessService");class a{constructor(k,T){this.a=k,this.b=T}getChannel(k){return this.a.getChannel(k,this.b)}registerChannel(k,T){this.a.registerChannel(k,T)}}e.$ajc=a}),define(fe[11],de([0,1,9,41,3,55,2,31,5,20,12,10,98,4]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=f,e.log=w,e.$tk=o,e.$uk=u,e.$vk=y,e.$wk=O,P=Oe(P),e.$fk=(0,g.$Ki)("logService"),e.$gk=(0,g.$Ki)("loggerService");function l(){return new Date().toISOString()}function f(S){return(0,R.$ng)(S)}var E;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$ik=E.Info;function w(S,v,N){switch(v){case E.Trace:S.trace(N);break;case E.Debug:S.debug(N);break;case E.Info:S.info(N);break;case E.Warning:S.warn(N);break;case E.Error:S.error(N);break;case E.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function d(S,v=!1){let N="";for(let F=0;F<S.length;F++){let U=S[F];if(U instanceof Error&&(U=(0,a.$vj)(U,v)),typeof U=="object")try{U=JSON.stringify(U)}catch{}N+=(F>0?" ":"")+U}return N}class I extends T.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new L.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==E.Off&&this.b<=v}}e.$kk=I;class $ extends I{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...N){this.f(E.Trace)&&this.g(E.Trace,d([v,...N],!0))}debug(v,...N){this.f(E.Debug)&&this.g(E.Debug,d([v,...N]))}info(v,...N){this.f(E.Info)&&this.g(E.Info,d([v,...N]))}warn(v,...N){this.f(E.Warning)&&this.g(E.Warning,d([v,...N]))}error(v,...N){if(this.f(E.Error))if(v instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=v.stack,this.g(E.Error,d(F))}else this.g(E.Error,d([v,...N]))}flush(){}}e.$lk=$;class c extends I{constructor(v=e.$ik){super(),this.setLevel(v),this.g=!A.$l}trace(v,...N){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...N):console.log(`[main ${l()}]`,v,...N))}debug(v,...N){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...N):console.log(`[main ${l()}]`,v,...N))}info(v,...N){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,v,...N):console.log(`[main ${l()}]`,v,...N))}warn(v,...N){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,v,...N):console.warn(`[main ${l()}]`,v,...N))}error(v,...N){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,v,...N):console.error(`[main ${l()}]`,v,...N))}flush(){}}e.$mk=c;class h extends I{constructor(v=e.$ik,N=!0){super(),this.g=N,this.setLevel(v)}trace(v,...N){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...N):console.log(v,...N))}debug(v,...N){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...N):console.log(v,...N))}info(v,...N){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...N):console.log(v,...N))}warn(v,...N){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...N):console.log(v,...N))}error(v,...N){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...N):console.error(v,...N))}flush(){}}e.$nk=h;class i extends I{constructor(v,N=e.$ik){super(),this.g=v,this.setLevel(N)}trace(v,...N){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(v),...N])}debug(v,...N){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(v),...N])}info(v,...N){this.f(E.Info)&&this.g.log(E.Info,[this.h(v),...N])}warn(v,...N){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(v),...N])}error(v,...N){this.f(E.Error)&&this.g.log(E.Error,[this.h(v),...N])}h(v){return typeof v=="string"?v:(0,a.$vj)(v,this.f(E.Trace))}flush(){}}e.$ok=i;class n extends I{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const N of this.g)N.setLevel(v);super.setLevel(v)}trace(v,...N){for(const F of this.g)F.trace(v,...N)}debug(v,...N){for(const F of this.g)F.debug(v,...N)}info(v,...N){for(const F of this.g)F.info(v,...N)}warn(v,...N){for(const F of this.g)F.warn(v,...N)}error(v,...N){for(const F of this.g)F.error(v,...N)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$pk=n;class t extends T.$Zc{constructor(v,N,F){if(super(),this.h=v,this.j=N,this.b=new C.$Fc,this.c=this.B(new L.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$qe),this.onDidChangeVisibility=this.g.event,F)for(const U of F)this.b.set(U.resource,{logger:void 0,info:U})}m(v){return(0,R.$jg)(v)?[...this.b.values()].find(N=>N.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,N){const F=this.n(v),U=(0,R.$jg)(v)?v:N?.id??(0,k.$yj)(F.toString()).toString(16);let j=this.b.get(F)?.logger;const G=N?.logLevel==="always"?E.Trace:N?.logLevel;j||(j=this.s(F,G??this.getLogLevel(F)??this.h,{...N,id:U}));const W={logger:j,info:{resource:F,id:U,logLevel:G,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(W.info),this.b.set(F,W),j}n(v){return(0,R.$jg)(v)?(0,b.$lh)(this.j,`${v}.log`):v}setLogLevel(v,N){if(p.URI.isUri(v)){const F=v,U=N,j=this.b.get(F);j&&U!==j.info.logLevel&&(j.info.logLevel=U===this.h?void 0:U,j.logger?.setLevel(U),this.b.set(j.info.resource,j),this.f.fire([F,U]))}else{this.h=v;for(const[F,U]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,N){const F=this.m(v);F&&N!==!F.info.hidden&&(F.info.hidden=!N,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,N]))}getLogLevel(v){let N;return v&&(N=this.b.get(v)?.info.logLevel),N??this.h}registerLogger(v){const N=this.b.get(v.resource);N?N.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const N=this.b.get(v);N&&(N.logger&&N.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=t;class s{constructor(){this.onDidChangeLogLevel=new L.$qe().event}setLevel(v){}getLevel(){return E.Info}trace(v,...N){}debug(v,...N){}info(v,...N){}warn(v,...N){}error(v,...N){}critical(v,...N){}dispose(){}flush(){}}e.$rk=s;class r extends s{}e.$sk=r;function o(S){if(S.verbose)return E.Trace;if(typeof S.logLevel=="string"){const v=O(S.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ik}function u(S){switch(S){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function y(S){switch(S){case E.Trace:return{original:"Trace",value:P.localize(1959,null)};case E.Debug:return{original:"Debug",value:P.localize(1960,null)};case E.Info:return{original:"Info",value:P.localize(1961,null)};case E.Warning:return{original:"Warning",value:P.localize(1962,null)};case E.Error:return{original:"Error",value:P.localize(1963,null)};case E.Off:return{original:"Off",value:P.localize(1964,null)}}}function O(S){switch(S){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$xk=new m.$2j("logLevel",u(E.Info))}),define(fe[173],de([0,1,6,8,2,22,13,20,30,15,11]),function(ce,e,P,a,L,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;let p=class extends L.$Zc{constructor(g,l){super(),this.a=g,this.b=l,this.B(new P.$Wh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const g=(0,C.$ih)(this.a.logsHome),l=(0,C.$kh)(this.a.logsHome.with({scheme:k.Schemas.file})).fsPath,w=(await A.Promises.readdir(l)).filter(I=>/^\d{8}T\d{6}$/.test(I)).sort().filter(I=>I!==g),d=w.slice(0,Math.max(0,w.length-9));d.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(I=>A.Promises.rm((0,T.$oc)(l,I)))))}catch(g){(0,a.$4)(g)}}};e.$tjc=p,e.$tjc=p=Ee([Y(0,b.$Ri),Y(1,R.$fk)],p)}),define(fe[174],de([0,1,17,6,8,3,42,2,13,46,11]),function(ce,e,P,a,L,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class p extends C.$Zc{constructor(g,l){super(),this.a=g,this.b=l,this.c=this.B(new k.$qe),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$qe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$Ih(0)),this.w=[],this.y=this.B(new a.$Ih(0))}watch(g,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(g,l):this.z(g,l)}n(g,l){const f={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},E=(0,P.$Xb)(this.j,f);return this.r(),(0,C.$Xc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,L.$4)(g))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,b.$er)(l)),l=>this.G(l),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const l of this.j)(0,b.$ar)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const l of this.j)(0,b.$ar)(l)&&g.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,l){const f={path:this.J(g),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},E=(0,P.$Xb)(this.w,f);return this.C(),(0,C.$Xc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,L.$4)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,b.$er)(g)),g=>this.G(g),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.H(g)}H(g){this.a[g.type](g.message)}I(g){return(0,A.$mc)(g.fsPath)}J(g){const l=this.I(g);return(0,T.$Mg)(l)}}e.$kr=p}),define(fe[175],de([0,1,17,6,14,25,3,55,63,2,51,22,102,20,50,9,7,101,11,8]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let c=class extends b.$Zc{static{$=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$qe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$qe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$qe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$qe),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$qe),this.Y=this.B(new T.$qe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$qe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new a.$Th)}registerProvider(i,n){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const t=new b.$Yc;return this.h.set(i,n),this.c.fire({added:!0,scheme:i,provider:n}),t.add(n.onDidChangeFile(s=>{const r=new E.$yl(s,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&t.add(n.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:i}))),(0,b.$Xc)(()=>{this.c.fire({added:!1,scheme:i,provider:n}),this.h.delete(i),(0,b.$Uc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const n=[];this.f.fire({scheme:i,join(t){n.push(t)}}),!this.h.has(i)&&await a.Promises.settled(n)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,n){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return A.Iterable.map(this.h,([i,n])=>({scheme:i,capabilities:n.capabilities}))}async j(i){if(!(0,g.$ph)(i))throw new E.$Al((0,f.localize)(1871,null,this.sb(i)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const n=this.h.get(i.scheme);if(!n){const t=new I.$fb;throw t.message=(0,f.localize)(1872,null,i.toString()),t}return n}async m(i){const n=await this.j(i);if((0,E.$ll)(n)||(0,E.$il)(n)||(0,E.$ml)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const n=await this.j(i);if((0,E.$ll)(n)||(0,E.$il)(n))return n;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,n){try{return await this.s(i,n)}catch(t){throw(0,E.$vl)(t)===E.FileSystemProviderErrorCode.FileNotFound?new E.$Al((0,f.localize)(1873,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.$tl)(t)}}async s(i,n){const t=await this.j(i),s=this.S(t),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,u=n?.resolveMetadata,y=await t.stat(i);let O;return this.t(t,i,y,void 0,!!u,(S,v)=>(O||(O=R.$Qi.forUris(()=>!s),O.set(i,!0),r&&O.fill(!0,r)),O.get(S.resource)||O.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?v===1:!1))}async t(i,n,t,s,r,o){const{providerExtUri:u}=this.R(i),y={resource:n,name:u.basename(n),isFile:(t.type&E.FileType.File)!==0,isDirectory:(t.type&E.FileType.Directory)!==0,isSymbolicLink:(t.type&E.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&E.FilePermission.Readonly)||!!(i.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&E.FilePermission.Locked),etag:(0,E.$Ll)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&o(y,s)){try{const O=await i.readdir(n),S=await a.Promises.settled(O.map(async([v,N])=>{try{const F=u.joinPath(n,v),U=r?await i.stat(F):{type:N};return await this.t(i,F,U,O.length,r,o)}catch(F){return this.b.trace(F),null}}));y.children=(0,P.$Lb)(S)}catch(O){this.b.trace(O),y.children=[]}return y}return y}async resolveAll(i){return a.Promises.settled(i.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const n=await this.j(i),t=await n.stat(i);return this.t(n,i,t,void 0,!0,()=>!1)}async exists(i){const n=await this.j(i);try{return!!await n.stat(i)}catch{return!1}}async canCreateFile(i,n){try{await this.u(i,n)}catch(t){return t}return!0}async u(i,n){if(!n?.overwrite&&await this.exists(i))throw new E.$Al((0,f.localize)(1874,null,this.sb(i)),E.FileOperationResult.FILE_MODIFIED_SINCE,n)}async createFile(i,n=L.$Se.fromString(""),t){await this.u(i,t);const s=await this.writeFile(i,n);return this.r.fire(new E.$xl(i,E.FileOperation.CREATE,s)),s}async writeFile(i,n,t){const s=this.qb(await this.n(i),i),{providerExtUri:r}=this.R(s);let o=t;if((0,E.$ol)(s)&&!o?.atomic){const u=s.enforceAtomicWriteFile?.(i);u&&(o={...t,atomic:u})}try{await this.w(s,i,o)||await this.U(s,r.dirname(i));let y;if((0,E.$il)(s)&&!(n instanceof L.$Se))if((0,l.$Ee)(n)){const O=await(0,l.$Le)(n,3);O.ended?y=L.$Se.concat(O.buffer):y=O}else y=(0,l.$Ie)(n,O=>L.$Se.concat(O),3);else y=n;!(0,E.$ll)(s)||(0,E.$il)(s)&&y instanceof L.$Se||(0,E.$il)(s)&&(0,E.$ol)(s)&&o?.atomic?await this.hb(s,i,o,y):await this.db(s,i,o,y instanceof L.$Se?(0,L.$4e)(y):y),this.r.fire(new E.$xl(i,E.FileOperation.WRITE))}catch(u){throw new E.$Al((0,f.localize)(1875,null,this.sb(i),(0,E.$tl)(u).toString()),(0,E.$wl)(u),o)}return this.resolve(i,{resolveMetadata:!0})}async w(i,n,t){const s=!!t?.unlock;if(s&&!(i.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,f.localize)(1876,null,this.sb(n)));if(!!t?.atomic){if(!(i.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,f.localize)(1877,null,this.sb(n)));if(!(i.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,f.localize)(1878,null,this.sb(n)));if(s)throw new Error((0,f.localize)(1879,null,this.sb(n)))}let o;try{o=await i.stat(n)}catch{return}if(o.type&E.FileType.Directory)throw new E.$Al((0,f.localize)(1880,null,this.sb(n)),E.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(n,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==E.$Kl&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,E.$Ll)({mtime:t.mtime,size:o.size}))throw new E.$Al((0,f.localize)(1881,null),E.FileOperationResult.FILE_MODIFIED_SINCE,t);return o}async readFile(i,n,t){const s=await this.m(i);return n?.atomic?this.z(s,i,n,t):this.C(s,i,n,t)}async z(i,n,t,s){return new Promise((r,o)=>{this.cb.queueFor(n,async()=>{try{const u=await this.C(i,n,t,s);r(u)}catch(u){o(u)}},this.R(i).providerExtUri)})}async C(i,n,t,s){const r=await this.D(i,n,{...t,preferUnbuffered:!0},s);return{...r,value:await(0,L.$5e)(r.value)}}async readFileStream(i,n,t){const s=await this.m(i);return this.D(s,i,n,t)}async D(i,n,t,s){const r=new k.$Be(s);let o=t;(0,E.$nl)(i)&&i.enforceAtomicReadFile?.(n)&&(o={...t,atomic:!0});const u=this.J(n,o).then(O=>O,O=>{throw r.dispose(!0),O});let y;try{return typeof o?.etag=="string"&&o.etag!==E.$Kl&&await u,o?.atomic&&(0,E.$nl)(i)||!((0,E.$ll)(i)||(0,E.$ml)(i))||(0,E.$il)(i)&&o?.preferUnbuffered?y=this.I(i,n,o):(0,E.$ml)(i)?y=this.G(i,n,r.token,o):y=this.H(i,n,r.token,o),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await u,value:y}}catch(O){throw y&&await(0,l.$Je)(y),this.F(O,n,o)}}F(i,n,t){const s=(0,f.localize)(1882,null,this.sb(n),(0,E.$tl)(i).toString());return i instanceof E.$Cl?new E.$Cl(s,i.stat,t):i instanceof E.$Bl?new E.$Bl(s,i.fileOperationResult,i.size,i.options):new E.$Al(s,(0,E.$wl)(i),t)}G(i,n,t,s=Object.create(null)){const r=i.readFileStream(n,s,t);return(0,l.$Pe)(r,{data:o=>o instanceof L.$Se?o:L.$Se.wrap(o),error:o=>this.F(o,n,s)},o=>L.$Se.concat(o))}H(i,n,t,s=Object.create(null)){const r=(0,L.$9e)();return(0,w.$0q)(i,n,r,o=>o,{...s,bufferSize:this.a,errorTransformer:o=>this.F(o,n,s)},t),r}I(i,n,t){const s=(0,l.$Ge)(r=>L.$Se.concat(r));return(async()=>{try{let r;t?.atomic&&(0,E.$nl)(i)?r=await i.readFile(n,{atomic:!0}):r=await i.readFile(n),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(n,r.byteLength,t),s.end(L.$Se.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async J(i,n){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new E.$Al((0,f.localize)(1883,null,this.sb(i)),E.FileOperationResult.FILE_IS_DIRECTORY,n);if(typeof n?.etag=="string"&&n.etag!==E.$Kl&&n.etag===t.etag)throw new E.$Cl((0,f.localize)(1884,null),t,n);return this.L(i,t.size,n),t}L(i,n,t){if(typeof t?.limits?.size=="number"&&n>t.limits.size)throw new E.$Bl((0,f.localize)(1885,null,this.sb(i)),E.FileOperationResult.FILE_TOO_LARGE,n,t)}async canMove(i,n,t){return this.M(i,n,"move",t)}async canCopy(i,n,t){return this.M(i,n,"copy",t)}async M(i,n,t,s){if(i.toString()!==n.toString())try{const r=t==="move"?this.qb(await this.n(i),i):await this.m(i),o=this.qb(await this.n(n),n);await this.Q(r,i,o,n,t,s)}catch(r){return r}return!0}async move(i,n,t){const s=this.qb(await this.n(i),i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"move",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$xl(i,o==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,u)),u}async copy(i,n,t){const s=await this.m(i),r=this.qb(await this.n(n),n),o=await this.N(s,i,r,n,"copy",!!t),u=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$xl(i,o==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,u)),u}async N(i,n,t,s,r,o){if(n.toString()===s.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:y}=await this.Q(i,n,t,s,r,o);if(u&&!y&&o&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),r==="copy"){if(i===t&&(0,E.$jl)(i))await i.copy(n,s,{overwrite:o});else{const O=await this.resolve(n);O.isDirectory?await this.P(i,O,t,s):await this.O(i,n,t,s)}return r}else return i===t?(await i.rename(n,s,{overwrite:o}),r):(await this.N(i,n,t,s,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(i,n,t,s){if((0,E.$ll)(i)&&(0,E.$ll)(t))return this.jb(i,n,t,s);if((0,E.$ll)(i)&&(0,E.$il)(t))return this.pb(i,n,t,s);if((0,E.$il)(i)&&(0,E.$ll)(t))return this.nb(i,n,t,s);if((0,E.$il)(i)&&(0,E.$il)(t))return this.lb(i,n,t,s)}async P(i,n,t,s){await t.mkdir(s),Array.isArray(n.children)&&await a.Promises.settled(n.children.map(async r=>{const o=this.R(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.P(i,await this.resolve(r.resource),t,o):this.O(i,r.resource,t,o)}))}async Q(i,n,t,s,r,o){let u=!1;if(i===t){const{providerExtUri:O,isPathCaseSensitive:S}=this.R(i);if(S||(u=O.isEqual(n,s)),u&&r==="copy")throw new Error((0,f.localize)(1886,null,this.sb(n),this.sb(s)));if(!u&&O.isEqualOrParent(s,n))throw new Error((0,f.localize)(1887,null,this.sb(n),this.sb(s)))}const y=await this.exists(s);if(y&&!u){if(!o)throw new E.$Al((0,f.localize)(1888,null,this.sb(n),this.sb(s)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:O}=this.R(i);if(O.isEqualOrParent(n,s))throw new Error((0,f.localize)(1889,null,this.sb(n),this.sb(s)))}}return{exists:y,isSameResourceWithDifferentPathCase:u}}R(i){const n=this.S(i);return{providerExtUri:n?g.$bh:g.$dh,isPathCaseSensitive:n}}S(i){return!!(i.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const n=this.qb(await this.j(i),i);await this.U(n,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new E.$xl(i,E.FileOperation.CREATE,t)),t}async U(i,n){const t=[],{providerExtUri:s}=this.R(i);for(;!s.isEqual(n,s.dirname(n));)try{if(!((await i.stat(n)).type&E.FileType.Directory))throw new Error((0,f.localize)(1890,null,this.sb(n)));break}catch(r){if((0,E.$vl)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(n)),n=s.dirname(n)}for(let r=t.length-1;r>=0;r--){n=s.joinPath(n,t[r]);try{await i.mkdir(n)}catch(o){if((0,E.$vl)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(i,n){try{await this.W(i,n)}catch(t){return t}return!0}async W(i,n){const t=this.qb(await this.j(i),i),s=!!n?.useTrash;if(s&&!(t.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,f.localize)(1891,null,this.sb(i)));const r=n?.atomic;if(r&&!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,f.localize)(1892,null,this.sb(i)));if(s&&r)throw new Error((0,f.localize)(1893,null,this.sb(i)));let o;try{o=await t.stat(i)}catch{}if(o)this.rb(i,o);else throw new E.$Al((0,f.localize)(1894,null,this.sb(i)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!n?.recursive){const y=await this.resolve(i);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,f.localize)(1895,null,this.sb(i)))}return t}async del(i,n){const t=await this.W(i,n);let s=n;if((0,E.$pl)(t)&&!s?.atomic){const y=t.enforceAtomicDelete?.(i);y&&(s={...n,atomic:y})}const r=!!s?.useTrash,o=!!s?.recursive,u=s?.atomic??!1;await t.delete(i,{recursive:o,useTrash:r,atomic:u}),this.r.fire(new E.$xl(i,E.FileOperation.DELETE))}async cloneFile(i,n){const t=await this.j(i),s=this.qb(await this.n(n),n);if(!(t===s&&this.R(t).providerExtUri.isEqual(i,n)))return t===s&&(0,E.$kl)(t)?t.cloneFile(i,n):(await this.U(s,this.R(s).providerExtUri.dirname(n)),t===s&&(0,E.$jl)(t)?this.cb.queueFor(i,()=>t.copy(i,n,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,s,n),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,n){return this.watch(i,{...n,correlationId:$.ab++})}watch(i,n={recursive:!1,excludes:[]}){const t=new b.$Yc;let s=!1,r=()=>{s=!0};t.add((0,b.$Xc)(()=>r())),(async()=>{try{const u=await this.bb(i,n);s?(0,b.$Uc)(u):r=()=>(0,b.$Uc)(u)}catch(u){this.b.error(u)}})();const o=n.correlationId;if(typeof o=="number"){const u=t.add(new T.$qe);return t.add(this.X.event(O=>{O.correlates(o)&&u.fire(O)})),{onDidChange:u.event,dispose:()=>t.dispose()}}return t}async bb(i,n){const t=await this.j(i),s=(0,C.$yj)([this.R(t).providerExtUri.getComparisonKey(i),n]);let r=this.$.get(s);return r||(r={count:0,disposable:t.watch(i,n)},this.$.set(s,r)),r.count+=1,(0,b.$Xc)(()=>{r&&(r.count--,r.count===0&&((0,b.$Uc)(r.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,b.$Uc)(i.disposable);this.$.clear()}async db(i,n,t,s){return this.cb.queueFor(n,async()=>{const r=await i.open(n,{create:!0,unlock:t?.unlock??!1});try{(0,l.$Ee)(s)||(0,l.$Fe)(s)?await this.eb(i,r,s):await this.fb(i,r,s)}catch(o){throw(0,E.$tl)(o)}finally{await i.close(r)}},this.R(i).providerExtUri)}async eb(i,n,t){let s=0,r;if((0,l.$Fe)(t)){if(t.buffer.length>0){const o=L.$Se.concat(t.buffer);await this.gb(i,n,o,o.byteLength,s,0),s+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((o,u)=>{(0,l.$Ke)(r,{onData:async y=>{r.pause();try{await this.gb(i,n,y,y.byteLength,s,0)}catch(O){return u(O)}s+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>u(y),onEnd:()=>o()})})}async fb(i,n,t){let s=0,r;for(;(r=t.read())!==null;)await this.gb(i,n,r,r.byteLength,s,0),s+=r.byteLength}async gb(i,n,t,s,r,o){let u=0;for(;u<s;){const y=await i.write(n,r+u,t.buffer,o+u,s-u);u+=y}}async hb(i,n,t,s){return this.cb.queueFor(n,()=>this.ib(i,n,t,s),this.R(i).providerExtUri)}async ib(i,n,t,s){let r;s instanceof L.$Se?r=s:(0,l.$Ee)(s)?r=await(0,L.$5e)(s):(0,l.$Fe)(s)?r=await(0,L.$6e)(s):r=(0,L.$3e)(s),await i.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,n,t,s){return this.cb.queueFor(s,()=>this.kb(i,n,t,s),this.R(t).providerExtUri)}async kb(i,n,t,s){let r,o;try{r=await i.open(n,{create:!1}),o=await t.open(s,{create:!0,unlock:!1});const u=L.$Se.alloc(this.a);let y=0,O=0,S=0;do S=await i.read(r,y,u.buffer,O,u.byteLength-O),await this.gb(t,o,u,S,y,O),y+=S,O+=S,O===u.byteLength&&(O=0);while(S>0)}catch(u){throw(0,E.$tl)(u)}finally{await a.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async lb(i,n,t,s){return this.cb.queueFor(s,()=>this.mb(i,n,t,s),this.R(t).providerExtUri)}async mb(i,n,t,s){return t.writeFile(s,await i.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,n,t,s){return this.cb.queueFor(s,()=>this.ob(i,n,t,s),this.R(t).providerExtUri)}async ob(i,n,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const o=await i.readFile(n);await this.gb(t,r,L.$Se.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.$tl)(o)}finally{await t.close(r)}}async pb(i,n,t,s){const r=await(0,L.$5e)(this.H(i,n,k.CancellationToken.None));await this.hb(t,s,void 0,r)}qb(i,n){if(i.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.$Al((0,f.localize)(1896,null,this.sb(n)),E.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.$Al((0,f.localize)(1897,null,this.sb(i)),E.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}};e.$$q=c,e.$$q=c=$=Ee([Y(0,d.$fk)],c)}),define(fe[176],de([0,1,33,6,31,14,3,42,2,13,5,20,50,30,9,7,101,174,171,170]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class $ extends w.$kr{static{this.L=!1}constructor(h,i){super(h,i),this.onDidChangeCapabilities=T.Event.None,this.P=new L.$Fc(n=>p.$ch.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=f.FileSystemProviderCapabilities.FileReadWrite|f.FileSystemProviderCapabilities.FileOpenReadWriteClose|f.FileSystemProviderCapabilities.FileReadStream|f.FileSystemProviderCapabilities.FileFolderCopy|f.FileSystemProviderCapabilities.FileWriteUnlock|f.FileSystemProviderCapabilities.FileAtomicRead|f.FileSystemProviderCapabilities.FileAtomicWrite|f.FileSystemProviderCapabilities.FileAtomicDelete|f.FileSystemProviderCapabilities.FileClone,R.$n&&(this.M|=f.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:i,symbolicLink:n}=await g.SymlinkSupport.stat(this.I(h));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:f.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const i=await g.Promises.readdir(this.I(h),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,p.$lh)(h,t.name))).type:s=this.O(t),n.push([t.name,s])}catch(s){this.a.trace(s)}})),n}catch(i){throw this.hb(i)}}O(h,i){let n;return i?.dangling?n=f.FileType.Unknown:h.isFile()?n=f.FileType.File:h.isDirectory()?n=f.FileType.Directory:n=f.FileType.Unknown,i&&(n|=f.FileType.SymbolicLink),n}async Q(h){const i=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const t=new a.$Jh;return this.P.set(h,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,A.$Xc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(h)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(h,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),n=await this.Q(h));const t=this.I(h);return await P.promises.readFile(t)}catch(t){throw this.hb(t)}finally{n?.dispose()}}R(h){$.L&&this.a.trace(h)}readFileStream(h,i,n){const t=(0,m.$Ge)(s=>k.$Se.concat(s.map(r=>k.$Se.wrap(r))).buffer);return(0,E.$0q)(this,h,t,s=>s.buffer,{...i,bufferSize:256*1024},n),t}async writeFile(h,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(h)?this.U(h,(0,p.$lh)((0,p.$kh)(h),`${(0,p.$ih)(h)}${n.atomic.postfix}`),i,n):this.W(h,i,n)}async S(h){try{const i=this.I(h),{symbolicLink:n}=await g.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(h,i,n,t){const s=new A.$Yc;try{s.add(await this.Q(h)),s.add(await this.Q(i)),await this.W(i,n,t,!0);try{await this.rename(i,h,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{s.dispose()}}async W(h,i,n,t){let s;try{const r=this.I(h);if(!n.create||!n.overwrite){if(await g.Promises.exists(r)){if(!n.overwrite)throw(0,f.$sl)((0,l.localize)(1901,null),f.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,f.$sl)((0,l.localize)(1902,null),f.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(h,{create:!0,unlock:n.unlock},t),await this.write(s,0,i,0,i.byteLength)}catch(r){throw await this.ib(h,r)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(h){$.$=h}async open(h,i,n){const t=this.I(h);let s;(0,f.$gl)(i)&&!n&&(s=await this.Q(h));let r;try{if((0,f.$gl)(i)&&i.unlock)try{const{stat:u}=await g.SymlinkSupport.stat(t);u.mode&128||await P.promises.chmod(t,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let o;if((0,f.$gl)(i)){if(R.$l)try{await P.promises.truncate(t,0),o="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}o||(o="w")}else o="r";r=await g.Promises.open(t,o)}catch(o){throw s?.dispose(),(0,f.$gl)(i)?await this.ib(h,o):this.hb(o)}if(this.X.set(r,0),(0,f.$gl)(i)&&this.Z.set(r,h),s){const o=this.Y.get(r);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.Y.set(r,s),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),o.dispose())}return r}async close(h){const i=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&$.$)try{await g.Promises.fdatasync(h)}catch(n){$.configureFlushOnWrite(!1),this.a.error(n)}return await g.Promises.close(h)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(h)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),i.dispose())}}async read(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await g.Promises.read(h,n,t,s,r)).bytesRead}catch(u){throw this.hb(u)}finally{this.bb(h,r,o)}return o}ab(h,i){return i===this.X.get(h)?null:i}bb(h,i,n){const t=this.X.get(h);typeof t=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(h,t+n):this.X.delete(h)))}async write(h,i,n,t,s){return(0,a.$5h)(()=>this.cb(h,i,n,t,s),100,3)}async cb(h,i,n,t,s){const r=this.ab(h,i);let o=null;try{o=(await g.Promises.write(h,n,t,s,r)).bytesWritten}catch(u){throw await this.ib(this.Z.get(h),u)}finally{this.bb(h,r,o)}return o}async mkdir(h){try{await P.promises.mkdir(this.I(h))}catch(i){throw this.hb(i)}}async delete(h,i){try{const n=this.I(h);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,b.$oc)((0,b.$rc)(n),`${(0,b.$sc)(n)}${i.atomic.postfix}`)),await g.Promises.rm(n,g.RimRafMode.MOVE,t)}else try{await P.promises.unlink(n)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:r,symbolicLink:o}=await g.SymlinkSupport.stat(n);s=r.isDirectory()&&!o}catch{}if(s)await P.promises.rmdir(n);else throw t}else throw t}}catch(n){throw this.hb(n)}}async rename(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"move",n.overwrite),await g.Promises.rename(t,s)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1903,null,(0,b.$sc)(t),(0,b.$sc)((0,b.$rc)(s)),r.toString()))),this.hb(r)}}async copy(h,i,n){const t=this.I(h),s=this.I(i);if(t!==s)try{await this.db(h,i,"copy",n.overwrite),await g.Promises.copy(t,s,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(1904,null,(0,b.$sc)(t),(0,b.$sc)((0,b.$rc)(s)),r.toString()))),this.hb(r)}}async db(h,i,n,t){const s=this.I(h),r=this.I(i);let o=!1;if(!!(this.capabilities&f.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,C.$Ig)(s,r,!0)),o){if(n==="copy")throw(0,f.$sl)((0,l.localize)(1905,null),f.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const y=await this.N(h);if(!y)throw(0,f.$sl)((0,l.localize)(1906,null),f.FileSystemProviderErrorCode.FileNotFound);const O=await this.N(i);if(O){if(!t)throw(0,f.$sl)((0,l.localize)(1907,null),f.FileSystemProviderErrorCode.FileExists);y.type&f.FileType.File&&O.type&f.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,i){return this.eb(h,i,!1)}async eb(h,i,n){const t=this.I(h),s=this.I(i),r=!!(this.capabilities&f.FileSystemProviderCapabilities.PathCaseSensitive);if((0,C.$Ig)(t,s,!r))return;const o=new A.$Yc;try{o.add(await this.Q(h)),o.add(await this.Q(i)),n&&await P.promises.mkdir((0,b.$rc)(s),{recursive:!0}),await P.promises.copyFile(t,s)}catch(u){if(u.code==="ENOENT"&&!n)return this.eb(h,i,!0);throw this.hb(u)}finally{o.dispose()}}t(h,i,n){return new d.$rr(t=>h(t),t=>i(t),n)}F(h,i,n){return new I.$Ar(t=>h(t),t=>i(t),n)}hb(h){if(h instanceof f.$rl)return h;let i=h,n;switch(h.code){case"ENOENT":n=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=f.FileSystemProviderErrorCode.Unknown;break;default:n=f.FileSystemProviderErrorCode.Unknown}return(0,f.$sl)(i,n)}async ib(h,i){let n=this.hb(i);if(h&&n.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await g.SymlinkSupport.stat(this.I(h));t.mode&128||(n=(0,f.$sl)(i,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return n}}e.$Br=$}),define(fe[103],de([0,1,3,2,4,11]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=e.$Sjc=void 0,e.$Sjc=(0,L.$Ki)("sharedProcessLifecycleService");let T=class extends a.$Zc{constructor(A){super(),this.b=A,this.a=this.B(new P.$qe),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Tjc=T,e.$Tjc=T=Ee([Y(0,k.$fk)],T)}),define(fe[177],de([0,1,10,3,11,2]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=e.$Cs=e.$Bs=void 0;class T extends L.$qk{constructor(p,m,g,l,f){super(m,g,l),this.r=p,this.t=f,this.B(f.listen("onDidChangeLogLevel",p)(E=>{(0,L.$hk)(E)?super.setLogLevel(E):super.setLogLevel(P.URI.revive(E[0]),E[1])})),this.B(f.listen("onDidChangeVisibility",p)(([E,w])=>super.setVisibility(P.URI.revive(E),w))),this.B(f.listen("onDidChangeLoggers",p)(({added:E,removed:w})=>{for(const d of E)super.registerLogger({...d,resource:P.URI.revive(d.resource)});for(const d of w)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new L.$ok({log:(p,m)=>{this.t.call("consoleLog",[p,m])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,m){super.setLogLevel(p,m),this.t.call("setLogLevel",[p,m])}setVisibility(p,m){super.setVisibility(p,m),this.t.call("setVisibility",[this.n(p),m])}s(p,m,g){return new C(this.t,p,m,g,this.r)}static setLogLevel(p,m,g){return p.call("setLogLevel",[m,g])}}e.$Bs=T;class C extends L.$lk{constructor(p,m,g,l,f){super(l?.logLevel==="always"),this.r=p,this.s=m,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[m,l,f]).then(()=>{this.u(this.n),this.m=!0})}g(p,m){const g=[[p,m]];this.m?this.u(g):this.n.push(...g)}u(p){this.r.call("log",[this.s,p])}}class A{constructor(p,m){this.a=p,this.b=m}listen(p,m){const g=this.b(p);switch(m){case"onDidChangeLoggers":return a.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(f=>this.c(f,g)),removed:[...l.removed].map(f=>this.c(f,g))}));case"onDidChangeVisibility":return a.Event.map(this.a.onDidChangeVisibility,l=>[g.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return a.Event.map(this.a.onDidChangeLogLevel,l=>(0,L.$hk)(l)?l:[g.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${m}`)}async call(p,m,g){const l=this.b(p);switch(m){case"setLogLevel":return(0,L.$hk)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(P.URI.revive(l.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(f=>this.c(f,l)))}throw new Error(`Call not found: ${m}`)}c(p,m){return{...p,resource:m.transformOutgoingURI(p.resource)}}}e.$Cs=A;class b extends k.$Zc{constructor(p,m){super(),m.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(g=>m.call("setLogLevel",[g]))),m.call("getRegisteredLoggers").then(g=>{for(const l of g)p.registerLogger({...l,resource:P.URI.revive(l.resource)})}),this.B(m.listen("onDidChangeVisibility")(([g,l])=>p.setVisibility(P.URI.revive(g),l))),this.B(m.listen("onDidChangeLoggers")(({added:g,removed:l})=>{for(const f of g)p.registerLogger({...f,resource:P.URI.revive(f.resource)});for(const f of l)p.deregisterLogger(f.resource)}))}}e.$Ds=b}),define(fe[178],de([0,1,2,11]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0R=void 0;class L extends P.$Zc{constructor(T,C=[]){super(),this.a=new a.$pk([T,...C]),this.B(T.onDidChangeLogLevel(A=>this.setLevel(A)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...C){this.a.trace(T,...C)}debug(T,...C){this.a.debug(T,...C)}info(T,...C){this.a.info(T,...C)}warn(T,...C){this.a.warn(T,...C)}error(T,...C){this.a.error(T,...C)}flush(){this.a.flush()}}e.$0R=L}),define(fe[57],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0,e.$Thc=(0,P.$Ki)("nativeHostService")}),define(fe[179],de([0,1,43,56]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;let L=class{constructor(T,C){return this.windowId=T,P.ProxyChannel.toService(C.getChannel("nativeHost"),{context:T,properties:(()=>{const A=new Map;return A.set("windowId",T),A})()})}};e.$cjc=L,e.$cjc=L=Ee([Y(1,a.$_ic)],L)}),define(fe[58],de([0,1,3,63,2,4]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=void 0,e.$zo=(0,k.$Ki)("policy");class T extends L.$Zc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$qe),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const R=Object.keys(this.f).length;return this.f={...b,...this.f},R!==Object.keys(this.f).length&&await this.j(b),a.Iterable.reduce(this.g.entries(),(p,[m,g])=>({...p,[m]:g}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return a.Iterable.reduce(Object.entries(this.f),(b,[R,p])=>({...b,[R]:{definition:p,value:this.g.get(R)}}),{})}}e.$Ao=T;class C{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Bo=C}),define(fe[180],de([0,1,3,2,58]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0;class k{constructor(A){this.b=A,this.a=new a.$Yc}listen(A,b){switch(b){case"onDidChange":return P.Event.map(this.b.onDidChange,R=>R.reduce((p,m)=>({...p,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(A,b,R){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(R)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$Fic=k;class T extends L.$Ao{constructor(A,b){super(),this.a=b;for(const R in A){const{definition:p,value:m}=A[R];this.f[R]=p,m!==void 0&&this.g.set(R,m)}this.a.listen("onDidChange")(R=>{for(const p in R){const m=R[p];m===null?this.g.delete(p):this.g.set(p,m)}this.h.fire(Object.keys(R))})}async j(A){const b=await this.a.call("updatePolicyDefinitions",A);for(const R in b)this.g.set(R,b[R])}}e.$Gic=T}),define(fe[104],de([0,1,37]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const k=L.context.configuration();if(k)a=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:k.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(fe[23],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,P.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"}),define(fe[181],de([0,1,33,6,8,2,13,30,11,23]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0,P=Oe(P);let R=class extends k.$Zc{constructor(m,g,l){super(),this.b=g,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this.B(new a.$Wh(()=>{this.f(m)},3e4)).schedule()}async f(m){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),l=(0,T.$rc)(m),f=(0,T.$sc)(m),E=await C.Promises.readdir(l);await Promise.all(E.map(async w=>{if(w===f)return;const d=(0,T.$oc)(l,w),I=await P.promises.stat(d);if(I.isDirectory()&&g-I.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),C.Promises.rm(d)}))}catch(g){(0,L.$4)(g)}}};e.$qjc=R,e.$qjc=R=Ee([Y(1,b.$yk),Y(2,A.$fk)],R)}),define(fe[182],de([0,1,33,6,8,2,13,30,15,11,23]),function(ce,e,P,a,L,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0,P=Oe(P);let p=class extends k.$Zc{constructor(g,l,f){super(),this.b=g,this.c=l,this.f=f,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new a.$Wh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),l=JSON.parse(await P.promises.readFile((0,T.$oc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const I of Object.keys(l)){const $=l[I];g[`${$.hash}.${I}`]=!0}const f=(0,T.$oc)(this.b.userDataPath,"clp");if(!await C.Promises.exists(f))return;const w=await C.Promises.readdir(f);for(const I of w){if(g[I]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${I}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${I}`),await C.Promises.rm((0,T.$oc)(f,I))}const d=Date.now();for(const I of Object.keys(g)){const $=(0,T.$oc)(f,I),c=await C.Promises.readdir($);for(const h of c){if(h==="tcf.json")continue;const i=(0,T.$oc)($,h),n=await P.promises.stat(i);n.isDirectory()&&d-n.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.$oc)(I,h)}`),await C.Promises.rm(i))}}}catch(g){(0,L.$4)(g)}}};e.$rjc=p,e.$rjc=p=Ee([Y(0,A.$Si),Y(1,b.$fk),Y(2,R.$yk)],p)}),define(fe[183],de([0,1,13,4]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$fH=void 0,e.$fH=(0,a.$Ki)("IV8InspectProfilingService");var L;(function(k){function T(A){return!!(A.samples&&A.timeDeltas)}k.isValidProfile=T;function C(A,b="noAbsolutePaths"){for(const R of A.nodes)R.callFrame&&R.callFrame.url&&((0,P.$nc)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(R.callFrame.url))&&(R.callFrame.url=(0,P.$oc)(b,(0,P.$sc)(R.callFrame.url)));return A}k.rewriteAbsolutePaths=C})(L||(e.Utils=L={}))}),define(fe[184],de([0,1,32]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;class a{constructor(){this.a=new Map}async startProfiling(k){const C=await(await new Promise((b,R)=>{ce(["v8-inspect-profiler"],b,R)}).then(Oe)).startProfiling({host:k.host,port:k.port,checkForPaused:!0}),A=(0,P.$7g)();return this.a.set(A,C),A}async stopProfiling(k){const T=this.a.get(k);if(!T)throw new Error(`UNKNOWN session '${k}'`);const C=await T.stop();return this.a.delete(k),C.profile}}e.$Ijc=a}),define(fe[44],de([0,1,133,12]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0,P=Oe(P),a=Oe(a);class L{constructor(){this.a=new Map}add(T,C){P.ok(a.$jg(T)),P.ok(a.$lg(C)),P.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,C)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$xo=new L}),define(fe[105],de([0,1,3,134,44]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=void 0,L=Oe(L),e.$yo={JSONContribution:"base.contributions.json"};function k(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class T{constructor(){this.b=new P.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,R){this.a[k(b)]=R,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(b){const R=this.a[b];return R?(0,a.$ak)(R):void 0}hasSchemaContent(b){return!!this.a[b]}}const C=new T;L.$xo.add(e.$yo.JSONContribution,C)}),define(fe[47],de([0,1,17,3,12,9,21,105,44]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ConfigurationScope=e.$Co=e.EditPresentationTypes=void 0,e.$No=f,e.$Oo=E,e.$Po=w,e.$Qo=I,e.$Ro=$,e.$So=c,e.$To=h,L=Oe(L),k=Oe(k);var b;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$Co={Configuration:"base.contributions.configuration"};var R;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo="vscode://schemas/settings/resourceLanguage",e.$Ko="vscode://schemas/settings/configurationDefaults";const p=A.$xo.as(C.$yo.JSONContribution);class m{constructor(){this.a=[],this.i=new Set,this.j=new a.$qe,this.onDidSchemaChange=this.j.event,this.k=new a.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:k.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},p.registerSchema(e.$Jo,this.h),this.z()}registerConfiguration(n,t=!0){this.registerConfigurations([n],t)}registerConfigurations(n,t=!0){const s=new Set;this.r(n,t,s),p.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(n){const t=new Set;this.s(n,t),p.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:n,remove:t}){const s=new Set;this.s(t,s),this.r(n,!1,s),p.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(n){const t=new Set;this.l(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(n,t){this.a.push(...n);const s=[];for(const{overrides:r,source:o}of n)for(const u in r){t.add(u);const y=this.b.get(u)??this.b.set(u,{configurationDefaultOverrides:[]}).get(u),O=r[u];if(y.configurationDefaultOverrides.push({value:O,source:o}),e.$Mo.test(u)){const S=this.o(u,O,o,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S,this.n(u,S,o),s.push(...f(u))}else{const S=this.p(u,O,o,y.configurationDefaultOverrideValue);if(!S)continue;y.configurationDefaultOverrideValue=S;const v=this.e[u];v&&(this.A(u,v),this.w(u,v))}}this.q(s)}deregisterDefaultConfigurations(n){const t=new Set;this.m(n,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(n,t){for(const s of n){const r=this.a.indexOf(s);r!==-1&&this.a.splice(r,1)}for(const{overrides:s,source:r}of n)for(const o in s){const u=this.b.get(o);if(!u)continue;const y=u.configurationDefaultOverrides.findIndex(O=>r?O.source?.id===r.id:O.value===s[o]);if(y!==-1){if(u.configurationDefaultOverrides.splice(y,1),u.configurationDefaultOverrides.length===0&&this.b.delete(o),e.$Mo.test(o)){let O;for(const S of u.configurationDefaultOverrides)O=this.o(o,S.value,S.source,O);O&&!L.$wg(O.value)?(u.configurationDefaultOverrideValue=O,this.n(o,O,r)):(this.b.delete(o),delete this.e[o],delete this.c.properties[o])}else{let O;for(const v of u.configurationDefaultOverrides)O=this.p(o,v.value,v.source,O);u.configurationDefaultOverrideValue=O;const S=this.e[o];S&&(this.A(o,S),this.w(o,S))}t.add(o)}}this.y()}n(n,t,s){const r={type:"object",default:t.value,description:k.localize(1663,null,(0,T.$oj)(n)),$ref:e.$Jo,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[n]=r,this.c.properties[n]=r}o(n,t,s,r){const o=r?.value||{},u=r?.source??new Map;if(!(u instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const y of Object.keys(t)){const O=t[y];if(L.$lg(O)&&(L.$qg(o[y])||L.$lg(o[y]))){if(o[y]={...o[y]??{},...O},s)for(const v in O)u.set(`${y}.${v}`,s)}else o[y]=O,s?u.set(y,s):u.delete(y)}return{value:o,source:u}}p(n,t,s,r){const o=this.e[n],u=r?.value??o?.defaultDefaultValue;let y=s;if(L.$lg(t)&&(o!==void 0&&o.type==="object"||o===void 0&&(L.$qg(u)||L.$lg(u)))){if(y=r?.source??new Map,!(y instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const S in t)s&&y.set(`${n}.${S}`,s);t={...L.$lg(u)?u:{},...t}}return{value:t,source:y}}deltaConfiguration(n){let t=!1;const s=new Set;n.removedDefaults&&(this.m(n.removedDefaults,s),t=!0),n.addedDefaults&&(this.l(n.addedDefaults,s),t=!0),n.removedConfigurations&&this.s(n.removedConfigurations,s),n.addedConfigurations&&this.r(n.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...n){this.j.fire()}registerOverrideIdentifiers(n){this.q(n),this.j.fire()}q(n){for(const t of n)this.i.add(t);this.y()}r(n,t,s){n.forEach(r=>{this.u(r,t,r.extensionInfo,r.restrictedProperties,void 0,s),this.d.push(r),this.v(r)})}s(n,t){const s=r=>{if(r.properties)for(const o in r.properties){t.add(o);const u=this.e[o];u?.policy?.name&&this.f.delete(u.policy.name),delete this.e[o],this.x(o,r.properties[o])}r.allOf?.forEach(o=>s(o))};for(const r of n){s(r);const o=this.d.indexOf(r);o!==-1&&this.d.splice(o,1)}}u(n,t=!0,s,r,o=R.WINDOW,u){o=L.$sg(n.scope)?o:n.scope;const y=n.properties;if(y)for(const S in y){const v=y[S];if(t&&I(S,v)){delete y[S];continue}if(v.source=s,v.defaultDefaultValue=y[S].default,this.A(S,v),e.$Mo.test(S)?v.scope=void 0:(v.scope=L.$sg(v.scope)?o:v.scope,v.restricted=L.$sg(v.restricted)?!!r?.includes(S):v.restricted),y[S].hasOwnProperty("included")&&!y[S].included){this.g[S]=y[S],delete y[S];continue}else this.e[S]=y[S],y[S].policy?.name&&this.f.set(y[S].policy.name,S);!y[S].deprecationMessage&&y[S].markdownDeprecationMessage&&(y[S].deprecationMessage=y[S].markdownDeprecationMessage),u.add(S)}const O=n.allOf;if(O)for(const S of O)this.u(S,t,s,r,o,u)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const n=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&n.set(t,s.configurationDefaultOverrideValue);return n}v(n){const t=s=>{const r=s.properties;if(r)for(const u in r)this.w(u,r[u]);s.allOf?.forEach(t)};t(n)}w(n,t){switch(e.$Do.properties[n]=t,t.scope){case R.APPLICATION:e.$Eo.properties[n]=t;break;case R.MACHINE:e.$Fo.properties[n]=t;break;case R.MACHINE_OVERRIDABLE:e.$Go.properties[n]=t;break;case R.WINDOW:e.$Ho.properties[n]=t;break;case R.RESOURCE:e.$Io.properties[n]=t;break;case R.LANGUAGE_OVERRIDABLE:e.$Io.properties[n]=t,this.h.properties[n]=t;break}}x(n,t){switch(delete e.$Do.properties[n],t.scope){case R.APPLICATION:delete e.$Eo.properties[n];break;case R.MACHINE:delete e.$Fo.properties[n];break;case R.MACHINE_OVERRIDABLE:delete e.$Go.properties[n];break;case R.WINDOW:delete e.$Ho.properties[n];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$Io.properties[n],delete this.h.properties[n];break}}y(){for(const n of this.i.values()){const t=`[${n}]`,s={type:"object",description:k.localize(1664,null),errorMessage:k.localize(1665,null),$ref:e.$Jo};this.A(t,s),e.$Do.properties[t]=s,e.$Eo.properties[t]=s,e.$Fo.properties[t]=s,e.$Go.properties[t]=s,e.$Ho.properties[t]=s,e.$Io.properties[t]=s}}z(){const n={type:"object",description:k.localize(1666,null),errorMessage:k.localize(1667,null),$ref:e.$Jo};e.$Do.patternProperties[e.$Lo]=n,e.$Eo.patternProperties[e.$Lo]=n,e.$Fo.patternProperties[e.$Lo]=n,e.$Go.patternProperties[e.$Lo]=n,e.$Ho.patternProperties[e.$Lo]=n,e.$Io.patternProperties[e.$Lo]=n,this.j.fire()}A(n,t){const s=this.b.get(n)?.configurationDefaultOverrideValue;let r,o;s&&(!t.disallowConfigurationDefault||!s.source)&&(r=s.value,o=s.source),L.$qg(r)&&(r=t.defaultDefaultValue,o=void 0),L.$qg(r)&&(r=w(t.type)),t.default=r,t.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",l=new RegExp(g,"g");e.$Lo=`^(${g})+$`,e.$Mo=new RegExp(e.$Lo);function f(i){const n=[];if(e.$Mo.test(i)){let t=l.exec(i);for(;t?.length;){const s=t[1].trim();s&&n.push(s),t=l.exec(i)}}return(0,P.$Qb)(n)}function E(i){return i.reduce((n,t)=>`${n}[${t}]`,"")}function w(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new m;A.$xo.add(e.$Co.Configuration,d);function I(i,n){return i.trim()?e.$Mo.test(i)?k.localize(1669,null,i):d.getConfigurationProperties()[i]!==void 0?k.localize(1670,null,i):n.policy?.name&&d.getPolicyConfigurations().get(n.policy?.name)!==void 0?k.localize(1671,null,i,n.policy?.name,d.getPolicyConfigurations().get(n.policy?.name)):null:k.localize(1668,null)}function $(){const i=[],n=d.getConfigurationProperties();for(const t of Object.keys(n))i.push([t,n[t].scope]);return i.push(["launch",R.RESOURCE]),i.push(["task",R.RESOURCE]),i}function c(i){const n={};for(const t of i){const s=t.properties;if(L.$lg(s))for(const r in s)n[r]=s[r];t.allOf&&Object.assign(n,c(t.allOf))}return n}function h(i){switch(i){case"application":return R.APPLICATION;case"machine":return R.MACHINE;case"resource":return R.RESOURCE;case"machine-overridable":return R.MACHINE_OVERRIDABLE;case"language-overridable":return R.LANGUAGE_OVERRIDABLE;default:return R.WINDOW}}}),define(fe[78],de([0,1,17,3,36,2,31,29,12,10,21,47,7,44]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Yo=$,P=Oe(P),L=Oe(L),C=Oe(C),A=Oe(A);function l(n){return Object.isFrozen(n)?n:C.$lo(n)}class f{static createEmptyModel(t){return new f({},[],[],void 0,t)}constructor(t,s,r,o,u){this.b=t,this.c=s,this.d=r,this.raw=o,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof f)return s;const r=new E("",this.f);return r.parseRaw(s),r.configurationModel});this.g=t.reduce((s,r)=>r===s?r:s.merge(r),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,R.$mj)(this.contents,t):this.contents}inspect(t,s){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return s?l(r.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return l(s?r.rawConfiguration.override(s).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:u,identifiers:y,keys:O}of r.rawConfiguration.overrides){const S=new f(u,O,[],void 0,r.f).getValue(t);S!==void 0&&o.push({identifiers:y,value:S})}return o.length?l(o):void 0}}}getOverrideValue(t,s){const r=this.j(s);return r?t?(0,R.$mj)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const r of this.overrides)r.identifiers.includes(t)&&s.push(...r.keys);return P.$Qb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return P.$Qb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=C.$ko(this.contents),r=C.$ko(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const y of t)if(u.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(s,y.contents);for(const O of y.overrides){const[S]=r.filter(v=>P.$yb(v.identifiers,O.identifiers));S?(this.i(S.contents,O.contents),S.keys.push(...O.keys),S.keys=P.$Qb(S.keys)):r.push(C.$ko(O))}for(const O of y.keys)o.indexOf(O)===-1&&o.push(O)}return new f(s,o,r,u.every(y=>y instanceof f)?void 0:u,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const r={};for(const o of P.$Qb([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[o];const y=s[o];y&&(typeof u=="object"&&typeof y=="object"?(u=C.$ko(u),this.i(u,y)):u=y),r[o]=u}return new f(r,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const r of Object.keys(s)){if(r in t&&A.$lg(t[r])&&A.$lg(s[r])){this.i(t[r],s[r]);continue}t[r]=C.$ko(s[r])}}j(t){let s=null,r=null;const o=u=>{u&&(r?this.i(r,u):r=C.$ko(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?s=u.contents:u.identifiers.includes(t)&&o(u.contents);return o(s),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,R.$lj)(this.contents,t),p.$Mo.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>P.$yb(r.identifiers,(0,p.$No)(t))),1))}k(t,s,r){if((0,R.$kj)(this.contents,t,s,o=>this.f.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),p.$Mo.test(t)){const o=(0,p.$No)(t),u={identifiers:o,keys:Object.keys(this.contents[t]),contents:(0,R.$jj)(this.contents[t],O=>this.f.error(O))},y=this.overrides.findIndex(O=>P.$yb(O.identifiers,o));y!==-1?this.overrides[y]=u:this.overrides.push(u)}}}e.$Uo=f;class E{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!A.$sg(t)){const r=this.h(t);this.parseRaw(r,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:r,keys:o,overrides:u,restricted:y,hasExcludedProperties:O}=this.i(t,s);this.b=new f(r,o,u,O?[t]:void 0,this.g),this.c=y||[]}h(t){let s={},r=null,o=[];const u=[],y=[];function O(v){Array.isArray(o)?o.push(v):r!==null&&(o[r]=v)}const S={onObjectBegin:()=>{const v={};O(v),u.push(o),o=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const v=[];O(v),u.push(o),o=v,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:O,onError:(v,N,F)=>{y.push({error:v,offset:N,length:F})}};if(t)try{L.$_n(t,S),s=o[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return s}i(t,s){const r=g.$xo.as(p.$Co.Configuration).getConfigurationProperties(),o=this.j(t,r,!0,s);t=o.raw;const u=(0,R.$jj)(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),y=Object.keys(t),O=this.l(t,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:u,keys:y,overrides:O,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,s,r,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const y={},O=[];for(const S in t)if(p.$Mo.test(S)&&r){const v=this.j(t[S],s,!1,o);y[S]=v.raw,u=u||v.hasExcludedProperties,O.push(...v.restricted)}else{const v=s[S],N=v?typeof v.scope<"u"?v.scope:p.ConfigurationScope.WINDOW:void 0;v?.restricted&&O.push(S),!o.exclude?.includes(S)&&(o.include?.includes(S)||(N===void 0||o.scopes===void 0||o.scopes.includes(N))&&!(o.skipRestricted&&v?.restricted))?y[S]=t[S]:u=!0}return{raw:y,restricted:O,hasExcludedProperties:u}}l(t,s){const r=[];for(const o of Object.keys(t))if(p.$Mo.test(o)){const u={};for(const y in t[o])u[y]=t[o][y];r.push({identifiers:(0,p.$No)(o),keys:Object.keys(u),contents:(0,R.$jj)(u,s)})}return r}}e.$Vo=E;class w extends k.$Zc{constructor(t,s,r,o,u){super(),this.c=t,this.f=s,this.g=o,this.h=u,this.b=this.B(new a.$qe),this.onDidChange=this.b.event,this.a=new E(this.c.toString(),u),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(m.FileOperation.CREATE)||y.isOperation(m.FileOperation.COPY)||y.isOperation(m.FileOperation.DELETE)||y.isOperation(m.FileOperation.WRITE))&&r.isEqual(y.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Wo=w;class d{constructor(t,s,r,o,u,y,O,S,v,N,F,U,j){this.a=t,this.b=s,this.c=r,this.overrideIdentifiers=o,this.d=u,this.f=y,this.g=O,this.h=S,this.i=v,this.j=N,this.k=F,this.l=U,this.m=j}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class I{constructor(t,s,r,o,u,y,O,S,v,N){this.j=t,this.l=s,this.m=r,this.n=o,this.p=u,this.q=y,this.r=O,this.s=S,this.t=v,this.u=N,this.h=null,this.i=new T.$Fc,this.v=null}getValue(t,s,r){return this.w(t,s,r).getValue(t)}updateValue(t,s,r={}){let o;r.resource?(o=this.t.get(r.resource),o||(o=f.createEmptyModel(this.u),this.t.set(r.resource,o))):o=this.s,s===void 0?o.removeValue(t):o.setValue(t,s),r.resource||(this.h=null)}inspect(t,s,r){const o=this.w(t,s,r),u=this.A(s.resource,r),y=s.resource?this.t.get(s.resource)||this.s:this.s,O=new Set;for(const S of o.overrides)for(const v of S.identifiers)o.getOverrideValue(t,v)!==void 0&&O.add(v);return new d(t,s,o.getValue(t),O.size?[...O]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,u||void 0,y)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=[];if(!s){const{added:o,updated:u,removed:y}=h(this.j,t);s=[...o,...u,...y]}for(const o of s)for(const u of(0,p.$No)(o)){const y=this.j.getKeysForOverrideIdentifier(u),O=t.getKeysForOverrideIdentifier(u),S=[...O.filter(v=>y.indexOf(v)===-1),...y.filter(v=>O.indexOf(v)===-1),...y.filter(v=>!C.$oo(this.j.override(u).getValue(v),t.override(u).getValue(v)))];r.push([u,S])}return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:r,removed:o}=h(this.l,t),u=[...s,...r,...o];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.applicationConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.localUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.remoteUserConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:o,overrides:u}=h(this.workspaceConfiguration,t),y=[...s,...r,...o];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:u}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:o,updated:u,removed:y,overrides:O}=h(r,s),S=[...o,...u,...y];return(S.length||!r)&&this.updateFolderConfiguration(t,s),{keys:S,overrides:O}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:u,overrides:y}=h(s,void 0);return{keys:[...r,...o,...u],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,r){let o=this.x(s,r);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},s){let r=this.y();if(s&&t){const o=s.getFolder(t);o&&(r=this.z(o.uri)||r);const u=this.t.get(t);u&&(r=r.merge(u))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const r=this.y(),o=this.r.get(t);o?(s=r.merge(o),this.i.set(t,s)):s=r}return s}A(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:r,overrides:o,keys:u}=this.r.get(s);return t.push([s,{contents:r,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(r=>t.add(r))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.q.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o))),[...s.values()]}static parse(t,s){const r=this.E(t.defaults,s),o=this.E(t.policy,s),u=this.E(t.application,s),y=this.E(t.user,s),O=this.E(t.workspace,s),S=t.folders.reduce((v,N)=>(v.set(b.URI.revive(N[0]),this.E(N[1],s)),v),new T.$Fc);return new I(r,o,u,y,f.createEmptyModel(s),O,S,f.createEmptyModel(s),new T.$Fc,s)}static E(t,s){return new f(t.contents,t.keys,t.overrides,void 0,s)}}e.$Xo=I;function $(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,s=new Map;for(const o of n)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,y])=>{const O=(0,T.$Cc)(s,u,new Set);y.forEach(S=>O.add(S))});const r=[];return s.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...t.values()],overrides:r}}class c{constructor(t,s,r,o,u){this.change=t,this.f=s,this.g=r,this.h=o,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of t.keys)this.affectedKeys.add(y);for(const[,y]of t.overrides)for(const O of y)this.affectedKeys.add(O);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=I.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const r=this.a+t,o=this.d.indexOf(r);if(o<0)return!1;const u=o+r.length;if(u>=this.d.length)return!1;const y=this.d.charCodeAt(u);if(y!==this.b&&y!==this.c)return!1;if(s){const O=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,S=this.g.getValue(t,s,this.h);return!C.$oo(O,S)}return!0}}e.$Zo=c;function h(n,t){const{added:s,removed:r,updated:o}=i(t?.rawConfiguration,n?.rawConfiguration),u=[],y=n?.getAllOverrideIdentifiers()||[],O=t?.getAllOverrideIdentifiers()||[];if(t){const S=O.filter(v=>!y.includes(v));for(const v of S)u.push([v,t.getKeysForOverrideIdentifier(v)])}if(n){const S=y.filter(v=>!O.includes(v));for(const v of S)u.push([v,n.getKeysForOverrideIdentifier(v)])}if(t&&n){for(const S of y)if(O.includes(S)){const v=i({contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});u.push([S,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:r,updated:o,overrides:u}}function i(n,t){const s=n?t?n.keys.filter(u=>t.keys.indexOf(u)===-1):[...n.keys]:[],r=t?n?t.keys.filter(u=>n.keys.indexOf(u)===-1):[...t.keys]:[],o=[];if(n&&t){for(const u of t.keys)if(n.keys.indexOf(u)!==-1){const y=(0,R.$mj)(t.contents,u),O=(0,R.$mj)(n.contents,u);C.$oo(y,O)||o.push(u)}}return{added:s,removed:r,updated:o}}}),define(fe[185],de([0,1,17,3,2,29,12,78,47,11,58,44]),function(ce,e,P,a,L,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=void 0;class m extends L.$Zc{get configurationModel(){return this.b}constructor(E){super(),this.c=E,this.a=this.B(new a.$qe),this.onDidChangeConfiguration=this.a.event,this.b=C.$Uo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(p.$xo.as(A.$Co.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:w})=>this.f(Array.from(E),w))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(E,w){this.j(E,p.$xo.as(A.$Co.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}g(){return{}}h(){this.b=C.$Uo.createEmptyModel(this.c);const E=p.$xo.as(A.$Co.Configuration).getConfigurationProperties();this.j(Object.keys(E),E)}j(E,w){const d=this.g();for(const I of E){const $=d[I],c=w[I];$!==void 0?this.b.setValue(I,$):c?this.b.setValue(I,c.default):this.b.removeValue(I)}}}e.$1o=m;class g{constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=C.$Uo.createEmptyModel(new b.$sk)}async initialize(){return this.configurationModel}}e.$2o=g;let l=class extends L.$Zc{get configurationModel(){return this.b}constructor(E,w,d){super(),this.c=E,this.f=w,this.g=d,this.a=this.B(new a.$qe),this.onDidChangeConfiguration=this.a.event,this.b=C.$Uo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const w={},d=[],I=p.$xo.as(A.$Co.Configuration).getConfigurationProperties();for(const $ of E){const c=I[$];if(!c){d.push($);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}d.push($),w[c.policy.name]={type:c.type}}}return(0,T.$wg)(w)||await this.f.updatePolicyDefinitions(w),d}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const w=p.$xo.as(A.$Co.Configuration).getPolicyConfigurations(),d=(0,P.$Lb)(E.map(I=>w.get(I)));this.m(d,!0)}m(E,w){this.g.trace("PolicyConfiguration#update",E);const d=p.$xo.as(A.$Co.Configuration).getConfigurationProperties(),I=[],$=this.b.isEmpty();for(const c of E){const h=d[c]?.policy?.name;if(h){const i=this.f.getPolicyValue(h);($?i!==void 0:!(0,k.$oo)(this.b.getValue(c),i))&&I.push([c,i])}else this.b.getValue(c)!==void 0&&I.push([c,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const c=this.b;this.b=C.$Uo.createEmptyModel(this.g);for(const h of c.keys)this.b.setValue(h,c.getValue(h));for(const[h,i]of I)i===void 0?this.b.removeValue(h):this.b.setValue(h,i);w&&this.a.fire(this.b)}}};e.$3o=l,e.$3o=l=Ee([Y(1,R.$zo),Y(2,b.$fk)],l)}),define(fe[186],de([0,1,17,6,14,3,36,64,2,31,29,5,20,21,78,47,185,7,58]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;class I extends A.$Zc{constructor(h,i,n,t){super(),this.m=h,this.n=t,this.h=this.B(new k.$qe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$1o(t)),this.c=n instanceof d.$Bo?new E.$2o:this.B(new E.$3o(this.b,n,t)),this.f=this.B(new l.$Wo(this.m,{},m.$ch,i,t)),this.a=new l.$Xo(this.b.configurationModel,this.c.configurationModel,l.$Uo.createEmptyModel(t),l.$Uo.createEmptyModel(t),l.$Uo.createEmptyModel(t),l.$Uo.createEmptyModel(t),new b.$Fc,l.$Uo.createEmptyModel(t),new b.$Fc,t),this.j=new $(h,i,this),this.g=this.B(new a.$Wh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:r})=>this.s(s,r))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,i,n]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Xo(h,i,l.$Uo.createEmptyModel(this.n),n,l.$Uo.createEmptyModel(this.n),l.$Uo.createEmptyModel(this.n),new b.$Fc,l.$Uo.createEmptyModel(this.n),new b.$Fc,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,i){const n=typeof h=="string"?h:void 0,t=(0,g.$fj)(h)?h:(0,g.$fj)(i)?i:{};return this.a.getValue(n,t,void 0)}async updateValue(h,i,n,t,s){const r=(0,g.$gj)(n)?n:(0,g.$fj)(n)?{resource:n.resource,overrideIdentifiers:n.overrideIdentifier?[n.overrideIdentifier]:void 0}:void 0,o=r?t:n;if(o!==void 0&&o!==g.ConfigurationTarget.USER_LOCAL&&o!==g.ConfigurationTarget.USER)throw new Error(`Unable to write ${h} to target ${o}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,P.$Qb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const u=this.inspect(h,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,R.$oo)(i,u.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const O=r.overrideIdentifiers.sort(),S=this.a.localUserConfiguration.overrides.find(v=>(0,P.$yb)([...v.identifiers].sort(),O));S&&(r.overrideIdentifiers=S.identifiers)}const y=r?.overrideIdentifiers?.length?[(0,f.$Oo)(r.overrideIdentifiers),h]:[h];await this.j.write(y,i),await this.reloadConfiguration()}inspect(h,i={}){return this.a.inspect(h,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const i=this.a.toData(),n=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(n,i,g.ConfigurationTarget.USER)}s(h,i){const n=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(h,i);this.u(t,n,g.ConfigurationTarget.DEFAULT)}t(h){const i=this.a.toData(),n=this.a.compareAndUpdatePolicyConfiguration(h);this.u(n,i,g.ConfigurationTarget.DEFAULT)}u(h,i,n){const t=new l.$Zo(h,{data:i},this.a,void 0,this.n);t.source=n,this.h.fire(t)}}e.$4o=I;class ${constructor(h,i,n){this.b=h,this.c=i,this.d=n,this.a=new a.$Rh}write(h,i){return this.a.queue(()=>this.e(h,i))}async e(h,i){let n;try{n=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===w.FileOperationResult.FILE_NOT_FOUND)n="{}";else throw r}const t=[];if((0,T.$5n)(n,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(n,h,i);n=(0,C.$jo)(n,s),await this.c.writeFile(this.b,L.$Se.fromString(n))}f(h,i,n){const{tabSize:t,insertSpaces:s,eol:r}=this.h;if(!i.length){const o=JSON.stringify(n,null,s?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,C.$go)(h,i,n,{tabSize:t,insertSpaces:s,eol:r})}get h(){if(!this.g){let h=p.OS===p.OperatingSystem.Linux||p.OS===p.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(h=i),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(fe[187],de([0,1,14,3,2,72]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fyb=e.$dyb=e.$cyb=void 0,e.$eyb=C;const T=(b,R,p)=>{const m=new Uint8Array(16);for(let f=0;f<16;f++)m[f]=Math.round(Math.random()*256);const g=(0,P.$af)(P.$Se.wrap(m));return[`GET ws://localhost${b}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`].join(`\r
`)+`\r
\r
`};e.$cyb=T,e.$dyb=P.$Se.fromString(`\r
\r
`);async function C(b,R,p,m,g){b.write(P.$Se.fromString((0,e.$cyb)(R,p,m)));const l=new L.$Yc;try{return await new Promise((f,E)=>{let w;l.add(b.onData(d=>{w?w=P.$Se.concat([w,d],w.byteLength+d.byteLength):w=d;const I=w.indexOf(e.$dyb);if(I===-1)return;f(b),b.pauseData();const $=w.slice(I+e.$dyb.byteLength);$.byteLength&&g.onData.fire($)})),l.add(b.onClose(d=>E(d??new Error("socket closed")))),l.add(b.onEnd(()=>E(new Error("socket ended"))))})}catch(f){throw b.dispose(),f}finally{l.dispose()}}class A extends L.$Zc{constructor(R,p){super(),this.g=R,this.a=this.B(new a.$te),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new a.$qe),this.onDidDispose=this.b.event,this.f=!1,this.B(p.onData),this.B(p.onData.event(m=>this.a.fire(m))),this.onClose=this.B(p.onClose).event,this.onEnd=this.B(p.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,p){k.SocketDiagnostics.traceSocketEvent(this,this.g,R,p)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$fyb=A}),define(fe[106],de([0,1,8,4]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.RemoteAuthorityResolverErrorCode=e.$Yl=e.$Xl=e.RemoteConnectionType=e.$Wl=void 0,e.$1l=b,e.$Wl=(0,a.$Ki)("remoteAuthorityResolverService");var L;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class k{constructor(p){this.id=p,this.type=L.Managed}toString(){return`Managed(${this.id})`}}e.$Xl=k;class T{constructor(p,m){this.host=p,this.port=m,this.type=L.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Yl=T;var C;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class A extends P.$fb{static isNotAvailable(p){return p instanceof A&&p._code===C.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof A&&p._code===C.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof A&&p._code===C.NoResolverFound}static isInvalidAuthority(p){return p instanceof A&&p._code===C.InvalidAuthority}static isHandled(p){return p instanceof A&&p.isHandled}constructor(p,m=C.Unknown,g){super(p),this._message=p,this._code=m,this._detail=g,this.isHandled=m===C.NotAvailable&&g===!0,Object.setPrototypeOf(this,A.prototype)}}e.$Zl=A;function b(R){const p=R.indexOf("+");return p===-1?R:R.substring(0,p)}}),define(fe[188],de([0,1,6,14,25,8,3,2,22,102,54,32,72,106]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$6l=u,e.$7l=y,e.$8l=S,b=Oe(b);const l=30*1e3;var f;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(f||(e.ConnectionType=f={}));function E(K){switch(K){case f.Management:return"Management";case f.ExtensionHost:return"ExtensionHost";case f.Tunnel:return"Tunnel"}}function w(K){const q=new L.$Be;return setTimeout(()=>q.cancel(),K),q.token}function d(K,q){if(K.isCancellationRequested||q.isCancellationRequested)return L.CancellationToken.Cancelled;const D=new L.$Be;return K.onCancellationRequested(()=>D.cancel()),q.onCancellationRequested(()=>D.cancel()),D.token}class I{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new C.$Yc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,P.$Dh)(),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function $(K,q){const D=new I(q);return D.registerDisposable(K.onControlMessage(J=>{const oe=JSON.parse(J.toString()),Q=H(oe);Q?D.reject(Q):D.resolve(oe)})),D.promise}function c(K,q,D,J,oe,Q,Z,M){const z=new I(M),ie=R.$ke.create(!1);return K.info(`Creating a socket (${Z})...`),b.mark(`code/willCreateSocket/${Q}`),q.connect(D,J,oe,Z).then(ae=>{z.didTimeout?(b.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${Z}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(b.mark(`code/didCreateSocketOK/${Q}`),K.info(`Creating a socket (${Z}) was successful after ${ie.elapsed()} ms.`),z.resolve(ae))},ae=>{b.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${Z}) returned an error after ${ie.elapsed()} ms.`),K.error(ae),z.reject(ae)}),z.promise}function h(K,q){const D=new I(q);return K.then(J=>{D.didTimeout||D.resolve(J)},J=>{D.didTimeout||D.reject(J)}),D.promise}async function i(K,q,D,J){const oe=ee(K,q);K.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,A.$Xg.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,E(q),`renderer-${E(q)}-${K.reconnectionToken}`,J)}catch(ae){throw K.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ae),ae}K.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let Z,M;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Q,null),Z=K.reconnectionProtocol,M=!1):(Z=new m.$yi({socket:Q}),M=!0),K.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const z=await h(K.signService.createNewMessage((0,p.$7g)()),J),ie={type:"auth",auth:K.connectionToken||"00000000000000000000",data:z.data};Z.sendControl(a.$Se.fromString(JSON.stringify(ie)));try{const ae=await $(Z,d(J,w(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(K.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await h(K.signService.validate(z,ae.signedData),J)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const pe=await h(K.signService.sign(ae.data),J),be={type:"connectionType",commit:K.commit,signedData:pe,desiredConnectionType:q};return D&&(be.args=D),K.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(a.$Se.fromString(JSON.stringify(be))),{protocol:Z,ownsProtocol:M}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(K.logService.error(`${oe} the handshake timed out. Error:`),K.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${oe} received error control message when negotiating connection. Error:`),K.logService.error(ae)),M&&B(Z),ae}}async function n(K,q,D,J){const oe=Date.now(),Q=ee(K,q),{protocol:Z,ownsProtocol:M}=await i(K,q,D,J),z=new I(J);return z.registerDisposable(Z.onControlMessage(ie=>{const ae=JSON.parse(ie.toString()),ue=H(ae);ue?(K.logService.error(`${Q} received error control message when negotiating connection. Error:`),K.logService.error(ue),M&&B(Z),z.reject(ue)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${X(oe)}!`),z.resolve({protocol:Z,firstMessage:ae}))})),z.promise}async function t(K,q){const{protocol:D}=await n(K,f.Management,void 0,q);return{protocol:D}}async function s(K,q,D){const{protocol:J,firstMessage:oe}=await n(K,f.ExtensionHost,q,D),Q=oe&&oe.debugPort;return{protocol:J,debugPort:Q}}async function r(K,q,D){const J=Date.now(),oe=ee(K,f.Tunnel),{protocol:Q}=await i(K,f.Tunnel,q,D);return K.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${X(J)}!`),Q}async function o(K,q,D){const{connectTo:J,connectionToken:oe}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:J,connectionToken:oe,reconnectionToken:q,reconnectionProtocol:D,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function u(K,q,D){return O(K,async J=>{const{protocol:oe}=await t(J,L.CancellationToken.None);return new V(K,q,D,J.reconnectionToken,oe)})}async function y(K,q){return O(K,async D=>{const{protocol:J,debugPort:oe}=await s(D,q,L.CancellationToken.None);return new te(K,q,D.reconnectionToken,J,oe)})}async function O(K,q){for(let J=1;;J++)try{const oe=(0,p.$7g)(),Q=await o(K,oe,null);return await q(Q)}catch(oe){if(J<5)K.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(oe);else throw K.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(oe),x.triggerPermanentFailure(0,0,g.$Zl.isHandled(oe)),oe}}async function S(K,q,D){const J=await o(K,(0,p.$7g)(),null);return await r(J,{host:q,port:D},L.CancellationToken.None)}function v(K){return(0,P.$xh)(q=>new Promise((D,J)=>{const oe=setTimeout(D,K*1e3);q.onCancellationRequested(()=>{clearTimeout(oe),D()})}))}var N;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(q,D){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.type=N.ConnectionLost}}e.$9l=F;class U{constructor(q,D,J,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.durationSeconds=J,this.c=oe,this.type=N.ReconnectionWait}skipWait(){this.c.cancel()}}e.$0l=U;class j{constructor(q,D,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=N.ReconnectionRunning}}e.$$l=j;class G{constructor(q,D,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=N.ConnectionGain}}e.$_l=G;class W{constructor(q,D,J,oe){this.reconnectionToken=q,this.millisSinceLastIncomingData=D,this.attempt=J,this.handled=oe,this.type=N.ReconnectionPermanentFailure}}e.$am=W;class x extends C.$Zc{static triggerPermanentFailure(q,D,J){this._permanentFailure=!0,this.f=q,this.g=D,this.h=J,this.j.forEach(oe=>oe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(q=>q.y())}static debugPauseSocketWriting(){this.j.forEach(q=>q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(q,D,J,oe,Q){super(),this.t=q,this.u=D,this.reconnectionToken=J,this.protocol=oe,this.w=Q,this.m=this.B(new T.$qe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new G(this.reconnectionToken,0,0)),this.B(oe.onSocketClose(Z=>{const M=le(this.t,this.reconnectionToken,!0);Z?Z.type===m.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${M} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${M} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${M} received socket close event.`),this.y()})),this.B(oe.onSocketTimeout(Z=>{const M=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${M} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,C.$Xc)(()=>{const Z=x.j.indexOf(this);Z>=0&&x.j.splice(Z,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const q=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const oe=J<D.length?D[J]:D[D.length-1];try{if(oe>0){const Z=v(oe);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,Z)),this.u.logService.info(`${q} waiting for ${oe} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this.u.logService.info(`${q} resolving connection...`);const Q=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${q} connecting to ${Q.connectTo}...`),await this.G(Q,w(l)),this.u.logService.info(`${q} reconnected!`),this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this.u.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(g.$Zl.isTemporarilyNotAvailable(Q)){this.u.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.u.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((0,k.$8)(Q)){this.u.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if(Q instanceof g.$Zl){this.u.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,g.$Zl.isHandled(Q));break}this.u.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this.n&&!this.s)}C(q,D,J){this.w?x.triggerPermanentFailure(q,D,J):this.D(q,D,J)}D(q,D,J){this.m.fire(new W(this.reconnectionToken,q,D,J)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$bm=x;class V extends x{constructor(q,D,J,oe,Q){super(f.Management,q,oe,Q,!0),this.client=this.B(new m.$wi(Q,{remoteAuthority:D,clientId:J},q.ipcLogger))}async G(q,D){await t(q,D)}}e.$cm=V;class te extends x{constructor(q,D,J,oe,Q){super(f.ExtensionHost,q,J,oe,!1),this.H=D,this.debugPort=Q}async G(q,D){await s(q,this.H,D)}}e.$dm=te;function B(K){try{K.acceptDisconnect();const q=K.getSocket();K.dispose(),q.dispose()}catch(q){(0,k.$4)(q)}}function H(K){if(K&&K.type==="error"){const q=new Error(`Connection error: ${K.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function _(K,q){for(;K.length<q;)K+=" ";return K}function ne(K,q){return`[remote-connection][${_(E(K),13)}][${q.substr(0,5)}\u2026]`}function le(K,q,D){return`${ne(K,q)}[${D?"reconnect":"initial"}]`}function ee(K,q){return`${le(q,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function X(K){return`${Date.now()-K} ms`}}),define(fe[107],de([0,1,22]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=a,e.$on=L,e.$pn=k,e.$qn=T;function a(A){return A.scheme===P.Schemas.vscodeRemote?A.authority:void 0}function L(A){if(!A)return;const b=A.indexOf("+");return b<0?A:A.substr(0,b)}function k(A){const{host:b,port:R}=C(A);if(typeof R>"u")throw new Error(`Invalid remote authority: ${A}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:b,port:R}}function T(A,b){let{host:R,port:p}=C(A);return typeof p>"u"&&(p=b),{host:R,port:p}}function C(A){const b=A.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const R=A.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const p=A.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:A,port:void 0}}}),define(fe[34],de([0,1,26,4,107]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$zn=e.$yn=e.$xn=e.TargetPlatform=e.ExtensionType=e.$wn=e.$un=e.$tn=e.$sn=e.$rn=void 0,e.$vn=k,e.$An=p,e.$Bn=m,e.$Cn=g,e.$Dn=l,e.$En=f,e.$Fn=E,P=Oe(P),e.$rn="extensions.user.cache",e.$sn="extensions.builtin.cache",e.$tn="undefined_publisher",e.$un=["ui","workspace","web"];function k(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$wn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(T||(e.ExtensionType=T={}));var C;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class A{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,I){if(typeof d>"u"||d===null)return typeof I>"u"||I===null;if(typeof I>"u"||I===null)return!1;if(typeof d=="string"||typeof I=="string"){const $=typeof d=="string"?d:d.value,c=typeof I=="string"?I:I.value;return P.$Kf($,c)}return d._lower===I._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$xn=A;class b{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const I of d)this.add(I)}add(d){this.c.add(A.toKey(d))}delete(d){return this.c.delete(A.toKey(d))}has(d){return this.c.has(A.toKey(d))}}e.$yn=b;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(A.toKey(d))}get(d){return this.c.get(A.toKey(d))}has(d){return this.c.has(A.toKey(d))}set(d,I){this.c.set(A.toKey(d),I)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zn=R;function p(w){return m(w)}function m(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}function g(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}function l(w,d){if(d){const I=`onResolveRemoteAuthority:${(0,L.$on)(d)}`;return!!w.activationEvents?.includes(I)}return!1}function f(w){return w.map(d=>{const[I,$]=d.split("@");return{proposalName:I,version:$?parseInt($):void 0}})}function E(w){return w.map(d=>d.split("@")[0])}e.$Gn=(0,a.$Ki)("IBuiltinExtensionsScannerService")}),define(fe[27],de([0,1,5,9,34,4]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.ExtensionManagementErrorCode=e.$sp=e.ExtensionGalleryErrorCode=e.$rp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=C,e.$mp=A,e.$np=b,e.$op=R,e.$pp=p,e.$qp=m,e.$ep="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$fp=new RegExp(e.$ep),e.$gp="__web_extension",e.$hp="skipWalkthrough",e.$ip="extensionInstallSource",e.$jp="dependecyOrPackExtensionInstall",e.$kp="clientTargetPlatform";var T;(function(c){c.COMMAND="command",c.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function C(c){switch(c){case L.TargetPlatform.WIN32_X64:return"Windows 64 bit";case L.TargetPlatform.WIN32_ARM64:return"Windows ARM";case L.TargetPlatform.LINUX_X64:return"Linux 64 bit";case L.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case L.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case L.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case L.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case L.TargetPlatform.DARWIN_X64:return"Mac";case L.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case L.TargetPlatform.WEB:return"Web";case L.TargetPlatform.UNIVERSAL:return L.TargetPlatform.UNIVERSAL;case L.TargetPlatform.UNKNOWN:return L.TargetPlatform.UNKNOWN;case L.TargetPlatform.UNDEFINED:return L.TargetPlatform.UNDEFINED}}function A(c){switch(c){case L.TargetPlatform.WIN32_X64:return L.TargetPlatform.WIN32_X64;case L.TargetPlatform.WIN32_ARM64:return L.TargetPlatform.WIN32_ARM64;case L.TargetPlatform.LINUX_X64:return L.TargetPlatform.LINUX_X64;case L.TargetPlatform.LINUX_ARM64:return L.TargetPlatform.LINUX_ARM64;case L.TargetPlatform.LINUX_ARMHF:return L.TargetPlatform.LINUX_ARMHF;case L.TargetPlatform.ALPINE_X64:return L.TargetPlatform.ALPINE_X64;case L.TargetPlatform.ALPINE_ARM64:return L.TargetPlatform.ALPINE_ARM64;case L.TargetPlatform.DARWIN_X64:return L.TargetPlatform.DARWIN_X64;case L.TargetPlatform.DARWIN_ARM64:return L.TargetPlatform.DARWIN_ARM64;case L.TargetPlatform.WEB:return L.TargetPlatform.WEB;case L.TargetPlatform.UNIVERSAL:return L.TargetPlatform.UNIVERSAL;default:return L.TargetPlatform.UNKNOWN}}function b(c,h){switch(c){case P.Platform.Windows:return h==="x64"?L.TargetPlatform.WIN32_X64:h==="arm64"?L.TargetPlatform.WIN32_ARM64:L.TargetPlatform.UNKNOWN;case P.Platform.Linux:return h==="x64"?L.TargetPlatform.LINUX_X64:h==="arm64"?L.TargetPlatform.LINUX_ARM64:h==="arm"?L.TargetPlatform.LINUX_ARMHF:L.TargetPlatform.UNKNOWN;case"alpine":return h==="x64"?L.TargetPlatform.ALPINE_X64:h==="arm64"?L.TargetPlatform.ALPINE_ARM64:L.TargetPlatform.UNKNOWN;case P.Platform.Mac:return h==="x64"?L.TargetPlatform.DARWIN_X64:h==="arm64"?L.TargetPlatform.DARWIN_ARM64:L.TargetPlatform.UNKNOWN;case P.Platform.Web:return L.TargetPlatform.WEB}}function R(c,h){return h===L.TargetPlatform.WEB&&!c.includes(L.TargetPlatform.WEB)}function p(c,h,i){return R(h,i)?!1:c===L.TargetPlatform.UNDEFINED||c===L.TargetPlatform.UNIVERSAL?!0:c===L.TargetPlatform.UNKNOWN?!1:c===i}function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var g;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var l;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var f;(function(c){c.Install="install",c.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var E;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$rp=(0,k.$Ki)("extensionGalleryService");var w;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed",c.DownloadFailedWriting="DownloadFailedWriting",c.Offline="Offline"})(w||(e.ExtensionGalleryErrorCode=w={}));class d extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$sp=d;var I;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleApi="IncompatibleApi",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.DownloadFailedWriting="DownloadFailedWriting",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.ScanningExtension="ScanningExtension",c.ReadUninstalled="ReadUninstalled",c.UnsetUninstalled="UnsetUninstalled",c.Delete="Delete",c.Rename="Rename",c.IntializeDefaultProfile="IntializeDefaultProfile",c.AddToProfile="AddToProfile",c.InstalledExtensionNotFound="InstalledExtensionNotFound",c.PostInstall="PostInstall",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));class $ extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$tp=$,e.$up=(0,k.$Ki)("extensionManagementService"),e.$vp="extensionsIdentifiers/disabled",e.$wp="extensionsIdentifiers/enabled",e.$xp=(0,k.$Ki)("IGlobalExtensionEnablementService"),e.$yp=(0,k.$Ki)("IExtensionTipsService"),e.$zp=(0,a.localize2)(1780,"Extensions"),e.$Ap=(0,a.localize2)(1781,"Preferences")}),define(fe[189],de([0,1,3,2,29,10,96,27]),function(ce,e,P,a,L,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0;function A(E,w){return E?k.URI.revive(w?w.transformIncoming(E):E):void 0}function b(E,w){return w?w.transformOutgoingURI(E):E}function R(E,w){w=w||T.$Tn;const d=E.manifest;return{...(0,T.$Wn)({...E,manifest:void 0},w),manifest:d}}function p(E,w){return E?.profileLocation?(0,T.$Wn)(E,w??T.$Tn):E}function m(E,w){return w?(0,L.$mo)(E,d=>d instanceof k.URI?w.transformOutgoingURI(d):void 0):E}class g{constructor(w,d){this.a=w,this.b=d,this.onInstallExtension=P.Event.buffer(w.onInstallExtension,!0),this.onDidInstallExtensions=P.Event.buffer(w.onDidInstallExtensions,!0),this.onUninstallExtension=P.Event.buffer(w.onUninstallExtension,!0),this.onDidUninstallExtension=P.Event.buffer(w.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=P.Event.buffer(w.onDidUpdateExtensionMetadata,!0)}listen(w,d){const I=this.b(w);switch(d){case"onInstallExtension":return P.Event.map(this.onInstallExtension,$=>({...$,profileLocation:$.profileLocation?b($.profileLocation,I):$.profileLocation}));case"onDidInstallExtensions":return P.Event.map(this.onDidInstallExtensions,$=>$.map(c=>({...c,local:c.local?m(c.local,I):c.local,profileLocation:c.profileLocation?b(c.profileLocation,I):c.profileLocation})));case"onUninstallExtension":return P.Event.map(this.onUninstallExtension,$=>({...$,profileLocation:$.profileLocation?b($.profileLocation,I):$.profileLocation}));case"onDidUninstallExtension":return P.Event.map(this.onDidUninstallExtension,$=>({...$,profileLocation:$.profileLocation?b($.profileLocation,I):$.profileLocation}));case"onDidUpdateExtensionMetadata":return P.Event.map(this.onDidUpdateExtensionMetadata,$=>({local:m($.local,I),profileLocation:b($.profileLocation,I)}))}throw new Error("Invalid listen")}async call(w,d,I){const $=this.b(w);switch(d){case"zip":{const c=R(I[0],$),h=await this.a.zip(c);return b(h,$)}case"install":return this.a.install(A(I[0],$),p(I[1],$));case"installFromLocation":return this.a.installFromLocation(A(I[0],$),A(I[1],$));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(I[0],A(I[1],$),A(I[2],$));case"getManifest":return this.a.getManifest(A(I[0],$));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(I[0]);case"installFromGallery":return this.a.installFromGallery(I[0],p(I[1],$));case"installGalleryExtensions":{const c=I[0];return this.a.installGalleryExtensions(c.map(({extension:h,options:i})=>({extension:h,options:p(i,$)??{}})))}case"uninstall":return this.a.uninstall(R(I[0],$),p(I[1],$));case"uninstallExtensions":{const c=I[0];return this.a.uninstallExtensions(c.map(({extension:h,options:i})=>({extension:R(h,$),options:p(i,$)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(R(I[0],$));case"getInstalled":return(await this.a.getInstalled(I[0],A(I[1],$),I[2])).map(h=>m(h,$));case"toggleAppliationScope":{const c=await this.a.toggleAppliationScope(R(I[0],$),A(I[1],$));return m(c,$)}case"copyExtensions":return this.a.copyExtensions(A(I[0],$),A(I[1],$));case"updateMetadata":{const c=await this.a.updateMetadata(R(I[0],$),I[1],A(I[2],$));return m(c,$)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(I[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(I[0],I[1],I[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Fq=g;class l extends a.$Zc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(w){super(),this.m=w,this.c=this.B(new P.$qe),this.f=this.B(new P.$qe),this.g=this.B(new P.$qe),this.h=this.B(new P.$qe),this.j=this.B(new P.$qe),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?k.URI.revive(d.source):d.source,profileLocation:k.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map(I=>({...I,local:I.local?R(I.local,null):I.local,source:this.r(I.source)?k.URI.revive(I.source):I.source,profileLocation:k.URI.revive(I.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:k.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:k.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.n(this.j,{profileLocation:k.URI.revive(d.profileLocation),local:R(d.local,null)})))}n(w,d){w.fire(d)}r(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(w){const d=await this.getTargetPlatform();return w.allTargetPlatforms.some(I=>(0,C.$pp)(I,w.allTargetPlatforms,d))}zip(w){return Promise.resolve(this.m.call("zip",[w]).then(d=>k.URI.revive(d)))}install(w,d){return Promise.resolve(this.m.call("install",[w,d])).then(I=>R(I,null))}installFromLocation(w,d){return Promise.resolve(this.m.call("installFromLocation",[w,d])).then(I=>R(I,null))}async installExtensionsFromProfile(w,d,I){return(await this.m.call("installExtensionsFromProfile",[w,d,I])).map(c=>R(c,null))}getManifest(w){return Promise.resolve(this.m.call("getManifest",[w]))}installFromGallery(w,d){return Promise.resolve(this.m.call("installFromGallery",[w,d])).then(I=>R(I,null))}async installGalleryExtensions(w){return(await this.m.call("installGalleryExtensions",[w])).map(I=>({...I,local:I.local?R(I.local,null):I.local,source:this.r(I.source)?k.URI.revive(I.source):I.source,profileLocation:k.URI.revive(I.profileLocation)}))}uninstall(w,d){if(w.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[w,d]))}uninstallExtensions(w){if(w.some(d=>d.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[w]))}reinstallFromGallery(w){return Promise.resolve(this.m.call("reinstallFromGallery",[w])).then(d=>R(d,null))}getInstalled(w=null,d,I){return Promise.resolve(this.m.call("getInstalled",[w,d,I])).then($=>$.map(c=>R(c,null)))}updateMetadata(w,d,I){return Promise.resolve(this.m.call("updateMetadata",[w,d,I])).then($=>R($,null))}resetPinnedStateForAllUserExtensions(w){return this.m.call("resetPinnedStateForAllUserExtensions",[w])}toggleAppliationScope(w,d){return this.m.call("toggleAppliationScope",[w,d]).then(I=>R(I,null))}copyExtensions(w,d){return this.m.call("copyExtensions",[w,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(w,d,I){const $=await this.m.call("download",[w,d,I]);return k.URI.revive($)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Gq=l;class f{constructor(w){this.a=w}listen(w,d){throw new Error("Invalid listen")}call(w,d,I){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(k.URI.revive(I[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Hq=f}),define(fe[190],de([0,1,2,34,7]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class k extends P.$Zc{constructor(C,A,b,R,p){super(),this.a=C,this.b=A,this.c=b,this.f=p,this.B(R.onDidInstallExtensions(m=>this.g(m))),this.B(R.onDidUninstallExtension(m=>this.h(m)))}g(C){for(const A of C)A.local&&this.invalidate(A.profileLocation)}h(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const A of this.a.profiles)this.c.extUri.isEqual(A.extensionsResource,C)&&await this.j(A);else await this.j(this.a.defaultProfile)}async j(C){try{await this.b.del(this.c.extUri.joinPath(C.cacheHome,a.$rn))}catch(A){(0,L.$wl)(A)!==L.FileOperationResult.FILE_NOT_FOUND&&this.f.error(A)}}}e.$5q=k});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(fe[59],de([0,1,20,92,9,60,34,161]),function(ce,e,P,a,L,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=R,e.$7p=p,e.$8p=m,e.$9p=g,e.$0p=l,e.$$p=f,e.$_p=E,e.$aq=w,a=it(a),L=Oe(L),k=Oe(k);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function R($){return $=$.trim(),$==="*"||A.test($)}function p($){if(!R($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=$.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function m($){if(!$)return null;const c=$.majorBase,h=$.majorMustEqual,i=$.minorBase;let n=$.minorMustEqual;const t=$.patchBase;let s=$.patchMustEqual;$.hasCaret&&(c===0||(n=!1),s=!1);let r=0;if($.preRelease){const o=b.exec($.preRelease);if(o){const[,u,y,O]=o;r=Date.UTC(Number(u),Number(y)-1,Number(O))}}return{majorBase:c,majorMustEqual:h,minorBase:i,minorMustEqual:n,patchBase:t,patchMustEqual:s,isMinimum:$.hasGreaterEquals,notBefore:r}}function g($,c,h){let i;typeof $=="string"?i=m(p($)):i=$;let n;c instanceof Date?n=c.getTime():typeof c=="string"&&(n=new Date(c).getTime());let t;if(typeof h=="string"?t=m(p(h)):t=h,!i||!t)return!1;const s=i.majorBase,r=i.minorBase,o=i.patchBase;let u=t.majorBase,y=t.minorBase,O=t.patchBase;const S=t.notBefore;let v=t.majorMustEqual,N=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?s>u?!0:s<u?!1:r>y?!0:r<y||n&&n<S?!1:o>=O:(s===1&&u===0&&(!v||!N||!F)&&(u=1,y=0,O=0,v=!0,N=!1,F=!1),s<u?!1:s>u?!v:r<y?!1:r>y?!N:o<O?!1:o>O?!F:!(n&&n<S))}function l($,c,h,i,n,t){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([a.default.Error,L.localize(1832,null)]),s;if(typeof i.name!="string")return s.push([a.default.Error,L.localize(1833,null,"name")]),s;if(typeof i.version!="string")return s.push([a.default.Error,L.localize(1834,null,"version")]),s;if(!i.engines)return s.push([a.default.Error,L.localize(1835,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([a.default.Error,L.localize(1836,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!I(i.extensionDependencies))return s.push([a.default.Error,L.localize(1837,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!I(i.activationEvents))return s.push([a.default.Error,L.localize(1838,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([a.default.Error,L.localize(1839,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([a.default.Warning,L.localize(1840,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([a.default.Error,L.localize(1841,null,"main")]),s;{const u=(0,P.$lh)(h,i.main);(0,P.$fh)(u,h)||s.push([a.default.Warning,L.localize(1842,null,u.path,h.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([a.default.Error,L.localize(1843,null,"browser")]),s;{const u=(0,P.$lh)(h,i.browser);(0,P.$fh)(u,h)||s.push([a.default.Warning,L.localize(1844,null,u.path,h.path)])}}if(!k.valid(i.version))return s.push([a.default.Error,L.localize(1845,null)]),s;const r=[];if(!f($,c,i,n,r))for(const u of r)s.push([a.default.Error,u]);if(t&&i.enabledApiProposals?.length){const u=[];if(!w([...i.enabledApiProposals],u))for(const y of u)s.push([a.default.Error,y])}return s}function f($,c,h,i,n){return i||typeof h.main>"u"&&typeof h.browser>"u"?!0:d($,c,h.engines.vscode,n)}function E($,c,h){return $==="*"||d(c,h,$)}function w($,c){if($.length===0)return!0;const h=Array.isArray(c)?c:void 0,i=(h?void 0:c)??C.allApiProposals,n=[],t=(0,T.$En)($);for(const{proposalName:s,version:r}of t){const o=i[s];o&&r&&o.version!==r&&n.push(L.localize(1846,null,s))}return h?.push(...n),n.length===0}function d($,c,h,i=[]){const n=m(p(h));if(!n)return i.push(L.localize(1847,null,h)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return i.push(L.localize(1848,null,h)),!1}else if(!n.majorMustEqual)return i.push(L.localize(1849,null,h)),!1;return g($,c,n)?!0:(i.push(L.localize(1850,null,$,h)),!1)}function I($){if(!Array.isArray($))return!1;for(let c=0,h=$.length;c<h;c++)if(typeof $[c]!="string")return!1;return!0}}),define(fe[79],de([0,1,25,2,5,9,27,4]),function(ce,e,P,a,L,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=void 0,e.$gs=A;function A(R){return R.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.$hs=(0,C.$Ki)("languagePackService");let b=class extends a.$Zc{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new P.$Be;setTimeout(()=>p.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const l=m.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(E=>E.startsWith("lp-"))).map(f=>{const E=f.properties.localizedLanguages?.[0],w=A(f);return{...this.f(w,E,f),extensionId:f.identifier.id,galleryExtension:f}});return l.push(this.f("en","English")),l}f(p,m,g){const l=m??p;let f;if(l!==p&&(f=`(${p})`),p.toLowerCase()===L.$z.toLowerCase()&&(f??="",f+=(0,k.localize)(1928,null)),g?.installCount){f??="";const E=g.installCount;let w;E>1e6?w=`${Math.floor(E/1e5)/10}M`:E>1e3?w=`${Math.floor(E/1e3)}K`:w=String(E),f+=` $(cloud-download) ${w}`}return{id:p,label:l,description:f}}};e.$is=b,e.$is=b=Ee([Y(0,T.$rp)],b)}),define(fe[191],de([0,1,2,79]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;let L=class extends P.$Zc{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.$sjc=L,e.$sjc=L=Ee([Y(0,a.$hs)],L)}),define(fe[108],de([0,1,2,4]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=void 0,e.$2l=(0,a.$Ki)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(T,C){return this.a[T]??=[],this.a[T].push(C),(0,P.$Xc)(()=>{const A=this.a[T]?.indexOf(C);typeof A=="number"&&A>=0&&this.a[T]?.splice(A,1)})}b(T){return(this.a[T.type]||[]).find(A=>A.supports(T))}connect(T,C,A,b){const R=this.b(T);if(!R)throw new Error(`No socket factory found for ${T}`);return R.connect(T,C,A,b)}}e.$3l=L}),define(fe[192],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=e.$Fjc=void 0,e.$Fjc=(0,P.$Ki)("sharedProcessTunnelService"),e.$Gjc="sharedProcessTunnel"}),define(fe[109],de([0,1,4,9]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=e.$Pjc=e.$Ojc=e.$Njc=e.$Mjc=e.TunnelStates=e.$Ljc=e.$Kjc=void 0,e.$Kjc=(0,P.$Ki)("IRemoteTunnelService"),e.$Ljc={active:!1};var L;(function(k){k.disconnected=T=>({type:"disconnected",onTokenFailed:T}),k.connected=(T,C)=>({type:"connected",info:T,serviceInstallFailed:C}),k.connecting=T=>({type:"connecting",progress:T}),k.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$Mjc="remote.tunnels.access",e.$Njc=e.$Mjc+".hostNameOverride",e.$Ojc=e.$Mjc+".preventSleep",e.$Pjc="remoteTunnelService",e.$Qjc=(0,a.localize)(2044,null)}),define(fe[61],de([0,1,14,8,2,9,47,4,11,44]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$dq=m,e.$eq=g,e.$fq=l,e.$gq=f,e.$hq=E,e.$iq=w,e.$bq=(0,C.$Ki)("requestService");class R{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const h in this.b)h.toLowerCase()==="authorization"||h.toLowerCase()==="proxy-authorization"?c[h]="*****":c[h]=this.b[h];this.a=c}return this.a}}class p extends L.$Zc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,k.localize)(2050,null),when:A.$xk.isEqualTo((0,A.$uk)(A.LogLevel.Trace)).serialize()})}async c(c,h,i){const n=`${c} #${++this.b}: ${h.url}`;this.a.trace(`${n} - begin`,h.type,new R(h.headers??{}));try{const t=await i();return this.a.trace(`${n} - end`,h.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${n} - error`,h.type,(0,a.$bb)(t)),t}}}e.$cq=p;function m($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}function g($){return $.res.statusCode===204}async function l($){return g($)?null:(await(0,P.$5e)($.stream)).toString()}async function f($){if(!m($))throw new Error("Server returned "+$.res.statusCode);return l($)}async function E($){if(!m($))throw new Error("Server returned "+$.res.statusCode);if(g($))return null;const h=(await(0,P.$5e)($.stream)).toString();try{return JSON.parse(h)}catch(i){throw i.message+=`:
`+h,i}}function w($){I($)}let d;function I($){const c=b.$xo.as(T.$Co.Configuration),h=d;d={id:"http",order:15,title:(0,k.localize)(2051,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(2057,null),(0,k.localize)(2058,null),(0,k.localize)(2059,null),(0,k.localize)(2060,null)],default:"override",description:(0,k.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(2063,null),restricted:!0}}},c.updateConfigurations({add:[d],remove:h?[h]:[]})}I(T.ConfigurationScope.APPLICATION)}),define(fe[193],de([0,1,25,22,7,61]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oS=void 0;let T=class{constructor(A,b){this.a=A,this.b=b}async download(A,b,R=P.CancellationToken.None){if(A.scheme===a.Schemas.file||A.scheme===a.Schemas.vscodeRemote){await this.b.copy(A,b);return}const p={type:"GET",url:A.toString(!0)},m=await this.a.request(p,R);if(m.res.statusCode===200)await this.b.writeFile(b,m.stream);else{const g=await(0,k.$gq)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${g}`)}}};e.$oS=T,e.$oS=T=Ee([Y(0,k.$bq),Y(1,L.$fl)],T)}),define(fe[194],de([0,1,14,25]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=void 0;class L{constructor(C){this.a=C}listen(C,A){throw new Error("Invalid listen")}call(C,A,b,R=a.CancellationToken.None){switch(A){case"request":return this.a.request(b[0],R).then(async({res:p,stream:m})=>{const g=await(0,P.$5e)(m);return[{statusCode:p.statusCode,headers:p.headers},g]});case"resolveProxy":return this.a.resolveProxy(b[0]);case"lookupAuthorization":return this.a.lookupAuthorization(b[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(b[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$ks=L;class k{constructor(C){this.a=C}async request(C,A){const[b,R]=await this.a.call("request",[C],A);return{res:b,stream:(0,P.$7e)(R)}}async resolveProxy(C){return this.a.call("resolveProxy",[C])}async lookupAuthorization(C){return this.a.call("lookupAuthorization",[C])}async lookupKerberosAuthorization(C){return this.a.call("lookupKerberosAuthorization",[C])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ls=k}),define(fe[195],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=e.$eic=e.$dic=void 0,e.$dic={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$eic={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$fic={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(fe[196],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const k=await this.c();if(k){const T=String(P.a++);return this.b.set(T,k),{id:T,data:k.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,k){if(!L.id)return!0;const T=this.b.get(L.id);if(!T)return!1;this.b.delete(L.id);try{return T.validate(k)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$Ydc=P}),define(fe[110],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0,e.$4l="signService",e.$5l=(0,P.$Ki)(e.$4l)}),define(fe[197],de([0,1,69,196]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class L extends a.$Ydc{c(){return this.h().then(T=>new T.validator)}d(T){return this.h().then(C=>new C.signer().sign(T))}async h(){return(0,P.$zq)("vsda","index.js")}}e.$8ic=L}),define(fe[80],de([0,1,3,2]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NNb=e.$MNb=e.$LNb=e.$KNb=void 0;class L extends a.$Zc{constructor(p,m,g){super(),this.a=p,this.b=m,this.c=g}async getItems(){const p={profile:this.b,workspace:this.c},m=await this.a.call("getItems",p);return new Map(m)}updateItems(p){const m={profile:this.b,workspace:this.c};return p.insert&&(m.insert=Array.from(p.insert.entries())),p.delete&&(m.delete=Array.from(p.delete.values())),this.a.call("updateItems",m)}optimize(){const p={profile:this.b,workspace:this.c};return this.a.call("optimize",p)}}class k extends L{constructor(p,m){super(p,m,void 0),this.f=this.B(new P.$qe),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(p=>this.h(p)))}h(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this.f.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}}class T extends k{constructor(p){super(p,void 0)}async close(){this.dispose()}}e.$KNb=T;class C extends k{constructor(p,m){super(p,m)}async close(){this.dispose()}}e.$LNb=C;class A extends L{constructor(p,m){super(p,void 0,m),this.onDidChangeItemsExternal=P.Event.None}async close(){this.dispose()}}e.$MNb=A;class b{constructor(p){this.a=p}isUsed(p){const m={payload:p,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$NNb=b}),define(fe[111],de([0,1,5,37,32]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=T,e.$Cp=C;function k(A){if(P.$x===P.Platform.Linux&&/^penguin(\.|$)/i.test(A))return"chromebook"}function T(A,b,R,p,m,g,l,f,E,w){const d=Object.create(null);d["common.machineId"]=g,d["common.sqmId"]=l,d["common.devDeviceId"]=f,d.sessionID=(0,L.$7g)()+Date.now(),d.commitHash=p,d.version=m,d["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,P.$k)(P.$x),d["common.nodePlatform"]=a.$ic,d["common.nodeArch"]=R,d["common.product"]=w||"desktop",E&&(d["common.msftInternal"]=E);let I=0;const $=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),P.$o&&(d["common.snap"]="true");const c=k(b);return c&&(d["common.platformDetail"]=c),d}function C(A){const b=a.env.USERDNSDOMAIN;if(!b)return!1;const R=b.toLowerCase();return A.some(p=>R===p)}}),define(fe[18],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,P.$Ki)("telemetryService"),e.$fm=(0,P.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var a;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var L;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(fe[198],de([0,1,33,38,6,36,22,13,5,54,10,148,30,153,99,7,23,18]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$7s=I,e.$8s=c,e.$9s=h,P=Oe(P),a=Oe(a);const d=new Map;async function I(n,t){const s=`${n}::${t.join(":")}`,r=d.get(s);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,y=new Map,O=2e4;function S(N,F,U,j){const G=F.substring(N.length+1);return L.Promises.withAsyncBody(async W=>{let x;j.readdirCount++;try{x=await m.Promises.readdir(F,{withFileTypes:!0})}catch{W();return}if(j.count>=O){j.count+=x.length,j.maxReached=!0,W();return}let V=x.length;if(V===0){W();return}let te=x;j.count+x.length>O&&(j.maxReached=!0,V=O-j.count,te=x.slice(0,V)),j.count+=x.length;for(const B of te)if(B.isDirectory()){if(U.includes(B.name)||await S(N,(0,C.$oc)(F,B.name),U,j),--V===0){W();return}}else{const H=B.name.lastIndexOf(".");if(H>=0){const _=B.name.substring(H+1);_&&u.set(_,(u.get(_)??0)+1)}for(const _ of o)_.relativePathPattern?.test(G)!==!1&&_.filePattern.test(B.name)&&y.set(_.tag,(y.get(_.tag)??0)+1);if(--V===0){W();return}}})}const v=L.Promises.withAsyncBody(async N=>{const F={count:0,maxReached:!1,readdirCount:0},U=new b.$ke(!0);await S(n,n,t,F);const j=await h(n);N({configFiles:$(y),fileTypes:$(u),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:j,totalScanTime:U.elapsed(),totalReaddirCount:F.readdirCount})});return d.set(s,v),v}function $(n){return Array.from(n.entries(),([t,s])=>({name:t,count:s})).sort((t,s)=>s.count-t.count)}function c(){const n={os:`${a.type()} ${a.arch()} ${a.release()}`,memory:`${(a.totalmem()/f.$Nl.GB).toFixed(2)}GB (${(a.freemem()/f.$Nl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(p.$Yn.value()*100)}%`},t=a.cpus();return t&&t.length>0&&(n.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),n}async function h(n){try{const t=new Map,s=(0,C.$oc)(n,".vscode","launch.json"),r=await P.promises.readFile(s),o=[],u=(0,k.$5n)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,k.$ao)(u)==="object"&&u.configurations)for(const y of u.configurations){const O=y.type;O&&(t.has(O)?t.set(O,t.get(O)+1):t.set(O,1))}return $(t)}catch{return[]}}let i=class{constructor(t,s){this.c=t,this.d=s}f(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}g(t){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${a.type()} ${a.arch()} ${a.release()}`);const r=a.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(a.totalmem()/f.$Nl.GB).toFixed(2)}GB (${(a.freemem()/f.$Nl.GB).toFixed(2)}GB free)`),A.$l||s.push(`Load (avg):       ${a.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(p.$Yn.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,g.$6s)(t.mainPID),this.k(t)]).then(async r=>{let[o,u]=r,y=this.m(t,o);return s.forEach(O=>{if((0,l.$Zm)(O))y+=`
${O.errorMessage}`,u+=`
${O.errorMessage}`;else if(y+=`

Remote: ${O.hostName}`,O.processes&&(y+=`
${this.m(t,O.processes)}`),O.workspaceMetadata){u+=`
|  Remote: ${O.hostName}`;for(const S of Object.keys(O.workspaceMetadata)){const v=O.workspaceMetadata[S];let N=`${v.fileCount} files`;v.maxFilesReached&&(N=`more than ${N}`),u+=`|    Folder (${S}): ${N}`,u+=this.h(v)}}}),{processInfo:y,workspaceInfo:u}})}async getSystemInfo(t,s){const{memory:r,vmHint:o,os:u,cpus:y}=c(),O={os:u,memory:r,cpus:y,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return A.$l||(O.load=`${a.loadavg().map(S=>Math.round(S)).join(", ")}`),A.$n&&(O.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(O)}async getDiagnostics(t,s){const r=[];return(0,g.$6s)(t.mainPID).then(async o=>(r.push(""),r.push(this.g(t)),r.push(""),r.push(this.m(t,o)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(t))),s.forEach(u=>{if((0,l.$Zm)(u))r.push(`
${u.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${u.hostName}`),r.push(this.f(u.machineInfo)),u.processes&&r.push(this.m(t,u.processes)),u.workspaceMetadata)for(const y of Object.keys(u.workspaceMetadata)){const O=u.workspaceMetadata[y];let S=`${O.fileCount} files`;O.maxFilesReached&&(S=`more than ${S}`),r.push(`Folder (${y}): ${S}`),r.push(this.h(O))}}),r.push(""),r.push(""),r.join(`
`)))}h(t){const s=[];let o=0;const u=(v,N)=>{const F=` ${v}(${N})`;o+F.length>60?(s.push(y),y="|                 ",o=y.length):o+=F.length,y+=F};let y="|      File types:";const O=10,S=t.fileTypes.length>O?O:t.fileTypes.length;for(let v=0;v<S;v++){const N=t.fileTypes[v];u(N.name,N.count)}if(s.push(y),t.configFiles.length>=0&&(y="|      Conf files:",o=0,t.configFiles.forEach(v=>{u(v.name,v.count)}),s.push(y)),t.launchConfigFiles.length>0){let v="|      Launch Configs:";t.launchConfigFiles.forEach(N=>{const F=N.count>1?` ${N.name}(${N.count})`:` ${N.name}`;v+=F}),s.push(v)}return s.join(`
`)}j(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}k(t){const s=[],r=[];return t.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const y=R.URI.revive(u);if(y.scheme===T.Schemas.file){const O=y.fsPath;r.push(I(O,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),s.push(`|    Folder (${(0,C.$sc)(O)}): ${v}`),s.push(this.h(S))}).catch(S=>{s.push(`|      Error: Unable to collect workspace stats for folder ${O} (${S.toString()})`)}))}else s.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(t,s){const r=new Map;t.windows.forEach(u=>r.set(u.pid,`window [${u.id}] (${u.title})`)),t.pidToNames.forEach(({pid:u,name:y})=>r.set(u,y));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(t.mainPID,r,o,s,0),o.join(`
`)}n(t,s,r,o,u){const y=u===0;let O;y?O=o.pid===t?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?O=s.get(o.pid):O=`${"  ".repeat(u)} ${o.name}`;const S=process.platform==="win32"?o.mem:a.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(S/f.$Nl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${O}`),Array.isArray(o.children)&&o.children.forEach(v=>this.n(t,s,r,v,u+1))}async getWorkspaceFileExtensions(t){const s=new Set;for(const{uri:r}of t.folders){const o=R.URI.revive(r);if(o.scheme!==T.Schemas.file)continue;const u=o.fsPath;try{(await I(u,["node_modules",".git"])).fileTypes.forEach(O=>s.add(O.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=R.URI.revive(s);if(r.scheme!==T.Schemas.file)continue;const o=r.fsPath;try{const u=await I(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),u.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),u.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:u.totalScanTime,reachedLimit:u.maxFilesReached,fileCount:u.fileCount,readdirCount:u.totalReaddirCount})}catch{}}}};e.$0s=i,e.$0s=i=Ee([Y(0,w.$em),Y(1,E.$yk)],i)}),define(fe[112],de([0,1,69,8,4,11,18]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.ExtensionSignatureVerificationCode=e.$Bq=void 0,e.$Bq=(0,L.$Ki)("IExtensionSignatureVerificationService");var C;(function(R){R.Success="Success",R.RequiredArgumentMissing="RequiredArgumentMissing",R.InvalidArgument="InvalidArgument",R.PackageIsUnreadable="PackageIsUnreadable",R.UnhandledException="UnhandledException",R.SignatureManifestIsMissing="SignatureManifestIsMissing",R.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",R.SignatureIsMissing="SignatureIsMissing",R.SignatureIsUnreadable="SignatureIsUnreadable",R.CertificateIsUnreadable="CertificateIsUnreadable",R.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",R.FileAlreadyExists="FileAlreadyExists",R.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",R.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",R.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",R.SignatureIsInvalid="SignatureIsInvalid",R.SignatureManifestIsInvalid="SignatureManifestIsInvalid",R.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",R.EntryIsMissing="EntryIsMissing",R.EntryIsTampered="EntryIsTampered",R.Untrusted="Untrusted",R.CertificateRevoked="CertificateRevoked",R.SignatureIsNotValid="SignatureIsNotValid",R.UnknownError="UnknownError",R.PackageIsInvalidZip="PackageIsInvalidZip",R.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(C||(e.ExtensionSignatureVerificationCode=C={}));class A extends Error{constructor(p){super(p),this.code=p}}e.$Cq=A;let b=class{constructor(p,m){this.b=p,this.c=m}d(){return this.a||(this.a=this.f()),this.a}async f(){return(0,P.$zq)("@vscode/vsce-sign","src/main.js")}async verify(p,m,g,l){let f;const E=p.identifier.id;try{f=await this.d()}catch($){return this.b.error("Could not load vsce-sign module",(0,a.$bb)($)),this.b.info(`Extension signature verification is not done: ${E}`),!1}const w=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${E}...`),d=await f.verify(m,g,this.b.getLevel()===k.LogLevel.Trace)}catch($){d={code:C.UnknownError,didExecute:!1,output:(0,a.$bb)($)}}const I=new Date().getTime()-w;if(this.b.info(`Extension signature verification result for ${E}: ${d.code}. Executed: ${d.didExecute}. Duration: ${I}ms.`),this.b.trace(`Extension signature verification output for ${E}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:E,extensionVersion:p.version,code:d.code,internalCode:d.internalCode,duration:I,didExecute:d.didExecute,clientTargetPlatform:l}),d.code===C.Success)return!0;throw new A(d.code)}};e.$Dq=b,e.$Dq=b=Ee([Y(0,k.$fk),Y(1,T.$em)],b)}),define(fe[113],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=void 0;class P{constructor(k){this.b=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,{eventName:C,data:A}){return this.b.forEach(b=>b.log(C,A)),Promise.resolve(null)}}e.$iic=P;class a{constructor(k){this.b=k}log(k,T){return this.b.call("log",{eventName:k,data:T}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$jic=a}),define(fe[48],de([0,1,29,12,107,111,18]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Kp=R,e.$Lp=p,e.$Mp=m,e.$Np=g,e.$Op=f,e.$Pp=w,e.$Qp=d,e.$Rp=c;class C{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$Dp=C;class A{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ep=A,e.$Fp=new A;class b{async publicLog(i,n,t){}async publicLogError(i,n,t){}}e.$Gp=b,e.$Hp="telemetry",e.$Ip="extensionTelemetryLog",e.$Jp={log:()=>null,flush:()=>Promise.resolve(null)};function R(h,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!h.enableTelemetry)}function p(h,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}function m(h){const i=h.getValue(T.$nm),n=h.getValue(T.$om);if(h.getValue(T.$pm)===!1||n===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function g(h){const i={},n={},t={};E(h,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const r=t[s];typeof r=="number"?n[s]=r:typeof r=="boolean"?n[s]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${r.length}`),i[s]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[s]=r)}return{properties:i,measurements:n}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(h){if(!h)return"none";const i=(0,L.$on)(h);return l.has(i)?i:"other"}function E(h,i,n=0,t){if(h)for(const s of Object.getOwnPropertyNames(h)){const r=h[s],o=t?t+s:s;Array.isArray(r)?i[o]=(0,P.$po)(r):r instanceof Date?i[o]=r.toISOString():(0,a.$lg)(r)?n<2?E(r,i,n+1,o+"."):i[o]=(0,P.$po)(r):i[o]=r}}function w(h,i){const n=h.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,k.$Cp)(n)||t}function d(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}function I(h,i){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let n=h;const t=[];for(const u of i)for(;;){const y=u.exec(h);if(!y)break;t.push([y.index,u.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(n="";;){const u=r.exec(h);if(!u)break;const y=t.some(([O,S])=>u.index<S&&O<r.lastIndex);!s.test(u[0])&&!y&&(n+=h.substring(o,u.index)+"<REDACTED: user-file-path>",o=r.lastIndex)}return o<h.length&&(n+=h.substr(o)),n}function $(h){if(!h)return h;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of i)if(n.regex.test(h))return`<REDACTED: ${n.label}>`;return h}function c(h,i){return(0,P.$mo)(h,n=>{if(n instanceof C||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let t=n.replaceAll("%20"," ");t=I(t,i);for(const s of i)t=t.replace(s,"");return t=$(t),t}})}}),define(fe[35],de([0,1,26,27,34,5,10,8,37,48]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Tp=void 0,e.$Sp=R,e.$Up=l,e.$Vp=f,e.$Wp=E,e.$Xp=w,e.$Yp=d,e.$Zp=I,e.$1p=$,e.$3p=c,e.$4p=i;function R(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,P.$Ff)(n.id,t.id)===0}const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new m(t.identifier,s,r)}static parse(t){const s=p.exec(t);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r=L.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==L.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof m?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Tp=m;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(n){const t=g.exec(n);return t&&t[1]?[E(t[1]),t[2]]:[E(n),void 0]}function f(n,t){return`${n}.${t}`}function E(n){return n.toLowerCase()}function w(n,t){return E(f(n??L.$tn,t))}function d(n,t){const s=[],r=o=>{for(const u of s)if(u.some(y=>R(t(y),t(o))))return u;return null};for(const o of n){const u=r(o);u?u.push(o):s.push([o])}return s}function I(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function $(n){return{id:new b.$Dp(n.identifier.id),name:new b.$Dp(n.name),version:n.version,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$2p=new L.$xn("pprice.better-merge");function c(n,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&s.every(u=>!R(u.identifier,{id:o}))){const u=n.filter(y=>R(y.identifier,{id:o}));u.length===1&&(s.push(u[0]),r.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function h(n,t){if(!k.$n)return!1;let s;try{s=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){t.debug("Error while getting the os-release file.",(0,C.$bb)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(n,t){const s=await h(n,t),r=(0,a.$np)(s?"alpine":k.$x,A.$jc);return t.debug("ComputeTargetPlatform:",r),r}}),define(fe[199],de([0,1,25,27,35,34]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V8b=T;async function T(C,A,b,R,p){try{const m=await C.getExtensionsControlManifest();if(!m.deprecated)return;const g=await C.getInstalled(k.ExtensionType.User);for(const[l,f]of Object.entries(m.deprecated)){if(!f?.extension)continue;const{id:E,autoMigrate:w,preRelease:d}=f.extension;if(!w)continue;const I=g.find(c=>(0,L.$Sp)(c.identifier,{id:l}));if(!I)continue;const $=(await A.getExtensions([{id:E,preRelease:d}],{targetPlatform:await C.getTargetPlatform(),compatible:!0},P.CancellationToken.None))[0];if(!$){p.info(`Skipping migrating '${I.identifier.id}' extension because, the comaptible target '${E}' extension is not found`);continue}try{p.info(`Migrating '${I.identifier.id}' extension to '${E}' extension...`);const c=!R.getDisabledExtensions().some(i=>(0,L.$Sp)(i,I.identifier));await C.uninstall(I),p.info(`Uninstalled the unsupported extension '${I.identifier.id}'`);let h=g.find(i=>(0,L.$Sp)(i.identifier,{id:E}));(!h||!h.isPreReleaseVersion&&c)&&(h=await C.installFromGallery($,{installPreReleaseVersion:!0,isMachineScoped:I.isMachineScoped,operation:a.InstallOperation.Migrate}),p.info(`Installed the pre-release extension '${h.identifier.id}'`),c||(await R.disableExtension(h.identifier),p.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${I.identifier.id}' is disabled`)),w.storage&&(b.addToMigrationList((0,L.$Vp)(I.manifest.publisher,I.manifest.name),(0,L.$Vp)(h.manifest.publisher,h.manifest.name)),p.info("Added pre-release extension to the storage migration list"))),p.info(`Migrated '${I.identifier.id}' extension to '${E}' extension.`)}catch(c){p.error(c)}}}catch(m){p.error(m)}}}),define(fe[200],de([0,1,8,3,2,31,35,34,7]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class b extends L.$Zc{constructor(p,m,g,l,f,E,w){super(),this.f=p,this.g=m,this.h=g,this.j=l,this.m=f,this.n=E,this.r=w,this.a=this.B(new a.$qe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.$9c),this.s().then(null,d=>w.error("Error while initializing Extensions Watcher",(0,P.$bb)(d)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(p=>this.u(p.added))),this.B(this.j.onAddExtensions(p=>this.w(p))),this.B(this.j.onDidAddExtensions(p=>this.y(p))),this.B(this.j.onRemoveExtensions(p=>this.z(p))),this.B(this.j.onDidRemoveExtensions(p=>this.C(p))),this.B(this.n.onDidFilesChange(p=>this.D(p)))}async u(p){try{p.length&&await Promise.all(p.map(m=>(this.c.set(m.id,(0,L.$Wc)(this.n.watch(this.m.extUri.dirname(m.extensionsResource)),this.n.watch(m.extensionsResource))),this.G(m.extensionsResource))))}catch(m){throw this.r.error(m),m}}async w(p){for(const m of p.extensions)this.I(this.L(m.identifier,m.version),p.profileLocation)}async y(p){for(const m of p.extensions){const g=this.L(m.identifier,m.version);p.error?this.J(g,p.profileLocation):this.I(g,p.profileLocation)}}async z(p){for(const m of p.extensions)this.J(this.L(m.identifier,m.version),p.profileLocation)}async C(p){const m=[],g=[];for(const l of p.extensions){const f=this.L(l.identifier,l.version);p.error?this.I(f,p.profileLocation):(this.J(f,p.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",l.identifier.id,l.version),g.push(this.f.scanInstalledExtensionAtLocation(l.location).then(E=>{E?m.push(E):this.r.info("Extension not found at the location",l.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(g),m.length&&await this.H(m)}catch(l){this.r.error(l)}}D(p){for(const m of this.h.profiles)p.contains(m.extensionsResource,A.FileChangeType.UPDATED,A.FileChangeType.ADDED)&&this.F(m.extensionsResource)}async F(p){const m=[],g=[],l=await this.j.scanProfileExtensions(p),f=new Set,E=new Set;for(const[w,d]of this.b)d.has(p)&&E.add(w);for(const w of l){const d=this.L(w.identifier,w.version);f.add(d),E.has(d)||(m.push(w.identifier),this.I(d,p))}for(const w of E)if(!f.has(w)){const d=this.M(w);d&&(g.push(d.identifier),this.J(w,p))}(m.length||g.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:p}:void 0,removed:g.length?{extensions:g,profileLocation:p}:void 0})}async G(p){const m=await this.j.scanProfileExtensions(p);for(const g of m)this.I(this.L(g.identifier,g.version),p)}async H(p){p||(p=(await this.f.scanAllUserInstalledExtensions()).filter(g=>!this.b.has(this.L(g.identifier,g.manifest.version)))),p.length&&await this.f.markAsUninstalled(...p)}I(p,m){let g=this.b.get(p);g||this.b.set(p,g=new k.$Gc(l=>this.m.extUri.getComparisonKey(l))),g.add(m)}J(p,m){const g=this.b.get(p);g&&g.delete(m),g?.size||this.b.delete(p)}L(p,m){return`${C.$xn.toKey(p.id)}@${m}`}M(p){const[m,g]=(0,T.$Up)(p);return g?{identifier:{id:m},version:g}:void 0}}e.$6q=b}),define(fe[201],de([0,1,33,76,17,6,2,22,13,30,15,27,35,11,79,10]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0,P=Oe(P);let E=class extends l.$is{constructor($,c,h,i){super(h),this.h=$,this.j=i,this.g=this.B(new w(c,i)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri($,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const n=i.translations[$];return n?f.URI.file(n):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),c=Object.keys($).map(h=>{const i=$[h];return{...this.f(h,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((h,i)=>h.label.localeCompare(i.label)),c}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const c=await this.g.getLanguagePacks();Object.keys(c).some(h=>c[h]&&c[h].extensions.some(i=>(0,m.$Sp)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(c);return!(0,L.$yb)(Object.keys($),Object.keys(h))}};e.$js=E,e.$js=E=Ee([Y(0,p.$up),Y(1,R.$Si),Y(2,p.$rp),Y(3,g.$fk)],E);let w=class extends T.$Zc{constructor($,c){super(),this.j=c,this.c={},this.f=(0,A.$oc)($.userDataPath,"languagepacks.json"),this.g=new k.$Rh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(c=>{Object.keys(c).forEach(h=>delete c[h]),this.m(c,...$)}).then(()=>this.c)}m($,...c){for(const h of c)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n($,h);Object.keys($).forEach(h=>this.r($[h]))}n($,c){const h=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const n of i)if(c.location.scheme===C.Schemas.file&&d(n)){let t=$[n.languageId];t||(t={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},$[n.languageId]=t);const s=t.extensions.filter(r=>(0,m.$Sp)(r.extensionIdentifier,h))[0];s?s.version=c.manifest.version:t.extensions.push({extensionIdentifier:h,version:c.manifest.version});for(const r of n.translations)t.translations[r.id]=(0,A.$oc)(c.location.fsPath,r.path)}}r($){if($){const c=(0,a.createHash)("md5");for(const h of $.extensions)c.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);$.hash=c.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let c=null;return P.promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(c=$(h),h)).then(h=>{for(const n of Object.keys(h))h[n]||delete h[n];this.c=h,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),b.Promises.writeFile(this.f,i)}).then(()=>c,h=>this.j.error(h))})}};w=Ee([Y(0,R.$Si),Y(1,g.$fk)],w);function d(I){if(typeof I.languageId!="string"||!Array.isArray(I.translations)||I.translations.length===0)return!1;for(const $ of I.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(I.languageName&&typeof I.languageName!="string"||I.localizedLanguageName&&typeof I.localizedLanguageName!="string")}}),define(fe[202],de([0,1,69,8,29,5,48]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WR=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function b(p,m,g){k.$r;const l=await(0,P.$zq)("@microsoft/1ds-core-js","dist/ms.core.js"),f=await(0,P.$zq)("@microsoft/1ds-post-js","dist/ms.post.js"),E=new l.AppInsightsCore,w=new f.PostChannel,d={instrumentationKey:p,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(g){d.extensionConfig={};const I={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:g};d.extensionConfig[w.identifier]=I}return E.initialize(d,[]),E.addTelemetryInitializer(I=>{I.ext=I.ext??{},I.ext.web=I.ext.web??{},I.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',m&&(I.ext.utc=I.ext.utc??{},I.ext.utc.flags=8462029)}),E}class R{constructor(m,g,l,f,E){this.e=m,this.f=g,this.g=l,this.h=E,this.c=C,this.d=A,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(m){if(this.a){if(typeof this.a!="string"){m(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(g=>{m(g)},g=>{(0,a.$4)(g),console.error(g)})}}log(m,g){if(!this.a)return;g=(0,L.$no)(g,this.g),g=(0,T.$Np)(g);const l=this.f+"/"+m;try{this.i(f=>{f.pluginVersionString=g?.properties.version??"Unknown",f.track({name:l,baseData:{name:l,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(m=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.$WR=R}),define(fe[114],de([0,1,2,9,15,11,23,48]),function(ce,e,P,a,L,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;let A=class extends P.$Zc{constructor(R,p,m,g,l=""){super(),this.b=l;const f=p.getLogger(C.$Hp);if(f)this.a=this.B(f);else{const w=(0,C.$Lp)(g,m)?" (Not Sent)":"",d=()=>(0,C.$Kp)(g,m)&&R.getLevel()===k.LogLevel.Trace;this.a=this.B(p.createLogger(C.$Hp,{name:(0,a.localize)(2067,null,w),hidden:!d()})),this.B(R.onDidChangeLogLevel(()=>p.setVisibility(C.$Hp,d()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(R,p){this.a.trace(`${this.b}telemetry/${R}`,(0,C.$Np)(p))}};e.$wfc=A,e.$wfc=A=Ee([Y(0,k.$fk),Y(1,k.$gk),Y(2,L.$Ri),Y(3,T.$yk)],A)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(fe[115],de([0,1,2,29,5,26,9,21,47,104,23,44,18,48]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0,b=it(b);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(w,d,I){this.k=d,this.l=I,this.d={},this.i=new P.$Yc,this.j=[],this.b=w.appenders,this.c=w.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=w.piiPaths||[],this.g=m.TelemetryLevel.USAGE,this.h=!!w.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,k.$mf)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$mf)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(m.$nm)||$.affectsConfiguration(m.$pm)||$.affectsConfiguration(m.$om))&&this.m()}))}setExperimentProperty(w,d){this.d[w]=d}m(){let w=(0,g.$Mp)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const I=d.usage?m.TelemetryLevel.USAGE:d.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;w=Math.min(w,I)}this.g=w}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(w,d,I){this.g<d||(I=(0,a.$no)(I,this.d),I=(0,g.$Rp)(I,this.j),I=(0,a.$no)(I,this.c),this.b.forEach($=>$.log(w,I)))}publicLog(w,d){this.n(w,m.TelemetryLevel.USAGE,d)}publicLog2(w,d){this.publicLog(w,d)}publicLogError(w,d){this.h&&this.n(w,m.TelemetryLevel.ERROR,d)}publicLogError2(w,d){this.publicLogError(w,d)}};e.$ps=l,e.$ps=l=Ee([Y(1,C.$ej),Y(2,R.$yk)],l);function f(){const E=(0,T.localize)(2068,null,b.default.nameLong),w=b.default.privacyStatementUrl?(0,T.localize)(2070,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,T.localize)(2069,null,"https://aka.ms/vscode-telemetry"),d=L.$r?"":(0,T.localize)(2071,null),I=(0,T.localize)(2072,null),$=(0,T.localize)(2073,null),c=(0,T.localize)(2074,null),h=(0,T.localize)(2075,null),i=`
|       | ${I} | ${$} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,T.localize)(2076,null);return`
${E} ${w} ${d}

&nbsp;

${h}
${i}

&nbsp;

${n}
`}p.$xo.as(A.$Co.Configuration).registerConfiguration({id:m.$mm,order:1,type:"object",title:(0,T.localize)(2077,null),properties:{[m.$nm]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(2078,null),(0,T.localize)(2079,null),(0,T.localize)(2080,null),(0,T.localize)(2081,null)],markdownDescription:f(),default:m.TelemetryConfiguration.ON,restricted:!0,scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),p.$xo.as(A.$Co.Configuration).registerConfiguration({id:m.$mm,order:110,type:"object",title:(0,T.localize)(2082,null),properties:{[m.$pm]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,T.localize)(2084,null,b.default.nameLong,b.default.privacyStatementUrl):(0,T.localize)(2083,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(2085,null,`\`#${m.$nm}#\``),scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(fe[203],de([0,1,14,25,246,202]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XR=void 0,L=Oe(L);async function T(R,p){const m=await p.request(R,a.CancellationToken.None),g=(await(0,P.$5e)(m.stream)).toString(),l=m.res.statusCode??200;return{headers:m.res.headers,statusCode:l,responseData:g}}async function C(R){const p={method:R.type,headers:R.headers};return new Promise((g,l)=>{const f=L.request(R.url??"",p,E=>{E.on("data",function(w){g({headers:E.headers,statusCode:E.statusCode??200,responseData:w.toString()})}),E.on("error",function(w){l(w)})});f.write(R.data,E=>{E&&l(E)}),f.end()})}async function A(R,p,m){const g=typeof p.data=="string"?p.data:new TextDecoder().decode(p.data),l={type:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data).toString()},url:p.urlString,data:g};try{const f=R?await T(l,R):await C(l);m(f.statusCode,f.headers,f.responseData)}catch{m(0,{})}}class b extends k.$WR{constructor(p,m,g,l,f){const E={sendPOST:(w,d)=>{A(p,w,d)}};super(m,g,l,f,E)}}e.$XR=b}),define(fe[204],de([0,1,22,97,21,15,11,23,18,113,114,115]),function(ce,e,P,a,L,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;let m=class{constructor(l,f,E,w,d,I){this.b=l,this.c=f,this.d=E,this.e=w,this.f=d,this.g=I,this.a=new Map}h(l){if(!this.a.has(l.id)){const f=Object.create(null);f["common.vscodemachineid"]=this.c.machineId,f["common.vscodesessionid"]=this.c.sessionId;const E=[l.id,JSON.stringify(f),l.aiKey],d=new a.$qr(P.$5g.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new b.$jic(d),new R.$wfc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new p.$ps({appenders:I,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,f,E){this.h(l).publicLog(f,E)}publicLogError(l,f,E){this.h(l).publicLogError(f,E)}};e.$xjc=m,e.$xjc=m=Ee([Y(0,L.$ej),Y(1,A.$em),Y(2,T.$fk),Y(3,T.$gk),Y(4,k.$Ri),Y(5,C.$yk)],m)}),define(fe[81],de([0,1,3,2,5,10,21,4,11]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yw=e.$Xw=e.$Uw=e.$Sw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ow=e.$Nw=void 0,e.$Pw=p,e.$Qw=g,e.$Rw=l,e.$Tw=f,e.$Vw=E,e.$Ww=w,e.$Nw=(0,C.$Ki)("tunnelService"),e.$Ow=(0,C.$Ki)("sharedTunnelsService");var b;(function($){$.Http="http",$.Https="https"})(b||(e.TunnelProtocol=b={}));var R;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(R||(e.TunnelPrivacyId=R={}));function p($){return!!$.forwardPort}var m;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function g($){if($.scheme!=="http"&&$.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(c)return{address:c[1],port:+c[2]}}function l($){if($.scheme!=="http"&&$.scheme!=="https"||!$.query)return;const c=$.query.split("&");for(const h of c){const i=h.split("=")[1];if(/^https?:/.exec(i)){const n=g(k.URI.parse(i));if(n)return n}}}e.$Sw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function f($){return e.$Sw.indexOf($)>=0}e.$Uw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E($){return e.$Uw.indexOf($)>=0}function w($,c,h,i){if(h===L.OperatingSystem.Windows)return!1;if(h===L.OperatingSystem.Macintosh&&E(c)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(n?.length===4&&parseInt(n[1])>=18)return!1}return $<1024}class d{constructor(c,h,i){this.remoteAddress=c,this.localAddress=h,this.b=i,this.a=new P.$qe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Xw=d;let I=class extends a.$Zc{constructor(c,h){super(),this.r=c,this.s=h,this.a=new P.$qe,this.onTunnelOpened=this.a.event,this.b=new P.$qe,this.onTunnelClosed=this.b.event,this.c=new P.$qe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const c=this.s.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.g=c,c?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.h=c.elevation,this.m=c.privacyOptions,this.j=c.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const c=[],h=Array.from(this.f.values());for(const i of h){const n=Array.from(i.values());for(const t of n){const s=await t.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){super.dispose();for(const c of this.f.values()){for(const{value:h}of c.values())await h.then(i=>typeof i!="string"?i?.dispose():void 0);c.clear()}this.f.clear()}setEnvironmentTunnel(c,h,i,n,t){this.z(c,h,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:h,localAddress:i,privacy:n,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,h){(E(c)||f(c))&&(c=e.$Sw[0]);const i=this.D(c,h);if(i)return++i.refcount,i.value}openTunnel(c,h,i,n,t,s=!1,r,o){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${i} on local port ${t}.`);const u=this.g??c;if(!u)return;if(h||(h="localhost"),n||(n=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.F(u,h,i,n,t,s,r,o);return y?y.then(O=>{if(O){if(typeof O=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(h,i),O}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(h,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.w(O);return(O.tunnelRemoteHost!==h||O.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&O.privacy!==r&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}w(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const h=this.f.get(c.tunnelRemoteHost);if(h){const i=h.get(c.tunnelRemotePort);i&&(i.refcount--,await this.y(c.tunnelRemoteHost,c.tunnelRemotePort,i))}}}}async y(c,h,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${h}.`);const n=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(c)&&this.f.get(c).delete(h),n}}async closeTunnel(c,h){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${h} `);const i=this.f.get(c);if(i&&i.has(h)){const n=i.get(h);n.refcount=0,await this.y(c,h,n)}}z(c,h,i){this.f.has(c)||this.f.set(c,new Map),this.f.get(c).set(h,{refcount:1,value:i})}async C(c,h){const i=this.f.get(c);if(i){const n=i.get(h),t=n?await n.value:void 0;(!t||typeof t=="string")&&i.delete(h),i.size===0&&this.f.delete(c)}}D(c,h){const i=[c];f(c)?(i.push(...e.$Sw),i.push(...e.$Uw)):E(c)&&i.push(...e.$Uw);const n=i.map(t=>this.f.get(t));for(const t of n){const s=t?.get(h);if(s)return s}}canTunnel(c){return!!g(c)}G(c,h,i,n,t,s,r){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${i} on local port ${n}.`);const o=i;this.n.add(o);const u=n===void 0?i:n,y={elevationRequired:t?this.isPortPrivileged(u):!1},O={remoteAddress:{host:h,port:i},localAddressPort:n,privacy:s,public:s?s!==R.Private:void 0,protocol:r},S=c.forwardPort(O,y);return S?(this.z(h,i,S),S.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(o)})):this.n.delete(o),S}};e.$Yw=I,e.$Yw=I=Ee([Y(0,A.$fk),Y(1,T.$ej)],I)}),define(fe[205],de([0,1,11,81,2,8,6]),function(ce,e,P,a,L,k,T){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class A extends L.$Zc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.$8h),this.b.p)}setAddress(p){this.a=p,this.b&&(this.b.complete(p),this.b=null)}setTunnel(p){this.B(p)}}let b=class extends L.$Zc{static{C=this}static{this.a=0}constructor(p,m){super(),this.f=p,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(p=>p.dispose())}async createTunnel(){return{id:String(++C.a)}}async startTunnel(p,m,g,l,f,E,w){const d=new A,I=await Promise.resolve(this.f.openTunnel(p,d,g,l,f,E,w));if(!I||typeof I=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${l} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),d.dispose(),await I.dispose(),(0,k.$0)();return d.setTunnel(I),this.b.set(m,d),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${I.localAddress} (local) to ${g}:${l} (remote).`),{tunnelLocalPort:I.tunnelLocalPort,localAddress:I.localAddress}}async setAddress(p,m){const g=this.b.get(p);g&&g.setAddress(m)}async destroyTunnel(p){const m=this.b.get(p);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${p}.`),this.b.delete(p),await m.dispose();return}this.c.add(p)}};e.$Hjc=b,e.$Hjc=b=C=Ee([Y(0,a.$Ow),Y(1,P.$fk)],b)}),define(fe[28],de([0,1,4]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,P.$Ki)("IUriIdentityService")}),define(fe[206],de([0,1,28,162,7,20,135,3,2]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0;class b{static{this._clock=0}constructor(m){this.uri=m,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let R=class{constructor(m){this.g=m,this.c=new A.$Yc,this.f=2**16;const g=new Map,l=f=>{let E=g.get(f.scheme);return E===void 0&&(E=m.hasProvider(f)&&!this.g.hasCapability(f,L.FileSystemProviderCapabilities.PathCaseSensitive),g.set(f.scheme,E)),E};this.c.add(C.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(f=>{g.delete(f.scheme)})),this.extUri=new k.$ah(l),this.d=new T.$2s((f,E)=>this.extUri.compare(f,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,k.$mh)(m));const g=this.d.get(m);return g?g.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new b(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((l,f)=>l[1].time<f[1].time?1:l[1].time>f[1].time?-1:0);b._clock=0,this.d.clear();const g=this.f*.5;for(let l=0;l<g;l++)this.d.set(m[l][0],m[l][1].touch())}};e.$3s=R,e.$3s=R=Ee([Y(0,L.$fl)],R),(0,a.$Zs)(P.$Pl,R,a.InstantiationType.Delayed)}),define(fe[207],de([0,1,3,2,7,51,31]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=void 0;class C extends a.$Zc{constructor(b,R,p,m,g,l){super(),this.f=b,this.g=R,this.h=p,this.j=m,this.m=g,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$qe),this.onDidChangeFile=this.a.event,this.b=k.$Qi.forUris(()=>!(this.capabilities&L.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Gc(f=>this.m.extUri.getComparisonKey(this.t(f))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(f=>this.s(f)))}r(){this.c.clear();for(const b of this.j.profiles)this.c.add(b.settingsResource),this.c.add(b.keybindingsResource),this.c.add(b.tasksResource),this.c.add(b.extensionsResource)}open(b,R){return this.g.open(this.t(b),R)}close(b){return this.g.close(b)}read(b,R,p,m,g){return this.g.read(b,R,p,m,g)}write(b,R,p,m,g){return this.g.write(b,R,p,m,g)}watch(b,R){this.b.set(b,b);const p=this.g.watch(this.t(b),R);return(0,a.$Xc)(()=>{this.b.delete(b),p.dispose()})}stat(b){return this.g.stat(this.t(b))}mkdir(b){return this.g.mkdir(this.t(b))}rename(b,R,p){return this.g.rename(this.t(b),this.t(R),p)}readFile(b,R){return this.g.readFile(this.t(b),R)}readFileStream(b,R,p){return this.g.readFileStream(this.t(b),R,p)}readdir(b){return this.g.readdir(this.t(b))}enforceAtomicReadFile(b){return this.c.has(b)}writeFile(b,R,p){return this.g.writeFile(this.t(b),R,p)}enforceAtomicWriteFile(b){return this.c.has(b)?{postfix:".vsctmp"}:!1}delete(b,R){return this.g.delete(this.t(b),R)}copy(b,R,p){if((0,L.$jl)(this.g))return this.g.copy(this.t(b),this.t(R),p);throw new Error("copy not supported")}cloneFile(b,R){if((0,L.$kl)(this.g))return this.g.cloneFile(this.t(b),this.t(R));throw new Error("clone not supported")}s(b){const R=[];for(const p of b){if(p.resource.scheme!==this.f)continue;const m=this.u(p.resource);this.b.findSubstr(m)&&R.push({resource:m,type:p.type,cId:p.cId})}R.length&&(this.n.debug("User data changed"),this.a.fire(R))}t(b){return b.with({scheme:this.f})}u(b){return b.with({scheme:this.h})}}e.$$ic=C}),define(fe[82],de([0,1,64]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.$qNb=L,e.$rNb=k;function a(T,C,A,b){const R=(0,P.$go)(T,C,A,b)[0];return R&&(T=T.substring(0,R.offset)+R.content+T.substring(R.offset+R.length)),T}function L(T,C,A){let b=A;for(;b>=0;){if(T.charAt(b)===C.charAt(C.length-1)&&C.length===1)return b+1;if(b--,C.length===2&&b>=0&&T.charAt(b)===C.charAt(0))return b+2}return 0}function k(T,C,A){let b=A;for(;b>=0;)if(T.charAt(b)===C.charAt(C.length-1)&&C.length===1||(b++,C.length===2&&b>=0&&T.charAt(b)===C.charAt(1)))return b;return T.length-1}}),define(fe[208],de([0,1,29,60,12]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=k,a=Oe(a);function k(g,l,f,E,w,d){const I=[],$=[],c=[];if(!l){const j=g.filter(({identifier:G})=>w.every(W=>W.toLowerCase()!==G.id.toLowerCase()));return{local:{added:I,removed:$,updated:c},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}g=g.map(p),l=l.map(p),f=f?f.map(p):null;const h=new Map,i=j=>{j.uuid&&h.set(j.id.toLowerCase(),j.uuid)};g.forEach(({identifier:j})=>i(j)),l.forEach(({identifier:j})=>i(j)),f?.forEach(({identifier:j})=>i(j)),E?.forEach(({identifier:j})=>i(j)),d?.forEach(j=>i(j));const n=j=>{const G=j.identifier.uuid||h.get(j.identifier.id.toLowerCase());return G?`uuid:${G}`:`id:${j.identifier.id.toLowerCase()}`},t=(j,G)=>(j.set(n(G),G),j),s=g.reduce(t,new Map),r=l.reduce(t,new Map),o=l.reduce((j,G)=>t(j,(0,P.$ko)(G)),new Map),u=f?f.reduce(t,new Map):null,y=E.reduce(t,new Map),O=w.reduce((j,G)=>{const W=h.get(G.toLowerCase());return j.add(W?`uuid:${W}`:`id:${G.toLowerCase()}`)},new Set),S=d?d.reduce((j,{id:G,uuid:W})=>(W=W??h.get(G.toLowerCase()),j.add(W?`uuid:${W}`:`id:${G.toLowerCase()}`)),new Set):null,v=T(s,r,O,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const j=T(u,s,O,!1),G=T(u,r,O,!0),W=(x,V,te,B)=>{let H,_,ne;return V.installed?(H=B.pinned,ne=B.preRelease,H&&(_=B.version)):(H=te.pinned,ne=te.preRelease,H&&(_=te.version)),H===void 0&&(H=V.pinned,H&&(_=V.version)),ne===void 0&&(ne=V.preRelease),{...B,installed:V.installed||te.installed,pinned:H,preRelease:ne,version:_??(te.version&&(!V.installed||a.gt(te.version,V.version))?te.version:V.version),state:A(V,te,u?.get(x))}};for(const x of G.removed.values()){const V=s.get(x);if(!V)continue;const te=(0,L.$ug)(u?.get(x)),B=S&&!S.has(x)&&te.installed;V.installed&&B?$.push(V.identifier):o.set(x,V)}for(const x of G.added.values()){const V=(0,L.$ug)(r.get(x)),te=s.get(x);if(te){if(v.updated.has(x)){const B=W(x,te,V,V);C(te,V,!1,!1)||c.push(m(B,x)),o.set(x,B)}}else V.installed&&I.push(m(V,x))}for(const x of G.updated.values()){const V=(0,L.$ug)(r.get(x)),te=(0,L.$ug)(u?.get(x)),B=s.get(x);if(B)if(S&&!S.has(x)&&te.installed&&B.installed&&!V.installed)$.push(B.identifier);else{const _=W(x,B,V,V);c.push(m(_,x)),o.set(x,_)}else V.installed&&I.push(m(V,x))}for(const x of j.added.values())G.added.has(x)||o.set(x,(0,L.$ug)(s.get(x)));for(const x of j.updated.values()){if(G.removed.has(x)||G.updated.has(x))continue;const V=(0,L.$ug)(s.get(x)),te=(0,L.$ug)(r.get(x));o.set(x,W(x,V,te,V))}for(const x of j.removed.values())G.updated.has(x)||G.removed.has(x)||y.has(x)||(0,L.$ug)(r.get(x)).installed&&S&&(S.has(x)||!(0,L.$ug)(u?.get(x)).installed||o.delete(x))}const N=[],F=T(r,o,new Set,!0),U=F.added.size>0||F.updated.size>0||F.removed.size>0;return U&&o.forEach((j,G)=>N.push(m(j,G))),{local:{added:I,removed:$,updated:c},remote:U?{added:[...F.added].map(j=>o.get(j)),updated:[...F.updated].map(j=>o.get(j)),removed:[...F.removed].map(j=>r.get(j)),all:N}:null}}function T(g,l,f,E){const w=g?[...g.keys()].filter(h=>!f.has(h)):[],d=[...l.keys()].filter(h=>!f.has(h)),I=d.filter(h=>!w.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),$=w.filter(h=>!d.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),c=new Set;for(const h of w){if($.has(h))continue;const i=g.get(h),n=l.get(h);(!n||!C(i,n,E,!0))&&c.add(h)}return{added:I,removed:$,updated:c}}function C(g,l,f,E){return!(g.disabled!==l.disabled||!!g.isApplicationScoped!=!!l.isApplicationScoped||E&&g.installed!==l.installed||g.installed&&l.installed&&(g.preRelease!==l.preRelease||g.pinned!==l.pinned||l.pinned&&g.version!==l.version)||!R(g.state,l.state)||f&&g.version!==l.version)}function A(g,l,f){const E=g.state,w=l.state,d=f?.state;if(!l.version||E&&a.gt(g.version,l.version))return E;if(w&&a.gt(l.version,g.version)||!E)return w;if(!w)return E;const I=(0,P.$ko)(E),$=d?b(d,w):{added:Object.keys(w).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set},c=d?b(d,E):{added:Object.keys(E).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set};for(const h of[...$.added.values(),...$.updated.values()])I[h]=w[h];for(const h of $.removed.values())c.updated.has(h)||delete I[h];return I}function b(g,l){const f=Object.keys(g),E=Object.keys(l),w=E.filter($=>!f.includes($)).reduce(($,c)=>($.add(c),$),new Set),d=f.filter($=>!E.includes($)).reduce(($,c)=>($.add(c),$),new Set),I=new Set;for(const $ of f){if(d.has($))continue;const c=g[$],h=l[$];(0,P.$oo)(c,h)||I.add($)}return{added:w,removed:d,updated:I}}function R(g={},l={}){const{added:f,removed:E,updated:w}=b(g,l);return f.size===0&&E.size===0&&w.size===0}function p(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function m(g,l){const f={...g,identifier:{id:g.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!g.preRelease,pinned:!!g.pinned};return g.disabled||delete f.disabled,g.installed||delete f.installed,g.state||delete f.state,g.isApplicationScoped||delete f.isApplicationScoped,f}}),define(fe[116],de([0,1,17,21,4]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KPb=e.$JPb=void 0,e.$JPb=(0,L.$Ki)("IIgnoredExtensionsManagementService");let k=class{constructor(C){this.a=C}hasToNeverSyncExtension(C){return this.b().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.b().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,A){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==C&&R!==`-${C}`),A&&b.push(C.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(C,A){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==C&&R!==`-${C}`),A&&b.push(`-${C.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(C){const A=C.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),b=this.b().map(m=>m.toLowerCase()),R=[],p=[];if(Array.isArray(b))for(const m of b)m.startsWith("-")?p.push(m.substring(1)):R.push(m);return(0,P.$Qb)([...A,...R].filter(m=>!p.includes(m)))}b(){let C=this.a.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.a.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(A=>A.toLowerCase())}};e.$KPb=k,e.$KPb=k=Ee([Y(0,a.$ej)],k)}),define(fe[209],de([0,1,17,36,29,98,82]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=A,L=Oe(L),T=Oe(T);function C($){return(0,a.$5n)($)||[]}async function A($,c,h,i,n){const t=C($),s=C(c),r=h?C(h):null,o=[...t,...s,...r||[]].map(W=>W.key),u=await n.resolveUserBindings(o),y=R(t,s,r,u);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:$,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};const O=m(t),S=m(s),v=r?m(r):null,N=l(O,S,u),F=v?l(v,O,u):{added:[...O.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},U=v?l(v,S,u):{added:[...S.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},j=b(N,F,U);let G=$;for(const W of j.removed.values())j.conflicts.has(W)||(G=d(G,W,i));for(const W of j.added.values()){if(j.conflicts.has(W))continue;const x=S.get(W);if(x.some(V=>V.command!==`-${W}`&&y.conflicts.has(u[V.key]))){j.conflicts.add(W);continue}G=w(G,x,i)}for(const W of j.updated.values()){if(j.conflicts.has(W))continue;const x=S.get(W);if(x.some(V=>V.command!==`-${W}`&&y.conflicts.has(u[V.key]))){j.conflicts.add(W);continue}G=I(G,W,x,i)}return{mergeContent:G,hasChanges:!0,hasConflicts:j.conflicts.size>0}}function b($,c,h){const i=new Set,n=new Set,t=new Set,s=new Set;for(const r of c.removed.values())h.updated.has(r)&&s.add(r);for(const r of h.removed.values())s.has(r)||(c.updated.has(r)?s.add(r):n.add(r));for(const r of c.added.values())s.has(r)||h.added.has(r)&&$.updated.has(r)&&s.add(r);for(const r of h.added.values())s.has(r)||(c.added.has(r)?$.updated.has(r)&&s.add(r):i.add(r));for(const r of c.updated.values())s.has(r)||h.updated.has(r)&&$.updated.has(r)&&s.add(r);for(const r of h.updated.values())s.has(r)||(c.updated.has(r)?$.updated.has(r)&&s.add(r):t.add(r));return{added:i,removed:n,updated:t,conflicts:s}}function R($,c,h,i){const n=new Set,t=p($,i),s=p(c,i),r=h?p(h,i):null,o=g(t,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const u=r?g(r,t):{added:[...t.keys()].reduce((F,U)=>(F.add(U),F),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?g(r,s):{added:[...s.keys()].reduce((F,U)=>(F.add(U),F),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:O,removed:S,updated:v,conflicts:N}=b(o,u,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:O,removed:S,updated:v,conflicts:N}}function p($,c){const h=new Map;for(const i of $){const n=c[i.key];let t=h.get(n);t||(t=[],h.set(n,t)),t.push(i)}return h}function m($){const c=new Map;for(const h of $){const i=h.command[0]==="-"?h.command.substring(1):h.command;let n=c.get(i);n||(n=[],c.set(i,n)),n.push(h)}return c}function g($,c){const h=[...$.keys()],i=[...c.keys()],n=i.filter(r=>!h.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=h.filter(r=>!i.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),s=new Set;for(const r of h){if(t.has(r))continue;const o=$.get(r).map(y=>({...y,key:r})),u=c.get(r).map(y=>({...y,key:r}));(0,P.$yb)(o,u,(y,O)=>E(y,O))||s.add(r)}return{added:n,removed:t,updated:s}}function l($,c,h){const i=[...$.keys()],n=[...c.keys()],t=n.filter(o=>!i.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),s=i.filter(o=>!n.includes(o)).reduce((o,u)=>(o.add(u),o),new Set),r=new Set;for(const o of i){if(s.has(o))continue;const u=$.get(o).map(O=>({...O,key:h[O.key]})),y=c.get(o).map(O=>({...O,key:h[O.key]}));f(u,y)||r.add(o)}return{added:t,removed:s,updated:r}}function f($,c){return!(!(0,P.$yb)($.filter(({command:h})=>h[0]!=="-"),c.filter(({command:h})=>h[0]!=="-"),(h,i)=>E(h,i))||!(0,P.$yb)($.filter(({command:h})=>h[0]==="-"),c.filter(({command:h})=>h[0]==="-"),(h,i)=>E(h,i)))}function E($,c){if($.command!==c.command||$.key!==c.key)return!1;const h=k.$Ij.deserialize($.when),i=k.$Ij.deserialize(c.when);return!(h&&!i||!h&&i||h&&i&&!h.equals(i)||!L.$oo($.args,c.args))}function w($,c,h){for(const i of c)$=T.edit($,[-1],i,h);return $}function d($,c,h){const i=C($);for(let n=i.length-1;n>=0;n--)(i[n].command===c||i[n].command===`-${c}`)&&($=T.edit($,[n],void 0,h));return $}function I($,c,h,i){const n=C($),t=n.findIndex(s=>s.command===c||s.command===`-${c}`);for(let s=n.length-1;s>=0;s--)(n[s].command===c||n[s].command===`-${c}`)&&($=T.edit($,[s],void 0,i));for(let s=h.length-1;s>=0;s--)$=T.edit($,[t],h[s],i);return $}}),define(fe[210],de([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=P,e.$nec=L;function P(k,T,C){const A={},b={},R=new Set;if(!T)return{local:{added:A,updated:b,removed:[...R.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const p=a(k,T);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{local:{added:A,updated:b,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=a(C,k),g=a(C,T),l={},f={},E=new Set,w=new Set;for(const d of m.removed.values())g.updated.has(d)?A[d]=T[d]:E.add(d);for(const d of g.removed.values())w.has(d)||(m.updated.has(d)?w.add(d):R.add(d));for(const d of m.updated.values())w.has(d)||(g.updated.has(d)?p.updated.has(d)&&w.add(d):f[d]=k[d]);for(const d of g.updated.values())w.has(d)||(m.updated.has(d)?p.updated.has(d)&&w.add(d):k[d]!==void 0&&(b[d]=T[d]));for(const d of m.added.values())w.has(d)||(g.added.has(d)?p.updated.has(d)&&w.add(d):l[d]=k[d]);for(const d of g.added.values())w.has(d)||(m.added.has(d)?p.updated.has(d)&&w.add(d):A[d]=T[d]);return{local:{added:A,removed:[...R.values()],updated:b},remote:{added:l,removed:[...E.values()],updated:f},conflicts:[...w.values()]}}function a(k,T){const C=k?Object.keys(k):[],A=T?Object.keys(T):[],b=A.filter(m=>!C.includes(m)).reduce((m,g)=>(m.add(g),m),new Set),R=C.filter(m=>!A.includes(m)).reduce((m,g)=>(m.add(g),m),new Set),p=new Set;for(const m of C){if(R.has(m))continue;const g=k[m],l=T[m];g!==l&&p.add(m)}return{added:b,removed:R,updated:p}}function L(k,T){const{added:C,removed:A,updated:b}=a(k,T);return C.size===0&&A.size===0&&b.size===0}}),define(fe[211],de([0,1,29]),function(ce,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=a;function a(k,T,C,A){const b={added:[],removed:[],updated:[]};let R={added:[],removed:[],updated:[]};if(!T){const m=k.filter(({id:g})=>!A.includes(g));return m.length?R.added=m:R=null,{local:b,remote:R}}const p=L(k,T,A);if(p.added.length>0||p.removed.length>0||p.updated.length>0){const m=L(C,k,A),g=L(C,T,A);for(const l of g.removed){const f=k.find(E=>E.id===l);f&&b.removed.push(f)}for(const l of g.added){const f=T.find(E=>E.id===l);m.added.includes(l)?p.updated.includes(l)&&b.updated.push(f):b.added.push(f)}for(const l of g.updated)b.updated.push(T.find(f=>f.id===l));for(const l of m.added)g.added.includes(l)||R.added.push(k.find(f=>f.id===l));for(const l of m.updated)g.removed.includes(l)||g.updated.includes(l)||R.updated.push(k.find(f=>f.id===l));for(const l of m.removed){const f=T.find(E=>E.id===l);f&&R.removed.push(f)}}return R.added.length===0&&R.removed.length===0&&R.updated.length===0&&(R=null),{local:b,remote:R}}function L(k,T,C){k=k?k.filter(({id:g})=>!C.includes(g)):[],T=T.filter(({id:g})=>!C.includes(g));const A=k.map(({id:g})=>g),b=T.map(({id:g})=>g),R=b.filter(g=>!A.includes(g)),p=A.filter(g=>!b.includes(g)),m=[];for(const{id:g,name:l,shortName:f,icon:E,useDefaultFlags:w}of k){if(p.includes(g))continue;const d=T.find(I=>I.id===g);(!d||d.name!==l||d.shortName!==f||d.icon!==E||!(0,P.$oo)(d.useDefaultFlags,w))&&m.push(g)}return{added:R,removed:p,updated:m}}}),define(fe[24],de([0,1,17,12,9,47,27,4,105,44]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iob=e.$Hob=e.$Gob=e.$Fob=e.$Eob=e.$Dob=e.$Cob=e.$Bob=e.$Aob=e.$yob=e.MergeState=e.Change=e.SyncStatus=e.$xob=e.$wob=e.$vob=e.UserDataSyncErrorCode=e.$tob=e.$sob=e.$rob=e.$qob=e.$pob=e.$mob=e.SyncResource=e.$job=e.$iob=void 0,e.$fob=R,e.$gob=p,e.$hob=m,e.$kob=l,e.$lob=f,e.$nob=w,e.$oob=d,e.$uob=I,e.$zob=r;function R(){const o=b.$xo.as(k.$Co.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}function p(o=!1){const u=b.$xo.as(k.$Co.Configuration).getConfigurationProperties(),y=g(u,o),O=R();return(0,P.$Qb)([...y,...O])}function m(o){if(!o.contributes?.configuration)return[];const u=Array.isArray(o.contributes.configuration)?o.contributes.configuration:[o.contributes.configuration];if(!u.length)return[];const y=(0,k.$So)(u);return g(y,!1)}function g(o,u){const y=new Set;for(const O in o){if(u&&o[O].source)continue;const S=(0,a.$jg)(o[O].scope)?(0,k.$To)(o[O].scope):o[O].scope;(o[O].ignoreSync||S===k.ConfigurationScope.MACHINE||S===k.ConfigurationScope.MACHINE_OVERRIDABLE)&&y.add(O)}return[...y.values()]}e.$iob="settingsSync",e.$job="settingsSync.keybindingsPerPlatform";function l(){const o="vscode://schemas/ignoredSettings",u=b.$xo.as(k.$Co.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(2455,null),type:"object",properties:{[e.$job]:{type:"boolean",description:(0,L.localize)(2456,null),default:!0,scope:k.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2457,null),items:[{type:"string",pattern:T.$ep,errorMessage:(0,L.localize)(2458,null)}],default:[],scope:k.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(2459,null),default:[],scope:k.ConfigurationScope.APPLICATION,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=b.$xo.as(A.$yo.JSONContribution),O=()=>{const S=R(),v=p(),N=Object.keys(k.$Do.properties).filter(j=>!v.includes(j)),F=v.filter(j=>!S.includes(j)),U={items:{type:"string",enum:[...N,...F.map(j=>`-${j}`)]}};y.registerSchema(o,U)};return u.onDidUpdateConfiguration(()=>O())}function f(o){return o&&(0,a.$lg)(o)&&(0,a.$jg)(o.id)&&Array.isArray(o.scopes)}var E;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles",o.WorkspaceState="workspaceState"})(E||(e.SyncResource=E={})),e.$mob=[E.Settings,E.Keybindings,E.Snippets,E.Tasks,E.Extensions,E.GlobalState,E.Profiles];function w(o,...u){return o?[o,...u]:u}function d(o,u,y,O){return O.joinPath(y.userDataSyncHome,...w(o,u,`lastSync${u}.json`))}e.$pob=(0,C.$Ki)("IUserDataSyncStoreManagementService"),e.$qob=(0,C.$Ki)("IUserDataSyncStoreService"),e.$rob=(0,C.$Ki)("IUserDataSyncLocalStoreService"),e.$sob="x-operation-id",e.$tob="X-Execution-Id";function I(o){const u={};return u[e.$tob]=o,u}var $;(function(o){o.Unauthorized="Unauthorized",o.Forbidden="Forbidden",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})($||(e.UserDataSyncErrorCode=$={}));class c extends Error{constructor(u,y,O,S){super(u),this.code=y,this.resource=O,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$vob=c;class h extends c{constructor(u,y,O,S,v){super(u,O,void 0,v),this.url=y,this.serverCode=S}}e.$wob=h;class i extends c{constructor(u,y){super(u,y)}}e.$xob=i,function(o){function u(y){if(y instanceof o)return y;const O=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(O&&O[1]){const S=O[2]==="unknown"?void 0:O[2],v=O[3]==="unknown"?void 0:O[3];return new o(y.message,O[1],S,v)}return new o(y.message,$.Unknown)}o.toUserDataSyncError=u}(c||(e.$vob=c={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var t;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(t||(e.Change=t={}));var s;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(s||(e.MergeState=s={})),e.$yob="sync.store.url.type";function r(o){return`sync.enable.${o}`}e.$Aob=(0,C.$Ki)("IUserDataSyncEnablementService"),e.$Bob=(0,C.$Ki)("IUserDataSyncService"),e.$Cob=(0,C.$Ki)("IUserDataSyncResourceProviderService"),e.$Dob=(0,C.$Ki)("IUserDataAutoSyncService"),e.$Eob=(0,C.$Ki)("IUserDataSyncUtilService"),e.$Fob=(0,C.$Ki)("IUserDataSyncLogService"),e.$Gob="userDataSync",e.$Hob="vscode-userdata-sync",e.$Iob="preview"}),define(fe[212],de([0,1,29,24]),function(ce,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UOb=L,P=Oe(P);function L(T,C,A,b,R){if(!C)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const p=k(T,C);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=A?k(A,C):{added:Object.keys(C).reduce((d,I)=>(d.add(I),d),new Set),removed:new Set,updated:new Set},g=A?k(A,T):{added:Object.keys(T).reduce((d,I)=>(d.add(I),d),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},f=P.$ko(C),E=!A;for(const d of g.added.values())d!==a.$yob&&E&&m.added.has(d)||(f[d]=T[d]);for(const d of g.updated.values())f[d]=T[d];for(const d of g.removed.values())b.unregistered.includes(d)||delete f[d];for(const d of m.added.values()){const I=C[d];if(b.machine.includes(d)){R.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(A&&g.added.has(d))continue;const $=T[d];$&&$.value===I.value||d===a.$yob&&E&&g.added.has(d)||($?l.updated[d]=I:l.added[d]=I)}for(const d of m.updated.values()){const I=C[d];if(b.machine.includes(d)){R.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(g.updated.has(d)||g.removed.has(d))continue;const $=T[d];$&&$.value===I.value||(l.updated[d]=I)}for(const d of m.removed.values()){if(b.machine.includes(d)){R.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}g.updated.has(d)||g.removed.has(d)||l.removed.push(d)}const w=k(C,f);return{local:l,remote:{added:[...w.added],updated:[...w.updated],removed:[...w.removed],all:w.added.size===0&&w.removed.size===0&&w.updated.size===0?null:f}}}function k(T,C){const A=Object.keys(T),b=Object.keys(C),R=b.filter(g=>!A.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),p=A.filter(g=>!b.includes(g)).reduce((g,l)=>(g.add(l),g),new Set),m=new Set;for(const g of A){if(p.has(g))continue;const l=T[g],f=C[g];P.$oo(l,f)||m.add(g)}return{added:R,removed:p,updated:m}}}),define(fe[213],de([0,1,17,36,64,45,29,82,24]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sNb=b,e.$tNb=m,e.$uNb=g,e.$vNb=l,e.$wNb=E,e.$xNb=d,T=Oe(T),C=Oe(C);function b(o,u,y){let O=[];y?O=p(y):O=R(u);const S=[],v=[...(0,A.$fob)()];if(Array.isArray(O))for(const N of O)N.startsWith("-")?v.push(N.substring(1)):S.push(N);return(0,P.$Qb)([...o,...S].filter(N=>!v.includes(N)))}function R(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function p(o){const u=(0,a.$5n)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function m(o,u){const y=(0,a.$5n)(o)||{};let O="{}";for(const S of Object.keys(y)){const v=(0,L.$go)(O,[S],y[S],u);O=(0,L.$jo)(O,v)}return O}function g(o,u,y,O){if(y.length){const S=r(u),v=(0,a.$5n)(u)||{},N=(0,a.$5n)(o);if(!N)return o;const F=[];for(const U of y){const j=v[U],G=N[U];j===void 0?o=C.edit(o,[U],void 0,O):G!==void 0?o=C.edit(o,[U],j,O):F.push(h(U,S))}F.sort((U,j)=>U.startOffset-j.startOffset),F.forEach(U=>o=d(U.setting.key,u,o,O))}return o}function l(o,u,y,O,S,v){const N=g(o,u,O,v),F=y!==N,U=y!==u;if(!F&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:g(u,o,O,v),remoteContent:null,hasConflicts:!1};if(y===null&&E(o)){const D=f(o,u,O)?null:g(u,o,O,v);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let j=o,G=u;const W=(0,a.$5n)(o),x=(0,a.$5n)(u),V=y?(0,a.$5n)(y):null,te=O.reduce((D,J)=>(D.add(J),D),new Set),B=w(W,x,te),H=w(V,W,te),_=w(V,x,te),ne=new Map,le=new Set,ee=D=>{le.add(D);const J=S.filter(({key:oe})=>oe===D)[0];J?(j=C.edit(j,[D],J.value,v),G=C.edit(G,[D],J.value,v)):ne.set(D,{key:D,localValue:W[D],remoteValue:x[D]})};for(const D of H.removed.values())_.updated.has(D)?ee(D):G=C.edit(G,[D],void 0,v);for(const D of _.removed.values())le.has(D)||(H.updated.has(D)?ee(D):j=C.edit(j,[D],void 0,v));for(const D of H.updated.values())le.has(D)||(_.updated.has(D)?B.updated.has(D)&&ee(D):G=C.edit(G,[D],W[D],v));for(const D of _.updated.values())le.has(D)||(H.updated.has(D)?B.updated.has(D)&&ee(D):j=C.edit(j,[D],x[D],v));for(const D of H.added.values())le.has(D)||(_.added.has(D)?B.updated.has(D)&&ee(D):G=d(D,j,G,v));for(const D of _.added.values())le.has(D)||(H.added.has(D)?B.updated.has(D)&&ee(D):j=d(D,G,j,v));const X=ne.size>0||!f(j,G,O),K=X||!f(j,o,[]),q=X||!f(G,u,[]);return{localContent:K?j:null,remoteContent:q?G:null,conflictsSettings:[...ne.values()],hasConflicts:X}}function f(o,u,y){if(o===u)return!0;const O=(0,a.$5n)(o),S=(0,a.$5n)(u),v=y.reduce((U,j)=>(U.add(j),U),new Set),N=r(o).filter(U=>!(U.setting&&v.has(U.setting.key))),F=r(u).filter(U=>!(U.setting&&v.has(U.setting.key)));if(N.length!==F.length)return!1;for(let U=0;U<N.length;U++){const j=N[U],G=F[U];if(j.setting&&G.setting){if(j.setting.key!==G.setting.key||!T.$oo(O[j.setting.key],S[j.setting.key]))return!1}else if(!j.setting&&!G.setting){if(j.value!==G.value)return!1}else return!1}return!0}function E(o){return o?r(o).length===0:!0}function w(o,u,y){const O=o?Object.keys(o).filter(U=>!y.has(U)):[],S=Object.keys(u).filter(U=>!y.has(U)),v=S.filter(U=>!O.includes(U)).reduce((U,j)=>(U.add(j),U),new Set),N=O.filter(U=>!S.includes(U)).reduce((U,j)=>(U.add(j),U),new Set),F=new Set;if(o)for(const U of O){if(N.has(U))continue;const j=o[U],G=u[U];T.$oo(j,G)||F.add(U)}return{added:v,removed:N,updated:F}}function d(o,u,y,O){const S=(0,a.$5n)(u),v=r(u),N=r(y),F=I(o,v,N);return $(y,o,S[o],F,N,O)}function I(o,u,y){const O=u.findIndex(v=>v.setting?.key===o),S=u[O-1];if(S){if(S.setting){const N=h(S.setting.key,y);if(N)return{index:y.indexOf(N),insertAfter:!0}}else{const N=i(O,u);if(N){const F=h(N.setting.key,y);if(F){const U=n(y.indexOf(F),y),j=t(u,N,u[O]);if(U){const G=t(y,F,U),W=s(j,G);return W?{index:y.indexOf(W),insertAfter:!0}:{index:y.indexOf(U),insertAfter:!1}}else{const G=t(y,F,y[y.length-1]),W=s(j,G);return W?{index:y.indexOf(W),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const v=u[O+1];if(v)if(v.setting){const N=h(v.setting.key,y);if(N)return{index:y.indexOf(N),insertAfter:!1}}else{const N=n(O,u);if(N){const F=h(N.setting.key,y);if(F){const U=i(y.indexOf(F),y),j=t(u,u[O],N);if(U){const G=t(y,U,F),W=s(j.reverse(),G.reverse());return W?{index:y.indexOf(W),insertAfter:!1}:{index:y.indexOf(U),insertAfter:!0}}else{const G=t(y,y[0],F),W=s(j.reverse(),G.reverse());return W?{index:y.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function $(o,u,y,O,S,v){let N;return O.index===-1?N=(0,L.$go)(o,[u],y,v):N=c(o,u,y,O,S,v).map(F=>(0,L.$ho)(o,F,v)[0]),(0,L.$jo)(o,N)}function c(o,u,y,O,S,v){const N=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,F=(0,k.$do)(v,o),U=S[O.index];if(O.insertAfter){const j=[];if(U.setting)j.push({offset:U.endOffset,length:0,content:","+N});else{const G=n(O.index,S),W=i(O.index,S),x=W?.setting?.commaOffset;W&&x===void 0&&j.push({offset:W.endOffset,length:0,content:","});const V=x!==void 0&&x>U.endOffset;j.push({offset:V?x+1:U.endOffset,length:0,content:G?F+N+",":F+N})}return j}else{if(U.setting)return[{offset:U.startOffset,length:0,content:N+","}];const j=(S[O.index-1]&&!S[O.index-1].setting?F:"")+N+(n(O.index,S)?",":"")+F;return[{offset:U.startOffset,length:0,content:j}]}}function h(o,u){return u.filter(y=>y.setting?.key===o)[0]}function i(o,u){for(let y=o-1;y>=0;y--)if(u[y].setting)return u[y]}function n(o,u){for(let y=o+1;y<u.length;y++)if(u[y].setting)return u[y]}function t(o,u,y){const O=o.indexOf(u),S=o.indexOf(y);return o.filter((v,N)=>O<N&&N<S)}function s(o,u){if(o.length&&u.length){let y=0;for(;y<u.length&&y<o.length;y++)if(o[y].value!==u[y].value)return u[y-1];return u[y-1]}}function r(o){const u=[];let y=-1,O,S;const v={onObjectBegin:N=>{y++},onObjectProperty:(N,F,U)=>{y===0&&(O=F,S=N)},onObjectEnd:(N,F)=>{y--,y===0&&u.push({startOffset:O,endOffset:N+F,value:o.substring(O,N+F),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(N,F)=>{y++},onArrayEnd:(N,F)=>{y--,y===0&&u.push({startOffset:O,endOffset:N+F,value:o.substring(O,N+F),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(N,F,U)=>{y===0&&u.push({startOffset:O,endOffset:F+U,value:o.substring(O,F+U),setting:{key:S,commaOffset:void 0}})},onSeparator:(N,F,U)=>{if(y===0&&N===","){let j=u.length-1;for(;j>=0&&!u[j].setting;j--);const G=u[j];G&&u.splice(j,1,{startOffset:G.startOffset,endOffset:G.endOffset,value:G.value,setting:{key:G.setting.key,commaOffset:F}})}},onComment:(N,F)=>{y===0&&u.push({startOffset:N,endOffset:N+F,value:o.substring(N,N+F)})}};return(0,a.$_n)(o,v),u}}),define(fe[83],de([0,1,3,2,4,24]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dNb=e.$cNb=void 0,e.$cNb=(0,L.$Ki)("IUserDataSyncAccountService");let T=class extends a.$Zc{get account(){return this.a}constructor(A,b){super(),this.g=A,this.h=b,this.b=this.B(new P.$qe),this.onDidChangeAccount=this.b.event,this.c=this.B(new P.$qe),this.onTokenFailed=this.c.event,this.f=!1,this.B(A.onTokenFailed(R=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,R),this.updateAccount(void 0),R===k.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(A.onTokenSucceed(()=>this.f=!1))}async updateAccount(A){(A&&this.a?A.token!==this.a.token||A.authenticationProviderId!==this.a.authenticationProviderId:A!==this.a)&&(this.a=A,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(A))}};e.$dNb=T,e.$dNb=T=Ee([Y(0,k.$qob),Y(1,k.$Fob)],T)}),define(fe[214],de([0,1,20,9,15,11,24]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LPb=void 0;let C=class extends k.$kk{constructor(b,R){super(),this.g=this.B(b.createLogger((0,P.$lh)(R.logsHome,`${T.$Gob}.log`),{id:T.$Gob,name:(0,a.localize)(2460,null)}))}trace(b,...R){this.g.trace(b,...R)}debug(b,...R){this.g.debug(b,...R)}info(b,...R){this.g.info(b,...R)}warn(b,...R){this.g.warn(b,...R)}error(b,...R){this.g.error(b,...R)}flush(){this.g.flush()}};e.$LPb=C,e.$LPb=C=Ee([Y(0,k.$gk),Y(1,L.$Ri)],C)}),define(fe[215],de([0,1,6,3,2]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class k extends L.$Zc{constructor({onDidOpenMainWindow:C,onDidFocusMainWindow:A,getActiveWindowId:b}){super(),this.a=this.B(new L.$Yc),a.Event.latch(a.Event.any(C,A))(this.f,this,this.a),this.b=(0,P.$xh)(()=>b()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(C){this.b&&(this.b.cancel(),this.b=void 0),this.c=C}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Dic=k}),define(fe[117],de([0,1,9,13,51,20,10,4,22]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=b,e.$Vi=R,e.$Yi=p,e.$Zi=m,e.$1i=g,e.$2i=f,e.$3i=E,e.$6i=I,e.$$i=$,e.$_i=c,e.$bj=h,e.$cj=i,e.$dj=n,e.$Ti=(0,C.$Ki)("contextService");function b(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}function R(t){return typeof t?.id=="string"&&!b(t)&&!m(t)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function p(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,a.$sc)(t)}:s?e.$Wi:e.$Xi;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function m(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}function g(t){const s=t;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function f(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function E(t){const s=t;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class w{constructor(s,r,o,u,y){this.h=s,this.j=o,this.k=u,this.l=y,this.c=L.$Qi.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=L.$Qi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=w;class d{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,k.$lh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=d;function I(t){return new d({uri:t,index:0,name:(0,k.$hh)(t)},{uri:t.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,P.localize)(2489,null),extensions:[e.$7i]}],e.$0i="workspace.json";function $(t,s){return k.$ch.isEqualOrParent(t,s.untitledWorkspacesHome)}function c(t){let s;return T.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===A.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function h(t){return t.id===e.$aj}function i(t,s){return!$(t,s)&&!c(t)}function n(t){return(typeof t=="string"?(0,a.$tc)(t):(0,k.$jh)(t))===e.$8i}}),define(fe[19],de([0,1,55,3,2,20,10,9,15,7,4,11,117,31,28,6,32,26,12]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=$,e.$Sl=c,e.$Tl=h;var I;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function $(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&T.URI.isUri(s.location)&&T.URI.isUri(s.globalStorageHome)&&T.URI.isUri(s.settingsResource)&&T.URI.isUri(s.keybindingsResource)&&T.URI.isUri(s.tasksResource)&&T.URI.isUri(s.snippetsHome)&&T.URI.isUri(s.extensionsResource))}e.$Rl=(0,R.$Ki)("IUserDataProfilesService");function c(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:T.URI.revive(t.location).with({scheme:s}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:T.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:T.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function h(t,s,r,o,u,y){return{id:t,name:s,location:r,isDefault:!1,shortName:u?.shortName,icon:u?.icon,globalStorageHome:y&&u?.useDefaultFlags?.globalState?y.globalStorageHome:(0,k.$lh)(r,"globalStorage"),settingsResource:y&&u?.useDefaultFlags?.settings?y.settingsResource:(0,k.$lh)(r,"settings.json"),keybindingsResource:y&&u?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,k.$lh)(r,"keybindings.json"),tasksResource:y&&u?.useDefaultFlags?.tasks?y.tasksResource:(0,k.$lh)(r,"tasks.json"),snippetsHome:y&&u?.useDefaultFlags?.snippets?y.snippetsHome:(0,k.$lh)(r,"snippets"),extensionsResource:y&&u?.useDefaultFlags?.extensions?y.extensionsResource:(0,k.$lh)(r,"extensions.json"),cacheHome:(0,k.$lh)(o,t),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}let i=class extends L.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,o,u){super(),this.t=s,this.u=r,this.w=o,this.y=u,this.f=!0,this.h=this.B(new a.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new g.$Fc,workspaces:new g.$Fc,emptyWindows:new Map},this.profilesHome=(0,k.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,d.$jg)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(h((0,k.$ih)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.y.error(y)}const o=new g.$Fc,u=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[O,S]of Object.entries(y.workspaces)){const v=T.URI.parse(O),N=r.find(F=>F.id===S);N&&o.set(v,N)}if(y.emptyWindows)for(const[O,S]of Object.entries(y.emptyWindows)){const v=r.find(N=>N.id===S);v&&u.set(O,v)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:o,emptyWindows:u}}return this.z}D(){const s=h("__default__profile__",(0,C.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",o=new RegExp(`${(0,w.$mf)(r)}\\s(\\d+)`);let u=0;for(const O of this.profiles){const S=o.exec(O.name),v=S?parseInt(S[1]):0;u=v>u?v:u}const y=`${r} ${u+1}`;return this.createProfile((0,P.$yj)((0,E.$7g)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,o){return this.createProfile((0,P.$yj)((0,E.$7g)()).toString(16),s,r,o)}async createProfile(s,r,o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(s,r,o);return u&&await this.setProfileForWorkspace(u,y),y}async F(s,r,o){if(!(0,d.$jg)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let u=this.r.get(r);return u||(u=(async()=>{try{if(this.profiles.find(v=>v.name===r||v.id===s))throw new Error(`Profile with ${r} name already exists`);const O=h(s,r,(0,k.$lh)(this.profilesHome,s),this.g,o,this.defaultProfile);await this.u.createFolder(O.location);const S=[];return this.j.fire({profile:O,join(v){S.push(v)}}),await f.Promises.settled(S),this.I([O],[],[]),O}finally{this.r.delete(r)}})(),this.r.set(r,u)),u}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(u=>u.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);return o=h(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(u=>u.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const o=[];this.m.fire({profile:r,join(u){o.push(u)}});try{await Promise.allSettled(o)}catch(u){this.y.error(u)}for(const u of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(u)?.id&&this.C.emptyWindows.delete(u);for(const u of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(u)?.id&&this.C.workspaces.delete(u);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(u){(0,b.$wl)(u)!==b.FileOperationResult.FILE_NOT_FOUND&&this.y.error(u)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(u=>u.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,o)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s),o=T.URI.isUri(r)?this.C.workspaces.get(r):this.C.emptyWindows.get(r);return o||((0,m.$Ui)(s)?this.s.folders.get(s.uri):(0,m.$Zi)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,m.$Ui)(s)?s.uri:(0,m.$Zi)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.folders.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,o){const u=[...this.profiles,...s],y=[],O=this.s.profiles;this.s.profiles=[];for(let S of u){if(S.isDefault||r.some(N=>S.id===N.id))continue;S=o.find(N=>S.id===N.id)??S;const v=O.find(N=>S.id===N.id);if(S.isTransient)this.s.profiles.push(S);else{if(v){for(const[N,F]of this.s.emptyWindows.entries())if(S.id===F.id){this.L({id:N},S);break}for(const[N,F]of this.s.workspaces.entries())if(S.id===F.id){this.L({id:"",configPath:N},S);break}for(const[N,F]of this.s.folders.entries())if(S.id===F.id){this.L({id:"",uri:N},S);break}}y.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags})}}this.P(y),this.z=void 0,this.J(s,r,o)}J(s,r,o){this.h.fire({added:s,removed:r,updated:o,all:this.profiles})}L(s,r,o){if(o=r?.isTransient?!0:o,o)(0,m.$Ui)(s)?(this.s.folders.delete(s.uri),r&&this.s.folders.set(s.uri,r)):(0,m.$Zi)(s)?(this.s.workspaces.delete(s.configPath),r&&this.s.workspaces.set(s.configPath,r)):(this.s.emptyWindows.delete(s.id),r&&this.s.emptyWindows.set(s.id,r));else{this.L(s,void 0,!0);const u=this.G(s);T.URI.isUri(u)?(this.C.workspaces.delete(u),r&&this.C.workspaces.set(u,r)):(this.C.emptyWindows.delete(u),r&&this.C.emptyWindows.set(u,r)),this.M()}}M(){const s={};for(const[o,u]of this.C.workspaces.entries())s[o.toString()]=u.id;const r={};for(const[o,u]of this.C.emptyWindows.entries())r[o.toString()]=u.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},o=this.D();if(s.workspaces)for(const[y,O]of Object.entries(s.workspaces)){const S=T.URI.parse(O);r[y]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}const u={};if(s.emptyWindows)for(const[y,O]of Object.entries(s.emptyWindows)){const S=T.URI.parse(O);u[y]=this.w.extUri.isEqual(S,o.location)?o.id:this.w.extUri.basename(S)}return{workspaces:r,emptyWindows:u}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Ul=i,e.$Ul=i=Ee([Y(0,A.$Ri),Y(1,b.$fl),Y(2,l.$Pl),Y(3,p.$fk)],i);class n extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Vl=n}),define(fe[216],de([0,1,6,2,19]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;let k=class extends a.$Zc{constructor(C){super(),this.B(new P.$Wh(()=>{C.cleanUp()},10*1e3)).schedule()}};e.$Jjc=k,e.$Jjc=k=Ee([Y(0,L.$Rl)],k)}),define(fe[84],de([0,1,17,6,25,8,3,2,31,5,12,10,9,27,35,34,59,11,23,18,28,19]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=void 0,e.$Oq=i,m=Oe(m);let h=class extends C.$Zc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(r,o,u,y,O,S){super(),this.z=r,this.C=o,this.D=u,this.F=y,this.G=O,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new T.$qe),this.s=this.B(new T.$qe),this.t=this.B(new T.$qe),this.u=this.B(new T.$qe),this.w=this.B(new T.$qe),this.y=[],this.B((0,C.$Xc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(u=>(0,g.$pp)(u,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const y=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:O})=>(0,l.$Sp)(O,r.identifier));if(y?.local)return y?.local;throw y?.error?y.error:new g.$tp(`Unknown error while installing extension ${r.identifier.id}`,g.ExtensionManagementErrorCode.Unknown)}catch(u){throw i(u)}}async installGalleryExtensions(r){if(!this.z.isEnabled())throw new g.$tp(m.localize(1767,null),g.ExtensionManagementErrorCode.NotAllowed);const o=[],u=[];return await Promise.allSettled(r.map(async({extension:y,options:O})=>{try{const S=await this.N(y,!!O?.installGivenVersion,!!O?.installPreReleaseVersion,O.productVersion??{version:this.G.version,date:this.G.date});u.push({...S,options:O})}catch(S){o.push({identifier:y.identifier,operation:g.InstallOperation.Install,source:y,error:S,profileLocation:O.profileLocation??this.W()})}})),u.length&&o.push(...await this.I(u)),o}async uninstall(r,o){return this.F.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtensions([{extension:r,options:o}])}async toggleAppliationScope(r,o){if((0,f.$An)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let u=await this.updateMetadata(r,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(u=await this.Z(r,this.H.defaultProfile.extensionsResource,o));for(const y of this.H.profiles){const O=(await this.getInstalled(f.ExtensionType.User,y.extensionsResource)).find(S=>(0,l.$Sp)(S.identifier,r.identifier));O?this.w.fire({local:O,profileLocation:y.extensionsResource}):this.u.fire({identifier:r.identifier,profileLocation:y.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(r,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:g.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.g||r-this.h>1e3*60*5)&&(this.g=this.U(),this.h=r),this.g}registerParticipant(r){this.y.push(r)}async resetPinnedStateForAllUserExtensions(r){try{await this.L(this.H.profiles.map(async o=>{const u=await this.getInstalled(f.ExtensionType.User,o.extensionsResource);await this.L(u.map(async y=>{y.pinned!==r&&await this.updateMetadata(y,{pinned:r},o.extensionsResource)}))}))}catch(o){throw this.F.error("Error while resetting pinned state for all user extensions",(0,k.$bb)(o)),o}}async I(r){const o=new Map,u=new Map,y=[],O=(v,N)=>`${l.$Tp.create(v).toString()}-${N.toString()}`,S=(v,N,F,U)=>{const j=this.X(v,N,F),G=`${(0,l.$Xp)(v.publisher,v.name)}-${F.profileLocation.toString()}`;u.set(G,{task:j,root:U}),this.n.fire({identifier:j.identifier,source:N,profileLocation:F.profileLocation}),this.F.info("Installing extension:",j.identifier.id,F),p.URI.isUri(N)||this.j.set(O(N,F.profileLocation),{task:j,waitingTasks:[]})};try{for(const{manifest:v,extension:N,options:F}of r){const U=F.isApplicationScoped||F.isBuiltin||(0,f.$An)(v),j={...F,installOnlyNewlyAddedFromExtensionPack:F.installOnlyNewlyAddedFromExtensionPack??!p.URI.isUri(N),isApplicationScoped:U,profileLocation:U?this.H.defaultProfile.extensionsResource:F.profileLocation??this.W(),productVersion:F.productVersion??{version:this.G.version,date:this.G.date}},G=p.URI.isUri(N)?void 0:this.j.get(O(N,j.profileLocation));G?(this.F.info("Extension is already requested to install",G.task.identifier.id,j.profileLocation.toString()),y.push(G.task.waitUntilTaskIsFinished())):S(v,N,j,void 0)}return await Promise.all([...u.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const N=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),F=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),U={...v.options,context:{...v.options.context,[g.$jp]:!0}};for(const{gallery:j,manifest:G}of(0,P.$Qb)(N,({gallery:W})=>W.identifier.id)){if(u.has(`${j.identifier.id.toLowerCase()}-${U.profileLocation.toString()}`))continue;const W=this.j.get(O(j,U.profileLocation));if(W){if(this.J(v,W.task)){const x=W.task.identifier;this.F.info("Waiting for already requested installing extension",x.id,v.identifier.id,U.profileLocation.toString()),W.waitingTasks.push(v),y.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,V=>V.some(te=>(0,l.$Sp)(te.identifier,x)))).then(V=>{if(this.F.info("Finished waiting for already requested installing extension",x.id,v.identifier.id,U.profileLocation.toString()),!V.find(B=>(0,l.$Sp)(B.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else F.some(({identifier:x})=>(0,l.$Sp)(x,j.identifier))||S(G,j,U,v)}}catch(N){if(p.URI.isUri(v.source))(0,P.$Pb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,N.message),(0,P.$Pb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,N.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),N}})),await this.L([...u.entries()].map(async([v,{task:N}])=>{const F=new Date().getTime();let U;try{U=await N.run(),await this.L(this.y.map(j=>j.postInstall(U,N.source,N.options,L.CancellationToken.None)),g.ExtensionManagementErrorCode.PostInstall)}catch(j){const G=i(j);throw p.URI.isUri(N.source)||n(this.C,N.operation===g.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$1p)(N.source),error:G,source:N.options.context?.[g.$ip]}),o.set(v,{error:G,identifier:N.identifier,operation:N.operation,source:N.source,context:N.options.context,profileLocation:N.options.profileLocation,applicationScoped:N.options.isApplicationScoped}),this.F.error("Error while installing the extension",N.identifier.id,(0,k.$bb)(G),N.options.profileLocation.toString()),G}if(!p.URI.isUri(N.source)){const j=N.operation===g.InstallOperation.Update,G=j?void 0:(new Date().getTime()-N.source.lastUpdated)/1e3;if(n(this.C,j?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$1p)(N.source),verificationStatus:N.verificationStatus,duration:new Date().getTime()-F,durationSinceUpdate:G,source:N.options.context?.[g.$ip]}),b.$r&&N.operation!==g.InstallOperation.Update)try{await this.z.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,g.StatisticType.Install)}catch{}}o.set(v,{local:U,identifier:N.identifier,operation:N.operation,source:N.source,context:N.options.context,profileLocation:N.options.profileLocation,applicationScoped:U.isApplicationScoped})})),y.length&&await this.L(y),[...o.values()]}catch(v){const N=(j,G,W)=>{const x=[];j.manifest.extensionDependencies?.length&&x.push(...j.manifest.extensionDependencies),j.manifest.extensionPack?.length&&x.push(...j.manifest.extensionPack);for(const V of x){if(W.includes(V.toLowerCase()))continue;W.push(V.toLowerCase());const te=o.get(`${V.toLowerCase()}-${G.toString()}`);te?.local&&(W=N(te.local,G,W))}return W},F=j=>({identifier:j.identifier,operation:g.InstallOperation.Install,source:j.source,context:j.options.context,profileLocation:j.options.profileLocation,error:v}),U=[];for(const[j,{task:G,root:W}]of u){const x=o.get(j);x?x.local&&W&&!o.get(`${W.identifier.id.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local&&(U.push(this.Y(x.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),o.set(j,F(G))):(G.cancel(),o.set(j,F(G)))}for(const[j,{task:G}]of u){const W=o.get(j);if(!W?.local||G.options.donotIncludePackAndDependencies)continue;N(W.local,G.options.profileLocation,[W.local.identifier.id.toLowerCase()]).slice(1).some(V=>u.has(`${V.toLowerCase()}-${G.options.profileLocation.toString()}`)&&!o.get(`${V.toLowerCase()}-${G.options.profileLocation.toString()}`)?.local)&&(U.push(this.Y(W.local,{versionOnly:!0,profileLocation:G.options.profileLocation})),o.set(j,F(G)))}throw U.length&&await Promise.allSettled(U.map(async j=>{try{await j.run(),this.F.info("Rollback: Uninstalled extension",j.extension.identifier.id)}catch(G){this.F.warn("Rollback: Error while uninstalling extension",j.extension.identifier.id,(0,k.$bb)(G))}})),v}finally{for(const{task:v}of u.values())v.source&&!p.URI.isUri(v.source)&&this.j.delete(O(v.source,v.options.profileLocation));if(o.size){const v=[...o.values()];for(const N of v)N.local&&this.F.info("Extension installed successfully:",N.identifier.id,N.profileLocation.toString());this.s.fire(v)}}}J(r,o){for(const[,{task:u,waitingTasks:y}]of this.j.entries())if(u===r&&(y.includes(o)||y.some(O=>this.J(O,o)))||u===o&&y[0]&&!this.J(r,y[0]))return!1;return!0}async L(r,o){const u=[],y=[],O=await Promise.allSettled(r);for(const v of O)v.status==="fulfilled"?u.push(v.value):y.push(i(v.reason,o));if(!y.length)return u;if(y.length===1)throw y[0];let S=new g.$tp("",g.ExtensionManagementErrorCode.Unknown);for(const v of y)S=new g.$tp(S.message?`${S.message}, ${v.message}`:v.message,v.code!==g.ExtensionManagementErrorCode.Unknown&&v.code!==g.ExtensionManagementErrorCode.Internal?v.code:S.code);throw S}async M(r,o,u,y,O,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,O,S),N=[],F=[],U=async(j,G)=>{N.push(j);const W=G.extensionDependencies||[],x=[...W];if(G.extensionPack){const V=u?v.find(te=>(0,l.$Sp)(te.identifier,j)):void 0;for(const te of G.extensionPack)V&&V.manifest.extensionPack&&V.manifest.extensionPack.some(B=>(0,l.$Sp)({id:B},{id:te}))||x.every(B=>!(0,l.$Sp)({id:B},{id:te}))&&x.push(te)}if(x.length){const V=x.filter(te=>N.every(B=>!(0,l.$Sp)(B,{id:te})));if(V.length){const te=await this.z.getExtensions(V.map(B=>({id:B,preRelease:y})),L.CancellationToken.None);for(const B of te){if(N.find(ne=>(0,l.$Sp)(ne,B.identifier)))continue;const H=W.some(ne=>(0,l.$Sp)({id:ne},B.identifier));let _;try{_=await this.N(B,!1,y,S)}catch(ne){if(H)throw ne;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,k.$bb)(ne));continue}F.push({gallery:_.extension,manifest:_.manifest}),await U(_.extension.identifier,_.manifest)}}}};return await U(r,o),F}async N(r,o,u,y){let O;const S=await this.getExtensionsControlManifest();if(S.malicious.some(F=>(0,l.$Sp)(r.identifier,F)))throw new g.$tp(m.localize(1768,null,r.identifier.id),g.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[r.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),O=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:y},L.CancellationToken.None))[0],!O)throw new g.$tp(m.localize(1769,null,r.identifier.id,v.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const F=await this.getTargetPlatform();throw new g.$tp(m.localize(1770,null,r.identifier.id,this.G.nameLong,(0,g.$lp)(F)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(O=await this.O(r,o,u,y),!O){const F=[];throw(0,E.$aq)(r.properties.enabledApiProposals??[],F)?!u&&r.properties.isPreReleaseVersion&&(await this.z.getExtensions([r.identifier],L.CancellationToken.None))[0]?new g.$tp(m.localize(1772,null,r.displayName??r.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$tp(m.localize(1773,null,r.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible):new g.$tp(m.localize(1771,null,r.displayName??r.identifier.id,F[0]),g.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",O.identifier.id);const N=await this.z.getManifest(O,L.CancellationToken.None);if(N===null)throw new g.$tp(`Missing manifest for extension ${O.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(N.version!==O.version)throw new g.$tp(`Cannot install '${O.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:O,manifest:N}}async O(r,o,u,y){const O=await this.getTargetPlatform();let S=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==u&&(S=(await this.z.getExtensions([{...r.identifier,preRelease:u}],{targetPlatform:O,compatible:!0,productVersion:y},L.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(r,u,O,y)&&(S=r),S||(o?S=(await this.z.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:O,compatible:!0,productVersion:y},L.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(r,u,O,y)),S}async uninstallExtensions(r){const o=(F,U)=>`${F.identifier.id.toLowerCase()}${U.versionOnly?`-${F.manifest.version}`:""}@${U.profileLocation.toString()}`,u=(F,U)=>{const j=this.Y(F,U);return this.m.set(o(j.extension,U),j),this.F.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,U.profileLocation.toString()),this.t.fire({identifier:F.identifier,profileLocation:U.profileLocation,applicationScoped:F.isApplicationScoped}),j},y=(F,U,j)=>{j?this.F.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,U.profileLocation.toString(),j.message):this.F.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,U.profileLocation.toString()),n(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Zp)(F),error:j}),this.u.fire({identifier:F.identifier,error:j?.code,profileLocation:U.profileLocation,applicationScoped:F.isApplicationScoped})},O=[],S=[],v=[],N=new A.$Fc;for(const{extension:F,options:U}of r){const j={...U,profileLocation:F.isApplicationScoped?this.H.defaultProfile.extensionsResource:U?.profileLocation??this.W()},G=this.m.get(o(F,j));G?(this.F.info("Extensions is already requested to uninstall",F.identifier.id),v.push(G.waitUntilTaskIsFinished())):O.push(u(F,j))}try{for(const F of O.slice(0)){let U=N.get(F.options.profileLocation);if(U||N.set(F.options.profileLocation,U=await this.getInstalled(f.ExtensionType.User,F.options.profileLocation)),F.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${F.extension.identifier.id}@${F.extension.manifest.version}`);else{const j=this.R(F.extension,U);for(const G of j)this.m.has(o(G,F.options))?this.F.info("Extensions is already requested to uninstall",G.identifier.id):O.push(u(G,F.options))}F.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${F.extension.identifier.id}@${F.extension.manifest.version}`):this.P(O.map(j=>j.extension),U,F.extension)}await this.L(O.map(async F=>{try{if(await F.run(),await this.L(this.y.map(U=>U.postUninstall(F.extension,F.options,L.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,g.StatisticType.Uninstall)}catch{}}catch(U){const j=i(U);throw y(F.extension,F.options,j),j}finally{S.push(F)}})),v.length&&await this.L(v);for(const F of O)y(F.extension,F.options)}catch(F){const U=i(F);for(const j of O){try{j.cancel()}catch{}S.includes(j)||y(j.extension,j.options,U)}throw U}finally{for(const F of O)this.m.delete(o(F.extension,F.options))||this.F.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}P(r,o,u){for(const y of r){const O=this.S(y,o);if(O.length){const S=O.filter(v=>!r.some(N=>(0,l.$Sp)(N.identifier,v.identifier)));if(S.length)throw new Error(this.Q(y,S,u))}}}Q(r,o,u){return u===r?o.length===1?m.localize(1774,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(1775,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(1776,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?m.localize(1777,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?m.localize(1778,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):m.localize(1779,null,u.manifest.displayName||u.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}R(r,o,u=[]){if(u.indexOf(r)!==-1)return[];u.push(r);const y=r.manifest.extensionPack?r.manifest.extensionPack:[];if(y.length){const O=o.filter(v=>!v.isBuiltin&&y.some(N=>(0,l.$Sp)({id:N},v.identifier))),S=[];for(const v of O)S.push(...this.R(v,o,u));return[...O,...S]}return[]}S(r,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(y=>(0,l.$Sp)({id:y},r.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(r){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$bb)(r)),{malicious:[],deprecated:{},search:[]}}}};e.$Nq=h,e.$Nq=h=Ee([Y(0,g.$rp),Y(1,I.$em),Y(2,$.$Pl),Y(3,w.$fk),Y(4,d.$yk),Y(5,c.$Rl)],h);function i(s,r){if(s instanceof g.$tp)return s;let o;return s instanceof g.$sp?o=new g.$tp(s.message,s.code===g.ExtensionGalleryErrorCode.DownloadFailedWriting?g.ExtensionManagementErrorCode.DownloadFailedWriting:g.ExtensionManagementErrorCode.Gallery):o=new g.$tp(s.message,(0,k.$8)(s)?g.ExtensionManagementErrorCode.Cancelled:r??g.ExtensionManagementErrorCode.Internal),o.stack=s.stack,o}function n(s,r,{extensionData:o,verificationStatus:u,duration:y,error:O,source:S,durationSinceUpdate:v}){let N,F;(0,R.$rg)(u)&&(u===!0?u="Verified":(u===!1||(N=g.ExtensionManagementErrorCode.Signature,F=u),u="Unverified")),O&&(N=O.code,O.code===g.ExtensionManagementErrorCode.Signature&&(F=O.message)),s.publicLog(r,{...o,verificationStatus:u,success:!O,duration:y,errorcode:N,errorcodeDetail:F,durationSinceUpdate:v,source:S})}class t{constructor(){this.d=new a.$Jh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,a.$xh)(r=>this.h(r))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,a.$xh)(r=>new Promise((o,u)=>{const y=r.onCancellationRequested(()=>{y.dispose(),u(new k.$9)})})),this.d.open()),this.g.cancel()}}e.$Pq=t}),define(fe[52],de([0,1,6,14,2,3,31,10,27,35,7,4,11,19,28,12,8,18]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=e.$Qq=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class I extends Error{constructor(n,t){super(n),this.code=t}}e.$Qq=I,e.$Rq=(0,p.$Ki)("IExtensionsProfileScannerService");let $=class extends L.$Zc{constructor(n,t,s,r,o,u){super(),this.j=n,this.m=t,this.n=s,this.r=r,this.s=o,this.t=u,this.b=this.B(new k.$qe),this.onAddExtensions=this.b.event,this.c=this.B(new k.$qe),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$qe),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$qe),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Fc}scanProfileExtensions(n,t){return this.u(n,void 0,t)}async addExtensionsToProfile(n,t,s){const r=[],o=[];try{return await this.u(t,u=>{const y=[];if(s)y.push(...u);else for(const O of u)n.some(([S])=>(0,b.$Sp)(S.identifier,O.identifier)&&S.manifest.version!==O.version)?r.push(O):y.push(O);for(const[O,S]of n){const v=y.findIndex(F=>(0,b.$Sp)(F.identifier,O.identifier)&&F.version===O.manifest.version),N={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:S};v===-1?(o.push(N),y.push(N)):y.splice(v,1,N)}return o.length&&this.b.fire({extensions:o,profileLocation:t}),r.length&&this.f.fire({extensions:r,profileLocation:t}),y}),o.length&&this.c.fire({extensions:o,profileLocation:t}),r.length&&this.g.fire({extensions:r,profileLocation:t}),o}catch(u){throw o.length&&this.c.fire({extensions:o,error:u,profileLocation:t}),r.length&&this.g.fire({extensions:r,error:u,profileLocation:t}),u}}async updateMetadata(n,t){const s=[];return await this.u(t,r=>{const o=[];for(const u of r){const y=n.find(([O])=>(0,b.$Sp)(O.identifier,u.identifier)&&O.manifest.version===u.version);y&&(u.metadata={...u.metadata,...y[1]},s.push(u)),o.push(u)}return o}),s}async removeExtensionFromProfile(n,t){const s=[];try{await this.u(t,r=>{const o=[];for(const u of r)(0,b.$Sp)(u.identifier,n.identifier)?s.push(u):o.push(u);return s.length&&this.f.fire({extensions:s,profileLocation:t}),o}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:t}),r}}async u(n,t,s){return this.F(n).queue(async()=>{let r=[],o;try{const u=await this.m.readFile(n);o=JSON.parse(u.value.toString().trim()||"[]")}catch(u){if((0,R.$wl)(u)!==R.FileOperationResult.FILE_NOT_FOUND)throw u;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&s?.bailOutWhenFileNotFound)throw new I((0,E.$bb)(u),d.ERROR_PROFILE_NOT_FOUND)}if(o){Array.isArray(o)||this.w(n);let u=!1;for(const y of o){c(y)||this.w(n);let O;if((0,f.$jg)(y.relativeLocation)&&y.relativeLocation)O=this.z(y.relativeLocation);else if((0,f.$jg)(y.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{O=C.URI.revive(y.location);const S=this.y(O);S&&(u=!0,y.relativeLocation=S)}(0,f.$qg)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(u=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:O,version:y.version,metadata:y.metadata})}u&&await this.m.writeFile(n,a.$Se.fromString(JSON.stringify(o)))}if(t){r=t(r);const u=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,a.$Se.fromString(JSON.stringify(u)))}return r})}w(n){const t=new I(`Invalid extensions content in ${n.toString()}`,d.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(n)).value.toString()}catch(o){if((0,R.$wl)(o)===R.FileOperationResult.FILE_NOT_FOUND)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(s);Array.isArray(o)&&o.every(u=>c(u))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,a.$Se.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,R.$wl)(o)===R.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,R.$wl)(o)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}try{await this.m.del(t)}catch(o){(0,R.$wl)(o)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(o)}return r})()),this.C}F(n){let t=this.h.get(n);return t||(t=new P.$Rh,this.h.set(n,t)),t}};e.$Sq=$,e.$Sq=$=Ee([Y(1,R.$fl),Y(2,g.$Rl),Y(3,l.$Pl),Y(4,w.$em),Y(5,m.$fk)],$);function c(i){return(0,f.$lg)(i)&&(0,A.$qp)(i.identifier)&&(h(i.location)||(0,f.$jg)(i.location)&&i.location)&&((0,f.$qg)(i.relativeLocation)||(0,f.$jg)(i.relativeLocation))&&i.version&&(0,f.$jg)(i.version)}function h(i){return i?(0,f.$jg)(i.path)&&(0,f.$jg)(i.scheme):!1}});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(fe[85],de([0,1,17,6,29,14,8,36,144,2,22,13,5,20,60,92,12,10,9,15,35,34,59,7,4,11,23,3,68,52,19,28,159]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c,h,i,n,t,s,r,o,u,y,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Xq=e.$Wq=e.$Vq=e.Translations=void 0,e.$Yq=G,L=Oe(L),p=Oe(p),m=Oe(m),l=Oe(l),f=it(f);var v;(function(x){function V(te,B){if(te===B)return!0;const H=Object.keys(te),_=new Set;for(const ne of Object.keys(B))_.add(ne);if(H.length!==_.size)return!1;for(const ne of H){if(te[ne]!==B[ne])return!1;_.delete(ne)}return _.size===0}x.equals=V})(v||(e.Translations=v={})),e.$Vq=(0,n.$Ki)("IExtensionsScannerService");let N=class extends b.$Zc{constructor(V,te,B,H,_,ne,le,ee,X,K,q,D){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=te,this.r=B,this.s=H,this.t=_,this.u=ne,this.w=le,this.y=ee,this.z=X,this.C=K,this.D=q,this.F=D,this.g=this.B(new r.$qe),this.onDidChangeCache=this.g.event,this.h=(0,g.$lh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(j,this.s,this.h)),this.m=this.B(this.F.createInstance(j,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(c.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(c.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,$.$4p)(this.w,this.y)),this.G}async scanAllExtensions(V,te,B){const[H,_]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(te)]),ne=B?await this.scanExtensionsUnderDevelopment(V,[...H,..._]):[];return this.L(H,_,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const te=[];te.push(this.M(!!V.useCache,V.language)),te.push(this.N(V.language,!!V.checkControlFile));const[B,H]=await Promise.all(te);return this.J([...B,...H],c.ExtensionType.System,V,!1)}async scanUserExtensions(V){const te=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const B=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,H=await this.P(te,!!V.profileLocation,c.ExtensionType.User,!V.includeUninstalled,V.language,!0,B,V.productVersion??this.R()),_=V.useCache&&!H.devMode&&H.excludeObsolete?this.m:this.n;let ne;try{ne=await _.scanExtensions(H)}catch(le){if(le instanceof u.$Qq&&le.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ne=await _.scanExtensions(H);else throw le}return ne=await this.J(ne,c.ExtensionType.User,V,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(V,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(H=>H.scheme===R.Schemas.file).map(async H=>{const _=await this.P(H,!1,c.ExtensionType.User,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(_)).map(le=>(le.type=te.find(ee=>(0,$.$Sp)(ee.identifier,le.identifier))?.type??le.type,this.n.validate(le,_)))}))).flat();return this.J(B,"development",V,!0)}return[]}async scanExistingExtension(V,te,B){const H=await this.P(V,!1,te,!0,B.language,!0,void 0,B.productVersion??this.R()),_=await this.n.scanExtension(H);return!_||!B.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(V,te,B){const H=await this.P(V,!1,te,!0,B.language,!0,void 0,B.productVersion??this.R()),_=await this.n.scanOneOrMultipleExtensions(H);return this.J(_,te,B,!0)}async scanMultipleExtensions(V,te,B){const H=[];return await Promise.all(V.map(async _=>{const ne=await this.scanOneOrMultipleExtensions(_,te,B);H.push(...ne)})),this.J(H,te,B,!0)}async scanMetadata(V){const te=(0,g.$lh)(V,"package.json"),B=(await this.w.readFile(te)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(V,te){const B=(0,g.$lh)(V,"package.json"),H=(await this.w.readFile(B)).value.toString(),_=JSON.parse(H);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,_.__metadata={..._.__metadata,...te},await this.w.writeFile((0,g.$lh)(V,"package.json"),k.$Se.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof u.$Qq&&V.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Se.fromString(JSON.stringify([])))}catch(te){(0,i.$wl)(te)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$bb)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,te,B,H){return B.includeAllVersions||(V=this.L(te===c.ExtensionType.System?V:void 0,te===c.ExtensionType.User?V:void 0,te==="development"?V:void 0,await this.getTargetPlatform(),H)),B.includeInvalid||(V=V.filter(_=>_.isValid)),V.sort((_,ne)=>{const le=p.$sc(_.location.fsPath),ee=p.$sc(ne.location.fsPath);return le<ee?-1:le>ee?1:0})}L(V,te,B,H,_){const ne=(ee,X,K)=>{if(ee.isValid&&!X.isValid)return!1;if(ee.isValid===X.isValid){if(_&&l.gt(ee.manifest.version,X.manifest.version))return this.y.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(l.eq(ee.manifest.version,X.manifest.version)){if(ee.type===c.ExtensionType.System)return this.y.debug(`Skipping extension ${X.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===H)return this.y.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${ee.location.path} with ${X.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${X.location.path}.`),!0},le=new c.$zn;return V?.forEach(ee=>{const X=le.get(ee.identifier.id);(!X||ne(X,ee,!1))&&le.set(ee.identifier.id,ee)}),te?.forEach(ee=>{const X=le.get(ee.identifier.id);if(!X&&V&&ee.type===c.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!X||ne(X,ee,!1))&&le.set(ee.identifier.id,ee)}),B?.forEach(ee=>{const X=le.get(ee.identifier.id);(!X||ne(X,ee,!0))&&le.set(ee.identifier.id,ee),le.set(ee.identifier.id,ee)}),[...le.values()]}async M(V,te){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,c.ExtensionType.System,!0,te,!0,void 0,this.R()),_=await(V&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",_.length),_}async N(V,te){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const H=te?await this.O():{},_=[],ne=w.URI.file(p.$mc(p.$oc(R.$5g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of B){const X=H[ee.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":_.push((0,g.$lh)(ne,ee.name));break;default:_.push(w.URI.file(X));break}}const le=await Promise.all(_.map(async ee=>this.n.scanExtension(await this.P(ee,!1,c.ExtensionType.System,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",le.length),(0,P.$Lb)(le)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,te,B,H,_,ne,le,ee){const X=await this.f(_??m.$z),K=await this.Q(V),q=te&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=q?await this.Q(q):void 0;return new F(V,K,q,D,te,le,B,H,ne,ee.version,ee.date,this.C.commit,!this.z.isBuilt,_,X)}async Q(V){try{const te=await this.w.stat(V);if(typeof te.mtime=="number")return te.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Wq=N,e.$Wq=N=Ee([Y(4,y.$Rl),Y(5,u.$Rq),Y(6,i.$fl),Y(7,t.$fk),Y(8,I.$Ri),Y(9,s.$yk),Y(10,O.$Pl),Y(11,n.$Ji)],N);class F{constructor(V,te,B,H,_,ne,le,ee,X,K,q,D,J,oe,Q){this.location=V,this.mtime=te,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=H,this.profile=_,this.profileScanOptions=ne,this.type=le,this.excludeObsolete=ee,this.validate=X,this.productVersion=K,this.productDate=q,this.productCommit=D,this.devMode=J,this.language=oe,this.translations=Q}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,te){return(0,g.$eh)(V.location,te.location)&&V.mtime===te.mtime&&(0,g.$eh)(V.applicationExtensionslocation,te.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&V.profile===te.profile&&L.$oo(V.profileScanOptions,te.profileScanOptions)&&V.type===te.type&&V.excludeObsolete===te.excludeObsolete&&V.validate===te.validate&&V.productVersion===te.productVersion&&V.productDate===te.productDate&&V.productCommit===te.productCommit&&V.devMode===te.devMode&&V.language===te.language&&v.equals(V.translations,te.translations)}}e.$Xq=F;let U=class extends b.$Zc{constructor(V,te,B,H,_,ne,le){super(),this.g=V,this.h=te,this.j=B,this.m=H,this.n=ne,this.r=le,this.f=_.extensionsEnabledWithApiProposalVersion?.map(ee=>ee.toLowerCase())??[]}async scanExtensions(V){const te=V.profile?await this.t(V):await this.s(V);let B={};if(V.excludeObsolete&&V.type===c.ExtensionType.User)try{const H=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(H)}catch{}return(0,E.$wg)(B)?te:te.filter(H=>!B[$.$Tp.create(H).toString()])}async s(V){const te=await this.m.resolve(V.location);if(!te.children?.length)return[];const B=await Promise.all(te.children.map(async H=>{if(!H.isDirectory||V.type===c.ExtensionType.User&&(0,g.$ih)(H.resource).indexOf(".")===0)return null;const _=new F(H.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(_)}));return(0,P.$Lb)(B).sort((H,_)=>H.location.path<_.location.path?-1:1)}async t(V){let te=await this.u(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.j.extUri.isEqual(V.location,V.applicationExtensionslocation)){te=te.filter(H=>!H.metadata?.isApplicationScoped);const B=await this.u(V.applicationExtensionslocation,H=>!!H.metadata?.isBuiltin||!!H.metadata?.isApplicationScoped,V);te.push(...B)}return te}async u(V,te,B){const H=await this.h.scanProfileExtensions(V,B.profileScanOptions);if(!H.length)return[];const _=await Promise.all(H.map(async ne=>{if(te(ne)){const le=new F(ne.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(le,ne.metadata)}return null}));return(0,P.$Lb)(_)}async scanOneOrMultipleExtensions(V){try{if(await this.m.exists((0,g.$lh)(V.location,"package.json"))){const te=await this.scanExtension(V);return te?[te]:[]}else return await this.scanExtensions(V)}catch(te){return this.r.error(`Error scanning extensions at ${V.location.path}:`,(0,T.$bb)(te)),[]}}async scanExtension(V,te){try{let B=await this.w(V.location);if(B){B.publisher||(B.publisher=c.$tn),te=te??B.__metadata,delete B.__metadata;const H=(0,$.$Xp)(B.publisher,B.name),_=te?.id?{id:H,uuid:te.id}:{id:H},ne=te?.isSystem?c.ExtensionType.System:V.type,le=ne===c.ExtensionType.System||!!te?.isBuiltin;B=await this.y(V.location,B,F.createNlsConfiguration(V));let ee={type:ne,identifier:_,manifest:B,location:V.location,isBuiltin:le,targetPlatform:te?.targetPlatform??c.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return V.validate&&(ee=this.validate(ee,V)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(H.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,c.$Fn)([...B.enabledApiProposals])),ee}}catch(B){V.type!==c.ExtensionType.System&&this.r.error(B)}return null}validate(V,te){let B=!0;const H=this.n.isBuilt&&this.f.includes(V.identifier.id.toLowerCase()),_=(0,h.$0p)(te.productVersion,te.productDate,te.location,V.manifest,V.isBuiltin,H);for(const[ne,le]of _)ne===f.default.Error&&(B=!1,this.r.error(this.F(te.location,le)));return V.isValid=B,V.validations=_,V}async w(V){const te=(0,g.$lh)(V,"package.json");let B;try{B=(await this.m.readFile(te)).value.toString()}catch(_){return(0,i.$wl)(_)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(V,(0,d.localize)(1815,null,te.path,_.message))),null}let H;try{H=JSON.parse(B)}catch{const ne=[];(0,C.$5n)(B,ne);for(const le of ne)this.r.error(this.F(V,(0,d.localize)(1816,null,te.path,le.offset,le.length,(0,A.$Tq)(le.error))));return null}return(0,C.$ao)(H)!=="object"?(this.r.error(this.F(V,(0,d.localize)(1817,null,te.path))),null):H}async y(V,te,B){const H=await this.z(V,te,B);if(H)try{const _=[],ne=await this.C(H.default,_);if(_.length>0)return _.forEach(ee=>{this.r.error(this.F(V,(0,d.localize)(1818,null,H.default?.path,(0,A.$Tq)(ee.error))))}),te;if((0,C.$ao)(H)!=="object")return this.r.error(this.F(V,(0,d.localize)(1819,null,H.default?.path))),te;const le=H.values||Object.create(null);return(0,S.$Uq)(this.r,te,le,ne)}catch{}return te}async z(V,te,B){const H=(0,g.$lh)(V,"package.nls.json"),_=(X,K)=>{K.forEach(q=>{this.r.error(this.F(V,(0,d.localize)(1820,null,X?.path,(0,A.$Tq)(q.error))))})},ne=X=>{this.r.error(this.F(V,(0,d.localize)(1821,null,X?.path)))},le=`${te.publisher}.${te.name}`,ee=B.translations[le];if(ee)try{const X=w.URI.file(ee),K=(await this.m.readFile(X)).value.toString(),q=[],D=(0,C.$5n)(K,q);return q.length>0?(_(X,q),{values:void 0,default:H}):(0,C.$ao)(D)!=="object"?(ne(X),{values:void 0,default:H}):{values:D.contents?D.contents.package:void 0,default:H}}catch{return{values:void 0,default:H}}else{if(!await this.m.exists(H))return;let K;try{K=await this.D(V,B)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const q=(await this.m.readFile(K.localized)).value.toString(),D=[],J=(0,C.$5n)(q,D);return D.length>0?(_(K.localized,D),{values:void 0,default:K.original}):(0,C.$ao)(J)!=="object"?(ne(K.localized),{values:void 0,default:K.original}):{values:J,default:K.original}}catch{return{values:void 0,default:K.original}}}}async C(V,te){if(V)try{const B=(await this.m.readFile(V)).value.toString();return(0,C.$5n)(B,te)}catch{}}D(V,te){return new Promise((B,H)=>{const _=ne=>{const le=(0,g.$lh)(V,`package.nls.${ne}.json`);this.m.exists(le).then(ee=>{ee&&B({localized:le,original:(0,g.$lh)(V,"package.nls.json")});const X=ne.lastIndexOf("-");X===-1?B({localized:(0,g.$lh)(V,"package.nls.json"),original:null}):(ne=ne.substring(0,X),_(ne))})};if(te.devMode||te.pseudo||!te.language)return B({localized:(0,g.$lh)(V,"package.nls.json"),original:null});_(te.language)})}F(V,te){return`[${V.path}]: ${te}`}};U=Ee([Y(1,u.$Rq),Y(2,O.$Pl),Y(3,i.$fl),Y(4,s.$yk),Y(5,I.$Ri),Y(6,t.$fk)],U);let j=class extends U{constructor(V,te,B,H,_,ne,le,ee,X){super(te,H,_,ne,le,ee,X),this.J=V,this.L=B,this.H=this.B(new a.$Ih(3e3)),this.I=this.B(new r.$qe),this.onDidChangeCache=this.I.event}async scanExtensions(V){const te=this.P(V),B=await this.M(te);if(this.G=V,B&&B.input&&F.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",V.type===c.ExtensionType.System?"system":"user",V.location.toString()),this.H.trigger(()=>this.O()),B.result.map(_=>(_.location=w.URI.revive(_.location),_));const H=await super.scanExtensions(V);return await this.N(te,{input:V,result:H}),H}async M(V){try{const te=await this.m.readFile(V),B=JSON.parse(te.value.toString());return{result:B.result,input:(0,o.$hi)(B.input)}}catch(te){this.r.debug("Error while reading the extension cache file:",V.path,(0,T.$bb)(te))}return null}async N(V,te){try{await this.m.writeFile(V,k.$Se.fromString(JSON.stringify(te)))}catch(B){this.r.debug("Error while writing the extension cache file:",V.path,(0,T.$bb)(B))}}async O(){if(!this.G)return;const V=this.P(this.G),te=await this.M(V);if(!te)return;const B=te.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!L.$oo(H,B))try{this.r.info("Invalidating Cache",B,H),await this.m.del(V),this.I.fire()}catch(_){this.r.error(_)}}P(V){const te=this.Q(V);return this.j.extUri.joinPath(te.cacheHome,V.type===c.ExtensionType.System?c.$sn:c.$rn)}Q(V){return V.type===c.ExtensionType.System?this.L.defaultProfile:V.profile?this.j.extUri.isEqual(V.location,this.J.extensionsResource)?this.J:this.L.profiles.find(te=>this.j.extUri.isEqual(V.location,te.extensionsResource))??this.J:this.L.defaultProfile}};j=Ee([Y(2,y.$Rl),Y(3,u.$Rq),Y(4,O.$Pl),Y(5,i.$fl),Y(6,s.$yk),Y(7,I.$Ri),Y(8,t.$fk)],j);function G(x,V){const te=(0,$.$Vp)(x.manifest.publisher,x.manifest.name);return{id:te,identifier:new c.$xn(te),isBuiltin:x.type===c.ExtensionType.System,isUserBuiltin:x.type===c.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:V,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class W extends N{constructor(V,te,B,H,_,ne,le,ee,X,K,q,D){super(V,te,(0,g.$lh)(B,".vscode-oss-dev","extensions","control.json"),H,_,ne,le,ee,X,K,q,D),this.S=(async()=>{if(m.$C)try{const J=await this.w.readFile(w.URI.file(m.$C));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$Zq=W}),define(fe[217],de([0,1,70,6,41,3,2,22,13,30,11,19]),function(ce,e,P,a,L,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let m=class extends T.$Zc{constructor(l,f){super(),this.b=l,this.f=f,this.a=new a.$Qh(5)}async postUninstall(l){const f=this.g(l,"uninstall");f&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(f.script,"uninstall",f.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(E)}}));try{await b.Promises.rm(this.m(l))}catch(E){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(E)}}g(l,f){const E=`vscode:${f}`;if(l.location.scheme===C.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[E]=="string"){const w=l.manifest.scripts[E].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${E} should be a node script`),null):{script:(0,A.$oc)(l.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}h(l,f,E,w,d){return new Promise((I,$)=>{const c=this.j(l,f,E,d);let h;const i=n=>{h&&(clearTimeout(h),h=null),n?$(n):I(void 0)};c.on("error",n=>{i((0,L.$vj)(n)||"Unknown")}),c.on("exit",(n,t)=>{i(n?`post-${f} process exited with code ${n}`:void 0)}),w&&(h=setTimeout(()=>{h=null,c.kill(),$("timed out")},5e3))})}j(l,f,E,w){const d={silent:!0,execArgv:void 0},I=(0,P.fork)(l,[`--type=extension-post-${f}`,...E],d);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const $=k.Event.fromNodeEventEmitter(I.stdout,"data"),c=k.Event.fromNodeEventEmitter(I.stderr,"data");this.B($(n=>this.f.info(w.identifier.id,w.manifest.version,`post-${f}`,n))),this.B(c(n=>this.f.error(w.identifier.id,w.manifest.version,`post-${f}`,n)));const h=k.Event.any(k.Event.map($,n=>({data:`%c${n}`,format:[""]}),this.q),k.Event.map(c,n=>({data:`%c${n}`,format:["color: red"]}),this.q));return k.Event.debounce(h,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(n=>{console.group(w.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),I}m(l){return(0,A.$oc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$4q=m,e.$4q=m=Ee([Y(0,p.$Rl),Y(1,R.$fk)],m)}),define(fe[118],de([0,1,71,9,84,27]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=T,e.$2q=C;function T(A){let b=k.ExtensionManagementErrorCode.Extract;return A instanceof P.$Jq&&(A.type==="CorruptZip"?b=k.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(b=k.ExtensionManagementErrorCode.IncompleteZip)),(0,L.$Oq)(A,b)}async function C(A){let b;try{b=await(0,P.$Mq)(A,"extension/package.json")}catch(R){throw T(R)}try{return JSON.parse(b.toString("utf8"))}catch{throw new k.$tp((0,a.localize)(1831,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(fe[218],de([0,1,6,8,2,22,20,60,12,32,30,71,21,15,84,27,35,118,112,7,11,18]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0,C=Oe(C);let i=class extends L.$Zc{static{h=this}static{this.c=".sigzip"}constructor(t,s,r,o,u,y,O){super(),this.h=s,this.j=r,this.m=o,this.n=u,this.r=y,this.t=O,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,r,o){await this.g;const u=await this.w(t,s);let y=!1;if(r&&this.u(t)){let O;try{O=await this.y(t)}catch(S){try{await this.delete(u)}catch(v){this.t.error(v)}throw S}try{y=await this.n.verify(t,u.fsPath,O.fsPath,o)}catch(S){if(y=S.code,y===d.ExtensionSignatureVerificationCode.PackageIsInvalidZip||y===d.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(u)}catch(v){this.t.error(v)}throw new f.$tp(p.$Iq,f.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(O)}catch(S){this.t.error(S)}}}return{location:u,verificationStatus:y}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,A.$pg)(s)?s:!0}async w(t,s){try{const r=(0,T.$lh)(this.extensionsDownloadDir,this.G(t)),o=await this.C(t,"vsix",async()=>{await this.z(t,r,u=>this.j.download(t,u,s));try{await this.D(r.fsPath,"extension/package.json")}catch(u){try{await this.h.del(r)}catch(y){this.t.warn(`Error while deleting: ${r.path}`,(0,a.$bb)(y))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:o}),r}catch(r){throw(0,l.$Oq)(r,f.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,T.$lh)(this.extensionsDownloadDir,`.${(0,b.$7g)()}`),r=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(o){try{await this.h.del(s)}catch(u){this.t.warn(`Error while deleting: ${s.path}`,(0,a.$bb)(u))}throw o}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:r}),s}catch(s){throw(0,l.$Oq)(s,f.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,r){if(await this.h.exists(s))return;if(s.scheme!==k.Schemas.file){await r(s);return}const o=(0,T.$lh)(this.extensionsDownloadDir,`.${(0,b.$7g)()}`);try{await r(o)}catch(u){try{await this.h.del(o)}catch{}throw u}try{await R.Promises.rename(o.fsPath,s.fsPath,2*60*1e3)}catch(u){try{await this.h.del(o)}catch{}let y=!1;try{y=await this.h.exists(s)}catch{}if(y)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,a.$bb)(u)}. Deleted the file from downloaded location`,o.path),u}}async C(t,s,r,o){let u=1;for(;;)try{return await r(),u}catch(y){if(u++>o)throw y;this.t.warn(`Failed downloading ${s}. ${(0,a.$bb)(y)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,p.$Mq)(t,s)}catch(r){throw(0,w.$1q)(r)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],r=[],o=[];for(const O of t.children)if(O.name.endsWith(h.c))o.push(O.resource);else{const S=E.$Tp.parse(O.name);S&&r.push([S,O])}const u=(0,E.$Yp)(r,([O])=>O),y=[];for(const O of u)O.sort((S,v)=>C.rcompare(S[0].version,v[0].version)),s.push(...O.slice(1).map(S=>S[1].resource)),y.push(O[0][1]);y.sort((O,S)=>O.mtime-S.mtime),s.push(...y.slice(0,Math.max(0,y.length-this.f)).map(O=>O.resource)),s.push(...o),await P.Promises.settled(s.map(O=>(this.t.trace("Deleting from cache",O.path),this.h.del(O))))}}catch(t){this.t.error(t)}}G(t){return this.f?E.$Tp.create(t).toString().toLowerCase():(0,b.$7g)()}};e.$3q=i,e.$3q=i=h=Ee([Y(0,g.$Si),Y(1,I.$fl),Y(2,f.$rp),Y(3,m.$ej),Y(4,d.$Bq),Y(5,c.$em),Y(6,$.$fk)],i)}),define(fe[119],de([0,1,33,6,14,25,41,8,3,55,2,31,22,13,20,60,12,10,32,30,71,9,100,15,84,27,35,52,85,218,217,118,190,200,34,59,7,4,11,23,18,28,19]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c,h,i,n,t,s,r,o,u,y,O,S,v,N,F,U,j,G,W,x,V,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=void 0,P=Oe(P),g=Oe(g),f=Oe(f),I=Oe(I),c=Oe(c),e.$7q=(0,j.$Li)(t.$up);const B=".vsctmp";let H=class extends n.$Nq{constructor(X,K,q,D,J,oe,Q,Z,M,z,ie,ae){super(X,K,ie,q,z,ae),this.db=J,this.eb=oe,this.fb=Q,this.gb=Z,this.hb=M,this.cb=new Map,this.sb=new p.$Gc;const ue=this.B(Z.createInstance(y.$4q));this.$=this.B(Z.createInstance(_,be=>ue.postUninstall(be))),this.ab=this.B(new S.$5q(ae,M,ie,this,this.F)),this.bb=this.B(Z.createInstance(u.$3q));const pe=this.B(new v.$6q(this,this.db,ae,oe,ie,M,q));this.B(pe.onDidChangeExtensionsByAnotherSource(be=>this.rb(be))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$4p)(this.hb,this.F)),this.ib}async zip(X){this.F.trace("ExtensionManagementService#zip",X.identifier.id);const K=await this.qb(X),q=await(0,$.zip)((0,l.$lh)(this.bb.extensionsDownloadDir,(0,d.$7g)()).fsPath,K);return w.URI.file(q)}async getManifest(X){const{location:K,cleanup:q}=await this.kb(X),D=g.$pc(K.fsPath);try{return await(0,O.$2q)(D)}finally{await q()}}getInstalled(X,K=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(X??null,K,q)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.$.scanUserExtensionAtLocation(X)}async install(X,K={}){this.F.trace("ExtensionManagementService#install",X.toString());const{location:q,cleanup:D}=await this.kb(X);try{const J=await(0,O.$2q)(g.$pc(q.fsPath)),oe=(0,s.$Xp)(J.publisher,J.name);if(J.engines&&J.engines.vscode&&!(0,F.$_p)(J.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(1822,null,oe,this.G.version));const Z=(await this.I([{manifest:J,extension:q,options:K}])).find(({identifier:M})=>(0,s.$Sp)(M,{id:oe}));if(Z?.local)return Z.local;throw Z?.error?Z.error:(0,n.$Oq)(new Error(`Unknown error while installing extension ${oe}`))}finally{await D()}}async installFromLocation(X,K){this.F.trace("ExtensionManagementService#installFromLocation",X.toString());const q=await this.$.scanUserExtensionAtLocation(X);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.vb([[q,{source:"resource"}]],K),this.F.info("Successfully installed extension",q.identifier.id,K.toString()),q}async installExtensionsFromProfile(X,K,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",X,K.toString(),q.toString());const D=(await this.getInstalled(N.ExtensionType.User,K)).filter(J=>X.some(oe=>(0,s.$Sp)(oe,J.identifier)));if(D.length){const J=await Promise.all(D.map(oe=>this.$.scanMetadata(oe,K)));await this.vb(D.map((oe,Q)=>[oe,J[Q]]),q),this.F.info("Successfully installed extensions",D.map(oe=>oe.identifier.id),q.toString())}return D}async updateMetadata(X,K,q){return this.F.trace("ExtensionManagementService#updateMetadata",X.identifier.id),K.isPreReleaseVersion&&(K.preRelease=!0,K.hasPreReleaseVersion=!0),K.isMachineScoped===!1&&(K.isMachineScoped=void 0),K.isBuiltin===!1&&(K.isBuiltin=void 0),K.pinned===!1&&(K.pinned=void 0),X=await this.$.updateMetadata(X,K,q),this.ab.invalidate(q),this.w.fire({local:X,profileLocation:q}),X}async reinstallFromGallery(X){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1823,null));const K=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:K,compatible:!0},k.CancellationToken.None);if(!q)throw new Error(c.localize(1824,null));await this.$.setUninstalled(X);try{await this.$.removeUninstalledExtension(X)}catch(D){throw new Error(c.localize(1825,null,(0,T.$vj)(D)))}return this.installFromGallery(q)}Z(X,K,q,D){return this.$.copyExtension(X,K,q,D)}copyExtensions(X,K){return this.$.copyExtensions(X,K,{version:this.G.version,date:this.G.date})}markAsUninstalled(...X){return this.$.setUninstalled(...X)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(X){this.F.error(X)}}async download(X,K,q){const{location:D}=await this.bb.download(X,K,!q);return D}async kb(X){if(X.scheme===m.Schemas.file)return{location:X,async cleanup(){}};this.F.trace("Downloading extension from",X.toString());const K=(0,l.$lh)(this.bb.extensionsDownloadDir,(0,d.$7g)());return await this.fb.download(X,K),this.F.info("Downloaded extension to",K.toString()),{location:K,cleanup:async()=>{try{await this.hb.del(K)}catch(D){this.F.error(D)}}}}W(){return this.H.defaultProfile.extensionsResource}X(X,K,q){const D=K instanceof w.URI?new s.$Tp({id:(0,s.$Xp)(X.publisher,X.name)},X.version):s.$Tp.create(K);return this.gb.createInstance(ne,D,X,K,q,(J,oe)=>{if(K instanceof w.URI)return this.pb(D,K,q,oe);let Q=this.cb.get(D.toString());return Q||(this.cb.set(D.toString(),Q=this.ob(D,K,J,q,oe)),Q.finally(()=>this.cb.delete(D.toString()))),Q},this.$)}Y(X,K){return new le(X,K,this.eb)}async ob(X,K,q,D,J){const{verificationStatus:oe,location:Q}=await this.bb.download(K,q,!D.donotVerifySignature,D.context?.[t.$kp]);try{if(J.isCancellationRequested)throw new C.$9;const Z=await(0,O.$2q)(Q.fsPath);if(!new s.$Tp(K.identifier,K.version).equals(new s.$Tp({id:(0,s.$Xp)(Z.publisher,Z.name)},Z.version)))throw new t.$tp(c.localize(1826,null,K.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(X,Q.fsPath,{id:K.identifier.uuid,publisherId:K.publisherId,publisherDisplayName:K.publisherDisplayName,targetPlatform:K.properties.targetPlatform,isApplicationScoped:D.isApplicationScoped,isMachineScoped:D.isMachineScoped,isBuiltin:D.isBuiltin,isPreReleaseVersion:K.properties.isPreReleaseVersion,hasPreReleaseVersion:K.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:D.installGivenVersion?!0:!!D.pinned,preRelease:(0,E.$pg)(D.preRelease)?D.preRelease:D.installPreReleaseVersion||K.properties.isPreReleaseVersion,source:"gallery"},!1,J),verificationStatus:oe}}catch(Z){try{await this.bb.delete(Q)}catch(M){this.F.warn("Error while deleting the downloaded file",Q.toString(),(0,C.$bb)(M))}throw(0,n.$Oq)(Z)}}async pb(X,K,q,D){return{local:await this.$.extractUserExtension(X,g.$pc(K.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},q.keepExisting??!0,D)}}async qb(X){const K=async D=>{let J=await I.Promises.readdir(D);J=J.map(Z=>g.$oc(D,Z));const oe=await Promise.all(J.map(Z=>P.promises.stat(Z)));let Q=Promise.resolve([]);return oe.forEach((Z,M)=>{const z=J[M];Z.isFile()&&(Q=Q.then(ie=>[...ie,z])),Z.isDirectory()&&(Q=Q.then(ie=>K(z).then(ae=>[...ie,...ae])))}),Q};return(await K(X.location.fsPath)).map(D=>({path:`extension/${g.$qc(X.location.fsPath,D)}`,localPath:D}))}async rb({added:X,removed:K}){if(K){const q=X&&this.D.extUri.isEqual(K.profileLocation,X.profileLocation)?K.extensions.filter(D=>X.extensions.every(J=>!(0,s.$Sp)(J,D))):K.extensions;for(const D of q)this.F.info("Extensions removed from another source",D.id,K.profileLocation.toString()),this.u.fire({identifier:D,profileLocation:K.profileLocation})}if(X){const D=(await this.getInstalled(N.ExtensionType.User,X.profileLocation)).filter(J=>X.extensions.some(oe=>(0,s.$Sp)(oe,J.identifier)));this.s.fire(D.map(J=>(this.F.info("Extensions added from another source",J.identifier.id,X.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:X.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(K=>this.sb.add(K)));const X=await this.hb.resolve(this.db.userExtensionsLocation);for(const K of X.children??[])K.isDirectory&&this.sb.add(K.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(K=>this.ub(K)))}async ub(X){if(!X.affects(this.db.userExtensionsLocation,U.FileChangeType.ADDED))return;const K=[];for(const q of X.rawAdded){if(this.sb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.db.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.hb.stat(q)).isDirectory)continue;const D=await this.$.scanUserExtensionAtLocation(q);D&&D.installedTimestamp===void 0&&(this.sb.add(q),K.push(D))}K.length&&(await this.vb(K.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",K.map(q=>q.identifier.id)))}async vb(X,K){const q=X.map(D=>D[0]);await this.wb(q),await this.eb.addExtensionsToProfile(X,K),this.s.fire(q.map(D=>({local:D,identifier:D.identifier,operation:t.InstallOperation.None,profileLocation:K})))}async wb(X){const K=await this.$.getUninstalledExtensions();for(const q of X){const D=s.$Tp.create(q);K[D.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",D.id),await this.$.setInstalled(D),this.F.info("Removed the extension from uninstalled list:",D.id))}}};e.$8q=H,e.$8q=H=Ee([Y(0,t.$rp),Y(1,x.$em),Y(2,G.$fk),Y(3,i.$Si),Y(4,o.$Vq),Y(5,r.$Rq),Y(6,h.$8o),Y(7,j.$Ji),Y(8,U.$fl),Y(9,W.$yk),Y(10,V.$Pl),Y(11,te.$Rl)],H);let _=class extends R.$Zc{constructor(X,K,q,D,J,oe,Q){super(),this.n=X,this.s=K,this.t=q,this.u=D,this.w=J,this.y=oe,this.z=Q,this.h=this.B(new A.$qe),this.onExtract=this.h.event,this.j=new p.$Fc,this.m=new p.$Fc,this.c=(0,l.$lh)(this.t.userExtensionsLocation,".obsolete"),this.g=new a.$Rh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(X,K,q){try{const D={includeInvalid:!0,profileLocation:K,productVersion:q};let J=[];if(X===null||X===N.ExtensionType.System){let oe=this.j.get(K);oe||(oe=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},D,!1).finally(()=>this.j.delete(K)),this.j.set(K,oe)),J.push(...await oe)}else if(X===N.ExtensionType.User){let oe=this.m.get(K);oe||(oe=this.t.scanUserExtensions(D).finally(()=>this.m.delete(K)),this.m.set(K,oe)),J.push(...await oe)}return J=X!==null?J.filter(oe=>oe.type===X):J,await Promise.all(J.map(oe=>this.H(oe)))}catch(D){throw(0,n.$Oq)(D,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(X){try{const K=await this.t.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return await Promise.all(K.map(q=>this.H(q)))}catch(K){throw(0,n.$Oq)(K,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(X){try{const K=await this.t.scanExistingExtension(X,N.ExtensionType.User,{includeInvalid:!0});if(K)return await this.H(K)}catch(K){this.z.error(K)}return null}async extractUserExtension(X,K,q,D,J){const oe=X.toString(),Q=w.URI.file(g.$oc(this.t.userExtensionsLocation.fsPath,`.${(0,d.$7g)()}`)),Z=w.URI.file(g.$oc(this.t.userExtensionsLocation.fsPath,oe));if(await this.s.exists(Z)){if(!D)try{return await this.scanLocalExtension(Z,N.ExtensionType.User)}catch(M){this.z.warn(`Error while scanning the existing extension at ${Z.path}. Deleting the existing extension and extracting it.`,(0,C.$bb)(M))}try{await this.D(X.id,Z,"removeExisting")}catch{throw new t.$tp(c.localize(1827,null,Z.fsPath,X.id),t.ExtensionManagementErrorCode.Delete)}}try{if(J.isCancellationRequested)throw new C.$9;try{this.z.trace(`Started extracting the extension from ${K} to ${Z.fsPath}`),await(0,$.$Lq)(K,Q.fsPath,{sourcePath:"extension",overwrite:!0},J),this.z.info(`Extracted extension to ${Z}:`,X.id)}catch(M){throw(0,O.$1q)(M)}try{await this.t.updateMetadata(Q,q)}catch(M){throw this.y.publicLog2("extension:extract",{extensionId:X.id,code:`${(0,U.$wl)(M)}`}),(0,n.$Oq)(M,t.ExtensionManagementErrorCode.UpdateMetadata)}if(J.isCancellationRequested)throw new C.$9;try{this.z.trace(`Started renaming the extension from ${Q.fsPath} to ${Z.fsPath}`),await this.G(Q.fsPath,Z.fsPath),this.z.info("Renamed to",Z.fsPath)}catch(M){if(M.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);try{await this.s.del(Q,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,C.$bb)(M)}. Deleted from extracted location`,Q),M}this.h.fire(Z)}catch(M){try{await this.s.del(Q,{recursive:!0})}catch{}throw M}return this.scanLocalExtension(Z,N.ExtensionType.User)}async scanMetadata(X,K){return K?(await this.C(X,K))?.metadata:this.t.scanMetadata(X.location)}async C(X,K){return(await this.u.scanProfileExtensions(K)).find(D=>(0,s.$Sp)(D.identifier,X.identifier))}async updateMetadata(X,K,q){try{q?await this.u.updateMetadata([[X,K]],q):await this.t.updateMetadata(X.location,K)}catch(D){throw this.y.publicLog2("extension:extract",{extensionId:X.identifier.id,code:`${(0,U.$wl)(D)}`,isProfile:!!q}),(0,n.$Oq)(D,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(X.location,X.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(X){throw(0,n.$Oq)(X,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...X){const K=X.map(q=>s.$Tp.create(q));await this.F(q=>K.forEach(D=>{q[D.toString()]=!0,this.z.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(X){try{await this.F(K=>delete K[X.toString()])}catch(K){throw(0,n.$Oq)(K,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(X,K){if(this.w.extUri.isEqualOrParent(X.location,this.t.userExtensionsLocation))return this.D(X.identifier.id,X.location,K)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.F(K=>delete K[s.$Tp.create(X).toString()])}async copyExtension(X,K,q,D){const J=await this.C(X,K),oe=await this.C(X,q);if(D={...J?.metadata,...D},oe)if(this.w.extUri.isEqual(oe.location,X.location))await this.u.updateMetadata([[X,{...oe.metadata,...D}]],q);else{const Q=await this.scanLocalExtension(oe.location,X.type,q);await this.u.removeExtensionFromProfile(Q,q),await this.u.addExtensionsToProfile([[X,{...oe.metadata,...D}]],q)}else await this.u.addExtensionsToProfile([[X,D]],q);return this.scanLocalExtension(X.location,X.type,q)}async copyExtensions(X,K,q){const D=await this.scanExtensions(N.ExtensionType.User,X,q),J=await Promise.all(D.filter(oe=>!oe.isApplicationScoped).map(async oe=>[oe,await this.scanMetadata(oe,X)]));await this.u.addExtensionsToProfile(J,K)}async D(X,K,q){this.z.trace(`Deleting ${q} extension from disk`,X,K.fsPath);const D=this.w.extUri.joinPath(this.w.extUri.dirname(K),`${this.w.extUri.basename(K)}.${(0,b.$yj)((0,d.$7g)()).toString(16)}${B}`);await this.G(K.fsPath,D.fsPath),await this.s.del(D,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,X,K.fsPath)}F(X){return this.g.queue(async()=>{let K;try{K=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,U.$wl)(D)!==U.FileOperationResult.FILE_NOT_FOUND)throw D}let q={};if(K)try{q=JSON.parse(K)}catch{}return X&&(X(q),Object.keys(q).length?await this.s.writeFile(this.c,L.$Se.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(X,K){try{await I.Promises.rename(X,K,2*60*1e3)}catch(q){throw(0,n.$Oq)(q,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(X,K,q){try{if(q){const J=(await this.t.scanUserExtensions({profileLocation:q})).find(oe=>this.w.extUri.isEqual(oe.location,X));if(J)return await this.H(J)}else{const D=await this.t.scanExistingExtension(X,K,{includeInvalid:!0});if(D)return await this.H(D)}throw new t.$tp(c.localize(1828,null,X.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(D){throw(0,n.$Oq)(D,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(X){const K=await this.s.resolve(X.location);let q,D;return K.children&&(q=K.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,D=K.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:q,changelogUrl:D,publisherDisplayName:X.metadata?.publisherDisplayName,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!X.metadata?.hasPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned,isWorkspaceScoped:!1,source:X.metadata?.source??(X.identifier.uuid?"gallery":"vsix")}}async I(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(X));const K=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const J of K)X[s.$Tp.create(J).toString()]||q.add(J.identifier.id.toLowerCase());try{const J=(0,s.$Yp)(K,oe=>oe.identifier);await a.Promises.settled(J.map(async oe=>{const Q=oe.sort((Z,M)=>f.rcompare(Z.manifest.version,M.manifest.version))[0];q.has(Q.identifier.id.toLowerCase())||await this.n(await this.H(Q))}))}catch(J){this.z.error(J)}const D=K.filter(J=>J.metadata&&X[s.$Tp.create(J).toString()]);await Promise.allSettled(D.map(J=>this.removeUninstalledExtension(J)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.s.resolve(this.t.userExtensionsLocation)}catch(K){(0,U.$wl)(K)!==U.FileOperationResult.FILE_NOT_FOUND&&this.z.error(K);return}if(X?.children)try{await Promise.allSettled(X.children.map(async K=>{if(!(!K.isDirectory||!K.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",K.resource.toString());try{await this.s.del(K.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",K.resource.toString())}catch(q){(0,U.$wl)(q)!==U.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};e.$9q=_,e.$9q=_=Ee([Y(1,U.$fl),Y(2,o.$Vq),Y(3,r.$Rq),Y(4,V.$Pl),Y(5,x.$em),Y(6,G.$fk)],_);let ne=class extends n.$Pq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(X,K,q,D,J,oe,Q,Z,M,z,ie,ae){super(),this.l=X,this.manifest=K,this.source=q,this.options=D,this.m=J,this.n=oe,this.o=Q,this.p=Z,this.q=M,this.s=z,this.t=ie,this.u=ae,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(X){const q=(await this.n.scanExtensions(N.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(Q=>(0,s.$Sp)(Q.identifier,this.identifier));q&&(this.j=t.InstallOperation.Update);const D={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===N.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof w.URI?"vsix":"gallery"};let J;if(this.source instanceof w.URI){if(q&&this.l.equals(new s.$Tp(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(c.localize(1829,null,this.manifest.displayName||this.manifest.name))}const Q=await this.w(this.l);if(Q)try{await this.n.removeExtension(Q,"existing")}catch{throw new Error(c.localize(1830,null,this.manifest.displayName||this.manifest.name))}}else{if(D.id=this.source.identifier.uuid,D.publisherId=this.source.publisherId,D.publisherDisplayName=this.source.publisherDisplayName,D.targetPlatform=this.source.properties.targetPlatform,D.updated=!!q,D.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,D.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,D.preRelease=(0,E.$pg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==N.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,D,this.options.profileLocation);J=await this.w(this.l)}if(X.isCancellationRequested)throw(0,n.$Oq)(new C.$9);if(!J){const Q=await this.m(this.operation,X);J=Q.local,this.k=Q.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(Q){throw(0,n.$Oq)(Q,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(X.isCancellationRequested)throw(0,n.$Oq)(new C.$9);try{await this.t.addExtensionsToProfile([[J,D]],this.options.profileLocation,!J.isValid)}catch(Q){throw(0,n.$Oq)(Q,t.ExtensionManagementErrorCode.AddToProfile)}const oe=await this.n.scanLocalExtension(J.location,N.ExtensionType.User,this.options.profileLocation);if(!oe)throw new t.$tp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof w.URI&&this.x(J,X),oe}async w(X){return(await this.n.getUninstalledExtensions())[X.toString()]?(this.u.trace("Removing the extension from uninstalled list:",X.id),await this.n.setInstalled(X),this.u.info("Removed the extension from uninstalled list:",X.id),(await this.n.scanAllUserExtensions(!0)).find(D=>s.$Tp.create(D).equals(X))):void 0}async x(X,K){try{let[q]=await this.p.getExtensions([{id:X.identifier.id,version:X.manifest.version}],K);if(q||([q]=await this.p.getExtensions([{id:X.identifier.id}],K)),q){const D={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:X.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(X,D,this.options.profileLocation)}}catch{}}};ne=Ee([Y(6,V.$Pl),Y(7,t.$rp),Y(8,te.$Rl),Y(9,o.$Vq),Y(10,r.$Rq),Y(11,G.$fk)],ne);class le extends n.$Pq{constructor(X,K,q){super(),this.extension=X,this.options=K,this.j=q}async h(X){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(fe[219],de([0,1,11,19,28,18,52,7,15,10]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9R=void 0;let R=class extends T.$Sq{constructor(m,g,l,f,E,w){super(b.URI.file(m.extensionsPath),g,l,f,E,w)}};e.$9R=R,e.$9R=R=Ee([Y(0,A.$Si),Y(1,C.$fl),Y(2,a.$Rl),Y(3,L.$Pl),Y(4,k.$em),Y(5,P.$fk)],R)}),define(fe[220],de([0,1,10,15,52,85,7,4,11,23,28,19]),function(ce,e,P,a,L,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;let m=class extends k.$Zq{constructor(l,f,E,w,d,I,$,c){super(P.URI.file(d.builtinExtensionsPath),P.URI.file(d.extensionsPath),d.userHome,l.defaultProfile,l,f,E,w,d,I,$,c)}};e.$Hic=m,e.$Hic=m=Ee([Y(0,p.$Rl),Y(1,L.$Rq),Y(2,T.$fl),Y(3,A.$fk),Y(4,a.$Si),Y(5,b.$yk),Y(6,R.$Pl),Y(7,C.$Ji)],m)}),define(fe[16],de([0,1,6,3,2,102,12,73,4,19]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$qq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$oq=e.$nq=e.$mq=void 0,e.$pq=g,e.$rq=f,e.$tq=w,e.$mq="__$__isNewStorageMarker",e.$nq="__$__targetStorageMarker",e.$oq=(0,A.$Ki)("storageService");var R;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var p;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function g(d){const I=d.get(e.$nq);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}class l extends L.$Zc{static{this.a=60*1e3}constructor(I={flushInterval:l.a}){super(),this.m=I,this.b=this.B(new a.$te),this.c=this.B(new a.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,$,c){return a.Event.filter(this.b.event,h=>h.scope===I&&($===void 0||h.key===$),c)}n(){this.j.value=(0,P.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,$){const{key:c,external:h}=$;if(c===e.$nq){switch(I){case p.APPLICATION:this.H=void 0;break;case p.PROFILE:this.F=void 0;break;case p.WORKSPACE:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:c,target:this.J(I)[c],external:h})}w(I){this.f.fire({reason:I})}get(I,$,c){return this.P($)?.get(I,c)}getBoolean(I,$,c){return this.P($)?.getBoolean(I,c)}getNumber(I,$,c){return this.P($)?.getNumber(I,c)}getObject(I,$,c){return this.P($)?.getObject(I,c)}storeAll(I,$){this.y(()=>{for(const c of I)this.store(c.key,c.value,c.scope,c.target,$)})}store(I,$,c,h,i=!1){if((0,T.$sg)($)){this.remove(I,c,i);return}this.y(()=>{this.z(I,c,h),this.P(c)?.set(I,$,i)})}remove(I,$,c=!1){this.y(()=>{this.z(I,$,void 0),this.P($)?.delete(I,c)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,$){const c=[],h=this.J(I);for(const i of Object.keys(h))h[i]===$&&c.push(i);return c}z(I,$,c,h=!1){const i=this.J($);typeof c=="number"?i[I]!==c&&(i[I]=c,this.P($)?.set(e.$nq,JSON.stringify(i),h)):typeof i[I]=="number"&&(delete i[I],this.P($)?.set(e.$nq,JSON.stringify(i),h))}get D(){return this.C||(this.C=this.L(p.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(p.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(p.APPLICATION)),this.H}J(I){switch(I){case p.APPLICATION:return this.I;case p.PROFILE:return this.G;default:return this.D}}L(I){const $=this.P(I);return $?g($):Object.create(null)}isNew(I){return this.getBoolean(e.$mq,I)===!0}async flush(I=R.NONE){this.f.fire({reason:I});const $=this.P(p.APPLICATION),c=this.P(p.PROFILE),h=this.P(p.WORKSPACE);switch(I){case R.NONE:await P.Promises.settled([$?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await P.Promises.settled([$?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(p.APPLICATION)?.items??new Map,$=this.P(p.PROFILE)?.items??new Map,c=this.P(p.WORKSPACE)?.items??new Map;return w(I,$,c,this.Q(p.APPLICATION)??"",this.Q(p.PROFILE)??"",this.Q(p.WORKSPACE)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,$){return this.w(R.NONE),(0,b.$Ql)(I)?this.R(I,$):this.S(I,$)}M(I,$){return!(I.id===$.id||f($)&&f(I))}N(I,$,c){this.y(()=>{const h=new Set;for(const[i,n]of I)h.add(i),$.get(i)!==n&&this.u(c,{key:i,external:!0});for(const[i]of $.items)h.has(i)||this.u(c,{key:i,external:!0})})}}e.$qq=l;function f(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class E extends l{constructor(){super(),this.U=this.B(new C.$kq(new C.$lq,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new C.$kq(new C.$lq,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new C.$kq(new C.$lq,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(p.WORKSPACE,I))),this.B(this.W.onDidChangeStorage(I=>this.u(p.PROFILE,I))),this.B(this.U.onDidChangeStorage(I=>this.u(p.APPLICATION,I)))}P(I){switch(I){case p.APPLICATION:return this.U;case p.PROFILE:return this.W;default:return this.X}}Q(I){switch(I){case p.APPLICATION:return"inMemory (application)";case p.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$sq=E;async function w(d,I,$,c,h,i){const n=v=>{try{return JSON.parse(v)}catch{return v}},t=new Map,s=new Map;d.forEach((v,N)=>{t.set(N,v),s.set(N,n(v))});const r=new Map,o=new Map;I.forEach((v,N)=>{r.set(N,v),o.set(N,n(v))});const u=new Map,y=new Map;$.forEach((v,N)=>{u.set(N,v),y.set(N,n(v))}),console.group(c!==h?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const O=[];if(t.forEach((v,N)=>{O.push({key:N,value:v})}),console.table(O),console.groupEnd(),console.log(s),c!==h){console.group(`Storage: Profile (path: ${h}, profile specific)`);const v=[];r.forEach((N,F)=>{v.push({key:F,value:N})}),console.table(v),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${i})`);const S=[];u.forEach((v,N)=>{S.push({key:N,value:v})}),console.table(S),console.groupEnd(),console.log(y)}}),define(fe[120],de([0,1,3,2,12,27,35,16]),function(ce,e,P,a,L,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bNb=e.$aNb=void 0;let A=class extends a.$Zc{constructor(p,m){super(),this.a=new P.$qe,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b(p)),this.B(this.b.onDidChange(g=>this.a.fire({extensions:g,source:"storage"}))),this.B(m.onDidInstallExtensions(g=>g.forEach(({local:l,operation:f})=>{l&&f===k.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension(p,m){return this.f(p)?(this.a.fire({extensions:[p],source:m}),!0):!1}async disableExtension(p,m){return this.c(p)?(this.a.fire({extensions:[p],source:m}),!0):!1}getDisabledExtensions(){return this.h(k.$vp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(p){const m=this.getDisabledExtensions();return m.every(g=>!(0,T.$Sp)(g,p))?(m.push(p),this.g(m),!0):!1}f(p){const m=this.getDisabledExtensions();for(let g=0;g<m.length;g++){const l=m[g];if((0,T.$Sp)(l,p))return m.splice(g,1),this.g(m),!0}return!1}g(p){this.j(k.$vp,p)}h(p){return this.b.get(p,C.StorageScope.PROFILE)}j(p,m){this.b.set(p,m,C.StorageScope.PROFILE)}};e.$aNb=A,e.$aNb=A=Ee([Y(0,C.$oq),Y(1,k.$up)],A);class b extends a.$Zc{constructor(p){super(),this.c=p,this.a=Object.create(null),this.b=this.B(new P.$qe),this.onDidChange=this.b.event,this.B(p.onDidChangeValue(C.StorageScope.PROFILE,void 0,this.B(new a.$Yc))(m=>this.f(m)))}get(p,m){let g;return m===C.StorageScope.PROFILE?((0,L.$sg)(this.a[p])&&(this.a[p]=this.g(p,m)),g=this.a[p]):g=this.g(p,m),JSON.parse(g)}set(p,m,g){const l=JSON.stringify(m.map(({id:E,uuid:w})=>({id:E,uuid:w})));this.g(p,g)!==l&&(g===C.StorageScope.PROFILE&&(m.length?this.a[p]=l:delete this.a[p]),this.h(p,m.length?l:void 0,g))}f(p){if(!(0,L.$sg)(this.a[p.key])&&this.g(p.key,p.scope)!==this.a[p.key]){const g=this.get(p.key,p.scope);delete this.a[p.key];const l=this.get(p.key,p.scope),f=g.filter(w=>!l.some(d=>(0,T.$Sp)(w,d))),E=l.filter(w=>!g.some(d=>(0,T.$Sp)(d,w)));(f.length||E.length)&&this.b.fire([...f,...E])}}g(p,m){return this.c.get(p,m,"[]")}h(p,m,g){m?this.c.store(p,m,g,C.StorageTarget.MACHINE):this.c.remove(p,g)}}e.$bNb=b}),define(fe[86],de([0,1,4,3,2,16,35,23,17,11,12]),function(ce,e,P,a,L,k,T,C,A,b,R){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=void 0,e.$zw=(0,P.$Ki)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class extends L.$Zc{static{p=this}static{this.a=512*1024}static b(f){return`extensionKeys/${(0,T.$Wp)(f.id)}@${f.version}`}static c(f){const E=m.exec(f);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(f,E){const w=await f.getInstalled(),d=[];for(const[I,$]of p.f(E)){const c=w.find(h=>(0,T.$Sp)(h.identifier,{id:I}))?.manifest.version;for(const h of $)c!==h&&d.push(p.b({id:I,version:h}))}for(const I of d)E.remove(I,k.StorageScope.PROFILE)}static f(f){const E=new Map,w=f.keys(k.StorageScope.PROFILE,k.StorageTarget.MACHINE);for(const d of w){const I=p.c(d);if(I){let $=E.get(I.id.toLowerCase());$||E.set(I.id.toLowerCase(),$=[]),$.push(I.version)}}return E}constructor(f,E,w){super(),this.j=f,this.m=E,this.n=w,this.g=this.B(new a.$qe),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=p.f(f),this.B(this.j.onDidChangeValue(k.StorageScope.PROFILE,void 0,this.B(new L.$Yc))(d=>this.r(d)))}r(f){if(this.h.has(f.key.toLowerCase())){this.g.fire();return}const E=p.c(f.key);if(E){if(this.j.get(f.key,k.StorageScope.PROFILE)===void 0)this.h.delete(E.id.toLowerCase());else{let w=this.h.get(E.id.toLowerCase());w||this.h.set(E.id.toLowerCase(),w=[]),w.push(E.version),this.g.fire()}return}}s(f){if((0,R.$jg)(f))return f;const E=f.manifest?f.manifest.publisher:f.publisher,w=f.manifest?f.manifest.name:f.name;return(0,T.$Vp)(E,w)}getExtensionState(f,E){const w=this.s(f),d=this.getExtensionStateRaw(f,E);if(d)try{return JSON.parse(d)}catch(I){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${E}): ${I}`)}}getExtensionStateRaw(f,E){const w=this.s(f),d=this.j.get(w,E?k.StorageScope.PROFILE:k.StorageScope.WORKSPACE);return d&&d?.length>p.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${w}, global: ${E}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(f,E,w){const d=this.s(f);E===void 0?this.j.remove(d,w?k.StorageScope.PROFILE:k.StorageScope.WORKSPACE):this.j.store(d,JSON.stringify(E),w?k.StorageScope.PROFILE:k.StorageScope.WORKSPACE,k.StorageTarget.MACHINE)}setKeysForSync(f,E){this.j.store(p.b(f),JSON.stringify(E),k.StorageScope.PROFILE,k.StorageTarget.MACHINE)}getKeysForSync(f){const E=this.m.extensionSyncedKeys?.[f.id.toLowerCase()],w=this.j.get(p.b(f),k.StorageScope.PROFILE),d=w?JSON.parse(w):void 0;return d&&E?(0,A.$Qb)([...d,...E]):d||E}addToMigrationList(f,E){if(f!==E){const w=this.t.filter(d=>!d.includes(f)&&!d.includes(E));w.push([f,E]),this.t=w}}getSourceExtensionToMigrate(f){const E=this.t.find(([,w])=>f===w);return E?E[0]:void 0}get t(){const f=this.j.get("extensionStorage.migrationList",k.StorageScope.APPLICATION,"[]");try{const E=JSON.parse(f);if(Array.isArray(E))return E}catch{}return[]}set t(f){f.length?this.j.store("extensionStorage.migrationList",JSON.stringify(f),k.StorageScope.APPLICATION,k.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",k.StorageScope.APPLICATION)}};e.$Aw=g,e.$Aw=g=p=Ee([Y(0,k.$oq),Y(1,C.$yk),Y(2,b.$fk)],g)}),define(fe[221],de([0,1,2,27,86,199,119,11,16]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;let b=class extends P.$Zc{constructor(p,m,g,l,f,E){super(),p.cleanUp(),(0,k.$V8b)(p,m,g,l,E),L.$Aw.removeOutdatedExtensionVersions(p,f)}};e.$Rjc=b,e.$Rjc=b=Ee([Y(0,T.$7q),Y(1,a.$rp),Y(2,L.$zw),Y(3,a.$xp),Y(4,A.$oq),Y(5,C.$fk)],b)}),define(fe[222],de([0,1,17,2,20,10,7,23,6,3,13,5,37,35,75,34,16]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0;let w=class extends a.$Zc{constructor(h,i){super(),this.b=h,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,n])=>this.a.set(n.configPath,n))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const i=[];for(const[n,t]of this.a)if(!(t.configScheme&&t.configScheme!==h.scheme))try{const s=(await this.b.readFile((0,L.$lh)(h,n))).value.toString();for(const[r,o]of Object.entries(t.recommendations))(!o.contentPattern||new RegExp(o.contentPattern,"mig").test(s))&&i.push({extensionId:r,extensionName:o.name,configName:t.configName,important:!!o.important,isExtensionPack:!!o.isExtensionPack,whenNotInstalled:o.whenNotInstalled})}catch{}return i}};e.$9fc=w,e.$9fc=w=Ee([Y(0,T.$fl),Y(1,C.$yk)],w);const d="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";class $ extends w{constructor(h,i,n,t,s,r,o,u){super(o,u),this.r=h,this.s=i,this.t=n,this.u=t,this.w=s,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,u.exeBasedExtensionTips&&Object.entries(u.exeBasedExtensionTips).forEach(([y,O])=>{const S=[],v=[],N=[];Object.entries(O.recommendations).forEach(([F,U])=>{U.important?O.important?S.push({extensionId:F,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):v.push({extensionId:F,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):N.push({extensionId:F,extensionName:U.name,isExtensionPack:!!U.isExtensionPack})}),S.length&&this.g.set(y,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:S}),v.length&&this.h.set(y,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:v}),N.length&&this.j.set(y,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:N})}),(0,A.$Mh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),i=await this.O(this.h);return[...h,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),i=await this.O(this.h),n=await this.u.getInstalled();this.m=this.D(h,n),this.n=this.D(i,n)}D(h,i){const n=new Map;h.forEach(u=>n.set(u.extensionId.toLowerCase(),u));const{installed:t,uninstalled:s}=this.N([...n.keys()],i);for(const u of t){const y=n.get(u);y&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:u,exeName:y.exeName})}for(const u of s){const y=n.get(u);y&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:u,exeName:y.exeName})}const r=this.L(),o=new Map;for(const u of s){const y=n.get(u);if(y&&(!r[y.exeName]||!r[y.exeName].includes(y.extensionId))){let O=o.get(y.exeName);O||(O=[],o.set(y.exeName,O)),O.push(y)}}return o}F(){if(this.m.size===0)return;const[h,i]=[...this.m.entries()][0];this.H(i).then(n=>{switch(n){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(h);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new a.$1c);t.value=(0,A.$Mh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),i=Date.now()-h,n=7*24*60*60*1e3;if(i<n){const r=this.B(new a.$1c);r.value=(0,A.$Mh)(()=>{r.dispose(),this.G()},n-i);return}const[t,s]=[...this.n.entries()][0];this.H(s).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(s[0].exeName,s);const o=this.B(new a.$1c);o.value=(0,A.$Mh)(()=>{o.dispose(),this.G()},n);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const o=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(o(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const o=this.B(new a.$1c);o.value=(0,A.$Mh)(()=>{o.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const i=await this.u.getInstalled(f.ExtensionType.User),n=h.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(s=>i.every(r=>!(0,g.$Sp)(r.identifier,{id:s})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:n,source:l.RecommendationSource.EXE,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(I,E.StorageScope.APPLICATION);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(I,h,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(d,E.StorageScope.APPLICATION,"{}"))}M(h,i){const n=this.L();n[h]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(d,JSON.stringify(n),E.StorageScope.APPLICATION,E.StorageTarget.USER)}N(h,i){const n=[],t=[],s=i.reduce((r,o)=>(r.add(o.identifier.id.toLowerCase()),r),new Set);return h.forEach(r=>{s.has(r.toLowerCase())?n.push(r):t.push(r)}),{installed:n,uninstalled:t}}async O(h){const i=[],n=new Map;for(const t of h.keys()){const s=h.get(t);if(!s||!(0,P.$Pb)(s.recommendations))continue;const r=[];p.$l?s.windowsPath&&r.push(s.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(r.push((0,R.$oc)("/usr/local/bin",t)),r.push((0,R.$oc)("/usr/bin",t)),r.push((0,R.$oc)(this.r.fsPath,t)));for(const o of r){let u=n.get(o);if(u===void 0&&(u=await this.b.exists(k.URI.file(o)),n.set(o,u)),u)for(const{extensionId:y,extensionName:O,isExtensionPack:S,whenNotInstalled:v}of s.recommendations)i.push({extensionId:y,extensionName:O,isExtensionPack:S,exeName:t,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:v})}}return i}}e.$0fc=$}),define(fe[223],de([0,1,27,7,23,15,75,57,16,18,222]),function(ce,e,P,a,L,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;let p=class extends R.$0fc{constructor(g,l,f,E,w,d,I,$){super(g.userHome,w,l,f,E,d,I,$)}};e.$Yjc=p,e.$Yjc=p=Ee([Y(0,k.$Si),Y(1,b.$em),Y(2,P.$up),Y(3,A.$oq),Y(4,C.$Thc),Y(5,T.$D8b),Y(6,a.$fl),Y(7,L.$yk)],p)}),define(fe[49],de([0,1,14,32,16]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=k;async function k(T,C,A){let b=A&&A.get("storage.serviceMachineId",L.StorageScope.APPLICATION)||null;if(b)return b;try{const p=(await C.readFile(T.serviceMachineIdResource)).value.toString();b=(0,a.$6g)(p)?p:null}catch{b=null}if(!b){b=(0,a.$7g)();try{await C.writeFile(T.serviceMachineIdResource,P.$Se.fromString(b))}catch{}}return A?.store("storage.serviceMachineId",b,L.StorageScope.APPLICATION,L.StorageTarget.MACHINE),b}}),define(fe[224],de([0,1,49,18,48]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=k;async function k(T,C,A,b,R,p,m){const g={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${C.nameShort})`};if((0,L.$Kp)(C,A)&&(0,L.$Mp)(b)===a.TelemetryLevel.USAGE){const l=await(0,P.$uq)(A,R,p);g["X-Market-User-Id"]=l,g["VSCode-SessionId"]=m.machineId||l}return g}}),define(fe[225],de([0,1,17,25,8,5,37,12,10,142,21,15,27,35,34,59,7,11,23,61,224,16,18,54]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0,e.$wq=K;const n=k.$r?l.TargetPlatform.WEB:(0,m.$np)(k.$x,T.$jc),t="X-Market-Search-Activity-Id";var s;(function(Z){Z[Z.None=0]="None",Z[Z.IncludeVersions=1]="IncludeVersions",Z[Z.IncludeFiles=2]="IncludeFiles",Z[Z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",Z[Z.IncludeSharedAccounts=8]="IncludeSharedAccounts",Z[Z.IncludeVersionProperties=16]="IncludeVersionProperties",Z[Z.ExcludeNonValidated=32]="ExcludeNonValidated",Z[Z.IncludeInstallationTargets=64]="IncludeInstallationTargets",Z[Z.IncludeAssetUri=128]="IncludeAssetUri",Z[Z.IncludeStatistics=256]="IncludeStatistics",Z[Z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",Z[Z.Unpublished=4096]="Unpublished",Z[Z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function r(...Z){return String(Z.reduce((M,z)=>M|z,0))}var o;(function(Z){Z[Z.Tag=1]="Tag",Z[Z.ExtensionId=4]="ExtensionId",Z[Z.Category=5]="Category",Z[Z.ExtensionName=7]="ExtensionName",Z[Z.Target=8]="Target",Z[Z.Featured=9]="Featured",Z[Z.SearchText=10]="SearchText",Z[Z.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},S={pageNumber:1,pageSize:10,sortBy:m.SortBy.NoneOrRelevance,sortOrder:m.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class v{constructor(M=S){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,z=this.d.pageSize){return new v({...this.d,pageNumber:M,pageSize:z})}withFilter(M,...z){const ie=[...this.d.criteria,...z.length?z.map(ae=>({filterType:M,value:ae})):[{filterType:M}]];return new v({...this.d,criteria:ie})}withSortBy(M){return new v({...this.d,sortBy:M})}withSortOrder(M){return new v({...this.d,sortOrder:M})}withFlags(...M){return new v({...this.d,flags:M.reduce((z,ie)=>z|ie,0)})}withAssetTypes(...M){return new v({...this.d,assetTypes:M})}withSource(M){return new v({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:z,pageSize:ie,sortBy:ae,sortOrder:ue,flags:pe,assetTypes:be}=this.d;return{filters:[{criteria:M,pageNumber:z,pageSize:ie,sortBy:ae,sortOrder:ue}],assetTypes:be,flags:pe}}get searchText(){const M=this.d.criteria.filter(z=>z.filterType===o.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(Z,M){const z=(Z||[]).filter(ie=>ie.statisticName===M)[0];return z?z.value:0}function F(Z){const M="Microsoft.VisualStudio.Code.Translation.";return Z.files.filter(ie=>ie.assetType.indexOf(M)===0).reduce((ie,ae)=>{const ue=G(Z,ae.assetType);return ue&&ie.push([ae.assetType.substring(M.length),ue]),ie},[])}function U(Z){if(Z.properties){const M=Z.properties.filter(ae=>ae.key===u.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=M.filter(ae=>z.test(ae.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return G(Z,u.Repository)}function j(Z){return{uri:`${Z.fallbackAssetUri}/${u.VSIX}?redirect=true${Z.targetPlatform?`&targetPlatform=${Z.targetPlatform}`:""}`,fallbackUri:`${Z.fallbackAssetUri}/${u.VSIX}${Z.targetPlatform?`?targetPlatform=${Z.targetPlatform}`:""}`}}function G(Z,M){return Z.files.filter(ie=>ie.assetType===M)[0]?{uri:`${Z.assetUri}/${M}${Z.targetPlatform?`?targetPlatform=${Z.targetPlatform}`:""}`,fallbackUri:`${Z.fallbackAssetUri}/${M}${Z.targetPlatform?`?targetPlatform=${Z.targetPlatform}`:""}`}:null}function W(Z,M){const z=Z.properties?Z.properties.filter(ae=>ae.key===M):[],ie=z.length>0&&z[0].value;return ie?ie.split(",").map(ae=>(0,g.$Wp)(ae)):[]}function x(Z){const M=Z.properties?Z.properties.filter(z=>z.key===y.Engine):[];return M.length>0&&M[0].value||""}function V(Z){const M=Z.properties?Z.properties.filter(z=>z.key===y.PreRelease):[];return M.length>0&&M[0].value==="true"}function te(Z){const M=Z.properties?Z.properties.filter(z=>z.key===y.ExecutesCode):[];return M.length>0?M[0].value==="true":void 0}function B(Z){const M=Z.properties?Z.properties.filter(ie=>ie.key===y.EnabledApiProposals):[],z=M.length>0&&M[0].value||"";return z?z.split(","):[]}function H(Z){const M=Z.properties?Z.properties.filter(ie=>ie.key===y.LocalizedLanguages):[],z=M.length>0&&M[0].value||"";return z?z.split(","):[]}function _(Z){return Z.properties?.find(M=>M.key===y.SponsorLink)?.value}function ne(Z){return Z.properties?.find(M=>M.key===y.SupportLink)?.value}function le(Z){return Z.indexOf("preview")!==-1}function ee(Z){return Z.targetPlatform?(0,m.$mp)(Z.targetPlatform):l.TargetPlatform.UNDEFINED}function X(Z){const M=(0,P.$Qb)(Z.versions.map(ee)),z=!!Z.tags?.includes(m.$gp),ie=M.indexOf(l.TargetPlatform.WEB);return z?ie===-1&&M.push(l.TargetPlatform.WEB):ie!==-1&&M.splice(ie,1),M}function K(Z,M){for(let z=0;z<Z.length;z++){const ie=Z[z];if(ie.version===Z[z-1]?.version){let ae=z;if(ee(ie)===M)for(;ae>0&&Z[ae-1].version===ie.version;)ae--;ae!==z&&(Z.splice(z,1),Z.splice(ae,0,ie))}}return Z}function q(Z,M,z){Z.telemetryData={index:M,querySource:z,queryActivityId:Z.queryContext?.[t]}}function D(Z,M,z,ie){const ae=Z.versions[0],ue={manifest:G(M,u.Manifest),readme:G(M,u.Details),changelog:G(M,u.Changelog),license:G(M,u.License),repository:U(M),download:j(M),icon:G(M,u.Icon),signature:G(M,u.Signature),coreTranslations:F(M)};return{type:"gallery",identifier:{id:(0,g.$Xp)(Z.publisher.publisherName,Z.extensionName),uuid:Z.extensionId},name:Z.extensionName,version:M.version,displayName:Z.displayName,publisherId:Z.publisher.publisherId,publisher:Z.publisher.publisherName,publisherDisplayName:Z.publisher.displayName,publisherDomain:Z.publisher.domain?{link:Z.publisher.domain,verified:!!Z.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(ae),description:Z.shortDescription??"",installCount:N(Z.statistics,"install"),rating:N(Z.statistics,"averagerating"),ratingCount:N(Z.statistics,"ratingcount"),categories:Z.categories||[],tags:Z.tags||[],releaseDate:Date.parse(Z.releaseDate),lastUpdated:Date.parse(Z.lastUpdated),allTargetPlatforms:z,assets:ue,properties:{dependencies:W(M,y.Dependency),extensionPack:W(M,y.ExtensionPack),engine:x(M),enabledApiProposals:B(M),localizedLanguages:H(M),targetPlatform:ee(M),isPreReleaseVersion:V(M),executesCode:te(M)},hasPreReleaseVersion:V(ae),hasReleaseVersion:!0,preview:le(Z.flags),isSigned:!!ue.signature,queryContext:ie,supportLink:ne(ae)}}let J=class{constructor(M,z,ie,ae,ue,pe,be,Ie){this.l=z,this.n=ie,this.o=ae,this.q=ue,this.u=pe,this.w=be,this.x=Ie;const Ae=be.extensionsGallery,ye=Ae?.servicePPEUrl&&Ie.getValue("_extensionsGallery.enablePPE");this.d=ye?Ae.servicePPEUrl:Ae?.serviceUrl,this.g=ye?void 0:Ae?.searchUrl,this.h=Ae?.controlUrl,this.k=be.extensionsEnabledWithApiProposalVersion?.map(we=>we.toLowerCase())??[],this.j=(0,$.$vq)(be.version,be,this.o,this.x,this.u,M,this.q)}y(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,z,ie){const ae=a.CancellationToken.isCancellationToken(z)?{}:z,ue=a.CancellationToken.isCancellationToken(z)?z:ie,pe=[],be=[],Ie=[],Ae=[];let ye=!0;for(const he of M){he.uuid?be.push(he.uuid):pe.push(he.id);const me=!!(he.version||he.preRelease);Ie.push({id:he.id,uuid:he.uuid,includePreRelease:me}),he.version&&Ae.push({id:he.id,uuid:he.uuid,version:he.version}),ye=ye&&!!he.hasPreRelease&&!me}if(!be.length&&!pe.length)return[];let we=new v().withPage(1,M.length);be.length&&(we=we.withFilter(o.ExtensionId,...be)),pe.length&&(we=we.withFilter(o.ExtensionName,...pe)),(ae.queryAllVersions||ye)&&(we=we.withFlags(we.flags,s.IncludeVersions)),ae.source&&(we=we.withSource(ae.source));const{extensions:re}=await this.B(we,{targetPlatform:ae.targetPlatform??n,includePreRelease:Ie,versions:Ae,compatible:!!ae.compatible,productVersion:ae.productVersion??{version:this.w.version,date:this.w.date}},ue);return ae.source&&re.forEach((he,me)=>q(he,me,ae.source)),re}async getCompatibleExtension(M,z,ie,ae={version:this.w.version,date:this.w.date}){if((0,m.$op)(M.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(M,z,ie))return M;const ue=new v().withFlags(s.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,M.identifier.uuid),{extensions:pe}=await this.B(ue,{targetPlatform:ie,compatible:!0,includePreRelease:z,productVersion:ae},a.CancellationToken.None);return pe[0]||null}async isExtensionCompatible(M,z,ie,ae={version:this.w.version,date:this.w.date}){if(!(0,m.$pp)(M.properties.targetPlatform,M.allTargetPlatforms,ie)||!z&&M.properties.isPreReleaseVersion)return!1;let ue=M.properties.engine;if(!ue){const pe=await this.getManifest(M,a.CancellationToken.None);if(!pe)throw new Error("Manifest was not found");ue=pe.engines.vscode}return!(!(0,f.$_p)(ue,ae.version,ae.date)||!this.z(M.identifier,M.properties.enabledApiProposals))}z(M,z){return!z||!this.k.includes(M.id.toLowerCase())?!0:(0,f.$aq)(z)}async A(M,z,ie,ae,ue,pe,be={version:this.w.version,date:this.w.date}){if(!(0,m.$pp)(ee(z),ue,pe)||ie!=="any"&&V(z)!==(ie==="prerelease"))return!1;if(ae)try{const Ie=await this.G(M,z);if(!(0,f.$_p)(Ie,be.version,be.date))return!1}catch(Ie){return this.n.error(`Error while getting the engine for the version ${z.version}.`,(0,L.$bb)(Ie)),!1}return!0}async query(M,z){let ie=M.text||"";const ae=M.pageSize??50;let ue=new v().withPage(1,ae);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,we,re)=>(ue=ue.withFilter(o.Category,re||we),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,we,re)=>(ue=ue.withFilter(o.Tag,re||we),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(ue=ue.withFilter(o.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),ue=ue.withFilter(o.SearchText,ie)),ue=ue.withSortBy(m.SortBy.NoneOrRelevance)):M.ids?ue=ue.withFilter(o.ExtensionId,...M.ids):M.names?ue=ue.withFilter(o.ExtensionName,...M.names):ue=ue.withSortBy(m.SortBy.InstallCount),typeof M.sortBy=="number"&&(ue=ue.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(ue=ue.withSortOrder(M.sortOrder)),M.source&&(ue=ue.withSource(M.source));const pe=async(ye,we)=>{const{extensions:re,total:he}=await this.B(ye,{targetPlatform:n,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.w.version,date:this.w.date}},we);return re.forEach((me,Se)=>q(me,(ye.pageNumber-1)*ye.pageSize+Se,M.source)),{extensions:re,total:he}},{extensions:be,total:Ie}=await pe(ue,z),Ae=async(ye,we)=>{if(we.isCancellationRequested)throw new L.$9;const{extensions:re}=await pe(ue.withPage(ye+1),we);return re};return{firstPage:be,total:Ie,pageSize:ue.pageSize,getPage:Ae}}async B(M,z,ie){const ae=M.flags;M.flags&s.IncludeLatestVersionOnly&&M.flags&s.IncludeVersions&&(M=M.withFlags(M.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(M.flags&s.IncludeLatestVersionOnly)&&!(M.flags&s.IncludeVersions)&&(M=M.withFlags(M.flags,s.IncludeLatestVersionOnly)),z.versions?.length&&(M=M.withFlags(M.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),M=M.withFlags(M.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:ue,total:pe,context:be}=await this.D(M,ie);if(!(M.flags&s.IncludeLatestVersionOnly)){const we=[];for(const re of ue){const he=await this.C(re,z,be);he&&we.push(he)}return{extensions:we,total:pe}}const Ae=[],ye=new Map;for(let we=0;we<ue.length;we++){const re=ue[we],he={id:(0,g.$Xp)(re.publisher.publisherName,re.extensionName),uuid:re.extensionId},me=(0,C.$pg)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Pe=>(0,g.$Sp)(Pe,he))?.includePreRelease;if(z.compatible&&(0,m.$op)(X(re),z.targetPlatform))continue;const Se=await this.C(re,z,be);!Se||Se.properties.isPreReleaseVersion&&(!me||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==z.targetPlatform&&Se.hasPreReleaseVersion?ye.set(re.extensionId,we):Ae.push([we,Se])}if(ye.size){const we=new i.$ke,re=new v().withFlags(ae&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ye.size).withFilter(o.ExtensionId,...ye.keys()),{extensions:he}=await this.B(re,z,ie);this.q.publicLog2("galleryService:additionalQuery",{duration:we.elapsed(),count:ye.size});for(const me of he){const Se=ye.get(me.identifier.uuid);Ae.push([Se,me])}}return{extensions:Ae.sort((we,re)=>we[0]-re[0]).map(([,we])=>we),total:pe}}async C(M,z,ie){const ae={id:(0,g.$Xp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},ue=z.versions?.find(Ae=>(0,g.$Sp)(Ae,ae))?.version,pe=(0,C.$pg)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Ae=>(0,g.$Sp)(Ae,ae))?.includePreRelease,be=X(M),Ie=K(M.versions,z.targetPlatform);if(z.compatible&&(0,m.$op)(be,z.targetPlatform))return null;for(let Ae=0;Ae<Ie.length;Ae++){const ye=Ie[Ae];if(!(ue&&ye.version!==ue)){if(await this.A(ae.id,ye,pe?"any":"release",z.compatible,be,z.targetPlatform,z.productVersion))return z.compatible&&!this.z(ae,B(ye))?null:D(M,ye,be,ie);if(ue&&ye.version===ue)return null}}return ue||z.compatible?null:D(M,M.versions[0],be)}async D(M,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,s.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,r(s.Unpublished));const ie=await this.j,ae=JSON.stringify(M.raw),ue={...ie,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ae.length)},pe=new i.$ke;let be,Ie,Ae=0;try{if(be=await this.l.request({type:"POST",url:this.g&&M.criteria.some(we=>we.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:ae,headers:ue},z),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Ae};const ye=await(0,I.$hq)(be);if(ye){const we=ye.results[0],re=we.extensions,he=we.resultMetadata&&we.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return Ae=he&&he.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:Ae,context:be.res.headers.activityid?{[t]:be.res.headers.activityid}:{}}}return{galleryExtensions:[],total:Ae}}catch(ye){if((0,L.$8)(ye))throw Ie=m.ExtensionGalleryErrorCode.Cancelled,ye;{const we=(0,L.$bb)(ye);throw Ie=(0,b.$cp)(ye)?m.ExtensionGalleryErrorCode.Offline:we.startsWith("XHR timeout")?m.ExtensionGalleryErrorCode.Timeout:m.ExtensionGalleryErrorCode.Failed,new m.$sp(we,Ie)}}finally{this.q.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ae.length),duration:pe.elapsed(),success:!!be&&(0,I.$dq)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ie,count:String(Ae)})}}async reportStatistic(M,z,ie,ae){if(!this.isEnabled())return;const ue=k.$r?this.y(`/itemName/${M}.${z}/version/${ie}/statType/${ae===m.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${M}/extensions/${z}/${ie}/stats?statType=${ae}`),pe=k.$r?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.j,Accept:pe};try{await this.l.request({type:"POST",url:ue,headers:Ie},a.CancellationToken.None)}catch{}}async download(M,z,ie){this.n.trace("ExtensionGalleryService#download",M.identifier.id);const ae=(0,g.$1p)(M),ue=new Date().getTime(),pe=ie===m.InstallOperation.Install?"install":ie===m.InstallOperation.Update?"update":"",be=pe?{uri:`${M.assets.download.uri}${A.URI.parse(M.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${M.assets.download.fallbackUri}${A.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:M.assets.download,Ie=M.queryContext?.[t]?{[t]:M.queryContext[t]}:void 0,Ae=await this.F(M.identifier.id,be,u.VSIX,Ie?{headers:Ie}:void 0);try{await this.u.writeFile(z,Ae.stream)}catch(ye){try{await this.u.del(z)}catch(we){this.n.warn(`Error while deleting the file ${z.toString()}`,(0,L.$bb)(we))}throw new m.$sp((0,L.$bb)(ye),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ae,duration:new Date().getTime()-ue})}async downloadSignatureArchive(M,z){if(!M.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const ie=await this.F(M.identifier.id,M.assets.signature,u.Signature);try{await this.u.writeFile(z,ie.stream)}catch(ae){try{await this.u.del(z)}catch(ue){this.n.warn(`Error while deleting the file ${z.toString()}`,(0,L.$bb)(ue))}throw new m.$sp((0,L.$bb)(ae),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,z){if(M.assets.readme){const ie=await this.F(M.identifier.id,M.assets.readme,u.Details,{},z);return await(0,I.$gq)(ie)||""}return""}async getManifest(M,z){if(M.assets.manifest){const ie=await this.F(M.identifier.id,M.assets.manifest,u.Manifest,{},z),ae=await(0,I.$gq)(ie);return ae?JSON.parse(ae):null}return null}async E(M,z,ie){const ae=G(z,u.Manifest);if(!ae)throw new Error("Manifest was not found");const ue={"Accept-Encoding":"gzip"},pe=await this.F(M,ae,u.Manifest,{headers:ue});return await(0,I.$hq)(pe)}async getCoreTranslation(M,z){const ie=M.assets.coreTranslations.filter(ae=>ae[0]===z.toUpperCase())[0];if(ie){const ae=await this.F(M.identifier.id,ie[1],ie[0]),ue=await(0,I.$gq)(ae);return ue?JSON.parse(ue):null}return null}async getChangelog(M,z){if(M.assets.changelog){const ie=await this.F(M.identifier.id,M.assets.changelog,u.Changelog,{},z);return await(0,I.$gq)(ie)||""}return""}async getAllCompatibleVersions(M,z,ie){let ae=new v().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);M.uuid?ae=ae.withFilter(o.ExtensionId,M.uuid):ae=ae.withFilter(o.ExtensionName,M.id);const{galleryExtensions:ue}=await this.D(ae,a.CancellationToken.None);if(!ue.length)return[];const pe=X(ue[0]);if((0,m.$op)(pe,ie))return[];const be=[];await Promise.all(ue[0].versions.map(async ye=>{try{await this.A(M.id,ye,z?"any":"release",!0,pe,ie)&&this.z(M,B(ye))&&be.push(ye)}catch{}}));const Ie=[],Ae=new Set;for(const ye of K(be,ie))Ae.has(ye.version)||(Ae.add(ye.version),Ie.push({version:ye.version,date:ye.lastUpdated,isPreReleaseVersion:V(ye)}));return Ie}async F(M,z,ie,ae={},ue=a.CancellationToken.None){const pe=await this.j,be={type:"GET"},Ie={...pe,...ae.headers||{}};ae={...ae,...be,headers:Ie};const Ae=z.uri,ye=z.fallbackUri,we={...ae,url:Ae};try{const re=await this.l.request(we,ue);if(re.res.statusCode===200)return re;const he=await(0,I.$gq)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${he}`)}catch(re){if((0,L.$8)(re))throw re;const he=(0,L.$bb)(re);this.q.publicLog2("galleryService:cdnFallback",{extension:M,assetType:ie,message:he});const me={...ae,url:ye};return this.l.request(me,ue)}}async G(M,z){let ie=x(z);if(!ie){this.q.publicLog2("galleryService:engineFallback",{extension:M,version:z.version});const ae=await this.E(M,z,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ie=ae.engines.vscode}return ie}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.l.request({type:"GET",url:this.h},a.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,I.$hq)(M),ie=[],ae={},ue=[],pe=[];if(z){for(const be of z.malicious)ie.push({id:be});if(z.migrateToPreRelease)for(const[be,Ie]of Object.entries(z.migrateToPreRelease))(!Ie.engine||(0,f.$_p)(Ie.engine,this.w.version,this.w.date))&&(ae[be.toLowerCase()]={disallowInstall:!0,extension:{id:Ie.id,displayName:Ie.displayName,autoMigrate:{storage:!!Ie.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[be,Ie]of Object.entries(z.deprecated))Ie&&(ae[be.toLowerCase()]=(0,C.$pg)(Ie)?{}:Ie);if(z.search)for(const be of z.search)ue.push(be);if(Array.isArray(z.extensionsEnabledWithPreRelease))for(const be of z.extensionsEnabledWithPreRelease)pe.push(be.toLowerCase())}return{malicious:ie,deprecated:ae,search:ue,extensionsEnabledWithPreRelease:pe}}};J=Ee([Y(1,I.$bq),Y(2,w.$fk),Y(3,p.$Ri),Y(4,h.$em),Y(5,E.$fl),Y(6,d.$yk),Y(7,R.$ej)],J);let oe=class extends J{constructor(M,z,ie,ae,ue,pe,be,Ie){super(M,z,ie,ae,ue,pe,be,Ie)}};e.$xq=oe,e.$xq=oe=Ee([Y(0,c.$oq),Y(1,I.$bq),Y(2,w.$fk),Y(3,p.$Ri),Y(4,h.$em),Y(5,E.$fl),Y(6,d.$yk),Y(7,R.$ej)],oe);let Q=class extends J{constructor(M,z,ie,ae,ue,pe,be){super(void 0,M,z,ie,ae,ue,pe,be)}};e.$yq=Q,e.$yq=Q=Ee([Y(0,I.$bq),Y(1,w.$fk),Y(2,p.$Ri),Y(3,h.$em),Y(4,E.$fl),Y(5,d.$yk),Y(6,R.$ej)],Q)}),define(fe[226],de([0,1,109,3,18,15,2,11,13,70,23,5,6,103,21,9,38,16,12,140,20]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=void 0;const c=[P.$Njc,P.$Ojc],h="remoteTunnelSession",i="remoteTunnelIsService";let n=class extends T.$Zc{constructor(o,u,y,O,S,v,N){super(),this.y=o,this.z=u,this.C=y,this.D=v,this.F=N,this.f=new a.$qe,this.onDidTokenFailed=this.f.event,this.g=new a.$qe,this.onDidChangeTunnelStatus=this.g.event,this.h=new a.$qe,this.onDidChangeMode=this.h.event,this.n=P.$Ljc,this.w=!1,this.I=(F,U)=>{U?this.j.error(F):this.j.info(F)},this.j=this.B(O.createLogger((0,$.$lh)(y.logsHome,`${P.$Pjc}.log`),{id:P.$Pjc,name:P.$Qjc})),this.t=new m.$Hh(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,C.$uk)(F)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(F=>{c.some(U=>F.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=P.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){s(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}J(){if(!this.u){let o;p.$m?o=this.C.appRoot:o=(0,A.$rc)((0,A.$rc)(this.C.appRoot)),this.u=(0,A.$oc)(o,"bin",`${this.z.tunnelApplicationName}${p.$l?".exe":""}`)}return this.u}async startTunnel(o){if(s(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const o=this.n.asService;this.H(P.$Ljc);try{o&&this.O("uninstallService",["service","uninstall"])}catch(u){this.j.error(u)}}try{await this.O("stop",["kill"])}catch(o){this.j.error(o)}this.G(P.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",u=!1;const y=(U,j)=>{j?this.j.error(U):o+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(P.TunnelStates.connecting((0,f.localize)(2045,null)))},O=this.O("status",["status"],y);this.r=O;try{if(await O,this.r!==O)return;let U;try{U=JSON.parse(o.trim().split(`
`).find(j=>j.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.G(P.TunnelStates.disconnected());return}if(u=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(P.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(P.TunnelStates.disconnected());return}finally{this.r===O&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const U=S.token;this.G(P.TunnelStates.connecting((0,f.localize)(2046,null,S.accountLabel,S.providerId)));const j=(W,x)=>{W=W.replaceAll(U,"*".repeat(4)),y(W,x)},G=this.O("login",["user","login","--provider",S.providerId,"--log",(0,C.$uk)(this.j.getLevel())],j,{VSCODE_CLI_ACCESS_TOKEN:U});this.r=G;try{if(await G,this.r!==G)return}catch(W){this.j.error(W),this.r=void 0,this.f.fire(S),this.G(P.TunnelStates.disconnected(S));return}}const v=this.Q();v?this.G(P.TunnelStates.connecting((0,f.localize)(2047,null,v))):this.G(P.TunnelStates.connecting((0,f.localize)(2048,null)));const N=["--accept-server-license-terms","--log",(0,C.$uk)(this.j.getLevel())];v?N.push("--name",v):N.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!u&&(F=await this.M(N)===!1),this.N(S,N,F)}async M(o){let u;try{u=await this.O("serviceInstall",["service","install",...o])}catch(y){this.j.error(y),u=1}if(u!==0){const y=(0,f.localize)(2049,null);return this.j.warn(y),this.G(P.TunnelStates.connecting(y)),!1}return!0}async N(o,u,y){u.push("--parent-process-id",String(process.pid)),this.P()&&u.push("--no-sleep");let O=!1;const S=this.O("tunnel",u,(v,N)=>{N?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(O=!0);const F=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const U={link:F[1],domain:F[2],tunnelName:F[4],isAttached:O};this.G(P.TunnelStates.connected(U,y))}else v.match(/error refreshing token/)&&(S.cancel(),this.f.fire(o),this.G(P.TunnelStates.disconnected(o)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=P.$Ljc,this.G(P.TunnelStates.disconnected()))})}O(o,u,y=this.I,O){return(0,m.$xh)(S=>new Promise((v,N)=>{S.isCancellationRequested&&v(-1);let F;const U=["ignore","pipe","pipe"];if(S.onCancellationRequested(()=>{F&&(this.j.info(`${o} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${o} Spawning: cargo run -- tunnel ${u.join(" ")}
`,!1),F=(0,b.spawn)("cargo",["run","--","tunnel",...u],{cwd:(0,A.$oc)(this.C.appRoot,"cli"),stdio:U,env:{...process.env,RUST_BACKTRACE:"1",...O}});else{y(`Running tunnel CLI
`,!1);const j=this.J();y(`${o} Spawning: ${j} tunnel ${u.join(" ")}
`,!1),F=(0,b.spawn)(j,["tunnel",...u],{cwd:(0,E.homedir)(),stdio:U,env:{...process.env,...O}})}F.stdout.pipe(new I.$gY(`
`)).on("data",j=>{if(F){const G=j.toString();y(G,!1)}}),F.stderr.pipe(new I.$gY(`
`)).on("data",j=>{if(F){const G=j.toString();y(G,!0)}}),F.on("exit",j=>{F&&(y(`${o} exit(${F.pid}): + ${j} `,!1),F=void 0,v(j||0))}),F.on("error",j=>{F&&(y(`${o} error(${F.pid}): + ${j} `,!0),F=void 0,N())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(P.$Ojc)}Q(){let o=this.D.getValue(P.$Njc)||(0,E.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(h,w.StorageScope.APPLICATION),u=this.F.getBoolean(i,w.StorageScope.APPLICATION,!1);if(o){const y=JSON.parse(o);if(y&&(0,d.$jg)(y.accountLabel)&&(0,d.$jg)(y.sessionId)&&(0,d.$jg)(y.providerId))return{active:!0,session:y,asService:u};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(o){this.j.error("Problems restoring session from storage",o)}return P.$Ljc}S(o){if(o.active){const u={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(h,JSON.stringify(u),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),this.F.store(i,o.asService,w.StorageScope.APPLICATION,w.StorageTarget.MACHINE)}else this.F.remove(h,w.StorageScope.APPLICATION),this.F.remove(i,w.StorageScope.APPLICATION)}};e.$Ujc=n,e.$Ujc=n=Ee([Y(0,L.$em),Y(1,R.$yk),Y(2,k.$Si),Y(3,C.$gk),Y(4,g.$Sjc),Y(5,l.$ej),Y(6,w.$oq)],n);function t(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const s=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&t(r.session,o.session):!0}),define(fe[227],de([0,1,6,2,22,20,73,16,80,19]),function(ce,e,P,a,L,k,T,C,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class R extends C.$qq{constructor(m,g,l,f){super(),this.bb=m,this.cb=g,this.db=l,this.eb=f,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new a.$Yc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new a.$Yc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new A.$KNb(this.db.getChannel("storage"))),g=this.B(new T.$kq(m));return this.B(g.onDidChangeStorage(l=>this.u(C.StorageScope.APPLICATION,l))),g}gb(m){this.X.clear(),this.W=m;let g;if((0,C.$rq)(m))g=this.U;else{const l=this.X.add(new A.$LNb(this.db.getChannel("storage"),m));g=this.X.add(new T.$kq(l))}return this.X.add(g.onDidChangeStorage(l=>this.u(C.StorageScope.PROFILE,l))),g}hb(m){this.$.clear(),this.Z=m?.id;let g;if(m){const l=this.$.add(new A.$MNb(this.db.getChannel("storage"),m));g=this.$.add(new T.$kq(l)),this.$.add(g.onDidChangeStorage(f=>this.u(C.StorageScope.WORKSPACE,f)))}return g}async O(){await P.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case C.StorageScope.APPLICATION:return this.U;case C.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(m){switch(m){case C.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case C.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,k.$lh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(C.WillSaveStateReason.SHUTDOWN),await P.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const g=this.Y,l=g.items;g!==this.U&&await g.close(),this.Y=this.gb(m),await this.Y.init(),this.N(l,this.Y,C.StorageScope.PROFILE)}async S(m,g){const l=this.ab,f=l?.items??new Map;await l?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(f,this.ab,C.StorageScope.WORKSPACE)}hasScope(m){return(0,b.$Ql)(m)?this.W.id===m.id:this.Z===m.id}}e.$Zjc=R}),define(fe[228],de([0,1,3,2,19,96]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eS=e.$dS=void 0;class T{constructor(b,R){this.a=b,this.b=R}listen(b,R){const p=this.b(b);switch(R){case"onDidChangeProfiles":return P.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(g=>(0,k.$Un)({...g},p)),added:m.added.map(g=>(0,k.$Un)({...g},p)),removed:m.removed.map(g=>(0,k.$Un)({...g},p)),updated:m.updated.map(g=>(0,k.$Un)({...g},p))}))}throw new Error(`Invalid listen ${R}`)}async call(b,R,p){const m=this.b(b);switch(R){case"createProfile":{const g=await this.a.createProfile(p[0],p[1],p[2]);return(0,k.$Un)({...g},m)}case"updateProfile":{let g=(0,L.$Sl)((0,k.$Vn)(p[0],m),this.a.profilesHome.scheme);return g=await this.a.updateProfile(g,p[1]),(0,k.$Un)({...g},m)}case"removeProfile":{const g=(0,L.$Sl)((0,k.$Vn)(p[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(g)}}throw new Error(`Invalid call ${R}`)}}e.$dS=T;class C extends a.$Zc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,R,p){super(),this.profilesHome=R,this.f=p,this.a=[],this.b=this.B(new P.$qe),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(m=>(0,L.$Sl)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const g=m.added.map(E=>(0,L.$Sl)(E,this.profilesHome.scheme)),l=m.removed.map(E=>(0,L.$Sl)(E,this.profilesHome.scheme)),f=m.updated.map(E=>(0,L.$Sl)(E,this.profilesHome.scheme));this.a=m.all.map(E=>(0,L.$Sl)(E,this.profilesHome.scheme)),this.b.fire({added:g,removed:l,updated:f,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,R,p){const m=await this.f.call("createNamedProfile",[b,R,p]);return(0,L.$Sl)(m,this.profilesHome.scheme)}async createProfile(b,R,p,m){const g=await this.f.call("createProfile",[b,R,p,m]);return(0,L.$Sl)(g,this.profilesHome.scheme)}async createTransientProfile(b){const R=await this.f.call("createTransientProfile",[b]);return(0,L.$Sl)(R,this.profilesHome.scheme)}async setProfileForWorkspace(b,R){await this.f.call("setProfileForWorkspace",[b,R])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,R){const p=await this.f.call("updateProfile",[b,R]);return(0,L.$Sl)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$eS=C}),define(fe[62],de([0,1,2,73,4,16,3,80,19]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QNb=e.$PNb=e.$ONb=void 0,e.$ONb=(0,L.$Ki)("IUserDataProfileStorageService");let b=class extends P.$Zc{constructor(g,l){super(),this.b=l,g&&(this.a=this.B(new P.$9c))}async readStorageData(g){return this.withProfileScopedStorageService(g,async l=>this.c(l))}async updateStorageData(g,l,f){return this.withProfileScopedStorageService(g,async E=>this.f(E,l,f))}async withProfileScopedStorageService(g,l){if(this.b.hasScope(g))return l(this.b);let f=this.a?.get(g.id);if(!f){f=new p(this.g(g)),this.a?.set(g.id,f);try{await f.initialize()}catch(E){throw this.a?.has(g.id)?this.a.deleteAndDispose(g.id):f.dispose(),E}}try{const E=await l(f);return await f.flush(),E}finally{this.a?.has(g.id)||f.dispose()}}c(g){const l=new Map,f=E=>{for(const w of g.keys(k.StorageScope.PROFILE,E))l.set(w,{value:g.get(w,k.StorageScope.PROFILE),target:E})};return f(k.StorageTarget.USER),f(k.StorageTarget.MACHINE),l}f(g,l,f){g.storeAll(Array.from(l.entries()).map(([E,w])=>({key:E,value:w,scope:k.StorageScope.PROFILE,target:f})),!0)}};e.$PNb=b,e.$PNb=b=Ee([Y(1,k.$oq)],b);class R extends b{constructor(g,l,f,E,w){super(g,E),this.j=l;const d=l.getChannel("profileStorageListener"),I=this.B(new P.$1c);this.h=this.B(new T.$qe({onWillAddFirstListener:()=>{I.value=d.listen("onDidChange")($=>{w.trace("profile storage changes",$),this.h.fire({targetChanges:$.targetChanges.map(c=>(0,A.$Sl)(c,f.profilesHome.scheme)),valueChanges:$.valueChanges.map(c=>({...c,profile:(0,A.$Sl)(c.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>I.value=void 0})),this.onDidChange=this.h.event}async g(g){const l=this.j.getChannel("storage");return(0,k.$rq)(g)?new C.$KNb(l):new C.$LNb(l,g)}}e.$QNb=R;class p extends k.$qq{constructor(g){super({flushInterval:100}),this.U=g}async O(){const g=await this.U,l=new a.$kq(g);return this.B(l.onDidChangeStorage(f=>{this.u(k.StorageScope.PROFILE,f)})),this.B((0,P.$Xc)(()=>{l.close(),l.dispose(),(0,P.$Tc)(g)&&g.dispose()})),this.s=l,this.s.init()}P(g){return g===k.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(fe[229],de([0,1,16,11,19,56,62]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=void 0;let C=class extends T.$QNb{constructor(b,R,p,m){super(!0,b,R,p,m)}};e.$Ejc=C,e.$Ejc=C=Ee([Y(0,k.$_ic),Y(1,L.$Rl),Y(2,P.$oq),Y(3,a.$fk)],C)}),define(fe[40],de([0,1,17,6,14,25,3,36,2,26,12,9,21,15,7,11,49,16,18,28,24,19]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TOb=e.$SOb=e.$ROb=e.$QOb=void 0,e.$NOb=h,e.$OOb=i,e.$POb=n;function h(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||i(u.syncData)))}function i(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}function n(u,y){return`${(0,b.$bg)(u)}${y.isDefault?"":` (${y.name})`}`}let t=class extends A.$Zc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,O,S,v,N,F,U,j,G,W,x,V){super(),this.syncResource=y,this.collection=O,this.G=S,this.H=v,this.I=N,this.J=F,this.L=U,this.M=j,this.N=G,this.O=W,this.P=x,this.c=null,this.m=$.SyncStatus.Idle,this.n=this.B(new T.$qe),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new T.$qe),this.onDidChangeConflicts=this.t.event,this.u=this.B(new a.$Ih(50)),this.w=this.B(new T.$qe),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=V.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,$.$nob)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,$.$Iob),this.y=(0,$.$oob)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,v,this.h),this.j=(0,E.$uq)(v,S,N)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===$.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const O=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(O)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,O={}){await this.U(y,!0,this.ob(),O)}async preview(y,O,S={}){return this.U(y,!1,O,S)}async apply(y,O={}){try{this.F={...O};const S=await this.ab(y);return this.S(S),this.c}finally{this.F={}}}async U(y,O,S,v){try{if(this.F={...v},this.status===$.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===$.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S($.SyncStatus.Syncing);let N=$.SyncStatus.Idle;try{const F=await this.getLastSyncUserData(),U=await this.X(y,F);return N=await this.Y(U,F,O,S),N===$.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N===$.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(N)}}finally{this.F={}}}async replace(y){const O=this.kb(y);if(!O)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S($.SyncStatus.Syncing);const S=await this.getLastSyncUserData(),v=await this.X(null,S),N=await this.W(v),F=await this.qb({ref:v.ref,syncData:O},S,N,this.ob(),k.CancellationToken.None),U=[];for(const j of F){const G=await this.sb(j,j.remoteResource,void 0,k.CancellationToken.None),{remoteChange:W}=await this.sb(j,j.previewResource,j.remoteContent,k.CancellationToken.None);U.push([j,{...G,remoteChange:W!==$.Change.None?W:$.Change.Modified}])}await this.tb(v,S,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S($.SyncStatus.Idle)}return!0}async W(y){const O=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===O}async X(y,O){if(O){const S=y?y[this.resource]:void 0;if(O.ref===S||S===void 0&&O.syncData===null)return O}return this.getRemoteUserData(O)}async Y(y,O,S,v){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new $.$vob((0,p.localize)(2443,null,this.resource,this.pb,y.syncData.version),$.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(y,O,S,v)}catch(N){if(N instanceof $.$vob)switch(N.code){case $.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,O,S,v);case $.UserDataSyncErrorCode.Conflict:case $.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),O=await this.getLastSyncUserData(),this.Y(y,O,S,v)}throw N}}async Z(y,O,S,v){try{const N=await this.W(y),F=!N&&O===null&&this.gb()!==void 0,U=S&&!F;this.c||(this.c=(0,a.$xh)(G=>this.eb(y,O,N,U,v,G)));let j=await this.c;if(S&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const G of j.resourcePreviews)j=await this.accept(G.remoteResource)||j}return this.cb(j.resourcePreviews),j.resourcePreviews.some(({mergeState:G})=>G===$.MergeState.Conflict)?$.SyncStatus.HasConflicts:S?await this.ab(!1):$.SyncStatus.Syncing}catch(N){throw this.c=null,N}}async merge(y){return await this.$(y,async O=>{const S=await this.rb(O,k.CancellationToken.None);await this.G.writeFile(O.previewResource,L.$Se.fromString(S?.content||""));const v=S&&!S.hasConflicts?await this.sb(O,O.previewResource,void 0,k.CancellationToken.None):void 0;return O.acceptResult=v,O.mergeState=S.hasConflicts?$.MergeState.Conflict:v?$.MergeState.Accepted:$.MergeState.Preview,O.localChange=v?v.localChange:S.localChange,O.remoteChange=v?v.remoteChange:S.remoteChange,O}),this.c}async accept(y,O){return await this.$(y,async S=>{const v=await this.sb(S,y,O,k.CancellationToken.None);return S.acceptResult=v,S.mergeState=$.MergeState.Accepted,S.localChange=v.localChange,S.remoteChange=v.remoteChange,S}),this.c}async discard(y){return await this.$(y,async O=>{const S=await this.rb(O,k.CancellationToken.None);return await this.G.writeFile(O.previewResource,L.$Se.fromString(S.content||"")),O.acceptResult=void 0,O.mergeState=$.MergeState.Preview,O.localChange=S.localChange,O.remoteChange=S.remoteChange,O}),this.c}async $(y,O){if(!this.c)return;let S=await this.c;const v=S.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:U})=>this.h.isEqual(N,y)||this.h.isEqual(F,y)||this.h.isEqual(U,y));v!==-1&&(this.c=(0,a.$xh)(async N=>{const F=[...S.resourcePreviews];return F[v]=await O(F[v]),{...S,resourcePreviews:F}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:N})=>N===$.MergeState.Conflict)?this.S($.SyncStatus.HasConflicts):this.S($.SyncStatus.Syncing))}async ab(y){if(!this.c)return $.SyncStatus.Idle;const O=await this.c;return O.resourcePreviews.some(({mergeState:S})=>S===$.MergeState.Conflict)?$.SyncStatus.HasConflicts:O.resourcePreviews.some(({mergeState:S})=>S!==$.MergeState.Accepted)?$.SyncStatus.Syncing:(await this.tb(O.remoteUserData,O.lastSyncUserData,O.resourcePreviews.map(S=>[S,S.acceptResult]),y),this.c=null,await this.bb(),$.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const O=y.filter(({mergeState:S})=>S===$.MergeState.Conflict);(0,P.$yb)(this.s,O,(S,v)=>this.h.isEqual(S.previewResource,v.previewResource))||(this.s=O,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const O=this.c?await this.c:null;if(O)for(const S of O.resourcePreviews){if(this.h.isEqual(S.acceptedResource,y))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,y))return S.remoteContent;if(this.h.isEqual(S.localResource,y))return S.localContent;if(this.h.isEqual(S.baseResource,y))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,w.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(y){(0,l.$wl)(y)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(y)}}async eb(y,O,S,v,N,F){const U=await this.qb(y,O,S,N,F),j=[];for(const G of U){const W=G.previewResource.with({scheme:$.$Hob,authority:"accepted"});if(G.localChange===$.Change.None&&G.remoteChange===$.Change.None)j.push({...G,acceptedResource:W,acceptResult:{content:null,localChange:$.Change.None,remoteChange:$.Change.None},mergeState:$.MergeState.Accepted});else{const x=v?await this.rb(G,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(G.previewResource,L.$Se.fromString(x?.content||""));const V=x&&!x.hasConflicts?await this.sb(G,G.previewResource,void 0,F):void 0;j.push({...G,acceptResult:V,mergeState:x?.hasConflicts?$.MergeState.Conflict:V?$.MergeState.Accepted:$.MergeState.Preview,localChange:V?V.localChange:x?x.localChange:G.localChange,remoteChange:V?V.remoteChange:x?x.remoteChange:G.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:O,resourcePreviews:j,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const O=JSON.parse(y),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!O.version&&!!S&&O.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${O.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let v,N=1;for(;v===void 0&&N++<6;)try{const F=await this.hb();F&&(F.ref===O.ref?v=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof l.$Al&&F.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof $.$vob)throw F;this.O.error(F,N)}}if(v===void 0)try{const F=await this.J.resolveResourceContent(this.resource,O.ref,this.collection,this.F);v=F===null?null:this.kb(F),await this.ib({ref:O.ref,syncData:v})}catch(F){if(F instanceof $.$vob&&F.code===$.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return v===void 0?null:{...O,syncData:v}}async fb(y,O={}){if(O.ref||O.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),v={ref:y.ref,version:S,...O};this.I.store(this.z,JSON.stringify(v),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),await this.ib(y)}gb(){return this.I.get(this.z,w.StorageScope.APPLICATION)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const O=y?JSON.parse(y):void 0;if(h(O))return O}catch(O){this.O.error(O)}}async ib(y){await this.G.writeFile(this.y,L.$Se.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),O=JSON.parse(y.value.toString());await this.G.del(this.y),O.ref&&O.content!==void 0?(this.I.store(this.z,JSON.stringify({...O,content:void 0}),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),await this.ib({ref:O.ref,syncData:O.content===null?null:JSON.parse(O.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,O)}catch(y){y instanceof l.$Al&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,w.StorageScope.APPLICATION)}async getRemoteUserData(y){const{ref:O,content:S}=await this.lb(y);let v=null;return S!==null&&(v=this.kb(S)),{ref:O,syncData:v}}kb(y){try{const O=JSON.parse(y);if(i(O))return O}catch(O){this.O.error(O)}throw new $.$vob((0,p.localize)(2444,null),$.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(y){const O=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,O,this.collection,this.F)}async mb(y,O){const S=await this.j,v={version:this.pb,machineId:S,content:y};try{return O=await this.J.writeResource(this.resource,JSON.stringify(v),O,this.collection,this.F),{ref:O,syncData:v}}catch(N){throw N instanceof $.$vob&&N.code===$.UserDataSyncErrorCode.TooLarge&&(N=new $.$vob(N.message,N.code,this.resource)),N}}async nb(y){const O={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(O),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==$.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S($.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue($.$iob)}};e.$QOb=t,e.$QOb=t=Ee([Y(2,l.$fl),Y(3,g.$Ri),Y(4,w.$oq),Y(5,$.$qob),Y(6,$.$rob),Y(7,$.$Aob),Y(8,d.$em),Y(9,$.$Fob),Y(10,m.$ej),Y(11,I.$Pl)],t);let s=class extends t{constructor(y,O,S,v,N,F,U,j,G,W,x,V,te){super(O,S,v,N,F,U,j,G,W,x,V,te),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(B=>this.yb(B)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,O,S){try{O?await this.G.writeFile(this.r,L.$Se.fromString(y),S?void 0:O):await this.G.createFile(this.r,L.$Se.fromString(y),{overwrite:S})}catch(v){throw v instanceof l.$Al&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||v instanceof l.$Al&&v.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new $.$vob(v.message,$.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof l.$Al&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$ROb=s,e.$ROb=s=Ee([Y(3,l.$fl),Y(4,g.$Ri),Y(5,w.$oq),Y(6,$.$qob),Y(7,$.$rob),Y(8,$.$Aob),Y(9,d.$em),Y(10,$.$Fob),Y(11,m.$ej),Y(12,I.$Pl)],s);let r=class extends s{constructor(y,O,S,v,N,F,U,j,G,W,x,V,te,B){super(y,O,S,v,N,F,U,j,G,W,x,te,B),this.zb=V,this.Bb=void 0}Ab(y,O){const S=[],v=(0,C.$5n)(y,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,R.$qg)(v)&&O!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$SOb=r,e.$SOb=r=Ee([Y(3,l.$fl),Y(4,g.$Ri),Y(5,w.$oq),Y(6,$.$qob),Y(7,$.$rob),Y(8,$.$Aob),Y(9,d.$em),Y(10,$.$Fob),Y(11,$.$Eob),Y(12,m.$ej),Y(13,I.$Pl)],r);let o=class{constructor(y,O,S,v,N,F,U){this.resource=y,this.g=O,this.h=S,this.j=v,this.k=N,this.l=F,this.d=U.extUri,this.f=(0,$.$oob)(void 0,this.resource,S,this.d)}async initialize({ref:y,content:O}){if(!O){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(O);if(S)try{await this.o({ref:y,syncData:S})}catch(v){this.j.error(v)}}m(y){try{const O=JSON.parse(y);if(i(O))return O}catch(O){this.j.error(O)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,O={}){if(O.ref||O.version)throw new Error("Cannot have core properties as additional");const S={ref:y.ref,version:void 0,...O};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),await this.k.writeFile(this.f,L.$Se.fromString(JSON.stringify(y)))}};e.$TOb=o,e.$TOb=o=Ee([Y(1,c.$Rl),Y(2,g.$Ri),Y(3,f.$fk),Y(4,l.$fl),Y(5,w.$oq),Y(6,I.$Pl)],o)}),define(fe[121],de([0,1,6,25,8,3,45,2,26,21,15,120,27,35,86,34,7,4,77,11,16,18,28,19,40,208,116,24,62]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c,h,i,n,t,s,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=e.$dec=e.$cec=void 0,e.$aec=y,e.$bec=O;async function u(F,U){const j=JSON.parse(F.content);if(F.version===1||F.version===2){const G=(await U.getInstalled(f.ExtensionType.System)).filter(W=>W.isBuiltin);for(const W of j)F.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),F.version===2&&G.every(x=>!(0,g.$Sp)(x.identifier,W.identifier))&&(W.installed=!0)}return j}function y(F){return JSON.parse(F.content)}function O(F,U){return F.sort((j,G)=>!j.identifier.uuid&&G.identifier.uuid?-1:j.identifier.uuid&&!G.identifier.uuid?1:(0,A.$Df)(j.identifier.id,G.identifier.id)),U?(0,T.$co)(F,{}):JSON.stringify(F)}let S=class extends n.$QOb{constructor(U,j,G,W,x,V,te,B,H,_,ne,le,ee,X,K,q,D){super({syncResource:r.SyncResource.Extensions,profile:U},j,W,G,x,V,te,le,ee,_,ne,K),this.Cb=B,this.Db=H,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Hob,authority:"base"}),this.yb=this.wb.with({scheme:r.$Hob,authority:"local"}),this.zb=this.wb.with({scheme:r.$Hob,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Hob,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(k.Event.any(k.Event.filter(this.Cb.onDidInstallExtensions,J=>J.some(({local:oe})=>!!oe)),k.Event.filter(this.Cb.onDidUninstallExtension,J=>!J.error),k.Event.filter(q.onDidChange,J=>J.valueChanges.some(({profile:oe,changes:Q})=>this.syncResource.profile.id===oe.id&&Q.some(Z=>Z.key===m.$vp))),X.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,j){const G=U.syncData?await u(U.syncData,this.Cb):null,W=j?.skippedExtensions??[],x=j?.builtinExtensions??null,V=j?.syncData?await u(j.syncData,this.Cb):null,{localExtensions:te,ignoredExtensions:B}=await this.Bb.getLocalExtensions(this.syncResource.profile);G?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:H,remote:_}=(0,t.$_dc)(te,G,V,W,B,x),ne={local:H,remote:_,content:this.Hb(te,H.added,H.updated,H.removed),localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:_!==null?r.Change.Modified:r.Change.None},le=this.Ob(te,!1);return[{skippedExtensions:W,builtinExtensions:x,baseResource:this.xb,baseContent:V?this.Ob(V,!1):le,localResource:this.yb,localContent:le,localExtensions:te,remoteResource:this.zb,remoteExtensions:G,remoteContent:G?this.Ob(G,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(U){const j=U.syncData?await u(U.syncData,this.Cb):null,{localExtensions:G,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.$_dc)(G,j,j,U.skippedExtensions||[],W,U.builtinExtensions||[]);return x!==null}Hb(U,j,G,W){const x=[...j,...G],V=new Set,te=B=>{V.add(B.id.toLowerCase()),B.uuid&&V.add(B.uuid)};x.forEach(({identifier:B})=>te(B)),W.forEach(te);for(const B of U)V.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&V.has(B.identifier.uuid)||x.push(B);return this.Ob(x,!1)}async rb(U,j){return{...U.previewResult,hasConflicts:!1}}async sb(U,j,G,W){if(this.h.isEqual(j,this.yb))return this.Kb(U);if(this.h.isEqual(j,this.zb))return this.Lb(U);if(this.h.isEqual(j,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async Kb(U){const j=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(j),W=(0,t.$_dc)(U.localExtensions,null,null,U.skippedExtensions,G,U.builtinExtensions),{local:x,remote:V}=W;return{content:U.localContent,local:x,remote:V,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:V!==null?r.Change.Modified:r.Change.None}}async Lb(U){const j=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),G=this.Db.getIgnoredExtensions(j),W=U.remoteContent?JSON.parse(U.remoteContent):null;if(W!==null){const x=(0,t.$_dc)(U.localExtensions,W,U.localExtensions,[],G,U.builtinExtensions),{local:V,remote:te}=x;return{content:U.remoteContent,local:V,remote:te,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:te!==null?r.Change.Modified:r.Change.None}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(U,j,G,W){let{skippedExtensions:x,builtinExtensions:V,localExtensions:te}=G[0][0];const{local:B,remote:H,localChange:_,remoteChange:ne}=G[0][1];if(_===r.Change.None&&ne===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),_!==r.Change.None&&(await this.nb(JSON.stringify(te)),x=await this.Bb.updateLocalExtensions(B.added,B.removed,B.updated,x,this.syncResource.profile)),H){this.O.trace(`${this.D}: Updating remote extensions...`);const le=JSON.stringify(H.all);U=await this.mb(le,W?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(ee=>ee.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(ee=>ee.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(ee=>ee.identifier.id))}.`:""}`)}j?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),V=this.Nb(te,V),await this.fb(U,{skippedExtensions:x,builtinExtensions:V}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(le=>le.identifier.id))}.`:""}`))}Nb(U,j){const G=new Set,W=[];for(const x of U)G.add(x.identifier.id.toLowerCase()),x.installed||W.push(x.identifier);if(j)for(const x of j)G.has(x.id.toLowerCase())||W.push(x);return W}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const j=await this.db(U);return j&&this.Ob(JSON.parse(j),!0)}return null}Ob(U,j){return O(U,j)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(j=>j.installed||j.disabled))return!0}catch{}return!1}};e.$cec=S,e.$cec=S=Ee([Y(2,R.$Ri),Y(3,E.$fl),Y(4,$.$oq),Y(5,r.$qob),Y(6,r.$rob),Y(7,m.$up),Y(8,s.$JPb),Y(9,r.$Fob),Y(10,b.$ej),Y(11,r.$Aob),Y(12,c.$em),Y(13,l.$zw),Y(14,h.$Pl),Y(15,o.$ONb),Y(16,w.$Ji)],S);let v=class{constructor(U,j,G,W,x,V){this.a=U,this.b=j,this.c=G,this.d=W,this.f=x,this.g=V}async getLocalExtensions(U){const j=await this.a.getInstalled(void 0,U.extensionsResource),G=this.d.getIgnoredExtensions(j);return{localExtensions:await this.j(U,async(x,V)=>{const te=x.getDisabledExtensions();return j.map(B=>{const{identifier:H,isBuiltin:_,manifest:ne,preRelease:le,pinned:ee,isApplicationScoped:X}=B,K={identifier:H,preRelease:le,version:ne.version,pinned:!!ee};X&&!(0,f.$An)(ne)&&(K.isApplicationScoped=X),te.some(q=>(0,g.$Sp)(q,H))&&(K.disabled=!0),_||(K.installed=!0);try{const q=V.getKeysForSync({id:H.id,version:ne.version});if(q){const D=V.getExtensionState(B,!0)||{};K.state=Object.keys(D).reduce((J,oe)=>(q.includes(oe)&&(J[oe]=D[oe]),J),{})}}catch(q){this.g.info(`${(0,n.$POb)(r.SyncResource.Extensions,U)}: Error while parsing extension state`,(0,L.$bb)(q))}return K})}),ignoredExtensions:G}}async updateLocalExtensions(U,j,G,W,x){const V=(0,n.$POb)(r.SyncResource.Extensions,x),te=[],B=new Map,H=[],_=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||G.length)&&await this.j(x,async(X,K)=>{await P.Promises.settled([...U,...G].map(async q=>{const D=ne.find(Q=>(0,g.$Sp)(Q.identifier,q.identifier));if(D&&D.isBuiltin){q.state&&D.manifest.version===q.version&&this.h(q.state,D,D.manifest.version,K),X.getDisabledExtensions().some(Z=>(0,g.$Sp)(Z,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${V}: Disabling extension...`,q.identifier.id),await X.disableExtension(q.identifier),this.g.info(`${V}: Disabled extension`,q.identifier.id)):(this.g.trace(`${V}: Enabling extension...`,q.identifier.id),await X.enableExtension(q.identifier),this.g.info(`${V}: Enabled extension`,q.identifier.id))),H.push(q.identifier);return}const J=q.pinned?q.version:void 0,oe=(await this.c.getExtensions([{...q.identifier,version:J,preRelease:J?void 0:q.preRelease}],a.CancellationToken.None))[0];if(q.state&&(D?D.manifest.version===q.version:oe)&&this.h(q.state,D||oe,D?.manifest.version,K),oe)try{X.getDisabledExtensions().some(Z=>(0,g.$Sp)(Z,q.identifier))!==!!q.disabled&&(q.disabled?(this.g.trace(`${V}: Disabling extension...`,q.identifier.id,oe.version),await X.disableExtension(oe.identifier),this.g.info(`${V}: Disabled extension`,q.identifier.id,oe.version)):(this.g.trace(`${V}: Enabling extension...`,q.identifier.id,oe.version),await X.enableExtension(oe.identifier),this.g.info(`${V}: Enabled extension`,q.identifier.id,oe.version))),(!D||D.preRelease!==q.preRelease||D.pinned!==q.pinned||J&&D.manifest.version!==J)&&(await this.a.canInstall(oe)?(te.push({extension:oe,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:q.pinned&&!!q.version,pinned:q.pinned,installPreReleaseVersion:q.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:q.isApplicationScoped,context:{[m.$hp]:!0,[m.$ip]:m.ExtensionInstallSource.SETTINGS_SYNC}}}),B.set(oe.identifier.id.toLowerCase(),q)):(this.g.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,oe.displayName||oe.identifier.id),_.push(q)))}catch(Q){_.push(q),this.g.error(Q),this.g.info(`${V}: Skipped synchronizing extension`,oe.displayName||oe.identifier.id)}else _.push(q),this.g.info(`${V}: Skipped synchronizing extension because the extension is not found.`,q.identifier.id)}))}),j.length){const X=ne.filter(({identifier:K,isBuiltin:q})=>!q&&j.some(D=>(0,g.$Sp)(K,D)));await P.Promises.settled(X.map(async K=>{this.g.trace(`${V}: Uninstalling local extension...`,K.identifier.id),await this.a.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${V}: Uninstalled local extension.`,K.identifier.id),H.push(K.identifier)}))}const le=await this.a.installGalleryExtensions(te);for(const{identifier:X,local:K,error:q,source:D}of le){const J=D;if(K)this.g.info(`${V}: Installed extension.`,X.id,J.version),H.push(X);else{const oe=B.get(X.id.toLowerCase());oe&&(_.push(oe),this.g.info(`${V}: Skipped synchronizing extension`,J.displayName||J.identifier.id)),q instanceof m.$tp&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleApi,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(q.code)?this.g.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,J.displayName||J.identifier.id):q&&this.g.error(q)}}const ee=[];for(const X of W)H.some(K=>(0,g.$Sp)(K,X.identifier))||ee.push(X);for(const X of _)ee.some(K=>(0,g.$Sp)(K.identifier,X.identifier))||ee.push(X);return ee}h(U,j,G,W){const x=W.getExtensionState(j,!0)||{},V=G?W.getKeysForSync({id:j.identifier.id,version:G}):void 0;V?V.forEach(te=>{x[te]=U[te]}):Object.keys(U).forEach(te=>x[te]=U[te]),W.setExtensionState(j,x,!0)}async j(U,j){return this.b.withProfileScopedStorageService(U,async G=>{const W=new C.$Yc,x=W.add(this.f.createChild(new d.$Ii([$.$oq,G]))),V=W.add(x.createInstance(p.$aNb)),te=W.add(x.createInstance(l.$Aw));try{return await j(V,te)}finally{W.dispose()}})}};e.$dec=v,e.$dec=v=Ee([Y(0,m.$up),Y(1,o.$ONb),Y(2,m.$rp),Y(3,s.$JPb),Y(4,w.$Ji),Y(5,r.$Fob)],v);let N=class extends n.$TOb{constructor(U,j,G,W,x,V,te,B){super(r.SyncResource.Extensions,W,x,V,G,te,B),this.p=U,this.q=j}async t(U){return U.syncData?await u(U.syncData,this.p):null}u(U,j){const G=[],W=[],x=[];for(const V of U){if(this.q.hasToNeverSyncExtension(V.identifier.id))continue;const te=j.find(B=>(0,g.$Sp)(B.identifier,V.identifier));te?(G.push(te),V.disabled&&x.push(V.identifier)):V.installed&&(W.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&x.push(V.identifier))}return{installedExtensions:G,newExtensions:W,disabledExtensions:x,remoteExtensions:U}}};e.$eec=N,e.$eec=N=Ee([Y(0,m.$up),Y(1,s.$JPb),Y(2,E.$fl),Y(3,i.$Rl),Y(4,R.$Ri),Y(5,I.$fk),Y(6,$.$oq),Y(7,h.$Pl)],N)}),define(fe[122],de([0,1,14,8,3,36,45,5,32,21,15,7,11,49,16,18,28,40,82,212,24,19,62,4]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZOb=e.$YOb=e.$XOb=e.$WOb=void 0,e.$VOb=s;const n="globalState.argv.",t=["locale"];function s(S,v){const N=S.storage?Object.keys(S.storage).sort():[],F={};return N.forEach(U=>F[U]=S.storage[U]),S.storage=F,v?(0,T.$co)(S,{}):JSON.stringify(S)}const r=1;let o=class extends w.$QOb{constructor(v,N,F,U,j,G,W,x,V,te,B,H,_,ne){super({syncResource:$.SyncResource.GlobalState,profile:v},N,U,x,H,j,G,V,te,W,B,_),this.Bb=F,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:$.$Hob,authority:"base"}),this.xb=this.vb.with({scheme:$.$Hob,authority:"local"}),this.yb=this.vb.with({scheme:$.$Hob,authority:"remote"}),this.zb=this.vb.with({scheme:$.$Hob,authority:"accepted"}),this.Ab=ne.createInstance(u),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(U.onDidFilesChange,le=>le.contains(this.H.argvResource)),L.Event.filter(F.onDidChange,le=>!!(le.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||le.valueChanges.some(({profile:ee,changes:X})=>this.syncResource.profile.id===ee.id&&X.some(K=>K.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,N,F){const U=v.syncData?JSON.parse(v.syncData.content):null;N=N===null&&F?v:N;const j=N&&N.syncData?JSON.parse(N.syncData.content):null,G=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=await this.Jb(j),{local:x,remote:V}=(0,I.$UOb)(G.storage,U?U.storage:null,j?j.storage:null,W,this.O),te={content:null,local:x,remote:V,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?$.Change.Modified:$.Change.None,remoteChange:V.all!==null?$.Change.Modified:$.Change.None},B=s(G,!1);return[{baseResource:this.wb,baseContent:j?s(j,!1):B,localResource:this.xb,localContent:B,localUserData:G,remoteResource:this.yb,remoteContent:U?s(U,!1):null,previewResource:this.vb,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.zb,storageKeys:W}]}async ub(v){const N=v.syncData?JSON.parse(v.syncData.content):null;if(N===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(N),{remote:j}=(0,I.$UOb)(F.storage,N.storage,N.storage,U,this.O);return j.all!==null}async rb(v,N){return{...v.previewResult,hasConflicts:!1}}async sb(v,N,F,U){if(this.h.isEqual(N,this.xb))return this.Gb(v);if(this.h.isEqual(N,this.yb))return this.Hb(v);if(this.h.isEqual(N,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:$.Change.None,remoteChange:$.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const N=JSON.parse(v.remoteContent),{local:F,remote:U}=(0,I.$UOb)(v.localUserData.storage,N.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:F,remote:U,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?$.Change.Modified:$.Change.None,remoteChange:U!==null?$.Change.Modified:$.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:$.Change.None,remoteChange:$.Change.None}}async tb(v,N,F,U){const{localUserData:j}=F[0][0],{local:G,remote:W,localChange:x,remoteChange:V}=F[0][1];if(x===$.Change.None&&V===$.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==$.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(j)),await this.Ab.writeLocalGlobalState(G,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),V!==$.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const te=JSON.stringify({storage:W.all});v=await this.mb(te,U?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${W.added.length?` Added: ${W.added}.`:""}${W.updated.length?` Updated: ${W.updated}.`:""}${W.removed.length?` Removed: ${W.removed}.`:""}`)}N?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const N=await this.db(v);return N&&s(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const N=await this.Bb.readStorageData(this.syncResource.profile),F=[],U=[];for(const[W,x]of N)x.target===l.StorageTarget.USER?F.push(W):x.target===l.StorageTarget.MACHINE&&U.push(W);const j=[...F,...U],G=v?.storage?Object.keys(v.storage).filter(W=>!W.startsWith(n)&&!j.includes(W)&&N.get(W)!==void 0):[];if(!C.$r){const W=[...$.$mob.map(x=>(0,$.$zob)(x)),$.$yob];G.push(...W),U.push(...W)}return{user:F,machine:U,unregistered:G}}};e.$WOb=o,e.$WOb=o=Ee([Y(2,h.$ONb),Y(3,p.$fl),Y(4,$.$qob),Y(5,$.$rob),Y(6,$.$Fob),Y(7,R.$Ri),Y(8,$.$Aob),Y(9,f.$em),Y(10,b.$ej),Y(11,l.$oq),Y(12,E.$Pl),Y(13,i.$Ji)],o);let u=class{constructor(v,N,F,U){this.a=v,this.b=N,this.c=F,this.d=U}async getLocalGlobalState(v){const N={};if(v.isDefault){const U=await this.f(),j=(0,k.$5n)(U);for(const G of t)j[G]!==void 0&&(N[`${n}${G}`]={version:1,value:j[G]})}const F=await this.c.readStorageData(v);for(const[U,j]of F)j.value&&j.target===l.StorageTarget.USER&&(N[U]={version:1,value:j.value});return{storage:N}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,a.$bb)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:N,updated:F},U){const j=(0,w.$POb)($.SyncResource.GlobalState,U),G={},W=new Map,x=await this.c.readStorageData(U),V=(te,B)=>{for(const H of te){if(H.startsWith(n)){G[H.substring(n.length)]=B?B[H].value:void 0;continue}if(B){const _=B[H];_.value!==x.get(H)?.value&&W.set(H,_.value)}else x.get(H)!==void 0&&W.set(H,void 0)}};if(V(Object.keys(v),v),V(Object.keys(F),F),V(N),Object.keys(G).length){this.d.trace(`${j}: Updating locale...`);const te=await this.f();let B=te;for(const H of Object.keys(G))B=(0,d.edit)(B,[H],G[H],{});te!==B&&(this.d.trace(`${j}: Updating locale...`),await this.a.writeFile(this.b.argvResource,P.$Se.fromString(B)),this.d.info(`${j}: Updated locale.`)),this.d.info(`${j}: Updated locale`)}W.size&&(this.d.trace(`${j}: Updating global state...`),await this.c.updateStorageData(U,W,l.StorageTarget.USER),this.d.info(`${j}: Updated global state`,[...W.keys()]))}};e.$XOb=u,e.$XOb=u=Ee([Y(0,p.$fl),Y(1,R.$Ri),Y(2,h.$ONb),Y(3,$.$Fob)],u);let y=class extends w.$TOb{constructor(v,N,F,U,j,G){super($.SyncResource.GlobalState,F,U,j,N,v,G)}async o(v){const N=v.syncData?JSON.parse(v.syncData.content):null;if(!N){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},U={};for(const j of Object.keys(N.storage))j.startsWith(n)?F[j.substring(n.length)]=N.storage[j].value:this.l.get(j,l.StorageScope.PROFILE)===void 0&&(U[j]=N.storage[j].value);if(Object.keys(F).length){let j="{}";try{j=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const G of Object.keys(F))j=(0,d.edit)(j,[G],F[G],{});await this.k.writeFile(this.h.argvResource,P.$Se.fromString(j))}if(Object.keys(U).length){const j=[];for(const G of Object.keys(U))j.push({key:G,value:U[G],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(j,!0)}}};e.$YOb=y,e.$YOb=y=Ee([Y(0,l.$oq),Y(1,p.$fl),Y(2,c.$Rl),Y(3,R.$Ri),Y(4,$.$Fob),Y(5,E.$Pl)],y);let O=class{constructor(v,N,F,U,j){this.a=v,this.b=N,this.c=F,this.d=U,this.f=j}getSyncStoreType(v){return this.h(v)?.storage[$.$yob]?.value}async sync(v){const N=(0,$.$uob)((0,A.$7g)());try{return await this.g(v,N)}catch(F){if(F instanceof $.$vob)switch(F.code){case $.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,N)}throw F}}async g(v,N){const F=await this.a.readResource($.SyncResource.GlobalState,null,void 0,N),U=this.h(F)||{storage:{}};U.storage[$.$yob]={value:v,version:r};const j=await(0,g.$uq)(this.c,this.d,this.b),G={version:r,machineId:j,content:s(U,!1)};await this.a.writeResource($.SyncResource.GlobalState,JSON.stringify(G),F.ref,void 0,N)}h({content:v}){if(!v)return null;const N=JSON.parse(v);if((0,w.$OOb)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.$ZOb=O,e.$ZOb=O=Ee([Y(1,l.$oq),Y(2,R.$Ri),Y(3,p.$fl),Y(4,m.$fk)],O)}),define(fe[123],de([0,1,17,14,3,36,5,12,9,21,15,7,16,18,28,19,40,209,24]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=e.$hec=void 0,e.$gec=I;function I(h,i,n){try{const t=JSON.parse(h);if(!i)return(0,C.$qg)(t.all)?null:t.all;switch(T.OS){case T.OperatingSystem.Macintosh:return(0,C.$qg)(t.mac)?null:t.mac;case T.OperatingSystem.Linux:return(0,C.$qg)(t.linux)?null:t.linux;case T.OperatingSystem.Windows:return(0,C.$qg)(t.windows)?null:t.windows}}catch(t){return n.error(t),null}}let $=class extends E.$SOb{constructor(i,n,t,s,r,o,u,y,O,S,v,N,F){super(i.keybindingsResource,{syncResource:d.SyncResource.Keybindings,profile:i},n,y,O,S,t,s,u,N,r,v,o,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:d.$Hob,authority:"base"}),this.Gb=this.Eb.with({scheme:d.$Hob,authority:"local"}),this.Hb=this.Eb.with({scheme:d.$Hob,authority:"remote"}),this.Ib=this.Eb.with({scheme:d.$Hob,authority:"accepted"}),this.B(L.Event.filter(o.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,n,t,s){const r=i.syncData?I(i.syncData.content,s.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&t?i:n;const o=n?this.Ob(n):null,u=await this.vb(),y=await this.Cb();let O=null,S=!1,v=!1,N=!1;if(r){let j=u?u.value.toString():"[]";if(j=j||"[]",this.Ab(j,!0))throw new d.$vob((0,A.localize)(2445,null),d.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==j||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const G=await(0,w.$fec)(j,r,o,y,this.zb);G.hasChanges&&(O=G.mergeContent,N=G.hasConflicts,S=N||G.mergeContent!==j,v=N||G.mergeContent!==r)}}else u&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),O=u.value.toString(),v=!0);const F={content:N?o:O,localChange:S?u?d.Change.Modified:d.Change.Added:d.Change.None,remoteChange:v?d.Change.Modified:d.Change.None,hasConflicts:N},U=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:U,localChange:F.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(i){const n=this.Ob(i);if(n===null)return!0;const t=await this.vb(),s=t?t.value.toString():"",r=await this.Cb(),o=await(0,w.$fec)(s||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(i,n){return i.previewResult}async sb(i,n,t,s){if(this.h.isEqual(n,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:d.Change.None,remoteChange:d.Change.Modified};if(this.h.isEqual(n,this.Hb))return{content:i.remoteContent,localChange:d.Change.Modified,remoteChange:d.Change.None};if(this.h.isEqual(n,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:d.Change.Modified,remoteChange:d.Change.Modified};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(i,n,t,s){const{fileContent:r}=t[0][0];let{content:o,localChange:u,remoteChange:y}=t[0][1];if(u===d.Change.None&&y===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new d.$vob((0,A.localize)(2446,null),d.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==d.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,s),this.O.info(`${this.D}: Updated local keybindings`)),y!==d.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const O=this.Pb(o||"[]",i.syncData?.content);i=await this.mb(O,s?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const n=(0,k.$5n)(i.value.toString());if((0,P.$Pb)(n))return!0}}catch(i){if(i.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:I(i.syncData.content,this.Qb(),this.O)}Pb(i,n){let t={};try{t=JSON.parse(n||"{}")}catch(s){this.O.error(s)}switch(this.Qb()?delete t.all:t.all=i,T.OS){case T.OperatingSystem.Macintosh:t.mac=i;break;case T.OperatingSystem.Linux:t.linux=i;break;case T.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(d.$job)}};e.$hec=$,e.$hec=$=Ee([Y(2,d.$qob),Y(3,d.$rob),Y(4,d.$Fob),Y(5,b.$ej),Y(6,d.$Aob),Y(7,p.$fl),Y(8,R.$Ri),Y(9,m.$oq),Y(10,d.$Eob),Y(11,g.$em),Y(12,l.$Pl)],$);let c=class extends E.$TOb{constructor(i,n,t,s,r,o){super(d.SyncResource.Keybindings,n,t,s,i,r,o)}async o(i){const n=i.syncData?this.p(i.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,a.$Se.fromString(n)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,k.$5n)(i.value.toString());return!(0,P.$Pb)(n)}catch(i){return i.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return I(i,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$iec=c,e.$iec=c=Ee([Y(0,p.$fl),Y(1,f.$Rl),Y(2,R.$Ri),Y(3,d.$Fob),Y(4,m.$oq),Y(5,l.$Pl)],c)}),define(fe[124],de([0,1,17,14,3,9,21,78,15,27,34,7,16,18,28,19,40,213,24]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0,e.$jec=$;function I(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function $(i){const n=JSON.parse(i);return I(n)?n:{settings:i}}let c=class extends E.$SOb{constructor(n,t,s,r,o,u,y,O,S,v,N,F,U,j){super(n.settingsResource,{syncResource:d.SyncResource.Settings,profile:n},t,s,r,o,u,y,N,F,O,S,v,j),this.Eb=n,this.Fb=U,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:d.$Hob,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$Hob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$Hob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$Hob,authority:"accepted"}),this.Pb=void 0,this.Qb=void 0,this.Rb=void 0}async getRemoteUserDataSyncConfiguration(n){const t=await this.getLastSyncUserData(),s=await this.X(n,t),r=this.Mb(s),o=new C.$Vo(d.$iob,this.O);return r?.settings&&o.parse(r.settings),o.configurationModel.getValue(d.$iob)||{}}async qb(n,t,s){const r=await this.vb(),o=await this.Cb(),u=this.Mb(n);t=t===null&&s?n:t;const y=t?this.Mb(t):null,O=await this.Sb();let S=null,v=!1,N=!1,F=!1;if(u){let W=r?r.value.toString().trim():"{}";W=W||"{}",this.Vb(W),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,w.$vNb)(W,u.settings,y?y.settings:null,O,[],o);S=x.localContent||x.remoteContent,v=x.localContent!==null,N=x.remoteContent!==null,F=x.hasConflicts}else r&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=r.value.toString().trim()||"{}",this.Vb(S),N=!0);const U=r?r.value.toString():null,j=y?.settings??null,G={content:F?j:S,localChange:v?d.Change.Modified:d.Change.None,remoteChange:N?d.Change.Modified:d.Change.None,hasConflicts:F};return[{fileContent:r,baseResource:this.baseResource,baseContent:j,localResource:this.localResource,localContent:U,localChange:G.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:G.remoteChange,previewResource:this.previewResource,previewResult:G,acceptedResource:this.acceptedResource}]}async ub(n){const t=this.Mb(n);if(t===null)return!0;const s=await this.vb(),r=s?s.value.toString().trim():"",o=await this.Sb(),u=await this.Cb();return(0,w.$vNb)(r||"{}",t.settings,t.settings,o,[],u).remoteContent!==null}async rb(n,t){const s=await this.Cb(),r=await this.Sb();return{...n.previewResult,content:n.previewResult.content?(0,w.$uNb)(n.previewResult.content,"{}",r,s):null}}async sb(n,t,s,r){const o=await this.Cb(),u=await this.Sb();if(this.h.isEqual(t,this.localResource))return{content:n.fileContent?(0,w.$uNb)(n.fileContent.value.toString(),"{}",u,o):null,localChange:d.Change.None,remoteChange:d.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:n.remoteContent!==null?(0,w.$uNb)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:d.Change.Modified,remoteChange:d.Change.None};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,w.$uNb)(s,n.fileContent?n.fileContent.value.toString():"{}",u,o):null,localChange:d.Change.Modified,remoteChange:d.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(n,t,s,r){const{fileContent:o}=s[0][0];let{content:u,localChange:y,remoteChange:O}=s[0][1];if(y===d.Change.None&&O===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.Vb(u),y!==d.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),o&&await this.nb(JSON.stringify(this.Ob(o.value.toString()))),await this.wb(u,o,r),await this.P.reloadConfiguration(T.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),O!==d.Change.None){const S=await this.Cb(),v=this.Mb(n),N=await this.Sb(u);u=(0,w.$uNb)(u,v?v.settings:"{}",N,S),this.O.trace(`${this.D}: Updating remote settings...`),n=await this.mb(JSON.stringify(this.Ob(u)),r?null:n.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==n.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(n),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.vb();if(n)return!(0,w.$wNb)(n.value.toString())}catch(n){if(n.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(n){return this.h.isEqual(this.remoteResource,n)||this.h.isEqual(this.localResource,n)||this.h.isEqual(this.acceptedResource,n)||this.h.isEqual(this.baseResource,n)?this.db(n):null}async db(n){let t=await super.db(n);if(t){const s=await this.Cb(),r=await this.Sb();t=(0,w.$uNb)(t,"{}",r,s)}return t}Mb(n){return n.syncData?this.Nb(n.syncData.content):null}Nb(n){try{return $(n)}catch(t){this.O.error(t)}return null}Ob(n){return{settings:n}}async Sb(n){if(this.Pb||(this.Pb=this.zb.resolveDefaultCoreIgnoredSettings()),this.Qb||(this.Qb=this.Tb()),!this.Rb){this.Rb=this.Ub();const s=this.B(L.Event.any(L.Event.filter(this.Fb.onDidInstallExtensions,r=>r.some(({local:o})=>!!o)),L.Event.filter(this.Fb.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this.Rb=void 0}))}const t=(await Promise.all([this.Pb,this.Qb,this.Rb])).flat();return(0,w.$sNb)(t,this.P,n)}async Tb(){const n=await this.Fb.getInstalled(R.ExtensionType.System);return(0,P.$Qb)(n.map(t=>(0,d.$hob)(t.manifest)).flat())}async Ub(){const n=await this.Fb.getInstalled(R.ExtensionType.User,this.Eb.extensionsResource);return(0,P.$Qb)(n.map(t=>(0,d.$hob)(t.manifest)).flat())}Vb(n){if(this.Ab(n,!1))throw new d.$vob((0,k.localize)(2447,null),d.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$kec=c,e.$kec=c=Ee([Y(2,p.$fl),Y(3,A.$Ri),Y(4,m.$oq),Y(5,d.$qob),Y(6,d.$rob),Y(7,d.$Fob),Y(8,d.$Eob),Y(9,T.$ej),Y(10,d.$Aob),Y(11,g.$em),Y(12,b.$up),Y(13,l.$Pl)],c);let h=class extends E.$TOb{constructor(n,t,s,r,o,u){super(d.SyncResource.Settings,t,s,r,n,o,u)}async o(n){const t=n.syncData?this.p(n.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,a.$Se.fromString(t.settings)),await this.n(n)}async i(){try{const n=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,w.$wNb)(n.value.toString().trim())}catch(n){return n.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}p(n){try{return $(n)}catch(t){this.j.error(t)}return null}};e.$lec=h,e.$lec=h=Ee([Y(0,p.$fl),Y(1,f.$Rl),Y(2,A.$Ri),Y(3,d.$Fob),Y(4,m.$oq),Y(5,l.$Pl)],h)}),define(fe[125],de([0,1,14,3,29,21,15,7,16,18,28,19,40,210,24]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=void 0,e.$oec=f;function f(d){return JSON.parse(d.content)}let E=class extends m.$QOb{constructor(I,$,c,h,i,n,t,s,r,o,u,y){super({syncResource:l.SyncResource.Snippets,profile:I},$,h,c,i,n,t,o,u,s,r,y),this.pb=1,this.vb=I.snippetsHome,this.B(this.G.watch(c.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(a.Event.filter(this.G.onDidFilesChange,O=>O.affects(this.vb))(()=>this.Q()))}async qb(I,$,c){const h=await this.Hb(),i=this.Gb(h),n=I.syncData?this.Fb(I.syncData):null;$=$===null&&c?I:$;const t=$&&$.syncData?this.Fb($.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,g.$mec)(i,n,t);return this.Bb(s,h,n||{},t||{})}async ub(I){const $=I.syncData?this.Fb(I.syncData):null;if($===null)return!0;const c=await this.Hb(),h=this.Gb(c),i=(0,g.$mec)(h,$,$);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(I,$){return I.previewResult}async sb(I,$,c,h){if(this.h.isEqualOrParent($,this.g.with({scheme:l.$Hob,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:I.fileContent?I.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent($,this.g.with({scheme:l.$Hob,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent($,this.g))return c===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:c,localChange:c===null?I.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:c===null?I.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${$.toString()}`)}async tb(I,$,c,h){const i=c.map(([n,t])=>({...n,acceptResult:t}));i.every(({localChange:n,remoteChange:t})=>n===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:n})=>n!==l.Change.None)&&(await this.Cb(i),await this.Db(i,h)),i.some(({remoteChange:n})=>n!==l.Change.None)&&(I=await this.Eb(i,I,h)),$?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of i)try{await this.G.del(n)}catch{}}Bb(I,$,c,h){const i=new Map;for(const n of Object.keys(I.local.added)){const t={content:I.local.added[n],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"accepted"})})}for(const n of Object.keys(I.local.updated)){const t={content:I.local.updated[n],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"accepted"})})}for(const n of I.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"accepted"})})}for(const n of Object.keys(I.remote.added)){const t={content:I.remote.added[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"accepted"})})}for(const n of Object.keys(I.remote.updated)){const t={content:I.remote.updated[n],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"local"}),fileContent:$[n],localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"accepted"})})}for(const n of I.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"remote"}),remoteContent:c[n],previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"accepted"})})}for(const n of I.conflicts){const t={content:h[n]??null,hasConflicts:!0,localChange:$[n]?l.Change.Modified:l.Change.Added,remoteChange:c[n]?l.Change.Modified:l.Change.Added},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"local"}),fileContent:$[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"accepted"})})}for(const n of Object.keys($))if(!i.has(n)){const t={content:$[n]?$[n].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},s=$[n]?$[n].value.toString():null;i.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"base"}),baseContent:h[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"local"}),fileContent:$[n]||null,localContent:s,remoteResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"remote"}),remoteContent:c[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:l.$Hob,authority:"accepted"})})}return[...i.values()]}async resolveContent(I){return this.h.isEqualOrParent(I,this.g.with({scheme:l.$Hob,authority:"remote"}))||this.h.isEqualOrParent(I,this.g.with({scheme:l.$Hob,authority:"local"}))||this.h.isEqualOrParent(I,this.g.with({scheme:l.$Hob,authority:"base"}))||this.h.isEqualOrParent(I,this.g.with({scheme:l.$Hob,authority:"accepted"}))?this.db(I):null}async hasLocalData(){try{const I=await this.Hb();if(Object.keys(I).length)return!0}catch{}return!1}async Cb(I){const $={};for(const c of I)c.fileContent&&($[this.h.basename(c.localResource)]=c.fileContent);await this.nb(JSON.stringify(this.Gb($)))}async Db(I,$){for(const{fileContent:c,acceptResult:h,localResource:i,remoteResource:n,localChange:t}of I)if(t!==l.Change.None){const s=n?this.h.basename(n):this.h.basename(i),r=this.h.joinPath(this.vb,s);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,P.$Se.fromString(h.content),{overwrite:$}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,P.$Se.fromString(h.content),$?void 0:c),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(I,$,c){const h=$.syncData?this.Fb($.syncData):{},i=(0,L.$ko)(h);for(const{acceptResult:n,localResource:t,remoteResource:s,remoteChange:r}of I)if(r!==l.Change.None){const o=t?this.h.basename(t):this.h.basename(s);r===l.Change.Deleted?delete i[o]:i[o]=n.content}return(0,g.$nec)(h,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),$=await this.mb(JSON.stringify(i),c?null:$.ref),this.O.info(`${this.D}: Updated remote snippets`)),$}Fb(I){return f(I)}Gb(I){const $={};for(const c of Object.keys(I))$[c]=I[c].value.toString();return $}async Hb(){const I={};let $;try{$=await this.G.resolve(this.vb)}catch(c){if(c instanceof C.$Al&&c.fileOperationResult===C.FileOperationResult.FILE_NOT_FOUND)return I;throw c}for(const c of $.children||[]){const h=c.resource,i=this.h.extname(h);if(i===".json"||i===".code-snippets"){const n=this.h.relativePath(this.vb,h),t=await this.G.readFile(h);I[n]=t}}return I}};e.$pec=E,e.$pec=E=Ee([Y(2,T.$Ri),Y(3,C.$fl),Y(4,A.$oq),Y(5,l.$qob),Y(6,l.$rob),Y(7,l.$Fob),Y(8,k.$ej),Y(9,l.$Aob),Y(10,b.$em),Y(11,R.$Pl)],E);let w=class extends m.$TOb{constructor(I,$,c,h,i,n){super(l.SyncResource.Snippets,$,c,h,I,i,n)}async o(I){const $=I.syncData?JSON.parse(I.syncData.content):null;if(!$){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const h of Object.keys($)){const i=$[h];if(i){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,h);await this.k.createFile(n,P.$Se.fromString(i)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(I)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===C.FileOperationResult.FILE_NOT_FOUND}}};e.$qec=w,e.$qec=w=Ee([Y(0,C.$fl),Y(1,p.$Rl),Y(2,T.$Ri),Y(3,l.$Fob),Y(4,A.$oq),Y(5,R.$Pl)],w)}),define(fe[126],de([0,1,14,21,15,7,16,18,28,19,40,24]),function(ce,e,P,a,L,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=void 0,e.$rec=m;function m(E,w){try{return JSON.parse(E).tasks??null}catch(d){return w.error(d),null}}let g=class extends R.$ROb{constructor(w,d,I,$,c,h,i,n,t,s,r,o){super(w.tasksResource,{syncResource:p.SyncResource.Tasks,profile:w},d,n,t,s,I,$,i,r,c,h,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:p.$Hob,authority:"base"}),this.Cb=this.Ab.with({scheme:p.$Hob,authority:"local"}),this.Db=this.Ab.with({scheme:p.$Hob,authority:"remote"}),this.Eb=this.Ab.with({scheme:p.$Hob,authority:"accepted"})}async qb(w,d,I,$){const c=w.syncData?m(w.syncData.content,this.O):null;d=d===null&&I?w:d;const h=d?.syncData?m(d.syncData.content,this.O):null,i=await this.vb();let n=null,t=!1,s=!1,r=!1;if(w.syncData){const y=i?i.value.toString():null;if(!h||h!==y||h!==c){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const O=f(y,c,h);n=O.content,r=O.hasConflicts,t=O.hasLocalChanged,s=O.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=i.value.toString(),s=!0);const o={content:r?h:n,localChange:t?i?p.Change.Modified:p.Change.Added:p.Change.None,remoteChange:s?p.Change.Modified:p.Change.None,hasConflicts:r},u=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:h,localResource:this.Cb,localContent:u,localChange:o.localChange,remoteResource:this.Db,remoteContent:c,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(w){const d=w?.syncData?m(w.syncData.content,this.O):null;if(d===null)return!0;const I=await this.vb(),$=I?I.value.toString():null,c=f($,d,d);return c.hasLocalChanged||c.hasRemoteChanged}async rb(w,d){return w.previewResult}async sb(w,d,I,$){if(this.h.isEqual(d,this.Cb))return{content:w.fileContent?w.fileContent.value.toString():null,localChange:p.Change.None,remoteChange:p.Change.Modified};if(this.h.isEqual(d,this.Db))return{content:w.remoteContent,localChange:p.Change.Modified,remoteChange:p.Change.None};if(this.h.isEqual(d,this.Ab))return I===void 0?{content:w.previewResult.content,localChange:w.previewResult.localChange,remoteChange:w.previewResult.remoteChange}:{content:I,localChange:p.Change.Modified,remoteChange:p.Change.Modified};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(w,d,I,$){const{fileContent:c}=I[0][0],{content:h,localChange:i,remoteChange:n}=I[0][1];if(i===p.Change.None&&n===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==p.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),c&&await this.nb(JSON.stringify(this.Kb(c.value.toString()))),h?await this.wb(h,c,$):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==p.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(h));w=await this.mb(t,$?null:w.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}d?.ref!==w.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(w),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(w){return this.h.isEqual(this.Db,w)||this.h.isEqual(this.Bb,w)||this.h.isEqual(this.Cb,w)||this.h.isEqual(this.Eb,w)?this.db(w):null}Kb(w){return w?{tasks:w}:{}}};e.$sec=g,e.$sec=g=Ee([Y(2,p.$qob),Y(3,p.$rob),Y(4,p.$Fob),Y(5,a.$ej),Y(6,p.$Aob),Y(7,k.$fl),Y(8,L.$Ri),Y(9,T.$oq),Y(10,C.$em),Y(11,A.$Pl)],g);let l=class extends R.$TOb{constructor(w,d,I,$,c,h){super(p.SyncResource.Tasks,d,I,$,w,c,h),this.c=this.g.defaultProfile.tasksResource}async o(w){const d=w.syncData?m(w.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,P.$Se.fromString(d)),await this.n(w)}async p(){return this.k.exists(this.c)}};e.$tec=l,e.$tec=l=Ee([Y(0,k.$fl),Y(1,b.$Rl),Y(2,L.$Ri),Y(3,p.$Fob),Y(4,T.$oq),Y(5,A.$Pl)],l);function f(E,w,d){if(E===null&&w===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===w)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const I=d!==E,$=d!==w;return!I&&!$?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:I&&!$?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:$&&!I?{content:w,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(fe[127],de([0,1,45,21,15,7,16,18,28,19,40,211,24]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0,e.$cgc=l,e.$dgc=f;let g=class extends R.$QOb{constructor(w,d,I,$,c,h,i,n,t,s,r,o,u){super({syncResource:m.SyncResource.Profiles,profile:w},d,$,c,h,i,n,r,o,t,s,u),this.vb=I,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$Hob,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$Hob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$Hob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$Hob,authority:"accepted"}),this.B(I.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const w=await this.getLastSyncUserData();return w?.syncData?f(w.syncData):null}async getRemoteSyncedProfiles(w){const d=await this.getLastSyncUserData(),I=await this.X(w,d);return I?.syncData?f(I.syncData):null}async qb(w,d,I){if(!this.vb.isEnabled())throw new m.$vob("Cannot sync profiles because they are disabled",m.UserDataSyncErrorCode.LocalError);const $=w.syncData?f(w.syncData):null,c=d?.syncData?f(d.syncData):null,h=this.Db(),{local:i,remote:n}=(0,p.$agc)(h,$,c,[]),t={local:i,remote:n,content:c?this.Eb(c):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?m.Change.Modified:m.Change.None,remoteChange:n!==null?m.Change.Modified:m.Change.None},s=l(h,!1);return[{baseResource:this.baseResource,baseContent:c?this.Eb(c):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:$?this.Eb($):null,remoteProfiles:$,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(w){const d=w?.syncData?f(w.syncData):null,I=this.Db(),{remote:$}=(0,p.$agc)(I,d,d,[]);return!!$?.added.length||!!$?.removed.length||!!$?.updated.length}async rb(w,d){return{...w.previewResult,hasConflicts:!1}}async sb(w,d,I,$){if(this.h.isEqual(d,this.localResource))return this.Ab(w);if(this.h.isEqual(d,this.remoteResource))return this.Bb(w);if(this.h.isEqual(d,this.previewResource))return w.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async Ab(w){const d=this.Db(),I=(0,p.$agc)(d,null,null,[]),{local:$,remote:c}=I;return{content:w.localContent,local:$,remote:c,localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?m.Change.Modified:m.Change.None,remoteChange:c!==null?m.Change.Modified:m.Change.None}}async Bb(w){const d=w.remoteContent?JSON.parse(w.remoteContent):null,I=[],$=[];for(const c of this.Db()){const h=d?.find(i=>i.id===c.id);h&&(I.push({id:c.id,name:c.name,collection:h.collection}),$.push(c))}if(d!==null){const c=(0,p.$agc)($,d,I,[]),{local:h,remote:i}=c;return{content:w.remoteContent,local:h,remote:i,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?m.Change.Modified:m.Change.None,remoteChange:i!==null?m.Change.Modified:m.Change.None}}else return{content:w.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:m.Change.None,remoteChange:m.Change.None}}async tb(w,d,I,$){const{local:c,remote:h,localChange:i,remoteChange:n}=I[0][1];i===m.Change.None&&n===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=I[0][0].remoteProfiles||[];if(t.length+(h?.added.length??0)-(h?.removed.length??0)>20)throw new m.$vob("Too many profiles to sync. Please remove some profiles and try again.",m.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==m.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(c.removed.map(async s=>{this.O.trace(`${this.D}: Removing '${s.name}' profile...`),await this.vb.removeProfile(s),this.O.info(`${this.D}: Removed profile '${s.name}'.`)})),await Promise.all(c.added.map(async s=>{this.O.trace(`${this.D}: Creating '${s.name}' profile...`),await this.vb.createProfile(s.id,s.name,{shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${s.name}'.`)})),await Promise.all(c.updated.map(async s=>{const r=this.vb.profiles.find(o=>o.id===s.id);r?(this.O.trace(`${this.D}: Updating '${s.name}' profile...`),await this.vb.updateProfile(r,{name:s.name,shortName:s.shortName,icon:s.icon,useDefaultFlags:s.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${s.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${s.id}' to update.`)}))),n!==m.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const s=[],r=t.length+(h?.added.length??0)<=20;if(r)for(const o of h?.added||[]){const u=await this.J.createCollection(this.F);s.push(u),t.push({id:o.id,name:o.name,collection:u,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of h?.removed||[])t.splice(t.findIndex(({id:u})=>o.id===u),1);for(const o of h?.updated||[]){const u=t.find(({id:y})=>o.id===y);u&&t.splice(t.indexOf(u),1,{...u,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{w=await this.updateRemoteProfiles(t,$?null:w.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&h?.added.length?` Added: ${JSON.stringify(h.added.map(o=>o.name))}.`:""}${h?.updated.length?` Updated: ${JSON.stringify(h.updated.map(o=>o.name))}.`:""}${h?.removed.length?` Removed: ${JSON.stringify(h.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of s)await this.J.deleteCollection(u,this.F)}throw o}for(const o of h?.removed||[])await this.J.deleteCollection(o.collection,this.F)}d?.ref!==w.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(w),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(w,d){return this.mb(this.Eb(w),d)}async hasLocalData(){return this.Db().length>0}async resolveContent(w){if(this.h.isEqual(this.remoteResource,w)||this.h.isEqual(this.baseResource,w)||this.h.isEqual(this.localResource,w)||this.h.isEqual(this.acceptedResource,w)){const d=await this.db(w);return d&&(0,P.$co)(JSON.parse(d),{})}return null}Db(){return this.vb.profiles.filter(w=>!w.isDefault&&!w.isTransient)}Eb(w){return JSON.stringify([...w].sort((d,I)=>d.name.localeCompare(I.name)))}};e.$bgc=g,e.$bgc=g=Ee([Y(2,b.$Rl),Y(3,k.$fl),Y(4,L.$Ri),Y(5,T.$oq),Y(6,m.$qob),Y(7,m.$rob),Y(8,m.$Fob),Y(9,a.$ej),Y(10,m.$Aob),Y(11,C.$em),Y(12,A.$Pl)],g);function l(E,w){const d=[...E].sort((I,$)=>I.name.localeCompare($.name)).map(I=>({id:I.id,name:I.name}));return w?(0,P.$co)(d,{}):JSON.stringify(d)}function f(E){return JSON.parse(E.content)}}),define(fe[230],de([0,1,3,2,5,15,16,18,24]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;const b="sync.enable";let R=class extends a.$Zc{constructor(m,g,l,f){super(),this.c=m,this.f=g,this.g=l,this.h=f,this.a=new P.$qe,this.onDidChangeEnablement=this.a.event,this.b=new P.$qe,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(T.StorageScope.APPLICATION,void 0,this.B(new a.$Yc))(E=>this.m(E)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,T.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:m}),this.c.store(b,m,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE))}isResourceEnabled(m){return this.c.getBoolean((0,A.$zob)(m),T.StorageScope.APPLICATION,!0)}setResourceEnablement(m,g){if(this.isResourceEnabled(m)!==g){const l=(0,A.$zob)(m);this.j(l,g)}}getResourceSyncStateVersion(m){}j(m,g){this.c.store(m,g,T.StorageScope.APPLICATION,L.$r?T.StorageTarget.USER:T.StorageTarget.MACHINE)}m(m){if(b===m.key){this.a.fire(this.isEnabled());return}const g=A.$mob.filter(l=>(0,A.$zob)(l)===m.key)[0];if(g){this.b.fire([g,this.isResourceEnabled(g)]);return}}};e.$1fc=R,e.$1fc=R=Ee([Y(0,T.$oq),Y(1,C.$em),Y(2,k.$Ri),Y(3,A.$pob)],R)}),define(fe[231],de([0,1,6,14,67,2,20,21,15,7,19,24]),function(ce,e,P,a,L,k,T,C,A,b,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;let m=class extends k.$Zc{constructor(l,f,E,w,d){super(),this.a=l,this.b=f,this.c=E,this.f=w,this.g=d,this.h()}async h(){for(const f of this.g.profiles)for(const E of p.$mob)try{await this.m(this.j(E,f.isDefault?void 0:f.id))}catch(w){this.f.error(w)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(f){(0,b.$wl)(f)!==b.FileOperationResult.FILE_NOT_FOUND&&this.f.error(f);return}if(l.children){for(const f of l.children)if(f.isDirectory&&!p.$mob.includes(f.name)&&!this.g.profiles.some(E=>E.id===f.name))try{this.f.info("Deleting non existing profile from backup",f.resource.path),await this.b.del(f.resource,{recursive:!0})}catch(E){this.f.error(E)}}}async getAllResourceRefs(l,f,E){const w=this.j(l,f,E);try{const d=await this.b.resolve(w);if(d.children)return d.children.filter($=>$.isFile&&!$.name.startsWith("lastSync")).sort().reverse().map($=>({ref:$.name,created:this.n($)}))}catch(d){if((0,b.$wl)(d)!==b.FileOperationResult.FILE_NOT_FOUND)throw d}return[]}async resolveResourceContent(l,f,E,w){const d=this.j(l,E,w),I=(0,T.$lh)(d,f);try{return(await this.b.readFile(I)).value.toString()}catch($){return this.f.error($),null}}async writeResource(l,f,E,w,d){const I=this.j(l,w,d),$=(0,T.$lh)(I,`${(0,L.$0m)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile($,a.$Se.fromString(f))}catch(c){this.f.error(c)}}j(l,f,E=this.a.userDataSyncHome){return(0,T.$lh)(E,...f?[f,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const f=await this.b.resolve(l);if(f.children){const E=f.children.filter($=>$.isFile&&/^\d{8}T\d{6}(\.json)?$/.test($.name)).sort(),w=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=E.filter($=>Date.now()-this.n($)>w);const I=E.length-d.length;I<10&&(d=d.slice(10-I)),await P.Promises.settled(d.map(async $=>{this.f.info("Deleting from backup",$.resource.path),await this.b.del($.resource)}))}}catch(f){this.f.error(f)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$_fc=m,e.$_fc=m=Ee([Y(0,A.$Ri),Y(1,b.$fl),Y(2,C.$ej),Y(3,p.$Fob),Y(4,R.$Rl)],m)}),define(fe[87],de([0,1,3,2,5,26,9,15,7,4,23,49,16,24]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$eob=e.$cob=void 0,e.$dob=c,e.$cob=(0,b.$Ki)("IUserDataSyncMachinesService");const f="sync.currentMachineName",E="Safari",w="Chrome",d="Edge",I="Firefox",$="Android";function c(n){switch(n){case E:case w:case d:case I:case $:case(0,L.$k)(L.Platform.Web):return!0}return!1}function h(){return L.$J?E:L.$H?w:L.$K?d:L.$I?I:L.$L?$:(0,L.$k)(L.$r?L.Platform.Web:L.$x)}let i=class extends a.$Zc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,s,r,o,u,y){super(),this.h=r,this.j=o,this.m=u,this.n=y,this.c=this.B(new P.$qe),this.onDidChange=this.c.event,this.g=null,this.f=(0,p.$uq)(t,s,r)}async getMachines(t){const s=await this.f;return(await this.s(t)).machines.map(o=>({...o,isCurrent:o.id===s}))}async addCurrentMachine(t){const s=await this.f,r=await this.s(t);r.machines.some(({id:o})=>o===s)||(r.machines.push({id:s,name:this.r(r.machines),platform:h()}),await this.t(r))}async removeCurrentMachine(t){const s=await this.f,r=await this.s(t),o=r.machines.filter(({id:u})=>u!==s);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(t,s,r){const o=await this.s(r),u=o.machines.find(({id:y})=>y===t);if(u){u.name=s,await this.t(o);const y=await this.f;t===y&&this.h.store(f,s,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE)}}async setEnablements(t){const s=await this.s();for(const[r,o]of t){const u=s.machines.find(y=>y.id===r);u&&(u.disabled=o?void 0:!0)}await this.t(s)}r(t){const s=this.h.get(f,m.StorageScope.APPLICATION);if(s)return s;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${h()} (${this.n.nameShort})`,o=new RegExp(`${(0,k.$mf)(r)}\\s#(\\d+)`);let u=0;for(const y of t){const O=o.exec(y.name),S=O?parseInt(O[1]):0;u=S>u?S:u}return`${r} #${u+1}`}async s(t){this.g=await this.u(t);const s=this.w(this.g);if(s.version!==l.a)throw new Error((0,T.localize)(2461,null,this.n.nameLong));return s}async t(t){const s=JSON.stringify(t),r=await this.j.writeResource(l.b,s,this.g?.ref||null);this.g={ref:r,content:s},this.c.fire()}async u(t){if(this.g){const s=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.m.error(s)}return{version:l.a,machines:[]}}};e.$eob=i,e.$eob=i=l=Ee([Y(0,C.$Ri),Y(1,A.$fl),Y(2,m.$oq),Y(3,g.$qob),Y(4,g.$Fob),Y(5,R.$yk)],i)}),define(fe[232],de([0,1,6,67,41,8,3,2,5,20,10,9,23,16,18,24,83,87]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;const d="sync.disableMachineEventually",I="sync.sessionId",$="sync.storeUrl",c="sync.productQuality";let h=class extends C.$Zc{get n(){const t=this.H.get($,g.StorageScope.APPLICATION);return t?R.URI.parse(t):void 0}set n(t){t?this.H.store($,t.toString(),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove($,g.StorageScope.APPLICATION)}get s(){return this.H.get(c,g.StorageScope.APPLICATION)}set s(t){t?this.H.store(c,t,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE):this.H.remove(c,g.StorageScope.APPLICATION)}constructor(t,s,r,o,u,y,O,S,v,N){super(),this.u=s,this.w=r,this.y=o,this.z=u,this.C=y,this.D=O,this.F=S,this.G=v,this.H=N,this.a=this.B(new C.$1c),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.$qe),this.onError=this.h.event,this.S=[],this.f=this.B(new P.$Ih(this.U())),this.j=this.n,this.n=s.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,b.$eh)(this.n,s.userDataSyncStore?.url)||(this.j=this.n,this.n=s.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(O.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(u.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(T.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:s}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.C.info(s),this.a.clear()):s&&this.y.isEnabled()&&this.C.info(s))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.$0m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,s,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(I,g.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),s)this.M(!1);else throw o}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const s=f.$vob.toUserDataSyncError(t);s instanceof f.$xob&&this.F.publicLog2("autosync/error",{code:s.code,service:this.u.userDataSyncStore.url.toString()}),s.code===f.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):s.code===f.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code===f.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):s.code===f.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code===f.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code===f.UserDataSyncErrorCode.UpgradeRequired||s.code===f.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code===f.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code===f.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code===f.UserDataSyncErrorCode.ServiceChanged||s.code===f.UserDataSyncErrorCode.DefaultServiceChanged?A.$r&&s.code===f.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(s),this.b++),this.h.fire(s)}async P(){this.H.store(d,!0,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await(0,P.$Lh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(d,g.StorageScope.APPLICATION,!1)}R(){this.H.remove(d,g.StorageScope.APPLICATION)}async triggerSync(t,s,r){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$fgc=h,e.$fgc=h=Ee([Y(0,m.$yk),Y(1,f.$pob),Y(2,f.$qob),Y(3,f.$Aob),Y(4,f.$Bob),Y(5,f.$Fob),Y(6,E.$cNb),Y(7,l.$em),Y(8,w.$cob),Y(9,g.$oq)],h);class i extends C.$Zc{static{this.a="Interval"}constructor(t,s,r,o,u,y,O,S,v){super(),this.m=t,this.n=s,this.r=r,this.s=o,this.u=u,this.w=y,this.y=O,this.z=S,this.C=v,this.b=this.B(new C.$1c),this.c=this.B(new T.$qe),this.onDidStartSync=this.c.event,this.f=this.B(new T.$qe),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,C.$Xc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,P.$Mh)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,s){const r=(0,P.$xh)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(u){if((0,k.$8)(u))return}return this.H(t,s,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,b.$eh)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),s=this.r.userDataSyncStore;return!!s&&!!t&&(!(0,b.$eh)(s.defaultUrl,t.defaultUrl)||!(0,b.$eh)(s.insidersUrl,t.insidersUrl)||!(0,b.$eh)(s.stableUrl,t.stableUrl))}async H(t,s,r){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let o;try{await this.I(s,r)}catch(u){if(this.y.error(u),o=u,f.$vob.toUserDataSyncError(u).code===f.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(s,r),o=void 0}catch(y){this.y.error(y),o=y}}this.f.fire(o)}async I(t,s){if(this.h=await this.u.createSyncTask(this.g,t),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new f.$xob((0,p.localize)(2448,null),f.UserDataSyncErrorCode.DefaultServiceChanged):new f.$xob((0,p.localize)(2449,null),f.UserDataSyncErrorCode.ServiceChanged):new f.$xob((0,p.localize)(2450,null),f.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(I,g.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new f.$xob((0,p.localize)(2451,null),f.UserDataSyncErrorCode.DefaultServiceChanged):new f.$xob((0,p.localize)(2452,null),f.UserDataSyncErrorCode.ServiceChanged):new f.$xob((0,p.localize)(2453,null),f.UserDataSyncErrorCode.SessionExpired);const o=await this.w.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const u=o.find(O=>O.isCurrent);if(u?.disabled)throw new f.$xob((0,p.localize)(2454,null),f.UserDataSyncErrorCode.TurnedOff);const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(O){throw new f.$xob((0,L.$vj)(O),O instanceof f.$vob?O.code:f.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(I,this.g.session,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),!s.isCancellationRequested&&(u||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(fe[233],de([0,1,10,9,15,7,49,16,28,24,19,40,125,124,123,21,126,121,122,4,127,45,26]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;let n=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(s,r,o,u,y,O,S,v,N,F){this.e=s,this.f=r,this.g=o,this.h=y,this.i=O,this.j=S,this.k=v,this.l=N,this.n=F,this.d=u.extUri}async getRemoteSyncedProfiles(){const s=await this.e.readResource(b.SyncResource.Profiles,null,void 0);if(s.content){const r=this.L(s.content,b.SyncResource.Profiles);return(0,$.$dgc)(r)}return[]}async getLocalSyncedProfiles(s){const r=await this.f.getAllResourceRefs(b.SyncResource.Profiles,void 0,s);if(r.length){const o=await this.f.resolveResourceContent(b.SyncResource.Profiles,r[0].ref,void 0,s);if(o){const u=this.L(o,b.SyncResource.Profiles);return(0,$.$dgc)(u)}}return[]}async getLocalSyncedMachines(s){const r=await this.f.getAllResourceRefs("machines",void 0,s);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,s);if(o)return JSON.parse(o).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(s,r){return(await this.e.getAllResourceRefs(s,r?.collection)).map(({created:u,ref:y})=>({created:u,uri:this.J({remote:!0,syncResource:s,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(s,r,o){return(await this.f.getAllResourceRefs(s,r?.collection,o)).map(({created:y,ref:O})=>({created:y,uri:this.J({remote:!1,syncResource:s,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:O,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:s}){const r=this.K(s),o=r?this.k.profiles.find(u=>u.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:s}){const r=this.K(s);if(!r)return[];const o=this.k.profiles.find(u=>u.id===r.profile);switch(r.syncResource){case b.SyncResource.Settings:return this.s(s,o);case b.SyncResource.Keybindings:return this.u(s,o);case b.SyncResource.Tasks:return this.w(s,o);case b.SyncResource.Snippets:return this.y(s,o);case b.SyncResource.GlobalState:return this.D(s,o);case b.SyncResource.Extensions:return this.A(s,o);case b.SyncResource.Profiles:return this.G(s,o);case b.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:s}){const r=this.K(s);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,T.$uq)(this.h,this.j,this.i)}}async resolveContent(s){const r=this.K(s);if(!r||r.node===i.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(s,r,o,u,y){if(s){const{content:O}=await this.M(r,u,o);return O}return this.f.resolveResourceContent(r,u,o,y)}q(s,r,o){const u=this.L(r,s);switch(s){case b.SyncResource.Settings:return this.t(u,o);case b.SyncResource.Keybindings:return this.v(u,o);case b.SyncResource.Tasks:return this.x(u,o);case b.SyncResource.Snippets:return this.z(u,o);case b.SyncResource.GlobalState:return this.E(u,o);case b.SyncResource.Extensions:return this.B(u,o);case b.SyncResource.Profiles:return this.H(u,o);case b.SyncResource.WorkspaceState:return null}}async r(s,r){const o=this.k.profiles.find(u=>u.id===r);if(!o)return null;switch(s){case b.SyncResource.GlobalState:return this.F(o);case b.SyncResource.Extensions:return this.C(o);case b.SyncResource.Profiles:return this.I(o);case b.SyncResource.Settings:return null;case b.SyncResource.Keybindings:return null;case b.SyncResource.Tasks:return null;case b.SyncResource.Snippets:return null;case b.SyncResource.WorkspaceState:return null}}s(s,r){const o=this.d.joinPath(s,"settings.json"),u=r?r.settingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}t(s,r){switch(r){case"settings.json":return(0,g.$jec)(s.content).settings}return null}u(s,r){const o=this.d.joinPath(s,"keybindings.json"),u=r?r.keybindingsResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}v(s,r){switch(r){case"keybindings.json":return(0,l.$gec)(s.content,!!this.l.getValue(b.$job),this.g)}return null}w(s,r){const o=this.d.joinPath(s,"tasks.json"),u=r?r.tasksResource:this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}x(s,r){switch(r){case"tasks.json":return(0,E.$rec)(s.content,this.g)}return null}async y(s,r){const o=await this.resolveContent(s);if(o){const u=this.L(o,b.SyncResource.Snippets);if(u){const y=(0,m.$oec)(u),O=[];for(const S of Object.keys(y)){const v=this.d.joinPath(s,S),N=r?this.d.joinPath(r.snippetsHome,S):this.d.joinPath(s,i.a);O.push({resource:v,comparableResource:N})}return O}}return[]}z(s,r){return(0,m.$oec)(s)[r]||null}A(s,r){const o=this.d.joinPath(s,"extensions.json"),u=r?this.J({remote:!1,syncResource:b.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}B(s,r){switch(r){case"extensions.json":return(0,w.$bec)((0,w.$aec)(s),!0)}return null}async C(s){const{localExtensions:r}=await this.n.createInstance(w.$dec).getLocalExtensions(s);return(0,w.$bec)(r,!0)}D(s,r){const o=this.d.joinPath(s,"globalState.json"),u=r?this.J({remote:!1,syncResource:b.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(s,i.a);return[{resource:o,comparableResource:u}]}E(s,r){switch(r){case"globalState.json":return(0,d.$VOb)(JSON.parse(s.content),!0)}return null}async F(s){const r=await this.n.createInstance(d.$XOb).getLocalGlobalState(s);return(0,d.$VOb)(r,!0)}G(s,r){const o=this.d.joinPath(s,"profiles.json"),u=this.J({remote:!1,syncResource:b.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:u}]}H(s,r){switch(r){case"profiles.json":return(0,c.$co)(JSON.parse(s.content),{})}return null}async I(s){return(0,$.$cgc)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(s){const r=s.remote?i.b:i.c,o=[];return s.location&&(o.push(`scheme:${s.location.scheme}`),o.push(`authority:${s.location.authority}`),o.push((0,h.$qf)(s.location.path,"/"))),o.push(`syncResource:${s.syncResource}`),o.push(`profile:${s.profile}`),s.collection&&o.push(`collection:${s.collection}`),s.ref&&o.push(`ref:${s.ref}`),s.node&&o.push(s.node),this.d.joinPath(P.URI.from({scheme:b.$Hob,authority:r,path:"/",query:s.location?.query,fragment:s.location?.fragment}),...o)}K(s){if(s.scheme!==b.$Hob)return;const r=[];for(;s.path!=="/";)r.unshift(this.d.basename(s)),s=this.d.dirname(s);if(r.length<2)return;const o=s.authority===i.b;let u,y;const O=[];let S,v,N,F,U;for(;r.length;){const j=r.shift();j.startsWith("scheme:")?u=j.substring(7):j.startsWith("authority:")?y=j.substring(10):j.startsWith("syncResource:")?S=j.substring(13):j.startsWith("profile:")?v=j.substring(8):j.startsWith("collection:")?N=j.substring(11):j.startsWith("ref:")?F=j.substring(4):S?U=j:O.push(j)}return{remote:o,syncResource:S,profile:v,collection:N,ref:F,node:U,location:u&&y!==void 0?this.d.joinPath(P.URI.from({scheme:u,authority:y,query:s.query,fragment:s.fragment,path:"/"}),...O):void 0}}L(s,r){try{const o=JSON.parse(s);if((0,p.$OOb)(o))return o}catch(o){this.g.error(o)}throw new b.$vob((0,a.localize)(2462,null),b.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(s,r,o){const u=await this.e.resolveResourceContent(s,r,o);return{ref:r,content:u}}};e.$Vgc=n,e.$Vgc=n=i=Ee([Y(0,b.$qob),Y(1,b.$rob),Y(2,b.$Fob),Y(3,A.$Pl),Y(4,L.$Ri),Y(5,C.$oq),Y(6,k.$fl),Y(7,R.$Rl),Y(8,f.$ej),Y(9,I.$Ji)],n)}),define(fe[234],de([0,1,17,6,25,41,3,2,20,12,32,21,27,7,4,16,18,19,121,122,123,124,125,126,127,24]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c,h,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;const s="sync.lastSyncTime";let r=class extends C.$Zc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,v,N,F,U,j,G,W,x,V,te){super(),this.C=S,this.D=v,this.F=N,this.G=F,this.H=U,this.I=j,this.J=G,this.L=W,this.M=x,this.N=V,this.O=te,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new T.$qe),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.$qe),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new T.$qe),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new T.$qe),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new T.$qe),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new T.$qe),this.onDidResetLocal=this.w.event,this.y=this.B(new T.$qe),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=N.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(s,f.StorageScope.APPLICATION,void 0),this.B((0,C.$Xc)(()=>this.cb())),this.B(new a.$Wh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(S,v){this.db(),this.H.info("Sync started.");const N=new Date().getTime(),F=(0,R.$7g)();try{const W=(0,t.$uob)(F);v&&(W["Cache-Control"]="no-cache"),S=await this.D.manifest(S,W)}catch(W){const x=t.$vob.toUserDataSyncError(W);throw y(x,F,this.F,this.I),x}const U=!1,j=this;let G;return{manifest:S,async run(){if(U)throw new Error("Can run a task only once");G=(0,a.$xh)(W=>j.P(S,!1,F,W)),await G.finally(()=>G=void 0),j.H.info(`Sync done. Took ${new Date().getTime()-N}ms`),j.ab()},stop(){return G?.cancel(),j.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$vob("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const S=new Date().getTime(),v=(0,R.$7g)(),N=(0,t.$uob)(v);let F;try{F=await this.D.manifest(null,N)}catch(G){const W=t.$vob.toUserDataSyncError(G);throw y(W,v,this.F,this.I),W}await this.resetLocal();const U=this,j=new L.$Be;return{id:v,async merge(){return U.P(F,!0,v,j.token)},async apply(){try{try{await U.R(F,v,j.token)}catch(G){if(t.$vob.toUserDataSyncError(G).code===t.UserDataSyncErrorCode.MethodNotFound)U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(F,v,j.token);else throw G}}catch(G){throw U.H.error(G),G}U.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),U.ab()},async stop(){j.cancel(),await U.U(),await U.resetLocal()}}}async P(S,v,N,F){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,S,v,N,F));const j=U.enabled.find(G=>G.resource===t.SyncResource.Profiles);if(j){const G=await j.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(G,S,v,N,F)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(S,v,N,F,U){for(const j of S){if(U.isCancellationRequested)return;const G=this.M.profiles.find(x=>x.id===j.id);if(!G){this.H.error(`Profile with id:${j.id} and name: ${j.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",j.name);const W=this.getOrCreateActiveProfileSynchronizer(G,j);this.n.push(...await this.S(W,v,N,F,U))}for(const[j,G]of this.z.entries())this.M.profiles.some(W=>W.id===G[0].profile.id)||(await G[0].resetLocal(),G[1].dispose(),this.z.delete(j))}async R(S,v,N){const F=this.bb();for(const x of F){if(N.isCancellationRequested)return;await x.apply(v,N)}const U=F.find(x=>x.profile.isDefault);if(!U)return;const j=U.enabled.find(x=>x.resource===t.SyncResource.Profiles);if(!j)return;const W=(await j.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(x=>F.every(V=>V.profile.id!==x.id));W.length&&await this.Q(W,S,!1,v,N)}async S(S,v,N,F,U){return(await S.sync(v,N,F,U)).map(([G,W])=>({profile:S.profile,syncResource:G,error:W}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(S=>S.stop()))}async resolveContent(S){const v=await this.N.resolveContent(S);if(v)return v;for(const N of this.bb())for(const F of N.enabled){const U=await F.resolveContent(S);if(U)return U}return null}async replace(S){this.db();const v=this.N.resolveUserDataSyncResource(S);if(!v)return;const N=await this.resolveContent(S.uri);N&&await this.X(v.profile,async F=>{if(v.syncResource===F.resource)return await F.replace(N),!0})}async accept(S,v,N,F){this.db(),await this.X(S.profile,async U=>{if(S.syncResource===U.resource)return await U.accept(v,N),F&&await U.apply((0,b.$pg)(F)?!1:F.force,(0,t.$uob)((0,R.$7g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==t.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(s,f.StorageScope.APPLICATION);for(const[S]of this.z.values())try{await S.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const S=this.J.keys(f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),v=[];for(const F of S){if(!F.endsWith(".lastSyncUserData"))continue;const U=F.split(".");U.length===3&&v.push([F,U[0]])}if(!v.length)return;const N=new C.$Yc;try{let F=this.z.get(this.M.defaultProfile.id)?.[0];F||(F=N.add(this.G.createInstance(o,this.M.defaultProfile,void 0)));const U=F.enabled.find(W=>W.resource===t.SyncResource.Profiles);if(!U)return;const G=(await U.getLastSyncedProfiles())?.map(W=>W.collection)??[];for(const[W,x]of v)G.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(W,f.StorageScope.APPLICATION))}finally{N.dispose()}}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),v=S.map(j=>j.collection),N=await this.D.getAllCollections(),F=N.filter(j=>!v.includes(j));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(j=>this.D.deleteCollection(j))),this.H.info("Deleted redundant collections on server"));const U=S.filter(j=>N.includes(j.collection));if(U.length!==S.length){const j=this.G.createInstance(n.$bgc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await j.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await j.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{j.dispose()}}}async saveRemoteActivityData(S){this.db();const v=await this.D.getActivityData();await this.C.writeFile(S,v)}async extractActivityData(S,v){const N=(await this.C.readFile(S)).value.toString(),F=JSON.parse(N);if(F.resources)for(const U in F.resources)for(const j of F.resources[U])await this.O.writeResource(U,j.content,new Date(j.created*1e3),void 0,v);if(F.collections)for(const U in F.collections)for(const j in F.collections[U].resources)for(const G of F.collections[U].resources?.[j]??[])await this.O.writeResource(j,G.content,new Date(G.created*1e3),U,v)}async X(S,v){const N=new C.$Yc;try{const F=this.z.get(S.id);if(F){const x=await this.Y(F[0],v,N);return(0,b.$qg)(x)?null:x}if(S.isDefault){const x=N.add(this.G.createInstance(o,S,void 0)),V=await this.Y(x,v,N);return(0,b.$qg)(V)?null:V}if(this.M.isEnabled())return null;const U=N.add(this.G.createInstance(n.$bgc,S,void 0)),j=await this.D.manifest(null),W=(await U.getRemoteSyncedProfiles(j?.latest??null)||[]).find(x=>x.id===S.id);if(W){const x=N.add(this.G.createInstance(o,S,W.collection)),V=await this.Y(x,v,N);return(0,b.$qg)(V)?null:V}return null}finally{N.dispose()}}async Y(S,v,N){const F=[...S.enabled,...S.disabled.reduce((U,j)=>(j!==t.SyncResource.WorkspaceState&&U.push(N.add(S.createSynchronizer(j))),U),[])];for(const U of F){const j=await v(U);if(!(0,b.$qg)(j))return j}}Z(S){const v=this.f;this.f!==S&&(this.f=S,this.g.fire(S),v===t.SyncStatus.HasConflicts&&this.ab())}$(){const S=this.bb().map(v=>v.conflicts).flat();(0,P.$yb)(this.j,S,(v,N)=>v.profile.id===N.profile.id&&v.syncResource===N.syncResource&&(0,P.$yb)(v.conflicts,N.conflicts,(F,U)=>(0,A.$eh)(F.previewResource,U.previewResource)))||(this.j=S,this.m.fire(S))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(s,this.t,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,v){let N=this.z.get(S.id);if(N&&N[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.z.delete(S.id)),!N){const F=new C.$Yc,U=F.add(this.G.createInstance(o,S,v?.collection));F.add(U.onDidChangeStatus(j=>this.Z(j))),F.add(U.onDidChangeConflicts(j=>this.$())),F.add(U.onDidChangeLocal(j=>this.h.fire(j))),this.z.set(S.id,N=[U,F])}return N[0]}bb(){const S=[];for(const[v]of this.z.values())S.push(v);return S}cb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$egc=r,e.$egc=r=Ee([Y(0,g.$fl),Y(1,t.$qob),Y(2,t.$pob),Y(3,l.$Ji),Y(4,t.$Fob),Y(5,E.$em),Y(6,f.$oq),Y(7,t.$Aob),Y(8,w.$Rl),Y(9,t.$Cob),Y(10,t.$rob)],r);let o=class extends C.$Zc{get enabled(){return this.f.sort((S,v)=>S[1]-v[1]).map(([S])=>S)}get disabled(){return t.$mob.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,v,N,F,U,j,G,W,x,V){super(),this.profile=S,this.collection=v,this.r=N,this.t=F,this.u=U,this.w=j,this.y=G,this.z=W,this.C=x,this.D=V,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new T.$qe),this.onDidChangeStatus=this.h.event,this.j=this.B(new T.$qe),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new T.$qe),this.onDidChangeConflicts=this.n.event,this.B(N.onDidChangeResourceEnablement(([te,B])=>this.F(te,B))),this.B((0,C.$Xc)(()=>this.f.splice(0,this.f.length).forEach(([,,te])=>te.dispose())));for(const te of t.$mob)N.isResourceEnabled(te)&&this.G(te)}F(S,v){v?this.G(S):this.H(S)}G(S){if(this.f.some(([U])=>U.resource===S))return;if(S===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||S===t.SyncResource.WorkspaceState)return;if(S!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const v=new C.$Yc,N=v.add(this.createSynchronizer(S));v.add(N.onDidChangeStatus(()=>this.L())),v.add(N.onDidChangeConflicts(()=>this.M())),v.add(N.onDidChangeLocal(()=>this.j.fire(S)));const F=this.N(S);this.f.push([N,F,v])}H(S){const v=this.f.findIndex(([N])=>N.resource===S);if(v!==-1){const[[N,,F]]=this.f.splice(v,1);F.dispose(),this.L(),N.stop().then(null,U=>this.z.error(U))}}createSynchronizer(S){switch(S){case t.SyncResource.Settings:return this.t.createInstance(c.$kec,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance($.$hec,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(h.$pec,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$sec,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(I.$WOb,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(d.$cec,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(n.$bgc,this.profile,this.collection)}}async sync(S,v,N,F){if(F.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const j=[],G=(0,t.$uob)(N),W=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,x=v?await this.I(W):{};for(const V of U){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(V.resource))return[];try{if(v){const te=await V.preview(W,x,G);if(te)for(const B of te.resourcePreviews)(B.localChange!==t.Change.None||B.remoteChange!==t.Change.None)&&B.mergeState===t.MergeState.Preview&&await V.merge(B.previewResource)}else await V.sync(W,G)}catch(te){const B=t.$vob.toUserDataSyncError(te);if(y(B,N,this.w,this.y),u(te))throw B;this.z.error(te),this.z.error(`${V.resource}: ${(0,k.$vj)(te)}`),j.push([V.resource,B])}}return j}finally{this.L()}}async apply(S,v){const N=(0,t.$uob)(S);for(const F of this.enabled){if(v.isCancellationRequested)return;try{await F.apply(!1,N)}catch(U){const j=t.$vob.toUserDataSyncError(U);if(y(j,S,this.w,this.y),u(U))throw j;this.z.error(U),this.z.error(`${F.resource}: ${(0,k.$vj)(U)}`)}}}async stop(){for(const S of this.enabled)try{S.status!==t.SyncStatus.Idle&&await S.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(v){this.z.error(`${S.resource}: ${(0,k.$vj)(v)}`),this.z.error(v)}}async I(S){if(!this.profile.isDefault)return{};const v=this.D.getValue(t.$iob),N=this.enabled.find(F=>F instanceof c.$kec);if(N){const F=await N.getRemoteUserDataSyncConfiguration(S);return{...v,...F}}return v}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(S=>S.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const S=this.enabled.filter(v=>v.status===t.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,P.$yb)(this.m,S,(v,N)=>v.syncResource===N.syncResource&&(0,P.$yb)(v.conflicts,N.conflicts,(F,U)=>(0,A.$eh)(F.previewResource,U.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};o=Ee([Y(2,t.$Aob),Y(3,l.$Ji),Y(4,m.$rp),Y(5,t.$pob),Y(6,E.$em),Y(7,t.$Fob),Y(8,w.$Rl),Y(9,p.$ej)],o);function u(O){if(O instanceof t.$vob)switch(O.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function y(O,S,v,N){N.publicLog2("sync/error",{code:O.code,serverCode:O instanceof t.$wob?String(O.serverCode):void 0,url:O instanceof t.$wob?O.url:void 0,resource:O.resource,executionId:S,service:v.userDataSyncStore.url.toString()})}}),define(fe[235],de([0,1,3,2,10,19,24]),function(ce,e,P,a,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=e.$Cjc=void 0;function C(m,g){return{...m,profile:(0,k.$Sl)(m.profile,g.profilesHome.scheme)}}function A(m){return{created:m.created,uri:L.URI.revive(m.uri)}}class b{constructor(g,l,f){this.c=g,this.d=l,this.f=f,this.a=new Map,this.b=new P.$qe}listen(g,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call(g,l,f){try{return await this.g(g,l,f)}catch(E){throw this.f.error(E),E}}async g(g,l,f){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(f[0]));case"accept":return this.c.accept(C(f[0],this.d),L.URI.revive(f[1]),f[2],f[3]);case"replace":return this.c.replace(A(f[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(f[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(f[0]),L.URI.revive(f[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const E=l.substring(11),w=f[0],d=this.h(w);switch(f=f.slice(1),E){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(g){const l=this.a.get(this.j(g));if(!l)throw new Error(`Manual sync taks not found: ${g}`);return l}async i(){const g=await this.c.createManualSyncTask();return this.a.set(this.j(g.id),g),g.id}j(g){return`manualSyncTask-${g}`}}e.$Cjc=b;let R=class extends a.$Zc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(g,l){super(),this.n=l,this.b=T.SyncStatus.Uninitialized,this.c=this.B(new P.$qe),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new P.$qe),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new P.$qe),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new P.$qe),this.onSyncErrors=this.m.event,this.a={call(f,E,w){return g.call(f,E,w).then(null,d=>{throw T.$vob.toUserDataSyncError(d)})},listen(f,E){return g.listen(f,E)}},this.a.call("_getInitialData").then(([f,E,w])=>{this.s(f),this.t(E),w&&this.u(w),this.B(this.a.listen("onDidChangeStatus")(d=>this.s(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.u(d)))}),this.B(this.a.listen("onDidChangeConflicts")(f=>this.t(f))),this.B(this.a.listen("onSyncErrors")(f=>this.m.fire(f.map(E=>({...E,error:T.$vob.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const g=await this.a.call("createManualSyncTask"),l=this;return new p(g,{async call(E,w,d){return l.a.call(`manualSync/${E}`,[g,...Array.isArray(w)?w:[w]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(g,l,f,E){return this.a.call("accept",[g,l,f,E])}resolveContent(g){return this.a.call("resolveContent",[g])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(g){return this.a.call("replace",[g])}saveRemoteActivityData(g){return this.a.call("getRemoteActivityData",[g])}extractActivityData(g,l){return this.a.call("extractActivityData",[g,l])}async s(g){this.b=g,this.c.fire(g)}async t(g){this.f=g.map(l=>({syncResource:l.syncResource,profile:(0,k.$Sl)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(f=>({...f,baseResource:L.URI.revive(f.baseResource),localResource:L.URI.revive(f.localResource),remoteResource:L.URI.revive(f.remoteResource),previewResource:L.URI.revive(f.previewResource)}))})),this.g.fire(this.f)}u(g){this.h!==g&&(this.h=g,this.j.fire(g))}};e.$Djc=R,e.$Djc=R=Ee([Y(1,k.$Rl)],R);class p extends a.$Zc{constructor(g,l){super(),this.id=g,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(fe[128],de([0,1,6,25,8,3,2,146,5,20,12,10,32,21,15,7,23,61,49,16,24]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MOb=e.$LOb=e.$KOb=e.$JOb=e.$IOb=void 0;const c="configurationSync.store",h="sync.previous.store",i="sync.donot-make-requests-until",n="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let o=class extends T.$Zc{get userDataSyncStore(){return this.b}get c(){return this.h.get($.$yob,I.StorageScope.APPLICATION)}set c(N){this.h.store($.$yob,N,I.StorageScope.APPLICATION,A.$r?I.StorageTarget.USER:I.StorageTarget.MACHINE)}constructor(N,F,U){super(),this.f=N,this.g=F,this.h=U,this.a=this.B(new k.$qe),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const j=this.B(new T.$Yc);this.B(k.Event.filter(U.onDidChangeValue(I.StorageScope.APPLICATION,$.$yob,j),()=>this.c!==this.userDataSyncStore?.type,j)(()=>this.j()))}j(){this.b=this.m(this.f[c]),this.a.fire()}m(N){if(N&&(N=A.$r&&N.web?{...N,...N.web}:N,(0,R.$jg)(N.url)&&(0,R.$lg)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(F=>Array.isArray(N.authenticationProviders[F].scopes)))){const F=N,U=!!F.canSwitch,j=F.url===F.insidersUrl?"insiders":"stable",G=(U?this.c:void 0)||j,W=G==="insiders"?F.insidersUrl:G==="stable"?F.stableUrl:F.url;return{url:p.URI.parse(W),type:G,defaultType:j,defaultUrl:p.URI.parse(F.url),stableUrl:p.URI.parse(F.stableUrl),insidersUrl:p.URI.parse(F.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,V)=>(x.push({id:V,scopes:F.authenticationProviders[V].scopes}),x),[])}}}};e.$IOb=o,e.$IOb=o=Ee([Y(0,E.$yk),Y(1,g.$ej),Y(2,I.$oq)],o);let u=class extends o{constructor(N,F,U){super(N,F,U);const j=this.h.get(h,I.StorageScope.APPLICATION);j&&(this.n=JSON.parse(j));const G=this.f[c];G?this.h.store(h,JSON.stringify(G),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE):this.h.remove(h,I.StorageScope.APPLICATION)}async switch(N){N!==this.c&&(this.c=N,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$JOb=u,e.$JOb=u=Ee([Y(0,E.$yk),Y(1,g.$ej),Y(2,I.$oq)],u);let y=class extends T.$Zc{get donotMakeRequestsUntil(){return this.j}constructor(N,F,U,j,G,W,x){super(),this.n=U,this.r=j,this.s=x,this.g=this.B(new k.$qe),this.onTokenFailed=this.g.event,this.h=this.B(new k.$qe),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new k.$qe),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(N),this.c=(0,d.$uq)(G,W,x).then(V=>{const te={"X-Client-Name":`${F.applicationName}${A.$r?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(te["X-Client-Commit"]=F.commit),te}),this.f=new S(s,r,this.n,this.r),this.u(),this.B((0,T.$Xc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}t(N){this.a=N?(0,b.$lh)(N,"v1"):void 0}u(){const N=this.s.getNumber(i,I.StorageScope.APPLICATION);N&&Date.now()<N&&this.y(new Date(N))}y(N){this.j?.getTime()!==N?.getTime()&&(this.j=N,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),this.w=(0,P.$xh)(F=>(0,P.$Lh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(i,I.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$lh)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const U=await this.D(F,{type:"GET",headers:N},[],a.CancellationToken.None);return(await(0,w.$hq)(U))?.map(({id:j})=>j)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$lh)(this.a,"collection").toString();N={...N},N["Content-Type"]=C.$gt.text;const U=await this.D(F,{type:"POST",headers:N},[],a.CancellationToken.None),j=await(0,w.$gq)(U);if(!j)throw new $.$wob("Server did not return the collection id",F,$.UserDataSyncErrorCode.NoCollection,U.res.statusCode,U.res.headers[$.$sob]);return j}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=N?(0,b.$lh)(this.a,"collection",N).toString():(0,b.$lh)(this.a,"collection").toString();F={...F},await this.D(U,{type:"DELETE",headers:F},[],a.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,F,N),j={},G=await this.D(U.toString(),{type:"GET",headers:j},[],a.CancellationToken.None);return(await(0,w.$hq)(G)||[]).map(({url:x,created:V})=>({ref:(0,b.$nh)(U,U.with({path:x})),created:V*1e3}))}async resolveResourceContent(N,F,U,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,b.$lh)(this.z(this.a,U,N),F).toString();j={...j},j["Cache-Control"]="no-cache";const W=await this.D(G,{type:"GET",headers:j},[],a.CancellationToken.None);return await(0,w.$gq)(W)}async deleteResource(N,F,U){if(!this.a)throw new Error("No settings sync store url configured.");const j=F!==null?(0,b.$lh)(this.z(this.a,U,N),F).toString():this.z(this.a,U,N).toString(),G={};await this.D(j,{type:"DELETE",headers:G},[],a.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,b.$lh)(this.a,"resource").toString(),F={"Content-Type":C.$gt.text};await this.D(N,{type:"DELETE",headers:F},[],a.CancellationToken.None)}async readResource(N,F,U,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=(0,b.$lh)(this.z(this.a,U,N),"latest").toString();j={...j},j["Cache-Control"]="no-cache",F&&(j["If-None-Match"]=F.ref);const W=await this.D(G,{type:"GET",headers:j},[304],a.CancellationToken.None);let x=null;if(W.res.statusCode===304&&(x=F),x===null){const V=W.res.headers.etag;if(!V)throw new $.$wob("Server did not return the ref",G,$.UserDataSyncErrorCode.NoRef,W.res.statusCode,W.res.headers[$.$sob]);const te=await(0,w.$gq)(W);if(!te&&W.res.statusCode===304)throw new $.$wob("Empty response",G,$.UserDataSyncErrorCode.EmptyResponse,W.res.statusCode,W.res.headers[$.$sob]);x={ref:V,content:te}}return x}async writeResource(N,F,U,j,G={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.z(this.a,j,N).toString();G={...G},G["Content-Type"]=C.$gt.text,U&&(G["If-Match"]=U);const x=await this.D(W,{type:"POST",data:F,headers:G},[],a.CancellationToken.None),V=x.res.headers.etag;if(!V)throw new $.$wob("Server did not return the ref",W,$.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[$.$sob]);return V}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$lh)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const j=await this.D(U,{type:"GET",headers:F},[304],a.CancellationToken.None);let G=null;if(j.res.statusCode===304&&(G=N),!G){const x=j.res.headers.etag;if(!x)throw new $.$wob("Server did not return the ref",U,$.UserDataSyncErrorCode.NoRef,j.res.statusCode,j.res.headers[$.$sob]);const V=await(0,w.$gq)(j);if(!V&&j.res.statusCode===304)throw new $.$wob("Empty response",U,$.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[$.$sob]);V&&(G={...JSON.parse(V),ref:x})}const W=this.s.get(n,I.StorageScope.APPLICATION);return W&&G&&W!==G.session&&this.C(),G===null&&W&&this.C(),G&&this.s.store(n,G.session,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),G}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,b.$lh)(this.a,"download").toString(),F={},U=await this.D(N,{type:"GET",headers:F},[],a.CancellationToken.None);if(!(0,w.$dq)(U))throw new $.$wob("Server returned "+U.res.statusCode,N,$.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[$.$sob]);if((0,w.$eq)(U))throw new $.$wob("Empty response",N,$.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[$.$sob]);return U.stream}z(N,F,U){return F?(0,b.$lh)(N,"collection",F,"resource",U):(0,b.$lh)(N,"resource",U)}C(){this.s.remove(n,I.StorageScope.APPLICATION),this.s.remove(t,I.StorageScope.APPLICATION)}async D(N,F,U,j){if(!this.b)throw new $.$wob("No Auth Token Available",N,$.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new $.$wob(`${F.type} request '${N}' failed because of too many requests (429).`,N,$.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const G=await this.c;F.headers={...F.headers||{},...G,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let W;try{W=await this.f.request(N,F,j)}catch(H){if(!(H instanceof $.$wob)){let _=$.UserDataSyncErrorCode.RequestFailed;const ne=(0,L.$bb)(H).toLowerCase();ne.includes("xhr timeout")?_=$.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?_=$.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?_=$.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?_=$.UserDataSyncErrorCode.RequestHeadersNotObject:(0,L.$8)(H)&&(_=$.UserDataSyncErrorCode.RequestCanceled),H=new $.$wob(`Connection refused for the request '${N}'.`,N,_,void 0,void 0)}throw this.r.info("Request failed",N),H}const x=W.res.headers[$.$sob],V={url:N,status:W.res.statusCode,"execution-id":F.headers[$.$tob],"operation-id":x},te=(0,w.$dq)(W)||W.res.statusCode&&U.includes(W.res.statusCode);let B="";if(te?this.r.trace("Request succeeded",V):(B=await(0,w.$fq)(W)||"",this.r.info("Request failed",V,B)),W.res.statusCode===401||W.res.statusCode===403){if(this.b=void 0,W.res.statusCode===401)throw this.g.fire($.UserDataSyncErrorCode.Unauthorized),new $.$wob(`${F.type} request '${N}' failed because of Unauthorized (401).`,N,$.UserDataSyncErrorCode.Unauthorized,W.res.statusCode,x);if(W.res.statusCode===403)throw this.g.fire($.UserDataSyncErrorCode.Forbidden),new $.$wob(`${F.type} request '${N}' failed because the access is forbidden (403).`,N,$.UserDataSyncErrorCode.Forbidden,W.res.statusCode,x)}if(this.h.fire(),W.res.statusCode===404)throw new $.$wob(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,$.UserDataSyncErrorCode.NotFound,W.res.statusCode,x);if(W.res.statusCode===405)throw new $.$wob(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${B}`,N,$.UserDataSyncErrorCode.MethodNotFound,W.res.statusCode,x);if(W.res.statusCode===409)throw new $.$wob(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,$.UserDataSyncErrorCode.Conflict,W.res.statusCode,x);if(W.res.statusCode===410)throw new $.$wob(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,$.UserDataSyncErrorCode.Gone,W.res.statusCode,x);if(W.res.statusCode===412)throw new $.$wob(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,$.UserDataSyncErrorCode.PreconditionFailed,W.res.statusCode,x);if(W.res.statusCode===413)throw new $.$wob(`${F.type} request '${N}' failed because of too large payload (413).`,N,$.UserDataSyncErrorCode.TooLarge,W.res.statusCode,x);if(W.res.statusCode===426)throw new $.$wob(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,$.UserDataSyncErrorCode.UpgradeRequired,W.res.statusCode,x);if(W.res.statusCode===429){const H=W.res.headers["retry-after"];throw H?(this.y(new Date(Date.now()+parseInt(H)*1e3)),new $.$wob(`${F.type} request '${N}' failed because of too many requests (429).`,N,$.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W.res.statusCode,x)):new $.$wob(`${F.type} request '${N}' failed because of too many requests (429).`,N,$.UserDataSyncErrorCode.TooManyRequests,W.res.statusCode,x)}if(!te)throw new $.$wob("Server returned "+W.res.statusCode,N,$.UserDataSyncErrorCode.Unknown,W.res.statusCode,x);return W}F(N){let F=this.s.get(t,I.StorageScope.APPLICATION);F===void 0&&(F=(0,m.$7g)(),this.s.store(t,F,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE)),N["X-Machine-Session-Id"]=F;const U=this.s.get(n,I.StorageScope.APPLICATION);U!==void 0&&(N["X-User-Session-Id"]=U)}};e.$KOb=y,e.$KOb=y=Ee([Y(1,E.$yk),Y(2,w.$bq),Y(3,$.$Fob),Y(4,l.$Ri),Y(5,f.$fl),Y(6,I.$oq)],y);let O=class extends y{constructor(N,F,U,j,G,W,x){super(N.userDataSyncStore?.url,F,U,j,G,W,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.t(N.userDataSyncStore?.url)))}};e.$LOb=O,e.$LOb=O=Ee([Y(0,$.$pob),Y(1,E.$yk),Y(2,w.$bq),Y(3,$.$Fob),Y(4,l.$Ri),Y(5,f.$fl),Y(6,I.$oq)],O);class S{constructor(N,F,U,j){this.c=N,this.d=F,this.f=U,this.g=j,this.a=[],this.b=void 0}request(N,F,U){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new $.$wob(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,$.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$MOb=S}),define(fe[236],de([0,1,3,2,10,21,23,16,128]),function(ce,e,P,a,L,k,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=e.$Ajc=e.$zjc=e.$yjc=void 0;class b{constructor(l){this.a=l}listen(l,f){switch(f){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${f}`)}call(l,f,E){switch(f){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(E)}throw new Error("Invalid call")}}e.$yjc=b;class R extends a.$Zc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new P.$qe),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(f=>{this.a=f,this.B(this.c.listen("onDidChangeAccount")(E=>{this.a=E,this.b.fire(E)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$zjc=R;class p{constructor(l){this.a=l}listen(l,f){switch(f){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${f}`)}call(l,f,E){switch(f){case"switch":return this.a.switch(E[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Ajc=p;let m=class extends A.$IOb{constructor(l,f,E,w){super(f,E,w),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:L.URI.revive(l.url),type:l.type,defaultUrl:L.URI.revive(l.defaultUrl),insidersUrl:L.URI.revive(l.insidersUrl),stableUrl:L.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$Bjc=m,e.$Bjc=m=Ee([Y(1,T.$yk),Y(2,k.$ej),Y(3,C.$oq)],m)}),define(fe[237],de([0,1,3,57,23,16,18,232,24,83,87]),function(ce,e,P,a,L,k,T,C,A,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=void 0;let p=class extends C.$fgc{constructor(g,l,f,E,w,d,I,$,c,h,i){super(g,l,f,E,w,I,$,c,h,i),this.B(P.Event.debounce(P.Event.any(P.Event.map(d.onDidFocusMainWindow,()=>"windowFocus"),P.Event.map(d.onDidOpenMainWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$Xjc=p,e.$Xjc=p=Ee([Y(0,L.$yk),Y(1,A.$pob),Y(2,A.$qob),Y(3,A.$Aob),Y(4,A.$Bob),Y(5,a.$Thc),Y(6,A.$Fob),Y(7,b.$cNb),Y(8,T.$em),Y(9,R.$cob),Y(10,k.$oq)],p)}),define(fe[238],de([0,1,76,22,5,20]),function(ce,e,P,a,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0,e.$hhc=T,e.$ihc=C,e.$jhc=A,e.$ghc=128/4;function T(b){function R(){let p=b.scheme===a.Schemas.file?(0,k.$_g)(b):b.toString();return L.$n||(p=p.toLowerCase()),(0,P.createHash)("md5").update(p).digest("hex")}return{id:R(),configPath:b}}function C(b,R){function p(){if(b.scheme!==a.Schemas.file)return(0,P.createHash)("md5").update(b.toString()).digest("hex");if(!R)return;let g;return L.$n?g=R.ino:L.$m?g=R.birthtime.getTime():L.$l&&(typeof R.birthtimeMs=="number"?g=Math.floor(R.birthtimeMs):g=R.birthtime.getTime()),(0,P.createHash)("md5").update(b.fsPath).update(g?String(g):"").digest("hex")}const m=p();if(typeof m=="string")return{id:m,uri:b}}function A(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(fe[239],de([0,1,6,8,2,13,30,15,11,80,117,238,57,56,22]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=void 0;let f=class extends L.$Zc{constructor(w,d,I,$){super(),this.a=w,this.b=d,this.c=I,this.f=$,this.B(new P.$Wh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const w=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,d=await T.Promises.readdir(w),I=new b.$NNb(this.f.getChannel("storage"));await Promise.all(d.map(async $=>{const c=(0,k.$oc)(w,$);$.length===p.$ghc||$===R.$Wi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===$)||await I.isUsed(c)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${$} as it seems to be an unused empty workspace.`),await T.Promises.rm(c))}))}catch(w){(0,a.$4)(w)}}};e.$ujc=f,e.$ujc=f=Ee([Y(0,C.$Si),Y(1,A.$fk),Y(2,m.$Thc),Y(3,g.$_ic)],f)}),define(fe[129],de([0,1,76,66,38,247,14,8,3,2,13,5,32,43,72]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Bi=e.$Ai=e.$zi=void 0,e.$Ci=t,e.$Di=s,e.$Fi=u,e.$Gi=y;const f=3e4;class E{traceSocketEvent(S,v){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,S,v)}constructor(S,v=""){this.f=!0,this.debugLabel=v,this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,C.$4)(F)}},this.socket.on("error",this.a);let N;this.b=F=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:F}),this.f=!1,N&&clearTimeout(N)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,N=setTimeout(()=>S.destroy(),f)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(S){const v=N=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,N),S(T.$Se.wrap(N))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(S){const v=N=>{S({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:N,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(S){const v=()=>{S()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(S){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,S),this.socket.write(S.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,C.$4)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,C.$4)(v)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((S,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),S()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.$zi=E;var w;(function(O){O[O.MinHeaderByteSize=2]="MinHeaderByteSize",O[O.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var d;(function(O){O[O.PeekHeader=1]="PeekHeader",O[O.ReadHeader=2]="ReadHeader",O[O.ReadBody=3]="ReadBody",O[O.Fin=4]="Fin"})(d||(d={}));class I extends b.$Zc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(S,v){this.socket.traceSocketEvent(S,v)}constructor(S,v,N,F){super(),this.f=this.B(new A.$qe),this.g=this.B(new A.$qe),this.h=!1,this.j={state:d.PeekHeader,readLen:w.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=S,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:N?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new $(this,v,N,F,this.f,(U,j)=>this.m(U,j))),this.B(this.a.onError(U=>{console.error(U),(0,C.$4)(U),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:U})})),this.b=new l.$ui,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this.f.event(S)}onClose(S){return this.g.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){let v=0;for(;v<S.byteLength;)this.a.writeMessage(S.slice(v,Math.min(v+w.MaxWebSocketMessageLength,S.byteLength)),{compressed:!0,opcode:2}),v+=w.MaxWebSocketMessageLength}m(S,{compressed:v,opcode:N}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,S);let F=w.MinHeaderByteSize;S.byteLength<126?F+=0:S.byteLength<2**16?F+=2:F+=8;const U=T.$Se.alloc(F),j=v?64:0,G=N&15;if(U.writeUInt8(128|j|G,0),S.byteLength<126)U.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){U.writeUInt8(126,1);let W=1;U.writeUInt8(S.byteLength>>>8&255,++W),U.writeUInt8(S.byteLength>>>0&255,++W)}else{U.writeUInt8(127,1);let W=1;U.writeUInt8(0,++W),U.writeUInt8(0,++W),U.writeUInt8(0,++W),U.writeUInt8(0,++W),U.writeUInt8(S.byteLength>>>24&255,++W),U.writeUInt8(S.byteLength>>>16&255,++W),U.writeUInt8(S.byteLength>>>8&255,++W),U.writeUInt8(S.byteLength>>>0&255,++W)}this.socket.write(T.$Se.concat([U,S]))}end(){this.h=!0,this.socket.end()}n(S){if(S.byteLength!==0){for(this.b.acceptChunk(S);this.b.byteLength>=this.j.readLen;)if(this.j.state===d.PeekHeader){const v=this.b.peek(this.j.readLen),N=v.readUInt8(0),F=(N&128)>>>7,U=(N&64)>>>6,j=N&15,G=v.readUInt8(1),W=(G&128)>>>7,x=G&127;this.j.state=d.ReadHeader,this.j.readLen=w.MinHeaderByteSize+(W?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===d.ReadHeader){const v=this.b.read(this.j.readLen),N=v.readUInt8(1),F=(N&128)>>>7;let U=N&127,j=1;U===126?U=v.readUInt8(++j)*2**8+v.readUInt8(++j):U===127&&(U=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let G=0;F&&(G=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=d.ReadBody,this.j.readLen=U,this.j.mask=G,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===d.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),i(v,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=d.PeekHeader,this.j.readLen=w.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$Ai=I;class $ extends b.$Zc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Se.alloc(0)}constructor(S,v,N,F,U,j){super(),this.n=S,this.r=U,this.s=j,this.a=this.B(new A.$qe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new A.$qe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new A.$qe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new c(this.n,F,N,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(S,v){this.g.push({data:S,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:S,options:v}=this.g.shift();if(this.f&&v.compressed){const N=await this.w(this.f,S);this.s(N,v)}else this.s(S,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(S,v){return new Promise((N,F)=>{S.write(v),S.flush(U=>N(U))})}acceptFrame(S,v,N){this.h.push({data:S,isCompressed:v,isLastFrameOfMessage:N}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const S=this.h.shift();if(this.b&&S.isCompressed){const v=await this.C(this.b,S.data,S.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(S.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(S,v,N){return new Promise((F,U)=>{S.write(v),N&&S.write(T.$Se.fromByteArray([0,0,255,255])),S.flush(j=>F(j))})}}class c extends b.$Zc{get recordedInflateBytes(){return this.j?T.$Se.concat(this.f):T.$Se.alloc(0)}constructor(S,v,N,F){super(),this.h=S,this.j=v,this.a=this.B(new A.$qe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,k.createInflateRaw)(F),this.b.on("error",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,U),this.g.push(T.$Se.wrap(U))}),N&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(S){this.j&&this.f.push(S.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,S),this.b.write(S.buffer)}flush(S){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Se.concat(this.g);this.g.length=0,S(v)})}}class h extends b.$Zc{constructor(S,v){super(),this.g=S,this.a=this.B(new A.$qe),this.onError=this.a.event,this.f=[],this.b=(0,k.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,N),this.f.push(T.$Se.wrap(N))})}write(S){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,S.buffer),this.b.write(S.buffer)}flush(S){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Se.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),S(v)})}}function i(O,S){if(S===0)return;const v=O.byteLength>>>2;for(let W=0;W<v;W++){const x=O.readUInt32BE(W*4);O.writeUInt32BE(x^S,W*4)}const N=v*4,F=O.byteLength-N,U=S>>>24&255,j=S>>>16&255,G=S>>>8&255;F>=1&&O.writeUInt8(O.readUInt8(N)^U,N),F>=2&&O.writeUInt8(O.readUInt8(N+1)^j,N+1),F>=3&&O.writeUInt8(O.readUInt8(N+2)^G,N+2)}e.$Bi=process.env.XDG_RUNTIME_DIR;const n={[p.Platform.Linux]:107,[p.Platform.Mac]:103};function t(){const O=(0,m.$7g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${O}-sock`;const S=process.platform!=="darwin"&&e.$Bi?e.$Bi:(0,L.tmpdir)(),v=(0,R.$oc)(S,`vscode-ipc-${O}.sock`);return r(v),v}function s(O,S,v){const F=(0,P.createHash)("sha256").update(O).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${v}-${S}-sock`;const U=v.substr(0,4),j=S.substr(0,6);let G;return process.platform!=="darwin"&&e.$Bi&&!process.env.VSCODE_PORTABLE?G=(0,R.$oc)(e.$Bi,`vscode-${F}-${U}-${j}.sock`):G=(0,R.$oc)(O,`${U}-${j}.sock`),r(G),G}function r(O){const S=n[p.$x];typeof S=="number"&&O.length>=S&&console.warn(`WARNING: IPC handle "${O}" is longer than ${S} chars, try a shorter --user-data-dir`)}class o extends g.$oi{static b(S){const v=A.Event.fromNodeEventEmitter(S,"connection");return A.Event.map(v,N=>({protocol:new l.$vi(new E(N,"ipc-server-connection")),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(N,"close"))}))}constructor(S){super(o.b(S)),this.d=S}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ei=o;function u(O){return new Promise((S,v)=>{const N=(0,a.createServer)();N.on("error",v),N.listen(O,()=>{N.removeListener("error",v),S(new o(N))})})}function y(O,S){return new Promise((v,N)=>{const F=(0,a.createConnection)(O,()=>{F.removeListener("error",N),v(l.$wi.fromSocket(new E(F,`ipc-client${S}`),S))});F.once("error",N)})}}),define(fe[240],de([0,1,66,129,187]),function(ce,e,P,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0,P=Oe(P),e.$1jc=new class{supports(k){return!0}connect({host:k,port:T},C,A,b){return new Promise((R,p)=>{const m=P.createConnection({host:k,port:T},()=>{m.removeListener("error",p),m.write((0,L.$cyb)(C,A,b));const g=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",g),R(new a.$zi(m,b)))};m.on("data",g)});m.setNoDelay(!0),m.once("error",p)})}}}),define(fe[241],de([0,1,66,38,141,129,6,2,5,21,11,23,188,108,110,81,14]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=e.$5ic=e.$4ic=e.$3ic=void 0,P=Oe(P),a=Oe(a);async function w(h,i,n,t,s){let r;for(let o=3;o&&(r?.dispose(),r=await new d(h,i,n,t,s).waitForReady(),!(s&&L.$0g[s]||!L.$0g[r.tunnelLocalPort]));o--);return r}class d extends C.$Zc{constructor(i,n,t,s,r){super(),this.m=n,this.n=r,this.privacy=f.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=P.createServer(),this.c=new T.$Jh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,n=(0,f.$Vw)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,L.$$g)(i,2,1e3,n),s=null;return this.b.listen(t,this.m),await this.c.wait(),s=this.b.address(),s||(t=0,this.b.listen(t,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(i){i.pause();const n=(0,f.$Tw)(this.tunnelRemoteHost)||(0,f.$Vw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,m.$8l)(this.a,n,this.tunnelRemotePort),s=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),s.end()}),i.on("close",()=>s.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),s instanceof k.$zi?s.socket.destroy():s.end()}),s instanceof k.$zi?this.t(i,s):this.s(i,s),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),s.end()})}s(i,n){n.onClose(()=>i.destroy()),n.onEnd(()=>i.end()),n.onData(t=>i.write(t.buffer)),i.on("data",t=>n.write(E.$Se.wrap(t))),i.resume()}t(i,n){const t=n.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$3ic=d;let I=class extends f.$Yw{constructor(i,n,t,s,r){super(n,r),this.H=i,this.I=t,this.J=s}isPortPrivileged(i){return(0,f.$Ww)(i,this.t,A.OS,a.release())}F(i,n,t,s,r,o,u,y){const O=this.D(n,t);if(O)return++O.refcount,O.value;if((0,f.$Pw)(i))return this.G(i,n,t,r,o,u,y);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${t} on local port ${r}.`);const S={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=w(S,s,n,t,r);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(n,t,v),v}}};e.$4ic=I,e.$4ic=I=Ee([Y(0,g.$2l),Y(1,R.$fk),Y(2,l.$5l),Y(3,p.$yk),Y(4,b.$ej)],I);let $=class extends I{constructor(i,n,t,s,r){super(i,n,t,s,r)}};e.$5ic=$,e.$5ic=$=Ee([Y(0,g.$2l),Y(1,R.$fk),Y(2,l.$5l),Y(3,p.$yk),Y(4,b.$ej)],$);let c=class extends C.$Zc{constructor(i,n,t,s,r){super(),this.b=i,this.c=n,this.f=t,this.g=s,this.h=r,this.a=new Map}async openTunnel(i,n,t,s,r,o,u,y,O){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${s} on local port ${o}.`),!this.a.has(i)){const S=new $(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(i,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(n,t,s,r,o,u,y,O)}};e.$6ic=c,e.$6ic=c=Ee([Y(0,g.$2l),Y(1,R.$fk),Y(2,p.$yk),Y(3,l.$5l),Y(4,b.$ej)],c)});var it=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(fe[248],de([0,1,38,41,8,2,22,10,17,3,43,154,181,182,191,173,239,164,165,21,186,99,198,100,193,15,120,225,27,112,189,119,75,7,175,176,74,4,172,77,79,201,11,177,104,23,61,16,111,18,113,114,115,48,204,86,116,24,83,231,236,214,87,230,234,235,128,62,229,215,110,197,81,241,192,205,28,206,5,207,166,184,183,85,220,19,52,180,58,228,203,216,109,233,221,9,178,103,226,219,194,160,57,179,237,223,56,227,108,106,240,158,195,150,145,149]),function(ce,e,P,a,L,k,T,C,A,b,R,p,m,g,l,f,E,w,d,I,$,c,h,i,n,t,s,r,o,u,y,O,S,v,N,F,U,j,G,W,x,V,te,B,H,_,ne,le,ee,X,K,q,D,J,oe,Q,Z,M,z,ie,ae,ue,pe,be,Ie,Ae,ye,we,re,he,me,Se,Pe,De,Le,Ce,Fe,Me,We,je,Be,ze,He,Ne,se,ge,$e,ve,ke,Te,qe,xe,Je,Ye,Ve,_e,Ze,nt,at,Ct,Lt,Nt,Tt,Dt,Ut,Ft,yt,jt,vt,Mt,qt,Bt,ht,zt,Ht,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,H=it(H);class Wt extends k.$Zc{constructor(Re){super(),this.f=Re,this.a=this.B(new p.$zY(this)),this.b=void 0,this.c=this.B(new b.$qe),this.g()}g(){let Re=!1;const Ue=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ue),(0,p.$AY)(process.parentPort,ht.$dic.exit,Ue)}async init(){const Re=await this.h();(0,M.$kob)(),Re.invokeFunction(Ue=>{const Ke=Ue.get(te.$fk),Ge=Ue.get(X.$em),et=Ue.get(ge.$Rl);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ue),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,k.$Wc)(Re.createInstance(m.$qjc,this.f.codeCachePath),Re.createInstance(g.$rjc),Re.createInstance(E.$ujc),Re.createInstance(f.$tjc),Re.createInstance(l.$sjc),Re.createInstance(Ve.$Rjc),Re.createInstance(xe.$Jjc)))}async h(){const Re=new W.$Ii,Ue={_serviceBrand:void 0,...H.default};Re.set(_.$yk,Ue);const Ke=new R.$si(Qe=>Qe==="main"),Ge=new yt.$ajc(this.a,Ke);Re.set(yt.$_ic,Ge);const et=this.f.policiesData?new ve.$Gic(this.f.policiesData,Ge.getChannel("policy")):new ke.$Bo;Re.set(ke.$zo,et);const Xe=new Bt.$cn(this.f.args,Ue);Re.set(t.$Si,Xe);const ot=new B.$Bs(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Qe=>({...Qe,resource:C.URI.revive(Qe.resource)})),Ge.getChannel("logger"));Re.set(te.$gk,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(172,null)})),$t=this.B(new te.$nk(ft.getLevel())),tt=this.B(new Ze.$0R(ft,[$t]));Re.set(te.$fk,tt),this.b=this.B(new nt.$Tjc(tt)),Re.set(nt.$Sjc,this.b);const st=this.B(new N.$$q(tt));Re.set(v.$fl,st);const pt=this.B(new F.$Br(tt));st.registerProvider(T.Schemas.file,pt);const dt=new Me.$3s(st);Re.set(Fe.$Pl,dt);const rt=this.B(new Te.$eS(this.f.profiles.all,C.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Re.set(ge.$Rl,rt);const wt=this.B(new je.$$ic(T.Schemas.file,this.B(new Be.$SR(Ge.getChannel(Be.$RR),{pathCaseSensitive:We.$n})),T.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(T.Schemas.vscodeUserData,wt);const ct=this.B(new $.$4o(rt.defaultProfile.settingsResource,st,et,tt));Re.set(I.$ej,ct);const bt=new jt.$Zjc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Xe);Re.set(le.$oq,bt),this.B((0,k.$Xc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const Rt=new Lt.$ls(Ge.getChannel("request"));Re.set(ne.$bq,Rt),Re.set(w.$vjc,new U.$Hi(d.$wjc,void 0,!1)),Re.set(He.$fH,new U.$Hi(ze.$Ijc,void 0,!1));const It=new Dt.$cjc(-1,Ge);Re.set(Tt.$Thc,It),Re.set(i.$8o,new U.$Hi(n.$oS,void 0,!0));const Gt=this.B(new he.$Dic(It)),Kt=new R.$si(Qe=>Gt.getActiveClientId().then(mt=>Qe===mt));Re.set(S.$D8b,new Nt.$Vjc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,J.$Pp)(Ue,ct);if((0,J.$Kp)(Ue,Xe)){const Qe=new q.$wfc(tt,ot,Xe,Ue);if(lt.push(Qe),!(0,J.$Lp)(Ue,Xe)&&Ue.aiConfig?.ariaKey){const mt=new qe.$XR(Rt,Pt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this.B((0,k.$Xc)(()=>mt.flush())),lt.push(mt)}gt=new D.$ps({appenders:lt,commonProperties:(0,ee.$Bp)((0,P.release)(),(0,P.hostname)(),process.arch,Ue.commit,Ue.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,J.$Qp)(Xe)},ct,Ue)}else{gt=J.$Fp;const Qe=J.$Jp;lt.push(Qe)}this.a.registerChannel("telemetryAppender",new K.$iic(lt)),Re.set(X.$em,gt);const Jt=new oe.$xjc(ct,gt,tt,ot,Xe,Ue);Re.set(X.$fm,Jt),Re.set($e.$Rq,new U.$Hi(Ct.$9R,void 0,!0)),Re.set(Ne.$Vq,new U.$Hi(se.$Hic,void 0,!0)),Re.set(u.$Bq,new U.$Hi(u.$Dq,void 0,!0)),Re.set(O.$7q,new U.$Hi(O.$8q,void 0,!0)),Re.set(o.$rp,new U.$Hi(r.$xq,void 0,!0)),Re.set(o.$yp,new U.$Hi(Ft.$Yjc,void 0,!1)),Re.set(x.$hs,new U.$Hi(V.$js,void 0,!1)),Re.set(c.$Ym,new U.$Hi(h.$0s,void 0,!1)),Re.set(z.$cNb,new U.$Hi(z.$dNb,void 0,!0)),Re.set(M.$Fob,new U.$Hi(ue.$LPb,void 0,!0)),Re.set(M.$Eob,R.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Re.set(o.$xp,new U.$Hi(s.$aNb,void 0,!1)),Re.set(Z.$JPb,new U.$Hi(Z.$KPb,void 0,!0)),Re.set(Q.$zw,new U.$Hi(Q.$Aw)),Re.set(M.$pob,new U.$Hi(ye.$JOb,void 0,!0)),Re.set(M.$qob,new U.$Hi(ye.$LOb,void 0,!0)),Re.set(pe.$cob,new U.$Hi(pe.$eob,void 0,!0)),Re.set(M.$rob,new U.$Hi(ie.$_fc,void 0,!1)),Re.set(M.$Aob,new U.$Hi(be.$1fc,void 0,!0)),Re.set(M.$Bob,new U.$Hi(Ie.$egc,void 0,!1)),Re.set(we.$ONb,new U.$Hi(re.$Ejc,void 0,!0)),Re.set(M.$Cob,new U.$Hi(Ye.$Vgc,void 0,!0)),Re.set(me.$5l,new U.$Hi(Se.$8ic,void 0,!1));const Ot=new vt.$3l;return Re.set(vt.$2l,Ot),Ot.register(Mt.RemoteConnectionType.WebSocket,qt.$1jc),Re.set(Pe.$Ow,new U.$Hi(De.$6ic)),Re.set(Le.$Fjc,new U.$Hi(Ce.$Hjc)),Re.set(Je.$Kjc,new U.$Hi(at.$Ujc)),new G.$Er(Re)}j(Re){const Ue=new y.$Fq(Re.get(o.$up),()=>null);this.a.registerChannel("extensions",Ue);const Ke=R.ProxyChannel.fromService(Re.get(x.$hs),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=R.ProxyChannel.fromService(Re.get(c.$Ym),this.q);this.a.registerChannel("diagnostics",Ge);const et=new y.$Hq(Re.get(o.$yp));this.a.registerChannel("extensionTipsService",et);const Xe=R.ProxyChannel.fromService(Re.get(w.$vjc),this.q);this.a.registerChannel("checksum",Xe);const ot=R.ProxyChannel.fromService(Re.get(He.$fH),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=R.ProxyChannel.fromService(Re.get(pe.$cob),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=R.ProxyChannel.fromService(Re.get(X.$fm),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ae.$yjc(Re.get(z.$cNb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ae.$Ajc(Re.get(M.$pob));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new Ae.$Cjc(Re.get(M.$Bob),Re.get(ge.$Rl),Re.get(te.$fk));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(j.$Ji).createInstance(Ut.$Xjc));this.a.registerChannel("userDataAutoSync",R.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",R.ProxyChannel.fromService(Re.get(M.$Cob),this.q));const rt=R.ProxyChannel.fromService(Re.get(Le.$Fjc),this.q);this.a.registerChannel(Le.$Gjc,rt);const wt=R.ProxyChannel.fromService(Re.get(Je.$Kjc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",Ue=>(0,L.$4)(Ue)),process.on("unhandledRejection",Ue=>(0,L.$4)(Ue)),(0,L.setUnexpectedErrorHandler)(Ue=>{const Ke=(0,a.$vj)(Ue,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,Ue){Re.publicLog2("profilesInfo",{count:Ue.profiles.length})}async r(Re,Ue){if(We.$n){const[Ke,Ge]=await Promise.all([(0,zt.$8g)(Ue.error.bind(Ue)),(0,Et.$hY)(Ue.error.bind(Ue))]),et=(0,Ht.$WX)(),Xe=(0,Et.$iY)(Ge,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$fic.response)return!1;const Ue=(0,A.$Sb)(Re.ports);return Ue?(this.c.fire(Ue),!0):!1}}async function St(ut){try{const Re=new Wt(ut);process.parentPort.postMessage(ht.$dic.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$dic.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Vt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Vt),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/36e4ddb4dbdf5d41bbeedfce2db4834085de2b87/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
